open Swig
type c_enum_type = [ 
  `unknown
| `Weekday
| `Month
| `TimeUnit
| `Frequency
| `Month
| `Month
| `Type
| `BusinessDayConvention
| `JointCalendarRule
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Market
| `Convention
| `Convention
| `Convention
| `Compounding
| `Type
| `Type
| `ResetScheme
| `ResetScheme
| `ResetScheme
| `VolatilityType
| `Rule
| `YieldCurveModel
| `Type
| `Type
| `Type
| `Type
| `FdmSchemeType
| `Type
| `Type
| `InterpolationType
| `Side
| `ConversionType
| `Type
| `Type
| `Choice
| `Type
| `Adjustments
| `DirectionIntegers
| `Type
]
type c_enum_value = [ 
  `Int of int
| `Sunday
| `Monday
| `Tuesday
| `Wednesday
| `Thursday
| `Friday
| `Saturday
| `January
| `February
| `March
| `April
| `May
| `June
| `July
| `August
| `September
| `October
| `November
| `December
| `Days
| `Weeks
| `Months
| `Years
| `Hours
| `Minutes
| `Seconds
| `Milliseconds
| `Microseconds
| `NoFrequency
| `Once
| `Annual
| `Semiannual
| `EveryFourthMonth
| `Quarterly
| `Bimonthly
| `Monthly
| `EveryFourthWeek
| `Biweekly
| `Weekly
| `Daily
| `OtherFrequency
| `F
| `G
| `H
| `J
| `K
| `M
| `N
| `Q
| `U
| `V
| `X
| `Z
| `None
| `Spectral
| `Following
| `ModifiedFollowing
| `Preceding
| `ModifiedPreceding
| `Unadjusted
| `HalfMonthModifiedFollowing
| `JoinHolidays
| `JoinBusinessDays
| `Merval
| `Settlement
| `Exchange
| `TSX
| `SSE
| `IB
| `PSE
| `FrankfurtStockExchange
| `Xetra
| `Eurex
| `HKEx
| `ICEX
| `NSE
| `BEJ
| `JSX
| `TASE
| `BMV
| `MOEX
| `Tadawul
| `SGX
| `BSSE
| `KRX
| `TSEC
| `USE
| `Metals
| `NYSE
| `GovernmentBond
| `NERC
| `Standard
| `Canadian
| `NoLeap
| `USA
| `BondBasis
| `European
| `EurobondBasis
| `Italian
| `ISMA
| `Bond
| `ISDA
| `Historical
| `Actual365
| `AFB
| `Euro
| `Simple
| `Compounded
| `Continuous
| `SimpleThenCompounded
| `CompoundedThenSimple
| `Open
| `Close
| `High
| `Low
| `MaxIterations
| `StationaryPoint
| `StationaryFunctionValue
| `StationaryFunctionAccuracy
| `ZeroGradientNorm
| `Unknown
| `NoResetScheme
| `ResetToBestPoint
| `ResetToOrigin
| `ShiftedLognormal
| `Normal
| `Backward
| `Forward
| `Zero
| `ThirdWednesday
| `Twentieth
| `TwentiethIMM
| `OldCDS
| `CDS
| `CDS2015
| `ExactYield
| `ParallelShifts
| `NonParallelShifts
| `Macaulay
| `Modified
| `Put
| `Call
| `DownIn
| `UpIn
| `DownOut
| `UpOut
| `KnockIn
| `KnockOut
| `KIKO
| `KOKI
| `HundsdorferType
| `DouglasType
| `CraigSneydType
| `ModifiedCraigSneydType
| `ImplicitEulerType
| `ExplicitEulerType
| `Arithmetic
| `Geometric
| `Dirty
| `Clean
| `AsIndex
| `Flat
| `Linear
| `Buyer
| `Seller
| `NoConversion
| `BaseCurrencyConversion
| `AutomatedConversion
| `Direct
| `Derived
| `IMM
| `ASX
| `MaturityDate
| `LastRelevantDate
| `CustomDate
| `Long
| `Short
| `AdjustNone
| `AdjustDigitals
| `AdjustYts
| `ExtrapolatePayoffFlat
| `NoPayoffExtrapolation
| `KahaleSmile
| `SmileExponentialExtrapolation
| `KahaleInterpolation
| `SmileDeleteArbitragePoints
| `SabrSmile
| `Unit
| `Jaeckel
| `SobolLevitan
| `SobolLevitanLemieux
| `JoeKuoD5
| `JoeKuoD6
| `JoeKuoD7
| `Kuo
| `Kuo2
| `Kuo3
| `Physical
| `Cash
]

type c_obj = c_enum_value c_obj_t
let module_name = "QuantLib"

exception BadArgs of string
exception BadMethodName of c_obj * string * string
exception NotObject of c_obj
exception NotEnumType of c_obj
exception LabelNotFromThisEnum of c_obj
exception InvalidDirectorCall of c_obj


  
  let array_to_vector v argcons array = 
    for i = 0 to (Array.length array) - 1 do
	(invoke v) "set" (C_list [ C_int i ; (argcons array.(i)) ])
    done ;
    v
    
  let vector_to_array v argcons array =
    for i = 0; to (get_int ((invoke v) "size" C_void)) - 1 do
	array.(i) <- argcons ((invoke v) "[]" (C_int i))
    done ; 
    v
      

let _ = Callback.register "Weekday_marker" (`Weekday)
external _Sunday : c_obj -> Swig.c_obj = "_wrap_Sunday" 
external _Monday : c_obj -> Swig.c_obj = "_wrap_Monday" 
external _Tuesday : c_obj -> Swig.c_obj = "_wrap_Tuesday" 
external _Wednesday : c_obj -> Swig.c_obj = "_wrap_Wednesday" 
external _Thursday : c_obj -> Swig.c_obj = "_wrap_Thursday" 
external _Friday : c_obj -> Swig.c_obj = "_wrap_Friday" 
external _Saturday : c_obj -> Swig.c_obj = "_wrap_Saturday" 
let _ = Callback.register "Month_marker" (`Month)
external _January : c_obj -> Swig.c_obj = "_wrap_January" 
external _February : c_obj -> Swig.c_obj = "_wrap_February" 
external _March : c_obj -> Swig.c_obj = "_wrap_March" 
external _April : c_obj -> Swig.c_obj = "_wrap_April" 
external _May : c_obj -> Swig.c_obj = "_wrap_May" 
external _June : c_obj -> Swig.c_obj = "_wrap_June" 
external _July : c_obj -> Swig.c_obj = "_wrap_July" 
external _August : c_obj -> Swig.c_obj = "_wrap_August" 
external _September : c_obj -> Swig.c_obj = "_wrap_September" 
external _October : c_obj -> Swig.c_obj = "_wrap_October" 
external _November : c_obj -> Swig.c_obj = "_wrap_November" 
external _December : c_obj -> Swig.c_obj = "_wrap_December" 
let _ = Callback.register "TimeUnit_marker" (`TimeUnit)
external _Days : c_obj -> Swig.c_obj = "_wrap_Days" 
external _Weeks : c_obj -> Swig.c_obj = "_wrap_Weeks" 
external _Months : c_obj -> Swig.c_obj = "_wrap_Months" 
external _Years : c_obj -> Swig.c_obj = "_wrap_Years" 
external _Hours : c_obj -> Swig.c_obj = "_wrap_Hours" 
external _Minutes : c_obj -> Swig.c_obj = "_wrap_Minutes" 
external _Seconds : c_obj -> Swig.c_obj = "_wrap_Seconds" 
external _Milliseconds : c_obj -> Swig.c_obj = "_wrap_Milliseconds" 
external _Microseconds : c_obj -> Swig.c_obj = "_wrap_Microseconds" 
let _ = Callback.register "Frequency_marker" (`Frequency)
external _NoFrequency : c_obj -> Swig.c_obj = "_wrap_NoFrequency" 
external _Once : c_obj -> Swig.c_obj = "_wrap_Once" 
external _Annual : c_obj -> Swig.c_obj = "_wrap_Annual" 
external _Semiannual : c_obj -> Swig.c_obj = "_wrap_Semiannual" 
external _EveryFourthMonth : c_obj -> Swig.c_obj = "_wrap_EveryFourthMonth" 
external _Quarterly : c_obj -> Swig.c_obj = "_wrap_Quarterly" 
external _Bimonthly : c_obj -> Swig.c_obj = "_wrap_Bimonthly" 
external _Monthly : c_obj -> Swig.c_obj = "_wrap_Monthly" 
external _EveryFourthWeek : c_obj -> Swig.c_obj = "_wrap_EveryFourthWeek" 
external _Biweekly : c_obj -> Swig.c_obj = "_wrap_Biweekly" 
external _Weekly : c_obj -> Swig.c_obj = "_wrap_Weekly" 
external _Daily : c_obj -> Swig.c_obj = "_wrap_Daily" 
external _OtherFrequency : c_obj -> Swig.c_obj = "_wrap_OtherFrequency" 
external _new_Period_f : c_obj list -> c_obj list = "_wrap_new_Period__SWIG_0QuantLib" ;;
let _new_Period arg = match _new_Period_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Period_f : c_obj list -> c_obj list = "_wrap_new_Period__SWIG_1QuantLib" ;;
let _new_Period arg = match _new_Period_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Period_f : c_obj list -> c_obj list = "_wrap_new_Period__SWIG_2QuantLib" ;;
let _new_Period arg = match _new_Period_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Period_length_f : c_obj list -> c_obj list = "_wrap_Period_lengthQuantLib" ;;
let _Period_length arg = match _Period_length_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Period_units_f : c_obj list -> c_obj list = "_wrap_Period_unitsQuantLib" ;;
let _Period_units arg = match _Period_units_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Period_frequency_f : c_obj list -> c_obj list = "_wrap_Period_frequencyQuantLib" ;;
let _Period_frequency arg = match _Period_frequency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Period_f : c_obj list -> c_obj list = "_wrap_new_PeriodQuantLib" ;;
let _new_Period arg = match _new_Period_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Period___str___f : c_obj list -> c_obj list = "_wrap_Period___str__QuantLib" ;;
let _Period___str__ arg = match _Period___str___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Period___repr___f : c_obj list -> c_obj list = "_wrap_Period___repr__QuantLib" ;;
let _Period___repr__ arg = match _Period___repr___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Period_f : c_obj list -> c_obj list = "_wrap_delete_PeriodQuantLib" ;;
let _delete_Period arg = match _delete_Period_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PeriodVector_f : c_obj list -> c_obj list = "_wrap_new_PeriodVector__SWIG_0QuantLib" ;;
let _new_PeriodVector arg = match _new_PeriodVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PeriodVector_f : c_obj list -> c_obj list = "_wrap_new_PeriodVector__SWIG_1QuantLib" ;;
let _new_PeriodVector arg = match _new_PeriodVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PeriodVector_f : c_obj list -> c_obj list = "_wrap_new_PeriodVector__SWIG_2QuantLib" ;;
let _new_PeriodVector arg = match _new_PeriodVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PeriodVector_f : c_obj list -> c_obj list = "_wrap_new_PeriodVectorQuantLib" ;;
let _new_PeriodVector arg = match _new_PeriodVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PeriodVector_size_f : c_obj list -> c_obj list = "_wrap_PeriodVector_sizeQuantLib" ;;
let _PeriodVector_size arg = match _PeriodVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PeriodVector_empty_f : c_obj list -> c_obj list = "_wrap_PeriodVector_emptyQuantLib" ;;
let _PeriodVector_empty arg = match _PeriodVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PeriodVector_clear_f : c_obj list -> c_obj list = "_wrap_PeriodVector_clearQuantLib" ;;
let _PeriodVector_clear arg = match _PeriodVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PeriodVector_push_back_f : c_obj list -> c_obj list = "_wrap_PeriodVector_push_backQuantLib" ;;
let _PeriodVector_push_back arg = match _PeriodVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PeriodVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_PeriodVector_operator_bB___QuantLib" ;;
let _PeriodVector_operator_xx_xx_lbrace_xx_rbrace arg = match _PeriodVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PeriodVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_PeriodVector_operator_e___QuantLib" ;;
let _PeriodVector_operator_xx_xx_equals arg = match _PeriodVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PeriodVector_set_f : c_obj list -> c_obj list = "_wrap_PeriodVector_setQuantLib" ;;
let _PeriodVector_set arg = match _PeriodVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PeriodVector_to_array_f : c_obj list -> c_obj list = "_wrap_PeriodVector_to_arrayQuantLib" ;;
let _PeriodVector_to_array arg = match _PeriodVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PeriodVector_f : c_obj list -> c_obj list = "_wrap_delete_PeriodVectorQuantLib" ;;
let _delete_PeriodVector arg = match _delete_PeriodVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Date_f : c_obj list -> c_obj list = "_wrap_new_Date__SWIG_0QuantLib" ;;
let _new_Date arg = match _new_Date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Date_f : c_obj list -> c_obj list = "_wrap_new_Date__SWIG_1QuantLib" ;;
let _new_Date arg = match _new_Date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Date_f : c_obj list -> c_obj list = "_wrap_new_Date__SWIG_2QuantLib" ;;
let _new_Date arg = match _new_Date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Date_f : c_obj list -> c_obj list = "_wrap_new_Date__SWIG_3QuantLib" ;;
let _new_Date arg = match _new_Date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Date_f : c_obj list -> c_obj list = "_wrap_new_Date__SWIG_4QuantLib" ;;
let _new_Date arg = match _new_Date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Date_f : c_obj list -> c_obj list = "_wrap_new_Date__SWIG_5QuantLib" ;;
let _new_Date arg = match _new_Date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_weekday_f : c_obj list -> c_obj list = "_wrap_Date_weekdayQuantLib" ;;
let _Date_weekday arg = match _Date_weekday_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_dayOfMonth_f : c_obj list -> c_obj list = "_wrap_Date_dayOfMonthQuantLib" ;;
let _Date_dayOfMonth arg = match _Date_dayOfMonth_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_dayOfYear_f : c_obj list -> c_obj list = "_wrap_Date_dayOfYearQuantLib" ;;
let _Date_dayOfYear arg = match _Date_dayOfYear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_month_f : c_obj list -> c_obj list = "_wrap_Date_monthQuantLib" ;;
let _Date_month arg = match _Date_month_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_year_f : c_obj list -> c_obj list = "_wrap_Date_yearQuantLib" ;;
let _Date_year arg = match _Date_year_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_hours_f : c_obj list -> c_obj list = "_wrap_Date_hoursQuantLib" ;;
let _Date_hours arg = match _Date_hours_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_minutes_f : c_obj list -> c_obj list = "_wrap_Date_minutesQuantLib" ;;
let _Date_minutes arg = match _Date_minutes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_seconds_f : c_obj list -> c_obj list = "_wrap_Date_secondsQuantLib" ;;
let _Date_seconds arg = match _Date_seconds_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_milliseconds_f : c_obj list -> c_obj list = "_wrap_Date_millisecondsQuantLib" ;;
let _Date_milliseconds arg = match _Date_milliseconds_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_microseconds_f : c_obj list -> c_obj list = "_wrap_Date_microsecondsQuantLib" ;;
let _Date_microseconds arg = match _Date_microseconds_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_fractionOfDay_f : c_obj list -> c_obj list = "_wrap_Date_fractionOfDayQuantLib" ;;
let _Date_fractionOfDay arg = match _Date_fractionOfDay_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_fractionOfSecond_f : c_obj list -> c_obj list = "_wrap_Date_fractionOfSecondQuantLib" ;;
let _Date_fractionOfSecond arg = match _Date_fractionOfSecond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_serialNumber_f : c_obj list -> c_obj list = "_wrap_Date_serialNumberQuantLib" ;;
let _Date_serialNumber arg = match _Date_serialNumber_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_isLeap_f : c_obj list -> c_obj list = "_wrap_Date_isLeapQuantLib" ;;
let _Date_isLeap arg = match _Date_isLeap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_minDate_f : c_obj list -> c_obj list = "_wrap_Date_minDateQuantLib" ;;
let _Date_minDate arg = match _Date_minDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_maxDate_f : c_obj list -> c_obj list = "_wrap_Date_maxDateQuantLib" ;;
let _Date_maxDate arg = match _Date_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_todaysDate_f : c_obj list -> c_obj list = "_wrap_Date_todaysDateQuantLib" ;;
let _Date_todaysDate arg = match _Date_todaysDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_localDateTime_f : c_obj list -> c_obj list = "_wrap_Date_localDateTimeQuantLib" ;;
let _Date_localDateTime arg = match _Date_localDateTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_universalDateTime_f : c_obj list -> c_obj list = "_wrap_Date_universalDateTimeQuantLib" ;;
let _Date_universalDateTime arg = match _Date_universalDateTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_endOfMonth_f : c_obj list -> c_obj list = "_wrap_Date_endOfMonthQuantLib" ;;
let _Date_endOfMonth arg = match _Date_endOfMonth_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_isEndOfMonth_f : c_obj list -> c_obj list = "_wrap_Date_isEndOfMonthQuantLib" ;;
let _Date_isEndOfMonth arg = match _Date_isEndOfMonth_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_nextWeekday_f : c_obj list -> c_obj list = "_wrap_Date_nextWeekdayQuantLib" ;;
let _Date_nextWeekday arg = match _Date_nextWeekday_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_nthWeekday_f : c_obj list -> c_obj list = "_wrap_Date_nthWeekdayQuantLib" ;;
let _Date_nthWeekday arg = match _Date_nthWeekday_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Date_f : c_obj list -> c_obj list = "_wrap_new_DateQuantLib" ;;
let _new_Date arg = match _new_Date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_weekdayNumber_f : c_obj list -> c_obj list = "_wrap_Date_weekdayNumberQuantLib" ;;
let _Date_weekdayNumber arg = match _Date_weekdayNumber_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date___str___f : c_obj list -> c_obj list = "_wrap_Date___str__QuantLib" ;;
let _Date___str__ arg = match _Date___str___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date___repr___f : c_obj list -> c_obj list = "_wrap_Date___repr__QuantLib" ;;
let _Date___repr__ arg = match _Date___repr___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Date_ISO_f : c_obj list -> c_obj list = "_wrap_Date_ISOQuantLib" ;;
let _Date_ISO arg = match _Date_ISO_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Date_f : c_obj list -> c_obj list = "_wrap_delete_DateQuantLib" ;;
let _delete_Date arg = match _delete_Date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DateParser_parseFormatted_f : c_obj list -> c_obj list = "_wrap_DateParser_parseFormattedQuantLib" ;;
let _DateParser_parseFormatted arg = match _DateParser_parseFormatted_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DateParser_parseISO_f : c_obj list -> c_obj list = "_wrap_DateParser_parseISOQuantLib" ;;
let _DateParser_parseISO arg = match _DateParser_parseISO_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DateParser_parse_f : c_obj list -> c_obj list = "_wrap_DateParser_parseQuantLib" ;;
let _DateParser_parse arg = match _DateParser_parse_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DateParser_f : c_obj list -> c_obj list = "_wrap_new_DateParserQuantLib" ;;
let _new_DateParser arg = match _new_DateParser_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DateParser_f : c_obj list -> c_obj list = "_wrap_delete_DateParserQuantLib" ;;
let _delete_DateParser arg = match _delete_DateParser_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PeriodParser_parse_f : c_obj list -> c_obj list = "_wrap_PeriodParser_parseQuantLib" ;;
let _PeriodParser_parse arg = match _PeriodParser_parse_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PeriodParser_f : c_obj list -> c_obj list = "_wrap_new_PeriodParserQuantLib" ;;
let _new_PeriodParser arg = match _new_PeriodParser_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PeriodParser_f : c_obj list -> c_obj list = "_wrap_delete_PeriodParserQuantLib" ;;
let _delete_PeriodParser arg = match _delete_PeriodParser_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DateVector_f : c_obj list -> c_obj list = "_wrap_new_DateVector__SWIG_0QuantLib" ;;
let _new_DateVector arg = match _new_DateVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DateVector_f : c_obj list -> c_obj list = "_wrap_new_DateVector__SWIG_1QuantLib" ;;
let _new_DateVector arg = match _new_DateVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DateVector_f : c_obj list -> c_obj list = "_wrap_new_DateVector__SWIG_2QuantLib" ;;
let _new_DateVector arg = match _new_DateVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DateVector_f : c_obj list -> c_obj list = "_wrap_new_DateVectorQuantLib" ;;
let _new_DateVector arg = match _new_DateVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DateVector_size_f : c_obj list -> c_obj list = "_wrap_DateVector_sizeQuantLib" ;;
let _DateVector_size arg = match _DateVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DateVector_empty_f : c_obj list -> c_obj list = "_wrap_DateVector_emptyQuantLib" ;;
let _DateVector_empty arg = match _DateVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DateVector_clear_f : c_obj list -> c_obj list = "_wrap_DateVector_clearQuantLib" ;;
let _DateVector_clear arg = match _DateVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DateVector_push_back_f : c_obj list -> c_obj list = "_wrap_DateVector_push_backQuantLib" ;;
let _DateVector_push_back arg = match _DateVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DateVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_DateVector_operator_bB___QuantLib" ;;
let _DateVector_operator_xx_xx_lbrace_xx_rbrace arg = match _DateVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DateVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_DateVector_operator_e___QuantLib" ;;
let _DateVector_operator_xx_xx_equals arg = match _DateVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DateVector_set_f : c_obj list -> c_obj list = "_wrap_DateVector_setQuantLib" ;;
let _DateVector_set arg = match _DateVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DateVector_to_array_f : c_obj list -> c_obj list = "_wrap_DateVector_to_arrayQuantLib" ;;
let _DateVector_to_array arg = match _DateVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DateVector_f : c_obj list -> c_obj list = "_wrap_delete_DateVectorQuantLib" ;;
let _delete_DateVector arg = match _delete_DateVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "IMM::Month_marker" (`Month)
external _F : c_obj -> Swig.c_obj = "_wrap_F" 
external _G : c_obj -> Swig.c_obj = "_wrap_G" 
external _H : c_obj -> Swig.c_obj = "_wrap_H" 
external _J : c_obj -> Swig.c_obj = "_wrap_J" 
external _K : c_obj -> Swig.c_obj = "_wrap_K" 
external _M : c_obj -> Swig.c_obj = "_wrap_M" 
external _N : c_obj -> Swig.c_obj = "_wrap_N" 
external _Q : c_obj -> Swig.c_obj = "_wrap_Q" 
external _U : c_obj -> Swig.c_obj = "_wrap_U" 
external _V : c_obj -> Swig.c_obj = "_wrap_V" 
external _X : c_obj -> Swig.c_obj = "_wrap_X" 
external _Z : c_obj -> Swig.c_obj = "_wrap_Z" 
external _IMM_isIMMdate_f : c_obj list -> c_obj list = "_wrap_IMM_isIMMdate__SWIG_0QuantLib" ;;
let _IMM_isIMMdate arg = match _IMM_isIMMdate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_isIMMdate_f : c_obj list -> c_obj list = "_wrap_IMM_isIMMdateQuantLib" ;;
let _IMM_isIMMdate arg = match _IMM_isIMMdate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_isIMMcode_f : c_obj list -> c_obj list = "_wrap_IMM_isIMMcode__SWIG_0QuantLib" ;;
let _IMM_isIMMcode arg = match _IMM_isIMMcode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_isIMMcode_f : c_obj list -> c_obj list = "_wrap_IMM_isIMMcodeQuantLib" ;;
let _IMM_isIMMcode arg = match _IMM_isIMMcode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_code_f : c_obj list -> c_obj list = "_wrap_IMM_codeQuantLib" ;;
let _IMM_code arg = match _IMM_code_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_date_f : c_obj list -> c_obj list = "_wrap_IMM_date__SWIG_0QuantLib" ;;
let _IMM_date arg = match _IMM_date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_date_f : c_obj list -> c_obj list = "_wrap_IMM_dateQuantLib" ;;
let _IMM_date arg = match _IMM_date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_nextDate_f : c_obj list -> c_obj list = "_wrap_IMM_nextDate__SWIG_0QuantLib" ;;
let _IMM_nextDate arg = match _IMM_nextDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_nextDate_f : c_obj list -> c_obj list = "_wrap_IMM_nextDate__SWIG_1QuantLib" ;;
let _IMM_nextDate arg = match _IMM_nextDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_nextDate_f : c_obj list -> c_obj list = "_wrap_IMM_nextDate__SWIG_2QuantLib" ;;
let _IMM_nextDate arg = match _IMM_nextDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_nextDate_f : c_obj list -> c_obj list = "_wrap_IMM_nextDate__SWIG_3QuantLib" ;;
let _IMM_nextDate arg = match _IMM_nextDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_nextDate_f : c_obj list -> c_obj list = "_wrap_IMM_nextDate__SWIG_4QuantLib" ;;
let _IMM_nextDate arg = match _IMM_nextDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_nextDate_f : c_obj list -> c_obj list = "_wrap_IMM_nextDateQuantLib" ;;
let _IMM_nextDate arg = match _IMM_nextDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_nextCode_f : c_obj list -> c_obj list = "_wrap_IMM_nextCode__SWIG_0QuantLib" ;;
let _IMM_nextCode arg = match _IMM_nextCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_nextCode_f : c_obj list -> c_obj list = "_wrap_IMM_nextCode__SWIG_1QuantLib" ;;
let _IMM_nextCode arg = match _IMM_nextCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_nextCode_f : c_obj list -> c_obj list = "_wrap_IMM_nextCode__SWIG_2QuantLib" ;;
let _IMM_nextCode arg = match _IMM_nextCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_nextCode_f : c_obj list -> c_obj list = "_wrap_IMM_nextCode__SWIG_3QuantLib" ;;
let _IMM_nextCode arg = match _IMM_nextCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_nextCode_f : c_obj list -> c_obj list = "_wrap_IMM_nextCode__SWIG_4QuantLib" ;;
let _IMM_nextCode arg = match _IMM_nextCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IMM_nextCode_f : c_obj list -> c_obj list = "_wrap_IMM_nextCodeQuantLib" ;;
let _IMM_nextCode arg = match _IMM_nextCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IMM_f : c_obj list -> c_obj list = "_wrap_new_IMMQuantLib" ;;
let _new_IMM arg = match _new_IMM_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IMM_f : c_obj list -> c_obj list = "_wrap_delete_IMMQuantLib" ;;
let _delete_IMM arg = match _delete_IMM_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "ASX::Month_marker" (`Month)
external _ASX_isASXdate_f : c_obj list -> c_obj list = "_wrap_ASX_isASXdate__SWIG_0QuantLib" ;;
let _ASX_isASXdate arg = match _ASX_isASXdate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_isASXdate_f : c_obj list -> c_obj list = "_wrap_ASX_isASXdateQuantLib" ;;
let _ASX_isASXdate arg = match _ASX_isASXdate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_isASXcode_f : c_obj list -> c_obj list = "_wrap_ASX_isASXcode__SWIG_0QuantLib" ;;
let _ASX_isASXcode arg = match _ASX_isASXcode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_isASXcode_f : c_obj list -> c_obj list = "_wrap_ASX_isASXcodeQuantLib" ;;
let _ASX_isASXcode arg = match _ASX_isASXcode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_code_f : c_obj list -> c_obj list = "_wrap_ASX_codeQuantLib" ;;
let _ASX_code arg = match _ASX_code_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_date_f : c_obj list -> c_obj list = "_wrap_ASX_date__SWIG_0QuantLib" ;;
let _ASX_date arg = match _ASX_date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_date_f : c_obj list -> c_obj list = "_wrap_ASX_dateQuantLib" ;;
let _ASX_date arg = match _ASX_date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_nextDate_f : c_obj list -> c_obj list = "_wrap_ASX_nextDate__SWIG_0QuantLib" ;;
let _ASX_nextDate arg = match _ASX_nextDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_nextDate_f : c_obj list -> c_obj list = "_wrap_ASX_nextDate__SWIG_1QuantLib" ;;
let _ASX_nextDate arg = match _ASX_nextDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_nextDate_f : c_obj list -> c_obj list = "_wrap_ASX_nextDate__SWIG_2QuantLib" ;;
let _ASX_nextDate arg = match _ASX_nextDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_nextDate_f : c_obj list -> c_obj list = "_wrap_ASX_nextDate__SWIG_3QuantLib" ;;
let _ASX_nextDate arg = match _ASX_nextDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_nextDate_f : c_obj list -> c_obj list = "_wrap_ASX_nextDate__SWIG_4QuantLib" ;;
let _ASX_nextDate arg = match _ASX_nextDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_nextDate_f : c_obj list -> c_obj list = "_wrap_ASX_nextDateQuantLib" ;;
let _ASX_nextDate arg = match _ASX_nextDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_nextCode_f : c_obj list -> c_obj list = "_wrap_ASX_nextCode__SWIG_0QuantLib" ;;
let _ASX_nextCode arg = match _ASX_nextCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_nextCode_f : c_obj list -> c_obj list = "_wrap_ASX_nextCode__SWIG_1QuantLib" ;;
let _ASX_nextCode arg = match _ASX_nextCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_nextCode_f : c_obj list -> c_obj list = "_wrap_ASX_nextCode__SWIG_2QuantLib" ;;
let _ASX_nextCode arg = match _ASX_nextCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_nextCode_f : c_obj list -> c_obj list = "_wrap_ASX_nextCode__SWIG_3QuantLib" ;;
let _ASX_nextCode arg = match _ASX_nextCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_nextCode_f : c_obj list -> c_obj list = "_wrap_ASX_nextCode__SWIG_4QuantLib" ;;
let _ASX_nextCode arg = match _ASX_nextCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ASX_nextCode_f : c_obj list -> c_obj list = "_wrap_ASX_nextCodeQuantLib" ;;
let _ASX_nextCode arg = match _ASX_nextCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ASX_f : c_obj list -> c_obj list = "_wrap_new_ASXQuantLib" ;;
let _new_ASX arg = match _new_ASX_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ASX_f : c_obj list -> c_obj list = "_wrap_delete_ASXQuantLib" ;;
let _delete_ASX arg = match _delete_ASX_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntVector_f : c_obj list -> c_obj list = "_wrap_new_IntVector__SWIG_0QuantLib" ;;
let _new_IntVector arg = match _new_IntVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntVector_f : c_obj list -> c_obj list = "_wrap_new_IntVector__SWIG_1QuantLib" ;;
let _new_IntVector arg = match _new_IntVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntVector_f : c_obj list -> c_obj list = "_wrap_new_IntVector__SWIG_2QuantLib" ;;
let _new_IntVector arg = match _new_IntVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntVector_f : c_obj list -> c_obj list = "_wrap_new_IntVectorQuantLib" ;;
let _new_IntVector arg = match _new_IntVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntVector_size_f : c_obj list -> c_obj list = "_wrap_IntVector_sizeQuantLib" ;;
let _IntVector_size arg = match _IntVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntVector_empty_f : c_obj list -> c_obj list = "_wrap_IntVector_emptyQuantLib" ;;
let _IntVector_empty arg = match _IntVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntVector_clear_f : c_obj list -> c_obj list = "_wrap_IntVector_clearQuantLib" ;;
let _IntVector_clear arg = match _IntVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntVector_push_back_f : c_obj list -> c_obj list = "_wrap_IntVector_push_backQuantLib" ;;
let _IntVector_push_back arg = match _IntVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_IntVector_operator_bB___QuantLib" ;;
let _IntVector_operator_xx_xx_lbrace_xx_rbrace arg = match _IntVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_IntVector_operator_e___QuantLib" ;;
let _IntVector_operator_xx_xx_equals arg = match _IntVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntVector_set_f : c_obj list -> c_obj list = "_wrap_IntVector_setQuantLib" ;;
let _IntVector_set arg = match _IntVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntVector_to_array_f : c_obj list -> c_obj list = "_wrap_IntVector_to_arrayQuantLib" ;;
let _IntVector_to_array arg = match _IntVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IntVector_f : c_obj list -> c_obj list = "_wrap_delete_IntVectorQuantLib" ;;
let _delete_IntVector arg = match _delete_IntVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UnsignedIntVector_f : c_obj list -> c_obj list = "_wrap_new_UnsignedIntVector__SWIG_0QuantLib" ;;
let _new_UnsignedIntVector arg = match _new_UnsignedIntVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UnsignedIntVector_f : c_obj list -> c_obj list = "_wrap_new_UnsignedIntVector__SWIG_1QuantLib" ;;
let _new_UnsignedIntVector arg = match _new_UnsignedIntVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UnsignedIntVector_f : c_obj list -> c_obj list = "_wrap_new_UnsignedIntVector__SWIG_2QuantLib" ;;
let _new_UnsignedIntVector arg = match _new_UnsignedIntVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UnsignedIntVector_f : c_obj list -> c_obj list = "_wrap_new_UnsignedIntVectorQuantLib" ;;
let _new_UnsignedIntVector arg = match _new_UnsignedIntVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UnsignedIntVector_size_f : c_obj list -> c_obj list = "_wrap_UnsignedIntVector_sizeQuantLib" ;;
let _UnsignedIntVector_size arg = match _UnsignedIntVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UnsignedIntVector_empty_f : c_obj list -> c_obj list = "_wrap_UnsignedIntVector_emptyQuantLib" ;;
let _UnsignedIntVector_empty arg = match _UnsignedIntVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UnsignedIntVector_clear_f : c_obj list -> c_obj list = "_wrap_UnsignedIntVector_clearQuantLib" ;;
let _UnsignedIntVector_clear arg = match _UnsignedIntVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UnsignedIntVector_push_back_f : c_obj list -> c_obj list = "_wrap_UnsignedIntVector_push_backQuantLib" ;;
let _UnsignedIntVector_push_back arg = match _UnsignedIntVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UnsignedIntVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_UnsignedIntVector_operator_bB___QuantLib" ;;
let _UnsignedIntVector_operator_xx_xx_lbrace_xx_rbrace arg = match _UnsignedIntVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UnsignedIntVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_UnsignedIntVector_operator_e___QuantLib" ;;
let _UnsignedIntVector_operator_xx_xx_equals arg = match _UnsignedIntVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UnsignedIntVector_set_f : c_obj list -> c_obj list = "_wrap_UnsignedIntVector_setQuantLib" ;;
let _UnsignedIntVector_set arg = match _UnsignedIntVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UnsignedIntVector_to_array_f : c_obj list -> c_obj list = "_wrap_UnsignedIntVector_to_arrayQuantLib" ;;
let _UnsignedIntVector_to_array arg = match _UnsignedIntVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_UnsignedIntVector_f : c_obj list -> c_obj list = "_wrap_delete_UnsignedIntVectorQuantLib" ;;
let _delete_UnsignedIntVector arg = match _delete_UnsignedIntVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DoubleVector_f : c_obj list -> c_obj list = "_wrap_new_DoubleVector__SWIG_0QuantLib" ;;
let _new_DoubleVector arg = match _new_DoubleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DoubleVector_f : c_obj list -> c_obj list = "_wrap_new_DoubleVector__SWIG_1QuantLib" ;;
let _new_DoubleVector arg = match _new_DoubleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DoubleVector_f : c_obj list -> c_obj list = "_wrap_new_DoubleVector__SWIG_2QuantLib" ;;
let _new_DoubleVector arg = match _new_DoubleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DoubleVector_f : c_obj list -> c_obj list = "_wrap_new_DoubleVectorQuantLib" ;;
let _new_DoubleVector arg = match _new_DoubleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleVector_size_f : c_obj list -> c_obj list = "_wrap_DoubleVector_sizeQuantLib" ;;
let _DoubleVector_size arg = match _DoubleVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleVector_empty_f : c_obj list -> c_obj list = "_wrap_DoubleVector_emptyQuantLib" ;;
let _DoubleVector_empty arg = match _DoubleVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleVector_clear_f : c_obj list -> c_obj list = "_wrap_DoubleVector_clearQuantLib" ;;
let _DoubleVector_clear arg = match _DoubleVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleVector_push_back_f : c_obj list -> c_obj list = "_wrap_DoubleVector_push_backQuantLib" ;;
let _DoubleVector_push_back arg = match _DoubleVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_DoubleVector_operator_bB___QuantLib" ;;
let _DoubleVector_operator_xx_xx_lbrace_xx_rbrace arg = match _DoubleVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_DoubleVector_operator_e___QuantLib" ;;
let _DoubleVector_operator_xx_xx_equals arg = match _DoubleVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleVector_set_f : c_obj list -> c_obj list = "_wrap_DoubleVector_setQuantLib" ;;
let _DoubleVector_set arg = match _DoubleVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleVector_to_array_f : c_obj list -> c_obj list = "_wrap_DoubleVector_to_arrayQuantLib" ;;
let _DoubleVector_to_array arg = match _DoubleVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DoubleVector_f : c_obj list -> c_obj list = "_wrap_delete_DoubleVectorQuantLib" ;;
let _delete_DoubleVector arg = match _delete_DoubleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StrVector_f : c_obj list -> c_obj list = "_wrap_new_StrVector__SWIG_0QuantLib" ;;
let _new_StrVector arg = match _new_StrVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StrVector_f : c_obj list -> c_obj list = "_wrap_new_StrVector__SWIG_1QuantLib" ;;
let _new_StrVector arg = match _new_StrVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StrVector_f : c_obj list -> c_obj list = "_wrap_new_StrVector__SWIG_2QuantLib" ;;
let _new_StrVector arg = match _new_StrVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StrVector_f : c_obj list -> c_obj list = "_wrap_new_StrVectorQuantLib" ;;
let _new_StrVector arg = match _new_StrVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrVector_size_f : c_obj list -> c_obj list = "_wrap_StrVector_sizeQuantLib" ;;
let _StrVector_size arg = match _StrVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrVector_empty_f : c_obj list -> c_obj list = "_wrap_StrVector_emptyQuantLib" ;;
let _StrVector_empty arg = match _StrVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrVector_clear_f : c_obj list -> c_obj list = "_wrap_StrVector_clearQuantLib" ;;
let _StrVector_clear arg = match _StrVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrVector_push_back_f : c_obj list -> c_obj list = "_wrap_StrVector_push_backQuantLib" ;;
let _StrVector_push_back arg = match _StrVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_StrVector_operator_bB___QuantLib" ;;
let _StrVector_operator_xx_xx_lbrace_xx_rbrace arg = match _StrVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_StrVector_operator_e___QuantLib" ;;
let _StrVector_operator_xx_xx_equals arg = match _StrVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrVector_set_f : c_obj list -> c_obj list = "_wrap_StrVector_setQuantLib" ;;
let _StrVector_set arg = match _StrVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrVector_to_array_f : c_obj list -> c_obj list = "_wrap_StrVector_to_arrayQuantLib" ;;
let _StrVector_to_array arg = match _StrVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_StrVector_f : c_obj list -> c_obj list = "_wrap_delete_StrVectorQuantLib" ;;
let _delete_StrVector arg = match _delete_StrVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BoolVector_f : c_obj list -> c_obj list = "_wrap_new_BoolVector__SWIG_0QuantLib" ;;
let _new_BoolVector arg = match _new_BoolVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BoolVector_f : c_obj list -> c_obj list = "_wrap_new_BoolVector__SWIG_1QuantLib" ;;
let _new_BoolVector arg = match _new_BoolVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BoolVector_f : c_obj list -> c_obj list = "_wrap_new_BoolVector__SWIG_2QuantLib" ;;
let _new_BoolVector arg = match _new_BoolVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BoolVector_f : c_obj list -> c_obj list = "_wrap_new_BoolVectorQuantLib" ;;
let _new_BoolVector arg = match _new_BoolVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoolVector_size_f : c_obj list -> c_obj list = "_wrap_BoolVector_sizeQuantLib" ;;
let _BoolVector_size arg = match _BoolVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoolVector_empty_f : c_obj list -> c_obj list = "_wrap_BoolVector_emptyQuantLib" ;;
let _BoolVector_empty arg = match _BoolVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoolVector_clear_f : c_obj list -> c_obj list = "_wrap_BoolVector_clearQuantLib" ;;
let _BoolVector_clear arg = match _BoolVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoolVector_push_back_f : c_obj list -> c_obj list = "_wrap_BoolVector_push_backQuantLib" ;;
let _BoolVector_push_back arg = match _BoolVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoolVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_BoolVector_operator_bB___QuantLib" ;;
let _BoolVector_operator_xx_xx_lbrace_xx_rbrace arg = match _BoolVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoolVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_BoolVector_operator_e___QuantLib" ;;
let _BoolVector_operator_xx_xx_equals arg = match _BoolVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoolVector_set_f : c_obj list -> c_obj list = "_wrap_BoolVector_setQuantLib" ;;
let _BoolVector_set arg = match _BoolVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoolVector_to_array_f : c_obj list -> c_obj list = "_wrap_BoolVector_to_arrayQuantLib" ;;
let _BoolVector_to_array arg = match _BoolVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BoolVector_f : c_obj list -> c_obj list = "_wrap_delete_BoolVectorQuantLib" ;;
let _delete_BoolVector arg = match _delete_BoolVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NodePair_f : c_obj list -> c_obj list = "_wrap_new_NodePair__SWIG_0QuantLib" ;;
let _new_NodePair arg = match _new_NodePair_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NodePair_f : c_obj list -> c_obj list = "_wrap_new_NodePair__SWIG_1QuantLib" ;;
let _new_NodePair arg = match _new_NodePair_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NodePair_f : c_obj list -> c_obj list = "_wrap_new_NodePairQuantLib" ;;
let _new_NodePair arg = match _new_NodePair_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NodePair_first_set_f : c_obj list -> c_obj list = "_wrap_NodePair_first_setQuantLib" ;;
let _NodePair_first_set arg = match _NodePair_first_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NodePair_first_get_f : c_obj list -> c_obj list = "_wrap_NodePair_first_getQuantLib" ;;
let _NodePair_first_get arg = match _NodePair_first_get_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NodePair_second_set_f : c_obj list -> c_obj list = "_wrap_NodePair_second_setQuantLib" ;;
let _NodePair_second_set arg = match _NodePair_second_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NodePair_second_get_f : c_obj list -> c_obj list = "_wrap_NodePair_second_getQuantLib" ;;
let _NodePair_second_get arg = match _NodePair_second_get_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NodePair_f : c_obj list -> c_obj list = "_wrap_delete_NodePairQuantLib" ;;
let _delete_NodePair arg = match _delete_NodePair_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NodeVector_f : c_obj list -> c_obj list = "_wrap_new_NodeVector__SWIG_0QuantLib" ;;
let _new_NodeVector arg = match _new_NodeVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NodeVector_f : c_obj list -> c_obj list = "_wrap_new_NodeVector__SWIG_1QuantLib" ;;
let _new_NodeVector arg = match _new_NodeVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NodeVector_f : c_obj list -> c_obj list = "_wrap_new_NodeVector__SWIG_2QuantLib" ;;
let _new_NodeVector arg = match _new_NodeVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NodeVector_f : c_obj list -> c_obj list = "_wrap_new_NodeVectorQuantLib" ;;
let _new_NodeVector arg = match _new_NodeVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NodeVector_size_f : c_obj list -> c_obj list = "_wrap_NodeVector_sizeQuantLib" ;;
let _NodeVector_size arg = match _NodeVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NodeVector_empty_f : c_obj list -> c_obj list = "_wrap_NodeVector_emptyQuantLib" ;;
let _NodeVector_empty arg = match _NodeVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NodeVector_clear_f : c_obj list -> c_obj list = "_wrap_NodeVector_clearQuantLib" ;;
let _NodeVector_clear arg = match _NodeVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NodeVector_push_back_f : c_obj list -> c_obj list = "_wrap_NodeVector_push_backQuantLib" ;;
let _NodeVector_push_back arg = match _NodeVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NodeVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_NodeVector_operator_bB___QuantLib" ;;
let _NodeVector_operator_xx_xx_lbrace_xx_rbrace arg = match _NodeVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NodeVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_NodeVector_operator_e___QuantLib" ;;
let _NodeVector_operator_xx_xx_equals arg = match _NodeVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NodeVector_set_f : c_obj list -> c_obj list = "_wrap_NodeVector_setQuantLib" ;;
let _NodeVector_set arg = match _NodeVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NodeVector_to_array_f : c_obj list -> c_obj list = "_wrap_NodeVector_to_arrayQuantLib" ;;
let _NodeVector_to_array arg = match _NodeVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NodeVector_f : c_obj list -> c_obj list = "_wrap_delete_NodeVectorQuantLib" ;;
let _delete_NodeVector arg = match _delete_NodeVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Exercise___deref___f : c_obj list -> c_obj list = "_wrap_Exercise___deref__QuantLib" ;;
let _Exercise___deref__ arg = match _Exercise___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Exercise_isNull_f : c_obj list -> c_obj list = "_wrap_Exercise_isNullQuantLib" ;;
let _Exercise_isNull arg = match _Exercise_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Exercise_American : c_obj -> Swig.c_obj = "_wrap_Exercise_American" 
external _Exercise_Bermudan : c_obj -> Swig.c_obj = "_wrap_Exercise_Bermudan" 
external _Exercise_European : c_obj -> Swig.c_obj = "_wrap_Exercise_European" 
external _Exercise_exerciseType_f : c_obj list -> c_obj list = "_wrap_Exercise_exerciseTypeQuantLib" ;;
let _Exercise_exerciseType arg = match _Exercise_exerciseType_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Exercise_f : c_obj list -> c_obj list = "_wrap_new_ExerciseQuantLib" ;;
let _new_Exercise arg = match _new_Exercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Exercise_f : c_obj list -> c_obj list = "_wrap_delete_ExerciseQuantLib" ;;
let _delete_Exercise arg = match _delete_Exercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Exercise_type_f : c_obj list -> c_obj list = "_wrap_Exercise_typeQuantLib" ;;
let _Exercise_type arg = match _Exercise_type_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Exercise_dates_f : c_obj list -> c_obj list = "_wrap_Exercise_datesQuantLib" ;;
let _Exercise_dates arg = match _Exercise_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Exercise_lastDate_f : c_obj list -> c_obj list = "_wrap_Exercise_lastDateQuantLib" ;;
let _Exercise_lastDate arg = match _Exercise_lastDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuropeanExercise_f : c_obj list -> c_obj list = "_wrap_new_EuropeanExerciseQuantLib" ;;
let _new_EuropeanExercise arg = match _new_EuropeanExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EuropeanExercise_f : c_obj list -> c_obj list = "_wrap_delete_EuropeanExerciseQuantLib" ;;
let _delete_EuropeanExercise arg = match _delete_EuropeanExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AmericanExercise_f : c_obj list -> c_obj list = "_wrap_new_AmericanExercise__SWIG_0QuantLib" ;;
let _new_AmericanExercise arg = match _new_AmericanExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AmericanExercise_f : c_obj list -> c_obj list = "_wrap_new_AmericanExerciseQuantLib" ;;
let _new_AmericanExercise arg = match _new_AmericanExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AmericanExercise_f : c_obj list -> c_obj list = "_wrap_delete_AmericanExerciseQuantLib" ;;
let _delete_AmericanExercise arg = match _delete_AmericanExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BermudanExercise_f : c_obj list -> c_obj list = "_wrap_new_BermudanExercise__SWIG_0QuantLib" ;;
let _new_BermudanExercise arg = match _new_BermudanExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BermudanExercise_f : c_obj list -> c_obj list = "_wrap_new_BermudanExerciseQuantLib" ;;
let _new_BermudanExercise arg = match _new_BermudanExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BermudanExercise_f : c_obj list -> c_obj list = "_wrap_delete_BermudanExerciseQuantLib" ;;
let _delete_BermudanExercise arg = match _delete_BermudanExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RebatedExercise_f : c_obj list -> c_obj list = "_wrap_new_RebatedExercise__SWIG_0QuantLib" ;;
let _new_RebatedExercise arg = match _new_RebatedExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RebatedExercise_f : c_obj list -> c_obj list = "_wrap_new_RebatedExercise__SWIG_1QuantLib" ;;
let _new_RebatedExercise arg = match _new_RebatedExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RebatedExercise_f : c_obj list -> c_obj list = "_wrap_new_RebatedExercise__SWIG_2QuantLib" ;;
let _new_RebatedExercise arg = match _new_RebatedExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RebatedExercise_f : c_obj list -> c_obj list = "_wrap_new_RebatedExerciseQuantLib" ;;
let _new_RebatedExercise arg = match _new_RebatedExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RebatedExercise_f : c_obj list -> c_obj list = "_wrap_delete_RebatedExerciseQuantLib" ;;
let _delete_RebatedExercise arg = match _delete_RebatedExercise_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Observable___deref___f : c_obj list -> c_obj list = "_wrap_Observable___deref__QuantLib" ;;
let _Observable___deref__ arg = match _Observable___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Observable_isNull_f : c_obj list -> c_obj list = "_wrap_Observable_isNullQuantLib" ;;
let _Observable_isNull arg = match _Observable_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Observable_f : c_obj list -> c_obj list = "_wrap_new_ObservableQuantLib" ;;
let _new_Observable arg = match _new_Observable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Observable_f : c_obj list -> c_obj list = "_wrap_delete_ObservableQuantLib" ;;
let _delete_Observable arg = match _delete_Observable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Array_f : c_obj list -> c_obj list = "_wrap_new_Array__SWIG_0QuantLib" ;;
let _new_Array arg = match _new_Array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Array_f : c_obj list -> c_obj list = "_wrap_new_Array__SWIG_1QuantLib" ;;
let _new_Array arg = match _new_Array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Array_f : c_obj list -> c_obj list = "_wrap_new_Array__SWIG_2QuantLib" ;;
let _new_Array arg = match _new_Array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Array_f : c_obj list -> c_obj list = "_wrap_new_ArrayQuantLib" ;;
let _new_Array arg = match _new_Array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Array_size_f : c_obj list -> c_obj list = "_wrap_Array_sizeQuantLib" ;;
let _Array_size arg = match _Array_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Array___str___f : c_obj list -> c_obj list = "_wrap_Array___str__QuantLib" ;;
let _Array___str__ arg = match _Array___str___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Array_f : c_obj list -> c_obj list = "_wrap_delete_ArrayQuantLib" ;;
let _delete_Array arg = match _delete_Array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LexicographicalView_xSize_f : c_obj list -> c_obj list = "_wrap_LexicographicalView_xSizeQuantLib" ;;
let _LexicographicalView_xSize arg = match _LexicographicalView_xSize_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LexicographicalView_ySize_f : c_obj list -> c_obj list = "_wrap_LexicographicalView_ySizeQuantLib" ;;
let _LexicographicalView_ySize arg = match _LexicographicalView_ySize_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LexicographicalView_f : c_obj list -> c_obj list = "_wrap_new_LexicographicalViewQuantLib" ;;
let _new_LexicographicalView arg = match _new_LexicographicalView_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LexicographicalView___str___f : c_obj list -> c_obj list = "_wrap_LexicographicalView___str__QuantLib" ;;
let _LexicographicalView___str__ arg = match _LexicographicalView___str___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LexicographicalView_f : c_obj list -> c_obj list = "_wrap_delete_LexicographicalViewQuantLib" ;;
let _delete_LexicographicalView arg = match _delete_LexicographicalView_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Matrix_f : c_obj list -> c_obj list = "_wrap_new_Matrix__SWIG_0QuantLib" ;;
let _new_Matrix arg = match _new_Matrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Matrix_f : c_obj list -> c_obj list = "_wrap_new_Matrix__SWIG_1QuantLib" ;;
let _new_Matrix arg = match _new_Matrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Matrix_f : c_obj list -> c_obj list = "_wrap_new_Matrix__SWIG_2QuantLib" ;;
let _new_Matrix arg = match _new_Matrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Matrix_f : c_obj list -> c_obj list = "_wrap_new_MatrixQuantLib" ;;
let _new_Matrix arg = match _new_Matrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Matrix_rows_f : c_obj list -> c_obj list = "_wrap_Matrix_rowsQuantLib" ;;
let _Matrix_rows arg = match _Matrix_rows_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Matrix_columns_f : c_obj list -> c_obj list = "_wrap_Matrix_columnsQuantLib" ;;
let _Matrix_columns arg = match _Matrix_columns_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Matrix___str___f : c_obj list -> c_obj list = "_wrap_Matrix___str__QuantLib" ;;
let _Matrix___str__ arg = match _Matrix___str___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Matrix_f : c_obj list -> c_obj list = "_wrap_delete_MatrixQuantLib" ;;
let _delete_Matrix arg = match _delete_Matrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "SalvagingAlgorithm::Type_marker" (`Type)
external _None : c_obj -> Swig.c_obj = "_wrap_None" 
external _Spectral : c_obj -> Swig.c_obj = "_wrap_Spectral" 
external _new_SalvagingAlgorithm_f : c_obj list -> c_obj list = "_wrap_new_SalvagingAlgorithmQuantLib" ;;
let _new_SalvagingAlgorithm arg = match _new_SalvagingAlgorithm_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SalvagingAlgorithm_f : c_obj list -> c_obj list = "_wrap_delete_SalvagingAlgorithmQuantLib" ;;
let _delete_SalvagingAlgorithm arg = match _delete_SalvagingAlgorithm_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _transpose_f : c_obj list -> c_obj list = "_wrap_transposeQuantLib" ;;
let _transpose arg = match _transpose_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _outerProduct_f : c_obj list -> c_obj list = "_wrap_outerProductQuantLib" ;;
let _outerProduct arg = match _outerProduct_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _pseudoSqrt_f : c_obj list -> c_obj list = "_wrap_pseudoSqrtQuantLib" ;;
let _pseudoSqrt arg = match _pseudoSqrt_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SVD_f : c_obj list -> c_obj list = "_wrap_new_SVDQuantLib" ;;
let _new_SVD arg = match _new_SVD_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SVD_U_f : c_obj list -> c_obj list = "_wrap_SVD_UQuantLib" ;;
let _SVD_U arg = match _SVD_U_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SVD_V_f : c_obj list -> c_obj list = "_wrap_SVD_VQuantLib" ;;
let _SVD_V arg = match _SVD_V_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SVD_S_f : c_obj list -> c_obj list = "_wrap_SVD_SQuantLib" ;;
let _SVD_S arg = match _SVD_S_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SVD_singularValues_f : c_obj list -> c_obj list = "_wrap_SVD_singularValuesQuantLib" ;;
let _SVD_singularValues arg = match _SVD_singularValues_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SVD_f : c_obj list -> c_obj list = "_wrap_delete_SVDQuantLib" ;;
let _delete_SVD arg = match _delete_SVD_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Quote___deref___f : c_obj list -> c_obj list = "_wrap_Quote___deref__QuantLib" ;;
let _Quote___deref__ arg = match _Quote___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Quote_isNull_f : c_obj list -> c_obj list = "_wrap_Quote_isNullQuantLib" ;;
let _Quote_isNull arg = match _Quote_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Quote_asObservable_f : c_obj list -> c_obj list = "_wrap_Quote_asObservableQuantLib" ;;
let _Quote_asObservable arg = match _Quote_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Quote_f : c_obj list -> c_obj list = "_wrap_new_QuoteQuantLib" ;;
let _new_Quote arg = match _new_Quote_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Quote_f : c_obj list -> c_obj list = "_wrap_delete_QuoteQuantLib" ;;
let _delete_Quote arg = match _delete_Quote_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Quote_value_f : c_obj list -> c_obj list = "_wrap_Quote_valueQuantLib" ;;
let _Quote_value arg = match _Quote_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteHandle_f : c_obj list -> c_obj list = "_wrap_new_QuoteHandle__SWIG_0QuantLib" ;;
let _new_QuoteHandle arg = match _new_QuoteHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteHandle_f : c_obj list -> c_obj list = "_wrap_new_QuoteHandleQuantLib" ;;
let _new_QuoteHandle arg = match _new_QuoteHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandle___deref___f : c_obj list -> c_obj list = "_wrap_QuoteHandle___deref__QuantLib" ;;
let _QuoteHandle___deref__ arg = match _QuoteHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandle_empty_f : c_obj list -> c_obj list = "_wrap_QuoteHandle_emptyQuantLib" ;;
let _QuoteHandle_empty arg = match _QuoteHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_QuoteHandle_asObservableQuantLib" ;;
let _QuoteHandle_asObservable arg = match _QuoteHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_QuoteHandle_f : c_obj list -> c_obj list = "_wrap_delete_QuoteHandleQuantLib" ;;
let _delete_QuoteHandle arg = match _delete_QuoteHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandle_value_f : c_obj list -> c_obj list = "_wrap_QuoteHandle_valueQuantLib" ;;
let _QuoteHandle_value arg = match _QuoteHandle_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableQuoteHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableQuoteHandle__SWIG_0QuantLib" ;;
let _new_RelinkableQuoteHandle arg = match _new_RelinkableQuoteHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableQuoteHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableQuoteHandleQuantLib" ;;
let _new_RelinkableQuoteHandle arg = match _new_RelinkableQuoteHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandle_linkToQuantLib" ;;
let _RelinkableQuoteHandle_linkTo arg = match _RelinkableQuoteHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableQuoteHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableQuoteHandleQuantLib" ;;
let _delete_RelinkableQuoteHandle arg = match _delete_RelinkableQuoteHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SimpleQuote_f : c_obj list -> c_obj list = "_wrap_new_SimpleQuoteQuantLib" ;;
let _new_SimpleQuote arg = match _new_SimpleQuote_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SimpleQuote_setValue_f : c_obj list -> c_obj list = "_wrap_SimpleQuote_setValueQuantLib" ;;
let _SimpleQuote_setValue arg = match _SimpleQuote_setValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SimpleQuote_f : c_obj list -> c_obj list = "_wrap_delete_SimpleQuoteQuantLib" ;;
let _delete_SimpleQuote arg = match _delete_SimpleQuote_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteVector__SWIG_0QuantLib" ;;
let _new_QuoteVector arg = match _new_QuoteVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteVector__SWIG_1QuantLib" ;;
let _new_QuoteVector arg = match _new_QuoteVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteVector__SWIG_2QuantLib" ;;
let _new_QuoteVector arg = match _new_QuoteVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteVectorQuantLib" ;;
let _new_QuoteVector arg = match _new_QuoteVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVector_size_f : c_obj list -> c_obj list = "_wrap_QuoteVector_sizeQuantLib" ;;
let _QuoteVector_size arg = match _QuoteVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVector_empty_f : c_obj list -> c_obj list = "_wrap_QuoteVector_emptyQuantLib" ;;
let _QuoteVector_empty arg = match _QuoteVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVector_clear_f : c_obj list -> c_obj list = "_wrap_QuoteVector_clearQuantLib" ;;
let _QuoteVector_clear arg = match _QuoteVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVector_push_back_f : c_obj list -> c_obj list = "_wrap_QuoteVector_push_backQuantLib" ;;
let _QuoteVector_push_back arg = match _QuoteVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_QuoteVector_operator_bB___QuantLib" ;;
let _QuoteVector_operator_xx_xx_lbrace_xx_rbrace arg = match _QuoteVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_QuoteVector_operator_e___QuantLib" ;;
let _QuoteVector_operator_xx_xx_equals arg = match _QuoteVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVector_set_f : c_obj list -> c_obj list = "_wrap_QuoteVector_setQuantLib" ;;
let _QuoteVector_set arg = match _QuoteVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVector_to_array_f : c_obj list -> c_obj list = "_wrap_QuoteVector_to_arrayQuantLib" ;;
let _QuoteVector_to_array arg = match _QuoteVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_QuoteVector_f : c_obj list -> c_obj list = "_wrap_delete_QuoteVectorQuantLib" ;;
let _delete_QuoteVector arg = match _delete_QuoteVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteVectorVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteVectorVector__SWIG_0QuantLib" ;;
let _new_QuoteVectorVector arg = match _new_QuoteVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteVectorVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteVectorVector__SWIG_1QuantLib" ;;
let _new_QuoteVectorVector arg = match _new_QuoteVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteVectorVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteVectorVector__SWIG_2QuantLib" ;;
let _new_QuoteVectorVector arg = match _new_QuoteVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteVectorVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteVectorVectorQuantLib" ;;
let _new_QuoteVectorVector arg = match _new_QuoteVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVectorVector_size_f : c_obj list -> c_obj list = "_wrap_QuoteVectorVector_sizeQuantLib" ;;
let _QuoteVectorVector_size arg = match _QuoteVectorVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVectorVector_empty_f : c_obj list -> c_obj list = "_wrap_QuoteVectorVector_emptyQuantLib" ;;
let _QuoteVectorVector_empty arg = match _QuoteVectorVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVectorVector_clear_f : c_obj list -> c_obj list = "_wrap_QuoteVectorVector_clearQuantLib" ;;
let _QuoteVectorVector_clear arg = match _QuoteVectorVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVectorVector_push_back_f : c_obj list -> c_obj list = "_wrap_QuoteVectorVector_push_backQuantLib" ;;
let _QuoteVectorVector_push_back arg = match _QuoteVectorVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVectorVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_QuoteVectorVector_operator_bB___QuantLib" ;;
let _QuoteVectorVector_operator_xx_xx_lbrace_xx_rbrace arg = match _QuoteVectorVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVectorVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_QuoteVectorVector_operator_e___QuantLib" ;;
let _QuoteVectorVector_operator_xx_xx_equals arg = match _QuoteVectorVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVectorVector_set_f : c_obj list -> c_obj list = "_wrap_QuoteVectorVector_setQuantLib" ;;
let _QuoteVectorVector_set arg = match _QuoteVectorVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteVectorVector_to_array_f : c_obj list -> c_obj list = "_wrap_QuoteVectorVector_to_arrayQuantLib" ;;
let _QuoteVectorVector_to_array arg = match _QuoteVectorVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_QuoteVectorVector_f : c_obj list -> c_obj list = "_wrap_delete_QuoteVectorVectorQuantLib" ;;
let _delete_QuoteVectorVector arg = match _delete_QuoteVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteHandleVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteHandleVector__SWIG_0QuantLib" ;;
let _new_QuoteHandleVector arg = match _new_QuoteHandleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteHandleVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteHandleVector__SWIG_1QuantLib" ;;
let _new_QuoteHandleVector arg = match _new_QuoteHandleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteHandleVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteHandleVector__SWIG_2QuantLib" ;;
let _new_QuoteHandleVector arg = match _new_QuoteHandleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteHandleVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteHandleVectorQuantLib" ;;
let _new_QuoteHandleVector arg = match _new_QuoteHandleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVector_size_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVector_sizeQuantLib" ;;
let _QuoteHandleVector_size arg = match _QuoteHandleVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVector_empty_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVector_emptyQuantLib" ;;
let _QuoteHandleVector_empty arg = match _QuoteHandleVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVector_clear_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVector_clearQuantLib" ;;
let _QuoteHandleVector_clear arg = match _QuoteHandleVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVector_push_back_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVector_push_backQuantLib" ;;
let _QuoteHandleVector_push_back arg = match _QuoteHandleVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVector_operator_bB___QuantLib" ;;
let _QuoteHandleVector_operator_xx_xx_lbrace_xx_rbrace arg = match _QuoteHandleVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVector_operator_e___QuantLib" ;;
let _QuoteHandleVector_operator_xx_xx_equals arg = match _QuoteHandleVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVector_set_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVector_setQuantLib" ;;
let _QuoteHandleVector_set arg = match _QuoteHandleVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVector_to_array_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVector_to_arrayQuantLib" ;;
let _QuoteHandleVector_to_array arg = match _QuoteHandleVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_QuoteHandleVector_f : c_obj list -> c_obj list = "_wrap_delete_QuoteHandleVectorQuantLib" ;;
let _delete_QuoteHandleVector arg = match _delete_QuoteHandleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteHandleVectorVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteHandleVectorVector__SWIG_0QuantLib" ;;
let _new_QuoteHandleVectorVector arg = match _new_QuoteHandleVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteHandleVectorVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteHandleVectorVector__SWIG_1QuantLib" ;;
let _new_QuoteHandleVectorVector arg = match _new_QuoteHandleVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteHandleVectorVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteHandleVectorVector__SWIG_2QuantLib" ;;
let _new_QuoteHandleVectorVector arg = match _new_QuoteHandleVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuoteHandleVectorVector_f : c_obj list -> c_obj list = "_wrap_new_QuoteHandleVectorVectorQuantLib" ;;
let _new_QuoteHandleVectorVector arg = match _new_QuoteHandleVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVectorVector_size_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVectorVector_sizeQuantLib" ;;
let _QuoteHandleVectorVector_size arg = match _QuoteHandleVectorVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVectorVector_empty_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVectorVector_emptyQuantLib" ;;
let _QuoteHandleVectorVector_empty arg = match _QuoteHandleVectorVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVectorVector_clear_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVectorVector_clearQuantLib" ;;
let _QuoteHandleVectorVector_clear arg = match _QuoteHandleVectorVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVectorVector_push_back_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVectorVector_push_backQuantLib" ;;
let _QuoteHandleVectorVector_push_back arg = match _QuoteHandleVectorVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVectorVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVectorVector_operator_bB___QuantLib" ;;
let _QuoteHandleVectorVector_operator_xx_xx_lbrace_xx_rbrace arg = match _QuoteHandleVectorVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVectorVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVectorVector_operator_e___QuantLib" ;;
let _QuoteHandleVectorVector_operator_xx_xx_equals arg = match _QuoteHandleVectorVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVectorVector_set_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVectorVector_setQuantLib" ;;
let _QuoteHandleVectorVector_set arg = match _QuoteHandleVectorVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuoteHandleVectorVector_to_array_f : c_obj list -> c_obj list = "_wrap_QuoteHandleVectorVector_to_arrayQuantLib" ;;
let _QuoteHandleVectorVector_to_array arg = match _QuoteHandleVectorVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_QuoteHandleVectorVector_f : c_obj list -> c_obj list = "_wrap_delete_QuoteHandleVectorVectorQuantLib" ;;
let _delete_QuoteHandleVectorVector arg = match _delete_QuoteHandleVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableQuoteHandleVector_f : c_obj list -> c_obj list = "_wrap_new_RelinkableQuoteHandleVector__SWIG_0QuantLib" ;;
let _new_RelinkableQuoteHandleVector arg = match _new_RelinkableQuoteHandleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableQuoteHandleVector_f : c_obj list -> c_obj list = "_wrap_new_RelinkableQuoteHandleVector__SWIG_1QuantLib" ;;
let _new_RelinkableQuoteHandleVector arg = match _new_RelinkableQuoteHandleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableQuoteHandleVector_f : c_obj list -> c_obj list = "_wrap_new_RelinkableQuoteHandleVector__SWIG_2QuantLib" ;;
let _new_RelinkableQuoteHandleVector arg = match _new_RelinkableQuoteHandleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableQuoteHandleVector_f : c_obj list -> c_obj list = "_wrap_new_RelinkableQuoteHandleVectorQuantLib" ;;
let _new_RelinkableQuoteHandleVector arg = match _new_RelinkableQuoteHandleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVector_size_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVector_sizeQuantLib" ;;
let _RelinkableQuoteHandleVector_size arg = match _RelinkableQuoteHandleVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVector_empty_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVector_emptyQuantLib" ;;
let _RelinkableQuoteHandleVector_empty arg = match _RelinkableQuoteHandleVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVector_clear_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVector_clearQuantLib" ;;
let _RelinkableQuoteHandleVector_clear arg = match _RelinkableQuoteHandleVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVector_push_back_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVector_push_backQuantLib" ;;
let _RelinkableQuoteHandleVector_push_back arg = match _RelinkableQuoteHandleVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVector_operator_bB___QuantLib" ;;
let _RelinkableQuoteHandleVector_operator_xx_xx_lbrace_xx_rbrace arg = match _RelinkableQuoteHandleVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVector_operator_e___QuantLib" ;;
let _RelinkableQuoteHandleVector_operator_xx_xx_equals arg = match _RelinkableQuoteHandleVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVector_set_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVector_setQuantLib" ;;
let _RelinkableQuoteHandleVector_set arg = match _RelinkableQuoteHandleVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVector_to_array_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVector_to_arrayQuantLib" ;;
let _RelinkableQuoteHandleVector_to_array arg = match _RelinkableQuoteHandleVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableQuoteHandleVector_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableQuoteHandleVectorQuantLib" ;;
let _delete_RelinkableQuoteHandleVector arg = match _delete_RelinkableQuoteHandleVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableQuoteHandleVectorVector_f : c_obj list -> c_obj list = "_wrap_new_RelinkableQuoteHandleVectorVector__SWIG_0QuantLib" ;;
let _new_RelinkableQuoteHandleVectorVector arg = match _new_RelinkableQuoteHandleVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableQuoteHandleVectorVector_f : c_obj list -> c_obj list = "_wrap_new_RelinkableQuoteHandleVectorVector__SWIG_1QuantLib" ;;
let _new_RelinkableQuoteHandleVectorVector arg = match _new_RelinkableQuoteHandleVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableQuoteHandleVectorVector_f : c_obj list -> c_obj list = "_wrap_new_RelinkableQuoteHandleVectorVector__SWIG_2QuantLib" ;;
let _new_RelinkableQuoteHandleVectorVector arg = match _new_RelinkableQuoteHandleVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableQuoteHandleVectorVector_f : c_obj list -> c_obj list = "_wrap_new_RelinkableQuoteHandleVectorVectorQuantLib" ;;
let _new_RelinkableQuoteHandleVectorVector arg = match _new_RelinkableQuoteHandleVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVectorVector_size_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVectorVector_sizeQuantLib" ;;
let _RelinkableQuoteHandleVectorVector_size arg = match _RelinkableQuoteHandleVectorVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVectorVector_empty_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVectorVector_emptyQuantLib" ;;
let _RelinkableQuoteHandleVectorVector_empty arg = match _RelinkableQuoteHandleVectorVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVectorVector_clear_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVectorVector_clearQuantLib" ;;
let _RelinkableQuoteHandleVectorVector_clear arg = match _RelinkableQuoteHandleVectorVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVectorVector_push_back_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVectorVector_push_backQuantLib" ;;
let _RelinkableQuoteHandleVectorVector_push_back arg = match _RelinkableQuoteHandleVectorVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVectorVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVectorVector_operator_bB___QuantLib" ;;
let _RelinkableQuoteHandleVectorVector_operator_xx_xx_lbrace_xx_rbrace arg = match _RelinkableQuoteHandleVectorVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVectorVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVectorVector_operator_e___QuantLib" ;;
let _RelinkableQuoteHandleVectorVector_operator_xx_xx_equals arg = match _RelinkableQuoteHandleVectorVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVectorVector_set_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVectorVector_setQuantLib" ;;
let _RelinkableQuoteHandleVectorVector_set arg = match _RelinkableQuoteHandleVectorVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableQuoteHandleVectorVector_to_array_f : c_obj list -> c_obj list = "_wrap_RelinkableQuoteHandleVectorVector_to_arrayQuantLib" ;;
let _RelinkableQuoteHandleVectorVector_to_array arg = match _RelinkableQuoteHandleVectorVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableQuoteHandleVectorVector_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableQuoteHandleVectorVectorQuantLib" ;;
let _delete_RelinkableQuoteHandleVectorVector arg = match _delete_RelinkableQuoteHandleVectorVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "BusinessDayConvention_marker" (`BusinessDayConvention)
external _Following : c_obj -> Swig.c_obj = "_wrap_Following" 
external _ModifiedFollowing : c_obj -> Swig.c_obj = "_wrap_ModifiedFollowing" 
external _Preceding : c_obj -> Swig.c_obj = "_wrap_Preceding" 
external _ModifiedPreceding : c_obj -> Swig.c_obj = "_wrap_ModifiedPreceding" 
external _Unadjusted : c_obj -> Swig.c_obj = "_wrap_Unadjusted" 
external _HalfMonthModifiedFollowing : c_obj -> Swig.c_obj = "_wrap_HalfMonthModifiedFollowing" 
let _ = Callback.register "JointCalendarRule_marker" (`JointCalendarRule)
external _JoinHolidays : c_obj -> Swig.c_obj = "_wrap_JoinHolidays" 
external _JoinBusinessDays : c_obj -> Swig.c_obj = "_wrap_JoinBusinessDays" 
external _Calendar_isWeekend_f : c_obj list -> c_obj list = "_wrap_Calendar_isWeekendQuantLib" ;;
let _Calendar_isWeekend arg = match _Calendar_isWeekend_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_endOfMonth_f : c_obj list -> c_obj list = "_wrap_Calendar_endOfMonthQuantLib" ;;
let _Calendar_endOfMonth arg = match _Calendar_endOfMonth_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_isBusinessDay_f : c_obj list -> c_obj list = "_wrap_Calendar_isBusinessDayQuantLib" ;;
let _Calendar_isBusinessDay arg = match _Calendar_isBusinessDay_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_isHoliday_f : c_obj list -> c_obj list = "_wrap_Calendar_isHolidayQuantLib" ;;
let _Calendar_isHoliday arg = match _Calendar_isHoliday_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_isEndOfMonth_f : c_obj list -> c_obj list = "_wrap_Calendar_isEndOfMonthQuantLib" ;;
let _Calendar_isEndOfMonth arg = match _Calendar_isEndOfMonth_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_addHoliday_f : c_obj list -> c_obj list = "_wrap_Calendar_addHolidayQuantLib" ;;
let _Calendar_addHoliday arg = match _Calendar_addHoliday_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_removeHoliday_f : c_obj list -> c_obj list = "_wrap_Calendar_removeHolidayQuantLib" ;;
let _Calendar_removeHoliday arg = match _Calendar_removeHoliday_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_adjust_f : c_obj list -> c_obj list = "_wrap_Calendar_adjust__SWIG_0QuantLib" ;;
let _Calendar_adjust arg = match _Calendar_adjust_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_adjust_f : c_obj list -> c_obj list = "_wrap_Calendar_adjustQuantLib" ;;
let _Calendar_adjust arg = match _Calendar_adjust_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_advance_f : c_obj list -> c_obj list = "_wrap_Calendar_advance__SWIG_0QuantLib" ;;
let _Calendar_advance arg = match _Calendar_advance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_advance_f : c_obj list -> c_obj list = "_wrap_Calendar_advance__SWIG_1QuantLib" ;;
let _Calendar_advance arg = match _Calendar_advance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_advance_f : c_obj list -> c_obj list = "_wrap_Calendar_advance__SWIG_2QuantLib" ;;
let _Calendar_advance arg = match _Calendar_advance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_advance_f : c_obj list -> c_obj list = "_wrap_Calendar_advance__SWIG_3QuantLib" ;;
let _Calendar_advance arg = match _Calendar_advance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_advance_f : c_obj list -> c_obj list = "_wrap_Calendar_advance__SWIG_4QuantLib" ;;
let _Calendar_advance arg = match _Calendar_advance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_advance_f : c_obj list -> c_obj list = "_wrap_Calendar_advanceQuantLib" ;;
let _Calendar_advance arg = match _Calendar_advance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_businessDaysBetween_f : c_obj list -> c_obj list = "_wrap_Calendar_businessDaysBetween__SWIG_0QuantLib" ;;
let _Calendar_businessDaysBetween arg = match _Calendar_businessDaysBetween_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_businessDaysBetween_f : c_obj list -> c_obj list = "_wrap_Calendar_businessDaysBetween__SWIG_1QuantLib" ;;
let _Calendar_businessDaysBetween arg = match _Calendar_businessDaysBetween_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_businessDaysBetween_f : c_obj list -> c_obj list = "_wrap_Calendar_businessDaysBetweenQuantLib" ;;
let _Calendar_businessDaysBetween arg = match _Calendar_businessDaysBetween_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar_name_f : c_obj list -> c_obj list = "_wrap_Calendar_nameQuantLib" ;;
let _Calendar_name arg = match _Calendar_name_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Calendar___str___f : c_obj list -> c_obj list = "_wrap_Calendar___str__QuantLib" ;;
let _Calendar___str__ arg = match _Calendar___str___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Calendar_f : c_obj list -> c_obj list = "_wrap_delete_CalendarQuantLib" ;;
let _delete_Calendar arg = match _delete_Calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Argentina::Market_marker" (`Market)
external _Merval : c_obj -> Swig.c_obj = "_wrap_Merval" 
external _new_Argentina_f : c_obj list -> c_obj list = "_wrap_new_Argentina__SWIG_0QuantLib" ;;
let _new_Argentina arg = match _new_Argentina_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Argentina_f : c_obj list -> c_obj list = "_wrap_new_ArgentinaQuantLib" ;;
let _new_Argentina arg = match _new_Argentina_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Argentina_f : c_obj list -> c_obj list = "_wrap_delete_ArgentinaQuantLib" ;;
let _delete_Argentina arg = match _delete_Argentina_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Australia_f : c_obj list -> c_obj list = "_wrap_new_AustraliaQuantLib" ;;
let _new_Australia arg = match _new_Australia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Australia_f : c_obj list -> c_obj list = "_wrap_delete_AustraliaQuantLib" ;;
let _delete_Australia arg = match _delete_Australia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Brazil::Market_marker" (`Market)
external _Settlement : c_obj -> Swig.c_obj = "_wrap_Settlement" 
external _Exchange : c_obj -> Swig.c_obj = "_wrap_Exchange" 
external _new_Brazil_f : c_obj list -> c_obj list = "_wrap_new_Brazil__SWIG_0QuantLib" ;;
let _new_Brazil arg = match _new_Brazil_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Brazil_f : c_obj list -> c_obj list = "_wrap_new_BrazilQuantLib" ;;
let _new_Brazil arg = match _new_Brazil_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Brazil_f : c_obj list -> c_obj list = "_wrap_delete_BrazilQuantLib" ;;
let _delete_Brazil arg = match _delete_Brazil_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Canada::Market_marker" (`Market)
external _TSX : c_obj -> Swig.c_obj = "_wrap_TSX" 
external _new_Canada_f : c_obj list -> c_obj list = "_wrap_new_Canada__SWIG_0QuantLib" ;;
let _new_Canada arg = match _new_Canada_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Canada_f : c_obj list -> c_obj list = "_wrap_new_CanadaQuantLib" ;;
let _new_Canada arg = match _new_Canada_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Canada_f : c_obj list -> c_obj list = "_wrap_delete_CanadaQuantLib" ;;
let _delete_Canada arg = match _delete_Canada_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::China::Market_marker" (`Market)
external _SSE : c_obj -> Swig.c_obj = "_wrap_SSE" 
external _IB : c_obj -> Swig.c_obj = "_wrap_IB" 
external _new_China_f : c_obj list -> c_obj list = "_wrap_new_China__SWIG_0QuantLib" ;;
let _new_China arg = match _new_China_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_China_f : c_obj list -> c_obj list = "_wrap_new_ChinaQuantLib" ;;
let _new_China arg = match _new_China_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_China_f : c_obj list -> c_obj list = "_wrap_delete_ChinaQuantLib" ;;
let _delete_China arg = match _delete_China_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::CzechRepublic::Market_marker" (`Market)
external _PSE : c_obj -> Swig.c_obj = "_wrap_PSE" 
external _new_CzechRepublic_f : c_obj list -> c_obj list = "_wrap_new_CzechRepublic__SWIG_0QuantLib" ;;
let _new_CzechRepublic arg = match _new_CzechRepublic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CzechRepublic_f : c_obj list -> c_obj list = "_wrap_new_CzechRepublicQuantLib" ;;
let _new_CzechRepublic arg = match _new_CzechRepublic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CzechRepublic_f : c_obj list -> c_obj list = "_wrap_delete_CzechRepublicQuantLib" ;;
let _delete_CzechRepublic arg = match _delete_CzechRepublic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Denmark_f : c_obj list -> c_obj list = "_wrap_new_DenmarkQuantLib" ;;
let _new_Denmark arg = match _new_Denmark_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Denmark_f : c_obj list -> c_obj list = "_wrap_delete_DenmarkQuantLib" ;;
let _delete_Denmark arg = match _delete_Denmark_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Finland_f : c_obj list -> c_obj list = "_wrap_new_FinlandQuantLib" ;;
let _new_Finland arg = match _new_Finland_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Finland_f : c_obj list -> c_obj list = "_wrap_delete_FinlandQuantLib" ;;
let _delete_Finland arg = match _delete_Finland_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Germany::Market_marker" (`Market)
external _FrankfurtStockExchange : c_obj -> Swig.c_obj = "_wrap_FrankfurtStockExchange" 
external _Xetra : c_obj -> Swig.c_obj = "_wrap_Xetra" 
external _Eurex : c_obj -> Swig.c_obj = "_wrap_Eurex" 
external _new_Germany_f : c_obj list -> c_obj list = "_wrap_new_Germany__SWIG_0QuantLib" ;;
let _new_Germany arg = match _new_Germany_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Germany_f : c_obj list -> c_obj list = "_wrap_new_GermanyQuantLib" ;;
let _new_Germany arg = match _new_Germany_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Germany_f : c_obj list -> c_obj list = "_wrap_delete_GermanyQuantLib" ;;
let _delete_Germany arg = match _delete_Germany_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::HongKong::Market_marker" (`Market)
external _HKEx : c_obj -> Swig.c_obj = "_wrap_HKEx" 
external _new_HongKong_f : c_obj list -> c_obj list = "_wrap_new_HongKong__SWIG_0QuantLib" ;;
let _new_HongKong arg = match _new_HongKong_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HongKong_f : c_obj list -> c_obj list = "_wrap_new_HongKongQuantLib" ;;
let _new_HongKong arg = match _new_HongKong_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HongKong_f : c_obj list -> c_obj list = "_wrap_delete_HongKongQuantLib" ;;
let _delete_HongKong arg = match _delete_HongKong_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Hungary_f : c_obj list -> c_obj list = "_wrap_new_HungaryQuantLib" ;;
let _new_Hungary arg = match _new_Hungary_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Hungary_f : c_obj list -> c_obj list = "_wrap_delete_HungaryQuantLib" ;;
let _delete_Hungary arg = match _delete_Hungary_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Iceland::Market_marker" (`Market)
external _ICEX : c_obj -> Swig.c_obj = "_wrap_ICEX" 
external _new_Iceland_f : c_obj list -> c_obj list = "_wrap_new_Iceland__SWIG_0QuantLib" ;;
let _new_Iceland arg = match _new_Iceland_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Iceland_f : c_obj list -> c_obj list = "_wrap_new_IcelandQuantLib" ;;
let _new_Iceland arg = match _new_Iceland_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Iceland_f : c_obj list -> c_obj list = "_wrap_delete_IcelandQuantLib" ;;
let _delete_Iceland arg = match _delete_Iceland_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::India::Market_marker" (`Market)
external _NSE : c_obj -> Swig.c_obj = "_wrap_NSE" 
external _new_India_f : c_obj list -> c_obj list = "_wrap_new_India__SWIG_0QuantLib" ;;
let _new_India arg = match _new_India_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_India_f : c_obj list -> c_obj list = "_wrap_new_IndiaQuantLib" ;;
let _new_India arg = match _new_India_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_India_f : c_obj list -> c_obj list = "_wrap_delete_IndiaQuantLib" ;;
let _delete_India arg = match _delete_India_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Indonesia::Market_marker" (`Market)
external _BEJ : c_obj -> Swig.c_obj = "_wrap_BEJ" 
external _JSX : c_obj -> Swig.c_obj = "_wrap_JSX" 
external _new_Indonesia_f : c_obj list -> c_obj list = "_wrap_new_Indonesia__SWIG_0QuantLib" ;;
let _new_Indonesia arg = match _new_Indonesia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Indonesia_f : c_obj list -> c_obj list = "_wrap_new_IndonesiaQuantLib" ;;
let _new_Indonesia arg = match _new_Indonesia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Indonesia_f : c_obj list -> c_obj list = "_wrap_delete_IndonesiaQuantLib" ;;
let _delete_Indonesia arg = match _delete_Indonesia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Israel::Market_marker" (`Market)
external _TASE : c_obj -> Swig.c_obj = "_wrap_TASE" 
external _new_Israel_f : c_obj list -> c_obj list = "_wrap_new_Israel__SWIG_0QuantLib" ;;
let _new_Israel arg = match _new_Israel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Israel_f : c_obj list -> c_obj list = "_wrap_new_IsraelQuantLib" ;;
let _new_Israel arg = match _new_Israel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Israel_f : c_obj list -> c_obj list = "_wrap_delete_IsraelQuantLib" ;;
let _delete_Israel arg = match _delete_Israel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Italy::Market_marker" (`Market)
external _new_Italy_f : c_obj list -> c_obj list = "_wrap_new_Italy__SWIG_0QuantLib" ;;
let _new_Italy arg = match _new_Italy_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Italy_f : c_obj list -> c_obj list = "_wrap_new_ItalyQuantLib" ;;
let _new_Italy arg = match _new_Italy_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Italy_f : c_obj list -> c_obj list = "_wrap_delete_ItalyQuantLib" ;;
let _delete_Italy arg = match _delete_Italy_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Japan_f : c_obj list -> c_obj list = "_wrap_new_JapanQuantLib" ;;
let _new_Japan arg = match _new_Japan_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Japan_f : c_obj list -> c_obj list = "_wrap_delete_JapanQuantLib" ;;
let _delete_Japan arg = match _delete_Japan_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Mexico::Market_marker" (`Market)
external _BMV : c_obj -> Swig.c_obj = "_wrap_BMV" 
external _new_Mexico_f : c_obj list -> c_obj list = "_wrap_new_Mexico__SWIG_0QuantLib" ;;
let _new_Mexico arg = match _new_Mexico_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Mexico_f : c_obj list -> c_obj list = "_wrap_new_MexicoQuantLib" ;;
let _new_Mexico arg = match _new_Mexico_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Mexico_f : c_obj list -> c_obj list = "_wrap_delete_MexicoQuantLib" ;;
let _delete_Mexico arg = match _delete_Mexico_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NewZealand_f : c_obj list -> c_obj list = "_wrap_new_NewZealandQuantLib" ;;
let _new_NewZealand arg = match _new_NewZealand_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NewZealand_f : c_obj list -> c_obj list = "_wrap_delete_NewZealandQuantLib" ;;
let _delete_NewZealand arg = match _delete_NewZealand_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Norway_f : c_obj list -> c_obj list = "_wrap_new_NorwayQuantLib" ;;
let _new_Norway arg = match _new_Norway_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Norway_f : c_obj list -> c_obj list = "_wrap_delete_NorwayQuantLib" ;;
let _delete_Norway arg = match _delete_Norway_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Poland_f : c_obj list -> c_obj list = "_wrap_new_PolandQuantLib" ;;
let _new_Poland arg = match _new_Poland_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Poland_f : c_obj list -> c_obj list = "_wrap_delete_PolandQuantLib" ;;
let _delete_Poland arg = match _delete_Poland_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Russia::Market_marker" (`Market)
external _MOEX : c_obj -> Swig.c_obj = "_wrap_MOEX" 
external _new_Russia_f : c_obj list -> c_obj list = "_wrap_new_Russia__SWIG_0QuantLib" ;;
let _new_Russia arg = match _new_Russia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Russia_f : c_obj list -> c_obj list = "_wrap_new_RussiaQuantLib" ;;
let _new_Russia arg = match _new_Russia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Russia_f : c_obj list -> c_obj list = "_wrap_delete_RussiaQuantLib" ;;
let _delete_Russia arg = match _delete_Russia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Romania_f : c_obj list -> c_obj list = "_wrap_new_RomaniaQuantLib" ;;
let _new_Romania arg = match _new_Romania_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Romania_f : c_obj list -> c_obj list = "_wrap_delete_RomaniaQuantLib" ;;
let _delete_Romania arg = match _delete_Romania_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::SaudiArabia::Market_marker" (`Market)
external _Tadawul : c_obj -> Swig.c_obj = "_wrap_Tadawul" 
external _new_SaudiArabia_f : c_obj list -> c_obj list = "_wrap_new_SaudiArabia__SWIG_0QuantLib" ;;
let _new_SaudiArabia arg = match _new_SaudiArabia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SaudiArabia_f : c_obj list -> c_obj list = "_wrap_new_SaudiArabiaQuantLib" ;;
let _new_SaudiArabia arg = match _new_SaudiArabia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SaudiArabia_f : c_obj list -> c_obj list = "_wrap_delete_SaudiArabiaQuantLib" ;;
let _delete_SaudiArabia arg = match _delete_SaudiArabia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Singapore::Market_marker" (`Market)
external _SGX : c_obj -> Swig.c_obj = "_wrap_SGX" 
external _new_Singapore_f : c_obj list -> c_obj list = "_wrap_new_Singapore__SWIG_0QuantLib" ;;
let _new_Singapore arg = match _new_Singapore_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Singapore_f : c_obj list -> c_obj list = "_wrap_new_SingaporeQuantLib" ;;
let _new_Singapore arg = match _new_Singapore_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Singapore_f : c_obj list -> c_obj list = "_wrap_delete_SingaporeQuantLib" ;;
let _delete_Singapore arg = match _delete_Singapore_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Slovakia::Market_marker" (`Market)
external _BSSE : c_obj -> Swig.c_obj = "_wrap_BSSE" 
external _new_Slovakia_f : c_obj list -> c_obj list = "_wrap_new_Slovakia__SWIG_0QuantLib" ;;
let _new_Slovakia arg = match _new_Slovakia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Slovakia_f : c_obj list -> c_obj list = "_wrap_new_SlovakiaQuantLib" ;;
let _new_Slovakia arg = match _new_Slovakia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Slovakia_f : c_obj list -> c_obj list = "_wrap_delete_SlovakiaQuantLib" ;;
let _delete_Slovakia arg = match _delete_Slovakia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SouthAfrica_f : c_obj list -> c_obj list = "_wrap_new_SouthAfricaQuantLib" ;;
let _new_SouthAfrica arg = match _new_SouthAfrica_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SouthAfrica_f : c_obj list -> c_obj list = "_wrap_delete_SouthAfricaQuantLib" ;;
let _delete_SouthAfrica arg = match _delete_SouthAfrica_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::SouthKorea::Market_marker" (`Market)
external _KRX : c_obj -> Swig.c_obj = "_wrap_KRX" 
external _new_SouthKorea_f : c_obj list -> c_obj list = "_wrap_new_SouthKorea__SWIG_0QuantLib" ;;
let _new_SouthKorea arg = match _new_SouthKorea_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SouthKorea_f : c_obj list -> c_obj list = "_wrap_new_SouthKoreaQuantLib" ;;
let _new_SouthKorea arg = match _new_SouthKorea_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SouthKorea_f : c_obj list -> c_obj list = "_wrap_delete_SouthKoreaQuantLib" ;;
let _delete_SouthKorea arg = match _delete_SouthKorea_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Sweden_f : c_obj list -> c_obj list = "_wrap_new_SwedenQuantLib" ;;
let _new_Sweden arg = match _new_Sweden_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Sweden_f : c_obj list -> c_obj list = "_wrap_delete_SwedenQuantLib" ;;
let _delete_Sweden arg = match _delete_Sweden_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Switzerland_f : c_obj list -> c_obj list = "_wrap_new_SwitzerlandQuantLib" ;;
let _new_Switzerland arg = match _new_Switzerland_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Switzerland_f : c_obj list -> c_obj list = "_wrap_delete_SwitzerlandQuantLib" ;;
let _delete_Switzerland arg = match _delete_Switzerland_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Taiwan::Market_marker" (`Market)
external _TSEC : c_obj -> Swig.c_obj = "_wrap_TSEC" 
external _new_Taiwan_f : c_obj list -> c_obj list = "_wrap_new_Taiwan__SWIG_0QuantLib" ;;
let _new_Taiwan arg = match _new_Taiwan_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Taiwan_f : c_obj list -> c_obj list = "_wrap_new_TaiwanQuantLib" ;;
let _new_Taiwan arg = match _new_Taiwan_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Taiwan_f : c_obj list -> c_obj list = "_wrap_delete_TaiwanQuantLib" ;;
let _delete_Taiwan arg = match _delete_Taiwan_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TARGET_f : c_obj list -> c_obj list = "_wrap_new_TARGETQuantLib" ;;
let _new_TARGET arg = match _new_TARGET_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TARGET_f : c_obj list -> c_obj list = "_wrap_delete_TARGETQuantLib" ;;
let _delete_TARGET arg = match _delete_TARGET_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Turkey_f : c_obj list -> c_obj list = "_wrap_new_TurkeyQuantLib" ;;
let _new_Turkey arg = match _new_Turkey_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Turkey_f : c_obj list -> c_obj list = "_wrap_delete_TurkeyQuantLib" ;;
let _delete_Turkey arg = match _delete_Turkey_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Ukraine::Market_marker" (`Market)
external _USE : c_obj -> Swig.c_obj = "_wrap_USE" 
external _new_Ukraine_f : c_obj list -> c_obj list = "_wrap_new_Ukraine__SWIG_0QuantLib" ;;
let _new_Ukraine arg = match _new_Ukraine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Ukraine_f : c_obj list -> c_obj list = "_wrap_new_UkraineQuantLib" ;;
let _new_Ukraine arg = match _new_Ukraine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Ukraine_f : c_obj list -> c_obj list = "_wrap_delete_UkraineQuantLib" ;;
let _delete_Ukraine arg = match _delete_Ukraine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::UnitedKingdom::Market_marker" (`Market)
external _Metals : c_obj -> Swig.c_obj = "_wrap_Metals" 
external _new_UnitedKingdom_f : c_obj list -> c_obj list = "_wrap_new_UnitedKingdom__SWIG_0QuantLib" ;;
let _new_UnitedKingdom arg = match _new_UnitedKingdom_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UnitedKingdom_f : c_obj list -> c_obj list = "_wrap_new_UnitedKingdomQuantLib" ;;
let _new_UnitedKingdom arg = match _new_UnitedKingdom_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_UnitedKingdom_f : c_obj list -> c_obj list = "_wrap_delete_UnitedKingdomQuantLib" ;;
let _delete_UnitedKingdom arg = match _delete_UnitedKingdom_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::UnitedStates::Market_marker" (`Market)
external _NYSE : c_obj -> Swig.c_obj = "_wrap_NYSE" 
external _GovernmentBond : c_obj -> Swig.c_obj = "_wrap_GovernmentBond" 
external _NERC : c_obj -> Swig.c_obj = "_wrap_NERC" 
external _new_UnitedStates_f : c_obj list -> c_obj list = "_wrap_new_UnitedStates__SWIG_0QuantLib" ;;
let _new_UnitedStates arg = match _new_UnitedStates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UnitedStates_f : c_obj list -> c_obj list = "_wrap_new_UnitedStatesQuantLib" ;;
let _new_UnitedStates arg = match _new_UnitedStates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_UnitedStates_f : c_obj list -> c_obj list = "_wrap_delete_UnitedStatesQuantLib" ;;
let _delete_UnitedStates arg = match _delete_UnitedStates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NullCalendar_f : c_obj list -> c_obj list = "_wrap_new_NullCalendarQuantLib" ;;
let _new_NullCalendar arg = match _new_NullCalendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NullCalendar_f : c_obj list -> c_obj list = "_wrap_delete_NullCalendarQuantLib" ;;
let _delete_NullCalendar arg = match _delete_NullCalendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_WeekendsOnly_f : c_obj list -> c_obj list = "_wrap_new_WeekendsOnlyQuantLib" ;;
let _new_WeekendsOnly arg = match _new_WeekendsOnly_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_WeekendsOnly_f : c_obj list -> c_obj list = "_wrap_delete_WeekendsOnlyQuantLib" ;;
let _delete_WeekendsOnly arg = match _delete_WeekendsOnly_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_JointCalendar_f : c_obj list -> c_obj list = "_wrap_new_JointCalendar__SWIG_0QuantLib" ;;
let _new_JointCalendar arg = match _new_JointCalendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_JointCalendar_f : c_obj list -> c_obj list = "_wrap_new_JointCalendar__SWIG_1QuantLib" ;;
let _new_JointCalendar arg = match _new_JointCalendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_JointCalendar_f : c_obj list -> c_obj list = "_wrap_new_JointCalendar__SWIG_2QuantLib" ;;
let _new_JointCalendar arg = match _new_JointCalendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_JointCalendar_f : c_obj list -> c_obj list = "_wrap_new_JointCalendar__SWIG_3QuantLib" ;;
let _new_JointCalendar arg = match _new_JointCalendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_JointCalendar_f : c_obj list -> c_obj list = "_wrap_new_JointCalendar__SWIG_4QuantLib" ;;
let _new_JointCalendar arg = match _new_JointCalendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_JointCalendar_f : c_obj list -> c_obj list = "_wrap_new_JointCalendarQuantLib" ;;
let _new_JointCalendar arg = match _new_JointCalendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_JointCalendar_f : c_obj list -> c_obj list = "_wrap_delete_JointCalendarQuantLib" ;;
let _delete_JointCalendar arg = match _delete_JointCalendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BespokeCalendar_f : c_obj list -> c_obj list = "_wrap_new_BespokeCalendarQuantLib" ;;
let _new_BespokeCalendar arg = match _new_BespokeCalendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BespokeCalendar_addWeekend_f : c_obj list -> c_obj list = "_wrap_BespokeCalendar_addWeekendQuantLib" ;;
let _BespokeCalendar_addWeekend arg = match _BespokeCalendar_addWeekend_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BespokeCalendar_f : c_obj list -> c_obj list = "_wrap_delete_BespokeCalendarQuantLib" ;;
let _delete_BespokeCalendar arg = match _delete_BespokeCalendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _nullInt_f : c_obj list -> c_obj list = "_wrap_nullIntQuantLib" ;;
let _nullInt arg = match _nullInt_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _nullDouble_f : c_obj list -> c_obj list = "_wrap_nullDoubleQuantLib" ;;
let _nullDouble arg = match _nullDouble_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DayCounter_dayCount_f : c_obj list -> c_obj list = "_wrap_DayCounter_dayCountQuantLib" ;;
let _DayCounter_dayCount arg = match _DayCounter_dayCount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DayCounter_yearFraction_f : c_obj list -> c_obj list = "_wrap_DayCounter_yearFraction__SWIG_0QuantLib" ;;
let _DayCounter_yearFraction arg = match _DayCounter_yearFraction_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DayCounter_yearFraction_f : c_obj list -> c_obj list = "_wrap_DayCounter_yearFraction__SWIG_1QuantLib" ;;
let _DayCounter_yearFraction arg = match _DayCounter_yearFraction_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DayCounter_yearFraction_f : c_obj list -> c_obj list = "_wrap_DayCounter_yearFractionQuantLib" ;;
let _DayCounter_yearFraction arg = match _DayCounter_yearFraction_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DayCounter_name_f : c_obj list -> c_obj list = "_wrap_DayCounter_nameQuantLib" ;;
let _DayCounter_name arg = match _DayCounter_name_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DayCounter___str___f : c_obj list -> c_obj list = "_wrap_DayCounter___str__QuantLib" ;;
let _DayCounter___str__ arg = match _DayCounter___str___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DayCounter_f : c_obj list -> c_obj list = "_wrap_delete_DayCounterQuantLib" ;;
let _delete_DayCounter arg = match _delete_DayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Actual360_f : c_obj list -> c_obj list = "_wrap_new_Actual360QuantLib" ;;
let _new_Actual360 arg = match _new_Actual360_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Actual360_f : c_obj list -> c_obj list = "_wrap_delete_Actual360QuantLib" ;;
let _delete_Actual360 arg = match _delete_Actual360_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Actual365Fixed::Convention_marker" (`Convention)
external _Standard : c_obj -> Swig.c_obj = "_wrap_Standard" 
external _Canadian : c_obj -> Swig.c_obj = "_wrap_Canadian" 
external _NoLeap : c_obj -> Swig.c_obj = "_wrap_NoLeap" 
external _new_Actual365Fixed_f : c_obj list -> c_obj list = "_wrap_new_Actual365Fixed__SWIG_0QuantLib" ;;
let _new_Actual365Fixed arg = match _new_Actual365Fixed_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Actual365Fixed_f : c_obj list -> c_obj list = "_wrap_new_Actual365FixedQuantLib" ;;
let _new_Actual365Fixed arg = match _new_Actual365Fixed_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Actual365Fixed_f : c_obj list -> c_obj list = "_wrap_delete_Actual365FixedQuantLib" ;;
let _delete_Actual365Fixed arg = match _delete_Actual365Fixed_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::Thirty360::Convention_marker" (`Convention)
external _USA : c_obj -> Swig.c_obj = "_wrap_USA" 
external _BondBasis : c_obj -> Swig.c_obj = "_wrap_BondBasis" 
external _European : c_obj -> Swig.c_obj = "_wrap_European" 
external _EurobondBasis : c_obj -> Swig.c_obj = "_wrap_EurobondBasis" 
external _Italian : c_obj -> Swig.c_obj = "_wrap_Italian" 
external _new_Thirty360_f : c_obj list -> c_obj list = "_wrap_new_Thirty360__SWIG_0QuantLib" ;;
let _new_Thirty360 arg = match _new_Thirty360_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Thirty360_f : c_obj list -> c_obj list = "_wrap_new_Thirty360QuantLib" ;;
let _new_Thirty360 arg = match _new_Thirty360_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Thirty360_f : c_obj list -> c_obj list = "_wrap_delete_Thirty360QuantLib" ;;
let _delete_Thirty360 arg = match _delete_Thirty360_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "QuantLib::ActualActual::Convention_marker" (`Convention)
external _ISMA : c_obj -> Swig.c_obj = "_wrap_ISMA" 
external _Bond : c_obj -> Swig.c_obj = "_wrap_Bond" 
external _ISDA : c_obj -> Swig.c_obj = "_wrap_ISDA" 
external _Historical : c_obj -> Swig.c_obj = "_wrap_Historical" 
external _Actual365 : c_obj -> Swig.c_obj = "_wrap_Actual365" 
external _AFB : c_obj -> Swig.c_obj = "_wrap_AFB" 
external _Euro : c_obj -> Swig.c_obj = "_wrap_Euro" 
external _new_ActualActual_f : c_obj list -> c_obj list = "_wrap_new_ActualActual__SWIG_0QuantLib" ;;
let _new_ActualActual arg = match _new_ActualActual_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ActualActual_f : c_obj list -> c_obj list = "_wrap_new_ActualActual__SWIG_1QuantLib" ;;
let _new_ActualActual arg = match _new_ActualActual_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ActualActual_f : c_obj list -> c_obj list = "_wrap_new_ActualActualQuantLib" ;;
let _new_ActualActual arg = match _new_ActualActual_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ActualActual_f : c_obj list -> c_obj list = "_wrap_delete_ActualActualQuantLib" ;;
let _delete_ActualActual arg = match _delete_ActualActual_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OneDayCounter_f : c_obj list -> c_obj list = "_wrap_new_OneDayCounterQuantLib" ;;
let _new_OneDayCounter arg = match _new_OneDayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_OneDayCounter_f : c_obj list -> c_obj list = "_wrap_delete_OneDayCounterQuantLib" ;;
let _delete_OneDayCounter arg = match _delete_OneDayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SimpleDayCounter_f : c_obj list -> c_obj list = "_wrap_new_SimpleDayCounterQuantLib" ;;
let _new_SimpleDayCounter arg = match _new_SimpleDayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SimpleDayCounter_f : c_obj list -> c_obj list = "_wrap_delete_SimpleDayCounterQuantLib" ;;
let _delete_SimpleDayCounter arg = match _delete_SimpleDayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Business252_f : c_obj list -> c_obj list = "_wrap_new_Business252__SWIG_0QuantLib" ;;
let _new_Business252 arg = match _new_Business252_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Business252_f : c_obj list -> c_obj list = "_wrap_new_Business252QuantLib" ;;
let _new_Business252 arg = match _new_Business252_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Business252_f : c_obj list -> c_obj list = "_wrap_delete_Business252QuantLib" ;;
let _delete_Business252 arg = match _delete_Business252_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Actual365NoLeap_f : c_obj list -> c_obj list = "_wrap_Actual365NoLeapQuantLib" ;;
let _Actual365NoLeap arg = match _Actual365NoLeap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "Compounding_marker" (`Compounding)
external _Simple : c_obj -> Swig.c_obj = "_wrap_Simple" 
external _Compounded : c_obj -> Swig.c_obj = "_wrap_Compounded" 
external _Continuous : c_obj -> Swig.c_obj = "_wrap_Continuous" 
external _SimpleThenCompounded : c_obj -> Swig.c_obj = "_wrap_SimpleThenCompounded" 
external _CompoundedThenSimple : c_obj -> Swig.c_obj = "_wrap_CompoundedThenSimple" 
external _new_InterestRate_f : c_obj list -> c_obj list = "_wrap_new_InterestRate__SWIG_0QuantLib" ;;
let _new_InterestRate arg = match _new_InterestRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InterestRate_f : c_obj list -> c_obj list = "_wrap_new_InterestRateQuantLib" ;;
let _new_InterestRate arg = match _new_InterestRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_rate_f : c_obj list -> c_obj list = "_wrap_InterestRate_rateQuantLib" ;;
let _InterestRate_rate arg = match _InterestRate_rate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_dayCounter_f : c_obj list -> c_obj list = "_wrap_InterestRate_dayCounterQuantLib" ;;
let _InterestRate_dayCounter arg = match _InterestRate_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_compounding_f : c_obj list -> c_obj list = "_wrap_InterestRate_compoundingQuantLib" ;;
let _InterestRate_compounding arg = match _InterestRate_compounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_frequency_f : c_obj list -> c_obj list = "_wrap_InterestRate_frequencyQuantLib" ;;
let _InterestRate_frequency arg = match _InterestRate_frequency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_discountFactor_f : c_obj list -> c_obj list = "_wrap_InterestRate_discountFactor__SWIG_0QuantLib" ;;
let _InterestRate_discountFactor arg = match _InterestRate_discountFactor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_discountFactor_f : c_obj list -> c_obj list = "_wrap_InterestRate_discountFactor__SWIG_1QuantLib" ;;
let _InterestRate_discountFactor arg = match _InterestRate_discountFactor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_discountFactor_f : c_obj list -> c_obj list = "_wrap_InterestRate_discountFactor__SWIG_2QuantLib" ;;
let _InterestRate_discountFactor arg = match _InterestRate_discountFactor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_discountFactor_f : c_obj list -> c_obj list = "_wrap_InterestRate_discountFactorQuantLib" ;;
let _InterestRate_discountFactor arg = match _InterestRate_discountFactor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_compoundFactor_f : c_obj list -> c_obj list = "_wrap_InterestRate_compoundFactor__SWIG_0QuantLib" ;;
let _InterestRate_compoundFactor arg = match _InterestRate_compoundFactor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_compoundFactor_f : c_obj list -> c_obj list = "_wrap_InterestRate_compoundFactor__SWIG_1QuantLib" ;;
let _InterestRate_compoundFactor arg = match _InterestRate_compoundFactor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_compoundFactor_f : c_obj list -> c_obj list = "_wrap_InterestRate_compoundFactor__SWIG_2QuantLib" ;;
let _InterestRate_compoundFactor arg = match _InterestRate_compoundFactor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_compoundFactor_f : c_obj list -> c_obj list = "_wrap_InterestRate_compoundFactorQuantLib" ;;
let _InterestRate_compoundFactor arg = match _InterestRate_compoundFactor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_impliedRate_f : c_obj list -> c_obj list = "_wrap_InterestRate_impliedRate__SWIG_0QuantLib" ;;
let _InterestRate_impliedRate arg = match _InterestRate_impliedRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_impliedRate_f : c_obj list -> c_obj list = "_wrap_InterestRate_impliedRate__SWIG_1QuantLib" ;;
let _InterestRate_impliedRate arg = match _InterestRate_impliedRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_impliedRate_f : c_obj list -> c_obj list = "_wrap_InterestRate_impliedRate__SWIG_2QuantLib" ;;
let _InterestRate_impliedRate arg = match _InterestRate_impliedRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_impliedRate_f : c_obj list -> c_obj list = "_wrap_InterestRate_impliedRateQuantLib" ;;
let _InterestRate_impliedRate arg = match _InterestRate_impliedRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_equivalentRate_f : c_obj list -> c_obj list = "_wrap_InterestRate_equivalentRate__SWIG_0QuantLib" ;;
let _InterestRate_equivalentRate arg = match _InterestRate_equivalentRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_equivalentRate_f : c_obj list -> c_obj list = "_wrap_InterestRate_equivalentRate__SWIG_1QuantLib" ;;
let _InterestRate_equivalentRate arg = match _InterestRate_equivalentRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_equivalentRate_f : c_obj list -> c_obj list = "_wrap_InterestRate_equivalentRate__SWIG_2QuantLib" ;;
let _InterestRate_equivalentRate arg = match _InterestRate_equivalentRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate_equivalentRate_f : c_obj list -> c_obj list = "_wrap_InterestRate_equivalentRateQuantLib" ;;
let _InterestRate_equivalentRate arg = match _InterestRate_equivalentRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRate___str___f : c_obj list -> c_obj list = "_wrap_InterestRate___str__QuantLib" ;;
let _InterestRate___str__ arg = match _InterestRate___str___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InterestRate_f : c_obj list -> c_obj list = "_wrap_delete_InterestRateQuantLib" ;;
let _delete_InterestRate arg = match _delete_InterestRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InterestRateVector_f : c_obj list -> c_obj list = "_wrap_new_InterestRateVector__SWIG_0QuantLib" ;;
let _new_InterestRateVector arg = match _new_InterestRateVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InterestRateVector_f : c_obj list -> c_obj list = "_wrap_new_InterestRateVector__SWIG_1QuantLib" ;;
let _new_InterestRateVector arg = match _new_InterestRateVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InterestRateVector_f : c_obj list -> c_obj list = "_wrap_new_InterestRateVector__SWIG_2QuantLib" ;;
let _new_InterestRateVector arg = match _new_InterestRateVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InterestRateVector_f : c_obj list -> c_obj list = "_wrap_new_InterestRateVectorQuantLib" ;;
let _new_InterestRateVector arg = match _new_InterestRateVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateVector_size_f : c_obj list -> c_obj list = "_wrap_InterestRateVector_sizeQuantLib" ;;
let _InterestRateVector_size arg = match _InterestRateVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateVector_empty_f : c_obj list -> c_obj list = "_wrap_InterestRateVector_emptyQuantLib" ;;
let _InterestRateVector_empty arg = match _InterestRateVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateVector_clear_f : c_obj list -> c_obj list = "_wrap_InterestRateVector_clearQuantLib" ;;
let _InterestRateVector_clear arg = match _InterestRateVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateVector_push_back_f : c_obj list -> c_obj list = "_wrap_InterestRateVector_push_backQuantLib" ;;
let _InterestRateVector_push_back arg = match _InterestRateVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_InterestRateVector_operator_bB___QuantLib" ;;
let _InterestRateVector_operator_xx_xx_lbrace_xx_rbrace arg = match _InterestRateVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_InterestRateVector_operator_e___QuantLib" ;;
let _InterestRateVector_operator_xx_xx_equals arg = match _InterestRateVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateVector_set_f : c_obj list -> c_obj list = "_wrap_InterestRateVector_setQuantLib" ;;
let _InterestRateVector_set arg = match _InterestRateVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateVector_to_array_f : c_obj list -> c_obj list = "_wrap_InterestRateVector_to_arrayQuantLib" ;;
let _InterestRateVector_to_array arg = match _InterestRateVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InterestRateVector_f : c_obj list -> c_obj list = "_wrap_delete_InterestRateVectorQuantLib" ;;
let _delete_InterestRateVector arg = match _delete_InterestRateVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Rounding_f : c_obj list -> c_obj list = "_wrap_new_RoundingQuantLib" ;;
let _new_Rounding arg = match _new_Rounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Rounding_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_Rounding_operator_pP___QuantLib" ;;
let _Rounding_operator_xx_xx_lparen_xx_rparen arg = match _Rounding_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Rounding_f : c_obj list -> c_obj list = "_wrap_delete_RoundingQuantLib" ;;
let _delete_Rounding arg = match _delete_Rounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UpRounding_f : c_obj list -> c_obj list = "_wrap_new_UpRounding__SWIG_0QuantLib" ;;
let _new_UpRounding arg = match _new_UpRounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UpRounding_f : c_obj list -> c_obj list = "_wrap_new_UpRoundingQuantLib" ;;
let _new_UpRounding arg = match _new_UpRounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_UpRounding_f : c_obj list -> c_obj list = "_wrap_delete_UpRoundingQuantLib" ;;
let _delete_UpRounding arg = match _delete_UpRounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DownRounding_f : c_obj list -> c_obj list = "_wrap_new_DownRounding__SWIG_0QuantLib" ;;
let _new_DownRounding arg = match _new_DownRounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DownRounding_f : c_obj list -> c_obj list = "_wrap_new_DownRoundingQuantLib" ;;
let _new_DownRounding arg = match _new_DownRounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DownRounding_f : c_obj list -> c_obj list = "_wrap_delete_DownRoundingQuantLib" ;;
let _delete_DownRounding arg = match _delete_DownRounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ClosestRounding_f : c_obj list -> c_obj list = "_wrap_new_ClosestRounding__SWIG_0QuantLib" ;;
let _new_ClosestRounding arg = match _new_ClosestRounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ClosestRounding_f : c_obj list -> c_obj list = "_wrap_new_ClosestRoundingQuantLib" ;;
let _new_ClosestRounding arg = match _new_ClosestRounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ClosestRounding_f : c_obj list -> c_obj list = "_wrap_delete_ClosestRoundingQuantLib" ;;
let _delete_ClosestRounding arg = match _delete_ClosestRounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CeilingTruncation_f : c_obj list -> c_obj list = "_wrap_new_CeilingTruncation__SWIG_0QuantLib" ;;
let _new_CeilingTruncation arg = match _new_CeilingTruncation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CeilingTruncation_f : c_obj list -> c_obj list = "_wrap_new_CeilingTruncationQuantLib" ;;
let _new_CeilingTruncation arg = match _new_CeilingTruncation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CeilingTruncation_f : c_obj list -> c_obj list = "_wrap_delete_CeilingTruncationQuantLib" ;;
let _delete_CeilingTruncation arg = match _delete_CeilingTruncation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloorTruncation_f : c_obj list -> c_obj list = "_wrap_new_FloorTruncation__SWIG_0QuantLib" ;;
let _new_FloorTruncation arg = match _new_FloorTruncation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloorTruncation_f : c_obj list -> c_obj list = "_wrap_new_FloorTruncationQuantLib" ;;
let _new_FloorTruncation arg = match _new_FloorTruncation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FloorTruncation_f : c_obj list -> c_obj list = "_wrap_delete_FloorTruncationQuantLib" ;;
let _delete_FloorTruncation arg = match _delete_FloorTruncation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Currency_name_f : c_obj list -> c_obj list = "_wrap_Currency_nameQuantLib" ;;
let _Currency_name arg = match _Currency_name_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Currency_code_f : c_obj list -> c_obj list = "_wrap_Currency_codeQuantLib" ;;
let _Currency_code arg = match _Currency_code_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Currency_numericCode_f : c_obj list -> c_obj list = "_wrap_Currency_numericCodeQuantLib" ;;
let _Currency_numericCode arg = match _Currency_numericCode_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Currency_symbol_f : c_obj list -> c_obj list = "_wrap_Currency_symbolQuantLib" ;;
let _Currency_symbol arg = match _Currency_symbol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Currency_fractionSymbol_f : c_obj list -> c_obj list = "_wrap_Currency_fractionSymbolQuantLib" ;;
let _Currency_fractionSymbol arg = match _Currency_fractionSymbol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Currency_fractionsPerUnit_f : c_obj list -> c_obj list = "_wrap_Currency_fractionsPerUnitQuantLib" ;;
let _Currency_fractionsPerUnit arg = match _Currency_fractionsPerUnit_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Currency_rounding_f : c_obj list -> c_obj list = "_wrap_Currency_roundingQuantLib" ;;
let _Currency_rounding arg = match _Currency_rounding_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Currency_format_f : c_obj list -> c_obj list = "_wrap_Currency_formatQuantLib" ;;
let _Currency_format arg = match _Currency_format_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Currency_empty_f : c_obj list -> c_obj list = "_wrap_Currency_emptyQuantLib" ;;
let _Currency_empty arg = match _Currency_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Currency_triangulationCurrency_f : c_obj list -> c_obj list = "_wrap_Currency_triangulationCurrencyQuantLib" ;;
let _Currency_triangulationCurrency arg = match _Currency_triangulationCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Currency___str___f : c_obj list -> c_obj list = "_wrap_Currency___str__QuantLib" ;;
let _Currency___str__ arg = match _Currency___str___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Currency_f : c_obj list -> c_obj list = "_wrap_new_CurrencyQuantLib" ;;
let _new_Currency arg = match _new_Currency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Currency_f : c_obj list -> c_obj list = "_wrap_delete_CurrencyQuantLib" ;;
let _delete_Currency arg = match _delete_Currency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ARSCurrency_f : c_obj list -> c_obj list = "_wrap_new_ARSCurrencyQuantLib" ;;
let _new_ARSCurrency arg = match _new_ARSCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ARSCurrency_f : c_obj list -> c_obj list = "_wrap_delete_ARSCurrencyQuantLib" ;;
let _delete_ARSCurrency arg = match _delete_ARSCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ATSCurrency_f : c_obj list -> c_obj list = "_wrap_new_ATSCurrencyQuantLib" ;;
let _new_ATSCurrency arg = match _new_ATSCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ATSCurrency_f : c_obj list -> c_obj list = "_wrap_delete_ATSCurrencyQuantLib" ;;
let _delete_ATSCurrency arg = match _delete_ATSCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AUDCurrency_f : c_obj list -> c_obj list = "_wrap_new_AUDCurrencyQuantLib" ;;
let _new_AUDCurrency arg = match _new_AUDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AUDCurrency_f : c_obj list -> c_obj list = "_wrap_delete_AUDCurrencyQuantLib" ;;
let _delete_AUDCurrency arg = match _delete_AUDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BDTCurrency_f : c_obj list -> c_obj list = "_wrap_new_BDTCurrencyQuantLib" ;;
let _new_BDTCurrency arg = match _new_BDTCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BDTCurrency_f : c_obj list -> c_obj list = "_wrap_delete_BDTCurrencyQuantLib" ;;
let _delete_BDTCurrency arg = match _delete_BDTCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BEFCurrency_f : c_obj list -> c_obj list = "_wrap_new_BEFCurrencyQuantLib" ;;
let _new_BEFCurrency arg = match _new_BEFCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BEFCurrency_f : c_obj list -> c_obj list = "_wrap_delete_BEFCurrencyQuantLib" ;;
let _delete_BEFCurrency arg = match _delete_BEFCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BGLCurrency_f : c_obj list -> c_obj list = "_wrap_new_BGLCurrencyQuantLib" ;;
let _new_BGLCurrency arg = match _new_BGLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BGLCurrency_f : c_obj list -> c_obj list = "_wrap_delete_BGLCurrencyQuantLib" ;;
let _delete_BGLCurrency arg = match _delete_BGLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BRLCurrency_f : c_obj list -> c_obj list = "_wrap_new_BRLCurrencyQuantLib" ;;
let _new_BRLCurrency arg = match _new_BRLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BRLCurrency_f : c_obj list -> c_obj list = "_wrap_delete_BRLCurrencyQuantLib" ;;
let _delete_BRLCurrency arg = match _delete_BRLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BYRCurrency_f : c_obj list -> c_obj list = "_wrap_new_BYRCurrencyQuantLib" ;;
let _new_BYRCurrency arg = match _new_BYRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BYRCurrency_f : c_obj list -> c_obj list = "_wrap_delete_BYRCurrencyQuantLib" ;;
let _delete_BYRCurrency arg = match _delete_BYRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CADCurrency_f : c_obj list -> c_obj list = "_wrap_new_CADCurrencyQuantLib" ;;
let _new_CADCurrency arg = match _new_CADCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CADCurrency_f : c_obj list -> c_obj list = "_wrap_delete_CADCurrencyQuantLib" ;;
let _delete_CADCurrency arg = match _delete_CADCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CHFCurrency_f : c_obj list -> c_obj list = "_wrap_new_CHFCurrencyQuantLib" ;;
let _new_CHFCurrency arg = match _new_CHFCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CHFCurrency_f : c_obj list -> c_obj list = "_wrap_delete_CHFCurrencyQuantLib" ;;
let _delete_CHFCurrency arg = match _delete_CHFCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CLPCurrency_f : c_obj list -> c_obj list = "_wrap_new_CLPCurrencyQuantLib" ;;
let _new_CLPCurrency arg = match _new_CLPCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CLPCurrency_f : c_obj list -> c_obj list = "_wrap_delete_CLPCurrencyQuantLib" ;;
let _delete_CLPCurrency arg = match _delete_CLPCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CNYCurrency_f : c_obj list -> c_obj list = "_wrap_new_CNYCurrencyQuantLib" ;;
let _new_CNYCurrency arg = match _new_CNYCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CNYCurrency_f : c_obj list -> c_obj list = "_wrap_delete_CNYCurrencyQuantLib" ;;
let _delete_CNYCurrency arg = match _delete_CNYCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_COPCurrency_f : c_obj list -> c_obj list = "_wrap_new_COPCurrencyQuantLib" ;;
let _new_COPCurrency arg = match _new_COPCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_COPCurrency_f : c_obj list -> c_obj list = "_wrap_delete_COPCurrencyQuantLib" ;;
let _delete_COPCurrency arg = match _delete_COPCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CYPCurrency_f : c_obj list -> c_obj list = "_wrap_new_CYPCurrencyQuantLib" ;;
let _new_CYPCurrency arg = match _new_CYPCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CYPCurrency_f : c_obj list -> c_obj list = "_wrap_delete_CYPCurrencyQuantLib" ;;
let _delete_CYPCurrency arg = match _delete_CYPCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CZKCurrency_f : c_obj list -> c_obj list = "_wrap_new_CZKCurrencyQuantLib" ;;
let _new_CZKCurrency arg = match _new_CZKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CZKCurrency_f : c_obj list -> c_obj list = "_wrap_delete_CZKCurrencyQuantLib" ;;
let _delete_CZKCurrency arg = match _delete_CZKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DEMCurrency_f : c_obj list -> c_obj list = "_wrap_new_DEMCurrencyQuantLib" ;;
let _new_DEMCurrency arg = match _new_DEMCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DEMCurrency_f : c_obj list -> c_obj list = "_wrap_delete_DEMCurrencyQuantLib" ;;
let _delete_DEMCurrency arg = match _delete_DEMCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DKKCurrency_f : c_obj list -> c_obj list = "_wrap_new_DKKCurrencyQuantLib" ;;
let _new_DKKCurrency arg = match _new_DKKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DKKCurrency_f : c_obj list -> c_obj list = "_wrap_delete_DKKCurrencyQuantLib" ;;
let _delete_DKKCurrency arg = match _delete_DKKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EEKCurrency_f : c_obj list -> c_obj list = "_wrap_new_EEKCurrencyQuantLib" ;;
let _new_EEKCurrency arg = match _new_EEKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EEKCurrency_f : c_obj list -> c_obj list = "_wrap_delete_EEKCurrencyQuantLib" ;;
let _delete_EEKCurrency arg = match _delete_EEKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ESPCurrency_f : c_obj list -> c_obj list = "_wrap_new_ESPCurrencyQuantLib" ;;
let _new_ESPCurrency arg = match _new_ESPCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ESPCurrency_f : c_obj list -> c_obj list = "_wrap_delete_ESPCurrencyQuantLib" ;;
let _delete_ESPCurrency arg = match _delete_ESPCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURCurrency_f : c_obj list -> c_obj list = "_wrap_new_EURCurrencyQuantLib" ;;
let _new_EURCurrency arg = match _new_EURCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURCurrency_f : c_obj list -> c_obj list = "_wrap_delete_EURCurrencyQuantLib" ;;
let _delete_EURCurrency arg = match _delete_EURCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FIMCurrency_f : c_obj list -> c_obj list = "_wrap_new_FIMCurrencyQuantLib" ;;
let _new_FIMCurrency arg = match _new_FIMCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FIMCurrency_f : c_obj list -> c_obj list = "_wrap_delete_FIMCurrencyQuantLib" ;;
let _delete_FIMCurrency arg = match _delete_FIMCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FRFCurrency_f : c_obj list -> c_obj list = "_wrap_new_FRFCurrencyQuantLib" ;;
let _new_FRFCurrency arg = match _new_FRFCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FRFCurrency_f : c_obj list -> c_obj list = "_wrap_delete_FRFCurrencyQuantLib" ;;
let _delete_FRFCurrency arg = match _delete_FRFCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GBPCurrency_f : c_obj list -> c_obj list = "_wrap_new_GBPCurrencyQuantLib" ;;
let _new_GBPCurrency arg = match _new_GBPCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GBPCurrency_f : c_obj list -> c_obj list = "_wrap_delete_GBPCurrencyQuantLib" ;;
let _delete_GBPCurrency arg = match _delete_GBPCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GRDCurrency_f : c_obj list -> c_obj list = "_wrap_new_GRDCurrencyQuantLib" ;;
let _new_GRDCurrency arg = match _new_GRDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GRDCurrency_f : c_obj list -> c_obj list = "_wrap_delete_GRDCurrencyQuantLib" ;;
let _delete_GRDCurrency arg = match _delete_GRDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HKDCurrency_f : c_obj list -> c_obj list = "_wrap_new_HKDCurrencyQuantLib" ;;
let _new_HKDCurrency arg = match _new_HKDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HKDCurrency_f : c_obj list -> c_obj list = "_wrap_delete_HKDCurrencyQuantLib" ;;
let _delete_HKDCurrency arg = match _delete_HKDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HUFCurrency_f : c_obj list -> c_obj list = "_wrap_new_HUFCurrencyQuantLib" ;;
let _new_HUFCurrency arg = match _new_HUFCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HUFCurrency_f : c_obj list -> c_obj list = "_wrap_delete_HUFCurrencyQuantLib" ;;
let _delete_HUFCurrency arg = match _delete_HUFCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IEPCurrency_f : c_obj list -> c_obj list = "_wrap_new_IEPCurrencyQuantLib" ;;
let _new_IEPCurrency arg = match _new_IEPCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IEPCurrency_f : c_obj list -> c_obj list = "_wrap_delete_IEPCurrencyQuantLib" ;;
let _delete_IEPCurrency arg = match _delete_IEPCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IDRCurrency_f : c_obj list -> c_obj list = "_wrap_new_IDRCurrencyQuantLib" ;;
let _new_IDRCurrency arg = match _new_IDRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IDRCurrency_f : c_obj list -> c_obj list = "_wrap_delete_IDRCurrencyQuantLib" ;;
let _delete_IDRCurrency arg = match _delete_IDRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ILSCurrency_f : c_obj list -> c_obj list = "_wrap_new_ILSCurrencyQuantLib" ;;
let _new_ILSCurrency arg = match _new_ILSCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ILSCurrency_f : c_obj list -> c_obj list = "_wrap_delete_ILSCurrencyQuantLib" ;;
let _delete_ILSCurrency arg = match _delete_ILSCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_INRCurrency_f : c_obj list -> c_obj list = "_wrap_new_INRCurrencyQuantLib" ;;
let _new_INRCurrency arg = match _new_INRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_INRCurrency_f : c_obj list -> c_obj list = "_wrap_delete_INRCurrencyQuantLib" ;;
let _delete_INRCurrency arg = match _delete_INRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IQDCurrency_f : c_obj list -> c_obj list = "_wrap_new_IQDCurrencyQuantLib" ;;
let _new_IQDCurrency arg = match _new_IQDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IQDCurrency_f : c_obj list -> c_obj list = "_wrap_delete_IQDCurrencyQuantLib" ;;
let _delete_IQDCurrency arg = match _delete_IQDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IRRCurrency_f : c_obj list -> c_obj list = "_wrap_new_IRRCurrencyQuantLib" ;;
let _new_IRRCurrency arg = match _new_IRRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IRRCurrency_f : c_obj list -> c_obj list = "_wrap_delete_IRRCurrencyQuantLib" ;;
let _delete_IRRCurrency arg = match _delete_IRRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ISKCurrency_f : c_obj list -> c_obj list = "_wrap_new_ISKCurrencyQuantLib" ;;
let _new_ISKCurrency arg = match _new_ISKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ISKCurrency_f : c_obj list -> c_obj list = "_wrap_delete_ISKCurrencyQuantLib" ;;
let _delete_ISKCurrency arg = match _delete_ISKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ITLCurrency_f : c_obj list -> c_obj list = "_wrap_new_ITLCurrencyQuantLib" ;;
let _new_ITLCurrency arg = match _new_ITLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ITLCurrency_f : c_obj list -> c_obj list = "_wrap_delete_ITLCurrencyQuantLib" ;;
let _delete_ITLCurrency arg = match _delete_ITLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_JPYCurrency_f : c_obj list -> c_obj list = "_wrap_new_JPYCurrencyQuantLib" ;;
let _new_JPYCurrency arg = match _new_JPYCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_JPYCurrency_f : c_obj list -> c_obj list = "_wrap_delete_JPYCurrencyQuantLib" ;;
let _delete_JPYCurrency arg = match _delete_JPYCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_KRWCurrency_f : c_obj list -> c_obj list = "_wrap_new_KRWCurrencyQuantLib" ;;
let _new_KRWCurrency arg = match _new_KRWCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_KRWCurrency_f : c_obj list -> c_obj list = "_wrap_delete_KRWCurrencyQuantLib" ;;
let _delete_KRWCurrency arg = match _delete_KRWCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_KWDCurrency_f : c_obj list -> c_obj list = "_wrap_new_KWDCurrencyQuantLib" ;;
let _new_KWDCurrency arg = match _new_KWDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_KWDCurrency_f : c_obj list -> c_obj list = "_wrap_delete_KWDCurrencyQuantLib" ;;
let _delete_KWDCurrency arg = match _delete_KWDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LTLCurrency_f : c_obj list -> c_obj list = "_wrap_new_LTLCurrencyQuantLib" ;;
let _new_LTLCurrency arg = match _new_LTLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LTLCurrency_f : c_obj list -> c_obj list = "_wrap_delete_LTLCurrencyQuantLib" ;;
let _delete_LTLCurrency arg = match _delete_LTLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LUFCurrency_f : c_obj list -> c_obj list = "_wrap_new_LUFCurrencyQuantLib" ;;
let _new_LUFCurrency arg = match _new_LUFCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LUFCurrency_f : c_obj list -> c_obj list = "_wrap_delete_LUFCurrencyQuantLib" ;;
let _delete_LUFCurrency arg = match _delete_LUFCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LVLCurrency_f : c_obj list -> c_obj list = "_wrap_new_LVLCurrencyQuantLib" ;;
let _new_LVLCurrency arg = match _new_LVLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LVLCurrency_f : c_obj list -> c_obj list = "_wrap_delete_LVLCurrencyQuantLib" ;;
let _delete_LVLCurrency arg = match _delete_LVLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MTLCurrency_f : c_obj list -> c_obj list = "_wrap_new_MTLCurrencyQuantLib" ;;
let _new_MTLCurrency arg = match _new_MTLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MTLCurrency_f : c_obj list -> c_obj list = "_wrap_delete_MTLCurrencyQuantLib" ;;
let _delete_MTLCurrency arg = match _delete_MTLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MXNCurrency_f : c_obj list -> c_obj list = "_wrap_new_MXNCurrencyQuantLib" ;;
let _new_MXNCurrency arg = match _new_MXNCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MXNCurrency_f : c_obj list -> c_obj list = "_wrap_delete_MXNCurrencyQuantLib" ;;
let _delete_MXNCurrency arg = match _delete_MXNCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MYRCurrency_f : c_obj list -> c_obj list = "_wrap_new_MYRCurrencyQuantLib" ;;
let _new_MYRCurrency arg = match _new_MYRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MYRCurrency_f : c_obj list -> c_obj list = "_wrap_delete_MYRCurrencyQuantLib" ;;
let _delete_MYRCurrency arg = match _delete_MYRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NLGCurrency_f : c_obj list -> c_obj list = "_wrap_new_NLGCurrencyQuantLib" ;;
let _new_NLGCurrency arg = match _new_NLGCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NLGCurrency_f : c_obj list -> c_obj list = "_wrap_delete_NLGCurrencyQuantLib" ;;
let _delete_NLGCurrency arg = match _delete_NLGCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NOKCurrency_f : c_obj list -> c_obj list = "_wrap_new_NOKCurrencyQuantLib" ;;
let _new_NOKCurrency arg = match _new_NOKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NOKCurrency_f : c_obj list -> c_obj list = "_wrap_delete_NOKCurrencyQuantLib" ;;
let _delete_NOKCurrency arg = match _delete_NOKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NPRCurrency_f : c_obj list -> c_obj list = "_wrap_new_NPRCurrencyQuantLib" ;;
let _new_NPRCurrency arg = match _new_NPRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NPRCurrency_f : c_obj list -> c_obj list = "_wrap_delete_NPRCurrencyQuantLib" ;;
let _delete_NPRCurrency arg = match _delete_NPRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NZDCurrency_f : c_obj list -> c_obj list = "_wrap_new_NZDCurrencyQuantLib" ;;
let _new_NZDCurrency arg = match _new_NZDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NZDCurrency_f : c_obj list -> c_obj list = "_wrap_delete_NZDCurrencyQuantLib" ;;
let _delete_NZDCurrency arg = match _delete_NZDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PEHCurrency_f : c_obj list -> c_obj list = "_wrap_new_PEHCurrencyQuantLib" ;;
let _new_PEHCurrency arg = match _new_PEHCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PEHCurrency_f : c_obj list -> c_obj list = "_wrap_delete_PEHCurrencyQuantLib" ;;
let _delete_PEHCurrency arg = match _delete_PEHCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PEICurrency_f : c_obj list -> c_obj list = "_wrap_new_PEICurrencyQuantLib" ;;
let _new_PEICurrency arg = match _new_PEICurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PEICurrency_f : c_obj list -> c_obj list = "_wrap_delete_PEICurrencyQuantLib" ;;
let _delete_PEICurrency arg = match _delete_PEICurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PENCurrency_f : c_obj list -> c_obj list = "_wrap_new_PENCurrencyQuantLib" ;;
let _new_PENCurrency arg = match _new_PENCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PENCurrency_f : c_obj list -> c_obj list = "_wrap_delete_PENCurrencyQuantLib" ;;
let _delete_PENCurrency arg = match _delete_PENCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PKRCurrency_f : c_obj list -> c_obj list = "_wrap_new_PKRCurrencyQuantLib" ;;
let _new_PKRCurrency arg = match _new_PKRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PKRCurrency_f : c_obj list -> c_obj list = "_wrap_delete_PKRCurrencyQuantLib" ;;
let _delete_PKRCurrency arg = match _delete_PKRCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PLNCurrency_f : c_obj list -> c_obj list = "_wrap_new_PLNCurrencyQuantLib" ;;
let _new_PLNCurrency arg = match _new_PLNCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PLNCurrency_f : c_obj list -> c_obj list = "_wrap_delete_PLNCurrencyQuantLib" ;;
let _delete_PLNCurrency arg = match _delete_PLNCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PTECurrency_f : c_obj list -> c_obj list = "_wrap_new_PTECurrencyQuantLib" ;;
let _new_PTECurrency arg = match _new_PTECurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PTECurrency_f : c_obj list -> c_obj list = "_wrap_delete_PTECurrencyQuantLib" ;;
let _delete_PTECurrency arg = match _delete_PTECurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ROLCurrency_f : c_obj list -> c_obj list = "_wrap_new_ROLCurrencyQuantLib" ;;
let _new_ROLCurrency arg = match _new_ROLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ROLCurrency_f : c_obj list -> c_obj list = "_wrap_delete_ROLCurrencyQuantLib" ;;
let _delete_ROLCurrency arg = match _delete_ROLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RONCurrency_f : c_obj list -> c_obj list = "_wrap_new_RONCurrencyQuantLib" ;;
let _new_RONCurrency arg = match _new_RONCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RONCurrency_f : c_obj list -> c_obj list = "_wrap_delete_RONCurrencyQuantLib" ;;
let _delete_RONCurrency arg = match _delete_RONCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RUBCurrency_f : c_obj list -> c_obj list = "_wrap_new_RUBCurrencyQuantLib" ;;
let _new_RUBCurrency arg = match _new_RUBCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RUBCurrency_f : c_obj list -> c_obj list = "_wrap_delete_RUBCurrencyQuantLib" ;;
let _delete_RUBCurrency arg = match _delete_RUBCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SARCurrency_f : c_obj list -> c_obj list = "_wrap_new_SARCurrencyQuantLib" ;;
let _new_SARCurrency arg = match _new_SARCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SARCurrency_f : c_obj list -> c_obj list = "_wrap_delete_SARCurrencyQuantLib" ;;
let _delete_SARCurrency arg = match _delete_SARCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SEKCurrency_f : c_obj list -> c_obj list = "_wrap_new_SEKCurrencyQuantLib" ;;
let _new_SEKCurrency arg = match _new_SEKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SEKCurrency_f : c_obj list -> c_obj list = "_wrap_delete_SEKCurrencyQuantLib" ;;
let _delete_SEKCurrency arg = match _delete_SEKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SGDCurrency_f : c_obj list -> c_obj list = "_wrap_new_SGDCurrencyQuantLib" ;;
let _new_SGDCurrency arg = match _new_SGDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SGDCurrency_f : c_obj list -> c_obj list = "_wrap_delete_SGDCurrencyQuantLib" ;;
let _delete_SGDCurrency arg = match _delete_SGDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SITCurrency_f : c_obj list -> c_obj list = "_wrap_new_SITCurrencyQuantLib" ;;
let _new_SITCurrency arg = match _new_SITCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SITCurrency_f : c_obj list -> c_obj list = "_wrap_delete_SITCurrencyQuantLib" ;;
let _delete_SITCurrency arg = match _delete_SITCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SKKCurrency_f : c_obj list -> c_obj list = "_wrap_new_SKKCurrencyQuantLib" ;;
let _new_SKKCurrency arg = match _new_SKKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SKKCurrency_f : c_obj list -> c_obj list = "_wrap_delete_SKKCurrencyQuantLib" ;;
let _delete_SKKCurrency arg = match _delete_SKKCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_THBCurrency_f : c_obj list -> c_obj list = "_wrap_new_THBCurrencyQuantLib" ;;
let _new_THBCurrency arg = match _new_THBCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_THBCurrency_f : c_obj list -> c_obj list = "_wrap_delete_THBCurrencyQuantLib" ;;
let _delete_THBCurrency arg = match _delete_THBCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TRLCurrency_f : c_obj list -> c_obj list = "_wrap_new_TRLCurrencyQuantLib" ;;
let _new_TRLCurrency arg = match _new_TRLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TRLCurrency_f : c_obj list -> c_obj list = "_wrap_delete_TRLCurrencyQuantLib" ;;
let _delete_TRLCurrency arg = match _delete_TRLCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TRYCurrency_f : c_obj list -> c_obj list = "_wrap_new_TRYCurrencyQuantLib" ;;
let _new_TRYCurrency arg = match _new_TRYCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TRYCurrency_f : c_obj list -> c_obj list = "_wrap_delete_TRYCurrencyQuantLib" ;;
let _delete_TRYCurrency arg = match _delete_TRYCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TTDCurrency_f : c_obj list -> c_obj list = "_wrap_new_TTDCurrencyQuantLib" ;;
let _new_TTDCurrency arg = match _new_TTDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TTDCurrency_f : c_obj list -> c_obj list = "_wrap_delete_TTDCurrencyQuantLib" ;;
let _delete_TTDCurrency arg = match _delete_TTDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TWDCurrency_f : c_obj list -> c_obj list = "_wrap_new_TWDCurrencyQuantLib" ;;
let _new_TWDCurrency arg = match _new_TWDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TWDCurrency_f : c_obj list -> c_obj list = "_wrap_delete_TWDCurrencyQuantLib" ;;
let _delete_TWDCurrency arg = match _delete_TWDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_USDCurrency_f : c_obj list -> c_obj list = "_wrap_new_USDCurrencyQuantLib" ;;
let _new_USDCurrency arg = match _new_USDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_USDCurrency_f : c_obj list -> c_obj list = "_wrap_delete_USDCurrencyQuantLib" ;;
let _delete_USDCurrency arg = match _delete_USDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_VEBCurrency_f : c_obj list -> c_obj list = "_wrap_new_VEBCurrencyQuantLib" ;;
let _new_VEBCurrency arg = match _new_VEBCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_VEBCurrency_f : c_obj list -> c_obj list = "_wrap_delete_VEBCurrencyQuantLib" ;;
let _delete_VEBCurrency arg = match _delete_VEBCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_VNDCurrency_f : c_obj list -> c_obj list = "_wrap_new_VNDCurrencyQuantLib" ;;
let _new_VNDCurrency arg = match _new_VNDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_VNDCurrency_f : c_obj list -> c_obj list = "_wrap_delete_VNDCurrencyQuantLib" ;;
let _delete_VNDCurrency arg = match _delete_VNDCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZARCurrency_f : c_obj list -> c_obj list = "_wrap_new_ZARCurrencyQuantLib" ;;
let _new_ZARCurrency arg = match _new_ZARCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZARCurrency_f : c_obj list -> c_obj list = "_wrap_delete_ZARCurrencyQuantLib" ;;
let _delete_ZARCurrency arg = match _delete_ZARCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LinearInterpolation_f : c_obj list -> c_obj list = "_wrap_new_LinearInterpolationQuantLib" ;;
let _new_LinearInterpolation arg = match _new_LinearInterpolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LinearInterpolation_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_LinearInterpolation_operator_pP_____SWIG_0QuantLib" ;;
let _LinearInterpolation_operator_xx_xx_lparen_xx_rparen arg = match _LinearInterpolation_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LinearInterpolation_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_LinearInterpolation_operator_pP___QuantLib" ;;
let _LinearInterpolation_operator_xx_xx_lparen_xx_rparen arg = match _LinearInterpolation_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LinearInterpolation_f : c_obj list -> c_obj list = "_wrap_delete_LinearInterpolationQuantLib" ;;
let _delete_LinearInterpolation arg = match _delete_LinearInterpolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogLinearInterpolation_f : c_obj list -> c_obj list = "_wrap_new_LogLinearInterpolationQuantLib" ;;
let _new_LogLinearInterpolation arg = match _new_LogLinearInterpolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogLinearInterpolation_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_LogLinearInterpolation_operator_pP_____SWIG_0QuantLib" ;;
let _LogLinearInterpolation_operator_xx_xx_lparen_xx_rparen arg = match _LogLinearInterpolation_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogLinearInterpolation_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_LogLinearInterpolation_operator_pP___QuantLib" ;;
let _LogLinearInterpolation_operator_xx_xx_lparen_xx_rparen arg = match _LogLinearInterpolation_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LogLinearInterpolation_f : c_obj list -> c_obj list = "_wrap_delete_LogLinearInterpolationQuantLib" ;;
let _delete_LogLinearInterpolation arg = match _delete_LogLinearInterpolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BackwardFlatInterpolation_f : c_obj list -> c_obj list = "_wrap_new_BackwardFlatInterpolationQuantLib" ;;
let _new_BackwardFlatInterpolation arg = match _new_BackwardFlatInterpolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BackwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_BackwardFlatInterpolation_operator_pP_____SWIG_0QuantLib" ;;
let _BackwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen arg = match _BackwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BackwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_BackwardFlatInterpolation_operator_pP___QuantLib" ;;
let _BackwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen arg = match _BackwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BackwardFlatInterpolation_f : c_obj list -> c_obj list = "_wrap_delete_BackwardFlatInterpolationQuantLib" ;;
let _delete_BackwardFlatInterpolation arg = match _delete_BackwardFlatInterpolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardFlatInterpolation_f : c_obj list -> c_obj list = "_wrap_new_ForwardFlatInterpolationQuantLib" ;;
let _new_ForwardFlatInterpolation arg = match _new_ForwardFlatInterpolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_ForwardFlatInterpolation_operator_pP_____SWIG_0QuantLib" ;;
let _ForwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen arg = match _ForwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_ForwardFlatInterpolation_operator_pP___QuantLib" ;;
let _ForwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen arg = match _ForwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ForwardFlatInterpolation_f : c_obj list -> c_obj list = "_wrap_delete_ForwardFlatInterpolationQuantLib" ;;
let _delete_ForwardFlatInterpolation arg = match _delete_ForwardFlatInterpolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CubicNaturalSpline_f : c_obj list -> c_obj list = "_wrap_new_CubicNaturalSplineQuantLib" ;;
let _new_CubicNaturalSpline arg = match _new_CubicNaturalSpline_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_CubicNaturalSpline_operator_pP_____SWIG_0QuantLib" ;;
let _CubicNaturalSpline_operator_xx_xx_lparen_xx_rparen arg = match _CubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_CubicNaturalSpline_operator_pP___QuantLib" ;;
let _CubicNaturalSpline_operator_xx_xx_lparen_xx_rparen arg = match _CubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicNaturalSpline_derivative_f : c_obj list -> c_obj list = "_wrap_CubicNaturalSpline_derivative__SWIG_0QuantLib" ;;
let _CubicNaturalSpline_derivative arg = match _CubicNaturalSpline_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicNaturalSpline_derivative_f : c_obj list -> c_obj list = "_wrap_CubicNaturalSpline_derivativeQuantLib" ;;
let _CubicNaturalSpline_derivative arg = match _CubicNaturalSpline_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicNaturalSpline_secondDerivative_f : c_obj list -> c_obj list = "_wrap_CubicNaturalSpline_secondDerivative__SWIG_0QuantLib" ;;
let _CubicNaturalSpline_secondDerivative arg = match _CubicNaturalSpline_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicNaturalSpline_secondDerivative_f : c_obj list -> c_obj list = "_wrap_CubicNaturalSpline_secondDerivativeQuantLib" ;;
let _CubicNaturalSpline_secondDerivative arg = match _CubicNaturalSpline_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicNaturalSpline_primitive_f : c_obj list -> c_obj list = "_wrap_CubicNaturalSpline_primitive__SWIG_0QuantLib" ;;
let _CubicNaturalSpline_primitive arg = match _CubicNaturalSpline_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicNaturalSpline_primitive_f : c_obj list -> c_obj list = "_wrap_CubicNaturalSpline_primitiveQuantLib" ;;
let _CubicNaturalSpline_primitive arg = match _CubicNaturalSpline_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CubicNaturalSpline_f : c_obj list -> c_obj list = "_wrap_delete_CubicNaturalSplineQuantLib" ;;
let _delete_CubicNaturalSpline arg = match _delete_CubicNaturalSpline_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogCubicNaturalSpline_f : c_obj list -> c_obj list = "_wrap_new_LogCubicNaturalSplineQuantLib" ;;
let _new_LogCubicNaturalSpline arg = match _new_LogCubicNaturalSpline_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_LogCubicNaturalSpline_operator_pP_____SWIG_0QuantLib" ;;
let _LogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen arg = match _LogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_LogCubicNaturalSpline_operator_pP___QuantLib" ;;
let _LogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen arg = match _LogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicNaturalSpline_derivative_f : c_obj list -> c_obj list = "_wrap_LogCubicNaturalSpline_derivative__SWIG_0QuantLib" ;;
let _LogCubicNaturalSpline_derivative arg = match _LogCubicNaturalSpline_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicNaturalSpline_derivative_f : c_obj list -> c_obj list = "_wrap_LogCubicNaturalSpline_derivativeQuantLib" ;;
let _LogCubicNaturalSpline_derivative arg = match _LogCubicNaturalSpline_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicNaturalSpline_secondDerivative_f : c_obj list -> c_obj list = "_wrap_LogCubicNaturalSpline_secondDerivative__SWIG_0QuantLib" ;;
let _LogCubicNaturalSpline_secondDerivative arg = match _LogCubicNaturalSpline_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicNaturalSpline_secondDerivative_f : c_obj list -> c_obj list = "_wrap_LogCubicNaturalSpline_secondDerivativeQuantLib" ;;
let _LogCubicNaturalSpline_secondDerivative arg = match _LogCubicNaturalSpline_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicNaturalSpline_primitive_f : c_obj list -> c_obj list = "_wrap_LogCubicNaturalSpline_primitive__SWIG_0QuantLib" ;;
let _LogCubicNaturalSpline_primitive arg = match _LogCubicNaturalSpline_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicNaturalSpline_primitive_f : c_obj list -> c_obj list = "_wrap_LogCubicNaturalSpline_primitiveQuantLib" ;;
let _LogCubicNaturalSpline_primitive arg = match _LogCubicNaturalSpline_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LogCubicNaturalSpline_f : c_obj list -> c_obj list = "_wrap_delete_LogCubicNaturalSplineQuantLib" ;;
let _delete_LogCubicNaturalSpline arg = match _delete_LogCubicNaturalSpline_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MonotonicCubicNaturalSpline_f : c_obj list -> c_obj list = "_wrap_new_MonotonicCubicNaturalSplineQuantLib" ;;
let _new_MonotonicCubicNaturalSpline arg = match _new_MonotonicCubicNaturalSpline_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicNaturalSpline_operator_pP_____SWIG_0QuantLib" ;;
let _MonotonicCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen arg = match _MonotonicCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicNaturalSpline_operator_pP___QuantLib" ;;
let _MonotonicCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen arg = match _MonotonicCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicNaturalSpline_derivative_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicNaturalSpline_derivative__SWIG_0QuantLib" ;;
let _MonotonicCubicNaturalSpline_derivative arg = match _MonotonicCubicNaturalSpline_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicNaturalSpline_derivative_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicNaturalSpline_derivativeQuantLib" ;;
let _MonotonicCubicNaturalSpline_derivative arg = match _MonotonicCubicNaturalSpline_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicNaturalSpline_secondDerivative_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicNaturalSpline_secondDerivative__SWIG_0QuantLib" ;;
let _MonotonicCubicNaturalSpline_secondDerivative arg = match _MonotonicCubicNaturalSpline_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicNaturalSpline_secondDerivative_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicNaturalSpline_secondDerivativeQuantLib" ;;
let _MonotonicCubicNaturalSpline_secondDerivative arg = match _MonotonicCubicNaturalSpline_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicNaturalSpline_primitive_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicNaturalSpline_primitive__SWIG_0QuantLib" ;;
let _MonotonicCubicNaturalSpline_primitive arg = match _MonotonicCubicNaturalSpline_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicNaturalSpline_primitive_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicNaturalSpline_primitiveQuantLib" ;;
let _MonotonicCubicNaturalSpline_primitive arg = match _MonotonicCubicNaturalSpline_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MonotonicCubicNaturalSpline_f : c_obj list -> c_obj list = "_wrap_delete_MonotonicCubicNaturalSplineQuantLib" ;;
let _delete_MonotonicCubicNaturalSpline arg = match _delete_MonotonicCubicNaturalSpline_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MonotonicLogCubicNaturalSpline_f : c_obj list -> c_obj list = "_wrap_new_MonotonicLogCubicNaturalSplineQuantLib" ;;
let _new_MonotonicLogCubicNaturalSpline arg = match _new_MonotonicLogCubicNaturalSpline_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_MonotonicLogCubicNaturalSpline_operator_pP_____SWIG_0QuantLib" ;;
let _MonotonicLogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen arg = match _MonotonicLogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_MonotonicLogCubicNaturalSpline_operator_pP___QuantLib" ;;
let _MonotonicLogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen arg = match _MonotonicLogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogCubicNaturalSpline_derivative_f : c_obj list -> c_obj list = "_wrap_MonotonicLogCubicNaturalSpline_derivative__SWIG_0QuantLib" ;;
let _MonotonicLogCubicNaturalSpline_derivative arg = match _MonotonicLogCubicNaturalSpline_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogCubicNaturalSpline_derivative_f : c_obj list -> c_obj list = "_wrap_MonotonicLogCubicNaturalSpline_derivativeQuantLib" ;;
let _MonotonicLogCubicNaturalSpline_derivative arg = match _MonotonicLogCubicNaturalSpline_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogCubicNaturalSpline_secondDerivative_f : c_obj list -> c_obj list = "_wrap_MonotonicLogCubicNaturalSpline_secondDerivative__SWIG_0QuantLib" ;;
let _MonotonicLogCubicNaturalSpline_secondDerivative arg = match _MonotonicLogCubicNaturalSpline_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogCubicNaturalSpline_secondDerivative_f : c_obj list -> c_obj list = "_wrap_MonotonicLogCubicNaturalSpline_secondDerivativeQuantLib" ;;
let _MonotonicLogCubicNaturalSpline_secondDerivative arg = match _MonotonicLogCubicNaturalSpline_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogCubicNaturalSpline_primitive_f : c_obj list -> c_obj list = "_wrap_MonotonicLogCubicNaturalSpline_primitive__SWIG_0QuantLib" ;;
let _MonotonicLogCubicNaturalSpline_primitive arg = match _MonotonicLogCubicNaturalSpline_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogCubicNaturalSpline_primitive_f : c_obj list -> c_obj list = "_wrap_MonotonicLogCubicNaturalSpline_primitiveQuantLib" ;;
let _MonotonicLogCubicNaturalSpline_primitive arg = match _MonotonicLogCubicNaturalSpline_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MonotonicLogCubicNaturalSpline_f : c_obj list -> c_obj list = "_wrap_delete_MonotonicLogCubicNaturalSplineQuantLib" ;;
let _delete_MonotonicLogCubicNaturalSpline arg = match _delete_MonotonicLogCubicNaturalSpline_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_KrugerCubic_f : c_obj list -> c_obj list = "_wrap_new_KrugerCubicQuantLib" ;;
let _new_KrugerCubic arg = match _new_KrugerCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerCubic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_KrugerCubic_operator_pP_____SWIG_0QuantLib" ;;
let _KrugerCubic_operator_xx_xx_lparen_xx_rparen arg = match _KrugerCubic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerCubic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_KrugerCubic_operator_pP___QuantLib" ;;
let _KrugerCubic_operator_xx_xx_lparen_xx_rparen arg = match _KrugerCubic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerCubic_derivative_f : c_obj list -> c_obj list = "_wrap_KrugerCubic_derivative__SWIG_0QuantLib" ;;
let _KrugerCubic_derivative arg = match _KrugerCubic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerCubic_derivative_f : c_obj list -> c_obj list = "_wrap_KrugerCubic_derivativeQuantLib" ;;
let _KrugerCubic_derivative arg = match _KrugerCubic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerCubic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_KrugerCubic_secondDerivative__SWIG_0QuantLib" ;;
let _KrugerCubic_secondDerivative arg = match _KrugerCubic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerCubic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_KrugerCubic_secondDerivativeQuantLib" ;;
let _KrugerCubic_secondDerivative arg = match _KrugerCubic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerCubic_primitive_f : c_obj list -> c_obj list = "_wrap_KrugerCubic_primitive__SWIG_0QuantLib" ;;
let _KrugerCubic_primitive arg = match _KrugerCubic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerCubic_primitive_f : c_obj list -> c_obj list = "_wrap_KrugerCubic_primitiveQuantLib" ;;
let _KrugerCubic_primitive arg = match _KrugerCubic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_KrugerCubic_f : c_obj list -> c_obj list = "_wrap_delete_KrugerCubicQuantLib" ;;
let _delete_KrugerCubic arg = match _delete_KrugerCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_KrugerLogCubic_f : c_obj list -> c_obj list = "_wrap_new_KrugerLogCubicQuantLib" ;;
let _new_KrugerLogCubic arg = match _new_KrugerLogCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerLogCubic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_KrugerLogCubic_operator_pP_____SWIG_0QuantLib" ;;
let _KrugerLogCubic_operator_xx_xx_lparen_xx_rparen arg = match _KrugerLogCubic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerLogCubic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_KrugerLogCubic_operator_pP___QuantLib" ;;
let _KrugerLogCubic_operator_xx_xx_lparen_xx_rparen arg = match _KrugerLogCubic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerLogCubic_derivative_f : c_obj list -> c_obj list = "_wrap_KrugerLogCubic_derivative__SWIG_0QuantLib" ;;
let _KrugerLogCubic_derivative arg = match _KrugerLogCubic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerLogCubic_derivative_f : c_obj list -> c_obj list = "_wrap_KrugerLogCubic_derivativeQuantLib" ;;
let _KrugerLogCubic_derivative arg = match _KrugerLogCubic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerLogCubic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_KrugerLogCubic_secondDerivative__SWIG_0QuantLib" ;;
let _KrugerLogCubic_secondDerivative arg = match _KrugerLogCubic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerLogCubic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_KrugerLogCubic_secondDerivativeQuantLib" ;;
let _KrugerLogCubic_secondDerivative arg = match _KrugerLogCubic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerLogCubic_primitive_f : c_obj list -> c_obj list = "_wrap_KrugerLogCubic_primitive__SWIG_0QuantLib" ;;
let _KrugerLogCubic_primitive arg = match _KrugerLogCubic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KrugerLogCubic_primitive_f : c_obj list -> c_obj list = "_wrap_KrugerLogCubic_primitiveQuantLib" ;;
let _KrugerLogCubic_primitive arg = match _KrugerLogCubic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_KrugerLogCubic_f : c_obj list -> c_obj list = "_wrap_delete_KrugerLogCubicQuantLib" ;;
let _delete_KrugerLogCubic arg = match _delete_KrugerLogCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FritschButlandCubic_f : c_obj list -> c_obj list = "_wrap_new_FritschButlandCubicQuantLib" ;;
let _new_FritschButlandCubic arg = match _new_FritschButlandCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandCubic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_FritschButlandCubic_operator_pP_____SWIG_0QuantLib" ;;
let _FritschButlandCubic_operator_xx_xx_lparen_xx_rparen arg = match _FritschButlandCubic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandCubic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_FritschButlandCubic_operator_pP___QuantLib" ;;
let _FritschButlandCubic_operator_xx_xx_lparen_xx_rparen arg = match _FritschButlandCubic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandCubic_derivative_f : c_obj list -> c_obj list = "_wrap_FritschButlandCubic_derivative__SWIG_0QuantLib" ;;
let _FritschButlandCubic_derivative arg = match _FritschButlandCubic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandCubic_derivative_f : c_obj list -> c_obj list = "_wrap_FritschButlandCubic_derivativeQuantLib" ;;
let _FritschButlandCubic_derivative arg = match _FritschButlandCubic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandCubic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_FritschButlandCubic_secondDerivative__SWIG_0QuantLib" ;;
let _FritschButlandCubic_secondDerivative arg = match _FritschButlandCubic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandCubic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_FritschButlandCubic_secondDerivativeQuantLib" ;;
let _FritschButlandCubic_secondDerivative arg = match _FritschButlandCubic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandCubic_primitive_f : c_obj list -> c_obj list = "_wrap_FritschButlandCubic_primitive__SWIG_0QuantLib" ;;
let _FritschButlandCubic_primitive arg = match _FritschButlandCubic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandCubic_primitive_f : c_obj list -> c_obj list = "_wrap_FritschButlandCubic_primitiveQuantLib" ;;
let _FritschButlandCubic_primitive arg = match _FritschButlandCubic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FritschButlandCubic_f : c_obj list -> c_obj list = "_wrap_delete_FritschButlandCubicQuantLib" ;;
let _delete_FritschButlandCubic arg = match _delete_FritschButlandCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FritschButlandLogCubic_f : c_obj list -> c_obj list = "_wrap_new_FritschButlandLogCubicQuantLib" ;;
let _new_FritschButlandLogCubic arg = match _new_FritschButlandLogCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandLogCubic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_FritschButlandLogCubic_operator_pP_____SWIG_0QuantLib" ;;
let _FritschButlandLogCubic_operator_xx_xx_lparen_xx_rparen arg = match _FritschButlandLogCubic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandLogCubic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_FritschButlandLogCubic_operator_pP___QuantLib" ;;
let _FritschButlandLogCubic_operator_xx_xx_lparen_xx_rparen arg = match _FritschButlandLogCubic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandLogCubic_derivative_f : c_obj list -> c_obj list = "_wrap_FritschButlandLogCubic_derivative__SWIG_0QuantLib" ;;
let _FritschButlandLogCubic_derivative arg = match _FritschButlandLogCubic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandLogCubic_derivative_f : c_obj list -> c_obj list = "_wrap_FritschButlandLogCubic_derivativeQuantLib" ;;
let _FritschButlandLogCubic_derivative arg = match _FritschButlandLogCubic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandLogCubic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_FritschButlandLogCubic_secondDerivative__SWIG_0QuantLib" ;;
let _FritschButlandLogCubic_secondDerivative arg = match _FritschButlandLogCubic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandLogCubic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_FritschButlandLogCubic_secondDerivativeQuantLib" ;;
let _FritschButlandLogCubic_secondDerivative arg = match _FritschButlandLogCubic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandLogCubic_primitive_f : c_obj list -> c_obj list = "_wrap_FritschButlandLogCubic_primitive__SWIG_0QuantLib" ;;
let _FritschButlandLogCubic_primitive arg = match _FritschButlandLogCubic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FritschButlandLogCubic_primitive_f : c_obj list -> c_obj list = "_wrap_FritschButlandLogCubic_primitiveQuantLib" ;;
let _FritschButlandLogCubic_primitive arg = match _FritschButlandLogCubic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FritschButlandLogCubic_f : c_obj list -> c_obj list = "_wrap_delete_FritschButlandLogCubicQuantLib" ;;
let _delete_FritschButlandLogCubic arg = match _delete_FritschButlandLogCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Parabolic_f : c_obj list -> c_obj list = "_wrap_new_ParabolicQuantLib" ;;
let _new_Parabolic arg = match _new_Parabolic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parabolic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_Parabolic_operator_pP_____SWIG_0QuantLib" ;;
let _Parabolic_operator_xx_xx_lparen_xx_rparen arg = match _Parabolic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parabolic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_Parabolic_operator_pP___QuantLib" ;;
let _Parabolic_operator_xx_xx_lparen_xx_rparen arg = match _Parabolic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parabolic_derivative_f : c_obj list -> c_obj list = "_wrap_Parabolic_derivative__SWIG_0QuantLib" ;;
let _Parabolic_derivative arg = match _Parabolic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parabolic_derivative_f : c_obj list -> c_obj list = "_wrap_Parabolic_derivativeQuantLib" ;;
let _Parabolic_derivative arg = match _Parabolic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parabolic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_Parabolic_secondDerivative__SWIG_0QuantLib" ;;
let _Parabolic_secondDerivative arg = match _Parabolic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parabolic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_Parabolic_secondDerivativeQuantLib" ;;
let _Parabolic_secondDerivative arg = match _Parabolic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parabolic_primitive_f : c_obj list -> c_obj list = "_wrap_Parabolic_primitive__SWIG_0QuantLib" ;;
let _Parabolic_primitive arg = match _Parabolic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parabolic_primitive_f : c_obj list -> c_obj list = "_wrap_Parabolic_primitiveQuantLib" ;;
let _Parabolic_primitive arg = match _Parabolic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Parabolic_f : c_obj list -> c_obj list = "_wrap_delete_ParabolicQuantLib" ;;
let _delete_Parabolic arg = match _delete_Parabolic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogParabolic_f : c_obj list -> c_obj list = "_wrap_new_LogParabolicQuantLib" ;;
let _new_LogParabolic arg = match _new_LogParabolic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogParabolic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_LogParabolic_operator_pP_____SWIG_0QuantLib" ;;
let _LogParabolic_operator_xx_xx_lparen_xx_rparen arg = match _LogParabolic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogParabolic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_LogParabolic_operator_pP___QuantLib" ;;
let _LogParabolic_operator_xx_xx_lparen_xx_rparen arg = match _LogParabolic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogParabolic_derivative_f : c_obj list -> c_obj list = "_wrap_LogParabolic_derivative__SWIG_0QuantLib" ;;
let _LogParabolic_derivative arg = match _LogParabolic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogParabolic_derivative_f : c_obj list -> c_obj list = "_wrap_LogParabolic_derivativeQuantLib" ;;
let _LogParabolic_derivative arg = match _LogParabolic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogParabolic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_LogParabolic_secondDerivative__SWIG_0QuantLib" ;;
let _LogParabolic_secondDerivative arg = match _LogParabolic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogParabolic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_LogParabolic_secondDerivativeQuantLib" ;;
let _LogParabolic_secondDerivative arg = match _LogParabolic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogParabolic_primitive_f : c_obj list -> c_obj list = "_wrap_LogParabolic_primitive__SWIG_0QuantLib" ;;
let _LogParabolic_primitive arg = match _LogParabolic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogParabolic_primitive_f : c_obj list -> c_obj list = "_wrap_LogParabolic_primitiveQuantLib" ;;
let _LogParabolic_primitive arg = match _LogParabolic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LogParabolic_f : c_obj list -> c_obj list = "_wrap_delete_LogParabolicQuantLib" ;;
let _delete_LogParabolic arg = match _delete_LogParabolic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MonotonicParabolic_f : c_obj list -> c_obj list = "_wrap_new_MonotonicParabolicQuantLib" ;;
let _new_MonotonicParabolic arg = match _new_MonotonicParabolic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicParabolic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_MonotonicParabolic_operator_pP_____SWIG_0QuantLib" ;;
let _MonotonicParabolic_operator_xx_xx_lparen_xx_rparen arg = match _MonotonicParabolic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicParabolic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_MonotonicParabolic_operator_pP___QuantLib" ;;
let _MonotonicParabolic_operator_xx_xx_lparen_xx_rparen arg = match _MonotonicParabolic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicParabolic_derivative_f : c_obj list -> c_obj list = "_wrap_MonotonicParabolic_derivative__SWIG_0QuantLib" ;;
let _MonotonicParabolic_derivative arg = match _MonotonicParabolic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicParabolic_derivative_f : c_obj list -> c_obj list = "_wrap_MonotonicParabolic_derivativeQuantLib" ;;
let _MonotonicParabolic_derivative arg = match _MonotonicParabolic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicParabolic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_MonotonicParabolic_secondDerivative__SWIG_0QuantLib" ;;
let _MonotonicParabolic_secondDerivative arg = match _MonotonicParabolic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicParabolic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_MonotonicParabolic_secondDerivativeQuantLib" ;;
let _MonotonicParabolic_secondDerivative arg = match _MonotonicParabolic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicParabolic_primitive_f : c_obj list -> c_obj list = "_wrap_MonotonicParabolic_primitive__SWIG_0QuantLib" ;;
let _MonotonicParabolic_primitive arg = match _MonotonicParabolic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicParabolic_primitive_f : c_obj list -> c_obj list = "_wrap_MonotonicParabolic_primitiveQuantLib" ;;
let _MonotonicParabolic_primitive arg = match _MonotonicParabolic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MonotonicParabolic_f : c_obj list -> c_obj list = "_wrap_delete_MonotonicParabolicQuantLib" ;;
let _delete_MonotonicParabolic arg = match _delete_MonotonicParabolic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MonotonicLogParabolic_f : c_obj list -> c_obj list = "_wrap_new_MonotonicLogParabolicQuantLib" ;;
let _new_MonotonicLogParabolic arg = match _new_MonotonicLogParabolic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogParabolic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_MonotonicLogParabolic_operator_pP_____SWIG_0QuantLib" ;;
let _MonotonicLogParabolic_operator_xx_xx_lparen_xx_rparen arg = match _MonotonicLogParabolic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogParabolic_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_MonotonicLogParabolic_operator_pP___QuantLib" ;;
let _MonotonicLogParabolic_operator_xx_xx_lparen_xx_rparen arg = match _MonotonicLogParabolic_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogParabolic_derivative_f : c_obj list -> c_obj list = "_wrap_MonotonicLogParabolic_derivative__SWIG_0QuantLib" ;;
let _MonotonicLogParabolic_derivative arg = match _MonotonicLogParabolic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogParabolic_derivative_f : c_obj list -> c_obj list = "_wrap_MonotonicLogParabolic_derivativeQuantLib" ;;
let _MonotonicLogParabolic_derivative arg = match _MonotonicLogParabolic_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogParabolic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_MonotonicLogParabolic_secondDerivative__SWIG_0QuantLib" ;;
let _MonotonicLogParabolic_secondDerivative arg = match _MonotonicLogParabolic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogParabolic_secondDerivative_f : c_obj list -> c_obj list = "_wrap_MonotonicLogParabolic_secondDerivativeQuantLib" ;;
let _MonotonicLogParabolic_secondDerivative arg = match _MonotonicLogParabolic_secondDerivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogParabolic_primitive_f : c_obj list -> c_obj list = "_wrap_MonotonicLogParabolic_primitive__SWIG_0QuantLib" ;;
let _MonotonicLogParabolic_primitive arg = match _MonotonicLogParabolic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicLogParabolic_primitive_f : c_obj list -> c_obj list = "_wrap_MonotonicLogParabolic_primitiveQuantLib" ;;
let _MonotonicLogParabolic_primitive arg = match _MonotonicLogParabolic_primitive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MonotonicLogParabolic_f : c_obj list -> c_obj list = "_wrap_delete_MonotonicLogParabolicQuantLib" ;;
let _delete_MonotonicLogParabolic arg = match _delete_MonotonicLogParabolic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BilinearInterpolation_f : c_obj list -> c_obj list = "_wrap_new_BilinearInterpolationQuantLib" ;;
let _new_BilinearInterpolation arg = match _new_BilinearInterpolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BilinearInterpolation_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_BilinearInterpolation_operator_pP_____SWIG_0QuantLib" ;;
let _BilinearInterpolation_operator_xx_xx_lparen_xx_rparen arg = match _BilinearInterpolation_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BilinearInterpolation_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_BilinearInterpolation_operator_pP___QuantLib" ;;
let _BilinearInterpolation_operator_xx_xx_lparen_xx_rparen arg = match _BilinearInterpolation_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BilinearInterpolation_f : c_obj list -> c_obj list = "_wrap_delete_BilinearInterpolationQuantLib" ;;
let _delete_BilinearInterpolation arg = match _delete_BilinearInterpolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BicubicSpline_f : c_obj list -> c_obj list = "_wrap_new_BicubicSplineQuantLib" ;;
let _new_BicubicSpline arg = match _new_BicubicSpline_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BicubicSpline_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_BicubicSpline_operator_pP_____SWIG_0QuantLib" ;;
let _BicubicSpline_operator_xx_xx_lparen_xx_rparen arg = match _BicubicSpline_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BicubicSpline_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_BicubicSpline_operator_pP___QuantLib" ;;
let _BicubicSpline_operator_xx_xx_lparen_xx_rparen arg = match _BicubicSpline_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BicubicSpline_f : c_obj list -> c_obj list = "_wrap_delete_BicubicSplineQuantLib" ;;
let _delete_BicubicSpline arg = match _delete_BicubicSpline_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BackwardFlat_f : c_obj list -> c_obj list = "_wrap_new_BackwardFlatQuantLib" ;;
let _new_BackwardFlat arg = match _new_BackwardFlat_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BackwardFlat_f : c_obj list -> c_obj list = "_wrap_delete_BackwardFlatQuantLib" ;;
let _delete_BackwardFlat arg = match _delete_BackwardFlat_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardFlat_f : c_obj list -> c_obj list = "_wrap_new_ForwardFlatQuantLib" ;;
let _new_ForwardFlat arg = match _new_ForwardFlat_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ForwardFlat_f : c_obj list -> c_obj list = "_wrap_delete_ForwardFlatQuantLib" ;;
let _delete_ForwardFlat arg = match _delete_ForwardFlat_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Linear_f : c_obj list -> c_obj list = "_wrap_new_LinearQuantLib" ;;
let _new_Linear arg = match _new_Linear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Linear_f : c_obj list -> c_obj list = "_wrap_delete_LinearQuantLib" ;;
let _delete_Linear arg = match _delete_Linear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogLinear_f : c_obj list -> c_obj list = "_wrap_new_LogLinearQuantLib" ;;
let _new_LogLinear arg = match _new_LogLinear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LogLinear_f : c_obj list -> c_obj list = "_wrap_delete_LogLinearQuantLib" ;;
let _delete_LogLinear arg = match _delete_LogLinear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Cubic_f : c_obj list -> c_obj list = "_wrap_new_CubicQuantLib" ;;
let _new_Cubic arg = match _new_Cubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Cubic_f : c_obj list -> c_obj list = "_wrap_delete_CubicQuantLib" ;;
let _delete_Cubic arg = match _delete_Cubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MonotonicCubic_f : c_obj list -> c_obj list = "_wrap_new_MonotonicCubicQuantLib" ;;
let _new_MonotonicCubic arg = match _new_MonotonicCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MonotonicCubic_f : c_obj list -> c_obj list = "_wrap_delete_MonotonicCubicQuantLib" ;;
let _delete_MonotonicCubic arg = match _delete_MonotonicCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultLogCubic_f : c_obj list -> c_obj list = "_wrap_new_DefaultLogCubicQuantLib" ;;
let _new_DefaultLogCubic arg = match _new_DefaultLogCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DefaultLogCubic_f : c_obj list -> c_obj list = "_wrap_delete_DefaultLogCubicQuantLib" ;;
let _delete_DefaultLogCubic arg = match _delete_DefaultLogCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MonotonicLogCubic_f : c_obj list -> c_obj list = "_wrap_new_MonotonicLogCubicQuantLib" ;;
let _new_MonotonicLogCubic arg = match _new_MonotonicLogCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MonotonicLogCubic_f : c_obj list -> c_obj list = "_wrap_delete_MonotonicLogCubicQuantLib" ;;
let _delete_MonotonicLogCubic arg = match _delete_MonotonicLogCubic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure___deref___f : c_obj list -> c_obj list = "_wrap_YieldTermStructure___deref__QuantLib" ;;
let _YieldTermStructure___deref__ arg = match _YieldTermStructure___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_isNull_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_isNullQuantLib" ;;
let _YieldTermStructure_isNull arg = match _YieldTermStructure_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_asObservable_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_asObservableQuantLib" ;;
let _YieldTermStructure_asObservable arg = match _YieldTermStructure_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YieldTermStructure_f : c_obj list -> c_obj list = "_wrap_new_YieldTermStructureQuantLib" ;;
let _new_YieldTermStructure arg = match _new_YieldTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YieldTermStructure_f : c_obj list -> c_obj list = "_wrap_delete_YieldTermStructureQuantLib" ;;
let _delete_YieldTermStructure arg = match _delete_YieldTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_dayCounter_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_dayCounterQuantLib" ;;
let _YieldTermStructure_dayCounter arg = match _YieldTermStructure_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_calendar_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_calendarQuantLib" ;;
let _YieldTermStructure_calendar arg = match _YieldTermStructure_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_referenceDate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_referenceDateQuantLib" ;;
let _YieldTermStructure_referenceDate arg = match _YieldTermStructure_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_maxDate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_maxDateQuantLib" ;;
let _YieldTermStructure_maxDate arg = match _YieldTermStructure_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_maxTime_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_maxTimeQuantLib" ;;
let _YieldTermStructure_maxTime arg = match _YieldTermStructure_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_discount_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_discount__SWIG_0QuantLib" ;;
let _YieldTermStructure_discount arg = match _YieldTermStructure_discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_discount_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_discount__SWIG_1QuantLib" ;;
let _YieldTermStructure_discount arg = match _YieldTermStructure_discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_discount_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_discount__SWIG_2QuantLib" ;;
let _YieldTermStructure_discount arg = match _YieldTermStructure_discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_discount_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_discountQuantLib" ;;
let _YieldTermStructure_discount arg = match _YieldTermStructure_discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_zeroRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_zeroRate__SWIG_0QuantLib" ;;
let _YieldTermStructure_zeroRate arg = match _YieldTermStructure_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_zeroRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_zeroRate__SWIG_1QuantLib" ;;
let _YieldTermStructure_zeroRate arg = match _YieldTermStructure_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_zeroRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_zeroRate__SWIG_2QuantLib" ;;
let _YieldTermStructure_zeroRate arg = match _YieldTermStructure_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_zeroRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_zeroRate__SWIG_3QuantLib" ;;
let _YieldTermStructure_zeroRate arg = match _YieldTermStructure_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_zeroRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_zeroRate__SWIG_4QuantLib" ;;
let _YieldTermStructure_zeroRate arg = match _YieldTermStructure_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_zeroRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_zeroRateQuantLib" ;;
let _YieldTermStructure_zeroRate arg = match _YieldTermStructure_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_forwardRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_forwardRate__SWIG_0QuantLib" ;;
let _YieldTermStructure_forwardRate arg = match _YieldTermStructure_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_forwardRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_forwardRate__SWIG_1QuantLib" ;;
let _YieldTermStructure_forwardRate arg = match _YieldTermStructure_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_forwardRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_forwardRate__SWIG_2QuantLib" ;;
let _YieldTermStructure_forwardRate arg = match _YieldTermStructure_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_forwardRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_forwardRate__SWIG_3QuantLib" ;;
let _YieldTermStructure_forwardRate arg = match _YieldTermStructure_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_forwardRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_forwardRate__SWIG_4QuantLib" ;;
let _YieldTermStructure_forwardRate arg = match _YieldTermStructure_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_forwardRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_forwardRateQuantLib" ;;
let _YieldTermStructure_forwardRate arg = match _YieldTermStructure_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_enableExtrapolationQuantLib" ;;
let _YieldTermStructure_enableExtrapolation arg = match _YieldTermStructure_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_disableExtrapolationQuantLib" ;;
let _YieldTermStructure_disableExtrapolation arg = match _YieldTermStructure_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructure_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_YieldTermStructure_allowsExtrapolationQuantLib" ;;
let _YieldTermStructure_allowsExtrapolation arg = match _YieldTermStructure_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YieldTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_YieldTermStructureHandle__SWIG_0QuantLib" ;;
let _new_YieldTermStructureHandle arg = match _new_YieldTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YieldTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_YieldTermStructureHandleQuantLib" ;;
let _new_YieldTermStructureHandle arg = match _new_YieldTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle___deref___f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle___deref__QuantLib" ;;
let _YieldTermStructureHandle___deref__ arg = match _YieldTermStructureHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_empty_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_emptyQuantLib" ;;
let _YieldTermStructureHandle_empty arg = match _YieldTermStructureHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_asObservableQuantLib" ;;
let _YieldTermStructureHandle_asObservable arg = match _YieldTermStructureHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YieldTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_YieldTermStructureHandleQuantLib" ;;
let _delete_YieldTermStructureHandle arg = match _delete_YieldTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_dayCounter_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_dayCounterQuantLib" ;;
let _YieldTermStructureHandle_dayCounter arg = match _YieldTermStructureHandle_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_calendar_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_calendarQuantLib" ;;
let _YieldTermStructureHandle_calendar arg = match _YieldTermStructureHandle_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_referenceDate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_referenceDateQuantLib" ;;
let _YieldTermStructureHandle_referenceDate arg = match _YieldTermStructureHandle_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_maxDate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_maxDateQuantLib" ;;
let _YieldTermStructureHandle_maxDate arg = match _YieldTermStructureHandle_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_maxTime_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_maxTimeQuantLib" ;;
let _YieldTermStructureHandle_maxTime arg = match _YieldTermStructureHandle_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_discount_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_discount__SWIG_0QuantLib" ;;
let _YieldTermStructureHandle_discount arg = match _YieldTermStructureHandle_discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_discount_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_discount__SWIG_1QuantLib" ;;
let _YieldTermStructureHandle_discount arg = match _YieldTermStructureHandle_discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_discount_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_discount__SWIG_2QuantLib" ;;
let _YieldTermStructureHandle_discount arg = match _YieldTermStructureHandle_discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_discount_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_discountQuantLib" ;;
let _YieldTermStructureHandle_discount arg = match _YieldTermStructureHandle_discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_zeroRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_zeroRate__SWIG_0QuantLib" ;;
let _YieldTermStructureHandle_zeroRate arg = match _YieldTermStructureHandle_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_zeroRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_zeroRate__SWIG_1QuantLib" ;;
let _YieldTermStructureHandle_zeroRate arg = match _YieldTermStructureHandle_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_zeroRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_zeroRate__SWIG_2QuantLib" ;;
let _YieldTermStructureHandle_zeroRate arg = match _YieldTermStructureHandle_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_zeroRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_zeroRate__SWIG_3QuantLib" ;;
let _YieldTermStructureHandle_zeroRate arg = match _YieldTermStructureHandle_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_zeroRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_zeroRate__SWIG_4QuantLib" ;;
let _YieldTermStructureHandle_zeroRate arg = match _YieldTermStructureHandle_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_zeroRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_zeroRateQuantLib" ;;
let _YieldTermStructureHandle_zeroRate arg = match _YieldTermStructureHandle_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_forwardRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_forwardRate__SWIG_0QuantLib" ;;
let _YieldTermStructureHandle_forwardRate arg = match _YieldTermStructureHandle_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_forwardRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_forwardRate__SWIG_1QuantLib" ;;
let _YieldTermStructureHandle_forwardRate arg = match _YieldTermStructureHandle_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_forwardRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_forwardRate__SWIG_2QuantLib" ;;
let _YieldTermStructureHandle_forwardRate arg = match _YieldTermStructureHandle_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_forwardRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_forwardRate__SWIG_3QuantLib" ;;
let _YieldTermStructureHandle_forwardRate arg = match _YieldTermStructureHandle_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_forwardRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_forwardRate__SWIG_4QuantLib" ;;
let _YieldTermStructureHandle_forwardRate arg = match _YieldTermStructureHandle_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_forwardRate_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_forwardRateQuantLib" ;;
let _YieldTermStructureHandle_forwardRate arg = match _YieldTermStructureHandle_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_enableExtrapolationQuantLib" ;;
let _YieldTermStructureHandle_enableExtrapolation arg = match _YieldTermStructureHandle_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_disableExtrapolationQuantLib" ;;
let _YieldTermStructureHandle_disableExtrapolation arg = match _YieldTermStructureHandle_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YieldTermStructureHandle_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_YieldTermStructureHandle_allowsExtrapolationQuantLib" ;;
let _YieldTermStructureHandle_allowsExtrapolation arg = match _YieldTermStructureHandle_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableYieldTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableYieldTermStructureHandle__SWIG_0QuantLib" ;;
let _new_RelinkableYieldTermStructureHandle arg = match _new_RelinkableYieldTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableYieldTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableYieldTermStructureHandleQuantLib" ;;
let _new_RelinkableYieldTermStructureHandle arg = match _new_RelinkableYieldTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableYieldTermStructureHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableYieldTermStructureHandle_linkToQuantLib" ;;
let _RelinkableYieldTermStructureHandle_linkTo arg = match _RelinkableYieldTermStructureHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableYieldTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableYieldTermStructureHandleQuantLib" ;;
let _delete_RelinkableYieldTermStructureHandle arg = match _delete_RelinkableYieldTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ImpliedTermStructure_f : c_obj list -> c_obj list = "_wrap_new_ImpliedTermStructureQuantLib" ;;
let _new_ImpliedTermStructure arg = match _new_ImpliedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ImpliedTermStructure_f : c_obj list -> c_obj list = "_wrap_delete_ImpliedTermStructureQuantLib" ;;
let _delete_ImpliedTermStructure arg = match _delete_ImpliedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroSpreadedTermStructure_f : c_obj list -> c_obj list = "_wrap_new_ZeroSpreadedTermStructure__SWIG_0QuantLib" ;;
let _new_ZeroSpreadedTermStructure arg = match _new_ZeroSpreadedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroSpreadedTermStructure_f : c_obj list -> c_obj list = "_wrap_new_ZeroSpreadedTermStructure__SWIG_1QuantLib" ;;
let _new_ZeroSpreadedTermStructure arg = match _new_ZeroSpreadedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroSpreadedTermStructure_f : c_obj list -> c_obj list = "_wrap_new_ZeroSpreadedTermStructure__SWIG_2QuantLib" ;;
let _new_ZeroSpreadedTermStructure arg = match _new_ZeroSpreadedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroSpreadedTermStructure_f : c_obj list -> c_obj list = "_wrap_new_ZeroSpreadedTermStructureQuantLib" ;;
let _new_ZeroSpreadedTermStructure arg = match _new_ZeroSpreadedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZeroSpreadedTermStructure_f : c_obj list -> c_obj list = "_wrap_delete_ZeroSpreadedTermStructureQuantLib" ;;
let _delete_ZeroSpreadedTermStructure arg = match _delete_ZeroSpreadedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardSpreadedTermStructure_f : c_obj list -> c_obj list = "_wrap_new_ForwardSpreadedTermStructureQuantLib" ;;
let _new_ForwardSpreadedTermStructure arg = match _new_ForwardSpreadedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ForwardSpreadedTermStructure_f : c_obj list -> c_obj list = "_wrap_delete_ForwardSpreadedTermStructureQuantLib" ;;
let _delete_ForwardSpreadedTermStructure arg = match _delete_ForwardSpreadedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SpreadedLinearZeroInterpolatedTermStructure_f : c_obj list -> c_obj list = "_wrap_new_SpreadedLinearZeroInterpolatedTermStructure__SWIG_0QuantLib" ;;
let _new_SpreadedLinearZeroInterpolatedTermStructure arg = match _new_SpreadedLinearZeroInterpolatedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SpreadedLinearZeroInterpolatedTermStructure_f : c_obj list -> c_obj list = "_wrap_new_SpreadedLinearZeroInterpolatedTermStructure__SWIG_1QuantLib" ;;
let _new_SpreadedLinearZeroInterpolatedTermStructure arg = match _new_SpreadedLinearZeroInterpolatedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SpreadedLinearZeroInterpolatedTermStructure_f : c_obj list -> c_obj list = "_wrap_new_SpreadedLinearZeroInterpolatedTermStructure__SWIG_2QuantLib" ;;
let _new_SpreadedLinearZeroInterpolatedTermStructure arg = match _new_SpreadedLinearZeroInterpolatedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SpreadedLinearZeroInterpolatedTermStructure_f : c_obj list -> c_obj list = "_wrap_new_SpreadedLinearZeroInterpolatedTermStructure__SWIG_3QuantLib" ;;
let _new_SpreadedLinearZeroInterpolatedTermStructure arg = match _new_SpreadedLinearZeroInterpolatedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SpreadedLinearZeroInterpolatedTermStructure_f : c_obj list -> c_obj list = "_wrap_new_SpreadedLinearZeroInterpolatedTermStructureQuantLib" ;;
let _new_SpreadedLinearZeroInterpolatedTermStructure arg = match _new_SpreadedLinearZeroInterpolatedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SpreadedLinearZeroInterpolatedTermStructure_f : c_obj list -> c_obj list = "_wrap_delete_SpreadedLinearZeroInterpolatedTermStructureQuantLib" ;;
let _delete_SpreadedLinearZeroInterpolatedTermStructure arg = match _delete_SpreadedLinearZeroInterpolatedTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatForward_f : c_obj list -> c_obj list = "_wrap_new_FlatForward__SWIG_0QuantLib" ;;
let _new_FlatForward arg = match _new_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatForward_f : c_obj list -> c_obj list = "_wrap_new_FlatForward__SWIG_1QuantLib" ;;
let _new_FlatForward arg = match _new_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatForward_f : c_obj list -> c_obj list = "_wrap_new_FlatForward__SWIG_2QuantLib" ;;
let _new_FlatForward arg = match _new_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatForward_f : c_obj list -> c_obj list = "_wrap_new_FlatForward__SWIG_3QuantLib" ;;
let _new_FlatForward arg = match _new_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatForward_f : c_obj list -> c_obj list = "_wrap_new_FlatForward__SWIG_4QuantLib" ;;
let _new_FlatForward arg = match _new_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatForward_f : c_obj list -> c_obj list = "_wrap_new_FlatForward__SWIG_5QuantLib" ;;
let _new_FlatForward arg = match _new_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatForward_f : c_obj list -> c_obj list = "_wrap_new_FlatForward__SWIG_6QuantLib" ;;
let _new_FlatForward arg = match _new_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatForward_f : c_obj list -> c_obj list = "_wrap_new_FlatForward__SWIG_7QuantLib" ;;
let _new_FlatForward arg = match _new_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatForward_f : c_obj list -> c_obj list = "_wrap_new_FlatForward__SWIG_8QuantLib" ;;
let _new_FlatForward arg = match _new_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatForward_f : c_obj list -> c_obj list = "_wrap_new_FlatForward__SWIG_9QuantLib" ;;
let _new_FlatForward arg = match _new_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatForward_f : c_obj list -> c_obj list = "_wrap_new_FlatForward__SWIG_10QuantLib" ;;
let _new_FlatForward arg = match _new_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatForward_f : c_obj list -> c_obj list = "_wrap_new_FlatForwardQuantLib" ;;
let _new_FlatForward arg = match _new_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FlatForward_f : c_obj list -> c_obj list = "_wrap_delete_FlatForwardQuantLib" ;;
let _delete_FlatForward arg = match _delete_FlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RealTimeSeries_f : c_obj list -> c_obj list = "_wrap_new_RealTimeSeries__SWIG_0QuantLib" ;;
let _new_RealTimeSeries arg = match _new_RealTimeSeries_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RealTimeSeries_f : c_obj list -> c_obj list = "_wrap_new_RealTimeSeriesQuantLib" ;;
let _new_RealTimeSeries arg = match _new_RealTimeSeries_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RealTimeSeries_dates_f : c_obj list -> c_obj list = "_wrap_RealTimeSeries_datesQuantLib" ;;
let _RealTimeSeries_dates arg = match _RealTimeSeries_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RealTimeSeries_values_f : c_obj list -> c_obj list = "_wrap_RealTimeSeries_valuesQuantLib" ;;
let _RealTimeSeries_values arg = match _RealTimeSeries_values_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RealTimeSeries_size_f : c_obj list -> c_obj list = "_wrap_RealTimeSeries_sizeQuantLib" ;;
let _RealTimeSeries_size arg = match _RealTimeSeries_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RealTimeSeries_f : c_obj list -> c_obj list = "_wrap_delete_RealTimeSeriesQuantLib" ;;
let _delete_RealTimeSeries arg = match _delete_RealTimeSeries_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntervalPriceTimeSeries_f : c_obj list -> c_obj list = "_wrap_new_IntervalPriceTimeSeries__SWIG_0QuantLib" ;;
let _new_IntervalPriceTimeSeries arg = match _new_IntervalPriceTimeSeries_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntervalPriceTimeSeries_f : c_obj list -> c_obj list = "_wrap_new_IntervalPriceTimeSeriesQuantLib" ;;
let _new_IntervalPriceTimeSeries arg = match _new_IntervalPriceTimeSeries_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPriceTimeSeries_dates_f : c_obj list -> c_obj list = "_wrap_IntervalPriceTimeSeries_datesQuantLib" ;;
let _IntervalPriceTimeSeries_dates arg = match _IntervalPriceTimeSeries_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPriceTimeSeries_values_f : c_obj list -> c_obj list = "_wrap_IntervalPriceTimeSeries_valuesQuantLib" ;;
let _IntervalPriceTimeSeries_values arg = match _IntervalPriceTimeSeries_values_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPriceTimeSeries_size_f : c_obj list -> c_obj list = "_wrap_IntervalPriceTimeSeries_sizeQuantLib" ;;
let _IntervalPriceTimeSeries_size arg = match _IntervalPriceTimeSeries_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IntervalPriceTimeSeries_f : c_obj list -> c_obj list = "_wrap_delete_IntervalPriceTimeSeriesQuantLib" ;;
let _delete_IntervalPriceTimeSeries arg = match _delete_IntervalPriceTimeSeries_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntervalPriceVector_f : c_obj list -> c_obj list = "_wrap_new_IntervalPriceVector__SWIG_0QuantLib" ;;
let _new_IntervalPriceVector arg = match _new_IntervalPriceVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntervalPriceVector_f : c_obj list -> c_obj list = "_wrap_new_IntervalPriceVector__SWIG_1QuantLib" ;;
let _new_IntervalPriceVector arg = match _new_IntervalPriceVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntervalPriceVector_f : c_obj list -> c_obj list = "_wrap_new_IntervalPriceVector__SWIG_2QuantLib" ;;
let _new_IntervalPriceVector arg = match _new_IntervalPriceVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntervalPriceVector_f : c_obj list -> c_obj list = "_wrap_new_IntervalPriceVectorQuantLib" ;;
let _new_IntervalPriceVector arg = match _new_IntervalPriceVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPriceVector_size_f : c_obj list -> c_obj list = "_wrap_IntervalPriceVector_sizeQuantLib" ;;
let _IntervalPriceVector_size arg = match _IntervalPriceVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPriceVector_empty_f : c_obj list -> c_obj list = "_wrap_IntervalPriceVector_emptyQuantLib" ;;
let _IntervalPriceVector_empty arg = match _IntervalPriceVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPriceVector_clear_f : c_obj list -> c_obj list = "_wrap_IntervalPriceVector_clearQuantLib" ;;
let _IntervalPriceVector_clear arg = match _IntervalPriceVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPriceVector_push_back_f : c_obj list -> c_obj list = "_wrap_IntervalPriceVector_push_backQuantLib" ;;
let _IntervalPriceVector_push_back arg = match _IntervalPriceVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPriceVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_IntervalPriceVector_operator_bB___QuantLib" ;;
let _IntervalPriceVector_operator_xx_xx_lbrace_xx_rbrace arg = match _IntervalPriceVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPriceVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_IntervalPriceVector_operator_e___QuantLib" ;;
let _IntervalPriceVector_operator_xx_xx_equals arg = match _IntervalPriceVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPriceVector_set_f : c_obj list -> c_obj list = "_wrap_IntervalPriceVector_setQuantLib" ;;
let _IntervalPriceVector_set arg = match _IntervalPriceVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPriceVector_to_array_f : c_obj list -> c_obj list = "_wrap_IntervalPriceVector_to_arrayQuantLib" ;;
let _IntervalPriceVector_to_array arg = match _IntervalPriceVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IntervalPriceVector_f : c_obj list -> c_obj list = "_wrap_delete_IntervalPriceVectorQuantLib" ;;
let _delete_IntervalPriceVector arg = match _delete_IntervalPriceVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "IntervalPrice::Type_marker" (`Type)
external _Open : c_obj -> Swig.c_obj = "_wrap_Open" 
external _Close : c_obj -> Swig.c_obj = "_wrap_Close" 
external _High : c_obj -> Swig.c_obj = "_wrap_High" 
external _Low : c_obj -> Swig.c_obj = "_wrap_Low" 
external _new_IntervalPrice_f : c_obj list -> c_obj list = "_wrap_new_IntervalPriceQuantLib" ;;
let _new_IntervalPrice arg = match _new_IntervalPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPrice_setValue_f : c_obj list -> c_obj list = "_wrap_IntervalPrice_setValueQuantLib" ;;
let _IntervalPrice_setValue arg = match _IntervalPrice_setValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPrice_setValues_f : c_obj list -> c_obj list = "_wrap_IntervalPrice_setValuesQuantLib" ;;
let _IntervalPrice_setValues arg = match _IntervalPrice_setValues_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPrice_value_f : c_obj list -> c_obj list = "_wrap_IntervalPrice_valueQuantLib" ;;
let _IntervalPrice_value arg = match _IntervalPrice_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPrice_open_f : c_obj list -> c_obj list = "_wrap_IntervalPrice_openQuantLib" ;;
let _IntervalPrice_open arg = match _IntervalPrice_open_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPrice_close_f : c_obj list -> c_obj list = "_wrap_IntervalPrice_closeQuantLib" ;;
let _IntervalPrice_close arg = match _IntervalPrice_close_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPrice_high_f : c_obj list -> c_obj list = "_wrap_IntervalPrice_highQuantLib" ;;
let _IntervalPrice_high arg = match _IntervalPrice_high_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPrice_low_f : c_obj list -> c_obj list = "_wrap_IntervalPrice_lowQuantLib" ;;
let _IntervalPrice_low arg = match _IntervalPrice_low_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPrice_makeSeries_f : c_obj list -> c_obj list = "_wrap_IntervalPrice_makeSeriesQuantLib" ;;
let _IntervalPrice_makeSeries arg = match _IntervalPrice_makeSeries_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPrice_extractValues_f : c_obj list -> c_obj list = "_wrap_IntervalPrice_extractValuesQuantLib" ;;
let _IntervalPrice_extractValues arg = match _IntervalPrice_extractValues_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IntervalPrice_extractComponent_f : c_obj list -> c_obj list = "_wrap_IntervalPrice_extractComponentQuantLib" ;;
let _IntervalPrice_extractComponent arg = match _IntervalPrice_extractComponent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IntervalPrice_f : c_obj list -> c_obj list = "_wrap_delete_IntervalPriceQuantLib" ;;
let _delete_IntervalPrice arg = match _delete_IntervalPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IndexManager_instance_f : c_obj list -> c_obj list = "_wrap_IndexManager_instanceQuantLib" ;;
let _IndexManager_instance arg = match _IndexManager_instance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IndexManager_setHistory_f : c_obj list -> c_obj list = "_wrap_IndexManager_setHistoryQuantLib" ;;
let _IndexManager_setHistory arg = match _IndexManager_setHistory_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IndexManager_getHistory_f : c_obj list -> c_obj list = "_wrap_IndexManager_getHistoryQuantLib" ;;
let _IndexManager_getHistory arg = match _IndexManager_getHistory_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IndexManager_hasHistory_f : c_obj list -> c_obj list = "_wrap_IndexManager_hasHistoryQuantLib" ;;
let _IndexManager_hasHistory arg = match _IndexManager_hasHistory_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IndexManager_histories_f : c_obj list -> c_obj list = "_wrap_IndexManager_historiesQuantLib" ;;
let _IndexManager_histories arg = match _IndexManager_histories_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IndexManager_clearHistory_f : c_obj list -> c_obj list = "_wrap_IndexManager_clearHistoryQuantLib" ;;
let _IndexManager_clearHistory arg = match _IndexManager_clearHistory_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IndexManager_clearHistories_f : c_obj list -> c_obj list = "_wrap_IndexManager_clearHistoriesQuantLib" ;;
let _IndexManager_clearHistories arg = match _IndexManager_clearHistories_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IndexManager_f : c_obj list -> c_obj list = "_wrap_delete_IndexManagerQuantLib" ;;
let _delete_IndexManager arg = match _delete_IndexManager_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Index___deref___f : c_obj list -> c_obj list = "_wrap_Index___deref__QuantLib" ;;
let _Index___deref__ arg = match _Index___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Index_isNull_f : c_obj list -> c_obj list = "_wrap_Index_isNullQuantLib" ;;
let _Index_isNull arg = match _Index_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Index_addFixings_f : c_obj list -> c_obj list = "_wrap_Index_addFixingsQuantLib" ;;
let _Index_addFixings arg = match _Index_addFixings_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Index___str___f : c_obj list -> c_obj list = "_wrap_Index___str__QuantLib" ;;
let _Index___str__ arg = match _Index___str___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Index_asObservable_f : c_obj list -> c_obj list = "_wrap_Index_asObservableQuantLib" ;;
let _Index_asObservable arg = match _Index_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Index_f : c_obj list -> c_obj list = "_wrap_new_IndexQuantLib" ;;
let _new_Index arg = match _new_Index_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Index_f : c_obj list -> c_obj list = "_wrap_delete_IndexQuantLib" ;;
let _delete_Index arg = match _delete_Index_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Index_name_f : c_obj list -> c_obj list = "_wrap_Index_nameQuantLib" ;;
let _Index_name arg = match _Index_name_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Index_fixingCalendar_f : c_obj list -> c_obj list = "_wrap_Index_fixingCalendarQuantLib" ;;
let _Index_fixingCalendar arg = match _Index_fixingCalendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Index_isValidFixingDate_f : c_obj list -> c_obj list = "_wrap_Index_isValidFixingDateQuantLib" ;;
let _Index_isValidFixingDate arg = match _Index_isValidFixingDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Index_fixing_f : c_obj list -> c_obj list = "_wrap_Index_fixing__SWIG_0QuantLib" ;;
let _Index_fixing arg = match _Index_fixing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Index_fixing_f : c_obj list -> c_obj list = "_wrap_Index_fixingQuantLib" ;;
let _Index_fixing arg = match _Index_fixing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Index_addFixing_f : c_obj list -> c_obj list = "_wrap_Index_addFixingQuantLib" ;;
let _Index_addFixing arg = match _Index_addFixing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateIndex_familyName_f : c_obj list -> c_obj list = "_wrap_InterestRateIndex_familyNameQuantLib" ;;
let _InterestRateIndex_familyName arg = match _InterestRateIndex_familyName_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateIndex_tenor_f : c_obj list -> c_obj list = "_wrap_InterestRateIndex_tenorQuantLib" ;;
let _InterestRateIndex_tenor arg = match _InterestRateIndex_tenor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateIndex_fixingDays_f : c_obj list -> c_obj list = "_wrap_InterestRateIndex_fixingDaysQuantLib" ;;
let _InterestRateIndex_fixingDays arg = match _InterestRateIndex_fixingDays_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateIndex_fixingDate_f : c_obj list -> c_obj list = "_wrap_InterestRateIndex_fixingDateQuantLib" ;;
let _InterestRateIndex_fixingDate arg = match _InterestRateIndex_fixingDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateIndex_currency_f : c_obj list -> c_obj list = "_wrap_InterestRateIndex_currencyQuantLib" ;;
let _InterestRateIndex_currency arg = match _InterestRateIndex_currency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateIndex_dayCounter_f : c_obj list -> c_obj list = "_wrap_InterestRateIndex_dayCounterQuantLib" ;;
let _InterestRateIndex_dayCounter arg = match _InterestRateIndex_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateIndex_maturityDate_f : c_obj list -> c_obj list = "_wrap_InterestRateIndex_maturityDateQuantLib" ;;
let _InterestRateIndex_maturityDate arg = match _InterestRateIndex_maturityDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InterestRateIndex_valueDate_f : c_obj list -> c_obj list = "_wrap_InterestRateIndex_valueDateQuantLib" ;;
let _InterestRateIndex_valueDate arg = match _InterestRateIndex_valueDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InterestRateIndex_f : c_obj list -> c_obj list = "_wrap_delete_InterestRateIndexQuantLib" ;;
let _delete_InterestRateIndex arg = match _delete_InterestRateIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IborIndex_f : c_obj list -> c_obj list = "_wrap_new_IborIndex__SWIG_0QuantLib" ;;
let _new_IborIndex arg = match _new_IborIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IborIndex_f : c_obj list -> c_obj list = "_wrap_new_IborIndexQuantLib" ;;
let _new_IborIndex arg = match _new_IborIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborIndex_businessDayConvention_f : c_obj list -> c_obj list = "_wrap_IborIndex_businessDayConventionQuantLib" ;;
let _IborIndex_businessDayConvention arg = match _IborIndex_businessDayConvention_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborIndex_endOfMonth_f : c_obj list -> c_obj list = "_wrap_IborIndex_endOfMonthQuantLib" ;;
let _IborIndex_endOfMonth arg = match _IborIndex_endOfMonth_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborIndex_forwardingTermStructure_f : c_obj list -> c_obj list = "_wrap_IborIndex_forwardingTermStructureQuantLib" ;;
let _IborIndex_forwardingTermStructure arg = match _IborIndex_forwardingTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborIndex_clone_f : c_obj list -> c_obj list = "_wrap_IborIndex_cloneQuantLib" ;;
let _IborIndex_clone arg = match _IborIndex_clone_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IborIndex_f : c_obj list -> c_obj list = "_wrap_delete_IborIndexQuantLib" ;;
let _delete_IborIndex arg = match _delete_IborIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _as_iborindex_f : c_obj list -> c_obj list = "_wrap_as_iborindexQuantLib" ;;
let _as_iborindex arg = match _as_iborindex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OvernightIndex_f : c_obj list -> c_obj list = "_wrap_new_OvernightIndex__SWIG_0QuantLib" ;;
let _new_OvernightIndex arg = match _new_OvernightIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OvernightIndex_f : c_obj list -> c_obj list = "_wrap_new_OvernightIndexQuantLib" ;;
let _new_OvernightIndex arg = match _new_OvernightIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_OvernightIndex_f : c_obj list -> c_obj list = "_wrap_delete_OvernightIndexQuantLib" ;;
let _delete_OvernightIndex arg = match _delete_OvernightIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Libor_f : c_obj list -> c_obj list = "_wrap_new_Libor__SWIG_0QuantLib" ;;
let _new_Libor arg = match _new_Libor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Libor_f : c_obj list -> c_obj list = "_wrap_new_LiborQuantLib" ;;
let _new_Libor arg = match _new_Libor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Libor_f : c_obj list -> c_obj list = "_wrap_delete_LiborQuantLib" ;;
let _delete_Libor arg = match _delete_Libor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapIndex_f : c_obj list -> c_obj list = "_wrap_new_SwapIndex__SWIG_0QuantLib" ;;
let _new_SwapIndex arg = match _new_SwapIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapIndex_f : c_obj list -> c_obj list = "_wrap_new_SwapIndexQuantLib" ;;
let _new_SwapIndex arg = match _new_SwapIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwapIndex_fixedLegTenor_f : c_obj list -> c_obj list = "_wrap_SwapIndex_fixedLegTenorQuantLib" ;;
let _SwapIndex_fixedLegTenor arg = match _SwapIndex_fixedLegTenor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwapIndex_fixedLegConvention_f : c_obj list -> c_obj list = "_wrap_SwapIndex_fixedLegConventionQuantLib" ;;
let _SwapIndex_fixedLegConvention arg = match _SwapIndex_fixedLegConvention_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwapIndex_iborIndex_f : c_obj list -> c_obj list = "_wrap_SwapIndex_iborIndexQuantLib" ;;
let _SwapIndex_iborIndex arg = match _SwapIndex_iborIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwapIndex_forwardingTermStructure_f : c_obj list -> c_obj list = "_wrap_SwapIndex_forwardingTermStructureQuantLib" ;;
let _SwapIndex_forwardingTermStructure arg = match _SwapIndex_forwardingTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SwapIndex_f : c_obj list -> c_obj list = "_wrap_delete_SwapIndexQuantLib" ;;
let _delete_SwapIndex arg = match _delete_SwapIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AUDLibor_f : c_obj list -> c_obj list = "_wrap_new_AUDLibor__SWIG_0QuantLib" ;;
let _new_AUDLibor arg = match _new_AUDLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AUDLibor_f : c_obj list -> c_obj list = "_wrap_new_AUDLiborQuantLib" ;;
let _new_AUDLibor arg = match _new_AUDLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AUDLibor_f : c_obj list -> c_obj list = "_wrap_delete_AUDLiborQuantLib" ;;
let _delete_AUDLibor arg = match _delete_AUDLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CADLibor_f : c_obj list -> c_obj list = "_wrap_new_CADLibor__SWIG_0QuantLib" ;;
let _new_CADLibor arg = match _new_CADLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CADLibor_f : c_obj list -> c_obj list = "_wrap_new_CADLiborQuantLib" ;;
let _new_CADLibor arg = match _new_CADLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CADLibor_f : c_obj list -> c_obj list = "_wrap_delete_CADLiborQuantLib" ;;
let _delete_CADLibor arg = match _delete_CADLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Cdor_f : c_obj list -> c_obj list = "_wrap_new_Cdor__SWIG_0QuantLib" ;;
let _new_Cdor arg = match _new_Cdor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Cdor_f : c_obj list -> c_obj list = "_wrap_new_CdorQuantLib" ;;
let _new_Cdor arg = match _new_Cdor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Cdor_f : c_obj list -> c_obj list = "_wrap_delete_CdorQuantLib" ;;
let _delete_Cdor arg = match _delete_Cdor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CHFLibor_f : c_obj list -> c_obj list = "_wrap_new_CHFLibor__SWIG_0QuantLib" ;;
let _new_CHFLibor arg = match _new_CHFLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CHFLibor_f : c_obj list -> c_obj list = "_wrap_new_CHFLiborQuantLib" ;;
let _new_CHFLibor arg = match _new_CHFLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CHFLibor_f : c_obj list -> c_obj list = "_wrap_delete_CHFLiborQuantLib" ;;
let _delete_CHFLibor arg = match _delete_CHFLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DKKLibor_f : c_obj list -> c_obj list = "_wrap_new_DKKLibor__SWIG_0QuantLib" ;;
let _new_DKKLibor arg = match _new_DKKLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DKKLibor_f : c_obj list -> c_obj list = "_wrap_new_DKKLiborQuantLib" ;;
let _new_DKKLibor arg = match _new_DKKLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DKKLibor_f : c_obj list -> c_obj list = "_wrap_delete_DKKLiborQuantLib" ;;
let _delete_DKKLibor arg = match _delete_DKKLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw_f : c_obj list -> c_obj list = "_wrap_new_Bbsw__SWIG_0QuantLib" ;;
let _new_Bbsw arg = match _new_Bbsw_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw_f : c_obj list -> c_obj list = "_wrap_new_BbswQuantLib" ;;
let _new_Bbsw arg = match _new_Bbsw_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bbsw_f : c_obj list -> c_obj list = "_wrap_delete_BbswQuantLib" ;;
let _delete_Bbsw arg = match _delete_Bbsw_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw1M_f : c_obj list -> c_obj list = "_wrap_new_Bbsw1M__SWIG_0QuantLib" ;;
let _new_Bbsw1M arg = match _new_Bbsw1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw1M_f : c_obj list -> c_obj list = "_wrap_new_Bbsw1MQuantLib" ;;
let _new_Bbsw1M arg = match _new_Bbsw1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bbsw1M_f : c_obj list -> c_obj list = "_wrap_delete_Bbsw1MQuantLib" ;;
let _delete_Bbsw1M arg = match _delete_Bbsw1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw2M_f : c_obj list -> c_obj list = "_wrap_new_Bbsw2M__SWIG_0QuantLib" ;;
let _new_Bbsw2M arg = match _new_Bbsw2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw2M_f : c_obj list -> c_obj list = "_wrap_new_Bbsw2MQuantLib" ;;
let _new_Bbsw2M arg = match _new_Bbsw2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bbsw2M_f : c_obj list -> c_obj list = "_wrap_delete_Bbsw2MQuantLib" ;;
let _delete_Bbsw2M arg = match _delete_Bbsw2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw3M_f : c_obj list -> c_obj list = "_wrap_new_Bbsw3M__SWIG_0QuantLib" ;;
let _new_Bbsw3M arg = match _new_Bbsw3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw3M_f : c_obj list -> c_obj list = "_wrap_new_Bbsw3MQuantLib" ;;
let _new_Bbsw3M arg = match _new_Bbsw3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bbsw3M_f : c_obj list -> c_obj list = "_wrap_delete_Bbsw3MQuantLib" ;;
let _delete_Bbsw3M arg = match _delete_Bbsw3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw4M_f : c_obj list -> c_obj list = "_wrap_new_Bbsw4M__SWIG_0QuantLib" ;;
let _new_Bbsw4M arg = match _new_Bbsw4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw4M_f : c_obj list -> c_obj list = "_wrap_new_Bbsw4MQuantLib" ;;
let _new_Bbsw4M arg = match _new_Bbsw4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bbsw4M_f : c_obj list -> c_obj list = "_wrap_delete_Bbsw4MQuantLib" ;;
let _delete_Bbsw4M arg = match _delete_Bbsw4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw5M_f : c_obj list -> c_obj list = "_wrap_new_Bbsw5M__SWIG_0QuantLib" ;;
let _new_Bbsw5M arg = match _new_Bbsw5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw5M_f : c_obj list -> c_obj list = "_wrap_new_Bbsw5MQuantLib" ;;
let _new_Bbsw5M arg = match _new_Bbsw5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bbsw5M_f : c_obj list -> c_obj list = "_wrap_delete_Bbsw5MQuantLib" ;;
let _delete_Bbsw5M arg = match _delete_Bbsw5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw6M_f : c_obj list -> c_obj list = "_wrap_new_Bbsw6M__SWIG_0QuantLib" ;;
let _new_Bbsw6M arg = match _new_Bbsw6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bbsw6M_f : c_obj list -> c_obj list = "_wrap_new_Bbsw6MQuantLib" ;;
let _new_Bbsw6M arg = match _new_Bbsw6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bbsw6M_f : c_obj list -> c_obj list = "_wrap_delete_Bbsw6MQuantLib" ;;
let _delete_Bbsw6M arg = match _delete_Bbsw6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm_f : c_obj list -> c_obj list = "_wrap_new_Bkbm__SWIG_0QuantLib" ;;
let _new_Bkbm arg = match _new_Bkbm_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm_f : c_obj list -> c_obj list = "_wrap_new_BkbmQuantLib" ;;
let _new_Bkbm arg = match _new_Bkbm_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bkbm_f : c_obj list -> c_obj list = "_wrap_delete_BkbmQuantLib" ;;
let _delete_Bkbm arg = match _delete_Bkbm_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm1M_f : c_obj list -> c_obj list = "_wrap_new_Bkbm1M__SWIG_0QuantLib" ;;
let _new_Bkbm1M arg = match _new_Bkbm1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm1M_f : c_obj list -> c_obj list = "_wrap_new_Bkbm1MQuantLib" ;;
let _new_Bkbm1M arg = match _new_Bkbm1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bkbm1M_f : c_obj list -> c_obj list = "_wrap_delete_Bkbm1MQuantLib" ;;
let _delete_Bkbm1M arg = match _delete_Bkbm1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm2M_f : c_obj list -> c_obj list = "_wrap_new_Bkbm2M__SWIG_0QuantLib" ;;
let _new_Bkbm2M arg = match _new_Bkbm2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm2M_f : c_obj list -> c_obj list = "_wrap_new_Bkbm2MQuantLib" ;;
let _new_Bkbm2M arg = match _new_Bkbm2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bkbm2M_f : c_obj list -> c_obj list = "_wrap_delete_Bkbm2MQuantLib" ;;
let _delete_Bkbm2M arg = match _delete_Bkbm2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm3M_f : c_obj list -> c_obj list = "_wrap_new_Bkbm3M__SWIG_0QuantLib" ;;
let _new_Bkbm3M arg = match _new_Bkbm3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm3M_f : c_obj list -> c_obj list = "_wrap_new_Bkbm3MQuantLib" ;;
let _new_Bkbm3M arg = match _new_Bkbm3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bkbm3M_f : c_obj list -> c_obj list = "_wrap_delete_Bkbm3MQuantLib" ;;
let _delete_Bkbm3M arg = match _delete_Bkbm3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm4M_f : c_obj list -> c_obj list = "_wrap_new_Bkbm4M__SWIG_0QuantLib" ;;
let _new_Bkbm4M arg = match _new_Bkbm4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm4M_f : c_obj list -> c_obj list = "_wrap_new_Bkbm4MQuantLib" ;;
let _new_Bkbm4M arg = match _new_Bkbm4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bkbm4M_f : c_obj list -> c_obj list = "_wrap_delete_Bkbm4MQuantLib" ;;
let _delete_Bkbm4M arg = match _delete_Bkbm4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm5M_f : c_obj list -> c_obj list = "_wrap_new_Bkbm5M__SWIG_0QuantLib" ;;
let _new_Bkbm5M arg = match _new_Bkbm5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm5M_f : c_obj list -> c_obj list = "_wrap_new_Bkbm5MQuantLib" ;;
let _new_Bkbm5M arg = match _new_Bkbm5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bkbm5M_f : c_obj list -> c_obj list = "_wrap_delete_Bkbm5MQuantLib" ;;
let _delete_Bkbm5M arg = match _delete_Bkbm5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm6M_f : c_obj list -> c_obj list = "_wrap_new_Bkbm6M__SWIG_0QuantLib" ;;
let _new_Bkbm6M arg = match _new_Bkbm6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bkbm6M_f : c_obj list -> c_obj list = "_wrap_new_Bkbm6MQuantLib" ;;
let _new_Bkbm6M arg = match _new_Bkbm6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bkbm6M_f : c_obj list -> c_obj list = "_wrap_delete_Bkbm6MQuantLib" ;;
let _delete_Bkbm6M arg = match _delete_Bkbm6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor_f : c_obj list -> c_obj list = "_wrap_new_Euribor__SWIG_0QuantLib" ;;
let _new_Euribor arg = match _new_Euribor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor_f : c_obj list -> c_obj list = "_wrap_new_EuriborQuantLib" ;;
let _new_Euribor arg = match _new_Euribor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor_f : c_obj list -> c_obj list = "_wrap_delete_EuriborQuantLib" ;;
let _delete_Euribor arg = match _delete_Euribor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuriborSW_f : c_obj list -> c_obj list = "_wrap_new_EuriborSW__SWIG_0QuantLib" ;;
let _new_EuriborSW arg = match _new_EuriborSW_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuriborSW_f : c_obj list -> c_obj list = "_wrap_new_EuriborSWQuantLib" ;;
let _new_EuriborSW arg = match _new_EuriborSW_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EuriborSW_f : c_obj list -> c_obj list = "_wrap_delete_EuriborSWQuantLib" ;;
let _delete_EuriborSW arg = match _delete_EuriborSW_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor2W_f : c_obj list -> c_obj list = "_wrap_new_Euribor2W__SWIG_0QuantLib" ;;
let _new_Euribor2W arg = match _new_Euribor2W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor2W_f : c_obj list -> c_obj list = "_wrap_new_Euribor2WQuantLib" ;;
let _new_Euribor2W arg = match _new_Euribor2W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor2W_f : c_obj list -> c_obj list = "_wrap_delete_Euribor2WQuantLib" ;;
let _delete_Euribor2W arg = match _delete_Euribor2W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor3W_f : c_obj list -> c_obj list = "_wrap_new_Euribor3W__SWIG_0QuantLib" ;;
let _new_Euribor3W arg = match _new_Euribor3W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor3W_f : c_obj list -> c_obj list = "_wrap_new_Euribor3WQuantLib" ;;
let _new_Euribor3W arg = match _new_Euribor3W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor3W_f : c_obj list -> c_obj list = "_wrap_delete_Euribor3WQuantLib" ;;
let _delete_Euribor3W arg = match _delete_Euribor3W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor1M_f : c_obj list -> c_obj list = "_wrap_new_Euribor1M__SWIG_0QuantLib" ;;
let _new_Euribor1M arg = match _new_Euribor1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor1M_f : c_obj list -> c_obj list = "_wrap_new_Euribor1MQuantLib" ;;
let _new_Euribor1M arg = match _new_Euribor1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor1M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor1MQuantLib" ;;
let _delete_Euribor1M arg = match _delete_Euribor1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor2M_f : c_obj list -> c_obj list = "_wrap_new_Euribor2M__SWIG_0QuantLib" ;;
let _new_Euribor2M arg = match _new_Euribor2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor2M_f : c_obj list -> c_obj list = "_wrap_new_Euribor2MQuantLib" ;;
let _new_Euribor2M arg = match _new_Euribor2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor2M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor2MQuantLib" ;;
let _delete_Euribor2M arg = match _delete_Euribor2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor3M_f : c_obj list -> c_obj list = "_wrap_new_Euribor3M__SWIG_0QuantLib" ;;
let _new_Euribor3M arg = match _new_Euribor3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor3M_f : c_obj list -> c_obj list = "_wrap_new_Euribor3MQuantLib" ;;
let _new_Euribor3M arg = match _new_Euribor3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor3M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor3MQuantLib" ;;
let _delete_Euribor3M arg = match _delete_Euribor3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor4M_f : c_obj list -> c_obj list = "_wrap_new_Euribor4M__SWIG_0QuantLib" ;;
let _new_Euribor4M arg = match _new_Euribor4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor4M_f : c_obj list -> c_obj list = "_wrap_new_Euribor4MQuantLib" ;;
let _new_Euribor4M arg = match _new_Euribor4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor4M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor4MQuantLib" ;;
let _delete_Euribor4M arg = match _delete_Euribor4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor5M_f : c_obj list -> c_obj list = "_wrap_new_Euribor5M__SWIG_0QuantLib" ;;
let _new_Euribor5M arg = match _new_Euribor5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor5M_f : c_obj list -> c_obj list = "_wrap_new_Euribor5MQuantLib" ;;
let _new_Euribor5M arg = match _new_Euribor5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor5M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor5MQuantLib" ;;
let _delete_Euribor5M arg = match _delete_Euribor5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor6M_f : c_obj list -> c_obj list = "_wrap_new_Euribor6M__SWIG_0QuantLib" ;;
let _new_Euribor6M arg = match _new_Euribor6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor6M_f : c_obj list -> c_obj list = "_wrap_new_Euribor6MQuantLib" ;;
let _new_Euribor6M arg = match _new_Euribor6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor6M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor6MQuantLib" ;;
let _delete_Euribor6M arg = match _delete_Euribor6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor7M_f : c_obj list -> c_obj list = "_wrap_new_Euribor7M__SWIG_0QuantLib" ;;
let _new_Euribor7M arg = match _new_Euribor7M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor7M_f : c_obj list -> c_obj list = "_wrap_new_Euribor7MQuantLib" ;;
let _new_Euribor7M arg = match _new_Euribor7M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor7M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor7MQuantLib" ;;
let _delete_Euribor7M arg = match _delete_Euribor7M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor8M_f : c_obj list -> c_obj list = "_wrap_new_Euribor8M__SWIG_0QuantLib" ;;
let _new_Euribor8M arg = match _new_Euribor8M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor8M_f : c_obj list -> c_obj list = "_wrap_new_Euribor8MQuantLib" ;;
let _new_Euribor8M arg = match _new_Euribor8M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor8M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor8MQuantLib" ;;
let _delete_Euribor8M arg = match _delete_Euribor8M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor9M_f : c_obj list -> c_obj list = "_wrap_new_Euribor9M__SWIG_0QuantLib" ;;
let _new_Euribor9M arg = match _new_Euribor9M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor9M_f : c_obj list -> c_obj list = "_wrap_new_Euribor9MQuantLib" ;;
let _new_Euribor9M arg = match _new_Euribor9M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor9M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor9MQuantLib" ;;
let _delete_Euribor9M arg = match _delete_Euribor9M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor10M_f : c_obj list -> c_obj list = "_wrap_new_Euribor10M__SWIG_0QuantLib" ;;
let _new_Euribor10M arg = match _new_Euribor10M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor10M_f : c_obj list -> c_obj list = "_wrap_new_Euribor10MQuantLib" ;;
let _new_Euribor10M arg = match _new_Euribor10M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor10M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor10MQuantLib" ;;
let _delete_Euribor10M arg = match _delete_Euribor10M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor11M_f : c_obj list -> c_obj list = "_wrap_new_Euribor11M__SWIG_0QuantLib" ;;
let _new_Euribor11M arg = match _new_Euribor11M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor11M_f : c_obj list -> c_obj list = "_wrap_new_Euribor11MQuantLib" ;;
let _new_Euribor11M arg = match _new_Euribor11M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor11M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor11MQuantLib" ;;
let _delete_Euribor11M arg = match _delete_Euribor11M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor1Y_f : c_obj list -> c_obj list = "_wrap_new_Euribor1Y__SWIG_0QuantLib" ;;
let _new_Euribor1Y arg = match _new_Euribor1Y_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor1Y_f : c_obj list -> c_obj list = "_wrap_new_Euribor1YQuantLib" ;;
let _new_Euribor1Y arg = match _new_Euribor1Y_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor1Y_f : c_obj list -> c_obj list = "_wrap_delete_Euribor1YQuantLib" ;;
let _delete_Euribor1Y arg = match _delete_Euribor1Y_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_f : c_obj list -> c_obj list = "_wrap_new_Euribor365__SWIG_0QuantLib" ;;
let _new_Euribor365 arg = match _new_Euribor365_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_f : c_obj list -> c_obj list = "_wrap_new_Euribor365QuantLib" ;;
let _new_Euribor365 arg = match _new_Euribor365_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365QuantLib" ;;
let _delete_Euribor365 arg = match _delete_Euribor365_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_SW_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_SW__SWIG_0QuantLib" ;;
let _new_Euribor365_SW arg = match _new_Euribor365_SW_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_SW_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_SWQuantLib" ;;
let _new_Euribor365_SW arg = match _new_Euribor365_SW_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_SW_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_SWQuantLib" ;;
let _delete_Euribor365_SW arg = match _delete_Euribor365_SW_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_2W_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_2W__SWIG_0QuantLib" ;;
let _new_Euribor365_2W arg = match _new_Euribor365_2W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_2W_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_2WQuantLib" ;;
let _new_Euribor365_2W arg = match _new_Euribor365_2W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_2W_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_2WQuantLib" ;;
let _delete_Euribor365_2W arg = match _delete_Euribor365_2W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_3W_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_3W__SWIG_0QuantLib" ;;
let _new_Euribor365_3W arg = match _new_Euribor365_3W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_3W_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_3WQuantLib" ;;
let _new_Euribor365_3W arg = match _new_Euribor365_3W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_3W_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_3WQuantLib" ;;
let _delete_Euribor365_3W arg = match _delete_Euribor365_3W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_1M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_1M__SWIG_0QuantLib" ;;
let _new_Euribor365_1M arg = match _new_Euribor365_1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_1M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_1MQuantLib" ;;
let _new_Euribor365_1M arg = match _new_Euribor365_1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_1M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_1MQuantLib" ;;
let _delete_Euribor365_1M arg = match _delete_Euribor365_1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_2M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_2M__SWIG_0QuantLib" ;;
let _new_Euribor365_2M arg = match _new_Euribor365_2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_2M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_2MQuantLib" ;;
let _new_Euribor365_2M arg = match _new_Euribor365_2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_2M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_2MQuantLib" ;;
let _delete_Euribor365_2M arg = match _delete_Euribor365_2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_3M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_3M__SWIG_0QuantLib" ;;
let _new_Euribor365_3M arg = match _new_Euribor365_3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_3M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_3MQuantLib" ;;
let _new_Euribor365_3M arg = match _new_Euribor365_3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_3M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_3MQuantLib" ;;
let _delete_Euribor365_3M arg = match _delete_Euribor365_3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_4M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_4M__SWIG_0QuantLib" ;;
let _new_Euribor365_4M arg = match _new_Euribor365_4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_4M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_4MQuantLib" ;;
let _new_Euribor365_4M arg = match _new_Euribor365_4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_4M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_4MQuantLib" ;;
let _delete_Euribor365_4M arg = match _delete_Euribor365_4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_5M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_5M__SWIG_0QuantLib" ;;
let _new_Euribor365_5M arg = match _new_Euribor365_5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_5M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_5MQuantLib" ;;
let _new_Euribor365_5M arg = match _new_Euribor365_5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_5M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_5MQuantLib" ;;
let _delete_Euribor365_5M arg = match _delete_Euribor365_5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_6M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_6M__SWIG_0QuantLib" ;;
let _new_Euribor365_6M arg = match _new_Euribor365_6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_6M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_6MQuantLib" ;;
let _new_Euribor365_6M arg = match _new_Euribor365_6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_6M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_6MQuantLib" ;;
let _delete_Euribor365_6M arg = match _delete_Euribor365_6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_7M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_7M__SWIG_0QuantLib" ;;
let _new_Euribor365_7M arg = match _new_Euribor365_7M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_7M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_7MQuantLib" ;;
let _new_Euribor365_7M arg = match _new_Euribor365_7M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_7M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_7MQuantLib" ;;
let _delete_Euribor365_7M arg = match _delete_Euribor365_7M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_8M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_8M__SWIG_0QuantLib" ;;
let _new_Euribor365_8M arg = match _new_Euribor365_8M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_8M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_8MQuantLib" ;;
let _new_Euribor365_8M arg = match _new_Euribor365_8M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_8M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_8MQuantLib" ;;
let _delete_Euribor365_8M arg = match _delete_Euribor365_8M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_9M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_9M__SWIG_0QuantLib" ;;
let _new_Euribor365_9M arg = match _new_Euribor365_9M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_9M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_9MQuantLib" ;;
let _new_Euribor365_9M arg = match _new_Euribor365_9M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_9M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_9MQuantLib" ;;
let _delete_Euribor365_9M arg = match _delete_Euribor365_9M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_10M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_10M__SWIG_0QuantLib" ;;
let _new_Euribor365_10M arg = match _new_Euribor365_10M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_10M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_10MQuantLib" ;;
let _new_Euribor365_10M arg = match _new_Euribor365_10M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_10M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_10MQuantLib" ;;
let _delete_Euribor365_10M arg = match _delete_Euribor365_10M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_11M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_11M__SWIG_0QuantLib" ;;
let _new_Euribor365_11M arg = match _new_Euribor365_11M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_11M_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_11MQuantLib" ;;
let _new_Euribor365_11M arg = match _new_Euribor365_11M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_11M_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_11MQuantLib" ;;
let _delete_Euribor365_11M arg = match _delete_Euribor365_11M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_1Y_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_1Y__SWIG_0QuantLib" ;;
let _new_Euribor365_1Y arg = match _new_Euribor365_1Y_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Euribor365_1Y_f : c_obj list -> c_obj list = "_wrap_new_Euribor365_1YQuantLib" ;;
let _new_Euribor365_1Y arg = match _new_Euribor365_1Y_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Euribor365_1Y_f : c_obj list -> c_obj list = "_wrap_delete_Euribor365_1YQuantLib" ;;
let _delete_Euribor365_1Y arg = match _delete_Euribor365_1Y_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor_f : c_obj list -> c_obj list = "_wrap_new_EURLibor__SWIG_0QuantLib" ;;
let _new_EURLibor arg = match _new_EURLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor_f : c_obj list -> c_obj list = "_wrap_new_EURLiborQuantLib" ;;
let _new_EURLibor arg = match _new_EURLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor_f : c_obj list -> c_obj list = "_wrap_delete_EURLiborQuantLib" ;;
let _delete_EURLibor arg = match _delete_EURLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLiborSW_f : c_obj list -> c_obj list = "_wrap_new_EURLiborSW__SWIG_0QuantLib" ;;
let _new_EURLiborSW arg = match _new_EURLiborSW_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLiborSW_f : c_obj list -> c_obj list = "_wrap_new_EURLiborSWQuantLib" ;;
let _new_EURLiborSW arg = match _new_EURLiborSW_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLiborSW_f : c_obj list -> c_obj list = "_wrap_delete_EURLiborSWQuantLib" ;;
let _delete_EURLiborSW arg = match _delete_EURLiborSW_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor2W_f : c_obj list -> c_obj list = "_wrap_new_EURLibor2W__SWIG_0QuantLib" ;;
let _new_EURLibor2W arg = match _new_EURLibor2W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor2W_f : c_obj list -> c_obj list = "_wrap_new_EURLibor2WQuantLib" ;;
let _new_EURLibor2W arg = match _new_EURLibor2W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor2W_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor2WQuantLib" ;;
let _delete_EURLibor2W arg = match _delete_EURLibor2W_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor1M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor1M__SWIG_0QuantLib" ;;
let _new_EURLibor1M arg = match _new_EURLibor1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor1M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor1MQuantLib" ;;
let _new_EURLibor1M arg = match _new_EURLibor1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor1M_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor1MQuantLib" ;;
let _delete_EURLibor1M arg = match _delete_EURLibor1M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor2M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor2M__SWIG_0QuantLib" ;;
let _new_EURLibor2M arg = match _new_EURLibor2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor2M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor2MQuantLib" ;;
let _new_EURLibor2M arg = match _new_EURLibor2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor2M_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor2MQuantLib" ;;
let _delete_EURLibor2M arg = match _delete_EURLibor2M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor3M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor3M__SWIG_0QuantLib" ;;
let _new_EURLibor3M arg = match _new_EURLibor3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor3M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor3MQuantLib" ;;
let _new_EURLibor3M arg = match _new_EURLibor3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor3M_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor3MQuantLib" ;;
let _delete_EURLibor3M arg = match _delete_EURLibor3M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor4M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor4M__SWIG_0QuantLib" ;;
let _new_EURLibor4M arg = match _new_EURLibor4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor4M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor4MQuantLib" ;;
let _new_EURLibor4M arg = match _new_EURLibor4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor4M_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor4MQuantLib" ;;
let _delete_EURLibor4M arg = match _delete_EURLibor4M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor5M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor5M__SWIG_0QuantLib" ;;
let _new_EURLibor5M arg = match _new_EURLibor5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor5M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor5MQuantLib" ;;
let _new_EURLibor5M arg = match _new_EURLibor5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor5M_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor5MQuantLib" ;;
let _delete_EURLibor5M arg = match _delete_EURLibor5M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor6M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor6M__SWIG_0QuantLib" ;;
let _new_EURLibor6M arg = match _new_EURLibor6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor6M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor6MQuantLib" ;;
let _new_EURLibor6M arg = match _new_EURLibor6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor6M_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor6MQuantLib" ;;
let _delete_EURLibor6M arg = match _delete_EURLibor6M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor7M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor7M__SWIG_0QuantLib" ;;
let _new_EURLibor7M arg = match _new_EURLibor7M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor7M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor7MQuantLib" ;;
let _new_EURLibor7M arg = match _new_EURLibor7M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor7M_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor7MQuantLib" ;;
let _delete_EURLibor7M arg = match _delete_EURLibor7M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor8M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor8M__SWIG_0QuantLib" ;;
let _new_EURLibor8M arg = match _new_EURLibor8M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor8M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor8MQuantLib" ;;
let _new_EURLibor8M arg = match _new_EURLibor8M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor8M_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor8MQuantLib" ;;
let _delete_EURLibor8M arg = match _delete_EURLibor8M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor9M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor9M__SWIG_0QuantLib" ;;
let _new_EURLibor9M arg = match _new_EURLibor9M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor9M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor9MQuantLib" ;;
let _new_EURLibor9M arg = match _new_EURLibor9M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor9M_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor9MQuantLib" ;;
let _delete_EURLibor9M arg = match _delete_EURLibor9M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor10M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor10M__SWIG_0QuantLib" ;;
let _new_EURLibor10M arg = match _new_EURLibor10M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor10M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor10MQuantLib" ;;
let _new_EURLibor10M arg = match _new_EURLibor10M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor10M_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor10MQuantLib" ;;
let _delete_EURLibor10M arg = match _delete_EURLibor10M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor11M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor11M__SWIG_0QuantLib" ;;
let _new_EURLibor11M arg = match _new_EURLibor11M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor11M_f : c_obj list -> c_obj list = "_wrap_new_EURLibor11MQuantLib" ;;
let _new_EURLibor11M arg = match _new_EURLibor11M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor11M_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor11MQuantLib" ;;
let _delete_EURLibor11M arg = match _delete_EURLibor11M_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor1Y_f : c_obj list -> c_obj list = "_wrap_new_EURLibor1Y__SWIG_0QuantLib" ;;
let _new_EURLibor1Y arg = match _new_EURLibor1Y_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EURLibor1Y_f : c_obj list -> c_obj list = "_wrap_new_EURLibor1YQuantLib" ;;
let _new_EURLibor1Y arg = match _new_EURLibor1Y_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EURLibor1Y_f : c_obj list -> c_obj list = "_wrap_delete_EURLibor1YQuantLib" ;;
let _delete_EURLibor1Y arg = match _delete_EURLibor1Y_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GBPLibor_f : c_obj list -> c_obj list = "_wrap_new_GBPLibor__SWIG_0QuantLib" ;;
let _new_GBPLibor arg = match _new_GBPLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GBPLibor_f : c_obj list -> c_obj list = "_wrap_new_GBPLiborQuantLib" ;;
let _new_GBPLibor arg = match _new_GBPLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GBPLibor_f : c_obj list -> c_obj list = "_wrap_delete_GBPLiborQuantLib" ;;
let _delete_GBPLibor arg = match _delete_GBPLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Jibar_f : c_obj list -> c_obj list = "_wrap_new_Jibar__SWIG_0QuantLib" ;;
let _new_Jibar arg = match _new_Jibar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Jibar_f : c_obj list -> c_obj list = "_wrap_new_JibarQuantLib" ;;
let _new_Jibar arg = match _new_Jibar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Jibar_f : c_obj list -> c_obj list = "_wrap_delete_JibarQuantLib" ;;
let _delete_Jibar arg = match _delete_Jibar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_JPYLibor_f : c_obj list -> c_obj list = "_wrap_new_JPYLibor__SWIG_0QuantLib" ;;
let _new_JPYLibor arg = match _new_JPYLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_JPYLibor_f : c_obj list -> c_obj list = "_wrap_new_JPYLiborQuantLib" ;;
let _new_JPYLibor arg = match _new_JPYLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_JPYLibor_f : c_obj list -> c_obj list = "_wrap_delete_JPYLiborQuantLib" ;;
let _delete_JPYLibor arg = match _delete_JPYLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NZDLibor_f : c_obj list -> c_obj list = "_wrap_new_NZDLibor__SWIG_0QuantLib" ;;
let _new_NZDLibor arg = match _new_NZDLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NZDLibor_f : c_obj list -> c_obj list = "_wrap_new_NZDLiborQuantLib" ;;
let _new_NZDLibor arg = match _new_NZDLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NZDLibor_f : c_obj list -> c_obj list = "_wrap_delete_NZDLiborQuantLib" ;;
let _delete_NZDLibor arg = match _delete_NZDLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SEKLibor_f : c_obj list -> c_obj list = "_wrap_new_SEKLibor__SWIG_0QuantLib" ;;
let _new_SEKLibor arg = match _new_SEKLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SEKLibor_f : c_obj list -> c_obj list = "_wrap_new_SEKLiborQuantLib" ;;
let _new_SEKLibor arg = match _new_SEKLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SEKLibor_f : c_obj list -> c_obj list = "_wrap_delete_SEKLiborQuantLib" ;;
let _delete_SEKLibor arg = match _delete_SEKLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Tibor_f : c_obj list -> c_obj list = "_wrap_new_Tibor__SWIG_0QuantLib" ;;
let _new_Tibor arg = match _new_Tibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Tibor_f : c_obj list -> c_obj list = "_wrap_new_TiborQuantLib" ;;
let _new_Tibor arg = match _new_Tibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Tibor_f : c_obj list -> c_obj list = "_wrap_delete_TiborQuantLib" ;;
let _delete_Tibor arg = match _delete_Tibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TRLibor_f : c_obj list -> c_obj list = "_wrap_new_TRLibor__SWIG_0QuantLib" ;;
let _new_TRLibor arg = match _new_TRLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TRLibor_f : c_obj list -> c_obj list = "_wrap_new_TRLiborQuantLib" ;;
let _new_TRLibor arg = match _new_TRLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TRLibor_f : c_obj list -> c_obj list = "_wrap_delete_TRLiborQuantLib" ;;
let _delete_TRLibor arg = match _delete_TRLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_USDLibor_f : c_obj list -> c_obj list = "_wrap_new_USDLibor__SWIG_0QuantLib" ;;
let _new_USDLibor arg = match _new_USDLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_USDLibor_f : c_obj list -> c_obj list = "_wrap_new_USDLiborQuantLib" ;;
let _new_USDLibor arg = match _new_USDLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_USDLibor_f : c_obj list -> c_obj list = "_wrap_delete_USDLiborQuantLib" ;;
let _delete_USDLibor arg = match _delete_USDLibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Zibor_f : c_obj list -> c_obj list = "_wrap_new_Zibor__SWIG_0QuantLib" ;;
let _new_Zibor arg = match _new_Zibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Zibor_f : c_obj list -> c_obj list = "_wrap_new_ZiborQuantLib" ;;
let _new_Zibor arg = match _new_Zibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Zibor_f : c_obj list -> c_obj list = "_wrap_delete_ZiborQuantLib" ;;
let _delete_Zibor arg = match _delete_Zibor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Aonia_f : c_obj list -> c_obj list = "_wrap_new_Aonia__SWIG_0QuantLib" ;;
let _new_Aonia arg = match _new_Aonia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Aonia_f : c_obj list -> c_obj list = "_wrap_new_AoniaQuantLib" ;;
let _new_Aonia arg = match _new_Aonia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Aonia_f : c_obj list -> c_obj list = "_wrap_delete_AoniaQuantLib" ;;
let _delete_Aonia arg = match _delete_Aonia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Eonia_f : c_obj list -> c_obj list = "_wrap_new_Eonia__SWIG_0QuantLib" ;;
let _new_Eonia arg = match _new_Eonia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Eonia_f : c_obj list -> c_obj list = "_wrap_new_EoniaQuantLib" ;;
let _new_Eonia arg = match _new_Eonia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Eonia_f : c_obj list -> c_obj list = "_wrap_delete_EoniaQuantLib" ;;
let _delete_Eonia arg = match _delete_Eonia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Sonia_f : c_obj list -> c_obj list = "_wrap_new_Sonia__SWIG_0QuantLib" ;;
let _new_Sonia arg = match _new_Sonia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Sonia_f : c_obj list -> c_obj list = "_wrap_new_SoniaQuantLib" ;;
let _new_Sonia arg = match _new_Sonia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Sonia_f : c_obj list -> c_obj list = "_wrap_delete_SoniaQuantLib" ;;
let _delete_Sonia arg = match _delete_Sonia_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FedFunds_f : c_obj list -> c_obj list = "_wrap_new_FedFunds__SWIG_0QuantLib" ;;
let _new_FedFunds arg = match _new_FedFunds_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FedFunds_f : c_obj list -> c_obj list = "_wrap_new_FedFundsQuantLib" ;;
let _new_FedFunds arg = match _new_FedFunds_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FedFunds_f : c_obj list -> c_obj list = "_wrap_delete_FedFundsQuantLib" ;;
let _delete_FedFunds arg = match _delete_FedFunds_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Nzocr_f : c_obj list -> c_obj list = "_wrap_new_Nzocr__SWIG_0QuantLib" ;;
let _new_Nzocr arg = match _new_Nzocr_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Nzocr_f : c_obj list -> c_obj list = "_wrap_new_NzocrQuantLib" ;;
let _new_Nzocr arg = match _new_Nzocr_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Nzocr_f : c_obj list -> c_obj list = "_wrap_delete_NzocrQuantLib" ;;
let _delete_Nzocr arg = match _delete_Nzocr_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuriborSwapIsdaFixA_f : c_obj list -> c_obj list = "_wrap_new_EuriborSwapIsdaFixA__SWIG_0QuantLib" ;;
let _new_EuriborSwapIsdaFixA arg = match _new_EuriborSwapIsdaFixA_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuriborSwapIsdaFixA_f : c_obj list -> c_obj list = "_wrap_new_EuriborSwapIsdaFixA__SWIG_1QuantLib" ;;
let _new_EuriborSwapIsdaFixA arg = match _new_EuriborSwapIsdaFixA_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuriborSwapIsdaFixA_f : c_obj list -> c_obj list = "_wrap_new_EuriborSwapIsdaFixAQuantLib" ;;
let _new_EuriborSwapIsdaFixA arg = match _new_EuriborSwapIsdaFixA_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EuriborSwapIsdaFixA_f : c_obj list -> c_obj list = "_wrap_delete_EuriborSwapIsdaFixAQuantLib" ;;
let _delete_EuriborSwapIsdaFixA arg = match _delete_EuriborSwapIsdaFixA_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuriborSwapIsdaFixB_f : c_obj list -> c_obj list = "_wrap_new_EuriborSwapIsdaFixB__SWIG_0QuantLib" ;;
let _new_EuriborSwapIsdaFixB arg = match _new_EuriborSwapIsdaFixB_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuriborSwapIsdaFixB_f : c_obj list -> c_obj list = "_wrap_new_EuriborSwapIsdaFixB__SWIG_1QuantLib" ;;
let _new_EuriborSwapIsdaFixB arg = match _new_EuriborSwapIsdaFixB_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuriborSwapIsdaFixB_f : c_obj list -> c_obj list = "_wrap_new_EuriborSwapIsdaFixBQuantLib" ;;
let _new_EuriborSwapIsdaFixB arg = match _new_EuriborSwapIsdaFixB_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EuriborSwapIsdaFixB_f : c_obj list -> c_obj list = "_wrap_delete_EuriborSwapIsdaFixBQuantLib" ;;
let _delete_EuriborSwapIsdaFixB arg = match _delete_EuriborSwapIsdaFixB_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuriborSwapIfrFix_f : c_obj list -> c_obj list = "_wrap_new_EuriborSwapIfrFix__SWIG_0QuantLib" ;;
let _new_EuriborSwapIfrFix arg = match _new_EuriborSwapIfrFix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuriborSwapIfrFix_f : c_obj list -> c_obj list = "_wrap_new_EuriborSwapIfrFix__SWIG_1QuantLib" ;;
let _new_EuriborSwapIfrFix arg = match _new_EuriborSwapIfrFix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuriborSwapIfrFix_f : c_obj list -> c_obj list = "_wrap_new_EuriborSwapIfrFixQuantLib" ;;
let _new_EuriborSwapIfrFix arg = match _new_EuriborSwapIfrFix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EuriborSwapIfrFix_f : c_obj list -> c_obj list = "_wrap_delete_EuriborSwapIfrFixQuantLib" ;;
let _delete_EuriborSwapIfrFix arg = match _delete_EuriborSwapIfrFix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EurLiborSwapIsdaFixA_f : c_obj list -> c_obj list = "_wrap_new_EurLiborSwapIsdaFixA__SWIG_0QuantLib" ;;
let _new_EurLiborSwapIsdaFixA arg = match _new_EurLiborSwapIsdaFixA_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EurLiborSwapIsdaFixA_f : c_obj list -> c_obj list = "_wrap_new_EurLiborSwapIsdaFixA__SWIG_1QuantLib" ;;
let _new_EurLiborSwapIsdaFixA arg = match _new_EurLiborSwapIsdaFixA_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EurLiborSwapIsdaFixA_f : c_obj list -> c_obj list = "_wrap_new_EurLiborSwapIsdaFixAQuantLib" ;;
let _new_EurLiborSwapIsdaFixA arg = match _new_EurLiborSwapIsdaFixA_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EurLiborSwapIsdaFixA_f : c_obj list -> c_obj list = "_wrap_delete_EurLiborSwapIsdaFixAQuantLib" ;;
let _delete_EurLiborSwapIsdaFixA arg = match _delete_EurLiborSwapIsdaFixA_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EurLiborSwapIsdaFixB_f : c_obj list -> c_obj list = "_wrap_new_EurLiborSwapIsdaFixB__SWIG_0QuantLib" ;;
let _new_EurLiborSwapIsdaFixB arg = match _new_EurLiborSwapIsdaFixB_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EurLiborSwapIsdaFixB_f : c_obj list -> c_obj list = "_wrap_new_EurLiborSwapIsdaFixB__SWIG_1QuantLib" ;;
let _new_EurLiborSwapIsdaFixB arg = match _new_EurLiborSwapIsdaFixB_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EurLiborSwapIsdaFixB_f : c_obj list -> c_obj list = "_wrap_new_EurLiborSwapIsdaFixBQuantLib" ;;
let _new_EurLiborSwapIsdaFixB arg = match _new_EurLiborSwapIsdaFixB_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EurLiborSwapIsdaFixB_f : c_obj list -> c_obj list = "_wrap_delete_EurLiborSwapIsdaFixBQuantLib" ;;
let _delete_EurLiborSwapIsdaFixB arg = match _delete_EurLiborSwapIsdaFixB_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EurLiborSwapIfrFix_f : c_obj list -> c_obj list = "_wrap_new_EurLiborSwapIfrFix__SWIG_0QuantLib" ;;
let _new_EurLiborSwapIfrFix arg = match _new_EurLiborSwapIfrFix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EurLiborSwapIfrFix_f : c_obj list -> c_obj list = "_wrap_new_EurLiborSwapIfrFix__SWIG_1QuantLib" ;;
let _new_EurLiborSwapIfrFix arg = match _new_EurLiborSwapIfrFix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EurLiborSwapIfrFix_f : c_obj list -> c_obj list = "_wrap_new_EurLiborSwapIfrFixQuantLib" ;;
let _new_EurLiborSwapIfrFix arg = match _new_EurLiborSwapIfrFix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EurLiborSwapIfrFix_f : c_obj list -> c_obj list = "_wrap_delete_EurLiborSwapIfrFixQuantLib" ;;
let _delete_EurLiborSwapIfrFix arg = match _delete_EurLiborSwapIfrFix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Brent_setMaxEvaluations_f : c_obj list -> c_obj list = "_wrap_Brent_setMaxEvaluationsQuantLib" ;;
let _Brent_setMaxEvaluations arg = match _Brent_setMaxEvaluations_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Brent_setLowerBound_f : c_obj list -> c_obj list = "_wrap_Brent_setLowerBoundQuantLib" ;;
let _Brent_setLowerBound arg = match _Brent_setLowerBound_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Brent_setUpperBound_f : c_obj list -> c_obj list = "_wrap_Brent_setUpperBoundQuantLib" ;;
let _Brent_setUpperBound arg = match _Brent_setUpperBound_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Brent_f : c_obj list -> c_obj list = "_wrap_new_BrentQuantLib" ;;
let _new_Brent arg = match _new_Brent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Brent_f : c_obj list -> c_obj list = "_wrap_delete_BrentQuantLib" ;;
let _delete_Brent arg = match _delete_Brent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bisection_setMaxEvaluations_f : c_obj list -> c_obj list = "_wrap_Bisection_setMaxEvaluationsQuantLib" ;;
let _Bisection_setMaxEvaluations arg = match _Bisection_setMaxEvaluations_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bisection_setLowerBound_f : c_obj list -> c_obj list = "_wrap_Bisection_setLowerBoundQuantLib" ;;
let _Bisection_setLowerBound arg = match _Bisection_setLowerBound_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bisection_setUpperBound_f : c_obj list -> c_obj list = "_wrap_Bisection_setUpperBoundQuantLib" ;;
let _Bisection_setUpperBound arg = match _Bisection_setUpperBound_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bisection_f : c_obj list -> c_obj list = "_wrap_new_BisectionQuantLib" ;;
let _new_Bisection arg = match _new_Bisection_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bisection_f : c_obj list -> c_obj list = "_wrap_delete_BisectionQuantLib" ;;
let _delete_Bisection arg = match _delete_Bisection_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FalsePosition_setMaxEvaluations_f : c_obj list -> c_obj list = "_wrap_FalsePosition_setMaxEvaluationsQuantLib" ;;
let _FalsePosition_setMaxEvaluations arg = match _FalsePosition_setMaxEvaluations_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FalsePosition_setLowerBound_f : c_obj list -> c_obj list = "_wrap_FalsePosition_setLowerBoundQuantLib" ;;
let _FalsePosition_setLowerBound arg = match _FalsePosition_setLowerBound_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FalsePosition_setUpperBound_f : c_obj list -> c_obj list = "_wrap_FalsePosition_setUpperBoundQuantLib" ;;
let _FalsePosition_setUpperBound arg = match _FalsePosition_setUpperBound_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FalsePosition_f : c_obj list -> c_obj list = "_wrap_new_FalsePositionQuantLib" ;;
let _new_FalsePosition arg = match _new_FalsePosition_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FalsePosition_f : c_obj list -> c_obj list = "_wrap_delete_FalsePositionQuantLib" ;;
let _delete_FalsePosition arg = match _delete_FalsePosition_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Ridder_setMaxEvaluations_f : c_obj list -> c_obj list = "_wrap_Ridder_setMaxEvaluationsQuantLib" ;;
let _Ridder_setMaxEvaluations arg = match _Ridder_setMaxEvaluations_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Ridder_setLowerBound_f : c_obj list -> c_obj list = "_wrap_Ridder_setLowerBoundQuantLib" ;;
let _Ridder_setLowerBound arg = match _Ridder_setLowerBound_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Ridder_setUpperBound_f : c_obj list -> c_obj list = "_wrap_Ridder_setUpperBoundQuantLib" ;;
let _Ridder_setUpperBound arg = match _Ridder_setUpperBound_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Ridder_f : c_obj list -> c_obj list = "_wrap_new_RidderQuantLib" ;;
let _new_Ridder arg = match _new_Ridder_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Ridder_f : c_obj list -> c_obj list = "_wrap_delete_RidderQuantLib" ;;
let _delete_Ridder arg = match _delete_Ridder_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Secant_setMaxEvaluations_f : c_obj list -> c_obj list = "_wrap_Secant_setMaxEvaluationsQuantLib" ;;
let _Secant_setMaxEvaluations arg = match _Secant_setMaxEvaluations_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Secant_setLowerBound_f : c_obj list -> c_obj list = "_wrap_Secant_setLowerBoundQuantLib" ;;
let _Secant_setLowerBound arg = match _Secant_setLowerBound_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Secant_setUpperBound_f : c_obj list -> c_obj list = "_wrap_Secant_setUpperBoundQuantLib" ;;
let _Secant_setUpperBound arg = match _Secant_setUpperBound_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Secant_f : c_obj list -> c_obj list = "_wrap_new_SecantQuantLib" ;;
let _new_Secant arg = match _new_Secant_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Secant_f : c_obj list -> c_obj list = "_wrap_delete_SecantQuantLib" ;;
let _delete_Secant arg = match _delete_Secant_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Constraint_f : c_obj list -> c_obj list = "_wrap_delete_ConstraintQuantLib" ;;
let _delete_Constraint arg = match _delete_Constraint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BoundaryConstraint_f : c_obj list -> c_obj list = "_wrap_new_BoundaryConstraintQuantLib" ;;
let _new_BoundaryConstraint arg = match _new_BoundaryConstraint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BoundaryConstraint_f : c_obj list -> c_obj list = "_wrap_delete_BoundaryConstraintQuantLib" ;;
let _delete_BoundaryConstraint arg = match _delete_BoundaryConstraint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NoConstraint_f : c_obj list -> c_obj list = "_wrap_new_NoConstraintQuantLib" ;;
let _new_NoConstraint arg = match _new_NoConstraint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NoConstraint_f : c_obj list -> c_obj list = "_wrap_delete_NoConstraintQuantLib" ;;
let _delete_NoConstraint arg = match _delete_NoConstraint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PositiveConstraint_f : c_obj list -> c_obj list = "_wrap_new_PositiveConstraintQuantLib" ;;
let _new_PositiveConstraint arg = match _new_PositiveConstraint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PositiveConstraint_f : c_obj list -> c_obj list = "_wrap_delete_PositiveConstraintQuantLib" ;;
let _delete_PositiveConstraint arg = match _delete_PositiveConstraint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CompositeConstraint_f : c_obj list -> c_obj list = "_wrap_new_CompositeConstraintQuantLib" ;;
let _new_CompositeConstraint arg = match _new_CompositeConstraint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CompositeConstraint_f : c_obj list -> c_obj list = "_wrap_delete_CompositeConstraintQuantLib" ;;
let _delete_CompositeConstraint arg = match _delete_CompositeConstraint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NonhomogeneousBoundaryConstraint_f : c_obj list -> c_obj list = "_wrap_new_NonhomogeneousBoundaryConstraintQuantLib" ;;
let _new_NonhomogeneousBoundaryConstraint arg = match _new_NonhomogeneousBoundaryConstraint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NonhomogeneousBoundaryConstraint_f : c_obj list -> c_obj list = "_wrap_delete_NonhomogeneousBoundaryConstraintQuantLib" ;;
let _delete_NonhomogeneousBoundaryConstraint arg = match _delete_NonhomogeneousBoundaryConstraint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "EndCriteria::Type_marker" (`Type)
external _MaxIterations : c_obj -> Swig.c_obj = "_wrap_MaxIterations" 
external _StationaryPoint : c_obj -> Swig.c_obj = "_wrap_StationaryPoint" 
external _StationaryFunctionValue : c_obj -> Swig.c_obj = "_wrap_StationaryFunctionValue" 
external _StationaryFunctionAccuracy : c_obj -> Swig.c_obj = "_wrap_StationaryFunctionAccuracy" 
external _ZeroGradientNorm : c_obj -> Swig.c_obj = "_wrap_ZeroGradientNorm" 
external _Unknown : c_obj -> Swig.c_obj = "_wrap_Unknown" 
external _new_EndCriteria_f : c_obj list -> c_obj list = "_wrap_new_EndCriteriaQuantLib" ;;
let _new_EndCriteria arg = match _new_EndCriteria_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _EndCriteria_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_EndCriteria_operator_pP___QuantLib" ;;
let _EndCriteria_operator_xx_xx_lparen_xx_rparen arg = match _EndCriteria_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EndCriteria_f : c_obj list -> c_obj list = "_wrap_delete_EndCriteriaQuantLib" ;;
let _delete_EndCriteria arg = match _delete_EndCriteria_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_OptimizationMethod_f : c_obj list -> c_obj list = "_wrap_delete_OptimizationMethodQuantLib" ;;
let _delete_OptimizationMethod arg = match _delete_OptimizationMethod_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConjugateGradient_f : c_obj list -> c_obj list = "_wrap_new_ConjugateGradientQuantLib" ;;
let _new_ConjugateGradient arg = match _new_ConjugateGradient_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ConjugateGradient_f : c_obj list -> c_obj list = "_wrap_delete_ConjugateGradientQuantLib" ;;
let _delete_ConjugateGradient arg = match _delete_ConjugateGradient_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Simplex_f : c_obj list -> c_obj list = "_wrap_new_SimplexQuantLib" ;;
let _new_Simplex arg = match _new_Simplex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Simplex_f : c_obj list -> c_obj list = "_wrap_delete_SimplexQuantLib" ;;
let _delete_Simplex arg = match _delete_Simplex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SteepestDescent_f : c_obj list -> c_obj list = "_wrap_new_SteepestDescentQuantLib" ;;
let _new_SteepestDescent arg = match _new_SteepestDescent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SteepestDescent_f : c_obj list -> c_obj list = "_wrap_delete_SteepestDescentQuantLib" ;;
let _delete_SteepestDescent arg = match _delete_SteepestDescent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BFGS_f : c_obj list -> c_obj list = "_wrap_new_BFGSQuantLib" ;;
let _new_BFGS arg = match _new_BFGS_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BFGS_f : c_obj list -> c_obj list = "_wrap_delete_BFGSQuantLib" ;;
let _delete_BFGS arg = match _delete_BFGS_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LevenbergMarquardt_f : c_obj list -> c_obj list = "_wrap_new_LevenbergMarquardt__SWIG_0QuantLib" ;;
let _new_LevenbergMarquardt arg = match _new_LevenbergMarquardt_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LevenbergMarquardt_f : c_obj list -> c_obj list = "_wrap_new_LevenbergMarquardt__SWIG_1QuantLib" ;;
let _new_LevenbergMarquardt arg = match _new_LevenbergMarquardt_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LevenbergMarquardt_f : c_obj list -> c_obj list = "_wrap_new_LevenbergMarquardt__SWIG_2QuantLib" ;;
let _new_LevenbergMarquardt arg = match _new_LevenbergMarquardt_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LevenbergMarquardt_f : c_obj list -> c_obj list = "_wrap_new_LevenbergMarquardtQuantLib" ;;
let _new_LevenbergMarquardt arg = match _new_LevenbergMarquardt_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LevenbergMarquardt_f : c_obj list -> c_obj list = "_wrap_delete_LevenbergMarquardtQuantLib" ;;
let _delete_LevenbergMarquardt arg = match _delete_LevenbergMarquardt_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DifferentialEvolution_f : c_obj list -> c_obj list = "_wrap_new_DifferentialEvolutionQuantLib" ;;
let _new_DifferentialEvolution arg = match _new_DifferentialEvolution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DifferentialEvolution_f : c_obj list -> c_obj list = "_wrap_delete_DifferentialEvolutionQuantLib" ;;
let _delete_DifferentialEvolution arg = match _delete_DifferentialEvolution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SamplerGaussian_f : c_obj list -> c_obj list = "_wrap_new_SamplerGaussian__SWIG_0QuantLib" ;;
let _new_SamplerGaussian arg = match _new_SamplerGaussian_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SamplerGaussian_f : c_obj list -> c_obj list = "_wrap_new_SamplerGaussianQuantLib" ;;
let _new_SamplerGaussian arg = match _new_SamplerGaussian_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SamplerGaussian_f : c_obj list -> c_obj list = "_wrap_delete_SamplerGaussianQuantLib" ;;
let _delete_SamplerGaussian arg = match _delete_SamplerGaussian_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SamplerLogNormal_f : c_obj list -> c_obj list = "_wrap_new_SamplerLogNormal__SWIG_0QuantLib" ;;
let _new_SamplerLogNormal arg = match _new_SamplerLogNormal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SamplerLogNormal_f : c_obj list -> c_obj list = "_wrap_new_SamplerLogNormalQuantLib" ;;
let _new_SamplerLogNormal arg = match _new_SamplerLogNormal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SamplerLogNormal_f : c_obj list -> c_obj list = "_wrap_delete_SamplerLogNormalQuantLib" ;;
let _delete_SamplerLogNormal arg = match _delete_SamplerLogNormal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SamplerMirrorGaussian_f : c_obj list -> c_obj list = "_wrap_new_SamplerMirrorGaussian__SWIG_0QuantLib" ;;
let _new_SamplerMirrorGaussian arg = match _new_SamplerMirrorGaussian_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SamplerMirrorGaussian_f : c_obj list -> c_obj list = "_wrap_new_SamplerMirrorGaussianQuantLib" ;;
let _new_SamplerMirrorGaussian arg = match _new_SamplerMirrorGaussian_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SamplerMirrorGaussian_f : c_obj list -> c_obj list = "_wrap_delete_SamplerMirrorGaussianQuantLib" ;;
let _delete_SamplerMirrorGaussian arg = match _delete_SamplerMirrorGaussian_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ProbabilityBoltzmannDownhill_f : c_obj list -> c_obj list = "_wrap_new_ProbabilityBoltzmannDownhill__SWIG_0QuantLib" ;;
let _new_ProbabilityBoltzmannDownhill arg = match _new_ProbabilityBoltzmannDownhill_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ProbabilityBoltzmannDownhill_f : c_obj list -> c_obj list = "_wrap_new_ProbabilityBoltzmannDownhillQuantLib" ;;
let _new_ProbabilityBoltzmannDownhill arg = match _new_ProbabilityBoltzmannDownhill_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ProbabilityBoltzmannDownhill_f : c_obj list -> c_obj list = "_wrap_delete_ProbabilityBoltzmannDownhillQuantLib" ;;
let _delete_ProbabilityBoltzmannDownhill arg = match _delete_ProbabilityBoltzmannDownhill_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TemperatureExponential_f : c_obj list -> c_obj list = "_wrap_new_TemperatureExponential__SWIG_0QuantLib" ;;
let _new_TemperatureExponential arg = match _new_TemperatureExponential_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TemperatureExponential_f : c_obj list -> c_obj list = "_wrap_new_TemperatureExponentialQuantLib" ;;
let _new_TemperatureExponential arg = match _new_TemperatureExponential_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TemperatureExponential_f : c_obj list -> c_obj list = "_wrap_delete_TemperatureExponentialQuantLib" ;;
let _delete_TemperatureExponential arg = match _delete_TemperatureExponential_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ReannealingTrivial_f : c_obj list -> c_obj list = "_wrap_new_ReannealingTrivialQuantLib" ;;
let _new_ReannealingTrivial arg = match _new_ReannealingTrivial_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ReannealingTrivial_f : c_obj list -> c_obj list = "_wrap_delete_ReannealingTrivialQuantLib" ;;
let _delete_ReannealingTrivial arg = match _delete_ReannealingTrivial_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "GaussianSimulatedAnnealing::ResetScheme_marker" (`ResetScheme)
external _NoResetScheme : c_obj -> Swig.c_obj = "_wrap_NoResetScheme" 
external _ResetToBestPoint : c_obj -> Swig.c_obj = "_wrap_ResetToBestPoint" 
external _ResetToOrigin : c_obj -> Swig.c_obj = "_wrap_ResetToOrigin" 
external _new_GaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_GaussianSimulatedAnnealing__SWIG_0QuantLib" ;;
let _new_GaussianSimulatedAnnealing arg = match _new_GaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_GaussianSimulatedAnnealing__SWIG_1QuantLib" ;;
let _new_GaussianSimulatedAnnealing arg = match _new_GaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_GaussianSimulatedAnnealing__SWIG_2QuantLib" ;;
let _new_GaussianSimulatedAnnealing arg = match _new_GaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_GaussianSimulatedAnnealing__SWIG_3QuantLib" ;;
let _new_GaussianSimulatedAnnealing arg = match _new_GaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_GaussianSimulatedAnnealing__SWIG_4QuantLib" ;;
let _new_GaussianSimulatedAnnealing arg = match _new_GaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_GaussianSimulatedAnnealing__SWIG_5QuantLib" ;;
let _new_GaussianSimulatedAnnealing arg = match _new_GaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_GaussianSimulatedAnnealingQuantLib" ;;
let _new_GaussianSimulatedAnnealing arg = match _new_GaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_delete_GaussianSimulatedAnnealingQuantLib" ;;
let _delete_GaussianSimulatedAnnealing arg = match _delete_GaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "MirrorGaussianSimulatedAnnealing::ResetScheme_marker" (`ResetScheme)
external _new_MirrorGaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_MirrorGaussianSimulatedAnnealing__SWIG_0QuantLib" ;;
let _new_MirrorGaussianSimulatedAnnealing arg = match _new_MirrorGaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MirrorGaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_MirrorGaussianSimulatedAnnealing__SWIG_1QuantLib" ;;
let _new_MirrorGaussianSimulatedAnnealing arg = match _new_MirrorGaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MirrorGaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_MirrorGaussianSimulatedAnnealing__SWIG_2QuantLib" ;;
let _new_MirrorGaussianSimulatedAnnealing arg = match _new_MirrorGaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MirrorGaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_MirrorGaussianSimulatedAnnealing__SWIG_3QuantLib" ;;
let _new_MirrorGaussianSimulatedAnnealing arg = match _new_MirrorGaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MirrorGaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_MirrorGaussianSimulatedAnnealing__SWIG_4QuantLib" ;;
let _new_MirrorGaussianSimulatedAnnealing arg = match _new_MirrorGaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MirrorGaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_MirrorGaussianSimulatedAnnealing__SWIG_5QuantLib" ;;
let _new_MirrorGaussianSimulatedAnnealing arg = match _new_MirrorGaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MirrorGaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_MirrorGaussianSimulatedAnnealingQuantLib" ;;
let _new_MirrorGaussianSimulatedAnnealing arg = match _new_MirrorGaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MirrorGaussianSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_delete_MirrorGaussianSimulatedAnnealingQuantLib" ;;
let _delete_MirrorGaussianSimulatedAnnealing arg = match _delete_MirrorGaussianSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "LogNormalSimulatedAnnealing::ResetScheme_marker" (`ResetScheme)
external _new_LogNormalSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_LogNormalSimulatedAnnealing__SWIG_0QuantLib" ;;
let _new_LogNormalSimulatedAnnealing arg = match _new_LogNormalSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogNormalSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_LogNormalSimulatedAnnealing__SWIG_1QuantLib" ;;
let _new_LogNormalSimulatedAnnealing arg = match _new_LogNormalSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogNormalSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_LogNormalSimulatedAnnealing__SWIG_2QuantLib" ;;
let _new_LogNormalSimulatedAnnealing arg = match _new_LogNormalSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogNormalSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_LogNormalSimulatedAnnealing__SWIG_3QuantLib" ;;
let _new_LogNormalSimulatedAnnealing arg = match _new_LogNormalSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogNormalSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_LogNormalSimulatedAnnealing__SWIG_4QuantLib" ;;
let _new_LogNormalSimulatedAnnealing arg = match _new_LogNormalSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogNormalSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_LogNormalSimulatedAnnealing__SWIG_5QuantLib" ;;
let _new_LogNormalSimulatedAnnealing arg = match _new_LogNormalSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogNormalSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_new_LogNormalSimulatedAnnealingQuantLib" ;;
let _new_LogNormalSimulatedAnnealing arg = match _new_LogNormalSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LogNormalSimulatedAnnealing_f : c_obj list -> c_obj list = "_wrap_delete_LogNormalSimulatedAnnealingQuantLib" ;;
let _delete_LogNormalSimulatedAnnealing arg = match _delete_LogNormalSimulatedAnnealing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Optimizer_f : c_obj list -> c_obj list = "_wrap_new_OptimizerQuantLib" ;;
let _new_Optimizer arg = match _new_Optimizer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Optimizer_f : c_obj list -> c_obj list = "_wrap_delete_OptimizerQuantLib" ;;
let _delete_Optimizer arg = match _delete_Optimizer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "VolatilityType_marker" (`VolatilityType)
external _ShiftedLognormal : c_obj -> Swig.c_obj = "_wrap_ShiftedLognormal" 
external _Normal : c_obj -> Swig.c_obj = "_wrap_Normal" 
external _BlackVolTermStructure___deref___f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure___deref__QuantLib" ;;
let _BlackVolTermStructure___deref__ arg = match _BlackVolTermStructure___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_isNull_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_isNullQuantLib" ;;
let _BlackVolTermStructure_isNull arg = match _BlackVolTermStructure_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_asObservable_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_asObservableQuantLib" ;;
let _BlackVolTermStructure_asObservable arg = match _BlackVolTermStructure_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackVolTermStructure_f : c_obj list -> c_obj list = "_wrap_new_BlackVolTermStructureQuantLib" ;;
let _new_BlackVolTermStructure arg = match _new_BlackVolTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackVolTermStructure_f : c_obj list -> c_obj list = "_wrap_delete_BlackVolTermStructureQuantLib" ;;
let _delete_BlackVolTermStructure arg = match _delete_BlackVolTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_referenceDate_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_referenceDateQuantLib" ;;
let _BlackVolTermStructure_referenceDate arg = match _BlackVolTermStructure_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_dayCounter_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_dayCounterQuantLib" ;;
let _BlackVolTermStructure_dayCounter arg = match _BlackVolTermStructure_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_calendar_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_calendarQuantLib" ;;
let _BlackVolTermStructure_calendar arg = match _BlackVolTermStructure_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_maxDate_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_maxDateQuantLib" ;;
let _BlackVolTermStructure_maxDate arg = match _BlackVolTermStructure_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_maxTime_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_maxTimeQuantLib" ;;
let _BlackVolTermStructure_maxTime arg = match _BlackVolTermStructure_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_minStrike_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_minStrikeQuantLib" ;;
let _BlackVolTermStructure_minStrike arg = match _BlackVolTermStructure_minStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_maxStrike_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_maxStrikeQuantLib" ;;
let _BlackVolTermStructure_maxStrike arg = match _BlackVolTermStructure_maxStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackVol__SWIG_0QuantLib" ;;
let _BlackVolTermStructure_blackVol arg = match _BlackVolTermStructure_blackVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackVol__SWIG_1QuantLib" ;;
let _BlackVolTermStructure_blackVol arg = match _BlackVolTermStructure_blackVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackVol__SWIG_2QuantLib" ;;
let _BlackVolTermStructure_blackVol arg = match _BlackVolTermStructure_blackVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackVolQuantLib" ;;
let _BlackVolTermStructure_blackVol arg = match _BlackVolTermStructure_blackVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackVariance__SWIG_0QuantLib" ;;
let _BlackVolTermStructure_blackVariance arg = match _BlackVolTermStructure_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackVariance__SWIG_1QuantLib" ;;
let _BlackVolTermStructure_blackVariance arg = match _BlackVolTermStructure_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackVariance__SWIG_2QuantLib" ;;
let _BlackVolTermStructure_blackVariance arg = match _BlackVolTermStructure_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackVarianceQuantLib" ;;
let _BlackVolTermStructure_blackVariance arg = match _BlackVolTermStructure_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackForwardVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackForwardVol__SWIG_0QuantLib" ;;
let _BlackVolTermStructure_blackForwardVol arg = match _BlackVolTermStructure_blackForwardVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackForwardVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackForwardVol__SWIG_1QuantLib" ;;
let _BlackVolTermStructure_blackForwardVol arg = match _BlackVolTermStructure_blackForwardVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackForwardVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackForwardVol__SWIG_2QuantLib" ;;
let _BlackVolTermStructure_blackForwardVol arg = match _BlackVolTermStructure_blackForwardVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackForwardVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackForwardVolQuantLib" ;;
let _BlackVolTermStructure_blackForwardVol arg = match _BlackVolTermStructure_blackForwardVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackForwardVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackForwardVariance__SWIG_0QuantLib" ;;
let _BlackVolTermStructure_blackForwardVariance arg = match _BlackVolTermStructure_blackForwardVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackForwardVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackForwardVariance__SWIG_1QuantLib" ;;
let _BlackVolTermStructure_blackForwardVariance arg = match _BlackVolTermStructure_blackForwardVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackForwardVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackForwardVariance__SWIG_2QuantLib" ;;
let _BlackVolTermStructure_blackForwardVariance arg = match _BlackVolTermStructure_blackForwardVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_blackForwardVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_blackForwardVarianceQuantLib" ;;
let _BlackVolTermStructure_blackForwardVariance arg = match _BlackVolTermStructure_blackForwardVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_enableExtrapolationQuantLib" ;;
let _BlackVolTermStructure_enableExtrapolation arg = match _BlackVolTermStructure_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_disableExtrapolationQuantLib" ;;
let _BlackVolTermStructure_disableExtrapolation arg = match _BlackVolTermStructure_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructure_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructure_allowsExtrapolationQuantLib" ;;
let _BlackVolTermStructure_allowsExtrapolation arg = match _BlackVolTermStructure_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackVolTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_BlackVolTermStructureHandle__SWIG_0QuantLib" ;;
let _new_BlackVolTermStructureHandle arg = match _new_BlackVolTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackVolTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_BlackVolTermStructureHandleQuantLib" ;;
let _new_BlackVolTermStructureHandle arg = match _new_BlackVolTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle___deref___f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle___deref__QuantLib" ;;
let _BlackVolTermStructureHandle___deref__ arg = match _BlackVolTermStructureHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_empty_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_emptyQuantLib" ;;
let _BlackVolTermStructureHandle_empty arg = match _BlackVolTermStructureHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_asObservableQuantLib" ;;
let _BlackVolTermStructureHandle_asObservable arg = match _BlackVolTermStructureHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackVolTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_BlackVolTermStructureHandleQuantLib" ;;
let _delete_BlackVolTermStructureHandle arg = match _delete_BlackVolTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_referenceDate_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_referenceDateQuantLib" ;;
let _BlackVolTermStructureHandle_referenceDate arg = match _BlackVolTermStructureHandle_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_dayCounter_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_dayCounterQuantLib" ;;
let _BlackVolTermStructureHandle_dayCounter arg = match _BlackVolTermStructureHandle_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_calendar_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_calendarQuantLib" ;;
let _BlackVolTermStructureHandle_calendar arg = match _BlackVolTermStructureHandle_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_maxDate_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_maxDateQuantLib" ;;
let _BlackVolTermStructureHandle_maxDate arg = match _BlackVolTermStructureHandle_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_maxTime_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_maxTimeQuantLib" ;;
let _BlackVolTermStructureHandle_maxTime arg = match _BlackVolTermStructureHandle_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_minStrike_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_minStrikeQuantLib" ;;
let _BlackVolTermStructureHandle_minStrike arg = match _BlackVolTermStructureHandle_minStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_maxStrike_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_maxStrikeQuantLib" ;;
let _BlackVolTermStructureHandle_maxStrike arg = match _BlackVolTermStructureHandle_maxStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackVol__SWIG_0QuantLib" ;;
let _BlackVolTermStructureHandle_blackVol arg = match _BlackVolTermStructureHandle_blackVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackVol__SWIG_1QuantLib" ;;
let _BlackVolTermStructureHandle_blackVol arg = match _BlackVolTermStructureHandle_blackVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackVol__SWIG_2QuantLib" ;;
let _BlackVolTermStructureHandle_blackVol arg = match _BlackVolTermStructureHandle_blackVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackVolQuantLib" ;;
let _BlackVolTermStructureHandle_blackVol arg = match _BlackVolTermStructureHandle_blackVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackVariance__SWIG_0QuantLib" ;;
let _BlackVolTermStructureHandle_blackVariance arg = match _BlackVolTermStructureHandle_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackVariance__SWIG_1QuantLib" ;;
let _BlackVolTermStructureHandle_blackVariance arg = match _BlackVolTermStructureHandle_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackVariance__SWIG_2QuantLib" ;;
let _BlackVolTermStructureHandle_blackVariance arg = match _BlackVolTermStructureHandle_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackVarianceQuantLib" ;;
let _BlackVolTermStructureHandle_blackVariance arg = match _BlackVolTermStructureHandle_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackForwardVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackForwardVol__SWIG_0QuantLib" ;;
let _BlackVolTermStructureHandle_blackForwardVol arg = match _BlackVolTermStructureHandle_blackForwardVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackForwardVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackForwardVol__SWIG_1QuantLib" ;;
let _BlackVolTermStructureHandle_blackForwardVol arg = match _BlackVolTermStructureHandle_blackForwardVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackForwardVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackForwardVol__SWIG_2QuantLib" ;;
let _BlackVolTermStructureHandle_blackForwardVol arg = match _BlackVolTermStructureHandle_blackForwardVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackForwardVol_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackForwardVolQuantLib" ;;
let _BlackVolTermStructureHandle_blackForwardVol arg = match _BlackVolTermStructureHandle_blackForwardVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackForwardVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackForwardVariance__SWIG_0QuantLib" ;;
let _BlackVolTermStructureHandle_blackForwardVariance arg = match _BlackVolTermStructureHandle_blackForwardVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackForwardVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackForwardVariance__SWIG_1QuantLib" ;;
let _BlackVolTermStructureHandle_blackForwardVariance arg = match _BlackVolTermStructureHandle_blackForwardVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackForwardVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackForwardVariance__SWIG_2QuantLib" ;;
let _BlackVolTermStructureHandle_blackForwardVariance arg = match _BlackVolTermStructureHandle_blackForwardVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_blackForwardVariance_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_blackForwardVarianceQuantLib" ;;
let _BlackVolTermStructureHandle_blackForwardVariance arg = match _BlackVolTermStructureHandle_blackForwardVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_enableExtrapolationQuantLib" ;;
let _BlackVolTermStructureHandle_enableExtrapolation arg = match _BlackVolTermStructureHandle_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_disableExtrapolationQuantLib" ;;
let _BlackVolTermStructureHandle_disableExtrapolation arg = match _BlackVolTermStructureHandle_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVolTermStructureHandle_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_BlackVolTermStructureHandle_allowsExtrapolationQuantLib" ;;
let _BlackVolTermStructureHandle_allowsExtrapolation arg = match _BlackVolTermStructureHandle_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableBlackVolTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableBlackVolTermStructureHandle__SWIG_0QuantLib" ;;
let _new_RelinkableBlackVolTermStructureHandle arg = match _new_RelinkableBlackVolTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableBlackVolTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableBlackVolTermStructureHandleQuantLib" ;;
let _new_RelinkableBlackVolTermStructureHandle arg = match _new_RelinkableBlackVolTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableBlackVolTermStructureHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableBlackVolTermStructureHandle_linkToQuantLib" ;;
let _RelinkableBlackVolTermStructureHandle_linkTo arg = match _RelinkableBlackVolTermStructureHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableBlackVolTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableBlackVolTermStructureHandleQuantLib" ;;
let _delete_RelinkableBlackVolTermStructureHandle arg = match _delete_RelinkableBlackVolTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure___deref___f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure___deref__QuantLib" ;;
let _LocalVolTermStructure___deref__ arg = match _LocalVolTermStructure___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_isNull_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_isNullQuantLib" ;;
let _LocalVolTermStructure_isNull arg = match _LocalVolTermStructure_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_asObservable_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_asObservableQuantLib" ;;
let _LocalVolTermStructure_asObservable arg = match _LocalVolTermStructure_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LocalVolTermStructure_f : c_obj list -> c_obj list = "_wrap_new_LocalVolTermStructureQuantLib" ;;
let _new_LocalVolTermStructure arg = match _new_LocalVolTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LocalVolTermStructure_f : c_obj list -> c_obj list = "_wrap_delete_LocalVolTermStructureQuantLib" ;;
let _delete_LocalVolTermStructure arg = match _delete_LocalVolTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_referenceDate_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_referenceDateQuantLib" ;;
let _LocalVolTermStructure_referenceDate arg = match _LocalVolTermStructure_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_dayCounter_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_dayCounterQuantLib" ;;
let _LocalVolTermStructure_dayCounter arg = match _LocalVolTermStructure_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_calendar_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_calendarQuantLib" ;;
let _LocalVolTermStructure_calendar arg = match _LocalVolTermStructure_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_maxDate_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_maxDateQuantLib" ;;
let _LocalVolTermStructure_maxDate arg = match _LocalVolTermStructure_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_maxTime_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_maxTimeQuantLib" ;;
let _LocalVolTermStructure_maxTime arg = match _LocalVolTermStructure_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_minStrike_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_minStrikeQuantLib" ;;
let _LocalVolTermStructure_minStrike arg = match _LocalVolTermStructure_minStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_maxStrike_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_maxStrikeQuantLib" ;;
let _LocalVolTermStructure_maxStrike arg = match _LocalVolTermStructure_maxStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_localVol_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_localVol__SWIG_0QuantLib" ;;
let _LocalVolTermStructure_localVol arg = match _LocalVolTermStructure_localVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_localVol_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_localVol__SWIG_1QuantLib" ;;
let _LocalVolTermStructure_localVol arg = match _LocalVolTermStructure_localVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_localVol_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_localVol__SWIG_2QuantLib" ;;
let _LocalVolTermStructure_localVol arg = match _LocalVolTermStructure_localVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_localVol_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_localVolQuantLib" ;;
let _LocalVolTermStructure_localVol arg = match _LocalVolTermStructure_localVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_enableExtrapolationQuantLib" ;;
let _LocalVolTermStructure_enableExtrapolation arg = match _LocalVolTermStructure_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_disableExtrapolationQuantLib" ;;
let _LocalVolTermStructure_disableExtrapolation arg = match _LocalVolTermStructure_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructure_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructure_allowsExtrapolationQuantLib" ;;
let _LocalVolTermStructure_allowsExtrapolation arg = match _LocalVolTermStructure_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LocalVolTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_LocalVolTermStructureHandle__SWIG_0QuantLib" ;;
let _new_LocalVolTermStructureHandle arg = match _new_LocalVolTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LocalVolTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_LocalVolTermStructureHandleQuantLib" ;;
let _new_LocalVolTermStructureHandle arg = match _new_LocalVolTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle___deref___f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle___deref__QuantLib" ;;
let _LocalVolTermStructureHandle___deref__ arg = match _LocalVolTermStructureHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_empty_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_emptyQuantLib" ;;
let _LocalVolTermStructureHandle_empty arg = match _LocalVolTermStructureHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_asObservableQuantLib" ;;
let _LocalVolTermStructureHandle_asObservable arg = match _LocalVolTermStructureHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LocalVolTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_LocalVolTermStructureHandleQuantLib" ;;
let _delete_LocalVolTermStructureHandle arg = match _delete_LocalVolTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_referenceDate_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_referenceDateQuantLib" ;;
let _LocalVolTermStructureHandle_referenceDate arg = match _LocalVolTermStructureHandle_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_dayCounter_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_dayCounterQuantLib" ;;
let _LocalVolTermStructureHandle_dayCounter arg = match _LocalVolTermStructureHandle_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_calendar_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_calendarQuantLib" ;;
let _LocalVolTermStructureHandle_calendar arg = match _LocalVolTermStructureHandle_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_maxDate_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_maxDateQuantLib" ;;
let _LocalVolTermStructureHandle_maxDate arg = match _LocalVolTermStructureHandle_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_maxTime_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_maxTimeQuantLib" ;;
let _LocalVolTermStructureHandle_maxTime arg = match _LocalVolTermStructureHandle_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_minStrike_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_minStrikeQuantLib" ;;
let _LocalVolTermStructureHandle_minStrike arg = match _LocalVolTermStructureHandle_minStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_maxStrike_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_maxStrikeQuantLib" ;;
let _LocalVolTermStructureHandle_maxStrike arg = match _LocalVolTermStructureHandle_maxStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_localVol_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_localVol__SWIG_0QuantLib" ;;
let _LocalVolTermStructureHandle_localVol arg = match _LocalVolTermStructureHandle_localVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_localVol_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_localVol__SWIG_1QuantLib" ;;
let _LocalVolTermStructureHandle_localVol arg = match _LocalVolTermStructureHandle_localVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_localVol_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_localVol__SWIG_2QuantLib" ;;
let _LocalVolTermStructureHandle_localVol arg = match _LocalVolTermStructureHandle_localVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_localVol_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_localVolQuantLib" ;;
let _LocalVolTermStructureHandle_localVol arg = match _LocalVolTermStructureHandle_localVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_enableExtrapolationQuantLib" ;;
let _LocalVolTermStructureHandle_enableExtrapolation arg = match _LocalVolTermStructureHandle_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_disableExtrapolationQuantLib" ;;
let _LocalVolTermStructureHandle_disableExtrapolation arg = match _LocalVolTermStructureHandle_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LocalVolTermStructureHandle_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_LocalVolTermStructureHandle_allowsExtrapolationQuantLib" ;;
let _LocalVolTermStructureHandle_allowsExtrapolation arg = match _LocalVolTermStructureHandle_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableLocalVolTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableLocalVolTermStructureHandle__SWIG_0QuantLib" ;;
let _new_RelinkableLocalVolTermStructureHandle arg = match _new_RelinkableLocalVolTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableLocalVolTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableLocalVolTermStructureHandleQuantLib" ;;
let _new_RelinkableLocalVolTermStructureHandle arg = match _new_RelinkableLocalVolTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableLocalVolTermStructureHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableLocalVolTermStructureHandle_linkToQuantLib" ;;
let _RelinkableLocalVolTermStructureHandle_linkTo arg = match _RelinkableLocalVolTermStructureHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableLocalVolTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableLocalVolTermStructureHandleQuantLib" ;;
let _delete_RelinkableLocalVolTermStructureHandle arg = match _delete_RelinkableLocalVolTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure___deref___f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure___deref__QuantLib" ;;
let _OptionletVolatilityStructure___deref__ arg = match _OptionletVolatilityStructure___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_isNull_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_isNullQuantLib" ;;
let _OptionletVolatilityStructure_isNull arg = match _OptionletVolatilityStructure_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_asObservable_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_asObservableQuantLib" ;;
let _OptionletVolatilityStructure_asObservable arg = match _OptionletVolatilityStructure_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OptionletVolatilityStructure_f : c_obj list -> c_obj list = "_wrap_new_OptionletVolatilityStructureQuantLib" ;;
let _new_OptionletVolatilityStructure arg = match _new_OptionletVolatilityStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_OptionletVolatilityStructure_f : c_obj list -> c_obj list = "_wrap_delete_OptionletVolatilityStructureQuantLib" ;;
let _delete_OptionletVolatilityStructure arg = match _delete_OptionletVolatilityStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_referenceDate_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_referenceDateQuantLib" ;;
let _OptionletVolatilityStructure_referenceDate arg = match _OptionletVolatilityStructure_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_dayCounter_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_dayCounterQuantLib" ;;
let _OptionletVolatilityStructure_dayCounter arg = match _OptionletVolatilityStructure_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_calendar_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_calendarQuantLib" ;;
let _OptionletVolatilityStructure_calendar arg = match _OptionletVolatilityStructure_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_maxDate_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_maxDateQuantLib" ;;
let _OptionletVolatilityStructure_maxDate arg = match _OptionletVolatilityStructure_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_maxTime_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_maxTimeQuantLib" ;;
let _OptionletVolatilityStructure_maxTime arg = match _OptionletVolatilityStructure_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_minStrike_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_minStrikeQuantLib" ;;
let _OptionletVolatilityStructure_minStrike arg = match _OptionletVolatilityStructure_minStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_maxStrike_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_maxStrikeQuantLib" ;;
let _OptionletVolatilityStructure_maxStrike arg = match _OptionletVolatilityStructure_maxStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_volatility__SWIG_0QuantLib" ;;
let _OptionletVolatilityStructure_volatility arg = match _OptionletVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_volatility__SWIG_1QuantLib" ;;
let _OptionletVolatilityStructure_volatility arg = match _OptionletVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_volatility__SWIG_2QuantLib" ;;
let _OptionletVolatilityStructure_volatility arg = match _OptionletVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_volatilityQuantLib" ;;
let _OptionletVolatilityStructure_volatility arg = match _OptionletVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_blackVariance_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_blackVariance__SWIG_0QuantLib" ;;
let _OptionletVolatilityStructure_blackVariance arg = match _OptionletVolatilityStructure_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_blackVariance_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_blackVariance__SWIG_1QuantLib" ;;
let _OptionletVolatilityStructure_blackVariance arg = match _OptionletVolatilityStructure_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_blackVariance_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_blackVariance__SWIG_2QuantLib" ;;
let _OptionletVolatilityStructure_blackVariance arg = match _OptionletVolatilityStructure_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_blackVariance_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_blackVarianceQuantLib" ;;
let _OptionletVolatilityStructure_blackVariance arg = match _OptionletVolatilityStructure_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_enableExtrapolationQuantLib" ;;
let _OptionletVolatilityStructure_enableExtrapolation arg = match _OptionletVolatilityStructure_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_disableExtrapolationQuantLib" ;;
let _OptionletVolatilityStructure_disableExtrapolation arg = match _OptionletVolatilityStructure_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructure_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructure_allowsExtrapolationQuantLib" ;;
let _OptionletVolatilityStructure_allowsExtrapolation arg = match _OptionletVolatilityStructure_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OptionletVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_OptionletVolatilityStructureHandle__SWIG_0QuantLib" ;;
let _new_OptionletVolatilityStructureHandle arg = match _new_OptionletVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OptionletVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_OptionletVolatilityStructureHandleQuantLib" ;;
let _new_OptionletVolatilityStructureHandle arg = match _new_OptionletVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle___deref___f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle___deref__QuantLib" ;;
let _OptionletVolatilityStructureHandle___deref__ arg = match _OptionletVolatilityStructureHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_empty_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_emptyQuantLib" ;;
let _OptionletVolatilityStructureHandle_empty arg = match _OptionletVolatilityStructureHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_asObservableQuantLib" ;;
let _OptionletVolatilityStructureHandle_asObservable arg = match _OptionletVolatilityStructureHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_OptionletVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_OptionletVolatilityStructureHandleQuantLib" ;;
let _delete_OptionletVolatilityStructureHandle arg = match _delete_OptionletVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_referenceDate_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_referenceDateQuantLib" ;;
let _OptionletVolatilityStructureHandle_referenceDate arg = match _OptionletVolatilityStructureHandle_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_dayCounter_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_dayCounterQuantLib" ;;
let _OptionletVolatilityStructureHandle_dayCounter arg = match _OptionletVolatilityStructureHandle_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_calendar_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_calendarQuantLib" ;;
let _OptionletVolatilityStructureHandle_calendar arg = match _OptionletVolatilityStructureHandle_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_maxDate_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_maxDateQuantLib" ;;
let _OptionletVolatilityStructureHandle_maxDate arg = match _OptionletVolatilityStructureHandle_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_maxTime_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_maxTimeQuantLib" ;;
let _OptionletVolatilityStructureHandle_maxTime arg = match _OptionletVolatilityStructureHandle_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_minStrike_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_minStrikeQuantLib" ;;
let _OptionletVolatilityStructureHandle_minStrike arg = match _OptionletVolatilityStructureHandle_minStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_maxStrike_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_maxStrikeQuantLib" ;;
let _OptionletVolatilityStructureHandle_maxStrike arg = match _OptionletVolatilityStructureHandle_maxStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_volatility__SWIG_0QuantLib" ;;
let _OptionletVolatilityStructureHandle_volatility arg = match _OptionletVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_volatility__SWIG_1QuantLib" ;;
let _OptionletVolatilityStructureHandle_volatility arg = match _OptionletVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_volatility__SWIG_2QuantLib" ;;
let _OptionletVolatilityStructureHandle_volatility arg = match _OptionletVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_volatilityQuantLib" ;;
let _OptionletVolatilityStructureHandle_volatility arg = match _OptionletVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_blackVariance_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_blackVariance__SWIG_0QuantLib" ;;
let _OptionletVolatilityStructureHandle_blackVariance arg = match _OptionletVolatilityStructureHandle_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_blackVariance_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_blackVariance__SWIG_1QuantLib" ;;
let _OptionletVolatilityStructureHandle_blackVariance arg = match _OptionletVolatilityStructureHandle_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_blackVariance_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_blackVariance__SWIG_2QuantLib" ;;
let _OptionletVolatilityStructureHandle_blackVariance arg = match _OptionletVolatilityStructureHandle_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_blackVariance_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_blackVarianceQuantLib" ;;
let _OptionletVolatilityStructureHandle_blackVariance arg = match _OptionletVolatilityStructureHandle_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_enableExtrapolationQuantLib" ;;
let _OptionletVolatilityStructureHandle_enableExtrapolation arg = match _OptionletVolatilityStructureHandle_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_disableExtrapolationQuantLib" ;;
let _OptionletVolatilityStructureHandle_disableExtrapolation arg = match _OptionletVolatilityStructureHandle_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletVolatilityStructureHandle_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_OptionletVolatilityStructureHandle_allowsExtrapolationQuantLib" ;;
let _OptionletVolatilityStructureHandle_allowsExtrapolation arg = match _OptionletVolatilityStructureHandle_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableOptionletVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableOptionletVolatilityStructureHandle__SWIG_0QuantLib" ;;
let _new_RelinkableOptionletVolatilityStructureHandle arg = match _new_RelinkableOptionletVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableOptionletVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableOptionletVolatilityStructureHandleQuantLib" ;;
let _new_RelinkableOptionletVolatilityStructureHandle arg = match _new_RelinkableOptionletVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableOptionletVolatilityStructureHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableOptionletVolatilityStructureHandle_linkToQuantLib" ;;
let _RelinkableOptionletVolatilityStructureHandle_linkTo arg = match _RelinkableOptionletVolatilityStructureHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableOptionletVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableOptionletVolatilityStructureHandleQuantLib" ;;
let _delete_RelinkableOptionletVolatilityStructureHandle arg = match _delete_RelinkableOptionletVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure___deref___f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure___deref__QuantLib" ;;
let _SwaptionVolatilityStructure___deref__ arg = match _SwaptionVolatilityStructure___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_isNull_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_isNullQuantLib" ;;
let _SwaptionVolatilityStructure_isNull arg = match _SwaptionVolatilityStructure_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_asObservable_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_asObservableQuantLib" ;;
let _SwaptionVolatilityStructure_asObservable arg = match _SwaptionVolatilityStructure_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityStructure_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityStructureQuantLib" ;;
let _new_SwaptionVolatilityStructure arg = match _new_SwaptionVolatilityStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SwaptionVolatilityStructure_f : c_obj list -> c_obj list = "_wrap_delete_SwaptionVolatilityStructureQuantLib" ;;
let _delete_SwaptionVolatilityStructure arg = match _delete_SwaptionVolatilityStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_referenceDate_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_referenceDateQuantLib" ;;
let _SwaptionVolatilityStructure_referenceDate arg = match _SwaptionVolatilityStructure_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_dayCounter_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_dayCounterQuantLib" ;;
let _SwaptionVolatilityStructure_dayCounter arg = match _SwaptionVolatilityStructure_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_calendar_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_calendarQuantLib" ;;
let _SwaptionVolatilityStructure_calendar arg = match _SwaptionVolatilityStructure_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_maxSwapTenor_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_maxSwapTenorQuantLib" ;;
let _SwaptionVolatilityStructure_maxSwapTenor arg = match _SwaptionVolatilityStructure_maxSwapTenor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_maxSwapLength_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_maxSwapLengthQuantLib" ;;
let _SwaptionVolatilityStructure_maxSwapLength arg = match _SwaptionVolatilityStructure_maxSwapLength_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_minStrike_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_minStrikeQuantLib" ;;
let _SwaptionVolatilityStructure_minStrike arg = match _SwaptionVolatilityStructure_minStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_maxStrike_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_maxStrikeQuantLib" ;;
let _SwaptionVolatilityStructure_maxStrike arg = match _SwaptionVolatilityStructure_maxStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_volatility__SWIG_0QuantLib" ;;
let _SwaptionVolatilityStructure_volatility arg = match _SwaptionVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_volatility__SWIG_1QuantLib" ;;
let _SwaptionVolatilityStructure_volatility arg = match _SwaptionVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_volatility__SWIG_2QuantLib" ;;
let _SwaptionVolatilityStructure_volatility arg = match _SwaptionVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_volatilityQuantLib" ;;
let _SwaptionVolatilityStructure_volatility arg = match _SwaptionVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_blackVariance_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_blackVariance__SWIG_0QuantLib" ;;
let _SwaptionVolatilityStructure_blackVariance arg = match _SwaptionVolatilityStructure_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_blackVariance_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_blackVariance__SWIG_1QuantLib" ;;
let _SwaptionVolatilityStructure_blackVariance arg = match _SwaptionVolatilityStructure_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_blackVariance_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_blackVariance__SWIG_2QuantLib" ;;
let _SwaptionVolatilityStructure_blackVariance arg = match _SwaptionVolatilityStructure_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_blackVariance_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_blackVarianceQuantLib" ;;
let _SwaptionVolatilityStructure_blackVariance arg = match _SwaptionVolatilityStructure_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_optionDateFromTenor_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_optionDateFromTenorQuantLib" ;;
let _SwaptionVolatilityStructure_optionDateFromTenor arg = match _SwaptionVolatilityStructure_optionDateFromTenor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_enableExtrapolationQuantLib" ;;
let _SwaptionVolatilityStructure_enableExtrapolation arg = match _SwaptionVolatilityStructure_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_disableExtrapolationQuantLib" ;;
let _SwaptionVolatilityStructure_disableExtrapolation arg = match _SwaptionVolatilityStructure_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructure_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructure_allowsExtrapolationQuantLib" ;;
let _SwaptionVolatilityStructure_allowsExtrapolation arg = match _SwaptionVolatilityStructure_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityStructureHandle__SWIG_0QuantLib" ;;
let _new_SwaptionVolatilityStructureHandle arg = match _new_SwaptionVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityStructureHandleQuantLib" ;;
let _new_SwaptionVolatilityStructureHandle arg = match _new_SwaptionVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle___deref___f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle___deref__QuantLib" ;;
let _SwaptionVolatilityStructureHandle___deref__ arg = match _SwaptionVolatilityStructureHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_empty_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_emptyQuantLib" ;;
let _SwaptionVolatilityStructureHandle_empty arg = match _SwaptionVolatilityStructureHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_asObservableQuantLib" ;;
let _SwaptionVolatilityStructureHandle_asObservable arg = match _SwaptionVolatilityStructureHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SwaptionVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_SwaptionVolatilityStructureHandleQuantLib" ;;
let _delete_SwaptionVolatilityStructureHandle arg = match _delete_SwaptionVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_referenceDate_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_referenceDateQuantLib" ;;
let _SwaptionVolatilityStructureHandle_referenceDate arg = match _SwaptionVolatilityStructureHandle_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_dayCounter_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_dayCounterQuantLib" ;;
let _SwaptionVolatilityStructureHandle_dayCounter arg = match _SwaptionVolatilityStructureHandle_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_calendar_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_calendarQuantLib" ;;
let _SwaptionVolatilityStructureHandle_calendar arg = match _SwaptionVolatilityStructureHandle_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_maxSwapTenor_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_maxSwapTenorQuantLib" ;;
let _SwaptionVolatilityStructureHandle_maxSwapTenor arg = match _SwaptionVolatilityStructureHandle_maxSwapTenor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_maxSwapLength_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_maxSwapLengthQuantLib" ;;
let _SwaptionVolatilityStructureHandle_maxSwapLength arg = match _SwaptionVolatilityStructureHandle_maxSwapLength_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_minStrike_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_minStrikeQuantLib" ;;
let _SwaptionVolatilityStructureHandle_minStrike arg = match _SwaptionVolatilityStructureHandle_minStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_maxStrike_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_maxStrikeQuantLib" ;;
let _SwaptionVolatilityStructureHandle_maxStrike arg = match _SwaptionVolatilityStructureHandle_maxStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_volatility__SWIG_0QuantLib" ;;
let _SwaptionVolatilityStructureHandle_volatility arg = match _SwaptionVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_volatility__SWIG_1QuantLib" ;;
let _SwaptionVolatilityStructureHandle_volatility arg = match _SwaptionVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_volatility__SWIG_2QuantLib" ;;
let _SwaptionVolatilityStructureHandle_volatility arg = match _SwaptionVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_volatilityQuantLib" ;;
let _SwaptionVolatilityStructureHandle_volatility arg = match _SwaptionVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_blackVariance_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_blackVariance__SWIG_0QuantLib" ;;
let _SwaptionVolatilityStructureHandle_blackVariance arg = match _SwaptionVolatilityStructureHandle_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_blackVariance_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_blackVariance__SWIG_1QuantLib" ;;
let _SwaptionVolatilityStructureHandle_blackVariance arg = match _SwaptionVolatilityStructureHandle_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_blackVariance_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_blackVariance__SWIG_2QuantLib" ;;
let _SwaptionVolatilityStructureHandle_blackVariance arg = match _SwaptionVolatilityStructureHandle_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_blackVariance_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_blackVarianceQuantLib" ;;
let _SwaptionVolatilityStructureHandle_blackVariance arg = match _SwaptionVolatilityStructureHandle_blackVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_optionDateFromTenor_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_optionDateFromTenorQuantLib" ;;
let _SwaptionVolatilityStructureHandle_optionDateFromTenor arg = match _SwaptionVolatilityStructureHandle_optionDateFromTenor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_enableExtrapolationQuantLib" ;;
let _SwaptionVolatilityStructureHandle_enableExtrapolation arg = match _SwaptionVolatilityStructureHandle_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_disableExtrapolationQuantLib" ;;
let _SwaptionVolatilityStructureHandle_disableExtrapolation arg = match _SwaptionVolatilityStructureHandle_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolatilityStructureHandle_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_SwaptionVolatilityStructureHandle_allowsExtrapolationQuantLib" ;;
let _SwaptionVolatilityStructureHandle_allowsExtrapolation arg = match _SwaptionVolatilityStructureHandle_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableSwaptionVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableSwaptionVolatilityStructureHandle__SWIG_0QuantLib" ;;
let _new_RelinkableSwaptionVolatilityStructureHandle arg = match _new_RelinkableSwaptionVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableSwaptionVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableSwaptionVolatilityStructureHandleQuantLib" ;;
let _new_RelinkableSwaptionVolatilityStructureHandle arg = match _new_RelinkableSwaptionVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableSwaptionVolatilityStructureHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableSwaptionVolatilityStructureHandle_linkToQuantLib" ;;
let _RelinkableSwaptionVolatilityStructureHandle_linkTo arg = match _RelinkableSwaptionVolatilityStructureHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableSwaptionVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableSwaptionVolatilityStructureHandleQuantLib" ;;
let _delete_RelinkableSwaptionVolatilityStructureHandle arg = match _delete_RelinkableSwaptionVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackConstantVol_f : c_obj list -> c_obj list = "_wrap_new_BlackConstantVol__SWIG_0QuantLib" ;;
let _new_BlackConstantVol arg = match _new_BlackConstantVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackConstantVol_f : c_obj list -> c_obj list = "_wrap_new_BlackConstantVol__SWIG_1QuantLib" ;;
let _new_BlackConstantVol arg = match _new_BlackConstantVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackConstantVol_f : c_obj list -> c_obj list = "_wrap_new_BlackConstantVol__SWIG_2QuantLib" ;;
let _new_BlackConstantVol arg = match _new_BlackConstantVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackConstantVol_f : c_obj list -> c_obj list = "_wrap_new_BlackConstantVolQuantLib" ;;
let _new_BlackConstantVol arg = match _new_BlackConstantVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackConstantVol_f : c_obj list -> c_obj list = "_wrap_delete_BlackConstantVolQuantLib" ;;
let _delete_BlackConstantVol arg = match _delete_BlackConstantVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackVarianceCurve_f : c_obj list -> c_obj list = "_wrap_new_BlackVarianceCurve__SWIG_0QuantLib" ;;
let _new_BlackVarianceCurve arg = match _new_BlackVarianceCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackVarianceCurve_f : c_obj list -> c_obj list = "_wrap_new_BlackVarianceCurveQuantLib" ;;
let _new_BlackVarianceCurve arg = match _new_BlackVarianceCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackVarianceCurve_f : c_obj list -> c_obj list = "_wrap_delete_BlackVarianceCurveQuantLib" ;;
let _delete_BlackVarianceCurve arg = match _delete_BlackVarianceCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackVarianceSurface_f : c_obj list -> c_obj list = "_wrap_new_BlackVarianceSurface__SWIG_0QuantLib" ;;
let _new_BlackVarianceSurface arg = match _new_BlackVarianceSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackVarianceSurface_f : c_obj list -> c_obj list = "_wrap_new_BlackVarianceSurface__SWIG_1QuantLib" ;;
let _new_BlackVarianceSurface arg = match _new_BlackVarianceSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackVarianceSurface_f : c_obj list -> c_obj list = "_wrap_new_BlackVarianceSurface__SWIG_2QuantLib" ;;
let _new_BlackVarianceSurface arg = match _new_BlackVarianceSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackVarianceSurface_f : c_obj list -> c_obj list = "_wrap_new_BlackVarianceSurfaceQuantLib" ;;
let _new_BlackVarianceSurface arg = match _new_BlackVarianceSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVarianceSurface_setInterpolation_f : c_obj list -> c_obj list = "_wrap_BlackVarianceSurface_setInterpolation__SWIG_0QuantLib" ;;
let _BlackVarianceSurface_setInterpolation arg = match _BlackVarianceSurface_setInterpolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVarianceSurface_setInterpolation_f : c_obj list -> c_obj list = "_wrap_BlackVarianceSurface_setInterpolationQuantLib" ;;
let _BlackVarianceSurface_setInterpolation arg = match _BlackVarianceSurface_setInterpolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackVarianceSurface_ConstantExtrapolation : c_obj -> Swig.c_obj = "_wrap_BlackVarianceSurface_ConstantExtrapolation" 
external _BlackVarianceSurface_InterpolatorDefaultExtrapolation : c_obj -> Swig.c_obj = "_wrap_BlackVarianceSurface_InterpolatorDefaultExtrapolation" 
external _delete_BlackVarianceSurface_f : c_obj list -> c_obj list = "_wrap_delete_BlackVarianceSurfaceQuantLib" ;;
let _delete_BlackVarianceSurface arg = match _delete_BlackVarianceSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LocalConstantVol_f : c_obj list -> c_obj list = "_wrap_new_LocalConstantVol__SWIG_0QuantLib" ;;
let _new_LocalConstantVol arg = match _new_LocalConstantVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LocalConstantVol_f : c_obj list -> c_obj list = "_wrap_new_LocalConstantVol__SWIG_1QuantLib" ;;
let _new_LocalConstantVol arg = match _new_LocalConstantVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LocalConstantVol_f : c_obj list -> c_obj list = "_wrap_new_LocalConstantVol__SWIG_2QuantLib" ;;
let _new_LocalConstantVol arg = match _new_LocalConstantVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LocalConstantVol_f : c_obj list -> c_obj list = "_wrap_new_LocalConstantVolQuantLib" ;;
let _new_LocalConstantVol arg = match _new_LocalConstantVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LocalConstantVol_f : c_obj list -> c_obj list = "_wrap_delete_LocalConstantVolQuantLib" ;;
let _delete_LocalConstantVol arg = match _delete_LocalConstantVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LocalVolSurface_f : c_obj list -> c_obj list = "_wrap_new_LocalVolSurface__SWIG_0QuantLib" ;;
let _new_LocalVolSurface arg = match _new_LocalVolSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LocalVolSurface_f : c_obj list -> c_obj list = "_wrap_new_LocalVolSurfaceQuantLib" ;;
let _new_LocalVolSurface arg = match _new_LocalVolSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LocalVolSurface_f : c_obj list -> c_obj list = "_wrap_delete_LocalVolSurfaceQuantLib" ;;
let _delete_LocalVolSurface arg = match _delete_LocalVolSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantOptionletVolatility__SWIG_0QuantLib" ;;
let _new_ConstantOptionletVolatility arg = match _new_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantOptionletVolatility__SWIG_1QuantLib" ;;
let _new_ConstantOptionletVolatility arg = match _new_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantOptionletVolatility__SWIG_2QuantLib" ;;
let _new_ConstantOptionletVolatility arg = match _new_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantOptionletVolatility__SWIG_3QuantLib" ;;
let _new_ConstantOptionletVolatility arg = match _new_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantOptionletVolatility__SWIG_4QuantLib" ;;
let _new_ConstantOptionletVolatility arg = match _new_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantOptionletVolatility__SWIG_5QuantLib" ;;
let _new_ConstantOptionletVolatility arg = match _new_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantOptionletVolatility__SWIG_6QuantLib" ;;
let _new_ConstantOptionletVolatility arg = match _new_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantOptionletVolatility__SWIG_7QuantLib" ;;
let _new_ConstantOptionletVolatility arg = match _new_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantOptionletVolatility__SWIG_8QuantLib" ;;
let _new_ConstantOptionletVolatility arg = match _new_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantOptionletVolatility__SWIG_9QuantLib" ;;
let _new_ConstantOptionletVolatility arg = match _new_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantOptionletVolatility__SWIG_10QuantLib" ;;
let _new_ConstantOptionletVolatility arg = match _new_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantOptionletVolatilityQuantLib" ;;
let _new_ConstantOptionletVolatility arg = match _new_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ConstantOptionletVolatility_f : c_obj list -> c_obj list = "_wrap_delete_ConstantOptionletVolatilityQuantLib" ;;
let _delete_ConstantOptionletVolatility arg = match _delete_ConstantOptionletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantSwaptionVolatility__SWIG_0QuantLib" ;;
let _new_ConstantSwaptionVolatility arg = match _new_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantSwaptionVolatility__SWIG_1QuantLib" ;;
let _new_ConstantSwaptionVolatility arg = match _new_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantSwaptionVolatility__SWIG_2QuantLib" ;;
let _new_ConstantSwaptionVolatility arg = match _new_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantSwaptionVolatility__SWIG_3QuantLib" ;;
let _new_ConstantSwaptionVolatility arg = match _new_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantSwaptionVolatility__SWIG_4QuantLib" ;;
let _new_ConstantSwaptionVolatility arg = match _new_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantSwaptionVolatility__SWIG_5QuantLib" ;;
let _new_ConstantSwaptionVolatility arg = match _new_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantSwaptionVolatility__SWIG_6QuantLib" ;;
let _new_ConstantSwaptionVolatility arg = match _new_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantSwaptionVolatility__SWIG_7QuantLib" ;;
let _new_ConstantSwaptionVolatility arg = match _new_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantSwaptionVolatility__SWIG_8QuantLib" ;;
let _new_ConstantSwaptionVolatility arg = match _new_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantSwaptionVolatility__SWIG_9QuantLib" ;;
let _new_ConstantSwaptionVolatility arg = match _new_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantSwaptionVolatility__SWIG_10QuantLib" ;;
let _new_ConstantSwaptionVolatility arg = match _new_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_new_ConstantSwaptionVolatilityQuantLib" ;;
let _new_ConstantSwaptionVolatility arg = match _new_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ConstantSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_delete_ConstantSwaptionVolatilityQuantLib" ;;
let _delete_ConstantSwaptionVolatility arg = match _delete_ConstantSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityMatrix__SWIG_0QuantLib" ;;
let _new_SwaptionVolatilityMatrix arg = match _new_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityMatrix__SWIG_1QuantLib" ;;
let _new_SwaptionVolatilityMatrix arg = match _new_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityMatrix__SWIG_2QuantLib" ;;
let _new_SwaptionVolatilityMatrix arg = match _new_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityMatrix__SWIG_3QuantLib" ;;
let _new_SwaptionVolatilityMatrix arg = match _new_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityMatrix__SWIG_4QuantLib" ;;
let _new_SwaptionVolatilityMatrix arg = match _new_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityMatrix__SWIG_5QuantLib" ;;
let _new_SwaptionVolatilityMatrix arg = match _new_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityMatrix__SWIG_6QuantLib" ;;
let _new_SwaptionVolatilityMatrix arg = match _new_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityMatrix__SWIG_7QuantLib" ;;
let _new_SwaptionVolatilityMatrix arg = match _new_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityMatrix__SWIG_8QuantLib" ;;
let _new_SwaptionVolatilityMatrix arg = match _new_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityMatrix__SWIG_9QuantLib" ;;
let _new_SwaptionVolatilityMatrix arg = match _new_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityMatrix__SWIG_10QuantLib" ;;
let _new_SwaptionVolatilityMatrix arg = match _new_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolatilityMatrixQuantLib" ;;
let _new_SwaptionVolatilityMatrix arg = match _new_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SwaptionVolatilityMatrix_f : c_obj list -> c_obj list = "_wrap_delete_SwaptionVolatilityMatrixQuantLib" ;;
let _delete_SwaptionVolatilityMatrix arg = match _delete_SwaptionVolatilityMatrix_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolCube1_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolCube1__SWIG_0QuantLib" ;;
let _new_SwaptionVolCube1 arg = match _new_SwaptionVolCube1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolCube1_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolCube1__SWIG_1QuantLib" ;;
let _new_SwaptionVolCube1 arg = match _new_SwaptionVolCube1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolCube1_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolCube1__SWIG_2QuantLib" ;;
let _new_SwaptionVolCube1 arg = match _new_SwaptionVolCube1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolCube1_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolCube1QuantLib" ;;
let _new_SwaptionVolCube1 arg = match _new_SwaptionVolCube1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolCube1_sparseSabrParameters_f : c_obj list -> c_obj list = "_wrap_SwaptionVolCube1_sparseSabrParametersQuantLib" ;;
let _SwaptionVolCube1_sparseSabrParameters arg = match _SwaptionVolCube1_sparseSabrParameters_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolCube1_denseSabrParameters_f : c_obj list -> c_obj list = "_wrap_SwaptionVolCube1_denseSabrParametersQuantLib" ;;
let _SwaptionVolCube1_denseSabrParameters arg = match _SwaptionVolCube1_denseSabrParameters_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolCube1_marketVolCube_f : c_obj list -> c_obj list = "_wrap_SwaptionVolCube1_marketVolCubeQuantLib" ;;
let _SwaptionVolCube1_marketVolCube arg = match _SwaptionVolCube1_marketVolCube_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionVolCube1_volCubeAtmCalibrated_f : c_obj list -> c_obj list = "_wrap_SwaptionVolCube1_volCubeAtmCalibratedQuantLib" ;;
let _SwaptionVolCube1_volCubeAtmCalibrated arg = match _SwaptionVolCube1_volCubeAtmCalibrated_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SwaptionVolCube1_f : c_obj list -> c_obj list = "_wrap_delete_SwaptionVolCube1QuantLib" ;;
let _delete_SwaptionVolCube1 arg = match _delete_SwaptionVolCube1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionVolCube2_f : c_obj list -> c_obj list = "_wrap_new_SwaptionVolCube2QuantLib" ;;
let _new_SwaptionVolCube2 arg = match _new_SwaptionVolCube2_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SwaptionVolCube2_f : c_obj list -> c_obj list = "_wrap_delete_SwaptionVolCube2QuantLib" ;;
let _delete_SwaptionVolCube2 arg = match _delete_SwaptionVolCube2_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess___deref___f : c_obj list -> c_obj list = "_wrap_StochasticProcess___deref__QuantLib" ;;
let _StochasticProcess___deref__ arg = match _StochasticProcess___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess_isNull_f : c_obj list -> c_obj list = "_wrap_StochasticProcess_isNullQuantLib" ;;
let _StochasticProcess_isNull arg = match _StochasticProcess_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess_asObservable_f : c_obj list -> c_obj list = "_wrap_StochasticProcess_asObservableQuantLib" ;;
let _StochasticProcess_asObservable arg = match _StochasticProcess_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StochasticProcess_f : c_obj list -> c_obj list = "_wrap_new_StochasticProcessQuantLib" ;;
let _new_StochasticProcess arg = match _new_StochasticProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_StochasticProcess_f : c_obj list -> c_obj list = "_wrap_delete_StochasticProcessQuantLib" ;;
let _delete_StochasticProcess arg = match _delete_StochasticProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess_size_f : c_obj list -> c_obj list = "_wrap_StochasticProcess_sizeQuantLib" ;;
let _StochasticProcess_size arg = match _StochasticProcess_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess_factors_f : c_obj list -> c_obj list = "_wrap_StochasticProcess_factorsQuantLib" ;;
let _StochasticProcess_factors arg = match _StochasticProcess_factors_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess_initialValues_f : c_obj list -> c_obj list = "_wrap_StochasticProcess_initialValuesQuantLib" ;;
let _StochasticProcess_initialValues arg = match _StochasticProcess_initialValues_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess_drift_f : c_obj list -> c_obj list = "_wrap_StochasticProcess_driftQuantLib" ;;
let _StochasticProcess_drift arg = match _StochasticProcess_drift_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess_diffusion_f : c_obj list -> c_obj list = "_wrap_StochasticProcess_diffusionQuantLib" ;;
let _StochasticProcess_diffusion arg = match _StochasticProcess_diffusion_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess_expectation_f : c_obj list -> c_obj list = "_wrap_StochasticProcess_expectationQuantLib" ;;
let _StochasticProcess_expectation arg = match _StochasticProcess_expectation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess_stdDeviation_f : c_obj list -> c_obj list = "_wrap_StochasticProcess_stdDeviationQuantLib" ;;
let _StochasticProcess_stdDeviation arg = match _StochasticProcess_stdDeviation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess_covariance_f : c_obj list -> c_obj list = "_wrap_StochasticProcess_covarianceQuantLib" ;;
let _StochasticProcess_covariance arg = match _StochasticProcess_covariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess_evolve_f : c_obj list -> c_obj list = "_wrap_StochasticProcess_evolveQuantLib" ;;
let _StochasticProcess_evolve arg = match _StochasticProcess_evolve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StochasticProcessVector_f : c_obj list -> c_obj list = "_wrap_new_StochasticProcessVector__SWIG_0QuantLib" ;;
let _new_StochasticProcessVector arg = match _new_StochasticProcessVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StochasticProcessVector_f : c_obj list -> c_obj list = "_wrap_new_StochasticProcessVector__SWIG_1QuantLib" ;;
let _new_StochasticProcessVector arg = match _new_StochasticProcessVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StochasticProcessVector_f : c_obj list -> c_obj list = "_wrap_new_StochasticProcessVector__SWIG_2QuantLib" ;;
let _new_StochasticProcessVector arg = match _new_StochasticProcessVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StochasticProcessVector_f : c_obj list -> c_obj list = "_wrap_new_StochasticProcessVectorQuantLib" ;;
let _new_StochasticProcessVector arg = match _new_StochasticProcessVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcessVector_size_f : c_obj list -> c_obj list = "_wrap_StochasticProcessVector_sizeQuantLib" ;;
let _StochasticProcessVector_size arg = match _StochasticProcessVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcessVector_empty_f : c_obj list -> c_obj list = "_wrap_StochasticProcessVector_emptyQuantLib" ;;
let _StochasticProcessVector_empty arg = match _StochasticProcessVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcessVector_clear_f : c_obj list -> c_obj list = "_wrap_StochasticProcessVector_clearQuantLib" ;;
let _StochasticProcessVector_clear arg = match _StochasticProcessVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcessVector_push_back_f : c_obj list -> c_obj list = "_wrap_StochasticProcessVector_push_backQuantLib" ;;
let _StochasticProcessVector_push_back arg = match _StochasticProcessVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcessVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_StochasticProcessVector_operator_bB___QuantLib" ;;
let _StochasticProcessVector_operator_xx_xx_lbrace_xx_rbrace arg = match _StochasticProcessVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcessVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_StochasticProcessVector_operator_e___QuantLib" ;;
let _StochasticProcessVector_operator_xx_xx_equals arg = match _StochasticProcessVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcessVector_set_f : c_obj list -> c_obj list = "_wrap_StochasticProcessVector_setQuantLib" ;;
let _StochasticProcessVector_set arg = match _StochasticProcessVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcessVector_to_array_f : c_obj list -> c_obj list = "_wrap_StochasticProcessVector_to_arrayQuantLib" ;;
let _StochasticProcessVector_to_array arg = match _StochasticProcessVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_StochasticProcessVector_f : c_obj list -> c_obj list = "_wrap_delete_StochasticProcessVectorQuantLib" ;;
let _delete_StochasticProcessVector arg = match _delete_StochasticProcessVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess1D_x0_f : c_obj list -> c_obj list = "_wrap_StochasticProcess1D_x0QuantLib" ;;
let _StochasticProcess1D_x0 arg = match _StochasticProcess1D_x0_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess1D_drift_f : c_obj list -> c_obj list = "_wrap_StochasticProcess1D_driftQuantLib" ;;
let _StochasticProcess1D_drift arg = match _StochasticProcess1D_drift_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess1D_diffusion_f : c_obj list -> c_obj list = "_wrap_StochasticProcess1D_diffusionQuantLib" ;;
let _StochasticProcess1D_diffusion arg = match _StochasticProcess1D_diffusion_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess1D_expectation_f : c_obj list -> c_obj list = "_wrap_StochasticProcess1D_expectationQuantLib" ;;
let _StochasticProcess1D_expectation arg = match _StochasticProcess1D_expectation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess1D_stdDeviation_f : c_obj list -> c_obj list = "_wrap_StochasticProcess1D_stdDeviationQuantLib" ;;
let _StochasticProcess1D_stdDeviation arg = match _StochasticProcess1D_stdDeviation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess1D_variance_f : c_obj list -> c_obj list = "_wrap_StochasticProcess1D_varianceQuantLib" ;;
let _StochasticProcess1D_variance arg = match _StochasticProcess1D_variance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess1D_evolve_f : c_obj list -> c_obj list = "_wrap_StochasticProcess1D_evolveQuantLib" ;;
let _StochasticProcess1D_evolve arg = match _StochasticProcess1D_evolve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StochasticProcess1D_apply_f : c_obj list -> c_obj list = "_wrap_StochasticProcess1D_applyQuantLib" ;;
let _StochasticProcess1D_apply arg = match _StochasticProcess1D_apply_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_StochasticProcess1D_f : c_obj list -> c_obj list = "_wrap_delete_StochasticProcess1DQuantLib" ;;
let _delete_StochasticProcess1D arg = match _delete_StochasticProcess1D_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GeneralizedBlackScholesProcess_f : c_obj list -> c_obj list = "_wrap_new_GeneralizedBlackScholesProcessQuantLib" ;;
let _new_GeneralizedBlackScholesProcess arg = match _new_GeneralizedBlackScholesProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GeneralizedBlackScholesProcess_stateVariable_f : c_obj list -> c_obj list = "_wrap_GeneralizedBlackScholesProcess_stateVariableQuantLib" ;;
let _GeneralizedBlackScholesProcess_stateVariable arg = match _GeneralizedBlackScholesProcess_stateVariable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GeneralizedBlackScholesProcess_dividendYield_f : c_obj list -> c_obj list = "_wrap_GeneralizedBlackScholesProcess_dividendYieldQuantLib" ;;
let _GeneralizedBlackScholesProcess_dividendYield arg = match _GeneralizedBlackScholesProcess_dividendYield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GeneralizedBlackScholesProcess_riskFreeRate_f : c_obj list -> c_obj list = "_wrap_GeneralizedBlackScholesProcess_riskFreeRateQuantLib" ;;
let _GeneralizedBlackScholesProcess_riskFreeRate arg = match _GeneralizedBlackScholesProcess_riskFreeRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GeneralizedBlackScholesProcess_blackVolatility_f : c_obj list -> c_obj list = "_wrap_GeneralizedBlackScholesProcess_blackVolatilityQuantLib" ;;
let _GeneralizedBlackScholesProcess_blackVolatility arg = match _GeneralizedBlackScholesProcess_blackVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GeneralizedBlackScholesProcess_f : c_obj list -> c_obj list = "_wrap_delete_GeneralizedBlackScholesProcessQuantLib" ;;
let _delete_GeneralizedBlackScholesProcess arg = match _delete_GeneralizedBlackScholesProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackScholesProcess_f : c_obj list -> c_obj list = "_wrap_new_BlackScholesProcessQuantLib" ;;
let _new_BlackScholesProcess arg = match _new_BlackScholesProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackScholesProcess_f : c_obj list -> c_obj list = "_wrap_delete_BlackScholesProcessQuantLib" ;;
let _delete_BlackScholesProcess arg = match _delete_BlackScholesProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackScholesMertonProcess_f : c_obj list -> c_obj list = "_wrap_new_BlackScholesMertonProcessQuantLib" ;;
let _new_BlackScholesMertonProcess arg = match _new_BlackScholesMertonProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackScholesMertonProcess_f : c_obj list -> c_obj list = "_wrap_delete_BlackScholesMertonProcessQuantLib" ;;
let _delete_BlackScholesMertonProcess arg = match _delete_BlackScholesMertonProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackProcess_f : c_obj list -> c_obj list = "_wrap_new_BlackProcessQuantLib" ;;
let _new_BlackProcess arg = match _new_BlackProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackProcess_f : c_obj list -> c_obj list = "_wrap_delete_BlackProcessQuantLib" ;;
let _delete_BlackProcess arg = match _delete_BlackProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GarmanKohlagenProcess_f : c_obj list -> c_obj list = "_wrap_new_GarmanKohlagenProcessQuantLib" ;;
let _new_GarmanKohlagenProcess arg = match _new_GarmanKohlagenProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GarmanKohlagenProcess_f : c_obj list -> c_obj list = "_wrap_delete_GarmanKohlagenProcessQuantLib" ;;
let _delete_GarmanKohlagenProcess arg = match _delete_GarmanKohlagenProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Merton76Process_f : c_obj list -> c_obj list = "_wrap_new_Merton76ProcessQuantLib" ;;
let _new_Merton76Process arg = match _new_Merton76Process_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Merton76Process_f : c_obj list -> c_obj list = "_wrap_delete_Merton76ProcessQuantLib" ;;
let _delete_Merton76Process arg = match _delete_Merton76Process_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StochasticProcessArray_f : c_obj list -> c_obj list = "_wrap_new_StochasticProcessArrayQuantLib" ;;
let _new_StochasticProcessArray arg = match _new_StochasticProcessArray_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_StochasticProcessArray_f : c_obj list -> c_obj list = "_wrap_delete_StochasticProcessArrayQuantLib" ;;
let _delete_StochasticProcessArray arg = match _delete_StochasticProcessArray_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GeometricBrownianMotionProcess_f : c_obj list -> c_obj list = "_wrap_new_GeometricBrownianMotionProcessQuantLib" ;;
let _new_GeometricBrownianMotionProcess arg = match _new_GeometricBrownianMotionProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GeometricBrownianMotionProcess_f : c_obj list -> c_obj list = "_wrap_delete_GeometricBrownianMotionProcessQuantLib" ;;
let _delete_GeometricBrownianMotionProcess arg = match _delete_GeometricBrownianMotionProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_VarianceGammaProcess_f : c_obj list -> c_obj list = "_wrap_new_VarianceGammaProcessQuantLib" ;;
let _new_VarianceGammaProcess arg = match _new_VarianceGammaProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_VarianceGammaProcess_f : c_obj list -> c_obj list = "_wrap_delete_VarianceGammaProcessQuantLib" ;;
let _delete_VarianceGammaProcess arg = match _delete_VarianceGammaProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HestonProcess_f : c_obj list -> c_obj list = "_wrap_new_HestonProcessQuantLib" ;;
let _new_HestonProcess arg = match _new_HestonProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HestonProcess_s0_f : c_obj list -> c_obj list = "_wrap_HestonProcess_s0QuantLib" ;;
let _HestonProcess_s0 arg = match _HestonProcess_s0_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HestonProcess_dividendYield_f : c_obj list -> c_obj list = "_wrap_HestonProcess_dividendYieldQuantLib" ;;
let _HestonProcess_dividendYield arg = match _HestonProcess_dividendYield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HestonProcess_riskFreeRate_f : c_obj list -> c_obj list = "_wrap_HestonProcess_riskFreeRateQuantLib" ;;
let _HestonProcess_riskFreeRate arg = match _HestonProcess_riskFreeRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HestonProcess_f : c_obj list -> c_obj list = "_wrap_delete_HestonProcessQuantLib" ;;
let _delete_HestonProcess arg = match _delete_HestonProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BatesProcess_f : c_obj list -> c_obj list = "_wrap_new_BatesProcessQuantLib" ;;
let _new_BatesProcess arg = match _new_BatesProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BatesProcess_f : c_obj list -> c_obj list = "_wrap_delete_BatesProcessQuantLib" ;;
let _delete_BatesProcess arg = match _delete_BatesProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HullWhiteProcess_f : c_obj list -> c_obj list = "_wrap_new_HullWhiteProcessQuantLib" ;;
let _new_HullWhiteProcess arg = match _new_HullWhiteProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HullWhiteProcess_f : c_obj list -> c_obj list = "_wrap_delete_HullWhiteProcessQuantLib" ;;
let _delete_HullWhiteProcess arg = match _delete_HullWhiteProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HullWhiteForwardProcess_f : c_obj list -> c_obj list = "_wrap_new_HullWhiteForwardProcessQuantLib" ;;
let _new_HullWhiteForwardProcess arg = match _new_HullWhiteForwardProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HullWhiteForwardProcess_alpha_f : c_obj list -> c_obj list = "_wrap_HullWhiteForwardProcess_alphaQuantLib" ;;
let _HullWhiteForwardProcess_alpha arg = match _HullWhiteForwardProcess_alpha_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HullWhiteForwardProcess_M_T_f : c_obj list -> c_obj list = "_wrap_HullWhiteForwardProcess_M_TQuantLib" ;;
let _HullWhiteForwardProcess_M_T arg = match _HullWhiteForwardProcess_M_T_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HullWhiteForwardProcess_B_f : c_obj list -> c_obj list = "_wrap_HullWhiteForwardProcess_BQuantLib" ;;
let _HullWhiteForwardProcess_B arg = match _HullWhiteForwardProcess_B_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HullWhiteForwardProcess_setForwardMeasureTime_f : c_obj list -> c_obj list = "_wrap_HullWhiteForwardProcess_setForwardMeasureTimeQuantLib" ;;
let _HullWhiteForwardProcess_setForwardMeasureTime arg = match _HullWhiteForwardProcess_setForwardMeasureTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HullWhiteForwardProcess_f : c_obj list -> c_obj list = "_wrap_delete_HullWhiteForwardProcessQuantLib" ;;
let _delete_HullWhiteForwardProcess arg = match _delete_HullWhiteForwardProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GsrProcess_f : c_obj list -> c_obj list = "_wrap_new_GsrProcess__SWIG_0QuantLib" ;;
let _new_GsrProcess arg = match _new_GsrProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GsrProcess_f : c_obj list -> c_obj list = "_wrap_new_GsrProcessQuantLib" ;;
let _new_GsrProcess arg = match _new_GsrProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GsrProcess_sigma_f : c_obj list -> c_obj list = "_wrap_GsrProcess_sigmaQuantLib" ;;
let _GsrProcess_sigma arg = match _GsrProcess_sigma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GsrProcess_reversion_f : c_obj list -> c_obj list = "_wrap_GsrProcess_reversionQuantLib" ;;
let _GsrProcess_reversion arg = match _GsrProcess_reversion_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GsrProcess_y_f : c_obj list -> c_obj list = "_wrap_GsrProcess_yQuantLib" ;;
let _GsrProcess_y arg = match _GsrProcess_y_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GsrProcess_G_f : c_obj list -> c_obj list = "_wrap_GsrProcess_GQuantLib" ;;
let _GsrProcess_G arg = match _GsrProcess_G_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GsrProcess_setForwardMeasureTime_f : c_obj list -> c_obj list = "_wrap_GsrProcess_setForwardMeasureTimeQuantLib" ;;
let _GsrProcess_setForwardMeasureTime arg = match _GsrProcess_setForwardMeasureTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GsrProcess_f : c_obj list -> c_obj list = "_wrap_delete_GsrProcessQuantLib" ;;
let _delete_GsrProcess arg = match _delete_GsrProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _as_gsr_process_f : c_obj list -> c_obj list = "_wrap_as_gsr_processQuantLib" ;;
let _as_gsr_process arg = match _as_gsr_process_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PricingEngine___deref___f : c_obj list -> c_obj list = "_wrap_PricingEngine___deref__QuantLib" ;;
let _PricingEngine___deref__ arg = match _PricingEngine___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PricingEngine_isNull_f : c_obj list -> c_obj list = "_wrap_PricingEngine_isNullQuantLib" ;;
let _PricingEngine_isNull arg = match _PricingEngine_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PricingEngine_f : c_obj list -> c_obj list = "_wrap_new_PricingEngineQuantLib" ;;
let _new_PricingEngine arg = match _new_PricingEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PricingEngine_f : c_obj list -> c_obj list = "_wrap_delete_PricingEngineQuantLib" ;;
let _delete_PricingEngine arg = match _delete_PricingEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Instrument___deref___f : c_obj list -> c_obj list = "_wrap_Instrument___deref__QuantLib" ;;
let _Instrument___deref__ arg = match _Instrument___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Instrument_isNull_f : c_obj list -> c_obj list = "_wrap_Instrument_isNullQuantLib" ;;
let _Instrument_isNull arg = match _Instrument_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Instrument_asObservable_f : c_obj list -> c_obj list = "_wrap_Instrument_asObservableQuantLib" ;;
let _Instrument_asObservable arg = match _Instrument_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Instrument_f : c_obj list -> c_obj list = "_wrap_new_InstrumentQuantLib" ;;
let _new_Instrument arg = match _new_Instrument_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Instrument_f : c_obj list -> c_obj list = "_wrap_delete_InstrumentQuantLib" ;;
let _delete_Instrument arg = match _delete_Instrument_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Instrument_NPV_f : c_obj list -> c_obj list = "_wrap_Instrument_NPVQuantLib" ;;
let _Instrument_NPV arg = match _Instrument_NPV_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Instrument_errorEstimate_f : c_obj list -> c_obj list = "_wrap_Instrument_errorEstimateQuantLib" ;;
let _Instrument_errorEstimate arg = match _Instrument_errorEstimate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Instrument_isExpired_f : c_obj list -> c_obj list = "_wrap_Instrument_isExpiredQuantLib" ;;
let _Instrument_isExpired arg = match _Instrument_isExpired_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Instrument_setPricingEngine_f : c_obj list -> c_obj list = "_wrap_Instrument_setPricingEngineQuantLib" ;;
let _Instrument_setPricingEngine arg = match _Instrument_setPricingEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Instrument_recalculate_f : c_obj list -> c_obj list = "_wrap_Instrument_recalculateQuantLib" ;;
let _Instrument_recalculate arg = match _Instrument_recalculate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Instrument_freeze_f : c_obj list -> c_obj list = "_wrap_Instrument_freezeQuantLib" ;;
let _Instrument_freeze arg = match _Instrument_freeze_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Instrument_unfreeze_f : c_obj list -> c_obj list = "_wrap_Instrument_unfreezeQuantLib" ;;
let _Instrument_unfreeze arg = match _Instrument_unfreeze_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InstrumentVector_f : c_obj list -> c_obj list = "_wrap_new_InstrumentVector__SWIG_0QuantLib" ;;
let _new_InstrumentVector arg = match _new_InstrumentVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InstrumentVector_f : c_obj list -> c_obj list = "_wrap_new_InstrumentVector__SWIG_1QuantLib" ;;
let _new_InstrumentVector arg = match _new_InstrumentVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InstrumentVector_f : c_obj list -> c_obj list = "_wrap_new_InstrumentVector__SWIG_2QuantLib" ;;
let _new_InstrumentVector arg = match _new_InstrumentVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InstrumentVector_f : c_obj list -> c_obj list = "_wrap_new_InstrumentVectorQuantLib" ;;
let _new_InstrumentVector arg = match _new_InstrumentVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InstrumentVector_size_f : c_obj list -> c_obj list = "_wrap_InstrumentVector_sizeQuantLib" ;;
let _InstrumentVector_size arg = match _InstrumentVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InstrumentVector_empty_f : c_obj list -> c_obj list = "_wrap_InstrumentVector_emptyQuantLib" ;;
let _InstrumentVector_empty arg = match _InstrumentVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InstrumentVector_clear_f : c_obj list -> c_obj list = "_wrap_InstrumentVector_clearQuantLib" ;;
let _InstrumentVector_clear arg = match _InstrumentVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InstrumentVector_push_back_f : c_obj list -> c_obj list = "_wrap_InstrumentVector_push_backQuantLib" ;;
let _InstrumentVector_push_back arg = match _InstrumentVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InstrumentVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_InstrumentVector_operator_bB___QuantLib" ;;
let _InstrumentVector_operator_xx_xx_lbrace_xx_rbrace arg = match _InstrumentVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InstrumentVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_InstrumentVector_operator_e___QuantLib" ;;
let _InstrumentVector_operator_xx_xx_equals arg = match _InstrumentVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InstrumentVector_set_f : c_obj list -> c_obj list = "_wrap_InstrumentVector_setQuantLib" ;;
let _InstrumentVector_set arg = match _InstrumentVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InstrumentVector_to_array_f : c_obj list -> c_obj list = "_wrap_InstrumentVector_to_arrayQuantLib" ;;
let _InstrumentVector_to_array arg = match _InstrumentVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InstrumentVector_f : c_obj list -> c_obj list = "_wrap_delete_InstrumentVectorQuantLib" ;;
let _delete_InstrumentVector arg = match _delete_InstrumentVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Stock_f : c_obj list -> c_obj list = "_wrap_new_StockQuantLib" ;;
let _new_Stock arg = match _new_Stock_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Stock_f : c_obj list -> c_obj list = "_wrap_delete_StockQuantLib" ;;
let _delete_Stock arg = match _delete_Stock_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CompositeInstrument_f : c_obj list -> c_obj list = "_wrap_new_CompositeInstrumentQuantLib" ;;
let _new_CompositeInstrument arg = match _new_CompositeInstrument_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CompositeInstrument_add_f : c_obj list -> c_obj list = "_wrap_CompositeInstrument_add__SWIG_0QuantLib" ;;
let _CompositeInstrument_add arg = match _CompositeInstrument_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CompositeInstrument_add_f : c_obj list -> c_obj list = "_wrap_CompositeInstrument_addQuantLib" ;;
let _CompositeInstrument_add arg = match _CompositeInstrument_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CompositeInstrument_subtract_f : c_obj list -> c_obj list = "_wrap_CompositeInstrument_subtract__SWIG_0QuantLib" ;;
let _CompositeInstrument_subtract arg = match _CompositeInstrument_subtract_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CompositeInstrument_subtract_f : c_obj list -> c_obj list = "_wrap_CompositeInstrument_subtractQuantLib" ;;
let _CompositeInstrument_subtract arg = match _CompositeInstrument_subtract_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CompositeInstrument_f : c_obj list -> c_obj list = "_wrap_delete_CompositeInstrumentQuantLib" ;;
let _delete_CompositeInstrument arg = match _delete_CompositeInstrument_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "DateGeneration::Rule_marker" (`Rule)
external _Backward : c_obj -> Swig.c_obj = "_wrap_Backward" 
external _Forward : c_obj -> Swig.c_obj = "_wrap_Forward" 
external _Zero : c_obj -> Swig.c_obj = "_wrap_Zero" 
external _ThirdWednesday : c_obj -> Swig.c_obj = "_wrap_ThirdWednesday" 
external _Twentieth : c_obj -> Swig.c_obj = "_wrap_Twentieth" 
external _TwentiethIMM : c_obj -> Swig.c_obj = "_wrap_TwentiethIMM" 
external _OldCDS : c_obj -> Swig.c_obj = "_wrap_OldCDS" 
external _CDS : c_obj -> Swig.c_obj = "_wrap_CDS" 
external _CDS2015 : c_obj -> Swig.c_obj = "_wrap_CDS2015" 
external _new_DateGeneration_f : c_obj list -> c_obj list = "_wrap_new_DateGenerationQuantLib" ;;
let _new_DateGeneration arg = match _new_DateGeneration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DateGeneration_f : c_obj list -> c_obj list = "_wrap_delete_DateGenerationQuantLib" ;;
let _delete_DateGeneration arg = match _delete_DateGeneration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Schedule_f : c_obj list -> c_obj list = "_wrap_new_Schedule__SWIG_0QuantLib" ;;
let _new_Schedule arg = match _new_Schedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Schedule_f : c_obj list -> c_obj list = "_wrap_new_Schedule__SWIG_1QuantLib" ;;
let _new_Schedule arg = match _new_Schedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Schedule_f : c_obj list -> c_obj list = "_wrap_new_Schedule__SWIG_2QuantLib" ;;
let _new_Schedule arg = match _new_Schedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Schedule_f : c_obj list -> c_obj list = "_wrap_new_Schedule__SWIG_3QuantLib" ;;
let _new_Schedule arg = match _new_Schedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Schedule_f : c_obj list -> c_obj list = "_wrap_new_Schedule__SWIG_4QuantLib" ;;
let _new_Schedule arg = match _new_Schedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Schedule_f : c_obj list -> c_obj list = "_wrap_new_Schedule__SWIG_5QuantLib" ;;
let _new_Schedule arg = match _new_Schedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Schedule_f : c_obj list -> c_obj list = "_wrap_new_ScheduleQuantLib" ;;
let _new_Schedule arg = match _new_Schedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Schedule_size_f : c_obj list -> c_obj list = "_wrap_Schedule_sizeQuantLib" ;;
let _Schedule_size arg = match _Schedule_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Schedule_date_f : c_obj list -> c_obj list = "_wrap_Schedule_dateQuantLib" ;;
let _Schedule_date arg = match _Schedule_date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Schedule_isRegular_f : c_obj list -> c_obj list = "_wrap_Schedule_isRegularQuantLib" ;;
let _Schedule_isRegular arg = match _Schedule_isRegular_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Schedule_until_f : c_obj list -> c_obj list = "_wrap_Schedule_untilQuantLib" ;;
let _Schedule_until arg = match _Schedule_until_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Schedule_f : c_obj list -> c_obj list = "_wrap_delete_ScheduleQuantLib" ;;
let _delete_Schedule arg = match _delete_Schedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlow___deref___f : c_obj list -> c_obj list = "_wrap_CashFlow___deref__QuantLib" ;;
let _CashFlow___deref__ arg = match _CashFlow___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlow_isNull_f : c_obj list -> c_obj list = "_wrap_CashFlow_isNullQuantLib" ;;
let _CashFlow_isNull arg = match _CashFlow_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlow_asObservable_f : c_obj list -> c_obj list = "_wrap_CashFlow_asObservableQuantLib" ;;
let _CashFlow_asObservable arg = match _CashFlow_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CashFlow_f : c_obj list -> c_obj list = "_wrap_new_CashFlowQuantLib" ;;
let _new_CashFlow arg = match _new_CashFlow_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CashFlow_f : c_obj list -> c_obj list = "_wrap_delete_CashFlowQuantLib" ;;
let _delete_CashFlow arg = match _delete_CashFlow_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlow_amount_f : c_obj list -> c_obj list = "_wrap_CashFlow_amountQuantLib" ;;
let _CashFlow_amount arg = match _CashFlow_amount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlow_date_f : c_obj list -> c_obj list = "_wrap_CashFlow_dateQuantLib" ;;
let _CashFlow_date arg = match _CashFlow_date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Leg_f : c_obj list -> c_obj list = "_wrap_new_Leg__SWIG_0QuantLib" ;;
let _new_Leg arg = match _new_Leg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Leg_f : c_obj list -> c_obj list = "_wrap_new_Leg__SWIG_1QuantLib" ;;
let _new_Leg arg = match _new_Leg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Leg_f : c_obj list -> c_obj list = "_wrap_new_Leg__SWIG_2QuantLib" ;;
let _new_Leg arg = match _new_Leg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Leg_f : c_obj list -> c_obj list = "_wrap_new_LegQuantLib" ;;
let _new_Leg arg = match _new_Leg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Leg_size_f : c_obj list -> c_obj list = "_wrap_Leg_sizeQuantLib" ;;
let _Leg_size arg = match _Leg_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Leg_empty_f : c_obj list -> c_obj list = "_wrap_Leg_emptyQuantLib" ;;
let _Leg_empty arg = match _Leg_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Leg_clear_f : c_obj list -> c_obj list = "_wrap_Leg_clearQuantLib" ;;
let _Leg_clear arg = match _Leg_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Leg_push_back_f : c_obj list -> c_obj list = "_wrap_Leg_push_backQuantLib" ;;
let _Leg_push_back arg = match _Leg_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Leg_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_Leg_operator_bB___QuantLib" ;;
let _Leg_operator_xx_xx_lbrace_xx_rbrace arg = match _Leg_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Leg_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_Leg_operator_e___QuantLib" ;;
let _Leg_operator_xx_xx_equals arg = match _Leg_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Leg_set_f : c_obj list -> c_obj list = "_wrap_Leg_setQuantLib" ;;
let _Leg_set arg = match _Leg_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Leg_to_array_f : c_obj list -> c_obj list = "_wrap_Leg_to_arrayQuantLib" ;;
let _Leg_to_array arg = match _Leg_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Leg_f : c_obj list -> c_obj list = "_wrap_delete_LegQuantLib" ;;
let _delete_Leg arg = match _delete_Leg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SimpleCashFlow_f : c_obj list -> c_obj list = "_wrap_new_SimpleCashFlowQuantLib" ;;
let _new_SimpleCashFlow arg = match _new_SimpleCashFlow_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SimpleCashFlow_f : c_obj list -> c_obj list = "_wrap_delete_SimpleCashFlowQuantLib" ;;
let _delete_SimpleCashFlow arg = match _delete_SimpleCashFlow_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Redemption_f : c_obj list -> c_obj list = "_wrap_new_RedemptionQuantLib" ;;
let _new_Redemption arg = match _new_Redemption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Redemption_f : c_obj list -> c_obj list = "_wrap_delete_RedemptionQuantLib" ;;
let _delete_Redemption arg = match _delete_Redemption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AmortizingPayment_f : c_obj list -> c_obj list = "_wrap_new_AmortizingPaymentQuantLib" ;;
let _new_AmortizingPayment arg = match _new_AmortizingPayment_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AmortizingPayment_f : c_obj list -> c_obj list = "_wrap_delete_AmortizingPaymentQuantLib" ;;
let _delete_AmortizingPayment arg = match _delete_AmortizingPayment_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Coupon_nominal_f : c_obj list -> c_obj list = "_wrap_Coupon_nominalQuantLib" ;;
let _Coupon_nominal arg = match _Coupon_nominal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Coupon_accrualStartDate_f : c_obj list -> c_obj list = "_wrap_Coupon_accrualStartDateQuantLib" ;;
let _Coupon_accrualStartDate arg = match _Coupon_accrualStartDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Coupon_accrualEndDate_f : c_obj list -> c_obj list = "_wrap_Coupon_accrualEndDateQuantLib" ;;
let _Coupon_accrualEndDate arg = match _Coupon_accrualEndDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Coupon_referencePeriodStart_f : c_obj list -> c_obj list = "_wrap_Coupon_referencePeriodStartQuantLib" ;;
let _Coupon_referencePeriodStart arg = match _Coupon_referencePeriodStart_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Coupon_referencePeriodEnd_f : c_obj list -> c_obj list = "_wrap_Coupon_referencePeriodEndQuantLib" ;;
let _Coupon_referencePeriodEnd arg = match _Coupon_referencePeriodEnd_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Coupon_exCouponDate_f : c_obj list -> c_obj list = "_wrap_Coupon_exCouponDateQuantLib" ;;
let _Coupon_exCouponDate arg = match _Coupon_exCouponDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Coupon_rate_f : c_obj list -> c_obj list = "_wrap_Coupon_rateQuantLib" ;;
let _Coupon_rate arg = match _Coupon_rate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Coupon_accrualPeriod_f : c_obj list -> c_obj list = "_wrap_Coupon_accrualPeriodQuantLib" ;;
let _Coupon_accrualPeriod arg = match _Coupon_accrualPeriod_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Coupon_accrualDays_f : c_obj list -> c_obj list = "_wrap_Coupon_accrualDaysQuantLib" ;;
let _Coupon_accrualDays arg = match _Coupon_accrualDays_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Coupon_dayCounter_f : c_obj list -> c_obj list = "_wrap_Coupon_dayCounterQuantLib" ;;
let _Coupon_dayCounter arg = match _Coupon_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Coupon_accruedAmount_f : c_obj list -> c_obj list = "_wrap_Coupon_accruedAmountQuantLib" ;;
let _Coupon_accruedAmount arg = match _Coupon_accruedAmount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Coupon_f : c_obj list -> c_obj list = "_wrap_delete_CouponQuantLib" ;;
let _delete_Coupon arg = match _delete_Coupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _as_coupon_f : c_obj list -> c_obj list = "_wrap_as_couponQuantLib" ;;
let _as_coupon arg = match _as_coupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateCoupon_f : c_obj list -> c_obj list = "_wrap_new_FixedRateCoupon__SWIG_0QuantLib" ;;
let _new_FixedRateCoupon arg = match _new_FixedRateCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateCoupon_f : c_obj list -> c_obj list = "_wrap_new_FixedRateCoupon__SWIG_1QuantLib" ;;
let _new_FixedRateCoupon arg = match _new_FixedRateCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateCoupon_f : c_obj list -> c_obj list = "_wrap_new_FixedRateCoupon__SWIG_2QuantLib" ;;
let _new_FixedRateCoupon arg = match _new_FixedRateCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateCoupon_f : c_obj list -> c_obj list = "_wrap_new_FixedRateCouponQuantLib" ;;
let _new_FixedRateCoupon arg = match _new_FixedRateCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FixedRateCoupon_interestRate_f : c_obj list -> c_obj list = "_wrap_FixedRateCoupon_interestRateQuantLib" ;;
let _FixedRateCoupon_interestRate arg = match _FixedRateCoupon_interestRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FixedRateCoupon_f : c_obj list -> c_obj list = "_wrap_delete_FixedRateCouponQuantLib" ;;
let _delete_FixedRateCoupon arg = match _delete_FixedRateCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _as_fixed_rate_coupon_f : c_obj list -> c_obj list = "_wrap_as_fixed_rate_couponQuantLib" ;;
let _as_fixed_rate_coupon arg = match _as_fixed_rate_coupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCouponPricer___deref___f : c_obj list -> c_obj list = "_wrap_FloatingRateCouponPricer___deref__QuantLib" ;;
let _FloatingRateCouponPricer___deref__ arg = match _FloatingRateCouponPricer___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCouponPricer_isNull_f : c_obj list -> c_obj list = "_wrap_FloatingRateCouponPricer_isNullQuantLib" ;;
let _FloatingRateCouponPricer_isNull arg = match _FloatingRateCouponPricer_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatingRateCouponPricer_f : c_obj list -> c_obj list = "_wrap_new_FloatingRateCouponPricerQuantLib" ;;
let _new_FloatingRateCouponPricer arg = match _new_FloatingRateCouponPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FloatingRateCouponPricer_f : c_obj list -> c_obj list = "_wrap_delete_FloatingRateCouponPricerQuantLib" ;;
let _delete_FloatingRateCouponPricer arg = match _delete_FloatingRateCouponPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _setCouponPricer_f : c_obj list -> c_obj list = "_wrap_setCouponPricerQuantLib" ;;
let _setCouponPricer arg = match _setCouponPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCoupon_fixingDate_f : c_obj list -> c_obj list = "_wrap_FloatingRateCoupon_fixingDateQuantLib" ;;
let _FloatingRateCoupon_fixingDate arg = match _FloatingRateCoupon_fixingDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCoupon_fixingDays_f : c_obj list -> c_obj list = "_wrap_FloatingRateCoupon_fixingDaysQuantLib" ;;
let _FloatingRateCoupon_fixingDays arg = match _FloatingRateCoupon_fixingDays_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCoupon_isInArrears_f : c_obj list -> c_obj list = "_wrap_FloatingRateCoupon_isInArrearsQuantLib" ;;
let _FloatingRateCoupon_isInArrears arg = match _FloatingRateCoupon_isInArrears_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCoupon_gearing_f : c_obj list -> c_obj list = "_wrap_FloatingRateCoupon_gearingQuantLib" ;;
let _FloatingRateCoupon_gearing arg = match _FloatingRateCoupon_gearing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCoupon_spread_f : c_obj list -> c_obj list = "_wrap_FloatingRateCoupon_spreadQuantLib" ;;
let _FloatingRateCoupon_spread arg = match _FloatingRateCoupon_spread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCoupon_indexFixing_f : c_obj list -> c_obj list = "_wrap_FloatingRateCoupon_indexFixingQuantLib" ;;
let _FloatingRateCoupon_indexFixing arg = match _FloatingRateCoupon_indexFixing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCoupon_adjustedFixing_f : c_obj list -> c_obj list = "_wrap_FloatingRateCoupon_adjustedFixingQuantLib" ;;
let _FloatingRateCoupon_adjustedFixing arg = match _FloatingRateCoupon_adjustedFixing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCoupon_convexityAdjustment_f : c_obj list -> c_obj list = "_wrap_FloatingRateCoupon_convexityAdjustmentQuantLib" ;;
let _FloatingRateCoupon_convexityAdjustment arg = match _FloatingRateCoupon_convexityAdjustment_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCoupon_price_f : c_obj list -> c_obj list = "_wrap_FloatingRateCoupon_priceQuantLib" ;;
let _FloatingRateCoupon_price arg = match _FloatingRateCoupon_price_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCoupon_index_f : c_obj list -> c_obj list = "_wrap_FloatingRateCoupon_indexQuantLib" ;;
let _FloatingRateCoupon_index arg = match _FloatingRateCoupon_index_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatingRateCoupon_setPricer_f : c_obj list -> c_obj list = "_wrap_FloatingRateCoupon_setPricerQuantLib" ;;
let _FloatingRateCoupon_setPricer arg = match _FloatingRateCoupon_setPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FloatingRateCoupon_f : c_obj list -> c_obj list = "_wrap_delete_FloatingRateCouponQuantLib" ;;
let _delete_FloatingRateCoupon arg = match _delete_FloatingRateCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _as_floating_rate_coupon_f : c_obj list -> c_obj list = "_wrap_as_floating_rate_couponQuantLib" ;;
let _as_floating_rate_coupon arg = match _as_floating_rate_coupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CappedFlooredCoupon_f : c_obj list -> c_obj list = "_wrap_new_CappedFlooredCoupon__SWIG_0QuantLib" ;;
let _new_CappedFlooredCoupon arg = match _new_CappedFlooredCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CappedFlooredCoupon_f : c_obj list -> c_obj list = "_wrap_new_CappedFlooredCoupon__SWIG_1QuantLib" ;;
let _new_CappedFlooredCoupon arg = match _new_CappedFlooredCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CappedFlooredCoupon_f : c_obj list -> c_obj list = "_wrap_new_CappedFlooredCouponQuantLib" ;;
let _new_CappedFlooredCoupon arg = match _new_CappedFlooredCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CappedFlooredCoupon_cap_f : c_obj list -> c_obj list = "_wrap_CappedFlooredCoupon_capQuantLib" ;;
let _CappedFlooredCoupon_cap arg = match _CappedFlooredCoupon_cap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CappedFlooredCoupon_floor_f : c_obj list -> c_obj list = "_wrap_CappedFlooredCoupon_floorQuantLib" ;;
let _CappedFlooredCoupon_floor arg = match _CappedFlooredCoupon_floor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CappedFlooredCoupon_effectiveCap_f : c_obj list -> c_obj list = "_wrap_CappedFlooredCoupon_effectiveCapQuantLib" ;;
let _CappedFlooredCoupon_effectiveCap arg = match _CappedFlooredCoupon_effectiveCap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CappedFlooredCoupon_effectiveFloor_f : c_obj list -> c_obj list = "_wrap_CappedFlooredCoupon_effectiveFloorQuantLib" ;;
let _CappedFlooredCoupon_effectiveFloor arg = match _CappedFlooredCoupon_effectiveFloor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CappedFlooredCoupon_isCapped_f : c_obj list -> c_obj list = "_wrap_CappedFlooredCoupon_isCappedQuantLib" ;;
let _CappedFlooredCoupon_isCapped arg = match _CappedFlooredCoupon_isCapped_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CappedFlooredCoupon_isFloored_f : c_obj list -> c_obj list = "_wrap_CappedFlooredCoupon_isFlooredQuantLib" ;;
let _CappedFlooredCoupon_isFloored arg = match _CappedFlooredCoupon_isFloored_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CappedFlooredCoupon_setPricer_f : c_obj list -> c_obj list = "_wrap_CappedFlooredCoupon_setPricerQuantLib" ;;
let _CappedFlooredCoupon_setPricer arg = match _CappedFlooredCoupon_setPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CappedFlooredCoupon_f : c_obj list -> c_obj list = "_wrap_delete_CappedFlooredCouponQuantLib" ;;
let _delete_CappedFlooredCoupon arg = match _delete_CappedFlooredCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IborCoupon_f : c_obj list -> c_obj list = "_wrap_new_IborCoupon__SWIG_0QuantLib" ;;
let _new_IborCoupon arg = match _new_IborCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IborCoupon_f : c_obj list -> c_obj list = "_wrap_new_IborCoupon__SWIG_1QuantLib" ;;
let _new_IborCoupon arg = match _new_IborCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IborCoupon_f : c_obj list -> c_obj list = "_wrap_new_IborCoupon__SWIG_2QuantLib" ;;
let _new_IborCoupon arg = match _new_IborCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IborCoupon_f : c_obj list -> c_obj list = "_wrap_new_IborCoupon__SWIG_3QuantLib" ;;
let _new_IborCoupon arg = match _new_IborCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IborCoupon_f : c_obj list -> c_obj list = "_wrap_new_IborCoupon__SWIG_4QuantLib" ;;
let _new_IborCoupon arg = match _new_IborCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IborCoupon_f : c_obj list -> c_obj list = "_wrap_new_IborCouponQuantLib" ;;
let _new_IborCoupon arg = match _new_IborCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IborCoupon_f : c_obj list -> c_obj list = "_wrap_delete_IborCouponQuantLib" ;;
let _delete_IborCoupon arg = match _delete_IborCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborCouponPricer_capletVolatility_f : c_obj list -> c_obj list = "_wrap_IborCouponPricer_capletVolatilityQuantLib" ;;
let _IborCouponPricer_capletVolatility arg = match _IborCouponPricer_capletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborCouponPricer_setCapletVolatility_f : c_obj list -> c_obj list = "_wrap_IborCouponPricer_setCapletVolatility__SWIG_0QuantLib" ;;
let _IborCouponPricer_setCapletVolatility arg = match _IborCouponPricer_setCapletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborCouponPricer_setCapletVolatility_f : c_obj list -> c_obj list = "_wrap_IborCouponPricer_setCapletVolatilityQuantLib" ;;
let _IborCouponPricer_setCapletVolatility arg = match _IborCouponPricer_setCapletVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IborCouponPricer_f : c_obj list -> c_obj list = "_wrap_delete_IborCouponPricerQuantLib" ;;
let _delete_IborCouponPricer arg = match _delete_IborCouponPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackIborCouponPricer_f : c_obj list -> c_obj list = "_wrap_new_BlackIborCouponPricer__SWIG_0QuantLib" ;;
let _new_BlackIborCouponPricer arg = match _new_BlackIborCouponPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackIborCouponPricer_f : c_obj list -> c_obj list = "_wrap_new_BlackIborCouponPricerQuantLib" ;;
let _new_BlackIborCouponPricer arg = match _new_BlackIborCouponPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackIborCouponPricer_f : c_obj list -> c_obj list = "_wrap_delete_BlackIborCouponPricerQuantLib" ;;
let _delete_BlackIborCouponPricer arg = match _delete_BlackIborCouponPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CmsCoupon__SWIG_0QuantLib" ;;
let _new_CmsCoupon arg = match _new_CmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CmsCoupon__SWIG_1QuantLib" ;;
let _new_CmsCoupon arg = match _new_CmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CmsCoupon__SWIG_2QuantLib" ;;
let _new_CmsCoupon arg = match _new_CmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CmsCoupon__SWIG_3QuantLib" ;;
let _new_CmsCoupon arg = match _new_CmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CmsCoupon__SWIG_4QuantLib" ;;
let _new_CmsCoupon arg = match _new_CmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CmsCoupon__SWIG_5QuantLib" ;;
let _new_CmsCoupon arg = match _new_CmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CmsCouponQuantLib" ;;
let _new_CmsCoupon arg = match _new_CmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CmsCoupon_f : c_obj list -> c_obj list = "_wrap_delete_CmsCouponQuantLib" ;;
let _delete_CmsCoupon arg = match _delete_CmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsCouponPricer_swaptionVolatility_f : c_obj list -> c_obj list = "_wrap_CmsCouponPricer_swaptionVolatilityQuantLib" ;;
let _CmsCouponPricer_swaptionVolatility arg = match _CmsCouponPricer_swaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsCouponPricer_setSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_CmsCouponPricer_setSwaptionVolatility__SWIG_0QuantLib" ;;
let _CmsCouponPricer_setSwaptionVolatility arg = match _CmsCouponPricer_setSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsCouponPricer_setSwaptionVolatility_f : c_obj list -> c_obj list = "_wrap_CmsCouponPricer_setSwaptionVolatilityQuantLib" ;;
let _CmsCouponPricer_setSwaptionVolatility arg = match _CmsCouponPricer_setSwaptionVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CmsCouponPricer_f : c_obj list -> c_obj list = "_wrap_delete_CmsCouponPricerQuantLib" ;;
let _delete_CmsCouponPricer arg = match _delete_CmsCouponPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "GFunctionFactory::YieldCurveModel_marker" (`YieldCurveModel)
external _ExactYield : c_obj -> Swig.c_obj = "_wrap_ExactYield" 
external _ParallelShifts : c_obj -> Swig.c_obj = "_wrap_ParallelShifts" 
external _NonParallelShifts : c_obj -> Swig.c_obj = "_wrap_NonParallelShifts" 
external _delete_GFunctionFactory_f : c_obj list -> c_obj list = "_wrap_delete_GFunctionFactoryQuantLib" ;;
let _delete_GFunctionFactory arg = match _delete_GFunctionFactory_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticHaganPricer_f : c_obj list -> c_obj list = "_wrap_new_AnalyticHaganPricerQuantLib" ;;
let _new_AnalyticHaganPricer arg = match _new_AnalyticHaganPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticHaganPricer_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticHaganPricerQuantLib" ;;
let _delete_AnalyticHaganPricer arg = match _delete_AnalyticHaganPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NumericHaganPricer_f : c_obj list -> c_obj list = "_wrap_new_NumericHaganPricer__SWIG_0QuantLib" ;;
let _new_NumericHaganPricer arg = match _new_NumericHaganPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NumericHaganPricer_f : c_obj list -> c_obj list = "_wrap_new_NumericHaganPricer__SWIG_1QuantLib" ;;
let _new_NumericHaganPricer arg = match _new_NumericHaganPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NumericHaganPricer_f : c_obj list -> c_obj list = "_wrap_new_NumericHaganPricer__SWIG_2QuantLib" ;;
let _new_NumericHaganPricer arg = match _new_NumericHaganPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NumericHaganPricer_f : c_obj list -> c_obj list = "_wrap_new_NumericHaganPricerQuantLib" ;;
let _new_NumericHaganPricer arg = match _new_NumericHaganPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NumericHaganPricer_f : c_obj list -> c_obj list = "_wrap_delete_NumericHaganPricerQuantLib" ;;
let _delete_NumericHaganPricer arg = match _delete_NumericHaganPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CappedFlooredCmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CappedFlooredCmsCoupon__SWIG_0QuantLib" ;;
let _new_CappedFlooredCmsCoupon arg = match _new_CappedFlooredCmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CappedFlooredCmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CappedFlooredCmsCoupon__SWIG_1QuantLib" ;;
let _new_CappedFlooredCmsCoupon arg = match _new_CappedFlooredCmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CappedFlooredCmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CappedFlooredCmsCoupon__SWIG_2QuantLib" ;;
let _new_CappedFlooredCmsCoupon arg = match _new_CappedFlooredCmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CappedFlooredCmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CappedFlooredCmsCoupon__SWIG_3QuantLib" ;;
let _new_CappedFlooredCmsCoupon arg = match _new_CappedFlooredCmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CappedFlooredCmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CappedFlooredCmsCoupon__SWIG_4QuantLib" ;;
let _new_CappedFlooredCmsCoupon arg = match _new_CappedFlooredCmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CappedFlooredCmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CappedFlooredCmsCoupon__SWIG_5QuantLib" ;;
let _new_CappedFlooredCmsCoupon arg = match _new_CappedFlooredCmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CappedFlooredCmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CappedFlooredCmsCoupon__SWIG_6QuantLib" ;;
let _new_CappedFlooredCmsCoupon arg = match _new_CappedFlooredCmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CappedFlooredCmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CappedFlooredCmsCoupon__SWIG_7QuantLib" ;;
let _new_CappedFlooredCmsCoupon arg = match _new_CappedFlooredCmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CappedFlooredCmsCoupon_f : c_obj list -> c_obj list = "_wrap_new_CappedFlooredCmsCouponQuantLib" ;;
let _new_CappedFlooredCmsCoupon arg = match _new_CappedFlooredCmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CappedFlooredCmsCoupon_f : c_obj list -> c_obj list = "_wrap_delete_CappedFlooredCmsCouponQuantLib" ;;
let _delete_CappedFlooredCmsCoupon arg = match _delete_CappedFlooredCmsCoupon_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LinearTsrPricer_f : c_obj list -> c_obj list = "_wrap_new_LinearTsrPricer__SWIG_0QuantLib" ;;
let _new_LinearTsrPricer arg = match _new_LinearTsrPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LinearTsrPricer_f : c_obj list -> c_obj list = "_wrap_new_LinearTsrPricer__SWIG_1QuantLib" ;;
let _new_LinearTsrPricer arg = match _new_LinearTsrPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LinearTsrPricer_f : c_obj list -> c_obj list = "_wrap_new_LinearTsrPricerQuantLib" ;;
let _new_LinearTsrPricer arg = match _new_LinearTsrPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LinearTsrPricer_f : c_obj list -> c_obj list = "_wrap_delete_LinearTsrPricerQuantLib" ;;
let _delete_LinearTsrPricer arg = match _delete_LinearTsrPricer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FixedRateLeg_f : c_obj list -> c_obj list = "_wrap_FixedRateLeg__SWIG_0QuantLib" ;;
let _FixedRateLeg arg = match _FixedRateLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FixedRateLeg_f : c_obj list -> c_obj list = "_wrap_FixedRateLeg__SWIG_1QuantLib" ;;
let _FixedRateLeg arg = match _FixedRateLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FixedRateLeg_f : c_obj list -> c_obj list = "_wrap_FixedRateLegQuantLib" ;;
let _FixedRateLeg arg = match _FixedRateLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborLeg_f : c_obj list -> c_obj list = "_wrap_IborLeg__SWIG_0QuantLib" ;;
let _IborLeg arg = match _IborLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborLeg_f : c_obj list -> c_obj list = "_wrap_IborLeg__SWIG_1QuantLib" ;;
let _IborLeg arg = match _IborLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborLeg_f : c_obj list -> c_obj list = "_wrap_IborLeg__SWIG_2QuantLib" ;;
let _IborLeg arg = match _IborLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborLeg_f : c_obj list -> c_obj list = "_wrap_IborLeg__SWIG_3QuantLib" ;;
let _IborLeg arg = match _IborLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborLeg_f : c_obj list -> c_obj list = "_wrap_IborLeg__SWIG_4QuantLib" ;;
let _IborLeg arg = match _IborLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborLeg_f : c_obj list -> c_obj list = "_wrap_IborLeg__SWIG_5QuantLib" ;;
let _IborLeg arg = match _IborLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborLeg_f : c_obj list -> c_obj list = "_wrap_IborLeg__SWIG_6QuantLib" ;;
let _IborLeg arg = match _IborLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborLeg_f : c_obj list -> c_obj list = "_wrap_IborLeg__SWIG_7QuantLib" ;;
let _IborLeg arg = match _IborLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IborLeg_f : c_obj list -> c_obj list = "_wrap_IborLegQuantLib" ;;
let _IborLeg arg = match _IborLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsLeg_f : c_obj list -> c_obj list = "_wrap_CmsLeg__SWIG_0QuantLib" ;;
let _CmsLeg arg = match _CmsLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsLeg_f : c_obj list -> c_obj list = "_wrap_CmsLeg__SWIG_1QuantLib" ;;
let _CmsLeg arg = match _CmsLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsLeg_f : c_obj list -> c_obj list = "_wrap_CmsLeg__SWIG_2QuantLib" ;;
let _CmsLeg arg = match _CmsLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsLeg_f : c_obj list -> c_obj list = "_wrap_CmsLeg__SWIG_3QuantLib" ;;
let _CmsLeg arg = match _CmsLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsLeg_f : c_obj list -> c_obj list = "_wrap_CmsLeg__SWIG_4QuantLib" ;;
let _CmsLeg arg = match _CmsLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsLeg_f : c_obj list -> c_obj list = "_wrap_CmsLeg__SWIG_5QuantLib" ;;
let _CmsLeg arg = match _CmsLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsLeg_f : c_obj list -> c_obj list = "_wrap_CmsLeg__SWIG_6QuantLib" ;;
let _CmsLeg arg = match _CmsLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsLeg_f : c_obj list -> c_obj list = "_wrap_CmsLeg__SWIG_7QuantLib" ;;
let _CmsLeg arg = match _CmsLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsLeg_f : c_obj list -> c_obj list = "_wrap_CmsLegQuantLib" ;;
let _CmsLeg arg = match _CmsLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsZeroLeg_f : c_obj list -> c_obj list = "_wrap_CmsZeroLeg__SWIG_0QuantLib" ;;
let _CmsZeroLeg arg = match _CmsZeroLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsZeroLeg_f : c_obj list -> c_obj list = "_wrap_CmsZeroLeg__SWIG_1QuantLib" ;;
let _CmsZeroLeg arg = match _CmsZeroLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsZeroLeg_f : c_obj list -> c_obj list = "_wrap_CmsZeroLeg__SWIG_2QuantLib" ;;
let _CmsZeroLeg arg = match _CmsZeroLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsZeroLeg_f : c_obj list -> c_obj list = "_wrap_CmsZeroLeg__SWIG_3QuantLib" ;;
let _CmsZeroLeg arg = match _CmsZeroLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsZeroLeg_f : c_obj list -> c_obj list = "_wrap_CmsZeroLeg__SWIG_4QuantLib" ;;
let _CmsZeroLeg arg = match _CmsZeroLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsZeroLeg_f : c_obj list -> c_obj list = "_wrap_CmsZeroLeg__SWIG_5QuantLib" ;;
let _CmsZeroLeg arg = match _CmsZeroLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsZeroLeg_f : c_obj list -> c_obj list = "_wrap_CmsZeroLeg__SWIG_6QuantLib" ;;
let _CmsZeroLeg arg = match _CmsZeroLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CmsZeroLeg_f : c_obj list -> c_obj list = "_wrap_CmsZeroLegQuantLib" ;;
let _CmsZeroLeg arg = match _CmsZeroLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "Duration::Type_marker" (`Type)
external _Macaulay : c_obj -> Swig.c_obj = "_wrap_Macaulay" 
external _Modified : c_obj -> Swig.c_obj = "_wrap_Modified" 
external _new_Duration_f : c_obj list -> c_obj list = "_wrap_new_DurationQuantLib" ;;
let _new_Duration arg = match _new_Duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Duration_f : c_obj list -> c_obj list = "_wrap_delete_DurationQuantLib" ;;
let _delete_Duration arg = match _delete_Duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_startDate_f : c_obj list -> c_obj list = "_wrap_CashFlows_startDateQuantLib" ;;
let _CashFlows_startDate arg = match _CashFlows_startDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_maturityDate_f : c_obj list -> c_obj list = "_wrap_CashFlows_maturityDateQuantLib" ;;
let _CashFlows_maturityDate arg = match _CashFlows_maturityDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_npv_f : c_obj list -> c_obj list = "_wrap_CashFlows_npv__SWIG_0QuantLib" ;;
let _CashFlows_npv arg = match _CashFlows_npv_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_npv_f : c_obj list -> c_obj list = "_wrap_CashFlows_npv__SWIG_1QuantLib" ;;
let _CashFlows_npv arg = match _CashFlows_npv_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_npv_f : c_obj list -> c_obj list = "_wrap_CashFlows_npv__SWIG_2QuantLib" ;;
let _CashFlows_npv arg = match _CashFlows_npv_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_npv_f : c_obj list -> c_obj list = "_wrap_CashFlows_npv__SWIG_3QuantLib" ;;
let _CashFlows_npv arg = match _CashFlows_npv_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_npv_f : c_obj list -> c_obj list = "_wrap_CashFlows_npv__SWIG_4QuantLib" ;;
let _CashFlows_npv arg = match _CashFlows_npv_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_npv_f : c_obj list -> c_obj list = "_wrap_CashFlows_npv__SWIG_5QuantLib" ;;
let _CashFlows_npv arg = match _CashFlows_npv_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_npv_f : c_obj list -> c_obj list = "_wrap_CashFlows_npv__SWIG_6QuantLib" ;;
let _CashFlows_npv arg = match _CashFlows_npv_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_npv_f : c_obj list -> c_obj list = "_wrap_CashFlows_npv__SWIG_7QuantLib" ;;
let _CashFlows_npv arg = match _CashFlows_npv_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_npv_f : c_obj list -> c_obj list = "_wrap_CashFlows_npv__SWIG_8QuantLib" ;;
let _CashFlows_npv arg = match _CashFlows_npv_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_npv_f : c_obj list -> c_obj list = "_wrap_CashFlows_npv__SWIG_9QuantLib" ;;
let _CashFlows_npv arg = match _CashFlows_npv_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_npv_f : c_obj list -> c_obj list = "_wrap_CashFlows_npv__SWIG_10QuantLib" ;;
let _CashFlows_npv arg = match _CashFlows_npv_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_npv_f : c_obj list -> c_obj list = "_wrap_CashFlows_npvQuantLib" ;;
let _CashFlows_npv arg = match _CashFlows_npv_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_bps_f : c_obj list -> c_obj list = "_wrap_CashFlows_bps__SWIG_0QuantLib" ;;
let _CashFlows_bps arg = match _CashFlows_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_bps_f : c_obj list -> c_obj list = "_wrap_CashFlows_bps__SWIG_1QuantLib" ;;
let _CashFlows_bps arg = match _CashFlows_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_bps_f : c_obj list -> c_obj list = "_wrap_CashFlows_bps__SWIG_2QuantLib" ;;
let _CashFlows_bps arg = match _CashFlows_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_bps_f : c_obj list -> c_obj list = "_wrap_CashFlows_bps__SWIG_3QuantLib" ;;
let _CashFlows_bps arg = match _CashFlows_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_bps_f : c_obj list -> c_obj list = "_wrap_CashFlows_bps__SWIG_4QuantLib" ;;
let _CashFlows_bps arg = match _CashFlows_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_bps_f : c_obj list -> c_obj list = "_wrap_CashFlows_bps__SWIG_5QuantLib" ;;
let _CashFlows_bps arg = match _CashFlows_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_bps_f : c_obj list -> c_obj list = "_wrap_CashFlows_bps__SWIG_6QuantLib" ;;
let _CashFlows_bps arg = match _CashFlows_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_bps_f : c_obj list -> c_obj list = "_wrap_CashFlows_bps__SWIG_7QuantLib" ;;
let _CashFlows_bps arg = match _CashFlows_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_bps_f : c_obj list -> c_obj list = "_wrap_CashFlows_bps__SWIG_8QuantLib" ;;
let _CashFlows_bps arg = match _CashFlows_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_bps_f : c_obj list -> c_obj list = "_wrap_CashFlows_bps__SWIG_9QuantLib" ;;
let _CashFlows_bps arg = match _CashFlows_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_bps_f : c_obj list -> c_obj list = "_wrap_CashFlows_bps__SWIG_10QuantLib" ;;
let _CashFlows_bps arg = match _CashFlows_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_bps_f : c_obj list -> c_obj list = "_wrap_CashFlows_bpsQuantLib" ;;
let _CashFlows_bps arg = match _CashFlows_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_atmRate_f : c_obj list -> c_obj list = "_wrap_CashFlows_atmRate__SWIG_0QuantLib" ;;
let _CashFlows_atmRate arg = match _CashFlows_atmRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_atmRate_f : c_obj list -> c_obj list = "_wrap_CashFlows_atmRate__SWIG_1QuantLib" ;;
let _CashFlows_atmRate arg = match _CashFlows_atmRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_atmRate_f : c_obj list -> c_obj list = "_wrap_CashFlows_atmRate__SWIG_2QuantLib" ;;
let _CashFlows_atmRate arg = match _CashFlows_atmRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_atmRate_f : c_obj list -> c_obj list = "_wrap_CashFlows_atmRateQuantLib" ;;
let _CashFlows_atmRate arg = match _CashFlows_atmRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_yield_f : c_obj list -> c_obj list = "_wrap_CashFlows_yield__SWIG_0QuantLib" ;;
let _CashFlows_yield arg = match _CashFlows_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_yield_f : c_obj list -> c_obj list = "_wrap_CashFlows_yield__SWIG_1QuantLib" ;;
let _CashFlows_yield arg = match _CashFlows_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_yield_f : c_obj list -> c_obj list = "_wrap_CashFlows_yield__SWIG_2QuantLib" ;;
let _CashFlows_yield arg = match _CashFlows_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_yield_f : c_obj list -> c_obj list = "_wrap_CashFlows_yield__SWIG_3QuantLib" ;;
let _CashFlows_yield arg = match _CashFlows_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_yield_f : c_obj list -> c_obj list = "_wrap_CashFlows_yield__SWIG_4QuantLib" ;;
let _CashFlows_yield arg = match _CashFlows_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_yield_f : c_obj list -> c_obj list = "_wrap_CashFlows_yieldQuantLib" ;;
let _CashFlows_yield arg = match _CashFlows_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_duration_f : c_obj list -> c_obj list = "_wrap_CashFlows_duration__SWIG_0QuantLib" ;;
let _CashFlows_duration arg = match _CashFlows_duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_duration_f : c_obj list -> c_obj list = "_wrap_CashFlows_duration__SWIG_1QuantLib" ;;
let _CashFlows_duration arg = match _CashFlows_duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_duration_f : c_obj list -> c_obj list = "_wrap_CashFlows_duration__SWIG_2QuantLib" ;;
let _CashFlows_duration arg = match _CashFlows_duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_duration_f : c_obj list -> c_obj list = "_wrap_CashFlows_duration__SWIG_3QuantLib" ;;
let _CashFlows_duration arg = match _CashFlows_duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_duration_f : c_obj list -> c_obj list = "_wrap_CashFlows_durationQuantLib" ;;
let _CashFlows_duration arg = match _CashFlows_duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_convexity_f : c_obj list -> c_obj list = "_wrap_CashFlows_convexity__SWIG_0QuantLib" ;;
let _CashFlows_convexity arg = match _CashFlows_convexity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_convexity_f : c_obj list -> c_obj list = "_wrap_CashFlows_convexity__SWIG_1QuantLib" ;;
let _CashFlows_convexity arg = match _CashFlows_convexity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_convexity_f : c_obj list -> c_obj list = "_wrap_CashFlows_convexity__SWIG_2QuantLib" ;;
let _CashFlows_convexity arg = match _CashFlows_convexity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_convexity_f : c_obj list -> c_obj list = "_wrap_CashFlows_convexity__SWIG_3QuantLib" ;;
let _CashFlows_convexity arg = match _CashFlows_convexity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_convexity_f : c_obj list -> c_obj list = "_wrap_CashFlows_convexity__SWIG_4QuantLib" ;;
let _CashFlows_convexity arg = match _CashFlows_convexity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_convexity_f : c_obj list -> c_obj list = "_wrap_CashFlows_convexityQuantLib" ;;
let _CashFlows_convexity arg = match _CashFlows_convexity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_basisPointValue_f : c_obj list -> c_obj list = "_wrap_CashFlows_basisPointValue__SWIG_0QuantLib" ;;
let _CashFlows_basisPointValue arg = match _CashFlows_basisPointValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_basisPointValue_f : c_obj list -> c_obj list = "_wrap_CashFlows_basisPointValue__SWIG_1QuantLib" ;;
let _CashFlows_basisPointValue arg = match _CashFlows_basisPointValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_basisPointValue_f : c_obj list -> c_obj list = "_wrap_CashFlows_basisPointValue__SWIG_2QuantLib" ;;
let _CashFlows_basisPointValue arg = match _CashFlows_basisPointValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_basisPointValue_f : c_obj list -> c_obj list = "_wrap_CashFlows_basisPointValue__SWIG_3QuantLib" ;;
let _CashFlows_basisPointValue arg = match _CashFlows_basisPointValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_basisPointValue_f : c_obj list -> c_obj list = "_wrap_CashFlows_basisPointValue__SWIG_4QuantLib" ;;
let _CashFlows_basisPointValue arg = match _CashFlows_basisPointValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_basisPointValue_f : c_obj list -> c_obj list = "_wrap_CashFlows_basisPointValueQuantLib" ;;
let _CashFlows_basisPointValue arg = match _CashFlows_basisPointValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_zSpread_f : c_obj list -> c_obj list = "_wrap_CashFlows_zSpread__SWIG_0QuantLib" ;;
let _CashFlows_zSpread arg = match _CashFlows_zSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_zSpread_f : c_obj list -> c_obj list = "_wrap_CashFlows_zSpread__SWIG_1QuantLib" ;;
let _CashFlows_zSpread arg = match _CashFlows_zSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_zSpread_f : c_obj list -> c_obj list = "_wrap_CashFlows_zSpread__SWIG_2QuantLib" ;;
let _CashFlows_zSpread arg = match _CashFlows_zSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_zSpread_f : c_obj list -> c_obj list = "_wrap_CashFlows_zSpread__SWIG_3QuantLib" ;;
let _CashFlows_zSpread arg = match _CashFlows_zSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_zSpread_f : c_obj list -> c_obj list = "_wrap_CashFlows_zSpread__SWIG_4QuantLib" ;;
let _CashFlows_zSpread arg = match _CashFlows_zSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CashFlows_zSpread_f : c_obj list -> c_obj list = "_wrap_CashFlows_zSpreadQuantLib" ;;
let _CashFlows_zSpread arg = match _CashFlows_zSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CashFlows_f : c_obj list -> c_obj list = "_wrap_delete_CashFlowsQuantLib" ;;
let _delete_CashFlows arg = match _delete_CashFlows_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper___deref___f : c_obj list -> c_obj list = "_wrap_CalibrationHelper___deref__QuantLib" ;;
let _CalibrationHelper___deref__ arg = match _CalibrationHelper___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_isNull_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_isNullQuantLib" ;;
let _CalibrationHelper_isNull arg = match _CalibrationHelper_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_RelativePriceError : c_obj -> Swig.c_obj = "_wrap_CalibrationHelper_RelativePriceError" 
external _CalibrationHelper_PriceError : c_obj -> Swig.c_obj = "_wrap_CalibrationHelper_PriceError" 
external _CalibrationHelper_ImpliedVolError : c_obj -> Swig.c_obj = "_wrap_CalibrationHelper_ImpliedVolError" 
external _CalibrationHelper_swaptionExpiryDate_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_swaptionExpiryDateQuantLib" ;;
let _CalibrationHelper_swaptionExpiryDate arg = match _CalibrationHelper_swaptionExpiryDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_swaptionStrike_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_swaptionStrikeQuantLib" ;;
let _CalibrationHelper_swaptionStrike arg = match _CalibrationHelper_swaptionStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_swaptionNominal_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_swaptionNominalQuantLib" ;;
let _CalibrationHelper_swaptionNominal arg = match _CalibrationHelper_swaptionNominal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_swaptionMaturityDate_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_swaptionMaturityDateQuantLib" ;;
let _CalibrationHelper_swaptionMaturityDate arg = match _CalibrationHelper_swaptionMaturityDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CalibrationHelper_f : c_obj list -> c_obj list = "_wrap_new_CalibrationHelperQuantLib" ;;
let _new_CalibrationHelper arg = match _new_CalibrationHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CalibrationHelper_f : c_obj list -> c_obj list = "_wrap_delete_CalibrationHelperQuantLib" ;;
let _delete_CalibrationHelper arg = match _delete_CalibrationHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_setPricingEngine_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_setPricingEngineQuantLib" ;;
let _CalibrationHelper_setPricingEngine arg = match _CalibrationHelper_setPricingEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_marketValue_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_marketValueQuantLib" ;;
let _CalibrationHelper_marketValue arg = match _CalibrationHelper_marketValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_modelValue_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_modelValueQuantLib" ;;
let _CalibrationHelper_modelValue arg = match _CalibrationHelper_modelValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_calibrationError_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_calibrationErrorQuantLib" ;;
let _CalibrationHelper_calibrationError arg = match _CalibrationHelper_calibrationError_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_impliedVolatilityQuantLib" ;;
let _CalibrationHelper_impliedVolatility arg = match _CalibrationHelper_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_blackPrice_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_blackPriceQuantLib" ;;
let _CalibrationHelper_blackPrice arg = match _CalibrationHelper_blackPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_volatility_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_volatilityQuantLib" ;;
let _CalibrationHelper_volatility arg = match _CalibrationHelper_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelper_volatilityType_f : c_obj list -> c_obj list = "_wrap_CalibrationHelper_volatilityTypeQuantLib" ;;
let _CalibrationHelper_volatilityType arg = match _CalibrationHelper_volatilityType_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_0QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_1QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_2QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_3QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_4QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_5QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_6QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_7QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_8QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_9QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_10QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_11QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_12QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_13QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_14QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_15QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelper__SWIG_16QuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_new_SwaptionHelperQuantLib" ;;
let _new_SwaptionHelper arg = match _new_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwaptionHelper_times_f : c_obj list -> c_obj list = "_wrap_SwaptionHelper_timesQuantLib" ;;
let _SwaptionHelper_times arg = match _SwaptionHelper_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SwaptionHelper_f : c_obj list -> c_obj list = "_wrap_delete_SwaptionHelperQuantLib" ;;
let _delete_SwaptionHelper arg = match _delete_SwaptionHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapHelper_f : c_obj list -> c_obj list = "_wrap_new_CapHelper__SWIG_0QuantLib" ;;
let _new_CapHelper arg = match _new_CapHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapHelper_f : c_obj list -> c_obj list = "_wrap_new_CapHelperQuantLib" ;;
let _new_CapHelper arg = match _new_CapHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapHelper_times_f : c_obj list -> c_obj list = "_wrap_CapHelper_timesQuantLib" ;;
let _CapHelper_times arg = match _CapHelper_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CapHelper_f : c_obj list -> c_obj list = "_wrap_delete_CapHelperQuantLib" ;;
let _delete_CapHelper arg = match _delete_CapHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HestonModelHelper_f : c_obj list -> c_obj list = "_wrap_new_HestonModelHelper__SWIG_0QuantLib" ;;
let _new_HestonModelHelper arg = match _new_HestonModelHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HestonModelHelper_f : c_obj list -> c_obj list = "_wrap_new_HestonModelHelperQuantLib" ;;
let _new_HestonModelHelper arg = match _new_HestonModelHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HestonModelHelper_f : c_obj list -> c_obj list = "_wrap_delete_HestonModelHelperQuantLib" ;;
let _delete_HestonModelHelper arg = match _delete_HestonModelHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CalibrationHelperVector_f : c_obj list -> c_obj list = "_wrap_new_CalibrationHelperVector__SWIG_0QuantLib" ;;
let _new_CalibrationHelperVector arg = match _new_CalibrationHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CalibrationHelperVector_f : c_obj list -> c_obj list = "_wrap_new_CalibrationHelperVector__SWIG_1QuantLib" ;;
let _new_CalibrationHelperVector arg = match _new_CalibrationHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CalibrationHelperVector_f : c_obj list -> c_obj list = "_wrap_new_CalibrationHelperVector__SWIG_2QuantLib" ;;
let _new_CalibrationHelperVector arg = match _new_CalibrationHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CalibrationHelperVector_f : c_obj list -> c_obj list = "_wrap_new_CalibrationHelperVectorQuantLib" ;;
let _new_CalibrationHelperVector arg = match _new_CalibrationHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelperVector_size_f : c_obj list -> c_obj list = "_wrap_CalibrationHelperVector_sizeQuantLib" ;;
let _CalibrationHelperVector_size arg = match _CalibrationHelperVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelperVector_empty_f : c_obj list -> c_obj list = "_wrap_CalibrationHelperVector_emptyQuantLib" ;;
let _CalibrationHelperVector_empty arg = match _CalibrationHelperVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelperVector_clear_f : c_obj list -> c_obj list = "_wrap_CalibrationHelperVector_clearQuantLib" ;;
let _CalibrationHelperVector_clear arg = match _CalibrationHelperVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelperVector_push_back_f : c_obj list -> c_obj list = "_wrap_CalibrationHelperVector_push_backQuantLib" ;;
let _CalibrationHelperVector_push_back arg = match _CalibrationHelperVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelperVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_CalibrationHelperVector_operator_bB___QuantLib" ;;
let _CalibrationHelperVector_operator_xx_xx_lbrace_xx_rbrace arg = match _CalibrationHelperVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelperVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_CalibrationHelperVector_operator_e___QuantLib" ;;
let _CalibrationHelperVector_operator_xx_xx_equals arg = match _CalibrationHelperVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelperVector_set_f : c_obj list -> c_obj list = "_wrap_CalibrationHelperVector_setQuantLib" ;;
let _CalibrationHelperVector_set arg = match _CalibrationHelperVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibrationHelperVector_to_array_f : c_obj list -> c_obj list = "_wrap_CalibrationHelperVector_to_arrayQuantLib" ;;
let _CalibrationHelperVector_to_array arg = match _CalibrationHelperVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CalibrationHelperVector_f : c_obj list -> c_obj list = "_wrap_delete_CalibrationHelperVectorQuantLib" ;;
let _delete_CalibrationHelperVector arg = match _delete_CalibrationHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModel___deref___f : c_obj list -> c_obj list = "_wrap_CalibratedModel___deref__QuantLib" ;;
let _CalibratedModel___deref__ arg = match _CalibratedModel___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModel_isNull_f : c_obj list -> c_obj list = "_wrap_CalibratedModel_isNullQuantLib" ;;
let _CalibratedModel_isNull arg = match _CalibratedModel_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModel_asObservable_f : c_obj list -> c_obj list = "_wrap_CalibratedModel_asObservableQuantLib" ;;
let _CalibratedModel_asObservable arg = match _CalibratedModel_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CalibratedModel_f : c_obj list -> c_obj list = "_wrap_new_CalibratedModelQuantLib" ;;
let _new_CalibratedModel arg = match _new_CalibratedModel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CalibratedModel_f : c_obj list -> c_obj list = "_wrap_delete_CalibratedModelQuantLib" ;;
let _delete_CalibratedModel arg = match _delete_CalibratedModel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModel_params_f : c_obj list -> c_obj list = "_wrap_CalibratedModel_paramsQuantLib" ;;
let _CalibratedModel_params arg = match _CalibratedModel_params_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModel_calibrate_f : c_obj list -> c_obj list = "_wrap_CalibratedModel_calibrate__SWIG_0QuantLib" ;;
let _CalibratedModel_calibrate arg = match _CalibratedModel_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModel_calibrate_f : c_obj list -> c_obj list = "_wrap_CalibratedModel_calibrate__SWIG_1QuantLib" ;;
let _CalibratedModel_calibrate arg = match _CalibratedModel_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModel_calibrate_f : c_obj list -> c_obj list = "_wrap_CalibratedModel_calibrateQuantLib" ;;
let _CalibratedModel_calibrate arg = match _CalibratedModel_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModel_setParams_f : c_obj list -> c_obj list = "_wrap_CalibratedModel_setParamsQuantLib" ;;
let _CalibratedModel_setParams arg = match _CalibratedModel_setParams_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModel_value_f : c_obj list -> c_obj list = "_wrap_CalibratedModel_valueQuantLib" ;;
let _CalibratedModel_value arg = match _CalibratedModel_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CalibratedModelHandle_f : c_obj list -> c_obj list = "_wrap_new_CalibratedModelHandle__SWIG_0QuantLib" ;;
let _new_CalibratedModelHandle arg = match _new_CalibratedModelHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CalibratedModelHandle_f : c_obj list -> c_obj list = "_wrap_new_CalibratedModelHandleQuantLib" ;;
let _new_CalibratedModelHandle arg = match _new_CalibratedModelHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModelHandle___deref___f : c_obj list -> c_obj list = "_wrap_CalibratedModelHandle___deref__QuantLib" ;;
let _CalibratedModelHandle___deref__ arg = match _CalibratedModelHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModelHandle_empty_f : c_obj list -> c_obj list = "_wrap_CalibratedModelHandle_emptyQuantLib" ;;
let _CalibratedModelHandle_empty arg = match _CalibratedModelHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModelHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_CalibratedModelHandle_asObservableQuantLib" ;;
let _CalibratedModelHandle_asObservable arg = match _CalibratedModelHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CalibratedModelHandle_f : c_obj list -> c_obj list = "_wrap_delete_CalibratedModelHandleQuantLib" ;;
let _delete_CalibratedModelHandle arg = match _delete_CalibratedModelHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModelHandle_params_f : c_obj list -> c_obj list = "_wrap_CalibratedModelHandle_paramsQuantLib" ;;
let _CalibratedModelHandle_params arg = match _CalibratedModelHandle_params_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModelHandle_calibrate_f : c_obj list -> c_obj list = "_wrap_CalibratedModelHandle_calibrate__SWIG_0QuantLib" ;;
let _CalibratedModelHandle_calibrate arg = match _CalibratedModelHandle_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModelHandle_calibrate_f : c_obj list -> c_obj list = "_wrap_CalibratedModelHandle_calibrate__SWIG_1QuantLib" ;;
let _CalibratedModelHandle_calibrate arg = match _CalibratedModelHandle_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModelHandle_calibrate_f : c_obj list -> c_obj list = "_wrap_CalibratedModelHandle_calibrateQuantLib" ;;
let _CalibratedModelHandle_calibrate arg = match _CalibratedModelHandle_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModelHandle_setParams_f : c_obj list -> c_obj list = "_wrap_CalibratedModelHandle_setParamsQuantLib" ;;
let _CalibratedModelHandle_setParams arg = match _CalibratedModelHandle_setParams_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CalibratedModelHandle_value_f : c_obj list -> c_obj list = "_wrap_CalibratedModelHandle_valueQuantLib" ;;
let _CalibratedModelHandle_value arg = match _CalibratedModelHandle_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableCalibratedModelHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableCalibratedModelHandle__SWIG_0QuantLib" ;;
let _new_RelinkableCalibratedModelHandle arg = match _new_RelinkableCalibratedModelHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableCalibratedModelHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableCalibratedModelHandleQuantLib" ;;
let _new_RelinkableCalibratedModelHandle arg = match _new_RelinkableCalibratedModelHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableCalibratedModelHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableCalibratedModelHandle_linkToQuantLib" ;;
let _RelinkableCalibratedModelHandle_linkTo arg = match _RelinkableCalibratedModelHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableCalibratedModelHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableCalibratedModelHandleQuantLib" ;;
let _delete_RelinkableCalibratedModelHandle arg = match _delete_RelinkableCalibratedModelHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TimeGrid_f : c_obj list -> c_obj list = "_wrap_new_TimeGrid__SWIG_0QuantLib" ;;
let _new_TimeGrid arg = match _new_TimeGrid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TimeGrid_f : c_obj list -> c_obj list = "_wrap_new_TimeGrid__SWIG_1QuantLib" ;;
let _new_TimeGrid arg = match _new_TimeGrid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TimeGrid_f : c_obj list -> c_obj list = "_wrap_new_TimeGrid__SWIG_2QuantLib" ;;
let _new_TimeGrid arg = match _new_TimeGrid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TimeGrid_f : c_obj list -> c_obj list = "_wrap_new_TimeGridQuantLib" ;;
let _new_TimeGrid arg = match _new_TimeGrid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _TimeGrid_size_f : c_obj list -> c_obj list = "_wrap_TimeGrid_sizeQuantLib" ;;
let _TimeGrid_size arg = match _TimeGrid_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TimeGrid_f : c_obj list -> c_obj list = "_wrap_delete_TimeGridQuantLib" ;;
let _delete_TimeGrid arg = match _delete_TimeGrid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Parameter_f : c_obj list -> c_obj list = "_wrap_new_ParameterQuantLib" ;;
let _new_Parameter arg = match _new_Parameter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parameter_params_f : c_obj list -> c_obj list = "_wrap_Parameter_paramsQuantLib" ;;
let _Parameter_params arg = match _Parameter_params_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parameter_setParam_f : c_obj list -> c_obj list = "_wrap_Parameter_setParamQuantLib" ;;
let _Parameter_setParam arg = match _Parameter_setParam_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parameter_testParams_f : c_obj list -> c_obj list = "_wrap_Parameter_testParamsQuantLib" ;;
let _Parameter_testParams arg = match _Parameter_testParams_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parameter_size_f : c_obj list -> c_obj list = "_wrap_Parameter_sizeQuantLib" ;;
let _Parameter_size arg = match _Parameter_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parameter_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_Parameter_operator_pP___QuantLib" ;;
let _Parameter_operator_xx_xx_lparen_xx_rparen arg = match _Parameter_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Parameter_constraint_f : c_obj list -> c_obj list = "_wrap_Parameter_constraintQuantLib" ;;
let _Parameter_constraint arg = match _Parameter_constraint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Parameter_f : c_obj list -> c_obj list = "_wrap_delete_ParameterQuantLib" ;;
let _delete_Parameter arg = match _delete_Parameter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantParameter_f : c_obj list -> c_obj list = "_wrap_new_ConstantParameter__SWIG_0QuantLib" ;;
let _new_ConstantParameter arg = match _new_ConstantParameter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantParameter_f : c_obj list -> c_obj list = "_wrap_new_ConstantParameterQuantLib" ;;
let _new_ConstantParameter arg = match _new_ConstantParameter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ConstantParameter_f : c_obj list -> c_obj list = "_wrap_delete_ConstantParameterQuantLib" ;;
let _delete_ConstantParameter arg = match _delete_ConstantParameter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NullParameter_f : c_obj list -> c_obj list = "_wrap_new_NullParameterQuantLib" ;;
let _new_NullParameter arg = match _new_NullParameter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NullParameter_f : c_obj list -> c_obj list = "_wrap_delete_NullParameterQuantLib" ;;
let _delete_NullParameter arg = match _delete_NullParameter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseConstantParameter_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseConstantParameter__SWIG_0QuantLib" ;;
let _new_PiecewiseConstantParameter arg = match _new_PiecewiseConstantParameter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseConstantParameter_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseConstantParameterQuantLib" ;;
let _new_PiecewiseConstantParameter arg = match _new_PiecewiseConstantParameter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PiecewiseConstantParameter_f : c_obj list -> c_obj list = "_wrap_delete_PiecewiseConstantParameterQuantLib" ;;
let _delete_PiecewiseConstantParameter arg = match _delete_PiecewiseConstantParameter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "Option::Type_marker" (`Type)
external _Put : c_obj -> Swig.c_obj = "_wrap_Put" 
external _Call : c_obj -> Swig.c_obj = "_wrap_Call" 
external _delete_Option_f : c_obj list -> c_obj list = "_wrap_delete_OptionQuantLib" ;;
let _delete_Option arg = match _delete_Option_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "Barrier::Type_marker" (`Type)
external _DownIn : c_obj -> Swig.c_obj = "_wrap_DownIn" 
external _UpIn : c_obj -> Swig.c_obj = "_wrap_UpIn" 
external _DownOut : c_obj -> Swig.c_obj = "_wrap_DownOut" 
external _UpOut : c_obj -> Swig.c_obj = "_wrap_UpOut" 
external _new_Barrier_f : c_obj list -> c_obj list = "_wrap_new_BarrierQuantLib" ;;
let _new_Barrier arg = match _new_Barrier_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Barrier_f : c_obj list -> c_obj list = "_wrap_delete_BarrierQuantLib" ;;
let _delete_Barrier arg = match _delete_Barrier_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "DoubleBarrier::Type_marker" (`Type)
external _KnockIn : c_obj -> Swig.c_obj = "_wrap_KnockIn" 
external _KnockOut : c_obj -> Swig.c_obj = "_wrap_KnockOut" 
external _KIKO : c_obj -> Swig.c_obj = "_wrap_KIKO" 
external _KOKI : c_obj -> Swig.c_obj = "_wrap_KOKI" 
external _new_DoubleBarrier_f : c_obj list -> c_obj list = "_wrap_new_DoubleBarrierQuantLib" ;;
let _new_DoubleBarrier arg = match _new_DoubleBarrier_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DoubleBarrier_f : c_obj list -> c_obj list = "_wrap_delete_DoubleBarrierQuantLib" ;;
let _delete_DoubleBarrier arg = match _delete_DoubleBarrier_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Payoff___deref___f : c_obj list -> c_obj list = "_wrap_Payoff___deref__QuantLib" ;;
let _Payoff___deref__ arg = match _Payoff___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Payoff_isNull_f : c_obj list -> c_obj list = "_wrap_Payoff_isNullQuantLib" ;;
let _Payoff_isNull arg = match _Payoff_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Payoff_f : c_obj list -> c_obj list = "_wrap_new_PayoffQuantLib" ;;
let _new_Payoff arg = match _new_Payoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Payoff_f : c_obj list -> c_obj list = "_wrap_delete_PayoffQuantLib" ;;
let _delete_Payoff arg = match _delete_Payoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Payoff_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_Payoff_operator_pP___QuantLib" ;;
let _Payoff_operator_xx_xx_lparen_xx_rparen arg = match _Payoff_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_VanillaOption_f : c_obj list -> c_obj list = "_wrap_new_VanillaOptionQuantLib" ;;
let _new_VanillaOption arg = match _new_VanillaOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_priceCurve_f : c_obj list -> c_obj list = "_wrap_VanillaOption_priceCurveQuantLib" ;;
let _VanillaOption_priceCurve arg = match _VanillaOption_priceCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_VanillaOption_impliedVolatility__SWIG_0QuantLib" ;;
let _VanillaOption_impliedVolatility arg = match _VanillaOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_VanillaOption_impliedVolatility__SWIG_1QuantLib" ;;
let _VanillaOption_impliedVolatility arg = match _VanillaOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_VanillaOption_impliedVolatility__SWIG_2QuantLib" ;;
let _VanillaOption_impliedVolatility arg = match _VanillaOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_VanillaOption_impliedVolatility__SWIG_3QuantLib" ;;
let _VanillaOption_impliedVolatility arg = match _VanillaOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_VanillaOption_impliedVolatilityQuantLib" ;;
let _VanillaOption_impliedVolatility arg = match _VanillaOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_delta_f : c_obj list -> c_obj list = "_wrap_VanillaOption_deltaQuantLib" ;;
let _VanillaOption_delta arg = match _VanillaOption_delta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_gamma_f : c_obj list -> c_obj list = "_wrap_VanillaOption_gammaQuantLib" ;;
let _VanillaOption_gamma arg = match _VanillaOption_gamma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_theta_f : c_obj list -> c_obj list = "_wrap_VanillaOption_thetaQuantLib" ;;
let _VanillaOption_theta arg = match _VanillaOption_theta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_thetaPerDay_f : c_obj list -> c_obj list = "_wrap_VanillaOption_thetaPerDayQuantLib" ;;
let _VanillaOption_thetaPerDay arg = match _VanillaOption_thetaPerDay_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_vega_f : c_obj list -> c_obj list = "_wrap_VanillaOption_vegaQuantLib" ;;
let _VanillaOption_vega arg = match _VanillaOption_vega_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_rho_f : c_obj list -> c_obj list = "_wrap_VanillaOption_rhoQuantLib" ;;
let _VanillaOption_rho arg = match _VanillaOption_rho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_dividendRho_f : c_obj list -> c_obj list = "_wrap_VanillaOption_dividendRhoQuantLib" ;;
let _VanillaOption_dividendRho arg = match _VanillaOption_dividendRho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaOption_strikeSensitivity_f : c_obj list -> c_obj list = "_wrap_VanillaOption_strikeSensitivityQuantLib" ;;
let _VanillaOption_strikeSensitivity arg = match _VanillaOption_strikeSensitivity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_VanillaOption_f : c_obj list -> c_obj list = "_wrap_delete_VanillaOptionQuantLib" ;;
let _delete_VanillaOption arg = match _delete_VanillaOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EuropeanOption_f : c_obj list -> c_obj list = "_wrap_new_EuropeanOptionQuantLib" ;;
let _new_EuropeanOption arg = match _new_EuropeanOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EuropeanOption_f : c_obj list -> c_obj list = "_wrap_delete_EuropeanOptionQuantLib" ;;
let _delete_EuropeanOption arg = match _delete_EuropeanOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardVanillaOption_f : c_obj list -> c_obj list = "_wrap_new_ForwardVanillaOptionQuantLib" ;;
let _new_ForwardVanillaOption arg = match _new_ForwardVanillaOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ForwardVanillaOption_f : c_obj list -> c_obj list = "_wrap_delete_ForwardVanillaOptionQuantLib" ;;
let _delete_ForwardVanillaOption arg = match _delete_ForwardVanillaOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuantoVanillaOption_f : c_obj list -> c_obj list = "_wrap_new_QuantoVanillaOptionQuantLib" ;;
let _new_QuantoVanillaOption arg = match _new_QuantoVanillaOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuantoVanillaOption_qvega_f : c_obj list -> c_obj list = "_wrap_QuantoVanillaOption_qvegaQuantLib" ;;
let _QuantoVanillaOption_qvega arg = match _QuantoVanillaOption_qvega_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuantoVanillaOption_qrho_f : c_obj list -> c_obj list = "_wrap_QuantoVanillaOption_qrhoQuantLib" ;;
let _QuantoVanillaOption_qrho arg = match _QuantoVanillaOption_qrho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuantoVanillaOption_qlambda_f : c_obj list -> c_obj list = "_wrap_QuantoVanillaOption_qlambdaQuantLib" ;;
let _QuantoVanillaOption_qlambda arg = match _QuantoVanillaOption_qlambda_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_QuantoVanillaOption_f : c_obj list -> c_obj list = "_wrap_delete_QuantoVanillaOptionQuantLib" ;;
let _delete_QuantoVanillaOption arg = match _delete_QuantoVanillaOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuantoForwardVanillaOption_f : c_obj list -> c_obj list = "_wrap_new_QuantoForwardVanillaOptionQuantLib" ;;
let _new_QuantoForwardVanillaOption arg = match _new_QuantoForwardVanillaOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_QuantoForwardVanillaOption_f : c_obj list -> c_obj list = "_wrap_delete_QuantoForwardVanillaOptionQuantLib" ;;
let _delete_QuantoForwardVanillaOption arg = match _delete_QuantoForwardVanillaOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultiAssetOption_delta_f : c_obj list -> c_obj list = "_wrap_MultiAssetOption_deltaQuantLib" ;;
let _MultiAssetOption_delta arg = match _MultiAssetOption_delta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultiAssetOption_gamma_f : c_obj list -> c_obj list = "_wrap_MultiAssetOption_gammaQuantLib" ;;
let _MultiAssetOption_gamma arg = match _MultiAssetOption_gamma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultiAssetOption_theta_f : c_obj list -> c_obj list = "_wrap_MultiAssetOption_thetaQuantLib" ;;
let _MultiAssetOption_theta arg = match _MultiAssetOption_theta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultiAssetOption_vega_f : c_obj list -> c_obj list = "_wrap_MultiAssetOption_vegaQuantLib" ;;
let _MultiAssetOption_vega arg = match _MultiAssetOption_vega_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultiAssetOption_rho_f : c_obj list -> c_obj list = "_wrap_MultiAssetOption_rhoQuantLib" ;;
let _MultiAssetOption_rho arg = match _MultiAssetOption_rho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultiAssetOption_dividendRho_f : c_obj list -> c_obj list = "_wrap_MultiAssetOption_dividendRhoQuantLib" ;;
let _MultiAssetOption_dividendRho arg = match _MultiAssetOption_dividendRho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MultiAssetOption_f : c_obj list -> c_obj list = "_wrap_new_MultiAssetOptionQuantLib" ;;
let _new_MultiAssetOption arg = match _new_MultiAssetOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MultiAssetOption_f : c_obj list -> c_obj list = "_wrap_delete_MultiAssetOptionQuantLib" ;;
let _delete_MultiAssetOption arg = match _delete_MultiAssetOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticEuropeanEngineQuantLib" ;;
let _new_AnalyticEuropeanEngine arg = match _new_AnalyticEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticEuropeanEngineQuantLib" ;;
let _delete_AnalyticEuropeanEngine arg = match _delete_AnalyticEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HestonModel_f : c_obj list -> c_obj list = "_wrap_new_HestonModelQuantLib" ;;
let _new_HestonModel arg = match _new_HestonModel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HestonModel_theta_f : c_obj list -> c_obj list = "_wrap_HestonModel_thetaQuantLib" ;;
let _HestonModel_theta arg = match _HestonModel_theta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HestonModel_kappa_f : c_obj list -> c_obj list = "_wrap_HestonModel_kappaQuantLib" ;;
let _HestonModel_kappa arg = match _HestonModel_kappa_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HestonModel_sigma_f : c_obj list -> c_obj list = "_wrap_HestonModel_sigmaQuantLib" ;;
let _HestonModel_sigma arg = match _HestonModel_sigma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HestonModel_rho_f : c_obj list -> c_obj list = "_wrap_HestonModel_rhoQuantLib" ;;
let _HestonModel_rho arg = match _HestonModel_rho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HestonModel_v0_f : c_obj list -> c_obj list = "_wrap_HestonModel_v0QuantLib" ;;
let _HestonModel_v0 arg = match _HestonModel_v0_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HestonModel_f : c_obj list -> c_obj list = "_wrap_delete_HestonModelQuantLib" ;;
let _delete_HestonModel arg = match _delete_HestonModel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseTimeDependentHestonModel_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseTimeDependentHestonModelQuantLib" ;;
let _new_PiecewiseTimeDependentHestonModel arg = match _new_PiecewiseTimeDependentHestonModel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseTimeDependentHestonModel_theta_f : c_obj list -> c_obj list = "_wrap_PiecewiseTimeDependentHestonModel_thetaQuantLib" ;;
let _PiecewiseTimeDependentHestonModel_theta arg = match _PiecewiseTimeDependentHestonModel_theta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseTimeDependentHestonModel_kappa_f : c_obj list -> c_obj list = "_wrap_PiecewiseTimeDependentHestonModel_kappaQuantLib" ;;
let _PiecewiseTimeDependentHestonModel_kappa arg = match _PiecewiseTimeDependentHestonModel_kappa_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseTimeDependentHestonModel_sigma_f : c_obj list -> c_obj list = "_wrap_PiecewiseTimeDependentHestonModel_sigmaQuantLib" ;;
let _PiecewiseTimeDependentHestonModel_sigma arg = match _PiecewiseTimeDependentHestonModel_sigma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseTimeDependentHestonModel_rho_f : c_obj list -> c_obj list = "_wrap_PiecewiseTimeDependentHestonModel_rhoQuantLib" ;;
let _PiecewiseTimeDependentHestonModel_rho arg = match _PiecewiseTimeDependentHestonModel_rho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseTimeDependentHestonModel_v0_f : c_obj list -> c_obj list = "_wrap_PiecewiseTimeDependentHestonModel_v0QuantLib" ;;
let _PiecewiseTimeDependentHestonModel_v0 arg = match _PiecewiseTimeDependentHestonModel_v0_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseTimeDependentHestonModel_s0_f : c_obj list -> c_obj list = "_wrap_PiecewiseTimeDependentHestonModel_s0QuantLib" ;;
let _PiecewiseTimeDependentHestonModel_s0 arg = match _PiecewiseTimeDependentHestonModel_s0_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseTimeDependentHestonModel_timeGrid_f : c_obj list -> c_obj list = "_wrap_PiecewiseTimeDependentHestonModel_timeGridQuantLib" ;;
let _PiecewiseTimeDependentHestonModel_timeGrid arg = match _PiecewiseTimeDependentHestonModel_timeGrid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseTimeDependentHestonModel_dividendYield_f : c_obj list -> c_obj list = "_wrap_PiecewiseTimeDependentHestonModel_dividendYieldQuantLib" ;;
let _PiecewiseTimeDependentHestonModel_dividendYield arg = match _PiecewiseTimeDependentHestonModel_dividendYield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseTimeDependentHestonModel_riskFreeRate_f : c_obj list -> c_obj list = "_wrap_PiecewiseTimeDependentHestonModel_riskFreeRateQuantLib" ;;
let _PiecewiseTimeDependentHestonModel_riskFreeRate arg = match _PiecewiseTimeDependentHestonModel_riskFreeRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PiecewiseTimeDependentHestonModel_f : c_obj list -> c_obj list = "_wrap_delete_PiecewiseTimeDependentHestonModelQuantLib" ;;
let _delete_PiecewiseTimeDependentHestonModel arg = match _delete_PiecewiseTimeDependentHestonModel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticHestonEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticHestonEngine__SWIG_0QuantLib" ;;
let _new_AnalyticHestonEngine arg = match _new_AnalyticHestonEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticHestonEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticHestonEngine__SWIG_1QuantLib" ;;
let _new_AnalyticHestonEngine arg = match _new_AnalyticHestonEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticHestonEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticHestonEngineQuantLib" ;;
let _new_AnalyticHestonEngine arg = match _new_AnalyticHestonEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticHestonEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticHestonEngineQuantLib" ;;
let _delete_AnalyticHestonEngine arg = match _delete_AnalyticHestonEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticPTDHestonEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticPTDHestonEngine__SWIG_0QuantLib" ;;
let _new_AnalyticPTDHestonEngine arg = match _new_AnalyticPTDHestonEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticPTDHestonEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticPTDHestonEngine__SWIG_1QuantLib" ;;
let _new_AnalyticPTDHestonEngine arg = match _new_AnalyticPTDHestonEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticPTDHestonEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticPTDHestonEngineQuantLib" ;;
let _new_AnalyticPTDHestonEngine arg = match _new_AnalyticPTDHestonEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticPTDHestonEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticPTDHestonEngineQuantLib" ;;
let _delete_AnalyticPTDHestonEngine arg = match _delete_AnalyticPTDHestonEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BatesModel_f : c_obj list -> c_obj list = "_wrap_new_BatesModelQuantLib" ;;
let _new_BatesModel arg = match _new_BatesModel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BatesModel_nu_f : c_obj list -> c_obj list = "_wrap_BatesModel_nuQuantLib" ;;
let _BatesModel_nu arg = match _BatesModel_nu_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BatesModel_delta_f : c_obj list -> c_obj list = "_wrap_BatesModel_deltaQuantLib" ;;
let _BatesModel_delta arg = match _BatesModel_delta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BatesModel_lambda_f : c_obj list -> c_obj list = "_wrap_BatesModel_lambdaQuantLib" ;;
let _BatesModel_lambda arg = match _BatesModel_lambda_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BatesModel_f : c_obj list -> c_obj list = "_wrap_delete_BatesModelQuantLib" ;;
let _delete_BatesModel arg = match _delete_BatesModel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BatesEngine_f : c_obj list -> c_obj list = "_wrap_new_BatesEngine__SWIG_0QuantLib" ;;
let _new_BatesEngine arg = match _new_BatesEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BatesEngine_f : c_obj list -> c_obj list = "_wrap_new_BatesEngine__SWIG_1QuantLib" ;;
let _new_BatesEngine arg = match _new_BatesEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BatesEngine_f : c_obj list -> c_obj list = "_wrap_new_BatesEngineQuantLib" ;;
let _new_BatesEngine arg = match _new_BatesEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BatesEngine_f : c_obj list -> c_obj list = "_wrap_delete_BatesEngineQuantLib" ;;
let _delete_BatesEngine arg = match _delete_BatesEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntegralEngine_f : c_obj list -> c_obj list = "_wrap_new_IntegralEngineQuantLib" ;;
let _new_IntegralEngine arg = match _new_IntegralEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IntegralEngine_f : c_obj list -> c_obj list = "_wrap_delete_IntegralEngineQuantLib" ;;
let _delete_IntegralEngine arg = match _delete_IntegralEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDBermudanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDBermudanEngine__SWIG_0QuantLib" ;;
let _new_FDBermudanEngine arg = match _new_FDBermudanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDBermudanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDBermudanEngine__SWIG_1QuantLib" ;;
let _new_FDBermudanEngine arg = match _new_FDBermudanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDBermudanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDBermudanEngine__SWIG_2QuantLib" ;;
let _new_FDBermudanEngine arg = match _new_FDBermudanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDBermudanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDBermudanEngineQuantLib" ;;
let _new_FDBermudanEngine arg = match _new_FDBermudanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FDBermudanEngine_f : c_obj list -> c_obj list = "_wrap_delete_FDBermudanEngineQuantLib" ;;
let _delete_FDBermudanEngine arg = match _delete_FDBermudanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDEuropeanEngine__SWIG_0QuantLib" ;;
let _new_FDEuropeanEngine arg = match _new_FDEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDEuropeanEngine__SWIG_1QuantLib" ;;
let _new_FDEuropeanEngine arg = match _new_FDEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDEuropeanEngine__SWIG_2QuantLib" ;;
let _new_FDEuropeanEngine arg = match _new_FDEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDEuropeanEngineQuantLib" ;;
let _new_FDEuropeanEngine arg = match _new_FDEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FDEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_delete_FDEuropeanEngineQuantLib" ;;
let _delete_FDEuropeanEngine arg = match _delete_FDEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BinomialVanillaEngine_f : c_obj list -> c_obj list = "_wrap_new_BinomialVanillaEngineQuantLib" ;;
let _new_BinomialVanillaEngine arg = match _new_BinomialVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BinomialVanillaEngine_f : c_obj list -> c_obj list = "_wrap_delete_BinomialVanillaEngineQuantLib" ;;
let _delete_BinomialVanillaEngine arg = match _delete_BinomialVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanEngine__SWIG_0QuantLib" ;;
let _new_MCEuropeanEngine arg = match _new_MCEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanEngine__SWIG_1QuantLib" ;;
let _new_MCEuropeanEngine arg = match _new_MCEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanEngine__SWIG_2QuantLib" ;;
let _new_MCEuropeanEngine arg = match _new_MCEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanEngine__SWIG_3QuantLib" ;;
let _new_MCEuropeanEngine arg = match _new_MCEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanEngine__SWIG_4QuantLib" ;;
let _new_MCEuropeanEngine arg = match _new_MCEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanEngine__SWIG_5QuantLib" ;;
let _new_MCEuropeanEngine arg = match _new_MCEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanEngine__SWIG_6QuantLib" ;;
let _new_MCEuropeanEngine arg = match _new_MCEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanEngine__SWIG_7QuantLib" ;;
let _new_MCEuropeanEngine arg = match _new_MCEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanEngineQuantLib" ;;
let _new_MCEuropeanEngine arg = match _new_MCEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MCEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_delete_MCEuropeanEngineQuantLib" ;;
let _delete_MCEuropeanEngine arg = match _delete_MCEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDAmericanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDAmericanEngine__SWIG_0QuantLib" ;;
let _new_FDAmericanEngine arg = match _new_FDAmericanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDAmericanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDAmericanEngine__SWIG_1QuantLib" ;;
let _new_FDAmericanEngine arg = match _new_FDAmericanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDAmericanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDAmericanEngine__SWIG_2QuantLib" ;;
let _new_FDAmericanEngine arg = match _new_FDAmericanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDAmericanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDAmericanEngineQuantLib" ;;
let _new_FDAmericanEngine arg = match _new_FDAmericanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FDAmericanEngine_f : c_obj list -> c_obj list = "_wrap_delete_FDAmericanEngineQuantLib" ;;
let _delete_FDAmericanEngine arg = match _delete_FDAmericanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBlackScholesVanillaEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBlackScholesVanillaEngine__SWIG_0QuantLib" ;;
let _new_FdBlackScholesVanillaEngine arg = match _new_FdBlackScholesVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBlackScholesVanillaEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBlackScholesVanillaEngine__SWIG_1QuantLib" ;;
let _new_FdBlackScholesVanillaEngine arg = match _new_FdBlackScholesVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBlackScholesVanillaEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBlackScholesVanillaEngine__SWIG_2QuantLib" ;;
let _new_FdBlackScholesVanillaEngine arg = match _new_FdBlackScholesVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBlackScholesVanillaEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBlackScholesVanillaEngineQuantLib" ;;
let _new_FdBlackScholesVanillaEngine arg = match _new_FdBlackScholesVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FdBlackScholesVanillaEngine_f : c_obj list -> c_obj list = "_wrap_delete_FdBlackScholesVanillaEngineQuantLib" ;;
let _delete_FdBlackScholesVanillaEngine arg = match _delete_FdBlackScholesVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBatesVanillaEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBatesVanillaEngine__SWIG_0QuantLib" ;;
let _new_FdBatesVanillaEngine arg = match _new_FdBatesVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBatesVanillaEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBatesVanillaEngine__SWIG_1QuantLib" ;;
let _new_FdBatesVanillaEngine arg = match _new_FdBatesVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBatesVanillaEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBatesVanillaEngine__SWIG_2QuantLib" ;;
let _new_FdBatesVanillaEngine arg = match _new_FdBatesVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBatesVanillaEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBatesVanillaEngine__SWIG_3QuantLib" ;;
let _new_FdBatesVanillaEngine arg = match _new_FdBatesVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBatesVanillaEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBatesVanillaEngineQuantLib" ;;
let _new_FdBatesVanillaEngine arg = match _new_FdBatesVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FdBatesVanillaEngine_f : c_obj list -> c_obj list = "_wrap_delete_FdBatesVanillaEngineQuantLib" ;;
let _delete_FdBatesVanillaEngine arg = match _delete_FdBatesVanillaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ContinuousArithmeticAsianLevyEngine_f : c_obj list -> c_obj list = "_wrap_new_ContinuousArithmeticAsianLevyEngineQuantLib" ;;
let _new_ContinuousArithmeticAsianLevyEngine arg = match _new_ContinuousArithmeticAsianLevyEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ContinuousArithmeticAsianLevyEngine_f : c_obj list -> c_obj list = "_wrap_delete_ContinuousArithmeticAsianLevyEngineQuantLib" ;;
let _delete_ContinuousArithmeticAsianLevyEngine arg = match _delete_ContinuousArithmeticAsianLevyEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBlackScholesAsianEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBlackScholesAsianEngineQuantLib" ;;
let _new_FdBlackScholesAsianEngine arg = match _new_FdBlackScholesAsianEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FdBlackScholesAsianEngine_f : c_obj list -> c_obj list = "_wrap_delete_FdBlackScholesAsianEngineQuantLib" ;;
let _delete_FdBlackScholesAsianEngine arg = match _delete_FdBlackScholesAsianEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDShoutEngine_f : c_obj list -> c_obj list = "_wrap_new_FDShoutEngine__SWIG_0QuantLib" ;;
let _new_FDShoutEngine arg = match _new_FDShoutEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDShoutEngine_f : c_obj list -> c_obj list = "_wrap_new_FDShoutEngine__SWIG_1QuantLib" ;;
let _new_FDShoutEngine arg = match _new_FDShoutEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDShoutEngine_f : c_obj list -> c_obj list = "_wrap_new_FDShoutEngine__SWIG_2QuantLib" ;;
let _new_FDShoutEngine arg = match _new_FDShoutEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDShoutEngine_f : c_obj list -> c_obj list = "_wrap_new_FDShoutEngineQuantLib" ;;
let _new_FDShoutEngine arg = match _new_FDShoutEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FDShoutEngine_f : c_obj list -> c_obj list = "_wrap_delete_FDShoutEngineQuantLib" ;;
let _delete_FDShoutEngine arg = match _delete_FDShoutEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BaroneAdesiWhaleyEngine_f : c_obj list -> c_obj list = "_wrap_new_BaroneAdesiWhaleyEngineQuantLib" ;;
let _new_BaroneAdesiWhaleyEngine arg = match _new_BaroneAdesiWhaleyEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BaroneAdesiWhaleyEngine_f : c_obj list -> c_obj list = "_wrap_delete_BaroneAdesiWhaleyEngineQuantLib" ;;
let _delete_BaroneAdesiWhaleyEngine arg = match _delete_BaroneAdesiWhaleyEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BjerksundStenslandEngine_f : c_obj list -> c_obj list = "_wrap_new_BjerksundStenslandEngineQuantLib" ;;
let _new_BjerksundStenslandEngine arg = match _new_BjerksundStenslandEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BjerksundStenslandEngine_f : c_obj list -> c_obj list = "_wrap_delete_BjerksundStenslandEngineQuantLib" ;;
let _delete_BjerksundStenslandEngine arg = match _delete_BjerksundStenslandEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticDigitalAmericanEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticDigitalAmericanEngineQuantLib" ;;
let _new_AnalyticDigitalAmericanEngine arg = match _new_AnalyticDigitalAmericanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticDigitalAmericanEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticDigitalAmericanEngineQuantLib" ;;
let _delete_AnalyticDigitalAmericanEngine arg = match _delete_AnalyticDigitalAmericanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticDigitalAmericanKOEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticDigitalAmericanKOEngineQuantLib" ;;
let _new_AnalyticDigitalAmericanKOEngine arg = match _new_AnalyticDigitalAmericanKOEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticDigitalAmericanKOEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticDigitalAmericanKOEngineQuantLib" ;;
let _delete_AnalyticDigitalAmericanKOEngine arg = match _delete_AnalyticDigitalAmericanKOEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DividendVanillaOption_f : c_obj list -> c_obj list = "_wrap_new_DividendVanillaOptionQuantLib" ;;
let _new_DividendVanillaOption arg = match _new_DividendVanillaOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_priceCurve_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_priceCurveQuantLib" ;;
let _DividendVanillaOption_priceCurve arg = match _DividendVanillaOption_priceCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_impliedVolatility__SWIG_0QuantLib" ;;
let _DividendVanillaOption_impliedVolatility arg = match _DividendVanillaOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_impliedVolatility__SWIG_1QuantLib" ;;
let _DividendVanillaOption_impliedVolatility arg = match _DividendVanillaOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_impliedVolatility__SWIG_2QuantLib" ;;
let _DividendVanillaOption_impliedVolatility arg = match _DividendVanillaOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_impliedVolatility__SWIG_3QuantLib" ;;
let _DividendVanillaOption_impliedVolatility arg = match _DividendVanillaOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_impliedVolatilityQuantLib" ;;
let _DividendVanillaOption_impliedVolatility arg = match _DividendVanillaOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_delta_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_deltaQuantLib" ;;
let _DividendVanillaOption_delta arg = match _DividendVanillaOption_delta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_gamma_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_gammaQuantLib" ;;
let _DividendVanillaOption_gamma arg = match _DividendVanillaOption_gamma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_theta_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_thetaQuantLib" ;;
let _DividendVanillaOption_theta arg = match _DividendVanillaOption_theta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_thetaPerDay_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_thetaPerDayQuantLib" ;;
let _DividendVanillaOption_thetaPerDay arg = match _DividendVanillaOption_thetaPerDay_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_vega_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_vegaQuantLib" ;;
let _DividendVanillaOption_vega arg = match _DividendVanillaOption_vega_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_rho_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_rhoQuantLib" ;;
let _DividendVanillaOption_rho arg = match _DividendVanillaOption_rho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_dividendRho_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_dividendRhoQuantLib" ;;
let _DividendVanillaOption_dividendRho arg = match _DividendVanillaOption_dividendRho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendVanillaOption_strikeSensitivity_f : c_obj list -> c_obj list = "_wrap_DividendVanillaOption_strikeSensitivityQuantLib" ;;
let _DividendVanillaOption_strikeSensitivity arg = match _DividendVanillaOption_strikeSensitivity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DividendVanillaOption_f : c_obj list -> c_obj list = "_wrap_delete_DividendVanillaOptionQuantLib" ;;
let _delete_DividendVanillaOption arg = match _delete_DividendVanillaOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticDividendEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticDividendEuropeanEngineQuantLib" ;;
let _new_AnalyticDividendEuropeanEngine arg = match _new_AnalyticDividendEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticDividendEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticDividendEuropeanEngineQuantLib" ;;
let _delete_AnalyticDividendEuropeanEngine arg = match _delete_AnalyticDividendEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDDividendEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDDividendEuropeanEngine__SWIG_0QuantLib" ;;
let _new_FDDividendEuropeanEngine arg = match _new_FDDividendEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDDividendEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDDividendEuropeanEngine__SWIG_1QuantLib" ;;
let _new_FDDividendEuropeanEngine arg = match _new_FDDividendEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDDividendEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDDividendEuropeanEngine__SWIG_2QuantLib" ;;
let _new_FDDividendEuropeanEngine arg = match _new_FDDividendEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDDividendEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDDividendEuropeanEngineQuantLib" ;;
let _new_FDDividendEuropeanEngine arg = match _new_FDDividendEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FDDividendEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_delete_FDDividendEuropeanEngineQuantLib" ;;
let _delete_FDDividendEuropeanEngine arg = match _delete_FDDividendEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDDividendAmericanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDDividendAmericanEngine__SWIG_0QuantLib" ;;
let _new_FDDividendAmericanEngine arg = match _new_FDDividendAmericanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDDividendAmericanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDDividendAmericanEngine__SWIG_1QuantLib" ;;
let _new_FDDividendAmericanEngine arg = match _new_FDDividendAmericanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDDividendAmericanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDDividendAmericanEngine__SWIG_2QuantLib" ;;
let _new_FDDividendAmericanEngine arg = match _new_FDDividendAmericanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FDDividendAmericanEngine_f : c_obj list -> c_obj list = "_wrap_new_FDDividendAmericanEngineQuantLib" ;;
let _new_FDDividendAmericanEngine arg = match _new_FDDividendAmericanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FDDividendAmericanEngine_f : c_obj list -> c_obj list = "_wrap_delete_FDDividendAmericanEngineQuantLib" ;;
let _delete_FDDividendAmericanEngine arg = match _delete_FDDividendAmericanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BarrierOption_f : c_obj list -> c_obj list = "_wrap_new_BarrierOptionQuantLib" ;;
let _new_BarrierOption arg = match _new_BarrierOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_priceCurve_f : c_obj list -> c_obj list = "_wrap_BarrierOption_priceCurveQuantLib" ;;
let _BarrierOption_priceCurve arg = match _BarrierOption_priceCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_BarrierOption_impliedVolatility__SWIG_0QuantLib" ;;
let _BarrierOption_impliedVolatility arg = match _BarrierOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_BarrierOption_impliedVolatility__SWIG_1QuantLib" ;;
let _BarrierOption_impliedVolatility arg = match _BarrierOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_BarrierOption_impliedVolatility__SWIG_2QuantLib" ;;
let _BarrierOption_impliedVolatility arg = match _BarrierOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_BarrierOption_impliedVolatility__SWIG_3QuantLib" ;;
let _BarrierOption_impliedVolatility arg = match _BarrierOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_BarrierOption_impliedVolatilityQuantLib" ;;
let _BarrierOption_impliedVolatility arg = match _BarrierOption_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_delta_f : c_obj list -> c_obj list = "_wrap_BarrierOption_deltaQuantLib" ;;
let _BarrierOption_delta arg = match _BarrierOption_delta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_gamma_f : c_obj list -> c_obj list = "_wrap_BarrierOption_gammaQuantLib" ;;
let _BarrierOption_gamma arg = match _BarrierOption_gamma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_theta_f : c_obj list -> c_obj list = "_wrap_BarrierOption_thetaQuantLib" ;;
let _BarrierOption_theta arg = match _BarrierOption_theta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_thetaPerDay_f : c_obj list -> c_obj list = "_wrap_BarrierOption_thetaPerDayQuantLib" ;;
let _BarrierOption_thetaPerDay arg = match _BarrierOption_thetaPerDay_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_vega_f : c_obj list -> c_obj list = "_wrap_BarrierOption_vegaQuantLib" ;;
let _BarrierOption_vega arg = match _BarrierOption_vega_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_rho_f : c_obj list -> c_obj list = "_wrap_BarrierOption_rhoQuantLib" ;;
let _BarrierOption_rho arg = match _BarrierOption_rho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_dividendRho_f : c_obj list -> c_obj list = "_wrap_BarrierOption_dividendRhoQuantLib" ;;
let _BarrierOption_dividendRho arg = match _BarrierOption_dividendRho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BarrierOption_strikeSensitivity_f : c_obj list -> c_obj list = "_wrap_BarrierOption_strikeSensitivityQuantLib" ;;
let _BarrierOption_strikeSensitivity arg = match _BarrierOption_strikeSensitivity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BarrierOption_f : c_obj list -> c_obj list = "_wrap_delete_BarrierOptionQuantLib" ;;
let _delete_BarrierOption arg = match _delete_BarrierOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticBarrierEngineQuantLib" ;;
let _new_AnalyticBarrierEngine arg = match _new_AnalyticBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticBarrierEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticBarrierEngineQuantLib" ;;
let _delete_AnalyticBarrierEngine arg = match _delete_AnalyticBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_MCBarrierEngine__SWIG_0QuantLib" ;;
let _new_MCBarrierEngine arg = match _new_MCBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_MCBarrierEngine__SWIG_1QuantLib" ;;
let _new_MCBarrierEngine arg = match _new_MCBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_MCBarrierEngine__SWIG_2QuantLib" ;;
let _new_MCBarrierEngine arg = match _new_MCBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_MCBarrierEngine__SWIG_3QuantLib" ;;
let _new_MCBarrierEngine arg = match _new_MCBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_MCBarrierEngine__SWIG_4QuantLib" ;;
let _new_MCBarrierEngine arg = match _new_MCBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_MCBarrierEngine__SWIG_5QuantLib" ;;
let _new_MCBarrierEngine arg = match _new_MCBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_MCBarrierEngine__SWIG_6QuantLib" ;;
let _new_MCBarrierEngine arg = match _new_MCBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_MCBarrierEngine__SWIG_7QuantLib" ;;
let _new_MCBarrierEngine arg = match _new_MCBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_MCBarrierEngine__SWIG_8QuantLib" ;;
let _new_MCBarrierEngine arg = match _new_MCBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_MCBarrierEngineQuantLib" ;;
let _new_MCBarrierEngine arg = match _new_MCBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MCBarrierEngine_f : c_obj list -> c_obj list = "_wrap_delete_MCBarrierEngineQuantLib" ;;
let _delete_MCBarrierEngine arg = match _delete_MCBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "FdmSchemeDesc::FdmSchemeType_marker" (`FdmSchemeType)
external _HundsdorferType : c_obj -> Swig.c_obj = "_wrap_HundsdorferType" 
external _DouglasType : c_obj -> Swig.c_obj = "_wrap_DouglasType" 
external _CraigSneydType : c_obj -> Swig.c_obj = "_wrap_CraigSneydType" 
external _ModifiedCraigSneydType : c_obj -> Swig.c_obj = "_wrap_ModifiedCraigSneydType" 
external _ImplicitEulerType : c_obj -> Swig.c_obj = "_wrap_ImplicitEulerType" 
external _ExplicitEulerType : c_obj -> Swig.c_obj = "_wrap_ExplicitEulerType" 
external _new_FdmSchemeDesc_f : c_obj list -> c_obj list = "_wrap_new_FdmSchemeDescQuantLib" ;;
let _new_FdmSchemeDesc arg = match _new_FdmSchemeDesc_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FdmSchemeDesc_type_get_f : c_obj list -> c_obj list = "_wrap_FdmSchemeDesc_type_getQuantLib" ;;
let _FdmSchemeDesc_type_get arg = match _FdmSchemeDesc_type_get_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FdmSchemeDesc_theta_get_f : c_obj list -> c_obj list = "_wrap_FdmSchemeDesc_theta_getQuantLib" ;;
let _FdmSchemeDesc_theta_get arg = match _FdmSchemeDesc_theta_get_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FdmSchemeDesc_mu_get_f : c_obj list -> c_obj list = "_wrap_FdmSchemeDesc_mu_getQuantLib" ;;
let _FdmSchemeDesc_mu_get arg = match _FdmSchemeDesc_mu_get_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FdmSchemeDesc_Douglas_f : c_obj list -> c_obj list = "_wrap_FdmSchemeDesc_DouglasQuantLib" ;;
let _FdmSchemeDesc_Douglas arg = match _FdmSchemeDesc_Douglas_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FdmSchemeDesc_ImplicitEuler_f : c_obj list -> c_obj list = "_wrap_FdmSchemeDesc_ImplicitEulerQuantLib" ;;
let _FdmSchemeDesc_ImplicitEuler arg = match _FdmSchemeDesc_ImplicitEuler_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FdmSchemeDesc_ExplicitEuler_f : c_obj list -> c_obj list = "_wrap_FdmSchemeDesc_ExplicitEulerQuantLib" ;;
let _FdmSchemeDesc_ExplicitEuler arg = match _FdmSchemeDesc_ExplicitEuler_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FdmSchemeDesc_CraigSneyd_f : c_obj list -> c_obj list = "_wrap_FdmSchemeDesc_CraigSneydQuantLib" ;;
let _FdmSchemeDesc_CraigSneyd arg = match _FdmSchemeDesc_CraigSneyd_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FdmSchemeDesc_ModifiedCraigSneyd_f : c_obj list -> c_obj list = "_wrap_FdmSchemeDesc_ModifiedCraigSneydQuantLib" ;;
let _FdmSchemeDesc_ModifiedCraigSneyd arg = match _FdmSchemeDesc_ModifiedCraigSneyd_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FdmSchemeDesc_Hundsdorfer_f : c_obj list -> c_obj list = "_wrap_FdmSchemeDesc_HundsdorferQuantLib" ;;
let _FdmSchemeDesc_Hundsdorfer arg = match _FdmSchemeDesc_Hundsdorfer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FdmSchemeDesc_ModifiedHundsdorfer_f : c_obj list -> c_obj list = "_wrap_FdmSchemeDesc_ModifiedHundsdorferQuantLib" ;;
let _FdmSchemeDesc_ModifiedHundsdorfer arg = match _FdmSchemeDesc_ModifiedHundsdorfer_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FdmSchemeDesc_f : c_obj list -> c_obj list = "_wrap_delete_FdmSchemeDescQuantLib" ;;
let _delete_FdmSchemeDesc arg = match _delete_FdmSchemeDesc_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBlackScholesBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBlackScholesBarrierEngine__SWIG_0QuantLib" ;;
let _new_FdBlackScholesBarrierEngine arg = match _new_FdBlackScholesBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBlackScholesBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBlackScholesBarrierEngine__SWIG_1QuantLib" ;;
let _new_FdBlackScholesBarrierEngine arg = match _new_FdBlackScholesBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBlackScholesBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBlackScholesBarrierEngine__SWIG_2QuantLib" ;;
let _new_FdBlackScholesBarrierEngine arg = match _new_FdBlackScholesBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBlackScholesBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBlackScholesBarrierEngine__SWIG_3QuantLib" ;;
let _new_FdBlackScholesBarrierEngine arg = match _new_FdBlackScholesBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBlackScholesBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBlackScholesBarrierEngine__SWIG_4QuantLib" ;;
let _new_FdBlackScholesBarrierEngine arg = match _new_FdBlackScholesBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBlackScholesBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBlackScholesBarrierEngine__SWIG_5QuantLib" ;;
let _new_FdBlackScholesBarrierEngine arg = match _new_FdBlackScholesBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdBlackScholesBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_FdBlackScholesBarrierEngineQuantLib" ;;
let _new_FdBlackScholesBarrierEngine arg = match _new_FdBlackScholesBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FdBlackScholesBarrierEngine_f : c_obj list -> c_obj list = "_wrap_delete_FdBlackScholesBarrierEngineQuantLib" ;;
let _delete_FdBlackScholesBarrierEngine arg = match _delete_FdBlackScholesBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticBinaryBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticBinaryBarrierEngineQuantLib" ;;
let _new_AnalyticBinaryBarrierEngine arg = match _new_AnalyticBinaryBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticBinaryBarrierEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticBinaryBarrierEngineQuantLib" ;;
let _delete_AnalyticBinaryBarrierEngine arg = match _delete_AnalyticBinaryBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BinomialBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_BinomialBarrierEngine__SWIG_0QuantLib" ;;
let _new_BinomialBarrierEngine arg = match _new_BinomialBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BinomialBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_BinomialBarrierEngineQuantLib" ;;
let _new_BinomialBarrierEngine arg = match _new_BinomialBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BinomialBarrierEngine_f : c_obj list -> c_obj list = "_wrap_delete_BinomialBarrierEngineQuantLib" ;;
let _delete_BinomialBarrierEngine arg = match _delete_BinomialBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_ForwardEuropeanEngineQuantLib" ;;
let _new_ForwardEuropeanEngine arg = match _new_ForwardEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ForwardEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_delete_ForwardEuropeanEngineQuantLib" ;;
let _delete_ForwardEuropeanEngine arg = match _delete_ForwardEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuantoEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_QuantoEuropeanEngineQuantLib" ;;
let _new_QuantoEuropeanEngine arg = match _new_QuantoEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_QuantoEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_delete_QuantoEuropeanEngineQuantLib" ;;
let _delete_QuantoEuropeanEngine arg = match _delete_QuantoEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuantoForwardEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_new_QuantoForwardEuropeanEngineQuantLib" ;;
let _new_QuantoForwardEuropeanEngine arg = match _new_QuantoForwardEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_QuantoForwardEuropeanEngine_f : c_obj list -> c_obj list = "_wrap_delete_QuantoForwardEuropeanEngineQuantLib" ;;
let _delete_QuantoForwardEuropeanEngine arg = match _delete_QuantoForwardEuropeanEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackCalculator_f : c_obj list -> c_obj list = "_wrap_new_BlackCalculator__SWIG_0QuantLib" ;;
let _new_BlackCalculator arg = match _new_BlackCalculator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackCalculator_f : c_obj list -> c_obj list = "_wrap_new_BlackCalculatorQuantLib" ;;
let _new_BlackCalculator arg = match _new_BlackCalculator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_value_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_valueQuantLib" ;;
let _BlackCalculator_value arg = match _BlackCalculator_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_deltaForward_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_deltaForwardQuantLib" ;;
let _BlackCalculator_deltaForward arg = match _BlackCalculator_deltaForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_delta_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_deltaQuantLib" ;;
let _BlackCalculator_delta arg = match _BlackCalculator_delta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_elasticityForward_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_elasticityForwardQuantLib" ;;
let _BlackCalculator_elasticityForward arg = match _BlackCalculator_elasticityForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_elasticity_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_elasticityQuantLib" ;;
let _BlackCalculator_elasticity arg = match _BlackCalculator_elasticity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_gammaForward_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_gammaForwardQuantLib" ;;
let _BlackCalculator_gammaForward arg = match _BlackCalculator_gammaForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_gamma_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_gammaQuantLib" ;;
let _BlackCalculator_gamma arg = match _BlackCalculator_gamma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_theta_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_thetaQuantLib" ;;
let _BlackCalculator_theta arg = match _BlackCalculator_theta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_thetaPerDay_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_thetaPerDayQuantLib" ;;
let _BlackCalculator_thetaPerDay arg = match _BlackCalculator_thetaPerDay_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_vega_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_vegaQuantLib" ;;
let _BlackCalculator_vega arg = match _BlackCalculator_vega_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_rho_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_rhoQuantLib" ;;
let _BlackCalculator_rho arg = match _BlackCalculator_rho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_dividendRho_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_dividendRhoQuantLib" ;;
let _BlackCalculator_dividendRho arg = match _BlackCalculator_dividendRho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_itmCashProbability_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_itmCashProbabilityQuantLib" ;;
let _BlackCalculator_itmCashProbability arg = match _BlackCalculator_itmCashProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_itmAssetProbability_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_itmAssetProbabilityQuantLib" ;;
let _BlackCalculator_itmAssetProbability arg = match _BlackCalculator_itmAssetProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_strikeSensitivity_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_strikeSensitivityQuantLib" ;;
let _BlackCalculator_strikeSensitivity arg = match _BlackCalculator_strikeSensitivity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_alpha_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_alphaQuantLib" ;;
let _BlackCalculator_alpha arg = match _BlackCalculator_alpha_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackCalculator_beta_f : c_obj list -> c_obj list = "_wrap_BlackCalculator_betaQuantLib" ;;
let _BlackCalculator_beta arg = match _BlackCalculator_beta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackCalculator_f : c_obj list -> c_obj list = "_wrap_delete_BlackCalculatorQuantLib" ;;
let _delete_BlackCalculator arg = match _delete_BlackCalculator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "Average::Type_marker" (`Type)
external _Arithmetic : c_obj -> Swig.c_obj = "_wrap_Arithmetic" 
external _Geometric : c_obj -> Swig.c_obj = "_wrap_Geometric" 
external _new_Average_f : c_obj list -> c_obj list = "_wrap_new_AverageQuantLib" ;;
let _new_Average arg = match _new_Average_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Average_f : c_obj list -> c_obj list = "_wrap_delete_AverageQuantLib" ;;
let _delete_Average arg = match _delete_Average_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ContinuousAveragingAsianOption_f : c_obj list -> c_obj list = "_wrap_new_ContinuousAveragingAsianOptionQuantLib" ;;
let _new_ContinuousAveragingAsianOption arg = match _new_ContinuousAveragingAsianOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ContinuousAveragingAsianOption_delta_f : c_obj list -> c_obj list = "_wrap_ContinuousAveragingAsianOption_deltaQuantLib" ;;
let _ContinuousAveragingAsianOption_delta arg = match _ContinuousAveragingAsianOption_delta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ContinuousAveragingAsianOption_gamma_f : c_obj list -> c_obj list = "_wrap_ContinuousAveragingAsianOption_gammaQuantLib" ;;
let _ContinuousAveragingAsianOption_gamma arg = match _ContinuousAveragingAsianOption_gamma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ContinuousAveragingAsianOption_theta_f : c_obj list -> c_obj list = "_wrap_ContinuousAveragingAsianOption_thetaQuantLib" ;;
let _ContinuousAveragingAsianOption_theta arg = match _ContinuousAveragingAsianOption_theta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ContinuousAveragingAsianOption_thetaPerDay_f : c_obj list -> c_obj list = "_wrap_ContinuousAveragingAsianOption_thetaPerDayQuantLib" ;;
let _ContinuousAveragingAsianOption_thetaPerDay arg = match _ContinuousAveragingAsianOption_thetaPerDay_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ContinuousAveragingAsianOption_vega_f : c_obj list -> c_obj list = "_wrap_ContinuousAveragingAsianOption_vegaQuantLib" ;;
let _ContinuousAveragingAsianOption_vega arg = match _ContinuousAveragingAsianOption_vega_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ContinuousAveragingAsianOption_rho_f : c_obj list -> c_obj list = "_wrap_ContinuousAveragingAsianOption_rhoQuantLib" ;;
let _ContinuousAveragingAsianOption_rho arg = match _ContinuousAveragingAsianOption_rho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ContinuousAveragingAsianOption_dividendRho_f : c_obj list -> c_obj list = "_wrap_ContinuousAveragingAsianOption_dividendRhoQuantLib" ;;
let _ContinuousAveragingAsianOption_dividendRho arg = match _ContinuousAveragingAsianOption_dividendRho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ContinuousAveragingAsianOption_strikeSensitivity_f : c_obj list -> c_obj list = "_wrap_ContinuousAveragingAsianOption_strikeSensitivityQuantLib" ;;
let _ContinuousAveragingAsianOption_strikeSensitivity arg = match _ContinuousAveragingAsianOption_strikeSensitivity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ContinuousAveragingAsianOption_f : c_obj list -> c_obj list = "_wrap_delete_ContinuousAveragingAsianOptionQuantLib" ;;
let _delete_ContinuousAveragingAsianOption arg = match _delete_ContinuousAveragingAsianOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DiscreteAveragingAsianOption_f : c_obj list -> c_obj list = "_wrap_new_DiscreteAveragingAsianOptionQuantLib" ;;
let _new_DiscreteAveragingAsianOption arg = match _new_DiscreteAveragingAsianOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscreteAveragingAsianOption_delta_f : c_obj list -> c_obj list = "_wrap_DiscreteAveragingAsianOption_deltaQuantLib" ;;
let _DiscreteAveragingAsianOption_delta arg = match _DiscreteAveragingAsianOption_delta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscreteAveragingAsianOption_gamma_f : c_obj list -> c_obj list = "_wrap_DiscreteAveragingAsianOption_gammaQuantLib" ;;
let _DiscreteAveragingAsianOption_gamma arg = match _DiscreteAveragingAsianOption_gamma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscreteAveragingAsianOption_theta_f : c_obj list -> c_obj list = "_wrap_DiscreteAveragingAsianOption_thetaQuantLib" ;;
let _DiscreteAveragingAsianOption_theta arg = match _DiscreteAveragingAsianOption_theta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscreteAveragingAsianOption_thetaPerDay_f : c_obj list -> c_obj list = "_wrap_DiscreteAveragingAsianOption_thetaPerDayQuantLib" ;;
let _DiscreteAveragingAsianOption_thetaPerDay arg = match _DiscreteAveragingAsianOption_thetaPerDay_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscreteAveragingAsianOption_vega_f : c_obj list -> c_obj list = "_wrap_DiscreteAveragingAsianOption_vegaQuantLib" ;;
let _DiscreteAveragingAsianOption_vega arg = match _DiscreteAveragingAsianOption_vega_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscreteAveragingAsianOption_rho_f : c_obj list -> c_obj list = "_wrap_DiscreteAveragingAsianOption_rhoQuantLib" ;;
let _DiscreteAveragingAsianOption_rho arg = match _DiscreteAveragingAsianOption_rho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscreteAveragingAsianOption_dividendRho_f : c_obj list -> c_obj list = "_wrap_DiscreteAveragingAsianOption_dividendRhoQuantLib" ;;
let _DiscreteAveragingAsianOption_dividendRho arg = match _DiscreteAveragingAsianOption_dividendRho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscreteAveragingAsianOption_strikeSensitivity_f : c_obj list -> c_obj list = "_wrap_DiscreteAveragingAsianOption_strikeSensitivityQuantLib" ;;
let _DiscreteAveragingAsianOption_strikeSensitivity arg = match _DiscreteAveragingAsianOption_strikeSensitivity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DiscreteAveragingAsianOption_f : c_obj list -> c_obj list = "_wrap_delete_DiscreteAveragingAsianOptionQuantLib" ;;
let _delete_DiscreteAveragingAsianOption arg = match _delete_DiscreteAveragingAsianOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticContinuousGeometricAveragePriceAsianEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticContinuousGeometricAveragePriceAsianEngineQuantLib" ;;
let _new_AnalyticContinuousGeometricAveragePriceAsianEngine arg = match _new_AnalyticContinuousGeometricAveragePriceAsianEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticContinuousGeometricAveragePriceAsianEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticContinuousGeometricAveragePriceAsianEngineQuantLib" ;;
let _delete_AnalyticContinuousGeometricAveragePriceAsianEngine arg = match _delete_AnalyticContinuousGeometricAveragePriceAsianEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticDiscreteGeometricAveragePriceAsianEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticDiscreteGeometricAveragePriceAsianEngineQuantLib" ;;
let _new_AnalyticDiscreteGeometricAveragePriceAsianEngine arg = match _new_AnalyticDiscreteGeometricAveragePriceAsianEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticDiscreteGeometricAveragePriceAsianEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticDiscreteGeometricAveragePriceAsianEngineQuantLib" ;;
let _delete_AnalyticDiscreteGeometricAveragePriceAsianEngine arg = match _delete_AnalyticDiscreteGeometricAveragePriceAsianEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticDiscreteGeometricAverageStrikeAsianEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticDiscreteGeometricAverageStrikeAsianEngineQuantLib" ;;
let _new_AnalyticDiscreteGeometricAverageStrikeAsianEngine arg = match _new_AnalyticDiscreteGeometricAverageStrikeAsianEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticDiscreteGeometricAverageStrikeAsianEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticDiscreteGeometricAverageStrikeAsianEngineQuantLib" ;;
let _delete_AnalyticDiscreteGeometricAverageStrikeAsianEngine arg = match _delete_AnalyticDiscreteGeometricAverageStrikeAsianEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticAPEngine__SWIG_0QuantLib" ;;
let _new_MCDiscreteArithmeticAPEngine arg = match _new_MCDiscreteArithmeticAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticAPEngine__SWIG_1QuantLib" ;;
let _new_MCDiscreteArithmeticAPEngine arg = match _new_MCDiscreteArithmeticAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticAPEngine__SWIG_2QuantLib" ;;
let _new_MCDiscreteArithmeticAPEngine arg = match _new_MCDiscreteArithmeticAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticAPEngine__SWIG_3QuantLib" ;;
let _new_MCDiscreteArithmeticAPEngine arg = match _new_MCDiscreteArithmeticAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticAPEngine__SWIG_4QuantLib" ;;
let _new_MCDiscreteArithmeticAPEngine arg = match _new_MCDiscreteArithmeticAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticAPEngine__SWIG_5QuantLib" ;;
let _new_MCDiscreteArithmeticAPEngine arg = match _new_MCDiscreteArithmeticAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticAPEngine__SWIG_6QuantLib" ;;
let _new_MCDiscreteArithmeticAPEngine arg = match _new_MCDiscreteArithmeticAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticAPEngineQuantLib" ;;
let _new_MCDiscreteArithmeticAPEngine arg = match _new_MCDiscreteArithmeticAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MCDiscreteArithmeticAPEngine_f : c_obj list -> c_obj list = "_wrap_delete_MCDiscreteArithmeticAPEngineQuantLib" ;;
let _delete_MCDiscreteArithmeticAPEngine arg = match _delete_MCDiscreteArithmeticAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticASEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticASEngine__SWIG_0QuantLib" ;;
let _new_MCDiscreteArithmeticASEngine arg = match _new_MCDiscreteArithmeticASEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticASEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticASEngine__SWIG_1QuantLib" ;;
let _new_MCDiscreteArithmeticASEngine arg = match _new_MCDiscreteArithmeticASEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticASEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticASEngine__SWIG_2QuantLib" ;;
let _new_MCDiscreteArithmeticASEngine arg = match _new_MCDiscreteArithmeticASEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticASEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticASEngine__SWIG_3QuantLib" ;;
let _new_MCDiscreteArithmeticASEngine arg = match _new_MCDiscreteArithmeticASEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticASEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticASEngine__SWIG_4QuantLib" ;;
let _new_MCDiscreteArithmeticASEngine arg = match _new_MCDiscreteArithmeticASEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticASEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticASEngine__SWIG_5QuantLib" ;;
let _new_MCDiscreteArithmeticASEngine arg = match _new_MCDiscreteArithmeticASEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteArithmeticASEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteArithmeticASEngineQuantLib" ;;
let _new_MCDiscreteArithmeticASEngine arg = match _new_MCDiscreteArithmeticASEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MCDiscreteArithmeticASEngine_f : c_obj list -> c_obj list = "_wrap_delete_MCDiscreteArithmeticASEngineQuantLib" ;;
let _delete_MCDiscreteArithmeticASEngine arg = match _delete_MCDiscreteArithmeticASEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteGeometricAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteGeometricAPEngine__SWIG_0QuantLib" ;;
let _new_MCDiscreteGeometricAPEngine arg = match _new_MCDiscreteGeometricAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteGeometricAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteGeometricAPEngine__SWIG_1QuantLib" ;;
let _new_MCDiscreteGeometricAPEngine arg = match _new_MCDiscreteGeometricAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteGeometricAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteGeometricAPEngine__SWIG_2QuantLib" ;;
let _new_MCDiscreteGeometricAPEngine arg = match _new_MCDiscreteGeometricAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteGeometricAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteGeometricAPEngine__SWIG_3QuantLib" ;;
let _new_MCDiscreteGeometricAPEngine arg = match _new_MCDiscreteGeometricAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteGeometricAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteGeometricAPEngine__SWIG_4QuantLib" ;;
let _new_MCDiscreteGeometricAPEngine arg = match _new_MCDiscreteGeometricAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteGeometricAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteGeometricAPEngine__SWIG_5QuantLib" ;;
let _new_MCDiscreteGeometricAPEngine arg = match _new_MCDiscreteGeometricAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCDiscreteGeometricAPEngine_f : c_obj list -> c_obj list = "_wrap_new_MCDiscreteGeometricAPEngineQuantLib" ;;
let _new_MCDiscreteGeometricAPEngine arg = match _new_MCDiscreteGeometricAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MCDiscreteGeometricAPEngine_f : c_obj list -> c_obj list = "_wrap_delete_MCDiscreteGeometricAPEngineQuantLib" ;;
let _delete_MCDiscreteGeometricAPEngine arg = match _delete_MCDiscreteGeometricAPEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_VarianceGammaEngine_f : c_obj list -> c_obj list = "_wrap_new_VarianceGammaEngineQuantLib" ;;
let _new_VarianceGammaEngine arg = match _new_VarianceGammaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_VarianceGammaEngine_f : c_obj list -> c_obj list = "_wrap_delete_VarianceGammaEngineQuantLib" ;;
let _delete_VarianceGammaEngine arg = match _delete_VarianceGammaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FFTVarianceGammaEngine_f : c_obj list -> c_obj list = "_wrap_new_FFTVarianceGammaEngine__SWIG_0QuantLib" ;;
let _new_FFTVarianceGammaEngine arg = match _new_FFTVarianceGammaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FFTVarianceGammaEngine_f : c_obj list -> c_obj list = "_wrap_new_FFTVarianceGammaEngineQuantLib" ;;
let _new_FFTVarianceGammaEngine arg = match _new_FFTVarianceGammaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FFTVarianceGammaEngine_precalculate_f : c_obj list -> c_obj list = "_wrap_FFTVarianceGammaEngine_precalculateQuantLib" ;;
let _FFTVarianceGammaEngine_precalculate arg = match _FFTVarianceGammaEngine_precalculate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FFTVarianceGammaEngine_f : c_obj list -> c_obj list = "_wrap_delete_FFTVarianceGammaEngineQuantLib" ;;
let _delete_FFTVarianceGammaEngine arg = match _delete_FFTVarianceGammaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DoubleBarrierOption_f : c_obj list -> c_obj list = "_wrap_new_DoubleBarrierOptionQuantLib" ;;
let _new_DoubleBarrierOption arg = match _new_DoubleBarrierOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleBarrierOption_delta_f : c_obj list -> c_obj list = "_wrap_DoubleBarrierOption_deltaQuantLib" ;;
let _DoubleBarrierOption_delta arg = match _DoubleBarrierOption_delta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleBarrierOption_gamma_f : c_obj list -> c_obj list = "_wrap_DoubleBarrierOption_gammaQuantLib" ;;
let _DoubleBarrierOption_gamma arg = match _DoubleBarrierOption_gamma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleBarrierOption_theta_f : c_obj list -> c_obj list = "_wrap_DoubleBarrierOption_thetaQuantLib" ;;
let _DoubleBarrierOption_theta arg = match _DoubleBarrierOption_theta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleBarrierOption_thetaPerDay_f : c_obj list -> c_obj list = "_wrap_DoubleBarrierOption_thetaPerDayQuantLib" ;;
let _DoubleBarrierOption_thetaPerDay arg = match _DoubleBarrierOption_thetaPerDay_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleBarrierOption_vega_f : c_obj list -> c_obj list = "_wrap_DoubleBarrierOption_vegaQuantLib" ;;
let _DoubleBarrierOption_vega arg = match _DoubleBarrierOption_vega_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleBarrierOption_rho_f : c_obj list -> c_obj list = "_wrap_DoubleBarrierOption_rhoQuantLib" ;;
let _DoubleBarrierOption_rho arg = match _DoubleBarrierOption_rho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleBarrierOption_dividendRho_f : c_obj list -> c_obj list = "_wrap_DoubleBarrierOption_dividendRhoQuantLib" ;;
let _DoubleBarrierOption_dividendRho arg = match _DoubleBarrierOption_dividendRho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DoubleBarrierOption_strikeSensitivity_f : c_obj list -> c_obj list = "_wrap_DoubleBarrierOption_strikeSensitivityQuantLib" ;;
let _DoubleBarrierOption_strikeSensitivity arg = match _DoubleBarrierOption_strikeSensitivity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DoubleBarrierOption_f : c_obj list -> c_obj list = "_wrap_delete_DoubleBarrierOptionQuantLib" ;;
let _delete_DoubleBarrierOption arg = match _delete_DoubleBarrierOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_QuantoDoubleBarrierOption_f : c_obj list -> c_obj list = "_wrap_new_QuantoDoubleBarrierOptionQuantLib" ;;
let _new_QuantoDoubleBarrierOption arg = match _new_QuantoDoubleBarrierOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuantoDoubleBarrierOption_qvega_f : c_obj list -> c_obj list = "_wrap_QuantoDoubleBarrierOption_qvegaQuantLib" ;;
let _QuantoDoubleBarrierOption_qvega arg = match _QuantoDoubleBarrierOption_qvega_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuantoDoubleBarrierOption_qrho_f : c_obj list -> c_obj list = "_wrap_QuantoDoubleBarrierOption_qrhoQuantLib" ;;
let _QuantoDoubleBarrierOption_qrho arg = match _QuantoDoubleBarrierOption_qrho_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _QuantoDoubleBarrierOption_qlambda_f : c_obj list -> c_obj list = "_wrap_QuantoDoubleBarrierOption_qlambdaQuantLib" ;;
let _QuantoDoubleBarrierOption_qlambda arg = match _QuantoDoubleBarrierOption_qlambda_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_QuantoDoubleBarrierOption_f : c_obj list -> c_obj list = "_wrap_delete_QuantoDoubleBarrierOptionQuantLib" ;;
let _delete_QuantoDoubleBarrierOption arg = match _delete_QuantoDoubleBarrierOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticDoubleBarrierEngine__SWIG_0QuantLib" ;;
let _new_AnalyticDoubleBarrierEngine arg = match _new_AnalyticDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticDoubleBarrierEngineQuantLib" ;;
let _new_AnalyticDoubleBarrierEngine arg = match _new_AnalyticDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticDoubleBarrierEngineQuantLib" ;;
let _delete_AnalyticDoubleBarrierEngine arg = match _delete_AnalyticDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_WulinYongDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_WulinYongDoubleBarrierEngine__SWIG_0QuantLib" ;;
let _new_WulinYongDoubleBarrierEngine arg = match _new_WulinYongDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_WulinYongDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_WulinYongDoubleBarrierEngineQuantLib" ;;
let _new_WulinYongDoubleBarrierEngine arg = match _new_WulinYongDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_WulinYongDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_delete_WulinYongDoubleBarrierEngineQuantLib" ;;
let _delete_WulinYongDoubleBarrierEngine arg = match _delete_WulinYongDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DeltaVolQuote___deref___f : c_obj list -> c_obj list = "_wrap_DeltaVolQuote___deref__QuantLib" ;;
let _DeltaVolQuote___deref__ arg = match _DeltaVolQuote___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DeltaVolQuote_isNull_f : c_obj list -> c_obj list = "_wrap_DeltaVolQuote_isNullQuantLib" ;;
let _DeltaVolQuote_isNull arg = match _DeltaVolQuote_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DeltaVolQuote_asObservable_f : c_obj list -> c_obj list = "_wrap_DeltaVolQuote_asObservableQuantLib" ;;
let _DeltaVolQuote_asObservable arg = match _DeltaVolQuote_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DeltaVolQuote_Spot : c_obj -> Swig.c_obj = "_wrap_DeltaVolQuote_Spot" 
external _DeltaVolQuote_Fwd : c_obj -> Swig.c_obj = "_wrap_DeltaVolQuote_Fwd" 
external _DeltaVolQuote_PaSpot : c_obj -> Swig.c_obj = "_wrap_DeltaVolQuote_PaSpot" 
external _DeltaVolQuote_PaFwd : c_obj -> Swig.c_obj = "_wrap_DeltaVolQuote_PaFwd" 
external _DeltaVolQuote_AtmNull : c_obj -> Swig.c_obj = "_wrap_DeltaVolQuote_AtmNull" 
external _DeltaVolQuote_AtmSpot : c_obj -> Swig.c_obj = "_wrap_DeltaVolQuote_AtmSpot" 
external _DeltaVolQuote_AtmFwd : c_obj -> Swig.c_obj = "_wrap_DeltaVolQuote_AtmFwd" 
external _DeltaVolQuote_AtmDeltaNeutral : c_obj -> Swig.c_obj = "_wrap_DeltaVolQuote_AtmDeltaNeutral" 
external _DeltaVolQuote_AtmVegaMax : c_obj -> Swig.c_obj = "_wrap_DeltaVolQuote_AtmVegaMax" 
external _DeltaVolQuote_AtmGammaMax : c_obj -> Swig.c_obj = "_wrap_DeltaVolQuote_AtmGammaMax" 
external _DeltaVolQuote_AtmPutCall50 : c_obj -> Swig.c_obj = "_wrap_DeltaVolQuote_AtmPutCall50" 
external _new_DeltaVolQuote_f : c_obj list -> c_obj list = "_wrap_new_DeltaVolQuote__SWIG_0QuantLib" ;;
let _new_DeltaVolQuote arg = match _new_DeltaVolQuote_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DeltaVolQuote_f : c_obj list -> c_obj list = "_wrap_new_DeltaVolQuoteQuantLib" ;;
let _new_DeltaVolQuote arg = match _new_DeltaVolQuote_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DeltaVolQuote_f : c_obj list -> c_obj list = "_wrap_delete_DeltaVolQuoteQuantLib" ;;
let _delete_DeltaVolQuote arg = match _delete_DeltaVolQuote_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DeltaVolQuote_value_f : c_obj list -> c_obj list = "_wrap_DeltaVolQuote_valueQuantLib" ;;
let _DeltaVolQuote_value arg = match _DeltaVolQuote_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DeltaVolQuoteHandle_f : c_obj list -> c_obj list = "_wrap_new_DeltaVolQuoteHandle__SWIG_0QuantLib" ;;
let _new_DeltaVolQuoteHandle arg = match _new_DeltaVolQuoteHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DeltaVolQuoteHandle_f : c_obj list -> c_obj list = "_wrap_new_DeltaVolQuoteHandleQuantLib" ;;
let _new_DeltaVolQuoteHandle arg = match _new_DeltaVolQuoteHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DeltaVolQuoteHandle___deref___f : c_obj list -> c_obj list = "_wrap_DeltaVolQuoteHandle___deref__QuantLib" ;;
let _DeltaVolQuoteHandle___deref__ arg = match _DeltaVolQuoteHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DeltaVolQuoteHandle_empty_f : c_obj list -> c_obj list = "_wrap_DeltaVolQuoteHandle_emptyQuantLib" ;;
let _DeltaVolQuoteHandle_empty arg = match _DeltaVolQuoteHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DeltaVolQuoteHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_DeltaVolQuoteHandle_asObservableQuantLib" ;;
let _DeltaVolQuoteHandle_asObservable arg = match _DeltaVolQuoteHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DeltaVolQuoteHandle_f : c_obj list -> c_obj list = "_wrap_delete_DeltaVolQuoteHandleQuantLib" ;;
let _delete_DeltaVolQuoteHandle arg = match _delete_DeltaVolQuoteHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DeltaVolQuoteHandle_value_f : c_obj list -> c_obj list = "_wrap_DeltaVolQuoteHandle_valueQuantLib" ;;
let _DeltaVolQuoteHandle_value arg = match _DeltaVolQuoteHandle_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableDeltaVolQuoteHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableDeltaVolQuoteHandle__SWIG_0QuantLib" ;;
let _new_RelinkableDeltaVolQuoteHandle arg = match _new_RelinkableDeltaVolQuoteHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableDeltaVolQuoteHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableDeltaVolQuoteHandleQuantLib" ;;
let _new_RelinkableDeltaVolQuoteHandle arg = match _new_RelinkableDeltaVolQuoteHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableDeltaVolQuoteHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableDeltaVolQuoteHandle_linkToQuantLib" ;;
let _RelinkableDeltaVolQuoteHandle_linkTo arg = match _RelinkableDeltaVolQuoteHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableDeltaVolQuoteHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableDeltaVolQuoteHandleQuantLib" ;;
let _delete_RelinkableDeltaVolQuoteHandle arg = match _delete_RelinkableDeltaVolQuoteHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_VannaVolgaDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_VannaVolgaDoubleBarrierEngine__SWIG_0QuantLib" ;;
let _new_VannaVolgaDoubleBarrierEngine arg = match _new_VannaVolgaDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_VannaVolgaDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_VannaVolgaDoubleBarrierEngine__SWIG_1QuantLib" ;;
let _new_VannaVolgaDoubleBarrierEngine arg = match _new_VannaVolgaDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_VannaVolgaDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_VannaVolgaDoubleBarrierEngine__SWIG_2QuantLib" ;;
let _new_VannaVolgaDoubleBarrierEngine arg = match _new_VannaVolgaDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_VannaVolgaDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_VannaVolgaDoubleBarrierEngine__SWIG_3QuantLib" ;;
let _new_VannaVolgaDoubleBarrierEngine arg = match _new_VannaVolgaDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_VannaVolgaDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_VannaVolgaDoubleBarrierEngineQuantLib" ;;
let _new_VannaVolgaDoubleBarrierEngine arg = match _new_VannaVolgaDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_VannaVolgaDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_delete_VannaVolgaDoubleBarrierEngineQuantLib" ;;
let _delete_VannaVolgaDoubleBarrierEngine arg = match _delete_VannaVolgaDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticDoubleBarrierBinaryEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticDoubleBarrierBinaryEngineQuantLib" ;;
let _new_AnalyticDoubleBarrierBinaryEngine arg = match _new_AnalyticDoubleBarrierBinaryEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticDoubleBarrierBinaryEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticDoubleBarrierBinaryEngineQuantLib" ;;
let _delete_AnalyticDoubleBarrierBinaryEngine arg = match _delete_AnalyticDoubleBarrierBinaryEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BinomialDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_new_BinomialDoubleBarrierEngineQuantLib" ;;
let _new_BinomialDoubleBarrierEngine arg = match _new_BinomialDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BinomialDoubleBarrierEngine_f : c_obj list -> c_obj list = "_wrap_delete_BinomialDoubleBarrierEngineQuantLib" ;;
let _delete_BinomialDoubleBarrierEngine arg = match _delete_BinomialDoubleBarrierEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PlainVanillaPayoff_f : c_obj list -> c_obj list = "_wrap_new_PlainVanillaPayoffQuantLib" ;;
let _new_PlainVanillaPayoff arg = match _new_PlainVanillaPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PlainVanillaPayoff_optionType_f : c_obj list -> c_obj list = "_wrap_PlainVanillaPayoff_optionTypeQuantLib" ;;
let _PlainVanillaPayoff_optionType arg = match _PlainVanillaPayoff_optionType_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PlainVanillaPayoff_strike_f : c_obj list -> c_obj list = "_wrap_PlainVanillaPayoff_strikeQuantLib" ;;
let _PlainVanillaPayoff_strike arg = match _PlainVanillaPayoff_strike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PlainVanillaPayoff_f : c_obj list -> c_obj list = "_wrap_delete_PlainVanillaPayoffQuantLib" ;;
let _delete_PlainVanillaPayoff arg = match _delete_PlainVanillaPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PercentageStrikePayoff_f : c_obj list -> c_obj list = "_wrap_new_PercentageStrikePayoffQuantLib" ;;
let _new_PercentageStrikePayoff arg = match _new_PercentageStrikePayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PercentageStrikePayoff_f : c_obj list -> c_obj list = "_wrap_delete_PercentageStrikePayoffQuantLib" ;;
let _delete_PercentageStrikePayoff arg = match _delete_PercentageStrikePayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CashOrNothingPayoff_f : c_obj list -> c_obj list = "_wrap_new_CashOrNothingPayoffQuantLib" ;;
let _new_CashOrNothingPayoff arg = match _new_CashOrNothingPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CashOrNothingPayoff_f : c_obj list -> c_obj list = "_wrap_delete_CashOrNothingPayoffQuantLib" ;;
let _delete_CashOrNothingPayoff arg = match _delete_CashOrNothingPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AssetOrNothingPayoff_f : c_obj list -> c_obj list = "_wrap_new_AssetOrNothingPayoffQuantLib" ;;
let _new_AssetOrNothingPayoff arg = match _new_AssetOrNothingPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AssetOrNothingPayoff_f : c_obj list -> c_obj list = "_wrap_delete_AssetOrNothingPayoffQuantLib" ;;
let _delete_AssetOrNothingPayoff arg = match _delete_AssetOrNothingPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SuperSharePayoff_f : c_obj list -> c_obj list = "_wrap_new_SuperSharePayoffQuantLib" ;;
let _new_SuperSharePayoff arg = match _new_SuperSharePayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SuperSharePayoff_f : c_obj list -> c_obj list = "_wrap_delete_SuperSharePayoffQuantLib" ;;
let _delete_SuperSharePayoff arg = match _delete_SuperSharePayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GapPayoff_f : c_obj list -> c_obj list = "_wrap_new_GapPayoffQuantLib" ;;
let _new_GapPayoff arg = match _new_GapPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GapPayoff_f : c_obj list -> c_obj list = "_wrap_delete_GapPayoffQuantLib" ;;
let _delete_GapPayoff arg = match _delete_GapPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BasketPayoff_f : c_obj list -> c_obj list = "_wrap_new_BasketPayoffQuantLib" ;;
let _new_BasketPayoff arg = match _new_BasketPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BasketPayoff_f : c_obj list -> c_obj list = "_wrap_delete_BasketPayoffQuantLib" ;;
let _delete_BasketPayoff arg = match _delete_BasketPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MinBasketPayoff_f : c_obj list -> c_obj list = "_wrap_new_MinBasketPayoffQuantLib" ;;
let _new_MinBasketPayoff arg = match _new_MinBasketPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MinBasketPayoff_f : c_obj list -> c_obj list = "_wrap_delete_MinBasketPayoffQuantLib" ;;
let _delete_MinBasketPayoff arg = match _delete_MinBasketPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MaxBasketPayoff_f : c_obj list -> c_obj list = "_wrap_new_MaxBasketPayoffQuantLib" ;;
let _new_MaxBasketPayoff arg = match _new_MaxBasketPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MaxBasketPayoff_f : c_obj list -> c_obj list = "_wrap_delete_MaxBasketPayoffQuantLib" ;;
let _delete_MaxBasketPayoff arg = match _delete_MaxBasketPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AverageBasketPayoff_f : c_obj list -> c_obj list = "_wrap_new_AverageBasketPayoff__SWIG_0QuantLib" ;;
let _new_AverageBasketPayoff arg = match _new_AverageBasketPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AverageBasketPayoff_f : c_obj list -> c_obj list = "_wrap_new_AverageBasketPayoffQuantLib" ;;
let _new_AverageBasketPayoff arg = match _new_AverageBasketPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AverageBasketPayoff_f : c_obj list -> c_obj list = "_wrap_delete_AverageBasketPayoffQuantLib" ;;
let _delete_AverageBasketPayoff arg = match _delete_AverageBasketPayoff_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BasketOption_f : c_obj list -> c_obj list = "_wrap_new_BasketOptionQuantLib" ;;
let _new_BasketOption arg = match _new_BasketOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BasketOption_f : c_obj list -> c_obj list = "_wrap_delete_BasketOptionQuantLib" ;;
let _delete_BasketOption arg = match _delete_BasketOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanBasketEngine__SWIG_0QuantLib" ;;
let _new_MCEuropeanBasketEngine arg = match _new_MCEuropeanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanBasketEngine__SWIG_1QuantLib" ;;
let _new_MCEuropeanBasketEngine arg = match _new_MCEuropeanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanBasketEngine__SWIG_2QuantLib" ;;
let _new_MCEuropeanBasketEngine arg = match _new_MCEuropeanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanBasketEngine__SWIG_3QuantLib" ;;
let _new_MCEuropeanBasketEngine arg = match _new_MCEuropeanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanBasketEngine__SWIG_4QuantLib" ;;
let _new_MCEuropeanBasketEngine arg = match _new_MCEuropeanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanBasketEngine__SWIG_5QuantLib" ;;
let _new_MCEuropeanBasketEngine arg = match _new_MCEuropeanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanBasketEngine__SWIG_6QuantLib" ;;
let _new_MCEuropeanBasketEngine arg = match _new_MCEuropeanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanBasketEngine__SWIG_7QuantLib" ;;
let _new_MCEuropeanBasketEngine arg = match _new_MCEuropeanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEuropeanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEuropeanBasketEngineQuantLib" ;;
let _new_MCEuropeanBasketEngine arg = match _new_MCEuropeanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MCEuropeanBasketEngine_f : c_obj list -> c_obj list = "_wrap_delete_MCEuropeanBasketEngineQuantLib" ;;
let _delete_MCEuropeanBasketEngine arg = match _delete_MCEuropeanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCAmericanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCAmericanBasketEngine__SWIG_0QuantLib" ;;
let _new_MCAmericanBasketEngine arg = match _new_MCAmericanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCAmericanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCAmericanBasketEngine__SWIG_1QuantLib" ;;
let _new_MCAmericanBasketEngine arg = match _new_MCAmericanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCAmericanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCAmericanBasketEngine__SWIG_2QuantLib" ;;
let _new_MCAmericanBasketEngine arg = match _new_MCAmericanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCAmericanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCAmericanBasketEngine__SWIG_3QuantLib" ;;
let _new_MCAmericanBasketEngine arg = match _new_MCAmericanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCAmericanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCAmericanBasketEngine__SWIG_4QuantLib" ;;
let _new_MCAmericanBasketEngine arg = match _new_MCAmericanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCAmericanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCAmericanBasketEngine__SWIG_5QuantLib" ;;
let _new_MCAmericanBasketEngine arg = match _new_MCAmericanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCAmericanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCAmericanBasketEngine__SWIG_6QuantLib" ;;
let _new_MCAmericanBasketEngine arg = match _new_MCAmericanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCAmericanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCAmericanBasketEngine__SWIG_7QuantLib" ;;
let _new_MCAmericanBasketEngine arg = match _new_MCAmericanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCAmericanBasketEngine_f : c_obj list -> c_obj list = "_wrap_new_MCAmericanBasketEngineQuantLib" ;;
let _new_MCAmericanBasketEngine arg = match _new_MCAmericanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MCAmericanBasketEngine_f : c_obj list -> c_obj list = "_wrap_delete_MCAmericanBasketEngineQuantLib" ;;
let _delete_MCAmericanBasketEngine arg = match _delete_MCAmericanBasketEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StulzEngine_f : c_obj list -> c_obj list = "_wrap_new_StulzEngineQuantLib" ;;
let _new_StulzEngine arg = match _new_StulzEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_StulzEngine_f : c_obj list -> c_obj list = "_wrap_delete_StulzEngineQuantLib" ;;
let _delete_StulzEngine arg = match _delete_StulzEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EverestOption_f : c_obj list -> c_obj list = "_wrap_new_EverestOptionQuantLib" ;;
let _new_EverestOption arg = match _new_EverestOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EverestOption_f : c_obj list -> c_obj list = "_wrap_delete_EverestOptionQuantLib" ;;
let _delete_EverestOption arg = match _delete_EverestOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEverestEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEverestEngine__SWIG_0QuantLib" ;;
let _new_MCEverestEngine arg = match _new_MCEverestEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEverestEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEverestEngine__SWIG_1QuantLib" ;;
let _new_MCEverestEngine arg = match _new_MCEverestEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEverestEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEverestEngine__SWIG_2QuantLib" ;;
let _new_MCEverestEngine arg = match _new_MCEverestEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEverestEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEverestEngine__SWIG_3QuantLib" ;;
let _new_MCEverestEngine arg = match _new_MCEverestEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEverestEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEverestEngine__SWIG_4QuantLib" ;;
let _new_MCEverestEngine arg = match _new_MCEverestEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEverestEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEverestEngine__SWIG_5QuantLib" ;;
let _new_MCEverestEngine arg = match _new_MCEverestEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEverestEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEverestEngine__SWIG_6QuantLib" ;;
let _new_MCEverestEngine arg = match _new_MCEverestEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEverestEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEverestEngine__SWIG_7QuantLib" ;;
let _new_MCEverestEngine arg = match _new_MCEverestEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCEverestEngine_f : c_obj list -> c_obj list = "_wrap_new_MCEverestEngineQuantLib" ;;
let _new_MCEverestEngine arg = match _new_MCEverestEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MCEverestEngine_f : c_obj list -> c_obj list = "_wrap_delete_MCEverestEngineQuantLib" ;;
let _delete_MCEverestEngine arg = match _delete_MCEverestEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HimalayaOption_f : c_obj list -> c_obj list = "_wrap_new_HimalayaOptionQuantLib" ;;
let _new_HimalayaOption arg = match _new_HimalayaOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HimalayaOption_f : c_obj list -> c_obj list = "_wrap_delete_HimalayaOptionQuantLib" ;;
let _delete_HimalayaOption arg = match _delete_HimalayaOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCHimalayaEngine_f : c_obj list -> c_obj list = "_wrap_new_MCHimalayaEngine__SWIG_0QuantLib" ;;
let _new_MCHimalayaEngine arg = match _new_MCHimalayaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCHimalayaEngine_f : c_obj list -> c_obj list = "_wrap_new_MCHimalayaEngine__SWIG_1QuantLib" ;;
let _new_MCHimalayaEngine arg = match _new_MCHimalayaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCHimalayaEngine_f : c_obj list -> c_obj list = "_wrap_new_MCHimalayaEngine__SWIG_2QuantLib" ;;
let _new_MCHimalayaEngine arg = match _new_MCHimalayaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCHimalayaEngine_f : c_obj list -> c_obj list = "_wrap_new_MCHimalayaEngine__SWIG_3QuantLib" ;;
let _new_MCHimalayaEngine arg = match _new_MCHimalayaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCHimalayaEngine_f : c_obj list -> c_obj list = "_wrap_new_MCHimalayaEngine__SWIG_4QuantLib" ;;
let _new_MCHimalayaEngine arg = match _new_MCHimalayaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCHimalayaEngine_f : c_obj list -> c_obj list = "_wrap_new_MCHimalayaEngine__SWIG_5QuantLib" ;;
let _new_MCHimalayaEngine arg = match _new_MCHimalayaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MCHimalayaEngine_f : c_obj list -> c_obj list = "_wrap_new_MCHimalayaEngineQuantLib" ;;
let _new_MCHimalayaEngine arg = match _new_MCHimalayaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MCHimalayaEngine_f : c_obj list -> c_obj list = "_wrap_delete_MCHimalayaEngineQuantLib" ;;
let _delete_MCHimalayaEngine arg = match _delete_MCHimalayaEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _blackFormula_f : c_obj list -> c_obj list = "_wrap_blackFormula__SWIG_0QuantLib" ;;
let _blackFormula arg = match _blackFormula_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _blackFormula_f : c_obj list -> c_obj list = "_wrap_blackFormula__SWIG_1QuantLib" ;;
let _blackFormula arg = match _blackFormula_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _blackFormula_f : c_obj list -> c_obj list = "_wrap_blackFormulaQuantLib" ;;
let _blackFormula arg = match _blackFormula_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _blackFormulaImpliedStdDev_f : c_obj list -> c_obj list = "_wrap_blackFormulaImpliedStdDev__SWIG_0QuantLib" ;;
let _blackFormulaImpliedStdDev arg = match _blackFormulaImpliedStdDev_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _blackFormulaImpliedStdDev_f : c_obj list -> c_obj list = "_wrap_blackFormulaImpliedStdDev__SWIG_1QuantLib" ;;
let _blackFormulaImpliedStdDev arg = match _blackFormulaImpliedStdDev_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _blackFormulaImpliedStdDev_f : c_obj list -> c_obj list = "_wrap_blackFormulaImpliedStdDev__SWIG_2QuantLib" ;;
let _blackFormulaImpliedStdDev arg = match _blackFormulaImpliedStdDev_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _blackFormulaImpliedStdDev_f : c_obj list -> c_obj list = "_wrap_blackFormulaImpliedStdDev__SWIG_3QuantLib" ;;
let _blackFormulaImpliedStdDev arg = match _blackFormulaImpliedStdDev_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _blackFormulaImpliedStdDev_f : c_obj list -> c_obj list = "_wrap_blackFormulaImpliedStdDev__SWIG_4QuantLib" ;;
let _blackFormulaImpliedStdDev arg = match _blackFormulaImpliedStdDev_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _blackFormulaImpliedStdDev_f : c_obj list -> c_obj list = "_wrap_blackFormulaImpliedStdDevQuantLib" ;;
let _blackFormulaImpliedStdDev arg = match _blackFormulaImpliedStdDev_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _blackFormulaCashItmProbability_f : c_obj list -> c_obj list = "_wrap_blackFormulaCashItmProbability__SWIG_0QuantLib" ;;
let _blackFormulaCashItmProbability arg = match _blackFormulaCashItmProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _blackFormulaCashItmProbability_f : c_obj list -> c_obj list = "_wrap_blackFormulaCashItmProbabilityQuantLib" ;;
let _blackFormulaCashItmProbability arg = match _blackFormulaCashItmProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _bachelierBlackFormula_f : c_obj list -> c_obj list = "_wrap_bachelierBlackFormula__SWIG_0QuantLib" ;;
let _bachelierBlackFormula arg = match _bachelierBlackFormula_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _bachelierBlackFormula_f : c_obj list -> c_obj list = "_wrap_bachelierBlackFormulaQuantLib" ;;
let _bachelierBlackFormula arg = match _bachelierBlackFormula_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _bachelierBlackFormulaImpliedVol_f : c_obj list -> c_obj list = "_wrap_bachelierBlackFormulaImpliedVol__SWIG_0QuantLib" ;;
let _bachelierBlackFormulaImpliedVol arg = match _bachelierBlackFormulaImpliedVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _bachelierBlackFormulaImpliedVol_f : c_obj list -> c_obj list = "_wrap_bachelierBlackFormulaImpliedVolQuantLib" ;;
let _bachelierBlackFormulaImpliedVol arg = match _bachelierBlackFormulaImpliedVol_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackDeltaCalculator_f : c_obj list -> c_obj list = "_wrap_new_BlackDeltaCalculatorQuantLib" ;;
let _new_BlackDeltaCalculator arg = match _new_BlackDeltaCalculator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackDeltaCalculator_deltaFromStrike_f : c_obj list -> c_obj list = "_wrap_BlackDeltaCalculator_deltaFromStrikeQuantLib" ;;
let _BlackDeltaCalculator_deltaFromStrike arg = match _BlackDeltaCalculator_deltaFromStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackDeltaCalculator_strikeFromDelta_f : c_obj list -> c_obj list = "_wrap_BlackDeltaCalculator_strikeFromDeltaQuantLib" ;;
let _BlackDeltaCalculator_strikeFromDelta arg = match _BlackDeltaCalculator_strikeFromDelta_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackDeltaCalculator_atmStrike_f : c_obj list -> c_obj list = "_wrap_BlackDeltaCalculator_atmStrikeQuantLib" ;;
let _BlackDeltaCalculator_atmStrike arg = match _BlackDeltaCalculator_atmStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackDeltaCalculator_f : c_obj list -> c_obj list = "_wrap_delete_BlackDeltaCalculatorQuantLib" ;;
let _delete_BlackDeltaCalculator arg = match _delete_BlackDeltaCalculator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "CallabilityPrice::Type_marker" (`Type)
external _Dirty : c_obj -> Swig.c_obj = "_wrap_Dirty" 
external _Clean : c_obj -> Swig.c_obj = "_wrap_Clean" 
external _new_CallabilityPrice_f : c_obj list -> c_obj list = "_wrap_new_CallabilityPriceQuantLib" ;;
let _new_CallabilityPrice arg = match _new_CallabilityPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CallabilityPrice_amount_f : c_obj list -> c_obj list = "_wrap_CallabilityPrice_amountQuantLib" ;;
let _CallabilityPrice_amount arg = match _CallabilityPrice_amount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CallabilityPrice_type_f : c_obj list -> c_obj list = "_wrap_CallabilityPrice_typeQuantLib" ;;
let _CallabilityPrice_type arg = match _CallabilityPrice_type_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CallabilityPrice_f : c_obj list -> c_obj list = "_wrap_delete_CallabilityPriceQuantLib" ;;
let _delete_CallabilityPrice arg = match _delete_CallabilityPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Callability___deref___f : c_obj list -> c_obj list = "_wrap_Callability___deref__QuantLib" ;;
let _Callability___deref__ arg = match _Callability___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Callability_isNull_f : c_obj list -> c_obj list = "_wrap_Callability_isNullQuantLib" ;;
let _Callability_isNull arg = match _Callability_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Callability_f : c_obj list -> c_obj list = "_wrap_new_CallabilityQuantLib" ;;
let _new_Callability arg = match _new_Callability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Callability_Call : c_obj -> Swig.c_obj = "_wrap_Callability_Call" 
external _Callability_Put : c_obj -> Swig.c_obj = "_wrap_Callability_Put" 
external _delete_Callability_f : c_obj list -> c_obj list = "_wrap_delete_CallabilityQuantLib" ;;
let _delete_Callability arg = match _delete_Callability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Callability_price_f : c_obj list -> c_obj list = "_wrap_Callability_priceQuantLib" ;;
let _Callability_price arg = match _Callability_price_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Callability_type_f : c_obj list -> c_obj list = "_wrap_Callability_typeQuantLib" ;;
let _Callability_type arg = match _Callability_type_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Callability_date_f : c_obj list -> c_obj list = "_wrap_Callability_dateQuantLib" ;;
let _Callability_date arg = match _Callability_date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SoftCallability_f : c_obj list -> c_obj list = "_wrap_new_SoftCallabilityQuantLib" ;;
let _new_SoftCallability arg = match _new_SoftCallability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SoftCallability_f : c_obj list -> c_obj list = "_wrap_delete_SoftCallabilityQuantLib" ;;
let _delete_SoftCallability arg = match _delete_SoftCallability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CallabilitySchedule_f : c_obj list -> c_obj list = "_wrap_new_CallabilitySchedule__SWIG_0QuantLib" ;;
let _new_CallabilitySchedule arg = match _new_CallabilitySchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CallabilitySchedule_f : c_obj list -> c_obj list = "_wrap_new_CallabilitySchedule__SWIG_1QuantLib" ;;
let _new_CallabilitySchedule arg = match _new_CallabilitySchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CallabilitySchedule_f : c_obj list -> c_obj list = "_wrap_new_CallabilitySchedule__SWIG_2QuantLib" ;;
let _new_CallabilitySchedule arg = match _new_CallabilitySchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CallabilitySchedule_f : c_obj list -> c_obj list = "_wrap_new_CallabilityScheduleQuantLib" ;;
let _new_CallabilitySchedule arg = match _new_CallabilitySchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CallabilitySchedule_size_f : c_obj list -> c_obj list = "_wrap_CallabilitySchedule_sizeQuantLib" ;;
let _CallabilitySchedule_size arg = match _CallabilitySchedule_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CallabilitySchedule_empty_f : c_obj list -> c_obj list = "_wrap_CallabilitySchedule_emptyQuantLib" ;;
let _CallabilitySchedule_empty arg = match _CallabilitySchedule_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CallabilitySchedule_clear_f : c_obj list -> c_obj list = "_wrap_CallabilitySchedule_clearQuantLib" ;;
let _CallabilitySchedule_clear arg = match _CallabilitySchedule_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CallabilitySchedule_push_back_f : c_obj list -> c_obj list = "_wrap_CallabilitySchedule_push_backQuantLib" ;;
let _CallabilitySchedule_push_back arg = match _CallabilitySchedule_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CallabilitySchedule_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_CallabilitySchedule_operator_bB___QuantLib" ;;
let _CallabilitySchedule_operator_xx_xx_lbrace_xx_rbrace arg = match _CallabilitySchedule_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CallabilitySchedule_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_CallabilitySchedule_operator_e___QuantLib" ;;
let _CallabilitySchedule_operator_xx_xx_equals arg = match _CallabilitySchedule_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CallabilitySchedule_set_f : c_obj list -> c_obj list = "_wrap_CallabilitySchedule_setQuantLib" ;;
let _CallabilitySchedule_set arg = match _CallabilitySchedule_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CallabilitySchedule_to_array_f : c_obj list -> c_obj list = "_wrap_CallabilitySchedule_to_arrayQuantLib" ;;
let _CallabilitySchedule_to_array arg = match _CallabilitySchedule_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CallabilitySchedule_f : c_obj list -> c_obj list = "_wrap_delete_CallabilityScheduleQuantLib" ;;
let _delete_CallabilitySchedule arg = match _delete_CallabilitySchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Seasonality___deref___f : c_obj list -> c_obj list = "_wrap_Seasonality___deref__QuantLib" ;;
let _Seasonality___deref__ arg = match _Seasonality___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Seasonality_isNull_f : c_obj list -> c_obj list = "_wrap_Seasonality_isNullQuantLib" ;;
let _Seasonality_isNull arg = match _Seasonality_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Seasonality_f : c_obj list -> c_obj list = "_wrap_new_SeasonalityQuantLib" ;;
let _new_Seasonality arg = match _new_Seasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Seasonality_f : c_obj list -> c_obj list = "_wrap_delete_SeasonalityQuantLib" ;;
let _delete_Seasonality arg = match _delete_Seasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Seasonality_correctZeroRate_f : c_obj list -> c_obj list = "_wrap_Seasonality_correctZeroRateQuantLib" ;;
let _Seasonality_correctZeroRate arg = match _Seasonality_correctZeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Seasonality_correctYoYRate_f : c_obj list -> c_obj list = "_wrap_Seasonality_correctYoYRateQuantLib" ;;
let _Seasonality_correctYoYRate arg = match _Seasonality_correctYoYRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Seasonality_isConsistent_f : c_obj list -> c_obj list = "_wrap_Seasonality_isConsistentQuantLib" ;;
let _Seasonality_isConsistent arg = match _Seasonality_isConsistent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MultiplicativePriceSeasonalityPtr_f : c_obj list -> c_obj list = "_wrap_new_MultiplicativePriceSeasonalityPtrQuantLib" ;;
let _new_MultiplicativePriceSeasonalityPtr arg = match _new_MultiplicativePriceSeasonalityPtr_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MultiplicativePriceSeasonalityPtr_f : c_obj list -> c_obj list = "_wrap_delete_MultiplicativePriceSeasonalityPtrQuantLib" ;;
let _delete_MultiplicativePriceSeasonalityPtr arg = match _delete_MultiplicativePriceSeasonalityPtr_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure___deref___f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure___deref__QuantLib" ;;
let _YoYInflationTermStructure___deref__ arg = match _YoYInflationTermStructure___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_isNull_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_isNullQuantLib" ;;
let _YoYInflationTermStructure_isNull arg = match _YoYInflationTermStructure_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_asObservable_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_asObservableQuantLib" ;;
let _YoYInflationTermStructure_asObservable arg = match _YoYInflationTermStructure_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YoYInflationTermStructure_f : c_obj list -> c_obj list = "_wrap_new_YoYInflationTermStructureQuantLib" ;;
let _new_YoYInflationTermStructure arg = match _new_YoYInflationTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YoYInflationTermStructure_f : c_obj list -> c_obj list = "_wrap_delete_YoYInflationTermStructureQuantLib" ;;
let _delete_YoYInflationTermStructure arg = match _delete_YoYInflationTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_yoyRate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_yoyRate__SWIG_0QuantLib" ;;
let _YoYInflationTermStructure_yoyRate arg = match _YoYInflationTermStructure_yoyRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_yoyRate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_yoyRate__SWIG_1QuantLib" ;;
let _YoYInflationTermStructure_yoyRate arg = match _YoYInflationTermStructure_yoyRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_yoyRate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_yoyRate__SWIG_2QuantLib" ;;
let _YoYInflationTermStructure_yoyRate arg = match _YoYInflationTermStructure_yoyRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_yoyRate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_yoyRateQuantLib" ;;
let _YoYInflationTermStructure_yoyRate arg = match _YoYInflationTermStructure_yoyRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_dayCounter_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_dayCounterQuantLib" ;;
let _YoYInflationTermStructure_dayCounter arg = match _YoYInflationTermStructure_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_calendar_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_calendarQuantLib" ;;
let _YoYInflationTermStructure_calendar arg = match _YoYInflationTermStructure_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_referenceDate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_referenceDateQuantLib" ;;
let _YoYInflationTermStructure_referenceDate arg = match _YoYInflationTermStructure_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_maxDate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_maxDateQuantLib" ;;
let _YoYInflationTermStructure_maxDate arg = match _YoYInflationTermStructure_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_maxTime_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_maxTimeQuantLib" ;;
let _YoYInflationTermStructure_maxTime arg = match _YoYInflationTermStructure_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_observationLag_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_observationLagQuantLib" ;;
let _YoYInflationTermStructure_observationLag arg = match _YoYInflationTermStructure_observationLag_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_frequency_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_frequencyQuantLib" ;;
let _YoYInflationTermStructure_frequency arg = match _YoYInflationTermStructure_frequency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_indexIsInterpolated_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_indexIsInterpolatedQuantLib" ;;
let _YoYInflationTermStructure_indexIsInterpolated arg = match _YoYInflationTermStructure_indexIsInterpolated_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_baseRate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_baseRateQuantLib" ;;
let _YoYInflationTermStructure_baseRate arg = match _YoYInflationTermStructure_baseRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_nominalTermStructure_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_nominalTermStructureQuantLib" ;;
let _YoYInflationTermStructure_nominalTermStructure arg = match _YoYInflationTermStructure_nominalTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_baseDate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_baseDateQuantLib" ;;
let _YoYInflationTermStructure_baseDate arg = match _YoYInflationTermStructure_baseDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_setSeasonality_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_setSeasonality__SWIG_0QuantLib" ;;
let _YoYInflationTermStructure_setSeasonality arg = match _YoYInflationTermStructure_setSeasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_setSeasonality_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_setSeasonalityQuantLib" ;;
let _YoYInflationTermStructure_setSeasonality arg = match _YoYInflationTermStructure_setSeasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_seasonality_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_seasonalityQuantLib" ;;
let _YoYInflationTermStructure_seasonality arg = match _YoYInflationTermStructure_seasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_hasSeasonality_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_hasSeasonalityQuantLib" ;;
let _YoYInflationTermStructure_hasSeasonality arg = match _YoYInflationTermStructure_hasSeasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_enableExtrapolationQuantLib" ;;
let _YoYInflationTermStructure_enableExtrapolation arg = match _YoYInflationTermStructure_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_disableExtrapolationQuantLib" ;;
let _YoYInflationTermStructure_disableExtrapolation arg = match _YoYInflationTermStructure_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructure_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructure_allowsExtrapolationQuantLib" ;;
let _YoYInflationTermStructure_allowsExtrapolation arg = match _YoYInflationTermStructure_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YoYInflationTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_YoYInflationTermStructureHandle__SWIG_0QuantLib" ;;
let _new_YoYInflationTermStructureHandle arg = match _new_YoYInflationTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YoYInflationTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_YoYInflationTermStructureHandleQuantLib" ;;
let _new_YoYInflationTermStructureHandle arg = match _new_YoYInflationTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle___deref___f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle___deref__QuantLib" ;;
let _YoYInflationTermStructureHandle___deref__ arg = match _YoYInflationTermStructureHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_empty_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_emptyQuantLib" ;;
let _YoYInflationTermStructureHandle_empty arg = match _YoYInflationTermStructureHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_asObservableQuantLib" ;;
let _YoYInflationTermStructureHandle_asObservable arg = match _YoYInflationTermStructureHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YoYInflationTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_YoYInflationTermStructureHandleQuantLib" ;;
let _delete_YoYInflationTermStructureHandle arg = match _delete_YoYInflationTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_yoyRate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_yoyRate__SWIG_0QuantLib" ;;
let _YoYInflationTermStructureHandle_yoyRate arg = match _YoYInflationTermStructureHandle_yoyRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_yoyRate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_yoyRate__SWIG_1QuantLib" ;;
let _YoYInflationTermStructureHandle_yoyRate arg = match _YoYInflationTermStructureHandle_yoyRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_yoyRate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_yoyRate__SWIG_2QuantLib" ;;
let _YoYInflationTermStructureHandle_yoyRate arg = match _YoYInflationTermStructureHandle_yoyRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_yoyRate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_yoyRateQuantLib" ;;
let _YoYInflationTermStructureHandle_yoyRate arg = match _YoYInflationTermStructureHandle_yoyRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_dayCounter_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_dayCounterQuantLib" ;;
let _YoYInflationTermStructureHandle_dayCounter arg = match _YoYInflationTermStructureHandle_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_calendar_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_calendarQuantLib" ;;
let _YoYInflationTermStructureHandle_calendar arg = match _YoYInflationTermStructureHandle_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_referenceDate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_referenceDateQuantLib" ;;
let _YoYInflationTermStructureHandle_referenceDate arg = match _YoYInflationTermStructureHandle_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_maxDate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_maxDateQuantLib" ;;
let _YoYInflationTermStructureHandle_maxDate arg = match _YoYInflationTermStructureHandle_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_maxTime_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_maxTimeQuantLib" ;;
let _YoYInflationTermStructureHandle_maxTime arg = match _YoYInflationTermStructureHandle_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_observationLag_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_observationLagQuantLib" ;;
let _YoYInflationTermStructureHandle_observationLag arg = match _YoYInflationTermStructureHandle_observationLag_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_frequency_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_frequencyQuantLib" ;;
let _YoYInflationTermStructureHandle_frequency arg = match _YoYInflationTermStructureHandle_frequency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_indexIsInterpolated_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_indexIsInterpolatedQuantLib" ;;
let _YoYInflationTermStructureHandle_indexIsInterpolated arg = match _YoYInflationTermStructureHandle_indexIsInterpolated_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_baseRate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_baseRateQuantLib" ;;
let _YoYInflationTermStructureHandle_baseRate arg = match _YoYInflationTermStructureHandle_baseRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_nominalTermStructure_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_nominalTermStructureQuantLib" ;;
let _YoYInflationTermStructureHandle_nominalTermStructure arg = match _YoYInflationTermStructureHandle_nominalTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_baseDate_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_baseDateQuantLib" ;;
let _YoYInflationTermStructureHandle_baseDate arg = match _YoYInflationTermStructureHandle_baseDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_setSeasonality_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_setSeasonality__SWIG_0QuantLib" ;;
let _YoYInflationTermStructureHandle_setSeasonality arg = match _YoYInflationTermStructureHandle_setSeasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_setSeasonality_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_setSeasonalityQuantLib" ;;
let _YoYInflationTermStructureHandle_setSeasonality arg = match _YoYInflationTermStructureHandle_setSeasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_seasonality_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_seasonalityQuantLib" ;;
let _YoYInflationTermStructureHandle_seasonality arg = match _YoYInflationTermStructureHandle_seasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_hasSeasonality_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_hasSeasonalityQuantLib" ;;
let _YoYInflationTermStructureHandle_hasSeasonality arg = match _YoYInflationTermStructureHandle_hasSeasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_enableExtrapolationQuantLib" ;;
let _YoYInflationTermStructureHandle_enableExtrapolation arg = match _YoYInflationTermStructureHandle_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_disableExtrapolationQuantLib" ;;
let _YoYInflationTermStructureHandle_disableExtrapolation arg = match _YoYInflationTermStructureHandle_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationTermStructureHandle_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_YoYInflationTermStructureHandle_allowsExtrapolationQuantLib" ;;
let _YoYInflationTermStructureHandle_allowsExtrapolation arg = match _YoYInflationTermStructureHandle_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableYoYInflationTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableYoYInflationTermStructureHandle__SWIG_0QuantLib" ;;
let _new_RelinkableYoYInflationTermStructureHandle arg = match _new_RelinkableYoYInflationTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableYoYInflationTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableYoYInflationTermStructureHandleQuantLib" ;;
let _new_RelinkableYoYInflationTermStructureHandle arg = match _new_RelinkableYoYInflationTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableYoYInflationTermStructureHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableYoYInflationTermStructureHandle_linkToQuantLib" ;;
let _RelinkableYoYInflationTermStructureHandle_linkTo arg = match _RelinkableYoYInflationTermStructureHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableYoYInflationTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableYoYInflationTermStructureHandleQuantLib" ;;
let _delete_RelinkableYoYInflationTermStructureHandle arg = match _delete_RelinkableYoYInflationTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure___deref___f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure___deref__QuantLib" ;;
let _ZeroInflationTermStructure___deref__ arg = match _ZeroInflationTermStructure___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_isNull_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_isNullQuantLib" ;;
let _ZeroInflationTermStructure_isNull arg = match _ZeroInflationTermStructure_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_asObservable_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_asObservableQuantLib" ;;
let _ZeroInflationTermStructure_asObservable arg = match _ZeroInflationTermStructure_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroInflationTermStructure_f : c_obj list -> c_obj list = "_wrap_new_ZeroInflationTermStructureQuantLib" ;;
let _new_ZeroInflationTermStructure arg = match _new_ZeroInflationTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZeroInflationTermStructure_f : c_obj list -> c_obj list = "_wrap_delete_ZeroInflationTermStructureQuantLib" ;;
let _delete_ZeroInflationTermStructure arg = match _delete_ZeroInflationTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_zeroRate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_zeroRate__SWIG_0QuantLib" ;;
let _ZeroInflationTermStructure_zeroRate arg = match _ZeroInflationTermStructure_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_zeroRate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_zeroRate__SWIG_1QuantLib" ;;
let _ZeroInflationTermStructure_zeroRate arg = match _ZeroInflationTermStructure_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_zeroRate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_zeroRate__SWIG_2QuantLib" ;;
let _ZeroInflationTermStructure_zeroRate arg = match _ZeroInflationTermStructure_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_zeroRate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_zeroRateQuantLib" ;;
let _ZeroInflationTermStructure_zeroRate arg = match _ZeroInflationTermStructure_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_dayCounter_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_dayCounterQuantLib" ;;
let _ZeroInflationTermStructure_dayCounter arg = match _ZeroInflationTermStructure_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_calendar_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_calendarQuantLib" ;;
let _ZeroInflationTermStructure_calendar arg = match _ZeroInflationTermStructure_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_referenceDate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_referenceDateQuantLib" ;;
let _ZeroInflationTermStructure_referenceDate arg = match _ZeroInflationTermStructure_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_maxDate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_maxDateQuantLib" ;;
let _ZeroInflationTermStructure_maxDate arg = match _ZeroInflationTermStructure_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_maxTime_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_maxTimeQuantLib" ;;
let _ZeroInflationTermStructure_maxTime arg = match _ZeroInflationTermStructure_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_observationLag_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_observationLagQuantLib" ;;
let _ZeroInflationTermStructure_observationLag arg = match _ZeroInflationTermStructure_observationLag_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_frequency_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_frequencyQuantLib" ;;
let _ZeroInflationTermStructure_frequency arg = match _ZeroInflationTermStructure_frequency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_indexIsInterpolated_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_indexIsInterpolatedQuantLib" ;;
let _ZeroInflationTermStructure_indexIsInterpolated arg = match _ZeroInflationTermStructure_indexIsInterpolated_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_baseRate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_baseRateQuantLib" ;;
let _ZeroInflationTermStructure_baseRate arg = match _ZeroInflationTermStructure_baseRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_nominalTermStructure_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_nominalTermStructureQuantLib" ;;
let _ZeroInflationTermStructure_nominalTermStructure arg = match _ZeroInflationTermStructure_nominalTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_baseDate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_baseDateQuantLib" ;;
let _ZeroInflationTermStructure_baseDate arg = match _ZeroInflationTermStructure_baseDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_setSeasonality_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_setSeasonality__SWIG_0QuantLib" ;;
let _ZeroInflationTermStructure_setSeasonality arg = match _ZeroInflationTermStructure_setSeasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_setSeasonality_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_setSeasonalityQuantLib" ;;
let _ZeroInflationTermStructure_setSeasonality arg = match _ZeroInflationTermStructure_setSeasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_seasonality_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_seasonalityQuantLib" ;;
let _ZeroInflationTermStructure_seasonality arg = match _ZeroInflationTermStructure_seasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_hasSeasonality_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_hasSeasonalityQuantLib" ;;
let _ZeroInflationTermStructure_hasSeasonality arg = match _ZeroInflationTermStructure_hasSeasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_enableExtrapolationQuantLib" ;;
let _ZeroInflationTermStructure_enableExtrapolation arg = match _ZeroInflationTermStructure_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_disableExtrapolationQuantLib" ;;
let _ZeroInflationTermStructure_disableExtrapolation arg = match _ZeroInflationTermStructure_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructure_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructure_allowsExtrapolationQuantLib" ;;
let _ZeroInflationTermStructure_allowsExtrapolation arg = match _ZeroInflationTermStructure_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroInflationTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_ZeroInflationTermStructureHandle__SWIG_0QuantLib" ;;
let _new_ZeroInflationTermStructureHandle arg = match _new_ZeroInflationTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroInflationTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_ZeroInflationTermStructureHandleQuantLib" ;;
let _new_ZeroInflationTermStructureHandle arg = match _new_ZeroInflationTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle___deref___f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle___deref__QuantLib" ;;
let _ZeroInflationTermStructureHandle___deref__ arg = match _ZeroInflationTermStructureHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_empty_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_emptyQuantLib" ;;
let _ZeroInflationTermStructureHandle_empty arg = match _ZeroInflationTermStructureHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_asObservableQuantLib" ;;
let _ZeroInflationTermStructureHandle_asObservable arg = match _ZeroInflationTermStructureHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZeroInflationTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_ZeroInflationTermStructureHandleQuantLib" ;;
let _delete_ZeroInflationTermStructureHandle arg = match _delete_ZeroInflationTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_zeroRate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_zeroRate__SWIG_0QuantLib" ;;
let _ZeroInflationTermStructureHandle_zeroRate arg = match _ZeroInflationTermStructureHandle_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_zeroRate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_zeroRate__SWIG_1QuantLib" ;;
let _ZeroInflationTermStructureHandle_zeroRate arg = match _ZeroInflationTermStructureHandle_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_zeroRate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_zeroRate__SWIG_2QuantLib" ;;
let _ZeroInflationTermStructureHandle_zeroRate arg = match _ZeroInflationTermStructureHandle_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_zeroRate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_zeroRateQuantLib" ;;
let _ZeroInflationTermStructureHandle_zeroRate arg = match _ZeroInflationTermStructureHandle_zeroRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_dayCounter_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_dayCounterQuantLib" ;;
let _ZeroInflationTermStructureHandle_dayCounter arg = match _ZeroInflationTermStructureHandle_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_calendar_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_calendarQuantLib" ;;
let _ZeroInflationTermStructureHandle_calendar arg = match _ZeroInflationTermStructureHandle_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_referenceDate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_referenceDateQuantLib" ;;
let _ZeroInflationTermStructureHandle_referenceDate arg = match _ZeroInflationTermStructureHandle_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_maxDate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_maxDateQuantLib" ;;
let _ZeroInflationTermStructureHandle_maxDate arg = match _ZeroInflationTermStructureHandle_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_maxTime_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_maxTimeQuantLib" ;;
let _ZeroInflationTermStructureHandle_maxTime arg = match _ZeroInflationTermStructureHandle_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_observationLag_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_observationLagQuantLib" ;;
let _ZeroInflationTermStructureHandle_observationLag arg = match _ZeroInflationTermStructureHandle_observationLag_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_frequency_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_frequencyQuantLib" ;;
let _ZeroInflationTermStructureHandle_frequency arg = match _ZeroInflationTermStructureHandle_frequency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_indexIsInterpolated_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_indexIsInterpolatedQuantLib" ;;
let _ZeroInflationTermStructureHandle_indexIsInterpolated arg = match _ZeroInflationTermStructureHandle_indexIsInterpolated_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_baseRate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_baseRateQuantLib" ;;
let _ZeroInflationTermStructureHandle_baseRate arg = match _ZeroInflationTermStructureHandle_baseRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_nominalTermStructure_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_nominalTermStructureQuantLib" ;;
let _ZeroInflationTermStructureHandle_nominalTermStructure arg = match _ZeroInflationTermStructureHandle_nominalTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_baseDate_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_baseDateQuantLib" ;;
let _ZeroInflationTermStructureHandle_baseDate arg = match _ZeroInflationTermStructureHandle_baseDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_setSeasonality_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_setSeasonality__SWIG_0QuantLib" ;;
let _ZeroInflationTermStructureHandle_setSeasonality arg = match _ZeroInflationTermStructureHandle_setSeasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_setSeasonality_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_setSeasonalityQuantLib" ;;
let _ZeroInflationTermStructureHandle_setSeasonality arg = match _ZeroInflationTermStructureHandle_setSeasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_seasonality_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_seasonalityQuantLib" ;;
let _ZeroInflationTermStructureHandle_seasonality arg = match _ZeroInflationTermStructureHandle_seasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_hasSeasonality_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_hasSeasonalityQuantLib" ;;
let _ZeroInflationTermStructureHandle_hasSeasonality arg = match _ZeroInflationTermStructureHandle_hasSeasonality_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_enableExtrapolationQuantLib" ;;
let _ZeroInflationTermStructureHandle_enableExtrapolation arg = match _ZeroInflationTermStructureHandle_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_disableExtrapolationQuantLib" ;;
let _ZeroInflationTermStructureHandle_disableExtrapolation arg = match _ZeroInflationTermStructureHandle_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroInflationTermStructureHandle_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_ZeroInflationTermStructureHandle_allowsExtrapolationQuantLib" ;;
let _ZeroInflationTermStructureHandle_allowsExtrapolation arg = match _ZeroInflationTermStructureHandle_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableZeroInflationTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableZeroInflationTermStructureHandle__SWIG_0QuantLib" ;;
let _new_RelinkableZeroInflationTermStructureHandle arg = match _new_RelinkableZeroInflationTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableZeroInflationTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableZeroInflationTermStructureHandleQuantLib" ;;
let _new_RelinkableZeroInflationTermStructureHandle arg = match _new_RelinkableZeroInflationTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableZeroInflationTermStructureHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableZeroInflationTermStructureHandle_linkToQuantLib" ;;
let _RelinkableZeroInflationTermStructureHandle_linkTo arg = match _RelinkableZeroInflationTermStructureHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableZeroInflationTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableZeroInflationTermStructureHandleQuantLib" ;;
let _delete_RelinkableZeroInflationTermStructureHandle arg = match _delete_RelinkableZeroInflationTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Region_name_f : c_obj list -> c_obj list = "_wrap_Region_nameQuantLib" ;;
let _Region_name arg = match _Region_name_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Region_code_f : c_obj list -> c_obj list = "_wrap_Region_codeQuantLib" ;;
let _Region_code arg = match _Region_code_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Region_f : c_obj list -> c_obj list = "_wrap_delete_RegionQuantLib" ;;
let _delete_Region arg = match _delete_Region_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CustomRegion_f : c_obj list -> c_obj list = "_wrap_new_CustomRegionQuantLib" ;;
let _new_CustomRegion arg = match _new_CustomRegion_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CustomRegion_f : c_obj list -> c_obj list = "_wrap_delete_CustomRegionQuantLib" ;;
let _delete_CustomRegion arg = match _delete_CustomRegion_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InflationIndex_interpolated_f : c_obj list -> c_obj list = "_wrap_InflationIndex_interpolatedQuantLib" ;;
let _InflationIndex_interpolated arg = match _InflationIndex_interpolated_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InflationIndex_frequency_f : c_obj list -> c_obj list = "_wrap_InflationIndex_frequencyQuantLib" ;;
let _InflationIndex_frequency arg = match _InflationIndex_frequency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InflationIndex_availabilityLag_f : c_obj list -> c_obj list = "_wrap_InflationIndex_availabilityLagQuantLib" ;;
let _InflationIndex_availabilityLag arg = match _InflationIndex_availabilityLag_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InflationIndex_currency_f : c_obj list -> c_obj list = "_wrap_InflationIndex_currencyQuantLib" ;;
let _InflationIndex_currency arg = match _InflationIndex_currency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InflationIndex_f : c_obj list -> c_obj list = "_wrap_delete_InflationIndexQuantLib" ;;
let _delete_InflationIndex arg = match _delete_InflationIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroInflationIndex_f : c_obj list -> c_obj list = "_wrap_new_ZeroInflationIndex__SWIG_0QuantLib" ;;
let _new_ZeroInflationIndex arg = match _new_ZeroInflationIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroInflationIndex_f : c_obj list -> c_obj list = "_wrap_new_ZeroInflationIndexQuantLib" ;;
let _new_ZeroInflationIndex arg = match _new_ZeroInflationIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZeroInflationIndex_f : c_obj list -> c_obj list = "_wrap_delete_ZeroInflationIndexQuantLib" ;;
let _delete_ZeroInflationIndex arg = match _delete_ZeroInflationIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YoYInflationIndex_f : c_obj list -> c_obj list = "_wrap_delete_YoYInflationIndexQuantLib" ;;
let _delete_YoYInflationIndex arg = match _delete_YoYInflationIndex_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EUHICP_f : c_obj list -> c_obj list = "_wrap_new_EUHICP__SWIG_0QuantLib" ;;
let _new_EUHICP arg = match _new_EUHICP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EUHICP_f : c_obj list -> c_obj list = "_wrap_new_EUHICPQuantLib" ;;
let _new_EUHICP arg = match _new_EUHICP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EUHICP_f : c_obj list -> c_obj list = "_wrap_delete_EUHICPQuantLib" ;;
let _delete_EUHICP arg = match _delete_EUHICP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EUHICPXT_f : c_obj list -> c_obj list = "_wrap_new_EUHICPXT__SWIG_0QuantLib" ;;
let _new_EUHICPXT arg = match _new_EUHICPXT_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_EUHICPXT_f : c_obj list -> c_obj list = "_wrap_new_EUHICPXTQuantLib" ;;
let _new_EUHICPXT arg = match _new_EUHICPXT_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_EUHICPXT_f : c_obj list -> c_obj list = "_wrap_delete_EUHICPXTQuantLib" ;;
let _delete_EUHICPXT arg = match _delete_EUHICPXT_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FRHICP_f : c_obj list -> c_obj list = "_wrap_new_FRHICP__SWIG_0QuantLib" ;;
let _new_FRHICP arg = match _new_FRHICP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FRHICP_f : c_obj list -> c_obj list = "_wrap_new_FRHICPQuantLib" ;;
let _new_FRHICP arg = match _new_FRHICP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FRHICP_f : c_obj list -> c_obj list = "_wrap_delete_FRHICPQuantLib" ;;
let _delete_FRHICP arg = match _delete_FRHICP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UKRPI_f : c_obj list -> c_obj list = "_wrap_new_UKRPI__SWIG_0QuantLib" ;;
let _new_UKRPI arg = match _new_UKRPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UKRPI_f : c_obj list -> c_obj list = "_wrap_new_UKRPIQuantLib" ;;
let _new_UKRPI arg = match _new_UKRPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_UKRPI_f : c_obj list -> c_obj list = "_wrap_delete_UKRPIQuantLib" ;;
let _delete_UKRPI arg = match _delete_UKRPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_USCPI_f : c_obj list -> c_obj list = "_wrap_new_USCPI__SWIG_0QuantLib" ;;
let _new_USCPI arg = match _new_USCPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_USCPI_f : c_obj list -> c_obj list = "_wrap_new_USCPIQuantLib" ;;
let _new_USCPI arg = match _new_USCPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_USCPI_f : c_obj list -> c_obj list = "_wrap_delete_USCPIQuantLib" ;;
let _delete_USCPI arg = match _delete_USCPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZACPI_f : c_obj list -> c_obj list = "_wrap_new_ZACPI__SWIG_0QuantLib" ;;
let _new_ZACPI arg = match _new_ZACPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZACPI_f : c_obj list -> c_obj list = "_wrap_new_ZACPIQuantLib" ;;
let _new_ZACPI arg = match _new_ZACPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZACPI_f : c_obj list -> c_obj list = "_wrap_delete_ZACPIQuantLib" ;;
let _delete_ZACPI arg = match _delete_ZACPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YYEUHICP_f : c_obj list -> c_obj list = "_wrap_new_YYEUHICP__SWIG_0QuantLib" ;;
let _new_YYEUHICP arg = match _new_YYEUHICP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YYEUHICP_f : c_obj list -> c_obj list = "_wrap_new_YYEUHICPQuantLib" ;;
let _new_YYEUHICP arg = match _new_YYEUHICP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YYEUHICP_f : c_obj list -> c_obj list = "_wrap_delete_YYEUHICPQuantLib" ;;
let _delete_YYEUHICP arg = match _delete_YYEUHICP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YYEUHICPXT_f : c_obj list -> c_obj list = "_wrap_new_YYEUHICPXT__SWIG_0QuantLib" ;;
let _new_YYEUHICPXT arg = match _new_YYEUHICPXT_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YYEUHICPXT_f : c_obj list -> c_obj list = "_wrap_new_YYEUHICPXTQuantLib" ;;
let _new_YYEUHICPXT arg = match _new_YYEUHICPXT_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YYEUHICPXT_f : c_obj list -> c_obj list = "_wrap_delete_YYEUHICPXTQuantLib" ;;
let _delete_YYEUHICPXT arg = match _delete_YYEUHICPXT_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YYFRHICP_f : c_obj list -> c_obj list = "_wrap_new_YYFRHICP__SWIG_0QuantLib" ;;
let _new_YYFRHICP arg = match _new_YYFRHICP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YYFRHICP_f : c_obj list -> c_obj list = "_wrap_new_YYFRHICPQuantLib" ;;
let _new_YYFRHICP arg = match _new_YYFRHICP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YYFRHICP_f : c_obj list -> c_obj list = "_wrap_delete_YYFRHICPQuantLib" ;;
let _delete_YYFRHICP arg = match _delete_YYFRHICP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YYUKRPI_f : c_obj list -> c_obj list = "_wrap_new_YYUKRPI__SWIG_0QuantLib" ;;
let _new_YYUKRPI arg = match _new_YYUKRPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YYUKRPI_f : c_obj list -> c_obj list = "_wrap_new_YYUKRPIQuantLib" ;;
let _new_YYUKRPI arg = match _new_YYUKRPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YYUKRPI_f : c_obj list -> c_obj list = "_wrap_delete_YYUKRPIQuantLib" ;;
let _delete_YYUKRPI arg = match _delete_YYUKRPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YYUSCPI_f : c_obj list -> c_obj list = "_wrap_new_YYUSCPI__SWIG_0QuantLib" ;;
let _new_YYUSCPI arg = match _new_YYUSCPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YYUSCPI_f : c_obj list -> c_obj list = "_wrap_new_YYUSCPIQuantLib" ;;
let _new_YYUSCPI arg = match _new_YYUSCPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YYUSCPI_f : c_obj list -> c_obj list = "_wrap_delete_YYUSCPIQuantLib" ;;
let _delete_YYUSCPI arg = match _delete_YYUSCPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YYZACPI_f : c_obj list -> c_obj list = "_wrap_new_YYZACPI__SWIG_0QuantLib" ;;
let _new_YYZACPI arg = match _new_YYZACPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YYZACPI_f : c_obj list -> c_obj list = "_wrap_new_YYZACPIQuantLib" ;;
let _new_YYZACPI arg = match _new_YYZACPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YYZACPI_f : c_obj list -> c_obj list = "_wrap_delete_YYZACPIQuantLib" ;;
let _delete_YYZACPI arg = match _delete_YYZACPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "CPI::InterpolationType_marker" (`InterpolationType)
external _AsIndex : c_obj -> Swig.c_obj = "_wrap_AsIndex" 
external _Flat : c_obj -> Swig.c_obj = "_wrap_Flat" 
external _Linear : c_obj -> Swig.c_obj = "_wrap_Linear" 
external _new_CPI_f : c_obj list -> c_obj list = "_wrap_new_CPIQuantLib" ;;
let _new_CPI arg = match _new_CPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CPI_f : c_obj list -> c_obj list = "_wrap_delete_CPIQuantLib" ;;
let _delete_CPI arg = match _delete_CPI_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroHelper___deref___f : c_obj list -> c_obj list = "_wrap_ZeroHelper___deref__QuantLib" ;;
let _ZeroHelper___deref__ arg = match _ZeroHelper___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroHelper_isNull_f : c_obj list -> c_obj list = "_wrap_ZeroHelper_isNullQuantLib" ;;
let _ZeroHelper_isNull arg = match _ZeroHelper_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroHelper_f : c_obj list -> c_obj list = "_wrap_new_ZeroHelperQuantLib" ;;
let _new_ZeroHelper arg = match _new_ZeroHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZeroHelper_f : c_obj list -> c_obj list = "_wrap_delete_ZeroHelperQuantLib" ;;
let _delete_ZeroHelper arg = match _delete_ZeroHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYHelper___deref___f : c_obj list -> c_obj list = "_wrap_YoYHelper___deref__QuantLib" ;;
let _YoYHelper___deref__ arg = match _YoYHelper___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYHelper_isNull_f : c_obj list -> c_obj list = "_wrap_YoYHelper_isNullQuantLib" ;;
let _YoYHelper_isNull arg = match _YoYHelper_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YoYHelper_f : c_obj list -> c_obj list = "_wrap_new_YoYHelperQuantLib" ;;
let _new_YoYHelper arg = match _new_YoYHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YoYHelper_f : c_obj list -> c_obj list = "_wrap_delete_YoYHelperQuantLib" ;;
let _delete_YoYHelper arg = match _delete_YoYHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroHelperVector_f : c_obj list -> c_obj list = "_wrap_new_ZeroHelperVector__SWIG_0QuantLib" ;;
let _new_ZeroHelperVector arg = match _new_ZeroHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroHelperVector_f : c_obj list -> c_obj list = "_wrap_new_ZeroHelperVector__SWIG_1QuantLib" ;;
let _new_ZeroHelperVector arg = match _new_ZeroHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroHelperVector_f : c_obj list -> c_obj list = "_wrap_new_ZeroHelperVector__SWIG_2QuantLib" ;;
let _new_ZeroHelperVector arg = match _new_ZeroHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroHelperVector_f : c_obj list -> c_obj list = "_wrap_new_ZeroHelperVectorQuantLib" ;;
let _new_ZeroHelperVector arg = match _new_ZeroHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroHelperVector_size_f : c_obj list -> c_obj list = "_wrap_ZeroHelperVector_sizeQuantLib" ;;
let _ZeroHelperVector_size arg = match _ZeroHelperVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroHelperVector_empty_f : c_obj list -> c_obj list = "_wrap_ZeroHelperVector_emptyQuantLib" ;;
let _ZeroHelperVector_empty arg = match _ZeroHelperVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroHelperVector_clear_f : c_obj list -> c_obj list = "_wrap_ZeroHelperVector_clearQuantLib" ;;
let _ZeroHelperVector_clear arg = match _ZeroHelperVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroHelperVector_push_back_f : c_obj list -> c_obj list = "_wrap_ZeroHelperVector_push_backQuantLib" ;;
let _ZeroHelperVector_push_back arg = match _ZeroHelperVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroHelperVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_ZeroHelperVector_operator_bB___QuantLib" ;;
let _ZeroHelperVector_operator_xx_xx_lbrace_xx_rbrace arg = match _ZeroHelperVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroHelperVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_ZeroHelperVector_operator_e___QuantLib" ;;
let _ZeroHelperVector_operator_xx_xx_equals arg = match _ZeroHelperVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroHelperVector_set_f : c_obj list -> c_obj list = "_wrap_ZeroHelperVector_setQuantLib" ;;
let _ZeroHelperVector_set arg = match _ZeroHelperVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroHelperVector_to_array_f : c_obj list -> c_obj list = "_wrap_ZeroHelperVector_to_arrayQuantLib" ;;
let _ZeroHelperVector_to_array arg = match _ZeroHelperVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZeroHelperVector_f : c_obj list -> c_obj list = "_wrap_delete_ZeroHelperVectorQuantLib" ;;
let _delete_ZeroHelperVector arg = match _delete_ZeroHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YoYHelperVector_f : c_obj list -> c_obj list = "_wrap_new_YoYHelperVector__SWIG_0QuantLib" ;;
let _new_YoYHelperVector arg = match _new_YoYHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YoYHelperVector_f : c_obj list -> c_obj list = "_wrap_new_YoYHelperVector__SWIG_1QuantLib" ;;
let _new_YoYHelperVector arg = match _new_YoYHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YoYHelperVector_f : c_obj list -> c_obj list = "_wrap_new_YoYHelperVector__SWIG_2QuantLib" ;;
let _new_YoYHelperVector arg = match _new_YoYHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YoYHelperVector_f : c_obj list -> c_obj list = "_wrap_new_YoYHelperVectorQuantLib" ;;
let _new_YoYHelperVector arg = match _new_YoYHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYHelperVector_size_f : c_obj list -> c_obj list = "_wrap_YoYHelperVector_sizeQuantLib" ;;
let _YoYHelperVector_size arg = match _YoYHelperVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYHelperVector_empty_f : c_obj list -> c_obj list = "_wrap_YoYHelperVector_emptyQuantLib" ;;
let _YoYHelperVector_empty arg = match _YoYHelperVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYHelperVector_clear_f : c_obj list -> c_obj list = "_wrap_YoYHelperVector_clearQuantLib" ;;
let _YoYHelperVector_clear arg = match _YoYHelperVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYHelperVector_push_back_f : c_obj list -> c_obj list = "_wrap_YoYHelperVector_push_backQuantLib" ;;
let _YoYHelperVector_push_back arg = match _YoYHelperVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYHelperVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_YoYHelperVector_operator_bB___QuantLib" ;;
let _YoYHelperVector_operator_xx_xx_lbrace_xx_rbrace arg = match _YoYHelperVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYHelperVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_YoYHelperVector_operator_e___QuantLib" ;;
let _YoYHelperVector_operator_xx_xx_equals arg = match _YoYHelperVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYHelperVector_set_f : c_obj list -> c_obj list = "_wrap_YoYHelperVector_setQuantLib" ;;
let _YoYHelperVector_set arg = match _YoYHelperVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYHelperVector_to_array_f : c_obj list -> c_obj list = "_wrap_YoYHelperVector_to_arrayQuantLib" ;;
let _YoYHelperVector_to_array arg = match _YoYHelperVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YoYHelperVector_f : c_obj list -> c_obj list = "_wrap_delete_YoYHelperVectorQuantLib" ;;
let _delete_YoYHelperVector arg = match _delete_YoYHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCouponInflationSwapHelper_f : c_obj list -> c_obj list = "_wrap_new_ZeroCouponInflationSwapHelperQuantLib" ;;
let _new_ZeroCouponInflationSwapHelper arg = match _new_ZeroCouponInflationSwapHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZeroCouponInflationSwapHelper_f : c_obj list -> c_obj list = "_wrap_delete_ZeroCouponInflationSwapHelperQuantLib" ;;
let _delete_ZeroCouponInflationSwapHelper arg = match _delete_ZeroCouponInflationSwapHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YearOnYearInflationSwapHelper_f : c_obj list -> c_obj list = "_wrap_new_YearOnYearInflationSwapHelperQuantLib" ;;
let _new_YearOnYearInflationSwapHelper arg = match _new_YearOnYearInflationSwapHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YearOnYearInflationSwapHelper_f : c_obj list -> c_obj list = "_wrap_delete_YearOnYearInflationSwapHelperQuantLib" ;;
let _delete_YearOnYearInflationSwapHelper arg = match _delete_YearOnYearInflationSwapHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseZeroInflation_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseZeroInflation__SWIG_0QuantLib" ;;
let _new_PiecewiseZeroInflation arg = match _new_PiecewiseZeroInflation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseZeroInflation_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseZeroInflation__SWIG_1QuantLib" ;;
let _new_PiecewiseZeroInflation arg = match _new_PiecewiseZeroInflation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseZeroInflation_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseZeroInflationQuantLib" ;;
let _new_PiecewiseZeroInflation arg = match _new_PiecewiseZeroInflation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseZeroInflation_dates_f : c_obj list -> c_obj list = "_wrap_PiecewiseZeroInflation_datesQuantLib" ;;
let _PiecewiseZeroInflation_dates arg = match _PiecewiseZeroInflation_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseZeroInflation_times_f : c_obj list -> c_obj list = "_wrap_PiecewiseZeroInflation_timesQuantLib" ;;
let _PiecewiseZeroInflation_times arg = match _PiecewiseZeroInflation_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseZeroInflation_nodes_f : c_obj list -> c_obj list = "_wrap_PiecewiseZeroInflation_nodesQuantLib" ;;
let _PiecewiseZeroInflation_nodes arg = match _PiecewiseZeroInflation_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PiecewiseZeroInflation_f : c_obj list -> c_obj list = "_wrap_delete_PiecewiseZeroInflationQuantLib" ;;
let _delete_PiecewiseZeroInflation arg = match _delete_PiecewiseZeroInflation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseYoYInflation_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseYoYInflation__SWIG_0QuantLib" ;;
let _new_PiecewiseYoYInflation arg = match _new_PiecewiseYoYInflation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseYoYInflation_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseYoYInflation__SWIG_1QuantLib" ;;
let _new_PiecewiseYoYInflation arg = match _new_PiecewiseYoYInflation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseYoYInflation_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseYoYInflationQuantLib" ;;
let _new_PiecewiseYoYInflation arg = match _new_PiecewiseYoYInflation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseYoYInflation_dates_f : c_obj list -> c_obj list = "_wrap_PiecewiseYoYInflation_datesQuantLib" ;;
let _PiecewiseYoYInflation_dates arg = match _PiecewiseYoYInflation_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseYoYInflation_times_f : c_obj list -> c_obj list = "_wrap_PiecewiseYoYInflation_timesQuantLib" ;;
let _PiecewiseYoYInflation_times arg = match _PiecewiseYoYInflation_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseYoYInflation_nodes_f : c_obj list -> c_obj list = "_wrap_PiecewiseYoYInflation_nodesQuantLib" ;;
let _PiecewiseYoYInflation_nodes arg = match _PiecewiseYoYInflation_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PiecewiseYoYInflation_f : c_obj list -> c_obj list = "_wrap_delete_PiecewiseYoYInflationQuantLib" ;;
let _delete_PiecewiseYoYInflation arg = match _delete_PiecewiseYoYInflation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _inflationBaseDate_f : c_obj list -> c_obj list = "_wrap_inflationBaseDateQuantLib" ;;
let _inflationBaseDate arg = match _inflationBaseDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroCouponInflationSwap_Receiver : c_obj -> Swig.c_obj = "_wrap_ZeroCouponInflationSwap_Receiver" 
external _ZeroCouponInflationSwap_Payer : c_obj -> Swig.c_obj = "_wrap_ZeroCouponInflationSwap_Payer" 
external _new_ZeroCouponInflationSwap_f : c_obj list -> c_obj list = "_wrap_new_ZeroCouponInflationSwap__SWIG_0QuantLib" ;;
let _new_ZeroCouponInflationSwap arg = match _new_ZeroCouponInflationSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCouponInflationSwap_f : c_obj list -> c_obj list = "_wrap_new_ZeroCouponInflationSwap__SWIG_1QuantLib" ;;
let _new_ZeroCouponInflationSwap arg = match _new_ZeroCouponInflationSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCouponInflationSwap_f : c_obj list -> c_obj list = "_wrap_new_ZeroCouponInflationSwap__SWIG_2QuantLib" ;;
let _new_ZeroCouponInflationSwap arg = match _new_ZeroCouponInflationSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCouponInflationSwap_f : c_obj list -> c_obj list = "_wrap_new_ZeroCouponInflationSwapQuantLib" ;;
let _new_ZeroCouponInflationSwap arg = match _new_ZeroCouponInflationSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroCouponInflationSwap_fairRate_f : c_obj list -> c_obj list = "_wrap_ZeroCouponInflationSwap_fairRateQuantLib" ;;
let _ZeroCouponInflationSwap_fairRate arg = match _ZeroCouponInflationSwap_fairRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroCouponInflationSwap_fixedLeg_f : c_obj list -> c_obj list = "_wrap_ZeroCouponInflationSwap_fixedLegQuantLib" ;;
let _ZeroCouponInflationSwap_fixedLeg arg = match _ZeroCouponInflationSwap_fixedLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroCouponInflationSwap_inflationLeg_f : c_obj list -> c_obj list = "_wrap_ZeroCouponInflationSwap_inflationLegQuantLib" ;;
let _ZeroCouponInflationSwap_inflationLeg arg = match _ZeroCouponInflationSwap_inflationLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroCouponInflationSwap_type_f : c_obj list -> c_obj list = "_wrap_ZeroCouponInflationSwap_typeQuantLib" ;;
let _ZeroCouponInflationSwap_type arg = match _ZeroCouponInflationSwap_type_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZeroCouponInflationSwap_f : c_obj list -> c_obj list = "_wrap_delete_ZeroCouponInflationSwapQuantLib" ;;
let _delete_ZeroCouponInflationSwap arg = match _delete_ZeroCouponInflationSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YearOnYearInflationSwap_Receiver : c_obj -> Swig.c_obj = "_wrap_YearOnYearInflationSwap_Receiver" 
external _YearOnYearInflationSwap_Payer : c_obj -> Swig.c_obj = "_wrap_YearOnYearInflationSwap_Payer" 
external _new_YearOnYearInflationSwap_f : c_obj list -> c_obj list = "_wrap_new_YearOnYearInflationSwap__SWIG_0QuantLib" ;;
let _new_YearOnYearInflationSwap arg = match _new_YearOnYearInflationSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YearOnYearInflationSwap_f : c_obj list -> c_obj list = "_wrap_new_YearOnYearInflationSwapQuantLib" ;;
let _new_YearOnYearInflationSwap arg = match _new_YearOnYearInflationSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YearOnYearInflationSwap_fairRate_f : c_obj list -> c_obj list = "_wrap_YearOnYearInflationSwap_fairRateQuantLib" ;;
let _YearOnYearInflationSwap_fairRate arg = match _YearOnYearInflationSwap_fairRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YearOnYearInflationSwap_f : c_obj list -> c_obj list = "_wrap_delete_YearOnYearInflationSwapQuantLib" ;;
let _delete_YearOnYearInflationSwap arg = match _delete_YearOnYearInflationSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationCapFloor_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_YoYInflationCapFloor_impliedVolatility__SWIG_0QuantLib" ;;
let _YoYInflationCapFloor_impliedVolatility arg = match _YoYInflationCapFloor_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationCapFloor_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_YoYInflationCapFloor_impliedVolatility__SWIG_1QuantLib" ;;
let _YoYInflationCapFloor_impliedVolatility arg = match _YoYInflationCapFloor_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationCapFloor_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_YoYInflationCapFloor_impliedVolatility__SWIG_2QuantLib" ;;
let _YoYInflationCapFloor_impliedVolatility arg = match _YoYInflationCapFloor_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationCapFloor_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_YoYInflationCapFloor_impliedVolatility__SWIG_3QuantLib" ;;
let _YoYInflationCapFloor_impliedVolatility arg = match _YoYInflationCapFloor_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _YoYInflationCapFloor_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_YoYInflationCapFloor_impliedVolatilityQuantLib" ;;
let _YoYInflationCapFloor_impliedVolatility arg = match _YoYInflationCapFloor_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YoYInflationCapFloor_f : c_obj list -> c_obj list = "_wrap_new_YoYInflationCapFloorQuantLib" ;;
let _new_YoYInflationCapFloor arg = match _new_YoYInflationCapFloor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YoYInflationCapFloor_f : c_obj list -> c_obj list = "_wrap_delete_YoYInflationCapFloorQuantLib" ;;
let _delete_YoYInflationCapFloor arg = match _delete_YoYInflationCapFloor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YoYInflationCap_f : c_obj list -> c_obj list = "_wrap_new_YoYInflationCapQuantLib" ;;
let _new_YoYInflationCap arg = match _new_YoYInflationCap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YoYInflationCap_f : c_obj list -> c_obj list = "_wrap_delete_YoYInflationCapQuantLib" ;;
let _delete_YoYInflationCap arg = match _delete_YoYInflationCap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YoYInflationFloor_f : c_obj list -> c_obj list = "_wrap_new_YoYInflationFloorQuantLib" ;;
let _new_YoYInflationFloor arg = match _new_YoYInflationFloor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YoYInflationFloor_f : c_obj list -> c_obj list = "_wrap_delete_YoYInflationFloorQuantLib" ;;
let _delete_YoYInflationFloor arg = match _delete_YoYInflationFloor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_YoYInflationCollar_f : c_obj list -> c_obj list = "_wrap_new_YoYInflationCollarQuantLib" ;;
let _new_YoYInflationCollar arg = match _new_YoYInflationCollar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_YoYInflationCollar_f : c_obj list -> c_obj list = "_wrap_delete_YoYInflationCollarQuantLib" ;;
let _delete_YoYInflationCollar arg = match _delete_YoYInflationCollar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModel___deref___f : c_obj list -> c_obj list = "_wrap_ShortRateModel___deref__QuantLib" ;;
let _ShortRateModel___deref__ arg = match _ShortRateModel___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModel_isNull_f : c_obj list -> c_obj list = "_wrap_ShortRateModel_isNullQuantLib" ;;
let _ShortRateModel_isNull arg = match _ShortRateModel_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModel_asObservable_f : c_obj list -> c_obj list = "_wrap_ShortRateModel_asObservableQuantLib" ;;
let _ShortRateModel_asObservable arg = match _ShortRateModel_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ShortRateModel_f : c_obj list -> c_obj list = "_wrap_new_ShortRateModelQuantLib" ;;
let _new_ShortRateModel arg = match _new_ShortRateModel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ShortRateModel_f : c_obj list -> c_obj list = "_wrap_delete_ShortRateModelQuantLib" ;;
let _delete_ShortRateModel arg = match _delete_ShortRateModel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModel_params_f : c_obj list -> c_obj list = "_wrap_ShortRateModel_paramsQuantLib" ;;
let _ShortRateModel_params arg = match _ShortRateModel_params_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModel_calibrate_f : c_obj list -> c_obj list = "_wrap_ShortRateModel_calibrate__SWIG_0QuantLib" ;;
let _ShortRateModel_calibrate arg = match _ShortRateModel_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModel_calibrate_f : c_obj list -> c_obj list = "_wrap_ShortRateModel_calibrate__SWIG_1QuantLib" ;;
let _ShortRateModel_calibrate arg = match _ShortRateModel_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModel_calibrate_f : c_obj list -> c_obj list = "_wrap_ShortRateModel_calibrate__SWIG_2QuantLib" ;;
let _ShortRateModel_calibrate arg = match _ShortRateModel_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModel_calibrate_f : c_obj list -> c_obj list = "_wrap_ShortRateModel_calibrateQuantLib" ;;
let _ShortRateModel_calibrate arg = match _ShortRateModel_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModel_value_f : c_obj list -> c_obj list = "_wrap_ShortRateModel_valueQuantLib" ;;
let _ShortRateModel_value arg = match _ShortRateModel_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModel_endCriteria_f : c_obj list -> c_obj list = "_wrap_ShortRateModel_endCriteriaQuantLib" ;;
let _ShortRateModel_endCriteria arg = match _ShortRateModel_endCriteria_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModel_setParams_f : c_obj list -> c_obj list = "_wrap_ShortRateModel_setParamsQuantLib" ;;
let _ShortRateModel_setParams arg = match _ShortRateModel_setParams_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ShortRateModelHandle_f : c_obj list -> c_obj list = "_wrap_new_ShortRateModelHandle__SWIG_0QuantLib" ;;
let _new_ShortRateModelHandle arg = match _new_ShortRateModelHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ShortRateModelHandle_f : c_obj list -> c_obj list = "_wrap_new_ShortRateModelHandleQuantLib" ;;
let _new_ShortRateModelHandle arg = match _new_ShortRateModelHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModelHandle___deref___f : c_obj list -> c_obj list = "_wrap_ShortRateModelHandle___deref__QuantLib" ;;
let _ShortRateModelHandle___deref__ arg = match _ShortRateModelHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModelHandle_empty_f : c_obj list -> c_obj list = "_wrap_ShortRateModelHandle_emptyQuantLib" ;;
let _ShortRateModelHandle_empty arg = match _ShortRateModelHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModelHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_ShortRateModelHandle_asObservableQuantLib" ;;
let _ShortRateModelHandle_asObservable arg = match _ShortRateModelHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ShortRateModelHandle_f : c_obj list -> c_obj list = "_wrap_delete_ShortRateModelHandleQuantLib" ;;
let _delete_ShortRateModelHandle arg = match _delete_ShortRateModelHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModelHandle_params_f : c_obj list -> c_obj list = "_wrap_ShortRateModelHandle_paramsQuantLib" ;;
let _ShortRateModelHandle_params arg = match _ShortRateModelHandle_params_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModelHandle_calibrate_f : c_obj list -> c_obj list = "_wrap_ShortRateModelHandle_calibrate__SWIG_0QuantLib" ;;
let _ShortRateModelHandle_calibrate arg = match _ShortRateModelHandle_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModelHandle_calibrate_f : c_obj list -> c_obj list = "_wrap_ShortRateModelHandle_calibrate__SWIG_1QuantLib" ;;
let _ShortRateModelHandle_calibrate arg = match _ShortRateModelHandle_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModelHandle_calibrate_f : c_obj list -> c_obj list = "_wrap_ShortRateModelHandle_calibrate__SWIG_2QuantLib" ;;
let _ShortRateModelHandle_calibrate arg = match _ShortRateModelHandle_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModelHandle_calibrate_f : c_obj list -> c_obj list = "_wrap_ShortRateModelHandle_calibrateQuantLib" ;;
let _ShortRateModelHandle_calibrate arg = match _ShortRateModelHandle_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModelHandle_value_f : c_obj list -> c_obj list = "_wrap_ShortRateModelHandle_valueQuantLib" ;;
let _ShortRateModelHandle_value arg = match _ShortRateModelHandle_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModelHandle_endCriteria_f : c_obj list -> c_obj list = "_wrap_ShortRateModelHandle_endCriteriaQuantLib" ;;
let _ShortRateModelHandle_endCriteria arg = match _ShortRateModelHandle_endCriteria_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ShortRateModelHandle_setParams_f : c_obj list -> c_obj list = "_wrap_ShortRateModelHandle_setParamsQuantLib" ;;
let _ShortRateModelHandle_setParams arg = match _ShortRateModelHandle_setParams_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableShortRateModelHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableShortRateModelHandle__SWIG_0QuantLib" ;;
let _new_RelinkableShortRateModelHandle arg = match _new_RelinkableShortRateModelHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableShortRateModelHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableShortRateModelHandleQuantLib" ;;
let _new_RelinkableShortRateModelHandle arg = match _new_RelinkableShortRateModelHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableShortRateModelHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableShortRateModelHandle_linkToQuantLib" ;;
let _RelinkableShortRateModelHandle_linkTo arg = match _RelinkableShortRateModelHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableShortRateModelHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableShortRateModelHandleQuantLib" ;;
let _delete_RelinkableShortRateModelHandle arg = match _delete_RelinkableShortRateModelHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Vasicek_f : c_obj list -> c_obj list = "_wrap_new_Vasicek__SWIG_0QuantLib" ;;
let _new_Vasicek arg = match _new_Vasicek_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Vasicek_f : c_obj list -> c_obj list = "_wrap_new_Vasicek__SWIG_1QuantLib" ;;
let _new_Vasicek arg = match _new_Vasicek_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Vasicek_f : c_obj list -> c_obj list = "_wrap_new_Vasicek__SWIG_2QuantLib" ;;
let _new_Vasicek arg = match _new_Vasicek_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Vasicek_f : c_obj list -> c_obj list = "_wrap_new_Vasicek__SWIG_3QuantLib" ;;
let _new_Vasicek arg = match _new_Vasicek_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Vasicek_f : c_obj list -> c_obj list = "_wrap_new_Vasicek__SWIG_4QuantLib" ;;
let _new_Vasicek arg = match _new_Vasicek_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Vasicek_f : c_obj list -> c_obj list = "_wrap_new_VasicekQuantLib" ;;
let _new_Vasicek arg = match _new_Vasicek_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Vasicek_discount_f : c_obj list -> c_obj list = "_wrap_Vasicek_discountQuantLib" ;;
let _Vasicek_discount arg = match _Vasicek_discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Vasicek_discountBond_f : c_obj list -> c_obj list = "_wrap_Vasicek_discountBondQuantLib" ;;
let _Vasicek_discountBond arg = match _Vasicek_discountBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Vasicek_f : c_obj list -> c_obj list = "_wrap_delete_VasicekQuantLib" ;;
let _delete_Vasicek arg = match _delete_Vasicek_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HullWhite_f : c_obj list -> c_obj list = "_wrap_new_HullWhite__SWIG_0QuantLib" ;;
let _new_HullWhite arg = match _new_HullWhite_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HullWhite_f : c_obj list -> c_obj list = "_wrap_new_HullWhite__SWIG_1QuantLib" ;;
let _new_HullWhite arg = match _new_HullWhite_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HullWhite_f : c_obj list -> c_obj list = "_wrap_new_HullWhiteQuantLib" ;;
let _new_HullWhite arg = match _new_HullWhite_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HullWhite_discount_f : c_obj list -> c_obj list = "_wrap_HullWhite_discountQuantLib" ;;
let _HullWhite_discount arg = match _HullWhite_discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HullWhite_discountBond_f : c_obj list -> c_obj list = "_wrap_HullWhite_discountBondQuantLib" ;;
let _HullWhite_discountBond arg = match _HullWhite_discountBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HullWhite_convexityBias_f : c_obj list -> c_obj list = "_wrap_HullWhite_convexityBiasQuantLib" ;;
let _HullWhite_convexityBias arg = match _HullWhite_convexityBias_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HullWhite_f : c_obj list -> c_obj list = "_wrap_delete_HullWhiteQuantLib" ;;
let _delete_HullWhite arg = match _delete_HullWhite_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackKarasinski_f : c_obj list -> c_obj list = "_wrap_new_BlackKarasinski__SWIG_0QuantLib" ;;
let _new_BlackKarasinski arg = match _new_BlackKarasinski_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackKarasinski_f : c_obj list -> c_obj list = "_wrap_new_BlackKarasinski__SWIG_1QuantLib" ;;
let _new_BlackKarasinski arg = match _new_BlackKarasinski_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackKarasinski_f : c_obj list -> c_obj list = "_wrap_new_BlackKarasinskiQuantLib" ;;
let _new_BlackKarasinski arg = match _new_BlackKarasinski_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackKarasinski_f : c_obj list -> c_obj list = "_wrap_delete_BlackKarasinskiQuantLib" ;;
let _delete_BlackKarasinski arg = match _delete_BlackKarasinski_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_G2_f : c_obj list -> c_obj list = "_wrap_new_G2__SWIG_0QuantLib" ;;
let _new_G2 arg = match _new_G2_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_G2_f : c_obj list -> c_obj list = "_wrap_new_G2__SWIG_1QuantLib" ;;
let _new_G2 arg = match _new_G2_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_G2_f : c_obj list -> c_obj list = "_wrap_new_G2__SWIG_2QuantLib" ;;
let _new_G2 arg = match _new_G2_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_G2_f : c_obj list -> c_obj list = "_wrap_new_G2__SWIG_3QuantLib" ;;
let _new_G2 arg = match _new_G2_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_G2_f : c_obj list -> c_obj list = "_wrap_new_G2__SWIG_4QuantLib" ;;
let _new_G2 arg = match _new_G2_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_G2_f : c_obj list -> c_obj list = "_wrap_new_G2QuantLib" ;;
let _new_G2 arg = match _new_G2_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _G2_discount_f : c_obj list -> c_obj list = "_wrap_G2_discountQuantLib" ;;
let _G2_discount arg = match _G2_discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _G2_discountBond_f : c_obj list -> c_obj list = "_wrap_G2_discountBondQuantLib" ;;
let _G2_discountBond arg = match _G2_discountBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_G2_f : c_obj list -> c_obj list = "_wrap_delete_G2QuantLib" ;;
let _delete_G2 arg = match _delete_G2_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_JamshidianSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_JamshidianSwaptionEngine__SWIG_0QuantLib" ;;
let _new_JamshidianSwaptionEngine arg = match _new_JamshidianSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_JamshidianSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_JamshidianSwaptionEngineQuantLib" ;;
let _new_JamshidianSwaptionEngine arg = match _new_JamshidianSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_JamshidianSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_delete_JamshidianSwaptionEngineQuantLib" ;;
let _delete_JamshidianSwaptionEngine arg = match _delete_JamshidianSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeSwaptionEngine__SWIG_0QuantLib" ;;
let _new_TreeSwaptionEngine arg = match _new_TreeSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeSwaptionEngine__SWIG_1QuantLib" ;;
let _new_TreeSwaptionEngine arg = match _new_TreeSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeSwaptionEngine__SWIG_2QuantLib" ;;
let _new_TreeSwaptionEngine arg = match _new_TreeSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeSwaptionEngine__SWIG_3QuantLib" ;;
let _new_TreeSwaptionEngine arg = match _new_TreeSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeSwaptionEngine__SWIG_4QuantLib" ;;
let _new_TreeSwaptionEngine arg = match _new_TreeSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeSwaptionEngineQuantLib" ;;
let _new_TreeSwaptionEngine arg = match _new_TreeSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TreeSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_delete_TreeSwaptionEngineQuantLib" ;;
let _delete_TreeSwaptionEngine arg = match _delete_TreeSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticCapFloorEngine__SWIG_0QuantLib" ;;
let _new_AnalyticCapFloorEngine arg = match _new_AnalyticCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AnalyticCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_new_AnalyticCapFloorEngineQuantLib" ;;
let _new_AnalyticCapFloorEngine arg = match _new_AnalyticCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AnalyticCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_delete_AnalyticCapFloorEngineQuantLib" ;;
let _delete_AnalyticCapFloorEngine arg = match _delete_AnalyticCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeCapFloorEngine__SWIG_0QuantLib" ;;
let _new_TreeCapFloorEngine arg = match _new_TreeCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeCapFloorEngine__SWIG_1QuantLib" ;;
let _new_TreeCapFloorEngine arg = match _new_TreeCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeCapFloorEngine__SWIG_2QuantLib" ;;
let _new_TreeCapFloorEngine arg = match _new_TreeCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeCapFloorEngineQuantLib" ;;
let _new_TreeCapFloorEngine arg = match _new_TreeCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TreeCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_delete_TreeCapFloorEngineQuantLib" ;;
let _delete_TreeCapFloorEngine arg = match _delete_TreeCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_G2SwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_G2SwaptionEngineQuantLib" ;;
let _new_G2SwaptionEngine arg = match _new_G2SwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_G2SwaptionEngine_f : c_obj list -> c_obj list = "_wrap_delete_G2SwaptionEngineQuantLib" ;;
let _delete_G2SwaptionEngine arg = match _delete_G2SwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdG2SwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdG2SwaptionEngine__SWIG_0QuantLib" ;;
let _new_FdG2SwaptionEngine arg = match _new_FdG2SwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdG2SwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdG2SwaptionEngine__SWIG_1QuantLib" ;;
let _new_FdG2SwaptionEngine arg = match _new_FdG2SwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdG2SwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdG2SwaptionEngine__SWIG_2QuantLib" ;;
let _new_FdG2SwaptionEngine arg = match _new_FdG2SwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdG2SwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdG2SwaptionEngine__SWIG_3QuantLib" ;;
let _new_FdG2SwaptionEngine arg = match _new_FdG2SwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdG2SwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdG2SwaptionEngine__SWIG_4QuantLib" ;;
let _new_FdG2SwaptionEngine arg = match _new_FdG2SwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdG2SwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdG2SwaptionEngine__SWIG_5QuantLib" ;;
let _new_FdG2SwaptionEngine arg = match _new_FdG2SwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdG2SwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdG2SwaptionEngineQuantLib" ;;
let _new_FdG2SwaptionEngine arg = match _new_FdG2SwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FdG2SwaptionEngine_f : c_obj list -> c_obj list = "_wrap_delete_FdG2SwaptionEngineQuantLib" ;;
let _delete_FdG2SwaptionEngine arg = match _delete_FdG2SwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdHullWhiteSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdHullWhiteSwaptionEngine__SWIG_0QuantLib" ;;
let _new_FdHullWhiteSwaptionEngine arg = match _new_FdHullWhiteSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdHullWhiteSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdHullWhiteSwaptionEngine__SWIG_1QuantLib" ;;
let _new_FdHullWhiteSwaptionEngine arg = match _new_FdHullWhiteSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdHullWhiteSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdHullWhiteSwaptionEngine__SWIG_2QuantLib" ;;
let _new_FdHullWhiteSwaptionEngine arg = match _new_FdHullWhiteSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdHullWhiteSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdHullWhiteSwaptionEngine__SWIG_3QuantLib" ;;
let _new_FdHullWhiteSwaptionEngine arg = match _new_FdHullWhiteSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdHullWhiteSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdHullWhiteSwaptionEngine__SWIG_4QuantLib" ;;
let _new_FdHullWhiteSwaptionEngine arg = match _new_FdHullWhiteSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FdHullWhiteSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_FdHullWhiteSwaptionEngineQuantLib" ;;
let _new_FdHullWhiteSwaptionEngine arg = match _new_FdHullWhiteSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FdHullWhiteSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_delete_FdHullWhiteSwaptionEngineQuantLib" ;;
let _delete_FdHullWhiteSwaptionEngine arg = match _delete_FdHullWhiteSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bond_f : c_obj list -> c_obj list = "_wrap_new_Bond__SWIG_0QuantLib" ;;
let _new_Bond arg = match _new_Bond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bond_f : c_obj list -> c_obj list = "_wrap_new_Bond__SWIG_1QuantLib" ;;
let _new_Bond arg = match _new_Bond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Bond_f : c_obj list -> c_obj list = "_wrap_new_BondQuantLib" ;;
let _new_Bond arg = match _new_Bond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_nextCouponRate_f : c_obj list -> c_obj list = "_wrap_Bond_nextCouponRate__SWIG_0QuantLib" ;;
let _Bond_nextCouponRate arg = match _Bond_nextCouponRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_nextCouponRate_f : c_obj list -> c_obj list = "_wrap_Bond_nextCouponRateQuantLib" ;;
let _Bond_nextCouponRate arg = match _Bond_nextCouponRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_previousCouponRate_f : c_obj list -> c_obj list = "_wrap_Bond_previousCouponRate__SWIG_0QuantLib" ;;
let _Bond_previousCouponRate arg = match _Bond_previousCouponRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_previousCouponRate_f : c_obj list -> c_obj list = "_wrap_Bond_previousCouponRateQuantLib" ;;
let _Bond_previousCouponRate arg = match _Bond_previousCouponRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_settlementDays_f : c_obj list -> c_obj list = "_wrap_Bond_settlementDaysQuantLib" ;;
let _Bond_settlementDays arg = match _Bond_settlementDays_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_settlementDate_f : c_obj list -> c_obj list = "_wrap_Bond_settlementDate__SWIG_0QuantLib" ;;
let _Bond_settlementDate arg = match _Bond_settlementDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_settlementDate_f : c_obj list -> c_obj list = "_wrap_Bond_settlementDateQuantLib" ;;
let _Bond_settlementDate arg = match _Bond_settlementDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_startDate_f : c_obj list -> c_obj list = "_wrap_Bond_startDateQuantLib" ;;
let _Bond_startDate arg = match _Bond_startDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_maturityDate_f : c_obj list -> c_obj list = "_wrap_Bond_maturityDateQuantLib" ;;
let _Bond_maturityDate arg = match _Bond_maturityDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_issueDate_f : c_obj list -> c_obj list = "_wrap_Bond_issueDateQuantLib" ;;
let _Bond_issueDate arg = match _Bond_issueDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_cashflows_f : c_obj list -> c_obj list = "_wrap_Bond_cashflowsQuantLib" ;;
let _Bond_cashflows arg = match _Bond_cashflows_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_redemptions_f : c_obj list -> c_obj list = "_wrap_Bond_redemptionsQuantLib" ;;
let _Bond_redemptions arg = match _Bond_redemptions_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_redemption_f : c_obj list -> c_obj list = "_wrap_Bond_redemptionQuantLib" ;;
let _Bond_redemption arg = match _Bond_redemption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_calendar_f : c_obj list -> c_obj list = "_wrap_Bond_calendarQuantLib" ;;
let _Bond_calendar arg = match _Bond_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_notionals_f : c_obj list -> c_obj list = "_wrap_Bond_notionalsQuantLib" ;;
let _Bond_notionals arg = match _Bond_notionals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_notional_f : c_obj list -> c_obj list = "_wrap_Bond_notional__SWIG_0QuantLib" ;;
let _Bond_notional arg = match _Bond_notional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_notional_f : c_obj list -> c_obj list = "_wrap_Bond_notionalQuantLib" ;;
let _Bond_notional arg = match _Bond_notional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_cleanPrice_f : c_obj list -> c_obj list = "_wrap_Bond_cleanPrice__SWIG_0QuantLib" ;;
let _Bond_cleanPrice arg = match _Bond_cleanPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_cleanPrice_f : c_obj list -> c_obj list = "_wrap_Bond_cleanPrice__SWIG_1QuantLib" ;;
let _Bond_cleanPrice arg = match _Bond_cleanPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_cleanPrice_f : c_obj list -> c_obj list = "_wrap_Bond_cleanPriceQuantLib" ;;
let _Bond_cleanPrice arg = match _Bond_cleanPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_dirtyPrice_f : c_obj list -> c_obj list = "_wrap_Bond_dirtyPrice__SWIG_0QuantLib" ;;
let _Bond_dirtyPrice arg = match _Bond_dirtyPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_dirtyPrice_f : c_obj list -> c_obj list = "_wrap_Bond_dirtyPrice__SWIG_1QuantLib" ;;
let _Bond_dirtyPrice arg = match _Bond_dirtyPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_dirtyPrice_f : c_obj list -> c_obj list = "_wrap_Bond_dirtyPriceQuantLib" ;;
let _Bond_dirtyPrice arg = match _Bond_dirtyPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_yield_f : c_obj list -> c_obj list = "_wrap_Bond_yield__SWIG_0QuantLib" ;;
let _Bond_yield arg = match _Bond_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_yield_f : c_obj list -> c_obj list = "_wrap_Bond_yield__SWIG_1QuantLib" ;;
let _Bond_yield arg = match _Bond_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_yield_f : c_obj list -> c_obj list = "_wrap_Bond_yield__SWIG_2QuantLib" ;;
let _Bond_yield arg = match _Bond_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_yield_f : c_obj list -> c_obj list = "_wrap_Bond_yield__SWIG_3QuantLib" ;;
let _Bond_yield arg = match _Bond_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_yield_f : c_obj list -> c_obj list = "_wrap_Bond_yield__SWIG_4QuantLib" ;;
let _Bond_yield arg = match _Bond_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_yield_f : c_obj list -> c_obj list = "_wrap_Bond_yield__SWIG_5QuantLib" ;;
let _Bond_yield arg = match _Bond_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_yield_f : c_obj list -> c_obj list = "_wrap_Bond_yieldQuantLib" ;;
let _Bond_yield arg = match _Bond_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_accruedAmount_f : c_obj list -> c_obj list = "_wrap_Bond_accruedAmount__SWIG_0QuantLib" ;;
let _Bond_accruedAmount arg = match _Bond_accruedAmount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_accruedAmount_f : c_obj list -> c_obj list = "_wrap_Bond_accruedAmountQuantLib" ;;
let _Bond_accruedAmount arg = match _Bond_accruedAmount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_settlementValue_f : c_obj list -> c_obj list = "_wrap_Bond_settlementValue__SWIG_0QuantLib" ;;
let _Bond_settlementValue arg = match _Bond_settlementValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Bond_settlementValue_f : c_obj list -> c_obj list = "_wrap_Bond_settlementValueQuantLib" ;;
let _Bond_settlementValue arg = match _Bond_settlementValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Bond_f : c_obj list -> c_obj list = "_wrap_delete_BondQuantLib" ;;
let _delete_Bond arg = match _delete_Bond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _cleanPriceFromZSpread_f : c_obj list -> c_obj list = "_wrap_cleanPriceFromZSpread__SWIG_0QuantLib" ;;
let _cleanPriceFromZSpread arg = match _cleanPriceFromZSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _cleanPriceFromZSpread_f : c_obj list -> c_obj list = "_wrap_cleanPriceFromZSpreadQuantLib" ;;
let _cleanPriceFromZSpread arg = match _cleanPriceFromZSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCouponBond_f : c_obj list -> c_obj list = "_wrap_new_ZeroCouponBond__SWIG_0QuantLib" ;;
let _new_ZeroCouponBond arg = match _new_ZeroCouponBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCouponBond_f : c_obj list -> c_obj list = "_wrap_new_ZeroCouponBond__SWIG_1QuantLib" ;;
let _new_ZeroCouponBond arg = match _new_ZeroCouponBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCouponBond_f : c_obj list -> c_obj list = "_wrap_new_ZeroCouponBond__SWIG_2QuantLib" ;;
let _new_ZeroCouponBond arg = match _new_ZeroCouponBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCouponBond_f : c_obj list -> c_obj list = "_wrap_new_ZeroCouponBondQuantLib" ;;
let _new_ZeroCouponBond arg = match _new_ZeroCouponBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZeroCouponBond_f : c_obj list -> c_obj list = "_wrap_delete_ZeroCouponBondQuantLib" ;;
let _delete_ZeroCouponBond arg = match _delete_ZeroCouponBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_0QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_1QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_2QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_3QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_4QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_5QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_6QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_7QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_8QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_9QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_10QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_11QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_12QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_13QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_14QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_15QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBond__SWIG_16QuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondQuantLib" ;;
let _new_FixedRateBond arg = match _new_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FixedRateBond_frequency_f : c_obj list -> c_obj list = "_wrap_FixedRateBond_frequencyQuantLib" ;;
let _FixedRateBond_frequency arg = match _FixedRateBond_frequency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FixedRateBond_dayCounter_f : c_obj list -> c_obj list = "_wrap_FixedRateBond_dayCounterQuantLib" ;;
let _FixedRateBond_dayCounter arg = match _FixedRateBond_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FixedRateBond_f : c_obj list -> c_obj list = "_wrap_delete_FixedRateBondQuantLib" ;;
let _delete_FixedRateBond arg = match _delete_FixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatingRateBond_f : c_obj list -> c_obj list = "_wrap_new_FloatingRateBond__SWIG_0QuantLib" ;;
let _new_FloatingRateBond arg = match _new_FloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatingRateBond_f : c_obj list -> c_obj list = "_wrap_new_FloatingRateBond__SWIG_1QuantLib" ;;
let _new_FloatingRateBond arg = match _new_FloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatingRateBond_f : c_obj list -> c_obj list = "_wrap_new_FloatingRateBond__SWIG_2QuantLib" ;;
let _new_FloatingRateBond arg = match _new_FloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatingRateBond_f : c_obj list -> c_obj list = "_wrap_new_FloatingRateBond__SWIG_3QuantLib" ;;
let _new_FloatingRateBond arg = match _new_FloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatingRateBond_f : c_obj list -> c_obj list = "_wrap_new_FloatingRateBond__SWIG_4QuantLib" ;;
let _new_FloatingRateBond arg = match _new_FloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatingRateBond_f : c_obj list -> c_obj list = "_wrap_new_FloatingRateBond__SWIG_5QuantLib" ;;
let _new_FloatingRateBond arg = match _new_FloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatingRateBond_f : c_obj list -> c_obj list = "_wrap_new_FloatingRateBond__SWIG_6QuantLib" ;;
let _new_FloatingRateBond arg = match _new_FloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatingRateBond_f : c_obj list -> c_obj list = "_wrap_new_FloatingRateBond__SWIG_7QuantLib" ;;
let _new_FloatingRateBond arg = match _new_FloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatingRateBond_f : c_obj list -> c_obj list = "_wrap_new_FloatingRateBond__SWIG_8QuantLib" ;;
let _new_FloatingRateBond arg = match _new_FloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatingRateBond_f : c_obj list -> c_obj list = "_wrap_new_FloatingRateBondQuantLib" ;;
let _new_FloatingRateBond arg = match _new_FloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FloatingRateBond_f : c_obj list -> c_obj list = "_wrap_delete_FloatingRateBondQuantLib" ;;
let _delete_FloatingRateBond arg = match _delete_FloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CmsRateBond_f : c_obj list -> c_obj list = "_wrap_new_CmsRateBond__SWIG_0QuantLib" ;;
let _new_CmsRateBond arg = match _new_CmsRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CmsRateBond_f : c_obj list -> c_obj list = "_wrap_new_CmsRateBond__SWIG_1QuantLib" ;;
let _new_CmsRateBond arg = match _new_CmsRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CmsRateBond_f : c_obj list -> c_obj list = "_wrap_new_CmsRateBond__SWIG_2QuantLib" ;;
let _new_CmsRateBond arg = match _new_CmsRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CmsRateBond_f : c_obj list -> c_obj list = "_wrap_new_CmsRateBondQuantLib" ;;
let _new_CmsRateBond arg = match _new_CmsRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CmsRateBond_f : c_obj list -> c_obj list = "_wrap_delete_CmsRateBondQuantLib" ;;
let _delete_CmsRateBond arg = match _delete_CmsRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DiscountingBondEngine_f : c_obj list -> c_obj list = "_wrap_new_DiscountingBondEngineQuantLib" ;;
let _new_DiscountingBondEngine arg = match _new_DiscountingBondEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DiscountingBondEngine_f : c_obj list -> c_obj list = "_wrap_delete_DiscountingBondEngineQuantLib" ;;
let _delete_DiscountingBondEngine arg = match _delete_DiscountingBondEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CallableFixedRateBond_f : c_obj list -> c_obj list = "_wrap_new_CallableFixedRateBondQuantLib" ;;
let _new_CallableFixedRateBond arg = match _new_CallableFixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CallableFixedRateBond_f : c_obj list -> c_obj list = "_wrap_delete_CallableFixedRateBondQuantLib" ;;
let _delete_CallableFixedRateBond arg = match _delete_CallableFixedRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeCallableFixedRateBondEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeCallableFixedRateBondEngine__SWIG_0QuantLib" ;;
let _new_TreeCallableFixedRateBondEngine arg = match _new_TreeCallableFixedRateBondEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeCallableFixedRateBondEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeCallableFixedRateBondEngine__SWIG_1QuantLib" ;;
let _new_TreeCallableFixedRateBondEngine arg = match _new_TreeCallableFixedRateBondEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeCallableFixedRateBondEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeCallableFixedRateBondEngine__SWIG_2QuantLib" ;;
let _new_TreeCallableFixedRateBondEngine arg = match _new_TreeCallableFixedRateBondEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TreeCallableFixedRateBondEngine_f : c_obj list -> c_obj list = "_wrap_new_TreeCallableFixedRateBondEngineQuantLib" ;;
let _new_TreeCallableFixedRateBondEngine arg = match _new_TreeCallableFixedRateBondEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TreeCallableFixedRateBondEngine_f : c_obj list -> c_obj list = "_wrap_delete_TreeCallableFixedRateBondEngineQuantLib" ;;
let _delete_TreeCallableFixedRateBondEngine arg = match _delete_TreeCallableFixedRateBondEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackCallableFixedRateBondEngine_f : c_obj list -> c_obj list = "_wrap_new_BlackCallableFixedRateBondEngineQuantLib" ;;
let _new_BlackCallableFixedRateBondEngine arg = match _new_BlackCallableFixedRateBondEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackCallableFixedRateBondEngine_f : c_obj list -> c_obj list = "_wrap_delete_BlackCallableFixedRateBondEngineQuantLib" ;;
let _delete_BlackCallableFixedRateBondEngine arg = match _delete_BlackCallableFixedRateBondEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CPIBond_f : c_obj list -> c_obj list = "_wrap_new_CPIBond__SWIG_0QuantLib" ;;
let _new_CPIBond arg = match _new_CPIBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CPIBond_f : c_obj list -> c_obj list = "_wrap_new_CPIBond__SWIG_1QuantLib" ;;
let _new_CPIBond arg = match _new_CPIBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CPIBond_f : c_obj list -> c_obj list = "_wrap_new_CPIBond__SWIG_2QuantLib" ;;
let _new_CPIBond arg = match _new_CPIBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CPIBond_f : c_obj list -> c_obj list = "_wrap_new_CPIBond__SWIG_3QuantLib" ;;
let _new_CPIBond arg = match _new_CPIBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CPIBond_f : c_obj list -> c_obj list = "_wrap_new_CPIBond__SWIG_4QuantLib" ;;
let _new_CPIBond arg = match _new_CPIBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CPIBond_f : c_obj list -> c_obj list = "_wrap_new_CPIBond__SWIG_5QuantLib" ;;
let _new_CPIBond arg = match _new_CPIBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CPIBond_f : c_obj list -> c_obj list = "_wrap_new_CPIBond__SWIG_6QuantLib" ;;
let _new_CPIBond arg = match _new_CPIBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CPIBond_f : c_obj list -> c_obj list = "_wrap_new_CPIBondQuantLib" ;;
let _new_CPIBond arg = match _new_CPIBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CPIBond_f : c_obj list -> c_obj list = "_wrap_delete_CPIBondQuantLib" ;;
let _delete_CPIBond arg = match _delete_CPIBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_startDate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_startDateQuantLib" ;;
let _BondFunctions_startDate arg = match _BondFunctions_startDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_maturityDate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_maturityDateQuantLib" ;;
let _BondFunctions_maturityDate arg = match _BondFunctions_maturityDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_isTradable_f : c_obj list -> c_obj list = "_wrap_BondFunctions_isTradable__SWIG_0QuantLib" ;;
let _BondFunctions_isTradable arg = match _BondFunctions_isTradable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_isTradable_f : c_obj list -> c_obj list = "_wrap_BondFunctions_isTradableQuantLib" ;;
let _BondFunctions_isTradable arg = match _BondFunctions_isTradable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_previousCashFlowDate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_previousCashFlowDate__SWIG_0QuantLib" ;;
let _BondFunctions_previousCashFlowDate arg = match _BondFunctions_previousCashFlowDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_previousCashFlowDate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_previousCashFlowDateQuantLib" ;;
let _BondFunctions_previousCashFlowDate arg = match _BondFunctions_previousCashFlowDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_nextCashFlowDate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_nextCashFlowDate__SWIG_0QuantLib" ;;
let _BondFunctions_nextCashFlowDate arg = match _BondFunctions_nextCashFlowDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_nextCashFlowDate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_nextCashFlowDateQuantLib" ;;
let _BondFunctions_nextCashFlowDate arg = match _BondFunctions_nextCashFlowDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_previousCashFlowAmount_f : c_obj list -> c_obj list = "_wrap_BondFunctions_previousCashFlowAmount__SWIG_0QuantLib" ;;
let _BondFunctions_previousCashFlowAmount arg = match _BondFunctions_previousCashFlowAmount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_previousCashFlowAmount_f : c_obj list -> c_obj list = "_wrap_BondFunctions_previousCashFlowAmountQuantLib" ;;
let _BondFunctions_previousCashFlowAmount arg = match _BondFunctions_previousCashFlowAmount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_nextCashFlowAmount_f : c_obj list -> c_obj list = "_wrap_BondFunctions_nextCashFlowAmount__SWIG_0QuantLib" ;;
let _BondFunctions_nextCashFlowAmount arg = match _BondFunctions_nextCashFlowAmount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_nextCashFlowAmount_f : c_obj list -> c_obj list = "_wrap_BondFunctions_nextCashFlowAmountQuantLib" ;;
let _BondFunctions_nextCashFlowAmount arg = match _BondFunctions_nextCashFlowAmount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_previousCouponRate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_previousCouponRate__SWIG_0QuantLib" ;;
let _BondFunctions_previousCouponRate arg = match _BondFunctions_previousCouponRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_previousCouponRate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_previousCouponRateQuantLib" ;;
let _BondFunctions_previousCouponRate arg = match _BondFunctions_previousCouponRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_nextCouponRate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_nextCouponRate__SWIG_0QuantLib" ;;
let _BondFunctions_nextCouponRate arg = match _BondFunctions_nextCouponRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_nextCouponRate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_nextCouponRateQuantLib" ;;
let _BondFunctions_nextCouponRate arg = match _BondFunctions_nextCouponRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accrualStartDate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accrualStartDate__SWIG_0QuantLib" ;;
let _BondFunctions_accrualStartDate arg = match _BondFunctions_accrualStartDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accrualStartDate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accrualStartDateQuantLib" ;;
let _BondFunctions_accrualStartDate arg = match _BondFunctions_accrualStartDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accrualEndDate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accrualEndDate__SWIG_0QuantLib" ;;
let _BondFunctions_accrualEndDate arg = match _BondFunctions_accrualEndDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accrualEndDate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accrualEndDateQuantLib" ;;
let _BondFunctions_accrualEndDate arg = match _BondFunctions_accrualEndDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accrualPeriod_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accrualPeriod__SWIG_0QuantLib" ;;
let _BondFunctions_accrualPeriod arg = match _BondFunctions_accrualPeriod_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accrualPeriod_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accrualPeriodQuantLib" ;;
let _BondFunctions_accrualPeriod arg = match _BondFunctions_accrualPeriod_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accrualDays_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accrualDays__SWIG_0QuantLib" ;;
let _BondFunctions_accrualDays arg = match _BondFunctions_accrualDays_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accrualDays_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accrualDaysQuantLib" ;;
let _BondFunctions_accrualDays arg = match _BondFunctions_accrualDays_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accruedPeriod_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accruedPeriod__SWIG_0QuantLib" ;;
let _BondFunctions_accruedPeriod arg = match _BondFunctions_accruedPeriod_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accruedPeriod_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accruedPeriodQuantLib" ;;
let _BondFunctions_accruedPeriod arg = match _BondFunctions_accruedPeriod_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accruedDays_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accruedDays__SWIG_0QuantLib" ;;
let _BondFunctions_accruedDays arg = match _BondFunctions_accruedDays_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accruedDays_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accruedDaysQuantLib" ;;
let _BondFunctions_accruedDays arg = match _BondFunctions_accruedDays_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accruedAmount_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accruedAmount__SWIG_0QuantLib" ;;
let _BondFunctions_accruedAmount arg = match _BondFunctions_accruedAmount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_accruedAmount_f : c_obj list -> c_obj list = "_wrap_BondFunctions_accruedAmountQuantLib" ;;
let _BondFunctions_accruedAmount arg = match _BondFunctions_accruedAmount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_cleanPrice_f : c_obj list -> c_obj list = "_wrap_BondFunctions_cleanPrice__SWIG_0QuantLib" ;;
let _BondFunctions_cleanPrice arg = match _BondFunctions_cleanPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_cleanPrice_f : c_obj list -> c_obj list = "_wrap_BondFunctions_cleanPrice__SWIG_1QuantLib" ;;
let _BondFunctions_cleanPrice arg = match _BondFunctions_cleanPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_bps_f : c_obj list -> c_obj list = "_wrap_BondFunctions_bps__SWIG_0QuantLib" ;;
let _BondFunctions_bps arg = match _BondFunctions_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_bps_f : c_obj list -> c_obj list = "_wrap_BondFunctions_bps__SWIG_1QuantLib" ;;
let _BondFunctions_bps arg = match _BondFunctions_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_atmRate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_atmRate__SWIG_0QuantLib" ;;
let _BondFunctions_atmRate arg = match _BondFunctions_atmRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_atmRate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_atmRate__SWIG_1QuantLib" ;;
let _BondFunctions_atmRate arg = match _BondFunctions_atmRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_atmRate_f : c_obj list -> c_obj list = "_wrap_BondFunctions_atmRateQuantLib" ;;
let _BondFunctions_atmRate arg = match _BondFunctions_atmRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_cleanPrice_f : c_obj list -> c_obj list = "_wrap_BondFunctions_cleanPrice__SWIG_2QuantLib" ;;
let _BondFunctions_cleanPrice arg = match _BondFunctions_cleanPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_cleanPrice_f : c_obj list -> c_obj list = "_wrap_BondFunctions_cleanPrice__SWIG_3QuantLib" ;;
let _BondFunctions_cleanPrice arg = match _BondFunctions_cleanPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_cleanPrice_f : c_obj list -> c_obj list = "_wrap_BondFunctions_cleanPrice__SWIG_4QuantLib" ;;
let _BondFunctions_cleanPrice arg = match _BondFunctions_cleanPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_cleanPrice_f : c_obj list -> c_obj list = "_wrap_BondFunctions_cleanPriceQuantLib" ;;
let _BondFunctions_cleanPrice arg = match _BondFunctions_cleanPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_bps_f : c_obj list -> c_obj list = "_wrap_BondFunctions_bps__SWIG_2QuantLib" ;;
let _BondFunctions_bps arg = match _BondFunctions_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_bps_f : c_obj list -> c_obj list = "_wrap_BondFunctions_bps__SWIG_3QuantLib" ;;
let _BondFunctions_bps arg = match _BondFunctions_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_bps_f : c_obj list -> c_obj list = "_wrap_BondFunctions_bps__SWIG_4QuantLib" ;;
let _BondFunctions_bps arg = match _BondFunctions_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_bps_f : c_obj list -> c_obj list = "_wrap_BondFunctions_bpsQuantLib" ;;
let _BondFunctions_bps arg = match _BondFunctions_bps_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yield_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yield__SWIG_0QuantLib" ;;
let _BondFunctions_yield arg = match _BondFunctions_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yield_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yield__SWIG_1QuantLib" ;;
let _BondFunctions_yield arg = match _BondFunctions_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yield_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yield__SWIG_2QuantLib" ;;
let _BondFunctions_yield arg = match _BondFunctions_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yield_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yield__SWIG_3QuantLib" ;;
let _BondFunctions_yield arg = match _BondFunctions_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yield_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldQuantLib" ;;
let _BondFunctions_yield arg = match _BondFunctions_yield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldBrent_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldBrent__SWIG_0QuantLib" ;;
let _BondFunctions_yieldBrent arg = match _BondFunctions_yieldBrent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldBrent_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldBrent__SWIG_1QuantLib" ;;
let _BondFunctions_yieldBrent arg = match _BondFunctions_yieldBrent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldBrent_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldBrent__SWIG_2QuantLib" ;;
let _BondFunctions_yieldBrent arg = match _BondFunctions_yieldBrent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldBrent_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldBrentQuantLib" ;;
let _BondFunctions_yieldBrent arg = match _BondFunctions_yieldBrent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldBisection_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldBisection__SWIG_0QuantLib" ;;
let _BondFunctions_yieldBisection arg = match _BondFunctions_yieldBisection_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldBisection_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldBisection__SWIG_1QuantLib" ;;
let _BondFunctions_yieldBisection arg = match _BondFunctions_yieldBisection_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldBisection_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldBisection__SWIG_2QuantLib" ;;
let _BondFunctions_yieldBisection arg = match _BondFunctions_yieldBisection_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldBisection_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldBisectionQuantLib" ;;
let _BondFunctions_yieldBisection arg = match _BondFunctions_yieldBisection_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldFalsePosition_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldFalsePosition__SWIG_0QuantLib" ;;
let _BondFunctions_yieldFalsePosition arg = match _BondFunctions_yieldFalsePosition_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldFalsePosition_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldFalsePosition__SWIG_1QuantLib" ;;
let _BondFunctions_yieldFalsePosition arg = match _BondFunctions_yieldFalsePosition_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldFalsePosition_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldFalsePosition__SWIG_2QuantLib" ;;
let _BondFunctions_yieldFalsePosition arg = match _BondFunctions_yieldFalsePosition_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldFalsePosition_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldFalsePositionQuantLib" ;;
let _BondFunctions_yieldFalsePosition arg = match _BondFunctions_yieldFalsePosition_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldRidder_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldRidder__SWIG_0QuantLib" ;;
let _BondFunctions_yieldRidder arg = match _BondFunctions_yieldRidder_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldRidder_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldRidder__SWIG_1QuantLib" ;;
let _BondFunctions_yieldRidder arg = match _BondFunctions_yieldRidder_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldRidder_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldRidder__SWIG_2QuantLib" ;;
let _BondFunctions_yieldRidder arg = match _BondFunctions_yieldRidder_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldRidder_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldRidderQuantLib" ;;
let _BondFunctions_yieldRidder arg = match _BondFunctions_yieldRidder_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldSecant_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldSecant__SWIG_0QuantLib" ;;
let _BondFunctions_yieldSecant arg = match _BondFunctions_yieldSecant_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldSecant_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldSecant__SWIG_1QuantLib" ;;
let _BondFunctions_yieldSecant arg = match _BondFunctions_yieldSecant_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldSecant_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldSecant__SWIG_2QuantLib" ;;
let _BondFunctions_yieldSecant arg = match _BondFunctions_yieldSecant_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldSecant_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldSecantQuantLib" ;;
let _BondFunctions_yieldSecant arg = match _BondFunctions_yieldSecant_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_duration_f : c_obj list -> c_obj list = "_wrap_BondFunctions_duration__SWIG_0QuantLib" ;;
let _BondFunctions_duration arg = match _BondFunctions_duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_duration_f : c_obj list -> c_obj list = "_wrap_BondFunctions_duration__SWIG_1QuantLib" ;;
let _BondFunctions_duration arg = match _BondFunctions_duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_duration_f : c_obj list -> c_obj list = "_wrap_BondFunctions_duration__SWIG_2QuantLib" ;;
let _BondFunctions_duration arg = match _BondFunctions_duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_duration_f : c_obj list -> c_obj list = "_wrap_BondFunctions_duration__SWIG_3QuantLib" ;;
let _BondFunctions_duration arg = match _BondFunctions_duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_duration_f : c_obj list -> c_obj list = "_wrap_BondFunctions_duration__SWIG_4QuantLib" ;;
let _BondFunctions_duration arg = match _BondFunctions_duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_duration_f : c_obj list -> c_obj list = "_wrap_BondFunctions_durationQuantLib" ;;
let _BondFunctions_duration arg = match _BondFunctions_duration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_convexity_f : c_obj list -> c_obj list = "_wrap_BondFunctions_convexity__SWIG_0QuantLib" ;;
let _BondFunctions_convexity arg = match _BondFunctions_convexity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_convexity_f : c_obj list -> c_obj list = "_wrap_BondFunctions_convexity__SWIG_1QuantLib" ;;
let _BondFunctions_convexity arg = match _BondFunctions_convexity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_convexity_f : c_obj list -> c_obj list = "_wrap_BondFunctions_convexity__SWIG_2QuantLib" ;;
let _BondFunctions_convexity arg = match _BondFunctions_convexity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_convexity_f : c_obj list -> c_obj list = "_wrap_BondFunctions_convexityQuantLib" ;;
let _BondFunctions_convexity arg = match _BondFunctions_convexity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_basisPointValue_f : c_obj list -> c_obj list = "_wrap_BondFunctions_basisPointValue__SWIG_0QuantLib" ;;
let _BondFunctions_basisPointValue arg = match _BondFunctions_basisPointValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_basisPointValue_f : c_obj list -> c_obj list = "_wrap_BondFunctions_basisPointValue__SWIG_1QuantLib" ;;
let _BondFunctions_basisPointValue arg = match _BondFunctions_basisPointValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_basisPointValue_f : c_obj list -> c_obj list = "_wrap_BondFunctions_basisPointValue__SWIG_2QuantLib" ;;
let _BondFunctions_basisPointValue arg = match _BondFunctions_basisPointValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_basisPointValue_f : c_obj list -> c_obj list = "_wrap_BondFunctions_basisPointValueQuantLib" ;;
let _BondFunctions_basisPointValue arg = match _BondFunctions_basisPointValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldValueBasisPoint_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldValueBasisPoint__SWIG_0QuantLib" ;;
let _BondFunctions_yieldValueBasisPoint arg = match _BondFunctions_yieldValueBasisPoint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldValueBasisPoint_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldValueBasisPoint__SWIG_1QuantLib" ;;
let _BondFunctions_yieldValueBasisPoint arg = match _BondFunctions_yieldValueBasisPoint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldValueBasisPoint_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldValueBasisPoint__SWIG_2QuantLib" ;;
let _BondFunctions_yieldValueBasisPoint arg = match _BondFunctions_yieldValueBasisPoint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_yieldValueBasisPoint_f : c_obj list -> c_obj list = "_wrap_BondFunctions_yieldValueBasisPointQuantLib" ;;
let _BondFunctions_yieldValueBasisPoint arg = match _BondFunctions_yieldValueBasisPoint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_zSpread_f : c_obj list -> c_obj list = "_wrap_BondFunctions_zSpread__SWIG_0QuantLib" ;;
let _BondFunctions_zSpread arg = match _BondFunctions_zSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_zSpread_f : c_obj list -> c_obj list = "_wrap_BondFunctions_zSpread__SWIG_1QuantLib" ;;
let _BondFunctions_zSpread arg = match _BondFunctions_zSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_zSpread_f : c_obj list -> c_obj list = "_wrap_BondFunctions_zSpread__SWIG_2QuantLib" ;;
let _BondFunctions_zSpread arg = match _BondFunctions_zSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_zSpread_f : c_obj list -> c_obj list = "_wrap_BondFunctions_zSpread__SWIG_3QuantLib" ;;
let _BondFunctions_zSpread arg = match _BondFunctions_zSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondFunctions_zSpread_f : c_obj list -> c_obj list = "_wrap_BondFunctions_zSpreadQuantLib" ;;
let _BondFunctions_zSpread arg = match _BondFunctions_zSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BondFunctions_f : c_obj list -> c_obj list = "_wrap_new_BondFunctionsQuantLib" ;;
let _new_BondFunctions arg = match _new_BondFunctions_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BondFunctions_f : c_obj list -> c_obj list = "_wrap_delete_BondFunctionsQuantLib" ;;
let _delete_BondFunctions arg = match _delete_BondFunctions_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_CapFloor_impliedVolatility__SWIG_0QuantLib" ;;
let _CapFloor_impliedVolatility arg = match _CapFloor_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_CapFloor_impliedVolatility__SWIG_1QuantLib" ;;
let _CapFloor_impliedVolatility arg = match _CapFloor_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_CapFloor_impliedVolatility__SWIG_2QuantLib" ;;
let _CapFloor_impliedVolatility arg = match _CapFloor_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_CapFloor_impliedVolatility__SWIG_3QuantLib" ;;
let _CapFloor_impliedVolatility arg = match _CapFloor_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_CapFloor_impliedVolatility__SWIG_4QuantLib" ;;
let _CapFloor_impliedVolatility arg = match _CapFloor_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_CapFloor_impliedVolatility__SWIG_5QuantLib" ;;
let _CapFloor_impliedVolatility arg = match _CapFloor_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_impliedVolatility_f : c_obj list -> c_obj list = "_wrap_CapFloor_impliedVolatilityQuantLib" ;;
let _CapFloor_impliedVolatility arg = match _CapFloor_impliedVolatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_floatingLeg_f : c_obj list -> c_obj list = "_wrap_CapFloor_floatingLegQuantLib" ;;
let _CapFloor_floatingLeg arg = match _CapFloor_floatingLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_capRates_f : c_obj list -> c_obj list = "_wrap_CapFloor_capRatesQuantLib" ;;
let _CapFloor_capRates arg = match _CapFloor_capRates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_floorRates_f : c_obj list -> c_obj list = "_wrap_CapFloor_floorRatesQuantLib" ;;
let _CapFloor_floorRates arg = match _CapFloor_floorRates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_startDate_f : c_obj list -> c_obj list = "_wrap_CapFloor_startDateQuantLib" ;;
let _CapFloor_startDate arg = match _CapFloor_startDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_maturityDate_f : c_obj list -> c_obj list = "_wrap_CapFloor_maturityDateQuantLib" ;;
let _CapFloor_maturityDate arg = match _CapFloor_maturityDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloor_atmRate_f : c_obj list -> c_obj list = "_wrap_CapFloor_atmRateQuantLib" ;;
let _CapFloor_atmRate arg = match _CapFloor_atmRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloor_f : c_obj list -> c_obj list = "_wrap_new_CapFloorQuantLib" ;;
let _new_CapFloor arg = match _new_CapFloor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CapFloor_f : c_obj list -> c_obj list = "_wrap_delete_CapFloorQuantLib" ;;
let _delete_CapFloor arg = match _delete_CapFloor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Cap_f : c_obj list -> c_obj list = "_wrap_new_CapQuantLib" ;;
let _new_Cap arg = match _new_Cap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Cap_f : c_obj list -> c_obj list = "_wrap_delete_CapQuantLib" ;;
let _delete_Cap arg = match _delete_Cap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Floor_f : c_obj list -> c_obj list = "_wrap_new_FloorQuantLib" ;;
let _new_Floor arg = match _new_Floor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Floor_f : c_obj list -> c_obj list = "_wrap_delete_FloorQuantLib" ;;
let _delete_Floor arg = match _delete_Floor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Collar_f : c_obj list -> c_obj list = "_wrap_new_CollarQuantLib" ;;
let _new_Collar arg = match _new_Collar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Collar_f : c_obj list -> c_obj list = "_wrap_delete_CollarQuantLib" ;;
let _delete_Collar arg = match _delete_Collar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_new_BlackCapFloorEngine__SWIG_0QuantLib" ;;
let _new_BlackCapFloorEngine arg = match _new_BlackCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_new_BlackCapFloorEngineQuantLib" ;;
let _new_BlackCapFloorEngine arg = match _new_BlackCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_delete_BlackCapFloorEngineQuantLib" ;;
let _delete_BlackCapFloorEngine arg = match _delete_BlackCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BachelierCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_new_BachelierCapFloorEngine__SWIG_0QuantLib" ;;
let _new_BachelierCapFloorEngine arg = match _new_BachelierCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BachelierCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_new_BachelierCapFloorEngineQuantLib" ;;
let _new_BachelierCapFloorEngine arg = match _new_BachelierCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BachelierCapFloorEngine_f : c_obj list -> c_obj list = "_wrap_delete_BachelierCapFloorEngineQuantLib" ;;
let _delete_BachelierCapFloorEngine arg = match _delete_BachelierCapFloorEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Dividend___deref___f : c_obj list -> c_obj list = "_wrap_Dividend___deref__QuantLib" ;;
let _Dividend___deref__ arg = match _Dividend___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Dividend_isNull_f : c_obj list -> c_obj list = "_wrap_Dividend_isNullQuantLib" ;;
let _Dividend_isNull arg = match _Dividend_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Dividend_f : c_obj list -> c_obj list = "_wrap_new_DividendQuantLib" ;;
let _new_Dividend arg = match _new_Dividend_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Dividend_f : c_obj list -> c_obj list = "_wrap_delete_DividendQuantLib" ;;
let _delete_Dividend arg = match _delete_Dividend_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Dividend_amount_f : c_obj list -> c_obj list = "_wrap_Dividend_amountQuantLib" ;;
let _Dividend_amount arg = match _Dividend_amount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Dividend_date_f : c_obj list -> c_obj list = "_wrap_Dividend_dateQuantLib" ;;
let _Dividend_date arg = match _Dividend_date_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedDividend_f : c_obj list -> c_obj list = "_wrap_new_FixedDividendQuantLib" ;;
let _new_FixedDividend arg = match _new_FixedDividend_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FixedDividend_f : c_obj list -> c_obj list = "_wrap_delete_FixedDividendQuantLib" ;;
let _delete_FixedDividend arg = match _delete_FixedDividend_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FractionalDividend_f : c_obj list -> c_obj list = "_wrap_new_FractionalDividendQuantLib" ;;
let _new_FractionalDividend arg = match _new_FractionalDividend_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FractionalDividend_f : c_obj list -> c_obj list = "_wrap_delete_FractionalDividendQuantLib" ;;
let _delete_FractionalDividend arg = match _delete_FractionalDividend_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DividendSchedule_f : c_obj list -> c_obj list = "_wrap_new_DividendSchedule__SWIG_0QuantLib" ;;
let _new_DividendSchedule arg = match _new_DividendSchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DividendSchedule_f : c_obj list -> c_obj list = "_wrap_new_DividendSchedule__SWIG_1QuantLib" ;;
let _new_DividendSchedule arg = match _new_DividendSchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DividendSchedule_f : c_obj list -> c_obj list = "_wrap_new_DividendSchedule__SWIG_2QuantLib" ;;
let _new_DividendSchedule arg = match _new_DividendSchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DividendSchedule_f : c_obj list -> c_obj list = "_wrap_new_DividendScheduleQuantLib" ;;
let _new_DividendSchedule arg = match _new_DividendSchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendSchedule_size_f : c_obj list -> c_obj list = "_wrap_DividendSchedule_sizeQuantLib" ;;
let _DividendSchedule_size arg = match _DividendSchedule_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendSchedule_empty_f : c_obj list -> c_obj list = "_wrap_DividendSchedule_emptyQuantLib" ;;
let _DividendSchedule_empty arg = match _DividendSchedule_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendSchedule_clear_f : c_obj list -> c_obj list = "_wrap_DividendSchedule_clearQuantLib" ;;
let _DividendSchedule_clear arg = match _DividendSchedule_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendSchedule_push_back_f : c_obj list -> c_obj list = "_wrap_DividendSchedule_push_backQuantLib" ;;
let _DividendSchedule_push_back arg = match _DividendSchedule_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendSchedule_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_DividendSchedule_operator_bB___QuantLib" ;;
let _DividendSchedule_operator_xx_xx_lbrace_xx_rbrace arg = match _DividendSchedule_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendSchedule_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_DividendSchedule_operator_e___QuantLib" ;;
let _DividendSchedule_operator_xx_xx_equals arg = match _DividendSchedule_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendSchedule_set_f : c_obj list -> c_obj list = "_wrap_DividendSchedule_setQuantLib" ;;
let _DividendSchedule_set arg = match _DividendSchedule_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DividendSchedule_to_array_f : c_obj list -> c_obj list = "_wrap_DividendSchedule_to_arrayQuantLib" ;;
let _DividendSchedule_to_array arg = match _DividendSchedule_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DividendSchedule_f : c_obj list -> c_obj list = "_wrap_delete_DividendScheduleQuantLib" ;;
let _delete_DividendSchedule arg = match _delete_DividendSchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConvertibleZeroCouponBond_f : c_obj list -> c_obj list = "_wrap_new_ConvertibleZeroCouponBond__SWIG_0QuantLib" ;;
let _new_ConvertibleZeroCouponBond arg = match _new_ConvertibleZeroCouponBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConvertibleZeroCouponBond_f : c_obj list -> c_obj list = "_wrap_new_ConvertibleZeroCouponBondQuantLib" ;;
let _new_ConvertibleZeroCouponBond arg = match _new_ConvertibleZeroCouponBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ConvertibleZeroCouponBond_f : c_obj list -> c_obj list = "_wrap_delete_ConvertibleZeroCouponBondQuantLib" ;;
let _delete_ConvertibleZeroCouponBond arg = match _delete_ConvertibleZeroCouponBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConvertibleFixedCouponBond_f : c_obj list -> c_obj list = "_wrap_new_ConvertibleFixedCouponBond__SWIG_0QuantLib" ;;
let _new_ConvertibleFixedCouponBond arg = match _new_ConvertibleFixedCouponBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConvertibleFixedCouponBond_f : c_obj list -> c_obj list = "_wrap_new_ConvertibleFixedCouponBondQuantLib" ;;
let _new_ConvertibleFixedCouponBond arg = match _new_ConvertibleFixedCouponBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ConvertibleFixedCouponBond_f : c_obj list -> c_obj list = "_wrap_delete_ConvertibleFixedCouponBondQuantLib" ;;
let _delete_ConvertibleFixedCouponBond arg = match _delete_ConvertibleFixedCouponBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConvertibleFloatingRateBond_f : c_obj list -> c_obj list = "_wrap_new_ConvertibleFloatingRateBond__SWIG_0QuantLib" ;;
let _new_ConvertibleFloatingRateBond arg = match _new_ConvertibleFloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConvertibleFloatingRateBond_f : c_obj list -> c_obj list = "_wrap_new_ConvertibleFloatingRateBondQuantLib" ;;
let _new_ConvertibleFloatingRateBond arg = match _new_ConvertibleFloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ConvertibleFloatingRateBond_f : c_obj list -> c_obj list = "_wrap_delete_ConvertibleFloatingRateBondQuantLib" ;;
let _delete_ConvertibleFloatingRateBond arg = match _delete_ConvertibleFloatingRateBond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BinomialConvertibleEngine_f : c_obj list -> c_obj list = "_wrap_new_BinomialConvertibleEngineQuantLib" ;;
let _new_BinomialConvertibleEngine arg = match _new_BinomialConvertibleEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BinomialConvertibleEngine_f : c_obj list -> c_obj list = "_wrap_delete_BinomialConvertibleEngineQuantLib" ;;
let _delete_BinomialConvertibleEngine arg = match _delete_BinomialConvertibleEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure___deref___f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure___deref__QuantLib" ;;
let _DefaultProbabilityTermStructure___deref__ arg = match _DefaultProbabilityTermStructure___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_isNull_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_isNullQuantLib" ;;
let _DefaultProbabilityTermStructure_isNull arg = match _DefaultProbabilityTermStructure_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_asObservable_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_asObservableQuantLib" ;;
let _DefaultProbabilityTermStructure_asObservable arg = match _DefaultProbabilityTermStructure_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultProbabilityTermStructure_f : c_obj list -> c_obj list = "_wrap_new_DefaultProbabilityTermStructureQuantLib" ;;
let _new_DefaultProbabilityTermStructure arg = match _new_DefaultProbabilityTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DefaultProbabilityTermStructure_f : c_obj list -> c_obj list = "_wrap_delete_DefaultProbabilityTermStructureQuantLib" ;;
let _delete_DefaultProbabilityTermStructure arg = match _delete_DefaultProbabilityTermStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_dayCounter_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_dayCounterQuantLib" ;;
let _DefaultProbabilityTermStructure_dayCounter arg = match _DefaultProbabilityTermStructure_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_calendar_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_calendarQuantLib" ;;
let _DefaultProbabilityTermStructure_calendar arg = match _DefaultProbabilityTermStructure_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_referenceDate_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_referenceDateQuantLib" ;;
let _DefaultProbabilityTermStructure_referenceDate arg = match _DefaultProbabilityTermStructure_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_maxDate_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_maxDateQuantLib" ;;
let _DefaultProbabilityTermStructure_maxDate arg = match _DefaultProbabilityTermStructure_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_maxTime_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_maxTimeQuantLib" ;;
let _DefaultProbabilityTermStructure_maxTime arg = match _DefaultProbabilityTermStructure_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_defaultProbability__SWIG_0QuantLib" ;;
let _DefaultProbabilityTermStructure_defaultProbability arg = match _DefaultProbabilityTermStructure_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_defaultProbability__SWIG_1QuantLib" ;;
let _DefaultProbabilityTermStructure_defaultProbability arg = match _DefaultProbabilityTermStructure_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_defaultProbability__SWIG_2QuantLib" ;;
let _DefaultProbabilityTermStructure_defaultProbability arg = match _DefaultProbabilityTermStructure_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_defaultProbability__SWIG_3QuantLib" ;;
let _DefaultProbabilityTermStructure_defaultProbability arg = match _DefaultProbabilityTermStructure_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_defaultProbability__SWIG_4QuantLib" ;;
let _DefaultProbabilityTermStructure_defaultProbability arg = match _DefaultProbabilityTermStructure_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_defaultProbability__SWIG_5QuantLib" ;;
let _DefaultProbabilityTermStructure_defaultProbability arg = match _DefaultProbabilityTermStructure_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_defaultProbability__SWIG_6QuantLib" ;;
let _DefaultProbabilityTermStructure_defaultProbability arg = match _DefaultProbabilityTermStructure_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_defaultProbabilityQuantLib" ;;
let _DefaultProbabilityTermStructure_defaultProbability arg = match _DefaultProbabilityTermStructure_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_survivalProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_survivalProbability__SWIG_0QuantLib" ;;
let _DefaultProbabilityTermStructure_survivalProbability arg = match _DefaultProbabilityTermStructure_survivalProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_survivalProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_survivalProbability__SWIG_1QuantLib" ;;
let _DefaultProbabilityTermStructure_survivalProbability arg = match _DefaultProbabilityTermStructure_survivalProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_survivalProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_survivalProbability__SWIG_2QuantLib" ;;
let _DefaultProbabilityTermStructure_survivalProbability arg = match _DefaultProbabilityTermStructure_survivalProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_survivalProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_survivalProbabilityQuantLib" ;;
let _DefaultProbabilityTermStructure_survivalProbability arg = match _DefaultProbabilityTermStructure_survivalProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_defaultDensity_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_defaultDensity__SWIG_0QuantLib" ;;
let _DefaultProbabilityTermStructure_defaultDensity arg = match _DefaultProbabilityTermStructure_defaultDensity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_defaultDensity_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_defaultDensity__SWIG_1QuantLib" ;;
let _DefaultProbabilityTermStructure_defaultDensity arg = match _DefaultProbabilityTermStructure_defaultDensity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_defaultDensity_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_defaultDensity__SWIG_2QuantLib" ;;
let _DefaultProbabilityTermStructure_defaultDensity arg = match _DefaultProbabilityTermStructure_defaultDensity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_defaultDensity_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_defaultDensityQuantLib" ;;
let _DefaultProbabilityTermStructure_defaultDensity arg = match _DefaultProbabilityTermStructure_defaultDensity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_hazardRate_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_hazardRate__SWIG_0QuantLib" ;;
let _DefaultProbabilityTermStructure_hazardRate arg = match _DefaultProbabilityTermStructure_hazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_hazardRate_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_hazardRate__SWIG_1QuantLib" ;;
let _DefaultProbabilityTermStructure_hazardRate arg = match _DefaultProbabilityTermStructure_hazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_hazardRate_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_hazardRate__SWIG_2QuantLib" ;;
let _DefaultProbabilityTermStructure_hazardRate arg = match _DefaultProbabilityTermStructure_hazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_hazardRate_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_hazardRateQuantLib" ;;
let _DefaultProbabilityTermStructure_hazardRate arg = match _DefaultProbabilityTermStructure_hazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_enableExtrapolationQuantLib" ;;
let _DefaultProbabilityTermStructure_enableExtrapolation arg = match _DefaultProbabilityTermStructure_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_disableExtrapolationQuantLib" ;;
let _DefaultProbabilityTermStructure_disableExtrapolation arg = match _DefaultProbabilityTermStructure_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructure_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructure_allowsExtrapolationQuantLib" ;;
let _DefaultProbabilityTermStructure_allowsExtrapolation arg = match _DefaultProbabilityTermStructure_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultProbabilityTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_DefaultProbabilityTermStructureHandle__SWIG_0QuantLib" ;;
let _new_DefaultProbabilityTermStructureHandle arg = match _new_DefaultProbabilityTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultProbabilityTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_DefaultProbabilityTermStructureHandleQuantLib" ;;
let _new_DefaultProbabilityTermStructureHandle arg = match _new_DefaultProbabilityTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle___deref___f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle___deref__QuantLib" ;;
let _DefaultProbabilityTermStructureHandle___deref__ arg = match _DefaultProbabilityTermStructureHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_empty_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_emptyQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_empty arg = match _DefaultProbabilityTermStructureHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_asObservableQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_asObservable arg = match _DefaultProbabilityTermStructureHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DefaultProbabilityTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_DefaultProbabilityTermStructureHandleQuantLib" ;;
let _delete_DefaultProbabilityTermStructureHandle arg = match _delete_DefaultProbabilityTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_dayCounter_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_dayCounterQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_dayCounter arg = match _DefaultProbabilityTermStructureHandle_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_calendar_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_calendarQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_calendar arg = match _DefaultProbabilityTermStructureHandle_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_referenceDate_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_referenceDateQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_referenceDate arg = match _DefaultProbabilityTermStructureHandle_referenceDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_maxDate_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_maxDateQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_maxDate arg = match _DefaultProbabilityTermStructureHandle_maxDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_maxTime_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_maxTimeQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_maxTime arg = match _DefaultProbabilityTermStructureHandle_maxTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_defaultProbability__SWIG_0QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_defaultProbability arg = match _DefaultProbabilityTermStructureHandle_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_defaultProbability__SWIG_1QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_defaultProbability arg = match _DefaultProbabilityTermStructureHandle_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_defaultProbability__SWIG_2QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_defaultProbability arg = match _DefaultProbabilityTermStructureHandle_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_defaultProbability__SWIG_3QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_defaultProbability arg = match _DefaultProbabilityTermStructureHandle_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_defaultProbability__SWIG_4QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_defaultProbability arg = match _DefaultProbabilityTermStructureHandle_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_defaultProbability__SWIG_5QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_defaultProbability arg = match _DefaultProbabilityTermStructureHandle_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_defaultProbability__SWIG_6QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_defaultProbability arg = match _DefaultProbabilityTermStructureHandle_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_defaultProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_defaultProbabilityQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_defaultProbability arg = match _DefaultProbabilityTermStructureHandle_defaultProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_survivalProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_survivalProbability__SWIG_0QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_survivalProbability arg = match _DefaultProbabilityTermStructureHandle_survivalProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_survivalProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_survivalProbability__SWIG_1QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_survivalProbability arg = match _DefaultProbabilityTermStructureHandle_survivalProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_survivalProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_survivalProbability__SWIG_2QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_survivalProbability arg = match _DefaultProbabilityTermStructureHandle_survivalProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_survivalProbability_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_survivalProbabilityQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_survivalProbability arg = match _DefaultProbabilityTermStructureHandle_survivalProbability_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_defaultDensity_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_defaultDensity__SWIG_0QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_defaultDensity arg = match _DefaultProbabilityTermStructureHandle_defaultDensity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_defaultDensity_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_defaultDensity__SWIG_1QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_defaultDensity arg = match _DefaultProbabilityTermStructureHandle_defaultDensity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_defaultDensity_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_defaultDensity__SWIG_2QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_defaultDensity arg = match _DefaultProbabilityTermStructureHandle_defaultDensity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_defaultDensity_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_defaultDensityQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_defaultDensity arg = match _DefaultProbabilityTermStructureHandle_defaultDensity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_hazardRate_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_hazardRate__SWIG_0QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_hazardRate arg = match _DefaultProbabilityTermStructureHandle_hazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_hazardRate_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_hazardRate__SWIG_1QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_hazardRate arg = match _DefaultProbabilityTermStructureHandle_hazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_hazardRate_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_hazardRate__SWIG_2QuantLib" ;;
let _DefaultProbabilityTermStructureHandle_hazardRate arg = match _DefaultProbabilityTermStructureHandle_hazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_hazardRate_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_hazardRateQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_hazardRate arg = match _DefaultProbabilityTermStructureHandle_hazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_enableExtrapolationQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_enableExtrapolation arg = match _DefaultProbabilityTermStructureHandle_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_disableExtrapolationQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_disableExtrapolation arg = match _DefaultProbabilityTermStructureHandle_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityTermStructureHandle_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityTermStructureHandle_allowsExtrapolationQuantLib" ;;
let _DefaultProbabilityTermStructureHandle_allowsExtrapolation arg = match _DefaultProbabilityTermStructureHandle_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableDefaultProbabilityTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableDefaultProbabilityTermStructureHandle__SWIG_0QuantLib" ;;
let _new_RelinkableDefaultProbabilityTermStructureHandle arg = match _new_RelinkableDefaultProbabilityTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableDefaultProbabilityTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableDefaultProbabilityTermStructureHandleQuantLib" ;;
let _new_RelinkableDefaultProbabilityTermStructureHandle arg = match _new_RelinkableDefaultProbabilityTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableDefaultProbabilityTermStructureHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableDefaultProbabilityTermStructureHandle_linkToQuantLib" ;;
let _RelinkableDefaultProbabilityTermStructureHandle_linkTo arg = match _RelinkableDefaultProbabilityTermStructureHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableDefaultProbabilityTermStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableDefaultProbabilityTermStructureHandleQuantLib" ;;
let _delete_RelinkableDefaultProbabilityTermStructureHandle arg = match _delete_RelinkableDefaultProbabilityTermStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatHazardRate_f : c_obj list -> c_obj list = "_wrap_new_FlatHazardRate__SWIG_0QuantLib" ;;
let _new_FlatHazardRate arg = match _new_FlatHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FlatHazardRate_f : c_obj list -> c_obj list = "_wrap_new_FlatHazardRateQuantLib" ;;
let _new_FlatHazardRate arg = match _new_FlatHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FlatHazardRate_f : c_obj list -> c_obj list = "_wrap_delete_FlatHazardRateQuantLib" ;;
let _delete_FlatHazardRate arg = match _delete_FlatHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HazardRateCurve_f : c_obj list -> c_obj list = "_wrap_new_HazardRateCurve__SWIG_0QuantLib" ;;
let _new_HazardRateCurve arg = match _new_HazardRateCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HazardRateCurve_f : c_obj list -> c_obj list = "_wrap_new_HazardRateCurve__SWIG_1QuantLib" ;;
let _new_HazardRateCurve arg = match _new_HazardRateCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HazardRateCurve_f : c_obj list -> c_obj list = "_wrap_new_HazardRateCurveQuantLib" ;;
let _new_HazardRateCurve arg = match _new_HazardRateCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HazardRateCurve_dates_f : c_obj list -> c_obj list = "_wrap_HazardRateCurve_datesQuantLib" ;;
let _HazardRateCurve_dates arg = match _HazardRateCurve_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HazardRateCurve_hazardRates_f : c_obj list -> c_obj list = "_wrap_HazardRateCurve_hazardRatesQuantLib" ;;
let _HazardRateCurve_hazardRates arg = match _HazardRateCurve_hazardRates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HazardRateCurve_nodes_f : c_obj list -> c_obj list = "_wrap_HazardRateCurve_nodesQuantLib" ;;
let _HazardRateCurve_nodes arg = match _HazardRateCurve_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HazardRateCurve_f : c_obj list -> c_obj list = "_wrap_delete_HazardRateCurveQuantLib" ;;
let _delete_HazardRateCurve arg = match _delete_HazardRateCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultDensityCurve_f : c_obj list -> c_obj list = "_wrap_new_DefaultDensityCurve__SWIG_0QuantLib" ;;
let _new_DefaultDensityCurve arg = match _new_DefaultDensityCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultDensityCurve_f : c_obj list -> c_obj list = "_wrap_new_DefaultDensityCurve__SWIG_1QuantLib" ;;
let _new_DefaultDensityCurve arg = match _new_DefaultDensityCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultDensityCurve_f : c_obj list -> c_obj list = "_wrap_new_DefaultDensityCurveQuantLib" ;;
let _new_DefaultDensityCurve arg = match _new_DefaultDensityCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultDensityCurve_dates_f : c_obj list -> c_obj list = "_wrap_DefaultDensityCurve_datesQuantLib" ;;
let _DefaultDensityCurve_dates arg = match _DefaultDensityCurve_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultDensityCurve_defaultDensities_f : c_obj list -> c_obj list = "_wrap_DefaultDensityCurve_defaultDensitiesQuantLib" ;;
let _DefaultDensityCurve_defaultDensities arg = match _DefaultDensityCurve_defaultDensities_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultDensityCurve_nodes_f : c_obj list -> c_obj list = "_wrap_DefaultDensityCurve_nodesQuantLib" ;;
let _DefaultDensityCurve_nodes arg = match _DefaultDensityCurve_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DefaultDensityCurve_f : c_obj list -> c_obj list = "_wrap_delete_DefaultDensityCurveQuantLib" ;;
let _delete_DefaultDensityCurve arg = match _delete_DefaultDensityCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityHelper___deref___f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityHelper___deref__QuantLib" ;;
let _DefaultProbabilityHelper___deref__ arg = match _DefaultProbabilityHelper___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityHelper_isNull_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityHelper_isNullQuantLib" ;;
let _DefaultProbabilityHelper_isNull arg = match _DefaultProbabilityHelper_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultProbabilityHelper_f : c_obj list -> c_obj list = "_wrap_new_DefaultProbabilityHelperQuantLib" ;;
let _new_DefaultProbabilityHelper arg = match _new_DefaultProbabilityHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DefaultProbabilityHelper_f : c_obj list -> c_obj list = "_wrap_delete_DefaultProbabilityHelperQuantLib" ;;
let _delete_DefaultProbabilityHelper arg = match _delete_DefaultProbabilityHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultProbabilityHelperVector_f : c_obj list -> c_obj list = "_wrap_new_DefaultProbabilityHelperVector__SWIG_0QuantLib" ;;
let _new_DefaultProbabilityHelperVector arg = match _new_DefaultProbabilityHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultProbabilityHelperVector_f : c_obj list -> c_obj list = "_wrap_new_DefaultProbabilityHelperVector__SWIG_1QuantLib" ;;
let _new_DefaultProbabilityHelperVector arg = match _new_DefaultProbabilityHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultProbabilityHelperVector_f : c_obj list -> c_obj list = "_wrap_new_DefaultProbabilityHelperVector__SWIG_2QuantLib" ;;
let _new_DefaultProbabilityHelperVector arg = match _new_DefaultProbabilityHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultProbabilityHelperVector_f : c_obj list -> c_obj list = "_wrap_new_DefaultProbabilityHelperVectorQuantLib" ;;
let _new_DefaultProbabilityHelperVector arg = match _new_DefaultProbabilityHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityHelperVector_size_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityHelperVector_sizeQuantLib" ;;
let _DefaultProbabilityHelperVector_size arg = match _DefaultProbabilityHelperVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityHelperVector_empty_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityHelperVector_emptyQuantLib" ;;
let _DefaultProbabilityHelperVector_empty arg = match _DefaultProbabilityHelperVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityHelperVector_clear_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityHelperVector_clearQuantLib" ;;
let _DefaultProbabilityHelperVector_clear arg = match _DefaultProbabilityHelperVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityHelperVector_push_back_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityHelperVector_push_backQuantLib" ;;
let _DefaultProbabilityHelperVector_push_back arg = match _DefaultProbabilityHelperVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityHelperVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityHelperVector_operator_bB___QuantLib" ;;
let _DefaultProbabilityHelperVector_operator_xx_xx_lbrace_xx_rbrace arg = match _DefaultProbabilityHelperVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityHelperVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityHelperVector_operator_e___QuantLib" ;;
let _DefaultProbabilityHelperVector_operator_xx_xx_equals arg = match _DefaultProbabilityHelperVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityHelperVector_set_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityHelperVector_setQuantLib" ;;
let _DefaultProbabilityHelperVector_set arg = match _DefaultProbabilityHelperVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DefaultProbabilityHelperVector_to_array_f : c_obj list -> c_obj list = "_wrap_DefaultProbabilityHelperVector_to_arrayQuantLib" ;;
let _DefaultProbabilityHelperVector_to_array arg = match _DefaultProbabilityHelperVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DefaultProbabilityHelperVector_f : c_obj list -> c_obj list = "_wrap_delete_DefaultProbabilityHelperVectorQuantLib" ;;
let _delete_DefaultProbabilityHelperVector arg = match _delete_DefaultProbabilityHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SpreadCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_SpreadCdsHelper__SWIG_0QuantLib" ;;
let _new_SpreadCdsHelper arg = match _new_SpreadCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SpreadCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_SpreadCdsHelper__SWIG_1QuantLib" ;;
let _new_SpreadCdsHelper arg = match _new_SpreadCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SpreadCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_SpreadCdsHelper__SWIG_2QuantLib" ;;
let _new_SpreadCdsHelper arg = match _new_SpreadCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SpreadCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_SpreadCdsHelper__SWIG_3QuantLib" ;;
let _new_SpreadCdsHelper arg = match _new_SpreadCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SpreadCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_SpreadCdsHelper__SWIG_4QuantLib" ;;
let _new_SpreadCdsHelper arg = match _new_SpreadCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SpreadCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_SpreadCdsHelperQuantLib" ;;
let _new_SpreadCdsHelper arg = match _new_SpreadCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SpreadCdsHelper_f : c_obj list -> c_obj list = "_wrap_delete_SpreadCdsHelperQuantLib" ;;
let _delete_SpreadCdsHelper arg = match _delete_SpreadCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UpfrontCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_UpfrontCdsHelper__SWIG_0QuantLib" ;;
let _new_UpfrontCdsHelper arg = match _new_UpfrontCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UpfrontCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_UpfrontCdsHelper__SWIG_1QuantLib" ;;
let _new_UpfrontCdsHelper arg = match _new_UpfrontCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UpfrontCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_UpfrontCdsHelper__SWIG_2QuantLib" ;;
let _new_UpfrontCdsHelper arg = match _new_UpfrontCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UpfrontCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_UpfrontCdsHelper__SWIG_3QuantLib" ;;
let _new_UpfrontCdsHelper arg = match _new_UpfrontCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UpfrontCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_UpfrontCdsHelper__SWIG_4QuantLib" ;;
let _new_UpfrontCdsHelper arg = match _new_UpfrontCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UpfrontCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_UpfrontCdsHelper__SWIG_5QuantLib" ;;
let _new_UpfrontCdsHelper arg = match _new_UpfrontCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UpfrontCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_UpfrontCdsHelper__SWIG_6QuantLib" ;;
let _new_UpfrontCdsHelper arg = match _new_UpfrontCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UpfrontCdsHelper_f : c_obj list -> c_obj list = "_wrap_new_UpfrontCdsHelperQuantLib" ;;
let _new_UpfrontCdsHelper arg = match _new_UpfrontCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_UpfrontCdsHelper_f : c_obj list -> c_obj list = "_wrap_delete_UpfrontCdsHelperQuantLib" ;;
let _delete_UpfrontCdsHelper arg = match _delete_UpfrontCdsHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HazardRate_f : c_obj list -> c_obj list = "_wrap_new_HazardRateQuantLib" ;;
let _new_HazardRate arg = match _new_HazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HazardRate_f : c_obj list -> c_obj list = "_wrap_delete_HazardRateQuantLib" ;;
let _delete_HazardRate arg = match _delete_HazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DefaultDensity_f : c_obj list -> c_obj list = "_wrap_new_DefaultDensityQuantLib" ;;
let _new_DefaultDensity arg = match _new_DefaultDensity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DefaultDensity_f : c_obj list -> c_obj list = "_wrap_delete_DefaultDensityQuantLib" ;;
let _delete_DefaultDensity arg = match _delete_DefaultDensity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatHazardRate_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatHazardRate__SWIG_0QuantLib" ;;
let _new_PiecewiseFlatHazardRate arg = match _new_PiecewiseFlatHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatHazardRate_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatHazardRate__SWIG_1QuantLib" ;;
let _new_PiecewiseFlatHazardRate arg = match _new_PiecewiseFlatHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatHazardRate_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatHazardRate__SWIG_2QuantLib" ;;
let _new_PiecewiseFlatHazardRate arg = match _new_PiecewiseFlatHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatHazardRate_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatHazardRate__SWIG_3QuantLib" ;;
let _new_PiecewiseFlatHazardRate arg = match _new_PiecewiseFlatHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatHazardRate_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatHazardRate__SWIG_4QuantLib" ;;
let _new_PiecewiseFlatHazardRate arg = match _new_PiecewiseFlatHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatHazardRate_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatHazardRateQuantLib" ;;
let _new_PiecewiseFlatHazardRate arg = match _new_PiecewiseFlatHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseFlatHazardRate_dates_f : c_obj list -> c_obj list = "_wrap_PiecewiseFlatHazardRate_datesQuantLib" ;;
let _PiecewiseFlatHazardRate_dates arg = match _PiecewiseFlatHazardRate_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseFlatHazardRate_times_f : c_obj list -> c_obj list = "_wrap_PiecewiseFlatHazardRate_timesQuantLib" ;;
let _PiecewiseFlatHazardRate_times arg = match _PiecewiseFlatHazardRate_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseFlatHazardRate_nodes_f : c_obj list -> c_obj list = "_wrap_PiecewiseFlatHazardRate_nodesQuantLib" ;;
let _PiecewiseFlatHazardRate_nodes arg = match _PiecewiseFlatHazardRate_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PiecewiseFlatHazardRate_f : c_obj list -> c_obj list = "_wrap_delete_PiecewiseFlatHazardRateQuantLib" ;;
let _delete_PiecewiseFlatHazardRate arg = match _delete_PiecewiseFlatHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "Protection::Side_marker" (`Side)
external _Buyer : c_obj -> Swig.c_obj = "_wrap_Buyer" 
external _Seller : c_obj -> Swig.c_obj = "_wrap_Seller" 
external _new_Protection_f : c_obj list -> c_obj list = "_wrap_new_ProtectionQuantLib" ;;
let _new_Protection arg = match _new_Protection_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Protection_f : c_obj list -> c_obj list = "_wrap_delete_ProtectionQuantLib" ;;
let _delete_Protection arg = match _delete_Protection_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CreditDefaultSwap_f : c_obj list -> c_obj list = "_wrap_new_CreditDefaultSwap__SWIG_0QuantLib" ;;
let _new_CreditDefaultSwap arg = match _new_CreditDefaultSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CreditDefaultSwap_f : c_obj list -> c_obj list = "_wrap_new_CreditDefaultSwap__SWIG_1QuantLib" ;;
let _new_CreditDefaultSwap arg = match _new_CreditDefaultSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CreditDefaultSwap_f : c_obj list -> c_obj list = "_wrap_new_CreditDefaultSwap__SWIG_2QuantLib" ;;
let _new_CreditDefaultSwap arg = match _new_CreditDefaultSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CreditDefaultSwap_f : c_obj list -> c_obj list = "_wrap_new_CreditDefaultSwap__SWIG_3QuantLib" ;;
let _new_CreditDefaultSwap arg = match _new_CreditDefaultSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CreditDefaultSwap_f : c_obj list -> c_obj list = "_wrap_new_CreditDefaultSwap__SWIG_4QuantLib" ;;
let _new_CreditDefaultSwap arg = match _new_CreditDefaultSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CreditDefaultSwap_f : c_obj list -> c_obj list = "_wrap_new_CreditDefaultSwapQuantLib" ;;
let _new_CreditDefaultSwap arg = match _new_CreditDefaultSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_side_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_sideQuantLib" ;;
let _CreditDefaultSwap_side arg = match _CreditDefaultSwap_side_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_notional_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_notionalQuantLib" ;;
let _CreditDefaultSwap_notional arg = match _CreditDefaultSwap_notional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_runningSpread_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_runningSpreadQuantLib" ;;
let _CreditDefaultSwap_runningSpread arg = match _CreditDefaultSwap_runningSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_upfront_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_upfrontQuantLib" ;;
let _CreditDefaultSwap_upfront arg = match _CreditDefaultSwap_upfront_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_settlesAccrual_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_settlesAccrualQuantLib" ;;
let _CreditDefaultSwap_settlesAccrual arg = match _CreditDefaultSwap_settlesAccrual_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_paysAtDefaultTime_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_paysAtDefaultTimeQuantLib" ;;
let _CreditDefaultSwap_paysAtDefaultTime arg = match _CreditDefaultSwap_paysAtDefaultTime_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_fairSpread_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_fairSpreadQuantLib" ;;
let _CreditDefaultSwap_fairSpread arg = match _CreditDefaultSwap_fairSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_fairUpfront_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_fairUpfrontQuantLib" ;;
let _CreditDefaultSwap_fairUpfront arg = match _CreditDefaultSwap_fairUpfront_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_couponLegBPS_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_couponLegBPSQuantLib" ;;
let _CreditDefaultSwap_couponLegBPS arg = match _CreditDefaultSwap_couponLegBPS_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_couponLegNPV_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_couponLegNPVQuantLib" ;;
let _CreditDefaultSwap_couponLegNPV arg = match _CreditDefaultSwap_couponLegNPV_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_defaultLegNPV_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_defaultLegNPVQuantLib" ;;
let _CreditDefaultSwap_defaultLegNPV arg = match _CreditDefaultSwap_defaultLegNPV_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_upfrontBPS_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_upfrontBPSQuantLib" ;;
let _CreditDefaultSwap_upfrontBPS arg = match _CreditDefaultSwap_upfrontBPS_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_upfrontNPV_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_upfrontNPVQuantLib" ;;
let _CreditDefaultSwap_upfrontNPV arg = match _CreditDefaultSwap_upfrontNPV_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_impliedHazardRate_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_impliedHazardRate__SWIG_0QuantLib" ;;
let _CreditDefaultSwap_impliedHazardRate arg = match _CreditDefaultSwap_impliedHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_impliedHazardRate_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_impliedHazardRate__SWIG_1QuantLib" ;;
let _CreditDefaultSwap_impliedHazardRate arg = match _CreditDefaultSwap_impliedHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_impliedHazardRate_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_impliedHazardRateQuantLib" ;;
let _CreditDefaultSwap_impliedHazardRate arg = match _CreditDefaultSwap_impliedHazardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CreditDefaultSwap_coupons_f : c_obj list -> c_obj list = "_wrap_CreditDefaultSwap_couponsQuantLib" ;;
let _CreditDefaultSwap_coupons arg = match _CreditDefaultSwap_coupons_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CreditDefaultSwap_f : c_obj list -> c_obj list = "_wrap_delete_CreditDefaultSwapQuantLib" ;;
let _delete_CreditDefaultSwap arg = match _delete_CreditDefaultSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MidPointCdsEngine_f : c_obj list -> c_obj list = "_wrap_new_MidPointCdsEngineQuantLib" ;;
let _new_MidPointCdsEngine arg = match _new_MidPointCdsEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MidPointCdsEngine_f : c_obj list -> c_obj list = "_wrap_delete_MidPointCdsEngineQuantLib" ;;
let _delete_MidPointCdsEngine arg = match _delete_MidPointCdsEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntegralCdsEngine_f : c_obj list -> c_obj list = "_wrap_new_IntegralCdsEngine__SWIG_0QuantLib" ;;
let _new_IntegralCdsEngine arg = match _new_IntegralCdsEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IntegralCdsEngine_f : c_obj list -> c_obj list = "_wrap_new_IntegralCdsEngineQuantLib" ;;
let _new_IntegralCdsEngine arg = match _new_IntegralCdsEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IntegralCdsEngine_f : c_obj list -> c_obj list = "_wrap_delete_IntegralCdsEngineQuantLib" ;;
let _delete_IntegralCdsEngine arg = match _delete_IntegralCdsEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_DiscountCurve__SWIG_0QuantLib" ;;
let _new_DiscountCurve arg = match _new_DiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_DiscountCurve__SWIG_1QuantLib" ;;
let _new_DiscountCurve arg = match _new_DiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_DiscountCurveQuantLib" ;;
let _new_DiscountCurve arg = match _new_DiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscountCurve_times_f : c_obj list -> c_obj list = "_wrap_DiscountCurve_timesQuantLib" ;;
let _DiscountCurve_times arg = match _DiscountCurve_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscountCurve_data_f : c_obj list -> c_obj list = "_wrap_DiscountCurve_dataQuantLib" ;;
let _DiscountCurve_data arg = match _DiscountCurve_data_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscountCurve_dates_f : c_obj list -> c_obj list = "_wrap_DiscountCurve_datesQuantLib" ;;
let _DiscountCurve_dates arg = match _DiscountCurve_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscountCurve_discounts_f : c_obj list -> c_obj list = "_wrap_DiscountCurve_discountsQuantLib" ;;
let _DiscountCurve_discounts arg = match _DiscountCurve_discounts_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _DiscountCurve_nodes_f : c_obj list -> c_obj list = "_wrap_DiscountCurve_nodesQuantLib" ;;
let _DiscountCurve_nodes arg = match _DiscountCurve_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DiscountCurve_f : c_obj list -> c_obj list = "_wrap_delete_DiscountCurveQuantLib" ;;
let _delete_DiscountCurve arg = match _delete_DiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NormalDistribution_f : c_obj list -> c_obj list = "_wrap_new_NormalDistribution__SWIG_0QuantLib" ;;
let _new_NormalDistribution arg = match _new_NormalDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NormalDistribution_f : c_obj list -> c_obj list = "_wrap_new_NormalDistribution__SWIG_1QuantLib" ;;
let _new_NormalDistribution arg = match _new_NormalDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NormalDistribution_f : c_obj list -> c_obj list = "_wrap_new_NormalDistributionQuantLib" ;;
let _new_NormalDistribution arg = match _new_NormalDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NormalDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_NormalDistribution_operator_pP___QuantLib" ;;
let _NormalDistribution_operator_xx_xx_lparen_xx_rparen arg = match _NormalDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NormalDistribution_derivative_f : c_obj list -> c_obj list = "_wrap_NormalDistribution_derivativeQuantLib" ;;
let _NormalDistribution_derivative arg = match _NormalDistribution_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NormalDistribution_f : c_obj list -> c_obj list = "_wrap_delete_NormalDistributionQuantLib" ;;
let _delete_NormalDistribution arg = match _delete_NormalDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CumulativeNormalDistribution_f : c_obj list -> c_obj list = "_wrap_new_CumulativeNormalDistribution__SWIG_0QuantLib" ;;
let _new_CumulativeNormalDistribution arg = match _new_CumulativeNormalDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CumulativeNormalDistribution_f : c_obj list -> c_obj list = "_wrap_new_CumulativeNormalDistribution__SWIG_1QuantLib" ;;
let _new_CumulativeNormalDistribution arg = match _new_CumulativeNormalDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CumulativeNormalDistribution_f : c_obj list -> c_obj list = "_wrap_new_CumulativeNormalDistributionQuantLib" ;;
let _new_CumulativeNormalDistribution arg = match _new_CumulativeNormalDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CumulativeNormalDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_CumulativeNormalDistribution_operator_pP___QuantLib" ;;
let _CumulativeNormalDistribution_operator_xx_xx_lparen_xx_rparen arg = match _CumulativeNormalDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CumulativeNormalDistribution_derivative_f : c_obj list -> c_obj list = "_wrap_CumulativeNormalDistribution_derivativeQuantLib" ;;
let _CumulativeNormalDistribution_derivative arg = match _CumulativeNormalDistribution_derivative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CumulativeNormalDistribution_f : c_obj list -> c_obj list = "_wrap_delete_CumulativeNormalDistributionQuantLib" ;;
let _delete_CumulativeNormalDistribution arg = match _delete_CumulativeNormalDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InverseCumulativeNormal_f : c_obj list -> c_obj list = "_wrap_new_InverseCumulativeNormal__SWIG_0QuantLib" ;;
let _new_InverseCumulativeNormal arg = match _new_InverseCumulativeNormal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InverseCumulativeNormal_f : c_obj list -> c_obj list = "_wrap_new_InverseCumulativeNormal__SWIG_1QuantLib" ;;
let _new_InverseCumulativeNormal arg = match _new_InverseCumulativeNormal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InverseCumulativeNormal_f : c_obj list -> c_obj list = "_wrap_new_InverseCumulativeNormalQuantLib" ;;
let _new_InverseCumulativeNormal arg = match _new_InverseCumulativeNormal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InverseCumulativeNormal_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_InverseCumulativeNormal_operator_pP___QuantLib" ;;
let _InverseCumulativeNormal_operator_xx_xx_lparen_xx_rparen arg = match _InverseCumulativeNormal_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InverseCumulativeNormal_f : c_obj list -> c_obj list = "_wrap_delete_InverseCumulativeNormalQuantLib" ;;
let _delete_InverseCumulativeNormal arg = match _delete_InverseCumulativeNormal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MoroInverseCumulativeNormal_f : c_obj list -> c_obj list = "_wrap_new_MoroInverseCumulativeNormal__SWIG_0QuantLib" ;;
let _new_MoroInverseCumulativeNormal arg = match _new_MoroInverseCumulativeNormal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MoroInverseCumulativeNormal_f : c_obj list -> c_obj list = "_wrap_new_MoroInverseCumulativeNormal__SWIG_1QuantLib" ;;
let _new_MoroInverseCumulativeNormal arg = match _new_MoroInverseCumulativeNormal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MoroInverseCumulativeNormal_f : c_obj list -> c_obj list = "_wrap_new_MoroInverseCumulativeNormalQuantLib" ;;
let _new_MoroInverseCumulativeNormal arg = match _new_MoroInverseCumulativeNormal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MoroInverseCumulativeNormal_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_MoroInverseCumulativeNormal_operator_pP___QuantLib" ;;
let _MoroInverseCumulativeNormal_operator_xx_xx_lparen_xx_rparen arg = match _MoroInverseCumulativeNormal_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MoroInverseCumulativeNormal_f : c_obj list -> c_obj list = "_wrap_delete_MoroInverseCumulativeNormalQuantLib" ;;
let _delete_MoroInverseCumulativeNormal arg = match _delete_MoroInverseCumulativeNormal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BivariateCumulativeNormalDistribution_f : c_obj list -> c_obj list = "_wrap_new_BivariateCumulativeNormalDistributionQuantLib" ;;
let _new_BivariateCumulativeNormalDistribution arg = match _new_BivariateCumulativeNormalDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BivariateCumulativeNormalDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_BivariateCumulativeNormalDistribution_operator_pP___QuantLib" ;;
let _BivariateCumulativeNormalDistribution_operator_xx_xx_lparen_xx_rparen arg = match _BivariateCumulativeNormalDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BivariateCumulativeNormalDistribution_f : c_obj list -> c_obj list = "_wrap_delete_BivariateCumulativeNormalDistributionQuantLib" ;;
let _delete_BivariateCumulativeNormalDistribution arg = match _delete_BivariateCumulativeNormalDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BinomialDistribution_f : c_obj list -> c_obj list = "_wrap_new_BinomialDistributionQuantLib" ;;
let _new_BinomialDistribution arg = match _new_BinomialDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BinomialDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_BinomialDistribution_operator_pP___QuantLib" ;;
let _BinomialDistribution_operator_xx_xx_lparen_xx_rparen arg = match _BinomialDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BinomialDistribution_f : c_obj list -> c_obj list = "_wrap_delete_BinomialDistributionQuantLib" ;;
let _delete_BinomialDistribution arg = match _delete_BinomialDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CumulativeBinomialDistribution_f : c_obj list -> c_obj list = "_wrap_new_CumulativeBinomialDistributionQuantLib" ;;
let _new_CumulativeBinomialDistribution arg = match _new_CumulativeBinomialDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CumulativeBinomialDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_CumulativeBinomialDistribution_operator_pP___QuantLib" ;;
let _CumulativeBinomialDistribution_operator_xx_xx_lparen_xx_rparen arg = match _CumulativeBinomialDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CumulativeBinomialDistribution_f : c_obj list -> c_obj list = "_wrap_delete_CumulativeBinomialDistributionQuantLib" ;;
let _delete_CumulativeBinomialDistribution arg = match _delete_CumulativeBinomialDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BivariateCumulativeNormalDistributionDr78_f : c_obj list -> c_obj list = "_wrap_new_BivariateCumulativeNormalDistributionDr78QuantLib" ;;
let _new_BivariateCumulativeNormalDistributionDr78 arg = match _new_BivariateCumulativeNormalDistributionDr78_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BivariateCumulativeNormalDistributionDr78_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_BivariateCumulativeNormalDistributionDr78_operator_pP___QuantLib" ;;
let _BivariateCumulativeNormalDistributionDr78_operator_xx_xx_lparen_xx_rparen arg = match _BivariateCumulativeNormalDistributionDr78_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BivariateCumulativeNormalDistributionDr78_f : c_obj list -> c_obj list = "_wrap_delete_BivariateCumulativeNormalDistributionDr78QuantLib" ;;
let _delete_BivariateCumulativeNormalDistributionDr78 arg = match _delete_BivariateCumulativeNormalDistributionDr78_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BivariateCumulativeNormalDistributionWe04DP_f : c_obj list -> c_obj list = "_wrap_new_BivariateCumulativeNormalDistributionWe04DPQuantLib" ;;
let _new_BivariateCumulativeNormalDistributionWe04DP arg = match _new_BivariateCumulativeNormalDistributionWe04DP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BivariateCumulativeNormalDistributionWe04DP_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_BivariateCumulativeNormalDistributionWe04DP_operator_pP___QuantLib" ;;
let _BivariateCumulativeNormalDistributionWe04DP_operator_xx_xx_lparen_xx_rparen arg = match _BivariateCumulativeNormalDistributionWe04DP_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BivariateCumulativeNormalDistributionWe04DP_f : c_obj list -> c_obj list = "_wrap_delete_BivariateCumulativeNormalDistributionWe04DPQuantLib" ;;
let _delete_BivariateCumulativeNormalDistributionWe04DP arg = match _delete_BivariateCumulativeNormalDistributionWe04DP_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ChiSquareDistribution_f : c_obj list -> c_obj list = "_wrap_new_ChiSquareDistributionQuantLib" ;;
let _new_ChiSquareDistribution arg = match _new_ChiSquareDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ChiSquareDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_ChiSquareDistribution_operator_pP___QuantLib" ;;
let _ChiSquareDistribution_operator_xx_xx_lparen_xx_rparen arg = match _ChiSquareDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ChiSquareDistribution_f : c_obj list -> c_obj list = "_wrap_delete_ChiSquareDistributionQuantLib" ;;
let _delete_ChiSquareDistribution arg = match _delete_ChiSquareDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NonCentralChiSquareDistribution_f : c_obj list -> c_obj list = "_wrap_new_NonCentralChiSquareDistributionQuantLib" ;;
let _new_NonCentralChiSquareDistribution arg = match _new_NonCentralChiSquareDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonCentralChiSquareDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_NonCentralChiSquareDistribution_operator_pP___QuantLib" ;;
let _NonCentralChiSquareDistribution_operator_xx_xx_lparen_xx_rparen arg = match _NonCentralChiSquareDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NonCentralChiSquareDistribution_f : c_obj list -> c_obj list = "_wrap_delete_NonCentralChiSquareDistributionQuantLib" ;;
let _delete_NonCentralChiSquareDistribution arg = match _delete_NonCentralChiSquareDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InverseNonCentralChiSquareDistribution_f : c_obj list -> c_obj list = "_wrap_new_InverseNonCentralChiSquareDistribution__SWIG_0QuantLib" ;;
let _new_InverseNonCentralChiSquareDistribution arg = match _new_InverseNonCentralChiSquareDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InverseNonCentralChiSquareDistribution_f : c_obj list -> c_obj list = "_wrap_new_InverseNonCentralChiSquareDistribution__SWIG_1QuantLib" ;;
let _new_InverseNonCentralChiSquareDistribution arg = match _new_InverseNonCentralChiSquareDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InverseNonCentralChiSquareDistribution_f : c_obj list -> c_obj list = "_wrap_new_InverseNonCentralChiSquareDistributionQuantLib" ;;
let _new_InverseNonCentralChiSquareDistribution arg = match _new_InverseNonCentralChiSquareDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InverseNonCentralChiSquareDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_InverseNonCentralChiSquareDistribution_operator_pP___QuantLib" ;;
let _InverseNonCentralChiSquareDistribution_operator_xx_xx_lparen_xx_rparen arg = match _InverseNonCentralChiSquareDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InverseNonCentralChiSquareDistribution_f : c_obj list -> c_obj list = "_wrap_delete_InverseNonCentralChiSquareDistributionQuantLib" ;;
let _delete_InverseNonCentralChiSquareDistribution arg = match _delete_InverseNonCentralChiSquareDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GammaDistribution_f : c_obj list -> c_obj list = "_wrap_new_GammaDistributionQuantLib" ;;
let _new_GammaDistribution arg = match _new_GammaDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GammaDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_GammaDistribution_operator_pP___QuantLib" ;;
let _GammaDistribution_operator_xx_xx_lparen_xx_rparen arg = match _GammaDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GammaDistribution_f : c_obj list -> c_obj list = "_wrap_delete_GammaDistributionQuantLib" ;;
let _delete_GammaDistribution arg = match _delete_GammaDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GammaFunction_logValue_f : c_obj list -> c_obj list = "_wrap_GammaFunction_logValueQuantLib" ;;
let _GammaFunction_logValue arg = match _GammaFunction_logValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GammaFunction_f : c_obj list -> c_obj list = "_wrap_new_GammaFunctionQuantLib" ;;
let _new_GammaFunction arg = match _new_GammaFunction_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GammaFunction_f : c_obj list -> c_obj list = "_wrap_delete_GammaFunctionQuantLib" ;;
let _delete_GammaFunction arg = match _delete_GammaFunction_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PoissonDistribution_f : c_obj list -> c_obj list = "_wrap_new_PoissonDistributionQuantLib" ;;
let _new_PoissonDistribution arg = match _new_PoissonDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PoissonDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_PoissonDistribution_operator_pP___QuantLib" ;;
let _PoissonDistribution_operator_xx_xx_lparen_xx_rparen arg = match _PoissonDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PoissonDistribution_f : c_obj list -> c_obj list = "_wrap_delete_PoissonDistributionQuantLib" ;;
let _delete_PoissonDistribution arg = match _delete_PoissonDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CumulativePoissonDistribution_f : c_obj list -> c_obj list = "_wrap_new_CumulativePoissonDistributionQuantLib" ;;
let _new_CumulativePoissonDistribution arg = match _new_CumulativePoissonDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CumulativePoissonDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_CumulativePoissonDistribution_operator_pP___QuantLib" ;;
let _CumulativePoissonDistribution_operator_xx_xx_lparen_xx_rparen arg = match _CumulativePoissonDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CumulativePoissonDistribution_f : c_obj list -> c_obj list = "_wrap_delete_CumulativePoissonDistributionQuantLib" ;;
let _delete_CumulativePoissonDistribution arg = match _delete_CumulativePoissonDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InverseCumulativePoisson_f : c_obj list -> c_obj list = "_wrap_new_InverseCumulativePoissonQuantLib" ;;
let _new_InverseCumulativePoisson arg = match _new_InverseCumulativePoisson_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InverseCumulativePoisson_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_InverseCumulativePoisson_operator_pP___QuantLib" ;;
let _InverseCumulativePoisson_operator_xx_xx_lparen_xx_rparen arg = match _InverseCumulativePoisson_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InverseCumulativePoisson_f : c_obj list -> c_obj list = "_wrap_delete_InverseCumulativePoissonQuantLib" ;;
let _delete_InverseCumulativePoisson arg = match _delete_InverseCumulativePoisson_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StudentDistribution_f : c_obj list -> c_obj list = "_wrap_new_StudentDistributionQuantLib" ;;
let _new_StudentDistribution arg = match _new_StudentDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StudentDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_StudentDistribution_operator_pP___QuantLib" ;;
let _StudentDistribution_operator_xx_xx_lparen_xx_rparen arg = match _StudentDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_StudentDistribution_f : c_obj list -> c_obj list = "_wrap_delete_StudentDistributionQuantLib" ;;
let _delete_StudentDistribution arg = match _delete_StudentDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CumulativeStudentDistribution_f : c_obj list -> c_obj list = "_wrap_new_CumulativeStudentDistributionQuantLib" ;;
let _new_CumulativeStudentDistribution arg = match _new_CumulativeStudentDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CumulativeStudentDistribution_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_CumulativeStudentDistribution_operator_pP___QuantLib" ;;
let _CumulativeStudentDistribution_operator_xx_xx_lparen_xx_rparen arg = match _CumulativeStudentDistribution_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CumulativeStudentDistribution_f : c_obj list -> c_obj list = "_wrap_delete_CumulativeStudentDistributionQuantLib" ;;
let _delete_CumulativeStudentDistribution arg = match _delete_CumulativeStudentDistribution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InverseCumulativeStudent_f : c_obj list -> c_obj list = "_wrap_new_InverseCumulativeStudent__SWIG_0QuantLib" ;;
let _new_InverseCumulativeStudent arg = match _new_InverseCumulativeStudent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InverseCumulativeStudent_f : c_obj list -> c_obj list = "_wrap_new_InverseCumulativeStudent__SWIG_1QuantLib" ;;
let _new_InverseCumulativeStudent arg = match _new_InverseCumulativeStudent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InverseCumulativeStudent_f : c_obj list -> c_obj list = "_wrap_new_InverseCumulativeStudentQuantLib" ;;
let _new_InverseCumulativeStudent arg = match _new_InverseCumulativeStudent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InverseCumulativeStudent_operator_xx_xx_lparen_xx_rparen_f : c_obj list -> c_obj list = "_wrap_InverseCumulativeStudent_operator_pP___QuantLib" ;;
let _InverseCumulativeStudent_operator_xx_xx_lparen_xx_rparen arg = match _InverseCumulativeStudent_operator_xx_xx_lparen_xx_rparen_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InverseCumulativeStudent_f : c_obj list -> c_obj list = "_wrap_delete_InverseCumulativeStudentQuantLib" ;;
let _delete_InverseCumulativeStudent arg = match _delete_InverseCumulativeStudent_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Money_f : c_obj list -> c_obj list = "_wrap_new_Money__SWIG_0QuantLib" ;;
let _new_Money arg = match _new_Money_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Money_f : c_obj list -> c_obj list = "_wrap_new_MoneyQuantLib" ;;
let _new_Money arg = match _new_Money_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Money_currency_f : c_obj list -> c_obj list = "_wrap_Money_currencyQuantLib" ;;
let _Money_currency arg = match _Money_currency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Money_value_f : c_obj list -> c_obj list = "_wrap_Money_valueQuantLib" ;;
let _Money_value arg = match _Money_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Money_rounded_f : c_obj list -> c_obj list = "_wrap_Money_roundedQuantLib" ;;
let _Money_rounded arg = match _Money_rounded_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "Money::ConversionType_marker" (`ConversionType)
external _NoConversion : c_obj -> Swig.c_obj = "_wrap_NoConversion" 
external _BaseCurrencyConversion : c_obj -> Swig.c_obj = "_wrap_BaseCurrencyConversion" 
external _AutomatedConversion : c_obj -> Swig.c_obj = "_wrap_AutomatedConversion" 
external _Money_setConversionType_f : c_obj list -> c_obj list = "_wrap_Money_setConversionTypeQuantLib" ;;
let _Money_setConversionType arg = match _Money_setConversionType_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Money_setBaseCurrency_f : c_obj list -> c_obj list = "_wrap_Money_setBaseCurrencyQuantLib" ;;
let _Money_setBaseCurrency arg = match _Money_setBaseCurrency_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Money_f : c_obj list -> c_obj list = "_wrap_delete_MoneyQuantLib" ;;
let _delete_Money arg = match _delete_Money_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "ExchangeRate::Type_marker" (`Type)
external _Direct : c_obj -> Swig.c_obj = "_wrap_Direct" 
external _Derived : c_obj -> Swig.c_obj = "_wrap_Derived" 
external _new_ExchangeRate_f : c_obj list -> c_obj list = "_wrap_new_ExchangeRateQuantLib" ;;
let _new_ExchangeRate arg = match _new_ExchangeRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRate_source_f : c_obj list -> c_obj list = "_wrap_ExchangeRate_sourceQuantLib" ;;
let _ExchangeRate_source arg = match _ExchangeRate_source_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRate_target_f : c_obj list -> c_obj list = "_wrap_ExchangeRate_targetQuantLib" ;;
let _ExchangeRate_target arg = match _ExchangeRate_target_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRate_type_f : c_obj list -> c_obj list = "_wrap_ExchangeRate_typeQuantLib" ;;
let _ExchangeRate_type arg = match _ExchangeRate_type_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRate_rate_f : c_obj list -> c_obj list = "_wrap_ExchangeRate_rateQuantLib" ;;
let _ExchangeRate_rate arg = match _ExchangeRate_rate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRate_exchange_f : c_obj list -> c_obj list = "_wrap_ExchangeRate_exchangeQuantLib" ;;
let _ExchangeRate_exchange arg = match _ExchangeRate_exchange_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRate_chain_f : c_obj list -> c_obj list = "_wrap_ExchangeRate_chainQuantLib" ;;
let _ExchangeRate_chain arg = match _ExchangeRate_chain_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ExchangeRate_f : c_obj list -> c_obj list = "_wrap_delete_ExchangeRateQuantLib" ;;
let _delete_ExchangeRate arg = match _delete_ExchangeRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRateManager_instance_f : c_obj list -> c_obj list = "_wrap_ExchangeRateManager_instanceQuantLib" ;;
let _ExchangeRateManager_instance arg = match _ExchangeRateManager_instance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRateManager_add_f : c_obj list -> c_obj list = "_wrap_ExchangeRateManager_add__SWIG_0QuantLib" ;;
let _ExchangeRateManager_add arg = match _ExchangeRateManager_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRateManager_add_f : c_obj list -> c_obj list = "_wrap_ExchangeRateManager_add__SWIG_1QuantLib" ;;
let _ExchangeRateManager_add arg = match _ExchangeRateManager_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRateManager_add_f : c_obj list -> c_obj list = "_wrap_ExchangeRateManager_addQuantLib" ;;
let _ExchangeRateManager_add arg = match _ExchangeRateManager_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRateManager_lookup_f : c_obj list -> c_obj list = "_wrap_ExchangeRateManager_lookup__SWIG_0QuantLib" ;;
let _ExchangeRateManager_lookup arg = match _ExchangeRateManager_lookup_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRateManager_lookup_f : c_obj list -> c_obj list = "_wrap_ExchangeRateManager_lookupQuantLib" ;;
let _ExchangeRateManager_lookup arg = match _ExchangeRateManager_lookup_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ExchangeRateManager_clear_f : c_obj list -> c_obj list = "_wrap_ExchangeRateManager_clearQuantLib" ;;
let _ExchangeRateManager_clear arg = match _ExchangeRateManager_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ExchangeRateManager_f : c_obj list -> c_obj list = "_wrap_delete_ExchangeRateManagerQuantLib" ;;
let _delete_ExchangeRateManager arg = match _delete_ExchangeRateManager_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "Futures::Type_marker" (`Type)
external _IMM : c_obj -> Swig.c_obj = "_wrap_IMM" 
external _ASX : c_obj -> Swig.c_obj = "_wrap_ASX" 
external _new_Futures_f : c_obj list -> c_obj list = "_wrap_new_FuturesQuantLib" ;;
let _new_Futures arg = match _new_Futures_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Futures_f : c_obj list -> c_obj list = "_wrap_delete_FuturesQuantLib" ;;
let _delete_Futures arg = match _delete_Futures_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TimeBasket_f : c_obj list -> c_obj list = "_wrap_new_TimeBasket__SWIG_0QuantLib" ;;
let _new_TimeBasket arg = match _new_TimeBasket_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TimeBasket_f : c_obj list -> c_obj list = "_wrap_new_TimeBasketQuantLib" ;;
let _new_TimeBasket arg = match _new_TimeBasket_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _TimeBasket_size_f : c_obj list -> c_obj list = "_wrap_TimeBasket_sizeQuantLib" ;;
let _TimeBasket_size arg = match _TimeBasket_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _TimeBasket_rebin_f : c_obj list -> c_obj list = "_wrap_TimeBasket_rebinQuantLib" ;;
let _TimeBasket_rebin arg = match _TimeBasket_rebin_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TimeBasket_f : c_obj list -> c_obj list = "_wrap_delete_TimeBasketQuantLib" ;;
let _delete_TimeBasket arg = match _delete_TimeBasket_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Swap_f : c_obj list -> c_obj list = "_wrap_new_SwapQuantLib" ;;
let _new_Swap arg = match _new_Swap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Swap_startDate_f : c_obj list -> c_obj list = "_wrap_Swap_startDateQuantLib" ;;
let _Swap_startDate arg = match _Swap_startDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Swap_maturityDate_f : c_obj list -> c_obj list = "_wrap_Swap_maturityDateQuantLib" ;;
let _Swap_maturityDate arg = match _Swap_maturityDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Swap_leg_f : c_obj list -> c_obj list = "_wrap_Swap_legQuantLib" ;;
let _Swap_leg arg = match _Swap_leg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Swap_legNPV_f : c_obj list -> c_obj list = "_wrap_Swap_legNPVQuantLib" ;;
let _Swap_legNPV arg = match _Swap_legNPV_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Swap_f : c_obj list -> c_obj list = "_wrap_delete_SwapQuantLib" ;;
let _delete_Swap arg = match _delete_Swap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_Receiver : c_obj -> Swig.c_obj = "_wrap_VanillaSwap_Receiver" 
external _VanillaSwap_Payer : c_obj -> Swig.c_obj = "_wrap_VanillaSwap_Payer" 
external _new_VanillaSwap_f : c_obj list -> c_obj list = "_wrap_new_VanillaSwapQuantLib" ;;
let _new_VanillaSwap arg = match _new_VanillaSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_fairRate_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_fairRateQuantLib" ;;
let _VanillaSwap_fairRate arg = match _VanillaSwap_fairRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_fairSpread_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_fairSpreadQuantLib" ;;
let _VanillaSwap_fairSpread arg = match _VanillaSwap_fairSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_fixedLegBPS_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_fixedLegBPSQuantLib" ;;
let _VanillaSwap_fixedLegBPS arg = match _VanillaSwap_fixedLegBPS_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_floatingLegBPS_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_floatingLegBPSQuantLib" ;;
let _VanillaSwap_floatingLegBPS arg = match _VanillaSwap_floatingLegBPS_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_fixedLegNPV_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_fixedLegNPVQuantLib" ;;
let _VanillaSwap_fixedLegNPV arg = match _VanillaSwap_fixedLegNPV_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_floatingLegNPV_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_floatingLegNPVQuantLib" ;;
let _VanillaSwap_floatingLegNPV arg = match _VanillaSwap_floatingLegNPV_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_fixedLeg_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_fixedLegQuantLib" ;;
let _VanillaSwap_fixedLeg arg = match _VanillaSwap_fixedLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_floatingLeg_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_floatingLegQuantLib" ;;
let _VanillaSwap_floatingLeg arg = match _VanillaSwap_floatingLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_nominal_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_nominalQuantLib" ;;
let _VanillaSwap_nominal arg = match _VanillaSwap_nominal_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_fixedSchedule_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_fixedScheduleQuantLib" ;;
let _VanillaSwap_fixedSchedule arg = match _VanillaSwap_fixedSchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_floatingSchedule_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_floatingScheduleQuantLib" ;;
let _VanillaSwap_floatingSchedule arg = match _VanillaSwap_floatingSchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_fixedRate_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_fixedRateQuantLib" ;;
let _VanillaSwap_fixedRate arg = match _VanillaSwap_fixedRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_spread_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_spreadQuantLib" ;;
let _VanillaSwap_spread arg = match _VanillaSwap_spread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_floatingDayCount_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_floatingDayCountQuantLib" ;;
let _VanillaSwap_floatingDayCount arg = match _VanillaSwap_floatingDayCount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _VanillaSwap_fixedDayCount_f : c_obj list -> c_obj list = "_wrap_VanillaSwap_fixedDayCountQuantLib" ;;
let _VanillaSwap_fixedDayCount arg = match _VanillaSwap_fixedDayCount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_VanillaSwap_f : c_obj list -> c_obj list = "_wrap_delete_VanillaSwapQuantLib" ;;
let _delete_VanillaSwap arg = match _delete_VanillaSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NonstandardSwap_f : c_obj list -> c_obj list = "_wrap_new_NonstandardSwap__SWIG_0QuantLib" ;;
let _new_NonstandardSwap arg = match _new_NonstandardSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NonstandardSwap_f : c_obj list -> c_obj list = "_wrap_new_NonstandardSwap__SWIG_1QuantLib" ;;
let _new_NonstandardSwap arg = match _new_NonstandardSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NonstandardSwap_f : c_obj list -> c_obj list = "_wrap_new_NonstandardSwap__SWIG_2QuantLib" ;;
let _new_NonstandardSwap arg = match _new_NonstandardSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NonstandardSwap_f : c_obj list -> c_obj list = "_wrap_new_NonstandardSwapQuantLib" ;;
let _new_NonstandardSwap arg = match _new_NonstandardSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonstandardSwap_fixedLeg_f : c_obj list -> c_obj list = "_wrap_NonstandardSwap_fixedLegQuantLib" ;;
let _NonstandardSwap_fixedLeg arg = match _NonstandardSwap_fixedLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonstandardSwap_floatingLeg_f : c_obj list -> c_obj list = "_wrap_NonstandardSwap_floatingLegQuantLib" ;;
let _NonstandardSwap_floatingLeg arg = match _NonstandardSwap_floatingLeg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonstandardSwap_fixedNominals_f : c_obj list -> c_obj list = "_wrap_NonstandardSwap_fixedNominalsQuantLib" ;;
let _NonstandardSwap_fixedNominals arg = match _NonstandardSwap_fixedNominals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonstandardSwap_floatingNominals_f : c_obj list -> c_obj list = "_wrap_NonstandardSwap_floatingNominalsQuantLib" ;;
let _NonstandardSwap_floatingNominals arg = match _NonstandardSwap_floatingNominals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonstandardSwap_fixedSchedule_f : c_obj list -> c_obj list = "_wrap_NonstandardSwap_fixedScheduleQuantLib" ;;
let _NonstandardSwap_fixedSchedule arg = match _NonstandardSwap_fixedSchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonstandardSwap_floatingSchedule_f : c_obj list -> c_obj list = "_wrap_NonstandardSwap_floatingScheduleQuantLib" ;;
let _NonstandardSwap_floatingSchedule arg = match _NonstandardSwap_floatingSchedule_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonstandardSwap_fixedRate_f : c_obj list -> c_obj list = "_wrap_NonstandardSwap_fixedRateQuantLib" ;;
let _NonstandardSwap_fixedRate arg = match _NonstandardSwap_fixedRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonstandardSwap_spreads_f : c_obj list -> c_obj list = "_wrap_NonstandardSwap_spreadsQuantLib" ;;
let _NonstandardSwap_spreads arg = match _NonstandardSwap_spreads_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonstandardSwap_gearings_f : c_obj list -> c_obj list = "_wrap_NonstandardSwap_gearingsQuantLib" ;;
let _NonstandardSwap_gearings arg = match _NonstandardSwap_gearings_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonstandardSwap_floatingDayCount_f : c_obj list -> c_obj list = "_wrap_NonstandardSwap_floatingDayCountQuantLib" ;;
let _NonstandardSwap_floatingDayCount arg = match _NonstandardSwap_floatingDayCount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonstandardSwap_fixedDayCount_f : c_obj list -> c_obj list = "_wrap_NonstandardSwap_fixedDayCountQuantLib" ;;
let _NonstandardSwap_fixedDayCount arg = match _NonstandardSwap_fixedDayCount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NonstandardSwap_f : c_obj list -> c_obj list = "_wrap_delete_NonstandardSwapQuantLib" ;;
let _delete_NonstandardSwap arg = match _delete_NonstandardSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DiscountingSwapEngine_f : c_obj list -> c_obj list = "_wrap_new_DiscountingSwapEngine__SWIG_0QuantLib" ;;
let _new_DiscountingSwapEngine arg = match _new_DiscountingSwapEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DiscountingSwapEngine_f : c_obj list -> c_obj list = "_wrap_new_DiscountingSwapEngine__SWIG_1QuantLib" ;;
let _new_DiscountingSwapEngine arg = match _new_DiscountingSwapEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DiscountingSwapEngine_f : c_obj list -> c_obj list = "_wrap_new_DiscountingSwapEngine__SWIG_2QuantLib" ;;
let _new_DiscountingSwapEngine arg = match _new_DiscountingSwapEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DiscountingSwapEngine_f : c_obj list -> c_obj list = "_wrap_new_DiscountingSwapEngine__SWIG_3QuantLib" ;;
let _new_DiscountingSwapEngine arg = match _new_DiscountingSwapEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DiscountingSwapEngine_f : c_obj list -> c_obj list = "_wrap_new_DiscountingSwapEngine__SWIG_4QuantLib" ;;
let _new_DiscountingSwapEngine arg = match _new_DiscountingSwapEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DiscountingSwapEngine_f : c_obj list -> c_obj list = "_wrap_new_DiscountingSwapEngineQuantLib" ;;
let _new_DiscountingSwapEngine arg = match _new_DiscountingSwapEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DiscountingSwapEngine_f : c_obj list -> c_obj list = "_wrap_delete_DiscountingSwapEngineQuantLib" ;;
let _delete_DiscountingSwapEngine arg = match _delete_DiscountingSwapEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AssetSwap_f : c_obj list -> c_obj list = "_wrap_new_AssetSwap__SWIG_0QuantLib" ;;
let _new_AssetSwap arg = match _new_AssetSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AssetSwap_f : c_obj list -> c_obj list = "_wrap_new_AssetSwap__SWIG_1QuantLib" ;;
let _new_AssetSwap arg = match _new_AssetSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AssetSwap_f : c_obj list -> c_obj list = "_wrap_new_AssetSwap__SWIG_2QuantLib" ;;
let _new_AssetSwap arg = match _new_AssetSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_AssetSwap_f : c_obj list -> c_obj list = "_wrap_new_AssetSwapQuantLib" ;;
let _new_AssetSwap arg = match _new_AssetSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _AssetSwap_fairCleanPrice_f : c_obj list -> c_obj list = "_wrap_AssetSwap_fairCleanPriceQuantLib" ;;
let _AssetSwap_fairCleanPrice arg = match _AssetSwap_fairCleanPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _AssetSwap_fairSpread_f : c_obj list -> c_obj list = "_wrap_AssetSwap_fairSpreadQuantLib" ;;
let _AssetSwap_fairSpread arg = match _AssetSwap_fairSpread_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_AssetSwap_f : c_obj list -> c_obj list = "_wrap_delete_AssetSwapQuantLib" ;;
let _delete_AssetSwap arg = match _delete_AssetSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwap__SWIG_0QuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwap__SWIG_1QuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwap__SWIG_2QuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwap__SWIG_3QuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwap__SWIG_4QuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwap__SWIG_5QuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwap__SWIG_6QuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwap__SWIG_7QuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwap__SWIG_8QuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwap__SWIG_9QuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwap__SWIG_10QuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwap__SWIG_11QuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwapQuantLib" ;;
let _new_FloatFloatSwap arg = match _new_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FloatFloatSwap_f : c_obj list -> c_obj list = "_wrap_delete_FloatFloatSwapQuantLib" ;;
let _delete_FloatFloatSwap arg = match _delete_FloatFloatSwap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "Pillar::Choice_marker" (`Choice)
external _MaturityDate : c_obj -> Swig.c_obj = "_wrap_MaturityDate" 
external _LastRelevantDate : c_obj -> Swig.c_obj = "_wrap_LastRelevantDate" 
external _CustomDate : c_obj -> Swig.c_obj = "_wrap_CustomDate" 
external _new_Pillar_f : c_obj list -> c_obj list = "_wrap_new_PillarQuantLib" ;;
let _new_Pillar arg = match _new_Pillar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Pillar_f : c_obj list -> c_obj list = "_wrap_delete_PillarQuantLib" ;;
let _delete_Pillar arg = match _delete_Pillar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RateHelper___deref___f : c_obj list -> c_obj list = "_wrap_RateHelper___deref__QuantLib" ;;
let _RateHelper___deref__ arg = match _RateHelper___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RateHelper_isNull_f : c_obj list -> c_obj list = "_wrap_RateHelper_isNullQuantLib" ;;
let _RateHelper_isNull arg = match _RateHelper_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RateHelper_f : c_obj list -> c_obj list = "_wrap_new_RateHelperQuantLib" ;;
let _new_RateHelper arg = match _new_RateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RateHelper_f : c_obj list -> c_obj list = "_wrap_delete_RateHelperQuantLib" ;;
let _delete_RateHelper arg = match _delete_RateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RateHelper_quote_f : c_obj list -> c_obj list = "_wrap_RateHelper_quoteQuantLib" ;;
let _RateHelper_quote arg = match _RateHelper_quote_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RateHelper_latestDate_f : c_obj list -> c_obj list = "_wrap_RateHelper_latestDateQuantLib" ;;
let _RateHelper_latestDate arg = match _RateHelper_latestDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DepositRateHelper_f : c_obj list -> c_obj list = "_wrap_new_DepositRateHelper__SWIG_0QuantLib" ;;
let _new_DepositRateHelper arg = match _new_DepositRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DepositRateHelper_f : c_obj list -> c_obj list = "_wrap_new_DepositRateHelper__SWIG_1QuantLib" ;;
let _new_DepositRateHelper arg = match _new_DepositRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DepositRateHelper_f : c_obj list -> c_obj list = "_wrap_new_DepositRateHelper__SWIG_2QuantLib" ;;
let _new_DepositRateHelper arg = match _new_DepositRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DepositRateHelper_f : c_obj list -> c_obj list = "_wrap_new_DepositRateHelperQuantLib" ;;
let _new_DepositRateHelper arg = match _new_DepositRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DepositRateHelper_f : c_obj list -> c_obj list = "_wrap_delete_DepositRateHelperQuantLib" ;;
let _delete_DepositRateHelper arg = match _delete_DepositRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FraRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FraRateHelper__SWIG_0QuantLib" ;;
let _new_FraRateHelper arg = match _new_FraRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FraRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FraRateHelper__SWIG_1QuantLib" ;;
let _new_FraRateHelper arg = match _new_FraRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FraRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FraRateHelper__SWIG_2QuantLib" ;;
let _new_FraRateHelper arg = match _new_FraRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FraRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FraRateHelperQuantLib" ;;
let _new_FraRateHelper arg = match _new_FraRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FraRateHelper_f : c_obj list -> c_obj list = "_wrap_delete_FraRateHelperQuantLib" ;;
let _delete_FraRateHelper arg = match _delete_FraRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_0QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_1QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_2QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_3QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_4QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_5QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_6QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_7QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_8QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_9QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_10QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_11QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_12QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelper__SWIG_13QuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_new_FuturesRateHelperQuantLib" ;;
let _new_FuturesRateHelper arg = match _new_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FuturesRateHelper_f : c_obj list -> c_obj list = "_wrap_delete_FuturesRateHelperQuantLib" ;;
let _delete_FuturesRateHelper arg = match _delete_FuturesRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_0QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_1QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_2QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_3QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_4QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_5QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_6QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_7QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_8QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_9QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_10QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_11QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_12QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_13QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_14QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_15QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_16QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_17QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_18QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_19QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_20QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_21QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_22QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_23QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelper__SWIG_24QuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_new_SwapRateHelperQuantLib" ;;
let _new_SwapRateHelper arg = match _new_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SwapRateHelper_swap_f : c_obj list -> c_obj list = "_wrap_SwapRateHelper_swapQuantLib" ;;
let _SwapRateHelper_swap arg = match _SwapRateHelper_swap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SwapRateHelper_f : c_obj list -> c_obj list = "_wrap_delete_SwapRateHelperQuantLib" ;;
let _delete_SwapRateHelper arg = match _delete_SwapRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BondHelper_f : c_obj list -> c_obj list = "_wrap_new_BondHelper__SWIG_0QuantLib" ;;
let _new_BondHelper arg = match _new_BondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BondHelper_f : c_obj list -> c_obj list = "_wrap_new_BondHelperQuantLib" ;;
let _new_BondHelper arg = match _new_BondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BondHelper_bond_f : c_obj list -> c_obj list = "_wrap_BondHelper_bondQuantLib" ;;
let _BondHelper_bond arg = match _BondHelper_bond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BondHelper_f : c_obj list -> c_obj list = "_wrap_delete_BondHelperQuantLib" ;;
let _delete_BondHelper arg = match _delete_BondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondHelper_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondHelper__SWIG_0QuantLib" ;;
let _new_FixedRateBondHelper arg = match _new_FixedRateBondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondHelper_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondHelper__SWIG_1QuantLib" ;;
let _new_FixedRateBondHelper arg = match _new_FixedRateBondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondHelper_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondHelper__SWIG_2QuantLib" ;;
let _new_FixedRateBondHelper arg = match _new_FixedRateBondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondHelper_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondHelper__SWIG_3QuantLib" ;;
let _new_FixedRateBondHelper arg = match _new_FixedRateBondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondHelper_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondHelper__SWIG_4QuantLib" ;;
let _new_FixedRateBondHelper arg = match _new_FixedRateBondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondHelper_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondHelper__SWIG_5QuantLib" ;;
let _new_FixedRateBondHelper arg = match _new_FixedRateBondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondHelper_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondHelper__SWIG_6QuantLib" ;;
let _new_FixedRateBondHelper arg = match _new_FixedRateBondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondHelper_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondHelper__SWIG_7QuantLib" ;;
let _new_FixedRateBondHelper arg = match _new_FixedRateBondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondHelper_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondHelper__SWIG_8QuantLib" ;;
let _new_FixedRateBondHelper arg = match _new_FixedRateBondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondHelper_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondHelperQuantLib" ;;
let _new_FixedRateBondHelper arg = match _new_FixedRateBondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FixedRateBondHelper_bond_f : c_obj list -> c_obj list = "_wrap_FixedRateBondHelper_bondQuantLib" ;;
let _FixedRateBondHelper_bond arg = match _FixedRateBondHelper_bond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FixedRateBondHelper_f : c_obj list -> c_obj list = "_wrap_delete_FixedRateBondHelperQuantLib" ;;
let _delete_FixedRateBondHelper arg = match _delete_FixedRateBondHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OISRateHelper_f : c_obj list -> c_obj list = "_wrap_new_OISRateHelper__SWIG_0QuantLib" ;;
let _new_OISRateHelper arg = match _new_OISRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OISRateHelper_f : c_obj list -> c_obj list = "_wrap_new_OISRateHelperQuantLib" ;;
let _new_OISRateHelper arg = match _new_OISRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_OISRateHelper_f : c_obj list -> c_obj list = "_wrap_delete_OISRateHelperQuantLib" ;;
let _delete_OISRateHelper arg = match _delete_OISRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DatedOISRateHelper_f : c_obj list -> c_obj list = "_wrap_new_DatedOISRateHelper__SWIG_0QuantLib" ;;
let _new_DatedOISRateHelper arg = match _new_DatedOISRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DatedOISRateHelper_f : c_obj list -> c_obj list = "_wrap_new_DatedOISRateHelperQuantLib" ;;
let _new_DatedOISRateHelper arg = match _new_DatedOISRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DatedOISRateHelper_f : c_obj list -> c_obj list = "_wrap_delete_DatedOISRateHelperQuantLib" ;;
let _delete_DatedOISRateHelper arg = match _delete_DatedOISRateHelper_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RateHelperVector_f : c_obj list -> c_obj list = "_wrap_new_RateHelperVector__SWIG_0QuantLib" ;;
let _new_RateHelperVector arg = match _new_RateHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RateHelperVector_f : c_obj list -> c_obj list = "_wrap_new_RateHelperVector__SWIG_1QuantLib" ;;
let _new_RateHelperVector arg = match _new_RateHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RateHelperVector_f : c_obj list -> c_obj list = "_wrap_new_RateHelperVector__SWIG_2QuantLib" ;;
let _new_RateHelperVector arg = match _new_RateHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RateHelperVector_f : c_obj list -> c_obj list = "_wrap_new_RateHelperVectorQuantLib" ;;
let _new_RateHelperVector arg = match _new_RateHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RateHelperVector_size_f : c_obj list -> c_obj list = "_wrap_RateHelperVector_sizeQuantLib" ;;
let _RateHelperVector_size arg = match _RateHelperVector_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RateHelperVector_empty_f : c_obj list -> c_obj list = "_wrap_RateHelperVector_emptyQuantLib" ;;
let _RateHelperVector_empty arg = match _RateHelperVector_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RateHelperVector_clear_f : c_obj list -> c_obj list = "_wrap_RateHelperVector_clearQuantLib" ;;
let _RateHelperVector_clear arg = match _RateHelperVector_clear_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RateHelperVector_push_back_f : c_obj list -> c_obj list = "_wrap_RateHelperVector_push_backQuantLib" ;;
let _RateHelperVector_push_back arg = match _RateHelperVector_push_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RateHelperVector_operator_xx_xx_lbrace_xx_rbrace_f : c_obj list -> c_obj list = "_wrap_RateHelperVector_operator_bB___QuantLib" ;;
let _RateHelperVector_operator_xx_xx_lbrace_xx_rbrace arg = match _RateHelperVector_operator_xx_xx_lbrace_xx_rbrace_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RateHelperVector_operator_xx_xx_equals_f : c_obj list -> c_obj list = "_wrap_RateHelperVector_operator_e___QuantLib" ;;
let _RateHelperVector_operator_xx_xx_equals arg = match _RateHelperVector_operator_xx_xx_equals_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RateHelperVector_set_f : c_obj list -> c_obj list = "_wrap_RateHelperVector_setQuantLib" ;;
let _RateHelperVector_set arg = match _RateHelperVector_set_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RateHelperVector_to_array_f : c_obj list -> c_obj list = "_wrap_RateHelperVector_to_arrayQuantLib" ;;
let _RateHelperVector_to_array arg = match _RateHelperVector_to_array_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RateHelperVector_f : c_obj list -> c_obj list = "_wrap_delete_RateHelperVectorQuantLib" ;;
let _delete_RateHelperVector arg = match _delete_RateHelperVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FittingMethod_f : c_obj list -> c_obj list = "_wrap_delete_FittingMethodQuantLib" ;;
let _delete_FittingMethod arg = match _delete_FittingMethod_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FittingMethod_solution_f : c_obj list -> c_obj list = "_wrap_FittingMethod_solutionQuantLib" ;;
let _FittingMethod_solution arg = match _FittingMethod_solution_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FittedBondDiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_FittedBondDiscountCurve__SWIG_0QuantLib" ;;
let _new_FittedBondDiscountCurve arg = match _new_FittedBondDiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FittedBondDiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_FittedBondDiscountCurve__SWIG_1QuantLib" ;;
let _new_FittedBondDiscountCurve arg = match _new_FittedBondDiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FittedBondDiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_FittedBondDiscountCurve__SWIG_2QuantLib" ;;
let _new_FittedBondDiscountCurve arg = match _new_FittedBondDiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FittedBondDiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_FittedBondDiscountCurve__SWIG_3QuantLib" ;;
let _new_FittedBondDiscountCurve arg = match _new_FittedBondDiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FittedBondDiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_FittedBondDiscountCurve__SWIG_4QuantLib" ;;
let _new_FittedBondDiscountCurve arg = match _new_FittedBondDiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FittedBondDiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_FittedBondDiscountCurve__SWIG_5QuantLib" ;;
let _new_FittedBondDiscountCurve arg = match _new_FittedBondDiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FittedBondDiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_FittedBondDiscountCurve__SWIG_6QuantLib" ;;
let _new_FittedBondDiscountCurve arg = match _new_FittedBondDiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FittedBondDiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_FittedBondDiscountCurve__SWIG_7QuantLib" ;;
let _new_FittedBondDiscountCurve arg = match _new_FittedBondDiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FittedBondDiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_FittedBondDiscountCurve__SWIG_8QuantLib" ;;
let _new_FittedBondDiscountCurve arg = match _new_FittedBondDiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FittedBondDiscountCurve_f : c_obj list -> c_obj list = "_wrap_new_FittedBondDiscountCurveQuantLib" ;;
let _new_FittedBondDiscountCurve arg = match _new_FittedBondDiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FittedBondDiscountCurve_fitResults_f : c_obj list -> c_obj list = "_wrap_FittedBondDiscountCurve_fitResultsQuantLib" ;;
let _FittedBondDiscountCurve_fitResults arg = match _FittedBondDiscountCurve_fitResults_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FittedBondDiscountCurve_f : c_obj list -> c_obj list = "_wrap_delete_FittedBondDiscountCurveQuantLib" ;;
let _delete_FittedBondDiscountCurve arg = match _delete_FittedBondDiscountCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ExponentialSplinesFitting_f : c_obj list -> c_obj list = "_wrap_new_ExponentialSplinesFitting__SWIG_0QuantLib" ;;
let _new_ExponentialSplinesFitting arg = match _new_ExponentialSplinesFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ExponentialSplinesFitting_f : c_obj list -> c_obj list = "_wrap_new_ExponentialSplinesFittingQuantLib" ;;
let _new_ExponentialSplinesFitting arg = match _new_ExponentialSplinesFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ExponentialSplinesFitting_f : c_obj list -> c_obj list = "_wrap_delete_ExponentialSplinesFittingQuantLib" ;;
let _delete_ExponentialSplinesFitting arg = match _delete_ExponentialSplinesFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NelsonSiegelFitting_f : c_obj list -> c_obj list = "_wrap_new_NelsonSiegelFittingQuantLib" ;;
let _new_NelsonSiegelFitting arg = match _new_NelsonSiegelFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NelsonSiegelFitting_f : c_obj list -> c_obj list = "_wrap_delete_NelsonSiegelFittingQuantLib" ;;
let _delete_NelsonSiegelFitting arg = match _delete_NelsonSiegelFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SvenssonFitting_f : c_obj list -> c_obj list = "_wrap_new_SvenssonFittingQuantLib" ;;
let _new_SvenssonFitting arg = match _new_SvenssonFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SvenssonFitting_f : c_obj list -> c_obj list = "_wrap_delete_SvenssonFittingQuantLib" ;;
let _delete_SvenssonFitting arg = match _delete_SvenssonFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CubicBSplinesFitting_f : c_obj list -> c_obj list = "_wrap_new_CubicBSplinesFitting__SWIG_0QuantLib" ;;
let _new_CubicBSplinesFitting arg = match _new_CubicBSplinesFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CubicBSplinesFitting_f : c_obj list -> c_obj list = "_wrap_new_CubicBSplinesFittingQuantLib" ;;
let _new_CubicBSplinesFitting arg = match _new_CubicBSplinesFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CubicBSplinesFitting_f : c_obj list -> c_obj list = "_wrap_delete_CubicBSplinesFittingQuantLib" ;;
let _delete_CubicBSplinesFitting arg = match _delete_CubicBSplinesFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SimplePolynomialFitting_f : c_obj list -> c_obj list = "_wrap_new_SimplePolynomialFitting__SWIG_0QuantLib" ;;
let _new_SimplePolynomialFitting arg = match _new_SimplePolynomialFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SimplePolynomialFitting_f : c_obj list -> c_obj list = "_wrap_new_SimplePolynomialFittingQuantLib" ;;
let _new_SimplePolynomialFitting arg = match _new_SimplePolynomialFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SimplePolynomialFitting_f : c_obj list -> c_obj list = "_wrap_delete_SimplePolynomialFittingQuantLib" ;;
let _delete_SimplePolynomialFitting arg = match _delete_SimplePolynomialFitting_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardCurve_f : c_obj list -> c_obj list = "_wrap_new_ForwardCurve__SWIG_0QuantLib" ;;
let _new_ForwardCurve arg = match _new_ForwardCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardCurve_f : c_obj list -> c_obj list = "_wrap_new_ForwardCurve__SWIG_1QuantLib" ;;
let _new_ForwardCurve arg = match _new_ForwardCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardCurve_f : c_obj list -> c_obj list = "_wrap_new_ForwardCurveQuantLib" ;;
let _new_ForwardCurve arg = match _new_ForwardCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardCurve_dates_f : c_obj list -> c_obj list = "_wrap_ForwardCurve_datesQuantLib" ;;
let _ForwardCurve_dates arg = match _ForwardCurve_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardCurve_forwards_f : c_obj list -> c_obj list = "_wrap_ForwardCurve_forwardsQuantLib" ;;
let _ForwardCurve_forwards arg = match _ForwardCurve_forwards_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardCurve_nodes_f : c_obj list -> c_obj list = "_wrap_ForwardCurve_nodesQuantLib" ;;
let _ForwardCurve_nodes arg = match _ForwardCurve_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ForwardCurve_f : c_obj list -> c_obj list = "_wrap_delete_ForwardCurveQuantLib" ;;
let _delete_ForwardCurve arg = match _delete_ForwardCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "Position::Type_marker" (`Type)
external _Long : c_obj -> Swig.c_obj = "_wrap_Long" 
external _Short : c_obj -> Swig.c_obj = "_wrap_Short" 
external _new_Position_f : c_obj list -> c_obj list = "_wrap_new_PositionQuantLib" ;;
let _new_Position arg = match _new_Position_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Position_f : c_obj list -> c_obj list = "_wrap_delete_PositionQuantLib" ;;
let _delete_Position arg = match _delete_Position_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardRateAgreement_f : c_obj list -> c_obj list = "_wrap_new_ForwardRateAgreement__SWIG_0QuantLib" ;;
let _new_ForwardRateAgreement arg = match _new_ForwardRateAgreement_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardRateAgreement_f : c_obj list -> c_obj list = "_wrap_new_ForwardRateAgreementQuantLib" ;;
let _new_ForwardRateAgreement arg = match _new_ForwardRateAgreement_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardRateAgreement_spotIncome_f : c_obj list -> c_obj list = "_wrap_ForwardRateAgreement_spotIncomeQuantLib" ;;
let _ForwardRateAgreement_spotIncome arg = match _ForwardRateAgreement_spotIncome_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardRateAgreement_spotValue_f : c_obj list -> c_obj list = "_wrap_ForwardRateAgreement_spotValueQuantLib" ;;
let _ForwardRateAgreement_spotValue arg = match _ForwardRateAgreement_spotValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardRateAgreement_forwardRate_f : c_obj list -> c_obj list = "_wrap_ForwardRateAgreement_forwardRateQuantLib" ;;
let _ForwardRateAgreement_forwardRate arg = match _ForwardRateAgreement_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ForwardRateAgreement_f : c_obj list -> c_obj list = "_wrap_delete_ForwardRateAgreementQuantLib" ;;
let _delete_ForwardRateAgreement arg = match _delete_ForwardRateAgreement_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel___deref___f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel___deref__QuantLib" ;;
let _Gaussian1dModel___deref__ arg = match _Gaussian1dModel___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_isNull_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_isNullQuantLib" ;;
let _Gaussian1dModel_isNull arg = match _Gaussian1dModel_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dModel_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dModelQuantLib" ;;
let _new_Gaussian1dModel arg = match _new_Gaussian1dModel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Gaussian1dModel_f : c_obj list -> c_obj list = "_wrap_delete_Gaussian1dModelQuantLib" ;;
let _delete_Gaussian1dModel arg = match _delete_Gaussian1dModel_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_stateProcess_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_stateProcessQuantLib" ;;
let _Gaussian1dModel_stateProcess arg = match _Gaussian1dModel_stateProcess_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_numeraire_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_numeraire__SWIG_0QuantLib" ;;
let _Gaussian1dModel_numeraire arg = match _Gaussian1dModel_numeraire_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_numeraire_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_numeraire__SWIG_1QuantLib" ;;
let _Gaussian1dModel_numeraire arg = match _Gaussian1dModel_numeraire_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_numeraire_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_numeraire__SWIG_2QuantLib" ;;
let _Gaussian1dModel_numeraire arg = match _Gaussian1dModel_numeraire_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_numeraire_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_numeraire__SWIG_3QuantLib" ;;
let _Gaussian1dModel_numeraire arg = match _Gaussian1dModel_numeraire_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_numeraire_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_numeraire__SWIG_4QuantLib" ;;
let _Gaussian1dModel_numeraire arg = match _Gaussian1dModel_numeraire_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_numeraire_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_numeraireQuantLib" ;;
let _Gaussian1dModel_numeraire arg = match _Gaussian1dModel_numeraire_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobond_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobond__SWIG_0QuantLib" ;;
let _Gaussian1dModel_zerobond arg = match _Gaussian1dModel_zerobond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobond_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobond__SWIG_1QuantLib" ;;
let _Gaussian1dModel_zerobond arg = match _Gaussian1dModel_zerobond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobond_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobond__SWIG_2QuantLib" ;;
let _Gaussian1dModel_zerobond arg = match _Gaussian1dModel_zerobond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobond_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobond__SWIG_3QuantLib" ;;
let _Gaussian1dModel_zerobond arg = match _Gaussian1dModel_zerobond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobond_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobond__SWIG_4QuantLib" ;;
let _Gaussian1dModel_zerobond arg = match _Gaussian1dModel_zerobond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobond_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobond__SWIG_5QuantLib" ;;
let _Gaussian1dModel_zerobond arg = match _Gaussian1dModel_zerobond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobond_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobond__SWIG_6QuantLib" ;;
let _Gaussian1dModel_zerobond arg = match _Gaussian1dModel_zerobond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobond_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobondQuantLib" ;;
let _Gaussian1dModel_zerobond arg = match _Gaussian1dModel_zerobond_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobondOption_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobondOption__SWIG_0QuantLib" ;;
let _Gaussian1dModel_zerobondOption arg = match _Gaussian1dModel_zerobondOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobondOption_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobondOption__SWIG_1QuantLib" ;;
let _Gaussian1dModel_zerobondOption arg = match _Gaussian1dModel_zerobondOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobondOption_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobondOption__SWIG_2QuantLib" ;;
let _Gaussian1dModel_zerobondOption arg = match _Gaussian1dModel_zerobondOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobondOption_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobondOption__SWIG_3QuantLib" ;;
let _Gaussian1dModel_zerobondOption arg = match _Gaussian1dModel_zerobondOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobondOption_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobondOption__SWIG_4QuantLib" ;;
let _Gaussian1dModel_zerobondOption arg = match _Gaussian1dModel_zerobondOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobondOption_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobondOption__SWIG_5QuantLib" ;;
let _Gaussian1dModel_zerobondOption arg = match _Gaussian1dModel_zerobondOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobondOption_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobondOption__SWIG_6QuantLib" ;;
let _Gaussian1dModel_zerobondOption arg = match _Gaussian1dModel_zerobondOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_zerobondOption_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_zerobondOptionQuantLib" ;;
let _Gaussian1dModel_zerobondOption arg = match _Gaussian1dModel_zerobondOption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_forwardRate_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_forwardRate__SWIG_0QuantLib" ;;
let _Gaussian1dModel_forwardRate arg = match _Gaussian1dModel_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_forwardRate_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_forwardRate__SWIG_1QuantLib" ;;
let _Gaussian1dModel_forwardRate arg = match _Gaussian1dModel_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_forwardRate_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_forwardRate__SWIG_2QuantLib" ;;
let _Gaussian1dModel_forwardRate arg = match _Gaussian1dModel_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_forwardRate_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_forwardRateQuantLib" ;;
let _Gaussian1dModel_forwardRate arg = match _Gaussian1dModel_forwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_swapRate_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_swapRate__SWIG_0QuantLib" ;;
let _Gaussian1dModel_swapRate arg = match _Gaussian1dModel_swapRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_swapRate_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_swapRate__SWIG_1QuantLib" ;;
let _Gaussian1dModel_swapRate arg = match _Gaussian1dModel_swapRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_swapRate_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_swapRate__SWIG_2QuantLib" ;;
let _Gaussian1dModel_swapRate arg = match _Gaussian1dModel_swapRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_swapRate_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_swapRateQuantLib" ;;
let _Gaussian1dModel_swapRate arg = match _Gaussian1dModel_swapRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_swapAnnuity_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_swapAnnuity__SWIG_0QuantLib" ;;
let _Gaussian1dModel_swapAnnuity arg = match _Gaussian1dModel_swapAnnuity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_swapAnnuity_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_swapAnnuity__SWIG_1QuantLib" ;;
let _Gaussian1dModel_swapAnnuity arg = match _Gaussian1dModel_swapAnnuity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_swapAnnuity_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_swapAnnuity__SWIG_2QuantLib" ;;
let _Gaussian1dModel_swapAnnuity arg = match _Gaussian1dModel_swapAnnuity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dModel_swapAnnuity_f : c_obj list -> c_obj list = "_wrap_Gaussian1dModel_swapAnnuityQuantLib" ;;
let _Gaussian1dModel_swapAnnuity arg = match _Gaussian1dModel_swapAnnuity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gsr_f : c_obj list -> c_obj list = "_wrap_new_Gsr__SWIG_0QuantLib" ;;
let _new_Gsr arg = match _new_Gsr_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gsr_f : c_obj list -> c_obj list = "_wrap_new_GsrQuantLib" ;;
let _new_Gsr arg = match _new_Gsr_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_calibrateVolatilitiesIterative_f : c_obj list -> c_obj list = "_wrap_Gsr_calibrateVolatilitiesIterative__SWIG_0QuantLib" ;;
let _Gsr_calibrateVolatilitiesIterative arg = match _Gsr_calibrateVolatilitiesIterative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_calibrateVolatilitiesIterative_f : c_obj list -> c_obj list = "_wrap_Gsr_calibrateVolatilitiesIterative__SWIG_1QuantLib" ;;
let _Gsr_calibrateVolatilitiesIterative arg = match _Gsr_calibrateVolatilitiesIterative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_calibrateVolatilitiesIterative_f : c_obj list -> c_obj list = "_wrap_Gsr_calibrateVolatilitiesIterativeQuantLib" ;;
let _Gsr_calibrateVolatilitiesIterative arg = match _Gsr_calibrateVolatilitiesIterative_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_calibrate_f : c_obj list -> c_obj list = "_wrap_Gsr_calibrate__SWIG_0QuantLib" ;;
let _Gsr_calibrate arg = match _Gsr_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_calibrate_f : c_obj list -> c_obj list = "_wrap_Gsr_calibrate__SWIG_1QuantLib" ;;
let _Gsr_calibrate arg = match _Gsr_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_calibrate_f : c_obj list -> c_obj list = "_wrap_Gsr_calibrate__SWIG_2QuantLib" ;;
let _Gsr_calibrate arg = match _Gsr_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_calibrate_f : c_obj list -> c_obj list = "_wrap_Gsr_calibrateQuantLib" ;;
let _Gsr_calibrate arg = match _Gsr_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_params_f : c_obj list -> c_obj list = "_wrap_Gsr_paramsQuantLib" ;;
let _Gsr_params arg = match _Gsr_params_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_value_f : c_obj list -> c_obj list = "_wrap_Gsr_valueQuantLib" ;;
let _Gsr_value arg = match _Gsr_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_endCriteria_f : c_obj list -> c_obj list = "_wrap_Gsr_endCriteriaQuantLib" ;;
let _Gsr_endCriteria arg = match _Gsr_endCriteria_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_setParams_f : c_obj list -> c_obj list = "_wrap_Gsr_setParamsQuantLib" ;;
let _Gsr_setParams arg = match _Gsr_setParams_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_functionEvaluation_f : c_obj list -> c_obj list = "_wrap_Gsr_functionEvaluationQuantLib" ;;
let _Gsr_functionEvaluation arg = match _Gsr_functionEvaluation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_reversion_f : c_obj list -> c_obj list = "_wrap_Gsr_reversionQuantLib" ;;
let _Gsr_reversion arg = match _Gsr_reversion_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gsr_volatility_f : c_obj list -> c_obj list = "_wrap_Gsr_volatilityQuantLib" ;;
let _Gsr_volatility arg = match _Gsr_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Gsr_f : c_obj list -> c_obj list = "_wrap_delete_GsrQuantLib" ;;
let _delete_Gsr arg = match _delete_Gsr_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "MarkovFunctional::ModelSettings::Adjustments_marker" (`Adjustments)
external _AdjustNone : c_obj -> Swig.c_obj = "_wrap_AdjustNone" 
external _AdjustDigitals : c_obj -> Swig.c_obj = "_wrap_AdjustDigitals" 
external _AdjustYts : c_obj -> Swig.c_obj = "_wrap_AdjustYts" 
external _ExtrapolatePayoffFlat : c_obj -> Swig.c_obj = "_wrap_ExtrapolatePayoffFlat" 
external _NoPayoffExtrapolation : c_obj -> Swig.c_obj = "_wrap_NoPayoffExtrapolation" 
external _KahaleSmile : c_obj -> Swig.c_obj = "_wrap_KahaleSmile" 
external _SmileExponentialExtrapolation : c_obj -> Swig.c_obj = "_wrap_SmileExponentialExtrapolation" 
external _KahaleInterpolation : c_obj -> Swig.c_obj = "_wrap_KahaleInterpolation" 
external _SmileDeleteArbitragePoints : c_obj -> Swig.c_obj = "_wrap_SmileDeleteArbitragePoints" 
external _SabrSmile : c_obj -> Swig.c_obj = "_wrap_SabrSmile" 
external _new_MarkovFunctionalSettings_f : c_obj list -> c_obj list = "_wrap_new_MarkovFunctionalSettingsQuantLib" ;;
let _new_MarkovFunctionalSettings arg = match _new_MarkovFunctionalSettings_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MarkovFunctionalSettings_f : c_obj list -> c_obj list = "_wrap_delete_MarkovFunctionalSettingsQuantLib" ;;
let _delete_MarkovFunctionalSettings arg = match _delete_MarkovFunctionalSettings_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MarkovFunctional_AdjustNone : c_obj -> Swig.c_obj = "_wrap_MarkovFunctional_AdjustNone" 
external _MarkovFunctional_AdjustDigitals : c_obj -> Swig.c_obj = "_wrap_MarkovFunctional_AdjustDigitals" 
external _MarkovFunctional_AdjustYts : c_obj -> Swig.c_obj = "_wrap_MarkovFunctional_AdjustYts" 
external _MarkovFunctional_ExtrapolatePayoffFlat : c_obj -> Swig.c_obj = "_wrap_MarkovFunctional_ExtrapolatePayoffFlat" 
external _MarkovFunctional_NoPayoffExtrapolation : c_obj -> Swig.c_obj = "_wrap_MarkovFunctional_NoPayoffExtrapolation" 
external _MarkovFunctional_KahaleSmile : c_obj -> Swig.c_obj = "_wrap_MarkovFunctional_KahaleSmile" 
external _MarkovFunctional_SmileExponentialExtrapolation : c_obj -> Swig.c_obj = "_wrap_MarkovFunctional_SmileExponentialExtrapolation" 
external _MarkovFunctional_KahaleInterpolation : c_obj -> Swig.c_obj = "_wrap_MarkovFunctional_KahaleInterpolation" 
external _MarkovFunctional_SmileDeleteArbitragePoints : c_obj -> Swig.c_obj = "_wrap_MarkovFunctional_SmileDeleteArbitragePoints" 
external _MarkovFunctional_SabrSmile : c_obj -> Swig.c_obj = "_wrap_MarkovFunctional_SabrSmile" 
external _new_MarkovFunctional_f : c_obj list -> c_obj list = "_wrap_new_MarkovFunctional__SWIG_0QuantLib" ;;
let _new_MarkovFunctional arg = match _new_MarkovFunctional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MarkovFunctional_f : c_obj list -> c_obj list = "_wrap_new_MarkovFunctional__SWIG_1QuantLib" ;;
let _new_MarkovFunctional arg = match _new_MarkovFunctional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MarkovFunctional_f : c_obj list -> c_obj list = "_wrap_new_MarkovFunctional__SWIG_2QuantLib" ;;
let _new_MarkovFunctional arg = match _new_MarkovFunctional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MarkovFunctional_f : c_obj list -> c_obj list = "_wrap_new_MarkovFunctional__SWIG_3QuantLib" ;;
let _new_MarkovFunctional arg = match _new_MarkovFunctional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MarkovFunctional_f : c_obj list -> c_obj list = "_wrap_new_MarkovFunctional__SWIG_4QuantLib" ;;
let _new_MarkovFunctional arg = match _new_MarkovFunctional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MarkovFunctional_f : c_obj list -> c_obj list = "_wrap_new_MarkovFunctional__SWIG_5QuantLib" ;;
let _new_MarkovFunctional arg = match _new_MarkovFunctional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MarkovFunctional_f : c_obj list -> c_obj list = "_wrap_new_MarkovFunctional__SWIG_6QuantLib" ;;
let _new_MarkovFunctional arg = match _new_MarkovFunctional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MarkovFunctional_f : c_obj list -> c_obj list = "_wrap_new_MarkovFunctional__SWIG_7QuantLib" ;;
let _new_MarkovFunctional arg = match _new_MarkovFunctional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MarkovFunctional_f : c_obj list -> c_obj list = "_wrap_new_MarkovFunctional__SWIG_8QuantLib" ;;
let _new_MarkovFunctional arg = match _new_MarkovFunctional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MarkovFunctional_f : c_obj list -> c_obj list = "_wrap_new_MarkovFunctionalQuantLib" ;;
let _new_MarkovFunctional arg = match _new_MarkovFunctional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MarkovFunctional_calibrate_f : c_obj list -> c_obj list = "_wrap_MarkovFunctional_calibrate__SWIG_0QuantLib" ;;
let _MarkovFunctional_calibrate arg = match _MarkovFunctional_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MarkovFunctional_calibrate_f : c_obj list -> c_obj list = "_wrap_MarkovFunctional_calibrate__SWIG_1QuantLib" ;;
let _MarkovFunctional_calibrate arg = match _MarkovFunctional_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MarkovFunctional_calibrate_f : c_obj list -> c_obj list = "_wrap_MarkovFunctional_calibrate__SWIG_2QuantLib" ;;
let _MarkovFunctional_calibrate arg = match _MarkovFunctional_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MarkovFunctional_calibrate_f : c_obj list -> c_obj list = "_wrap_MarkovFunctional_calibrateQuantLib" ;;
let _MarkovFunctional_calibrate arg = match _MarkovFunctional_calibrate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MarkovFunctional_volatility_f : c_obj list -> c_obj list = "_wrap_MarkovFunctional_volatilityQuantLib" ;;
let _MarkovFunctional_volatility arg = match _MarkovFunctional_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MarkovFunctional_f : c_obj list -> c_obj list = "_wrap_delete_MarkovFunctionalQuantLib" ;;
let _delete_MarkovFunctional arg = match _delete_MarkovFunctional_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dSwaptionEngine__SWIG_0QuantLib" ;;
let _new_Gaussian1dSwaptionEngine arg = match _new_Gaussian1dSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dSwaptionEngine__SWIG_1QuantLib" ;;
let _new_Gaussian1dSwaptionEngine arg = match _new_Gaussian1dSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dSwaptionEngine__SWIG_2QuantLib" ;;
let _new_Gaussian1dSwaptionEngine arg = match _new_Gaussian1dSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dSwaptionEngine__SWIG_3QuantLib" ;;
let _new_Gaussian1dSwaptionEngine arg = match _new_Gaussian1dSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dSwaptionEngine__SWIG_4QuantLib" ;;
let _new_Gaussian1dSwaptionEngine arg = match _new_Gaussian1dSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dSwaptionEngineQuantLib" ;;
let _new_Gaussian1dSwaptionEngine arg = match _new_Gaussian1dSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Gaussian1dSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_delete_Gaussian1dSwaptionEngineQuantLib" ;;
let _delete_Gaussian1dSwaptionEngine arg = match _delete_Gaussian1dSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dJamshidianSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dJamshidianSwaptionEngineQuantLib" ;;
let _new_Gaussian1dJamshidianSwaptionEngine arg = match _new_Gaussian1dJamshidianSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Gaussian1dJamshidianSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_delete_Gaussian1dJamshidianSwaptionEngineQuantLib" ;;
let _delete_Gaussian1dJamshidianSwaptionEngine arg = match _delete_Gaussian1dJamshidianSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dNonstandardSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dNonstandardSwaptionEngine__SWIG_0QuantLib" ;;
let _new_Gaussian1dNonstandardSwaptionEngine arg = match _new_Gaussian1dNonstandardSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dNonstandardSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dNonstandardSwaptionEngine__SWIG_1QuantLib" ;;
let _new_Gaussian1dNonstandardSwaptionEngine arg = match _new_Gaussian1dNonstandardSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dNonstandardSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dNonstandardSwaptionEngine__SWIG_2QuantLib" ;;
let _new_Gaussian1dNonstandardSwaptionEngine arg = match _new_Gaussian1dNonstandardSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dNonstandardSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dNonstandardSwaptionEngine__SWIG_3QuantLib" ;;
let _new_Gaussian1dNonstandardSwaptionEngine arg = match _new_Gaussian1dNonstandardSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dNonstandardSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dNonstandardSwaptionEngine__SWIG_4QuantLib" ;;
let _new_Gaussian1dNonstandardSwaptionEngine arg = match _new_Gaussian1dNonstandardSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dNonstandardSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dNonstandardSwaptionEngine__SWIG_5QuantLib" ;;
let _new_Gaussian1dNonstandardSwaptionEngine arg = match _new_Gaussian1dNonstandardSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dNonstandardSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dNonstandardSwaptionEngineQuantLib" ;;
let _new_Gaussian1dNonstandardSwaptionEngine arg = match _new_Gaussian1dNonstandardSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Gaussian1dNonstandardSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_delete_Gaussian1dNonstandardSwaptionEngineQuantLib" ;;
let _delete_Gaussian1dNonstandardSwaptionEngine arg = match _delete_Gaussian1dNonstandardSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Gaussian1dFloatFloatSwaptionEngine_None : c_obj -> Swig.c_obj = "_wrap_Gaussian1dFloatFloatSwaptionEngine_None" 
external _Gaussian1dFloatFloatSwaptionEngine_Naive : c_obj -> Swig.c_obj = "_wrap_Gaussian1dFloatFloatSwaptionEngine_Naive" 
external _Gaussian1dFloatFloatSwaptionEngine_Digital : c_obj -> Swig.c_obj = "_wrap_Gaussian1dFloatFloatSwaptionEngine_Digital" 
external _new_Gaussian1dFloatFloatSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dFloatFloatSwaptionEngine__SWIG_0QuantLib" ;;
let _new_Gaussian1dFloatFloatSwaptionEngine arg = match _new_Gaussian1dFloatFloatSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dFloatFloatSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dFloatFloatSwaptionEngine__SWIG_1QuantLib" ;;
let _new_Gaussian1dFloatFloatSwaptionEngine arg = match _new_Gaussian1dFloatFloatSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dFloatFloatSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dFloatFloatSwaptionEngine__SWIG_2QuantLib" ;;
let _new_Gaussian1dFloatFloatSwaptionEngine arg = match _new_Gaussian1dFloatFloatSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dFloatFloatSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dFloatFloatSwaptionEngine__SWIG_3QuantLib" ;;
let _new_Gaussian1dFloatFloatSwaptionEngine arg = match _new_Gaussian1dFloatFloatSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dFloatFloatSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dFloatFloatSwaptionEngine__SWIG_4QuantLib" ;;
let _new_Gaussian1dFloatFloatSwaptionEngine arg = match _new_Gaussian1dFloatFloatSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dFloatFloatSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dFloatFloatSwaptionEngine__SWIG_5QuantLib" ;;
let _new_Gaussian1dFloatFloatSwaptionEngine arg = match _new_Gaussian1dFloatFloatSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dFloatFloatSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dFloatFloatSwaptionEngine__SWIG_6QuantLib" ;;
let _new_Gaussian1dFloatFloatSwaptionEngine arg = match _new_Gaussian1dFloatFloatSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dFloatFloatSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dFloatFloatSwaptionEngine__SWIG_7QuantLib" ;;
let _new_Gaussian1dFloatFloatSwaptionEngine arg = match _new_Gaussian1dFloatFloatSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Gaussian1dFloatFloatSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_Gaussian1dFloatFloatSwaptionEngineQuantLib" ;;
let _new_Gaussian1dFloatFloatSwaptionEngine arg = match _new_Gaussian1dFloatFloatSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Gaussian1dFloatFloatSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_delete_Gaussian1dFloatFloatSwaptionEngineQuantLib" ;;
let _delete_Gaussian1dFloatFloatSwaptionEngine arg = match _delete_Gaussian1dFloatFloatSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SegmentIntegral_f : c_obj list -> c_obj list = "_wrap_new_SegmentIntegralQuantLib" ;;
let _new_SegmentIntegral arg = match _new_SegmentIntegral_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SegmentIntegral_f : c_obj list -> c_obj list = "_wrap_delete_SegmentIntegralQuantLib" ;;
let _delete_SegmentIntegral arg = match _delete_SegmentIntegral_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TrapezoidIntegralDefault_f : c_obj list -> c_obj list = "_wrap_new_TrapezoidIntegralDefaultQuantLib" ;;
let _new_TrapezoidIntegralDefault arg = match _new_TrapezoidIntegralDefault_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TrapezoidIntegralDefault_f : c_obj list -> c_obj list = "_wrap_delete_TrapezoidIntegralDefaultQuantLib" ;;
let _delete_TrapezoidIntegralDefault arg = match _delete_TrapezoidIntegralDefault_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TrapezoidIntegralMidPoint_f : c_obj list -> c_obj list = "_wrap_new_TrapezoidIntegralMidPointQuantLib" ;;
let _new_TrapezoidIntegralMidPoint arg = match _new_TrapezoidIntegralMidPoint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TrapezoidIntegralMidPoint_f : c_obj list -> c_obj list = "_wrap_delete_TrapezoidIntegralMidPointQuantLib" ;;
let _delete_TrapezoidIntegralMidPoint arg = match _delete_TrapezoidIntegralMidPoint_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SimpsonIntegral_f : c_obj list -> c_obj list = "_wrap_new_SimpsonIntegralQuantLib" ;;
let _new_SimpsonIntegral arg = match _new_SimpsonIntegral_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SimpsonIntegral_f : c_obj list -> c_obj list = "_wrap_delete_SimpsonIntegralQuantLib" ;;
let _delete_SimpsonIntegral arg = match _delete_SimpsonIntegral_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussKronrodAdaptive_f : c_obj list -> c_obj list = "_wrap_new_GaussKronrodAdaptive__SWIG_0QuantLib" ;;
let _new_GaussKronrodAdaptive arg = match _new_GaussKronrodAdaptive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussKronrodAdaptive_f : c_obj list -> c_obj list = "_wrap_new_GaussKronrodAdaptiveQuantLib" ;;
let _new_GaussKronrodAdaptive arg = match _new_GaussKronrodAdaptive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussKronrodAdaptive_f : c_obj list -> c_obj list = "_wrap_delete_GaussKronrodAdaptiveQuantLib" ;;
let _delete_GaussKronrodAdaptive arg = match _delete_GaussKronrodAdaptive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussKronrodNonAdaptive_f : c_obj list -> c_obj list = "_wrap_new_GaussKronrodNonAdaptiveQuantLib" ;;
let _new_GaussKronrodNonAdaptive arg = match _new_GaussKronrodNonAdaptive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussKronrodNonAdaptive_f : c_obj list -> c_obj list = "_wrap_delete_GaussKronrodNonAdaptiveQuantLib" ;;
let _delete_GaussKronrodNonAdaptive arg = match _delete_GaussKronrodNonAdaptive_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussLobattoIntegral_f : c_obj list -> c_obj list = "_wrap_new_GaussLobattoIntegral__SWIG_0QuantLib" ;;
let _new_GaussLobattoIntegral arg = match _new_GaussLobattoIntegral_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussLobattoIntegral_f : c_obj list -> c_obj list = "_wrap_new_GaussLobattoIntegral__SWIG_1QuantLib" ;;
let _new_GaussLobattoIntegral arg = match _new_GaussLobattoIntegral_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussLobattoIntegral_f : c_obj list -> c_obj list = "_wrap_new_GaussLobattoIntegralQuantLib" ;;
let _new_GaussLobattoIntegral arg = match _new_GaussLobattoIntegral_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussLobattoIntegral_f : c_obj list -> c_obj list = "_wrap_delete_GaussLobattoIntegralQuantLib" ;;
let _delete_GaussLobattoIntegral arg = match _delete_GaussLobattoIntegral_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussLaguerreIntegration_f : c_obj list -> c_obj list = "_wrap_new_GaussLaguerreIntegration__SWIG_0QuantLib" ;;
let _new_GaussLaguerreIntegration arg = match _new_GaussLaguerreIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussLaguerreIntegration_f : c_obj list -> c_obj list = "_wrap_new_GaussLaguerreIntegrationQuantLib" ;;
let _new_GaussLaguerreIntegration arg = match _new_GaussLaguerreIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussLaguerreIntegration_f : c_obj list -> c_obj list = "_wrap_delete_GaussLaguerreIntegrationQuantLib" ;;
let _delete_GaussLaguerreIntegration arg = match _delete_GaussLaguerreIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussHermiteIntegration_f : c_obj list -> c_obj list = "_wrap_new_GaussHermiteIntegration__SWIG_0QuantLib" ;;
let _new_GaussHermiteIntegration arg = match _new_GaussHermiteIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussHermiteIntegration_f : c_obj list -> c_obj list = "_wrap_new_GaussHermiteIntegrationQuantLib" ;;
let _new_GaussHermiteIntegration arg = match _new_GaussHermiteIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussHermiteIntegration_f : c_obj list -> c_obj list = "_wrap_delete_GaussHermiteIntegrationQuantLib" ;;
let _delete_GaussHermiteIntegration arg = match _delete_GaussHermiteIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussJacobiIntegration_f : c_obj list -> c_obj list = "_wrap_new_GaussJacobiIntegrationQuantLib" ;;
let _new_GaussJacobiIntegration arg = match _new_GaussJacobiIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussJacobiIntegration_f : c_obj list -> c_obj list = "_wrap_delete_GaussJacobiIntegrationQuantLib" ;;
let _delete_GaussJacobiIntegration arg = match _delete_GaussJacobiIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussHyperbolicIntegration_f : c_obj list -> c_obj list = "_wrap_new_GaussHyperbolicIntegrationQuantLib" ;;
let _new_GaussHyperbolicIntegration arg = match _new_GaussHyperbolicIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussHyperbolicIntegration_f : c_obj list -> c_obj list = "_wrap_delete_GaussHyperbolicIntegrationQuantLib" ;;
let _delete_GaussHyperbolicIntegration arg = match _delete_GaussHyperbolicIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussLegendreIntegration_f : c_obj list -> c_obj list = "_wrap_new_GaussLegendreIntegrationQuantLib" ;;
let _new_GaussLegendreIntegration arg = match _new_GaussLegendreIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussLegendreIntegration_f : c_obj list -> c_obj list = "_wrap_delete_GaussLegendreIntegrationQuantLib" ;;
let _delete_GaussLegendreIntegration arg = match _delete_GaussLegendreIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussChebyshevIntegration_f : c_obj list -> c_obj list = "_wrap_new_GaussChebyshevIntegrationQuantLib" ;;
let _new_GaussChebyshevIntegration arg = match _new_GaussChebyshevIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussChebyshevIntegration_f : c_obj list -> c_obj list = "_wrap_delete_GaussChebyshevIntegrationQuantLib" ;;
let _delete_GaussChebyshevIntegration arg = match _delete_GaussChebyshevIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussChebyshev2ndIntegration_f : c_obj list -> c_obj list = "_wrap_new_GaussChebyshev2ndIntegrationQuantLib" ;;
let _new_GaussChebyshev2ndIntegration arg = match _new_GaussChebyshev2ndIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussChebyshev2ndIntegration_f : c_obj list -> c_obj list = "_wrap_delete_GaussChebyshev2ndIntegrationQuantLib" ;;
let _delete_GaussChebyshev2ndIntegration arg = match _delete_GaussChebyshev2ndIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussGegenbauerIntegration_f : c_obj list -> c_obj list = "_wrap_new_GaussGegenbauerIntegrationQuantLib" ;;
let _new_GaussGegenbauerIntegration arg = match _new_GaussGegenbauerIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussGegenbauerIntegration_f : c_obj list -> c_obj list = "_wrap_delete_GaussGegenbauerIntegrationQuantLib" ;;
let _delete_GaussGegenbauerIntegration arg = match _delete_GaussGegenbauerIntegration_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampleNumber_value_f : c_obj list -> c_obj list = "_wrap_SampleNumber_valueQuantLib" ;;
let _SampleNumber_value arg = match _SampleNumber_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampleNumber_weight_f : c_obj list -> c_obj list = "_wrap_SampleNumber_weightQuantLib" ;;
let _SampleNumber_weight arg = match _SampleNumber_weight_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SampleNumber_f : c_obj list -> c_obj list = "_wrap_delete_SampleNumberQuantLib" ;;
let _delete_SampleNumber arg = match _delete_SampleNumber_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampleArray_value_f : c_obj list -> c_obj list = "_wrap_SampleArray_valueQuantLib" ;;
let _SampleArray_value arg = match _SampleArray_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampleArray_weight_f : c_obj list -> c_obj list = "_wrap_SampleArray_weightQuantLib" ;;
let _SampleArray_weight arg = match _SampleArray_weight_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SampleArray_f : c_obj list -> c_obj list = "_wrap_delete_SampleArrayQuantLib" ;;
let _delete_SampleArray arg = match _delete_SampleArray_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampleRealVector_value_f : c_obj list -> c_obj list = "_wrap_SampleRealVector_valueQuantLib" ;;
let _SampleRealVector_value arg = match _SampleRealVector_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampleRealVector_weight_f : c_obj list -> c_obj list = "_wrap_SampleRealVector_weightQuantLib" ;;
let _SampleRealVector_weight arg = match _SampleRealVector_weight_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SampleRealVector_f : c_obj list -> c_obj list = "_wrap_delete_SampleRealVectorQuantLib" ;;
let _delete_SampleRealVector arg = match _delete_SampleRealVector_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LecuyerUniformRng_f : c_obj list -> c_obj list = "_wrap_new_LecuyerUniformRng__SWIG_0QuantLib" ;;
let _new_LecuyerUniformRng arg = match _new_LecuyerUniformRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LecuyerUniformRng_f : c_obj list -> c_obj list = "_wrap_new_LecuyerUniformRngQuantLib" ;;
let _new_LecuyerUniformRng arg = match _new_LecuyerUniformRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LecuyerUniformRng_next_f : c_obj list -> c_obj list = "_wrap_LecuyerUniformRng_nextQuantLib" ;;
let _LecuyerUniformRng_next arg = match _LecuyerUniformRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LecuyerUniformRng_f : c_obj list -> c_obj list = "_wrap_delete_LecuyerUniformRngQuantLib" ;;
let _delete_LecuyerUniformRng arg = match _delete_LecuyerUniformRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_KnuthUniformRng_f : c_obj list -> c_obj list = "_wrap_new_KnuthUniformRng__SWIG_0QuantLib" ;;
let _new_KnuthUniformRng arg = match _new_KnuthUniformRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_KnuthUniformRng_f : c_obj list -> c_obj list = "_wrap_new_KnuthUniformRngQuantLib" ;;
let _new_KnuthUniformRng arg = match _new_KnuthUniformRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KnuthUniformRng_next_f : c_obj list -> c_obj list = "_wrap_KnuthUniformRng_nextQuantLib" ;;
let _KnuthUniformRng_next arg = match _KnuthUniformRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_KnuthUniformRng_f : c_obj list -> c_obj list = "_wrap_delete_KnuthUniformRngQuantLib" ;;
let _delete_KnuthUniformRng arg = match _delete_KnuthUniformRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MersenneTwisterUniformRng_f : c_obj list -> c_obj list = "_wrap_new_MersenneTwisterUniformRng__SWIG_0QuantLib" ;;
let _new_MersenneTwisterUniformRng arg = match _new_MersenneTwisterUniformRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MersenneTwisterUniformRng_f : c_obj list -> c_obj list = "_wrap_new_MersenneTwisterUniformRngQuantLib" ;;
let _new_MersenneTwisterUniformRng arg = match _new_MersenneTwisterUniformRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MersenneTwisterUniformRng_next_f : c_obj list -> c_obj list = "_wrap_MersenneTwisterUniformRng_nextQuantLib" ;;
let _MersenneTwisterUniformRng_next arg = match _MersenneTwisterUniformRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MersenneTwisterUniformRng_f : c_obj list -> c_obj list = "_wrap_delete_MersenneTwisterUniformRngQuantLib" ;;
let _delete_MersenneTwisterUniformRng arg = match _delete_MersenneTwisterUniformRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UniformRandomGenerator_f : c_obj list -> c_obj list = "_wrap_new_UniformRandomGenerator__SWIG_0QuantLib" ;;
let _new_UniformRandomGenerator arg = match _new_UniformRandomGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UniformRandomGenerator_f : c_obj list -> c_obj list = "_wrap_new_UniformRandomGeneratorQuantLib" ;;
let _new_UniformRandomGenerator arg = match _new_UniformRandomGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UniformRandomGenerator_next_f : c_obj list -> c_obj list = "_wrap_UniformRandomGenerator_nextQuantLib" ;;
let _UniformRandomGenerator_next arg = match _UniformRandomGenerator_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UniformRandomGenerator_nextValue_f : c_obj list -> c_obj list = "_wrap_UniformRandomGenerator_nextValueQuantLib" ;;
let _UniformRandomGenerator_nextValue arg = match _UniformRandomGenerator_nextValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_UniformRandomGenerator_f : c_obj list -> c_obj list = "_wrap_delete_UniformRandomGeneratorQuantLib" ;;
let _delete_UniformRandomGenerator arg = match _delete_UniformRandomGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CentralLimitLecuyerGaussianRng_f : c_obj list -> c_obj list = "_wrap_new_CentralLimitLecuyerGaussianRngQuantLib" ;;
let _new_CentralLimitLecuyerGaussianRng arg = match _new_CentralLimitLecuyerGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CentralLimitLecuyerGaussianRng_next_f : c_obj list -> c_obj list = "_wrap_CentralLimitLecuyerGaussianRng_nextQuantLib" ;;
let _CentralLimitLecuyerGaussianRng_next arg = match _CentralLimitLecuyerGaussianRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CentralLimitLecuyerGaussianRng_f : c_obj list -> c_obj list = "_wrap_delete_CentralLimitLecuyerGaussianRngQuantLib" ;;
let _delete_CentralLimitLecuyerGaussianRng arg = match _delete_CentralLimitLecuyerGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CentralLimitKnuthGaussianRng_f : c_obj list -> c_obj list = "_wrap_new_CentralLimitKnuthGaussianRngQuantLib" ;;
let _new_CentralLimitKnuthGaussianRng arg = match _new_CentralLimitKnuthGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CentralLimitKnuthGaussianRng_next_f : c_obj list -> c_obj list = "_wrap_CentralLimitKnuthGaussianRng_nextQuantLib" ;;
let _CentralLimitKnuthGaussianRng_next arg = match _CentralLimitKnuthGaussianRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CentralLimitKnuthGaussianRng_f : c_obj list -> c_obj list = "_wrap_delete_CentralLimitKnuthGaussianRngQuantLib" ;;
let _delete_CentralLimitKnuthGaussianRng arg = match _delete_CentralLimitKnuthGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CentralLimitMersenneTwisterGaussianRng_f : c_obj list -> c_obj list = "_wrap_new_CentralLimitMersenneTwisterGaussianRngQuantLib" ;;
let _new_CentralLimitMersenneTwisterGaussianRng arg = match _new_CentralLimitMersenneTwisterGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CentralLimitMersenneTwisterGaussianRng_next_f : c_obj list -> c_obj list = "_wrap_CentralLimitMersenneTwisterGaussianRng_nextQuantLib" ;;
let _CentralLimitMersenneTwisterGaussianRng_next arg = match _CentralLimitMersenneTwisterGaussianRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CentralLimitMersenneTwisterGaussianRng_f : c_obj list -> c_obj list = "_wrap_delete_CentralLimitMersenneTwisterGaussianRngQuantLib" ;;
let _delete_CentralLimitMersenneTwisterGaussianRng arg = match _delete_CentralLimitMersenneTwisterGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BoxMullerLecuyerGaussianRng_f : c_obj list -> c_obj list = "_wrap_new_BoxMullerLecuyerGaussianRngQuantLib" ;;
let _new_BoxMullerLecuyerGaussianRng arg = match _new_BoxMullerLecuyerGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoxMullerLecuyerGaussianRng_next_f : c_obj list -> c_obj list = "_wrap_BoxMullerLecuyerGaussianRng_nextQuantLib" ;;
let _BoxMullerLecuyerGaussianRng_next arg = match _BoxMullerLecuyerGaussianRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BoxMullerLecuyerGaussianRng_f : c_obj list -> c_obj list = "_wrap_delete_BoxMullerLecuyerGaussianRngQuantLib" ;;
let _delete_BoxMullerLecuyerGaussianRng arg = match _delete_BoxMullerLecuyerGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BoxMullerKnuthGaussianRng_f : c_obj list -> c_obj list = "_wrap_new_BoxMullerKnuthGaussianRngQuantLib" ;;
let _new_BoxMullerKnuthGaussianRng arg = match _new_BoxMullerKnuthGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoxMullerKnuthGaussianRng_next_f : c_obj list -> c_obj list = "_wrap_BoxMullerKnuthGaussianRng_nextQuantLib" ;;
let _BoxMullerKnuthGaussianRng_next arg = match _BoxMullerKnuthGaussianRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BoxMullerKnuthGaussianRng_f : c_obj list -> c_obj list = "_wrap_delete_BoxMullerKnuthGaussianRngQuantLib" ;;
let _delete_BoxMullerKnuthGaussianRng arg = match _delete_BoxMullerKnuthGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BoxMullerMersenneTwisterGaussianRng_f : c_obj list -> c_obj list = "_wrap_new_BoxMullerMersenneTwisterGaussianRngQuantLib" ;;
let _new_BoxMullerMersenneTwisterGaussianRng arg = match _new_BoxMullerMersenneTwisterGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoxMullerMersenneTwisterGaussianRng_next_f : c_obj list -> c_obj list = "_wrap_BoxMullerMersenneTwisterGaussianRng_nextQuantLib" ;;
let _BoxMullerMersenneTwisterGaussianRng_next arg = match _BoxMullerMersenneTwisterGaussianRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BoxMullerMersenneTwisterGaussianRng_f : c_obj list -> c_obj list = "_wrap_delete_BoxMullerMersenneTwisterGaussianRngQuantLib" ;;
let _delete_BoxMullerMersenneTwisterGaussianRng arg = match _delete_BoxMullerMersenneTwisterGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MoroInvCumulativeLecuyerGaussianRng_f : c_obj list -> c_obj list = "_wrap_new_MoroInvCumulativeLecuyerGaussianRngQuantLib" ;;
let _new_MoroInvCumulativeLecuyerGaussianRng arg = match _new_MoroInvCumulativeLecuyerGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MoroInvCumulativeLecuyerGaussianRng_next_f : c_obj list -> c_obj list = "_wrap_MoroInvCumulativeLecuyerGaussianRng_nextQuantLib" ;;
let _MoroInvCumulativeLecuyerGaussianRng_next arg = match _MoroInvCumulativeLecuyerGaussianRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MoroInvCumulativeLecuyerGaussianRng_f : c_obj list -> c_obj list = "_wrap_delete_MoroInvCumulativeLecuyerGaussianRngQuantLib" ;;
let _delete_MoroInvCumulativeLecuyerGaussianRng arg = match _delete_MoroInvCumulativeLecuyerGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MoroInvCumulativeKnuthGaussianRng_f : c_obj list -> c_obj list = "_wrap_new_MoroInvCumulativeKnuthGaussianRngQuantLib" ;;
let _new_MoroInvCumulativeKnuthGaussianRng arg = match _new_MoroInvCumulativeKnuthGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MoroInvCumulativeKnuthGaussianRng_next_f : c_obj list -> c_obj list = "_wrap_MoroInvCumulativeKnuthGaussianRng_nextQuantLib" ;;
let _MoroInvCumulativeKnuthGaussianRng_next arg = match _MoroInvCumulativeKnuthGaussianRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MoroInvCumulativeKnuthGaussianRng_f : c_obj list -> c_obj list = "_wrap_delete_MoroInvCumulativeKnuthGaussianRngQuantLib" ;;
let _delete_MoroInvCumulativeKnuthGaussianRng arg = match _delete_MoroInvCumulativeKnuthGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MoroInvCumulativeMersenneTwisterGaussianRng_f : c_obj list -> c_obj list = "_wrap_new_MoroInvCumulativeMersenneTwisterGaussianRngQuantLib" ;;
let _new_MoroInvCumulativeMersenneTwisterGaussianRng arg = match _new_MoroInvCumulativeMersenneTwisterGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MoroInvCumulativeMersenneTwisterGaussianRng_next_f : c_obj list -> c_obj list = "_wrap_MoroInvCumulativeMersenneTwisterGaussianRng_nextQuantLib" ;;
let _MoroInvCumulativeMersenneTwisterGaussianRng_next arg = match _MoroInvCumulativeMersenneTwisterGaussianRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MoroInvCumulativeMersenneTwisterGaussianRng_f : c_obj list -> c_obj list = "_wrap_delete_MoroInvCumulativeMersenneTwisterGaussianRngQuantLib" ;;
let _delete_MoroInvCumulativeMersenneTwisterGaussianRng arg = match _delete_MoroInvCumulativeMersenneTwisterGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InvCumulativeLecuyerGaussianRng_f : c_obj list -> c_obj list = "_wrap_new_InvCumulativeLecuyerGaussianRngQuantLib" ;;
let _new_InvCumulativeLecuyerGaussianRng arg = match _new_InvCumulativeLecuyerGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InvCumulativeLecuyerGaussianRng_next_f : c_obj list -> c_obj list = "_wrap_InvCumulativeLecuyerGaussianRng_nextQuantLib" ;;
let _InvCumulativeLecuyerGaussianRng_next arg = match _InvCumulativeLecuyerGaussianRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InvCumulativeLecuyerGaussianRng_f : c_obj list -> c_obj list = "_wrap_delete_InvCumulativeLecuyerGaussianRngQuantLib" ;;
let _delete_InvCumulativeLecuyerGaussianRng arg = match _delete_InvCumulativeLecuyerGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InvCumulativeKnuthGaussianRng_f : c_obj list -> c_obj list = "_wrap_new_InvCumulativeKnuthGaussianRngQuantLib" ;;
let _new_InvCumulativeKnuthGaussianRng arg = match _new_InvCumulativeKnuthGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InvCumulativeKnuthGaussianRng_next_f : c_obj list -> c_obj list = "_wrap_InvCumulativeKnuthGaussianRng_nextQuantLib" ;;
let _InvCumulativeKnuthGaussianRng_next arg = match _InvCumulativeKnuthGaussianRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InvCumulativeKnuthGaussianRng_f : c_obj list -> c_obj list = "_wrap_delete_InvCumulativeKnuthGaussianRngQuantLib" ;;
let _delete_InvCumulativeKnuthGaussianRng arg = match _delete_InvCumulativeKnuthGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InvCumulativeMersenneTwisterGaussianRng_f : c_obj list -> c_obj list = "_wrap_new_InvCumulativeMersenneTwisterGaussianRngQuantLib" ;;
let _new_InvCumulativeMersenneTwisterGaussianRng arg = match _new_InvCumulativeMersenneTwisterGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InvCumulativeMersenneTwisterGaussianRng_next_f : c_obj list -> c_obj list = "_wrap_InvCumulativeMersenneTwisterGaussianRng_nextQuantLib" ;;
let _InvCumulativeMersenneTwisterGaussianRng_next arg = match _InvCumulativeMersenneTwisterGaussianRng_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InvCumulativeMersenneTwisterGaussianRng_f : c_obj list -> c_obj list = "_wrap_delete_InvCumulativeMersenneTwisterGaussianRngQuantLib" ;;
let _delete_InvCumulativeMersenneTwisterGaussianRng arg = match _delete_InvCumulativeMersenneTwisterGaussianRng_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianRandomGenerator_f : c_obj list -> c_obj list = "_wrap_new_GaussianRandomGeneratorQuantLib" ;;
let _new_GaussianRandomGenerator arg = match _new_GaussianRandomGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GaussianRandomGenerator_next_f : c_obj list -> c_obj list = "_wrap_GaussianRandomGenerator_nextQuantLib" ;;
let _GaussianRandomGenerator_next arg = match _GaussianRandomGenerator_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GaussianRandomGenerator_nextValue_f : c_obj list -> c_obj list = "_wrap_GaussianRandomGenerator_nextValueQuantLib" ;;
let _GaussianRandomGenerator_nextValue arg = match _GaussianRandomGenerator_nextValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussianRandomGenerator_f : c_obj list -> c_obj list = "_wrap_delete_GaussianRandomGeneratorQuantLib" ;;
let _delete_GaussianRandomGenerator arg = match _delete_GaussianRandomGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HaltonRsg_f : c_obj list -> c_obj list = "_wrap_new_HaltonRsg__SWIG_0QuantLib" ;;
let _new_HaltonRsg arg = match _new_HaltonRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HaltonRsg_f : c_obj list -> c_obj list = "_wrap_new_HaltonRsg__SWIG_1QuantLib" ;;
let _new_HaltonRsg arg = match _new_HaltonRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HaltonRsg_f : c_obj list -> c_obj list = "_wrap_new_HaltonRsg__SWIG_2QuantLib" ;;
let _new_HaltonRsg arg = match _new_HaltonRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_HaltonRsg_f : c_obj list -> c_obj list = "_wrap_new_HaltonRsgQuantLib" ;;
let _new_HaltonRsg arg = match _new_HaltonRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HaltonRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_HaltonRsg_nextSequenceQuantLib" ;;
let _HaltonRsg_nextSequence arg = match _HaltonRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HaltonRsg_lastSequence_f : c_obj list -> c_obj list = "_wrap_HaltonRsg_lastSequenceQuantLib" ;;
let _HaltonRsg_lastSequence arg = match _HaltonRsg_lastSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _HaltonRsg_dimension_f : c_obj list -> c_obj list = "_wrap_HaltonRsg_dimensionQuantLib" ;;
let _HaltonRsg_dimension arg = match _HaltonRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_HaltonRsg_f : c_obj list -> c_obj list = "_wrap_delete_HaltonRsgQuantLib" ;;
let _delete_HaltonRsg arg = match _delete_HaltonRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "SobolRsg::DirectionIntegers_marker" (`DirectionIntegers)
external _Unit : c_obj -> Swig.c_obj = "_wrap_Unit" 
external _Jaeckel : c_obj -> Swig.c_obj = "_wrap_Jaeckel" 
external _SobolLevitan : c_obj -> Swig.c_obj = "_wrap_SobolLevitan" 
external _SobolLevitanLemieux : c_obj -> Swig.c_obj = "_wrap_SobolLevitanLemieux" 
external _JoeKuoD5 : c_obj -> Swig.c_obj = "_wrap_JoeKuoD5" 
external _JoeKuoD6 : c_obj -> Swig.c_obj = "_wrap_JoeKuoD6" 
external _JoeKuoD7 : c_obj -> Swig.c_obj = "_wrap_JoeKuoD7" 
external _Kuo : c_obj -> Swig.c_obj = "_wrap_Kuo" 
external _Kuo2 : c_obj -> Swig.c_obj = "_wrap_Kuo2" 
external _Kuo3 : c_obj -> Swig.c_obj = "_wrap_Kuo3" 
external _new_SobolRsg_f : c_obj list -> c_obj list = "_wrap_new_SobolRsg__SWIG_0QuantLib" ;;
let _new_SobolRsg arg = match _new_SobolRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SobolRsg_f : c_obj list -> c_obj list = "_wrap_new_SobolRsg__SWIG_1QuantLib" ;;
let _new_SobolRsg arg = match _new_SobolRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SobolRsg_f : c_obj list -> c_obj list = "_wrap_new_SobolRsgQuantLib" ;;
let _new_SobolRsg arg = match _new_SobolRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SobolRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_SobolRsg_nextSequenceQuantLib" ;;
let _SobolRsg_nextSequence arg = match _SobolRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SobolRsg_lastSequence_f : c_obj list -> c_obj list = "_wrap_SobolRsg_lastSequenceQuantLib" ;;
let _SobolRsg_lastSequence arg = match _SobolRsg_lastSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SobolRsg_dimension_f : c_obj list -> c_obj list = "_wrap_SobolRsg_dimensionQuantLib" ;;
let _SobolRsg_dimension arg = match _SobolRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SobolRsg_f : c_obj list -> c_obj list = "_wrap_delete_SobolRsgQuantLib" ;;
let _delete_SobolRsg arg = match _delete_SobolRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SobolBrownianBridgeRsg_f : c_obj list -> c_obj list = "_wrap_new_SobolBrownianBridgeRsgQuantLib" ;;
let _new_SobolBrownianBridgeRsg arg = match _new_SobolBrownianBridgeRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SobolBrownianBridgeRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_SobolBrownianBridgeRsg_nextSequenceQuantLib" ;;
let _SobolBrownianBridgeRsg_nextSequence arg = match _SobolBrownianBridgeRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SobolBrownianBridgeRsg_lastSequence_f : c_obj list -> c_obj list = "_wrap_SobolBrownianBridgeRsg_lastSequenceQuantLib" ;;
let _SobolBrownianBridgeRsg_lastSequence arg = match _SobolBrownianBridgeRsg_lastSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SobolBrownianBridgeRsg_dimension_f : c_obj list -> c_obj list = "_wrap_SobolBrownianBridgeRsg_dimensionQuantLib" ;;
let _SobolBrownianBridgeRsg_dimension arg = match _SobolBrownianBridgeRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SobolBrownianBridgeRsg_f : c_obj list -> c_obj list = "_wrap_delete_SobolBrownianBridgeRsgQuantLib" ;;
let _delete_SobolBrownianBridgeRsg arg = match _delete_SobolBrownianBridgeRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LecuyerUniformRsg_f : c_obj list -> c_obj list = "_wrap_new_LecuyerUniformRsgQuantLib" ;;
let _new_LecuyerUniformRsg arg = match _new_LecuyerUniformRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LecuyerUniformRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_LecuyerUniformRsg_nextSequenceQuantLib" ;;
let _LecuyerUniformRsg_nextSequence arg = match _LecuyerUniformRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LecuyerUniformRsg_dimension_f : c_obj list -> c_obj list = "_wrap_LecuyerUniformRsg_dimensionQuantLib" ;;
let _LecuyerUniformRsg_dimension arg = match _LecuyerUniformRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LecuyerUniformRsg_f : c_obj list -> c_obj list = "_wrap_delete_LecuyerUniformRsgQuantLib" ;;
let _delete_LecuyerUniformRsg arg = match _delete_LecuyerUniformRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_KnuthUniformRsg_f : c_obj list -> c_obj list = "_wrap_new_KnuthUniformRsgQuantLib" ;;
let _new_KnuthUniformRsg arg = match _new_KnuthUniformRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KnuthUniformRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_KnuthUniformRsg_nextSequenceQuantLib" ;;
let _KnuthUniformRsg_nextSequence arg = match _KnuthUniformRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _KnuthUniformRsg_dimension_f : c_obj list -> c_obj list = "_wrap_KnuthUniformRsg_dimensionQuantLib" ;;
let _KnuthUniformRsg_dimension arg = match _KnuthUniformRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_KnuthUniformRsg_f : c_obj list -> c_obj list = "_wrap_delete_KnuthUniformRsgQuantLib" ;;
let _delete_KnuthUniformRsg arg = match _delete_KnuthUniformRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MersenneTwisterUniformRsg_f : c_obj list -> c_obj list = "_wrap_new_MersenneTwisterUniformRsgQuantLib" ;;
let _new_MersenneTwisterUniformRsg arg = match _new_MersenneTwisterUniformRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MersenneTwisterUniformRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_MersenneTwisterUniformRsg_nextSequenceQuantLib" ;;
let _MersenneTwisterUniformRsg_nextSequence arg = match _MersenneTwisterUniformRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MersenneTwisterUniformRsg_dimension_f : c_obj list -> c_obj list = "_wrap_MersenneTwisterUniformRsg_dimensionQuantLib" ;;
let _MersenneTwisterUniformRsg_dimension arg = match _MersenneTwisterUniformRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MersenneTwisterUniformRsg_f : c_obj list -> c_obj list = "_wrap_delete_MersenneTwisterUniformRsgQuantLib" ;;
let _delete_MersenneTwisterUniformRsg arg = match _delete_MersenneTwisterUniformRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UniformRandomSequenceGenerator_f : c_obj list -> c_obj list = "_wrap_new_UniformRandomSequenceGeneratorQuantLib" ;;
let _new_UniformRandomSequenceGenerator arg = match _new_UniformRandomSequenceGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UniformRandomSequenceGenerator_nextSequence_f : c_obj list -> c_obj list = "_wrap_UniformRandomSequenceGenerator_nextSequenceQuantLib" ;;
let _UniformRandomSequenceGenerator_nextSequence arg = match _UniformRandomSequenceGenerator_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UniformRandomSequenceGenerator_dimension_f : c_obj list -> c_obj list = "_wrap_UniformRandomSequenceGenerator_dimensionQuantLib" ;;
let _UniformRandomSequenceGenerator_dimension arg = match _UniformRandomSequenceGenerator_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_UniformRandomSequenceGenerator_f : c_obj list -> c_obj list = "_wrap_delete_UniformRandomSequenceGeneratorQuantLib" ;;
let _delete_UniformRandomSequenceGenerator arg = match _delete_UniformRandomSequenceGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_UniformLowDiscrepancySequenceGenerator_f : c_obj list -> c_obj list = "_wrap_new_UniformLowDiscrepancySequenceGeneratorQuantLib" ;;
let _new_UniformLowDiscrepancySequenceGenerator arg = match _new_UniformLowDiscrepancySequenceGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UniformLowDiscrepancySequenceGenerator_nextSequence_f : c_obj list -> c_obj list = "_wrap_UniformLowDiscrepancySequenceGenerator_nextSequenceQuantLib" ;;
let _UniformLowDiscrepancySequenceGenerator_nextSequence arg = match _UniformLowDiscrepancySequenceGenerator_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _UniformLowDiscrepancySequenceGenerator_dimension_f : c_obj list -> c_obj list = "_wrap_UniformLowDiscrepancySequenceGenerator_dimensionQuantLib" ;;
let _UniformLowDiscrepancySequenceGenerator_dimension arg = match _UniformLowDiscrepancySequenceGenerator_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_UniformLowDiscrepancySequenceGenerator_f : c_obj list -> c_obj list = "_wrap_delete_UniformLowDiscrepancySequenceGeneratorQuantLib" ;;
let _delete_UniformLowDiscrepancySequenceGenerator arg = match _delete_UniformLowDiscrepancySequenceGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MoroInvCumulativeLecuyerGaussianRsg_f : c_obj list -> c_obj list = "_wrap_new_MoroInvCumulativeLecuyerGaussianRsgQuantLib" ;;
let _new_MoroInvCumulativeLecuyerGaussianRsg arg = match _new_MoroInvCumulativeLecuyerGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MoroInvCumulativeLecuyerGaussianRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_MoroInvCumulativeLecuyerGaussianRsg_nextSequenceQuantLib" ;;
let _MoroInvCumulativeLecuyerGaussianRsg_nextSequence arg = match _MoroInvCumulativeLecuyerGaussianRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MoroInvCumulativeLecuyerGaussianRsg_dimension_f : c_obj list -> c_obj list = "_wrap_MoroInvCumulativeLecuyerGaussianRsg_dimensionQuantLib" ;;
let _MoroInvCumulativeLecuyerGaussianRsg_dimension arg = match _MoroInvCumulativeLecuyerGaussianRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MoroInvCumulativeLecuyerGaussianRsg_f : c_obj list -> c_obj list = "_wrap_delete_MoroInvCumulativeLecuyerGaussianRsgQuantLib" ;;
let _delete_MoroInvCumulativeLecuyerGaussianRsg arg = match _delete_MoroInvCumulativeLecuyerGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MoroInvCumulativeKnuthGaussianRsg_f : c_obj list -> c_obj list = "_wrap_new_MoroInvCumulativeKnuthGaussianRsgQuantLib" ;;
let _new_MoroInvCumulativeKnuthGaussianRsg arg = match _new_MoroInvCumulativeKnuthGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MoroInvCumulativeKnuthGaussianRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_MoroInvCumulativeKnuthGaussianRsg_nextSequenceQuantLib" ;;
let _MoroInvCumulativeKnuthGaussianRsg_nextSequence arg = match _MoroInvCumulativeKnuthGaussianRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MoroInvCumulativeKnuthGaussianRsg_dimension_f : c_obj list -> c_obj list = "_wrap_MoroInvCumulativeKnuthGaussianRsg_dimensionQuantLib" ;;
let _MoroInvCumulativeKnuthGaussianRsg_dimension arg = match _MoroInvCumulativeKnuthGaussianRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MoroInvCumulativeKnuthGaussianRsg_f : c_obj list -> c_obj list = "_wrap_delete_MoroInvCumulativeKnuthGaussianRsgQuantLib" ;;
let _delete_MoroInvCumulativeKnuthGaussianRsg arg = match _delete_MoroInvCumulativeKnuthGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MoroInvCumulativeMersenneTwisterGaussianRsg_f : c_obj list -> c_obj list = "_wrap_new_MoroInvCumulativeMersenneTwisterGaussianRsgQuantLib" ;;
let _new_MoroInvCumulativeMersenneTwisterGaussianRsg arg = match _new_MoroInvCumulativeMersenneTwisterGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MoroInvCumulativeMersenneTwisterGaussianRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_MoroInvCumulativeMersenneTwisterGaussianRsg_nextSequenceQuantLib" ;;
let _MoroInvCumulativeMersenneTwisterGaussianRsg_nextSequence arg = match _MoroInvCumulativeMersenneTwisterGaussianRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MoroInvCumulativeMersenneTwisterGaussianRsg_dimension_f : c_obj list -> c_obj list = "_wrap_MoroInvCumulativeMersenneTwisterGaussianRsg_dimensionQuantLib" ;;
let _MoroInvCumulativeMersenneTwisterGaussianRsg_dimension arg = match _MoroInvCumulativeMersenneTwisterGaussianRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MoroInvCumulativeMersenneTwisterGaussianRsg_f : c_obj list -> c_obj list = "_wrap_delete_MoroInvCumulativeMersenneTwisterGaussianRsgQuantLib" ;;
let _delete_MoroInvCumulativeMersenneTwisterGaussianRsg arg = match _delete_MoroInvCumulativeMersenneTwisterGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MoroInvCumulativeHaltonGaussianRsg_f : c_obj list -> c_obj list = "_wrap_new_MoroInvCumulativeHaltonGaussianRsgQuantLib" ;;
let _new_MoroInvCumulativeHaltonGaussianRsg arg = match _new_MoroInvCumulativeHaltonGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MoroInvCumulativeHaltonGaussianRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_MoroInvCumulativeHaltonGaussianRsg_nextSequenceQuantLib" ;;
let _MoroInvCumulativeHaltonGaussianRsg_nextSequence arg = match _MoroInvCumulativeHaltonGaussianRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MoroInvCumulativeHaltonGaussianRsg_dimension_f : c_obj list -> c_obj list = "_wrap_MoroInvCumulativeHaltonGaussianRsg_dimensionQuantLib" ;;
let _MoroInvCumulativeHaltonGaussianRsg_dimension arg = match _MoroInvCumulativeHaltonGaussianRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MoroInvCumulativeHaltonGaussianRsg_f : c_obj list -> c_obj list = "_wrap_delete_MoroInvCumulativeHaltonGaussianRsgQuantLib" ;;
let _delete_MoroInvCumulativeHaltonGaussianRsg arg = match _delete_MoroInvCumulativeHaltonGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InvCumulativeLecuyerGaussianRsg_f : c_obj list -> c_obj list = "_wrap_new_InvCumulativeLecuyerGaussianRsgQuantLib" ;;
let _new_InvCumulativeLecuyerGaussianRsg arg = match _new_InvCumulativeLecuyerGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InvCumulativeLecuyerGaussianRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_InvCumulativeLecuyerGaussianRsg_nextSequenceQuantLib" ;;
let _InvCumulativeLecuyerGaussianRsg_nextSequence arg = match _InvCumulativeLecuyerGaussianRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InvCumulativeLecuyerGaussianRsg_dimension_f : c_obj list -> c_obj list = "_wrap_InvCumulativeLecuyerGaussianRsg_dimensionQuantLib" ;;
let _InvCumulativeLecuyerGaussianRsg_dimension arg = match _InvCumulativeLecuyerGaussianRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InvCumulativeLecuyerGaussianRsg_f : c_obj list -> c_obj list = "_wrap_delete_InvCumulativeLecuyerGaussianRsgQuantLib" ;;
let _delete_InvCumulativeLecuyerGaussianRsg arg = match _delete_InvCumulativeLecuyerGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InvCumulativeKnuthGaussianRsg_f : c_obj list -> c_obj list = "_wrap_new_InvCumulativeKnuthGaussianRsgQuantLib" ;;
let _new_InvCumulativeKnuthGaussianRsg arg = match _new_InvCumulativeKnuthGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InvCumulativeKnuthGaussianRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_InvCumulativeKnuthGaussianRsg_nextSequenceQuantLib" ;;
let _InvCumulativeKnuthGaussianRsg_nextSequence arg = match _InvCumulativeKnuthGaussianRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InvCumulativeKnuthGaussianRsg_dimension_f : c_obj list -> c_obj list = "_wrap_InvCumulativeKnuthGaussianRsg_dimensionQuantLib" ;;
let _InvCumulativeKnuthGaussianRsg_dimension arg = match _InvCumulativeKnuthGaussianRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InvCumulativeKnuthGaussianRsg_f : c_obj list -> c_obj list = "_wrap_delete_InvCumulativeKnuthGaussianRsgQuantLib" ;;
let _delete_InvCumulativeKnuthGaussianRsg arg = match _delete_InvCumulativeKnuthGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InvCumulativeMersenneTwisterGaussianRsg_f : c_obj list -> c_obj list = "_wrap_new_InvCumulativeMersenneTwisterGaussianRsgQuantLib" ;;
let _new_InvCumulativeMersenneTwisterGaussianRsg arg = match _new_InvCumulativeMersenneTwisterGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InvCumulativeMersenneTwisterGaussianRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_InvCumulativeMersenneTwisterGaussianRsg_nextSequenceQuantLib" ;;
let _InvCumulativeMersenneTwisterGaussianRsg_nextSequence arg = match _InvCumulativeMersenneTwisterGaussianRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InvCumulativeMersenneTwisterGaussianRsg_dimension_f : c_obj list -> c_obj list = "_wrap_InvCumulativeMersenneTwisterGaussianRsg_dimensionQuantLib" ;;
let _InvCumulativeMersenneTwisterGaussianRsg_dimension arg = match _InvCumulativeMersenneTwisterGaussianRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InvCumulativeMersenneTwisterGaussianRsg_f : c_obj list -> c_obj list = "_wrap_delete_InvCumulativeMersenneTwisterGaussianRsgQuantLib" ;;
let _delete_InvCumulativeMersenneTwisterGaussianRsg arg = match _delete_InvCumulativeMersenneTwisterGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_InvCumulativeHaltonGaussianRsg_f : c_obj list -> c_obj list = "_wrap_new_InvCumulativeHaltonGaussianRsgQuantLib" ;;
let _new_InvCumulativeHaltonGaussianRsg arg = match _new_InvCumulativeHaltonGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InvCumulativeHaltonGaussianRsg_nextSequence_f : c_obj list -> c_obj list = "_wrap_InvCumulativeHaltonGaussianRsg_nextSequenceQuantLib" ;;
let _InvCumulativeHaltonGaussianRsg_nextSequence arg = match _InvCumulativeHaltonGaussianRsg_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _InvCumulativeHaltonGaussianRsg_dimension_f : c_obj list -> c_obj list = "_wrap_InvCumulativeHaltonGaussianRsg_dimensionQuantLib" ;;
let _InvCumulativeHaltonGaussianRsg_dimension arg = match _InvCumulativeHaltonGaussianRsg_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_InvCumulativeHaltonGaussianRsg_f : c_obj list -> c_obj list = "_wrap_delete_InvCumulativeHaltonGaussianRsgQuantLib" ;;
let _delete_InvCumulativeHaltonGaussianRsg arg = match _delete_InvCumulativeHaltonGaussianRsg_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianRandomSequenceGenerator_f : c_obj list -> c_obj list = "_wrap_new_GaussianRandomSequenceGeneratorQuantLib" ;;
let _new_GaussianRandomSequenceGenerator arg = match _new_GaussianRandomSequenceGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GaussianRandomSequenceGenerator_nextSequence_f : c_obj list -> c_obj list = "_wrap_GaussianRandomSequenceGenerator_nextSequenceQuantLib" ;;
let _GaussianRandomSequenceGenerator_nextSequence arg = match _GaussianRandomSequenceGenerator_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GaussianRandomSequenceGenerator_dimension_f : c_obj list -> c_obj list = "_wrap_GaussianRandomSequenceGenerator_dimensionQuantLib" ;;
let _GaussianRandomSequenceGenerator_dimension arg = match _GaussianRandomSequenceGenerator_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussianRandomSequenceGenerator_f : c_obj list -> c_obj list = "_wrap_delete_GaussianRandomSequenceGeneratorQuantLib" ;;
let _delete_GaussianRandomSequenceGenerator arg = match _delete_GaussianRandomSequenceGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianLowDiscrepancySequenceGenerator_f : c_obj list -> c_obj list = "_wrap_new_GaussianLowDiscrepancySequenceGeneratorQuantLib" ;;
let _new_GaussianLowDiscrepancySequenceGenerator arg = match _new_GaussianLowDiscrepancySequenceGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GaussianLowDiscrepancySequenceGenerator_nextSequence_f : c_obj list -> c_obj list = "_wrap_GaussianLowDiscrepancySequenceGenerator_nextSequenceQuantLib" ;;
let _GaussianLowDiscrepancySequenceGenerator_nextSequence arg = match _GaussianLowDiscrepancySequenceGenerator_nextSequence_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GaussianLowDiscrepancySequenceGenerator_dimension_f : c_obj list -> c_obj list = "_wrap_GaussianLowDiscrepancySequenceGenerator_dimensionQuantLib" ;;
let _GaussianLowDiscrepancySequenceGenerator_dimension arg = match _GaussianLowDiscrepancySequenceGenerator_dimension_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussianLowDiscrepancySequenceGenerator_f : c_obj list -> c_obj list = "_wrap_delete_GaussianLowDiscrepancySequenceGeneratorQuantLib" ;;
let _delete_GaussianLowDiscrepancySequenceGenerator arg = match _delete_GaussianLowDiscrepancySequenceGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _getCovariance_f : c_obj list -> c_obj list = "_wrap_getCovarianceQuantLib" ;;
let _getCovariance arg = match _getCovariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Path_length_f : c_obj list -> c_obj list = "_wrap_Path_lengthQuantLib" ;;
let _Path_length arg = match _Path_length_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Path_value_f : c_obj list -> c_obj list = "_wrap_Path_valueQuantLib" ;;
let _Path_value arg = match _Path_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Path_front_f : c_obj list -> c_obj list = "_wrap_Path_frontQuantLib" ;;
let _Path_front arg = match _Path_front_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Path_back_f : c_obj list -> c_obj list = "_wrap_Path_backQuantLib" ;;
let _Path_back arg = match _Path_back_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Path_time_f : c_obj list -> c_obj list = "_wrap_Path_timeQuantLib" ;;
let _Path_time arg = match _Path_time_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Path_f : c_obj list -> c_obj list = "_wrap_delete_PathQuantLib" ;;
let _delete_Path arg = match _delete_Path_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SamplePath_value_f : c_obj list -> c_obj list = "_wrap_SamplePath_valueQuantLib" ;;
let _SamplePath_value arg = match _SamplePath_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SamplePath_weight_f : c_obj list -> c_obj list = "_wrap_SamplePath_weightQuantLib" ;;
let _SamplePath_weight arg = match _SamplePath_weight_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SamplePath_f : c_obj list -> c_obj list = "_wrap_delete_SamplePathQuantLib" ;;
let _delete_SamplePath arg = match _delete_SamplePath_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianPathGenerator_f : c_obj list -> c_obj list = "_wrap_new_GaussianPathGeneratorQuantLib" ;;
let _new_GaussianPathGenerator arg = match _new_GaussianPathGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GaussianPathGenerator_next_f : c_obj list -> c_obj list = "_wrap_GaussianPathGenerator_nextQuantLib" ;;
let _GaussianPathGenerator_next arg = match _GaussianPathGenerator_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GaussianPathGenerator_antithetic_f : c_obj list -> c_obj list = "_wrap_GaussianPathGenerator_antitheticQuantLib" ;;
let _GaussianPathGenerator_antithetic arg = match _GaussianPathGenerator_antithetic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussianPathGenerator_f : c_obj list -> c_obj list = "_wrap_delete_GaussianPathGeneratorQuantLib" ;;
let _delete_GaussianPathGenerator arg = match _delete_GaussianPathGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianSobolPathGenerator_f : c_obj list -> c_obj list = "_wrap_new_GaussianSobolPathGeneratorQuantLib" ;;
let _new_GaussianSobolPathGenerator arg = match _new_GaussianSobolPathGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GaussianSobolPathGenerator_next_f : c_obj list -> c_obj list = "_wrap_GaussianSobolPathGenerator_nextQuantLib" ;;
let _GaussianSobolPathGenerator_next arg = match _GaussianSobolPathGenerator_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GaussianSobolPathGenerator_antithetic_f : c_obj list -> c_obj list = "_wrap_GaussianSobolPathGenerator_antitheticQuantLib" ;;
let _GaussianSobolPathGenerator_antithetic arg = match _GaussianSobolPathGenerator_antithetic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussianSobolPathGenerator_f : c_obj list -> c_obj list = "_wrap_delete_GaussianSobolPathGeneratorQuantLib" ;;
let _delete_GaussianSobolPathGenerator arg = match _delete_GaussianSobolPathGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultiPath_pathSize_f : c_obj list -> c_obj list = "_wrap_MultiPath_pathSizeQuantLib" ;;
let _MultiPath_pathSize arg = match _MultiPath_pathSize_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultiPath_assetNumber_f : c_obj list -> c_obj list = "_wrap_MultiPath_assetNumberQuantLib" ;;
let _MultiPath_assetNumber arg = match _MultiPath_assetNumber_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultiPath_at_f : c_obj list -> c_obj list = "_wrap_MultiPath_atQuantLib" ;;
let _MultiPath_at arg = match _MultiPath_at_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MultiPath_f : c_obj list -> c_obj list = "_wrap_delete_MultiPathQuantLib" ;;
let _delete_MultiPath arg = match _delete_MultiPath_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampleMultiPath_value_f : c_obj list -> c_obj list = "_wrap_SampleMultiPath_valueQuantLib" ;;
let _SampleMultiPath_value arg = match _SampleMultiPath_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampleMultiPath_weight_f : c_obj list -> c_obj list = "_wrap_SampleMultiPath_weightQuantLib" ;;
let _SampleMultiPath_weight arg = match _SampleMultiPath_weight_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SampleMultiPath_f : c_obj list -> c_obj list = "_wrap_delete_SampleMultiPathQuantLib" ;;
let _delete_SampleMultiPath arg = match _delete_SampleMultiPath_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianMultiPathGenerator_f : c_obj list -> c_obj list = "_wrap_new_GaussianMultiPathGenerator__SWIG_0QuantLib" ;;
let _new_GaussianMultiPathGenerator arg = match _new_GaussianMultiPathGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GaussianMultiPathGenerator_f : c_obj list -> c_obj list = "_wrap_new_GaussianMultiPathGeneratorQuantLib" ;;
let _new_GaussianMultiPathGenerator arg = match _new_GaussianMultiPathGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GaussianMultiPathGenerator_next_f : c_obj list -> c_obj list = "_wrap_GaussianMultiPathGenerator_nextQuantLib" ;;
let _GaussianMultiPathGenerator_next arg = match _GaussianMultiPathGenerator_next_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GaussianMultiPathGenerator_antithetic_f : c_obj list -> c_obj list = "_wrap_GaussianMultiPathGenerator_antitheticQuantLib" ;;
let _GaussianMultiPathGenerator_antithetic arg = match _GaussianMultiPathGenerator_antithetic_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GaussianMultiPathGenerator_f : c_obj list -> c_obj list = "_wrap_delete_GaussianMultiPathGeneratorQuantLib" ;;
let _delete_GaussianMultiPathGenerator arg = match _delete_GaussianMultiPathGenerator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoundaryCondition___deref___f : c_obj list -> c_obj list = "_wrap_BoundaryCondition___deref__QuantLib" ;;
let _BoundaryCondition___deref__ arg = match _BoundaryCondition___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoundaryCondition_isNull_f : c_obj list -> c_obj list = "_wrap_BoundaryCondition_isNullQuantLib" ;;
let _BoundaryCondition_isNull arg = match _BoundaryCondition_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BoundaryCondition_NoSide : c_obj -> Swig.c_obj = "_wrap_BoundaryCondition_NoSide" 
external _BoundaryCondition_Upper : c_obj -> Swig.c_obj = "_wrap_BoundaryCondition_Upper" 
external _BoundaryCondition_Lower : c_obj -> Swig.c_obj = "_wrap_BoundaryCondition_Lower" 
external _new_BoundaryCondition_f : c_obj list -> c_obj list = "_wrap_new_BoundaryConditionQuantLib" ;;
let _new_BoundaryCondition arg = match _new_BoundaryCondition_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BoundaryCondition_f : c_obj list -> c_obj list = "_wrap_delete_BoundaryConditionQuantLib" ;;
let _delete_BoundaryCondition arg = match _delete_BoundaryCondition_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NeumannBC_f : c_obj list -> c_obj list = "_wrap_new_NeumannBCQuantLib" ;;
let _new_NeumannBC arg = match _new_NeumannBC_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NeumannBC_f : c_obj list -> c_obj list = "_wrap_delete_NeumannBCQuantLib" ;;
let _delete_NeumannBC arg = match _delete_NeumannBC_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DirichletBC_f : c_obj list -> c_obj list = "_wrap_new_DirichletBCQuantLib" ;;
let _new_DirichletBC arg = match _new_DirichletBC_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DirichletBC_f : c_obj list -> c_obj list = "_wrap_delete_DirichletBCQuantLib" ;;
let _delete_DirichletBC arg = match _delete_DirichletBC_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_TridiagonalOperator_f : c_obj list -> c_obj list = "_wrap_new_TridiagonalOperatorQuantLib" ;;
let _new_TridiagonalOperator arg = match _new_TridiagonalOperator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _TridiagonalOperator_solveFor_f : c_obj list -> c_obj list = "_wrap_TridiagonalOperator_solveForQuantLib" ;;
let _TridiagonalOperator_solveFor arg = match _TridiagonalOperator_solveFor_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _TridiagonalOperator_applyTo_f : c_obj list -> c_obj list = "_wrap_TridiagonalOperator_applyToQuantLib" ;;
let _TridiagonalOperator_applyTo arg = match _TridiagonalOperator_applyTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _TridiagonalOperator_size_f : c_obj list -> c_obj list = "_wrap_TridiagonalOperator_sizeQuantLib" ;;
let _TridiagonalOperator_size arg = match _TridiagonalOperator_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _TridiagonalOperator_setFirstRow_f : c_obj list -> c_obj list = "_wrap_TridiagonalOperator_setFirstRowQuantLib" ;;
let _TridiagonalOperator_setFirstRow arg = match _TridiagonalOperator_setFirstRow_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _TridiagonalOperator_setMidRow_f : c_obj list -> c_obj list = "_wrap_TridiagonalOperator_setMidRowQuantLib" ;;
let _TridiagonalOperator_setMidRow arg = match _TridiagonalOperator_setMidRow_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _TridiagonalOperator_setMidRows_f : c_obj list -> c_obj list = "_wrap_TridiagonalOperator_setMidRowsQuantLib" ;;
let _TridiagonalOperator_setMidRows arg = match _TridiagonalOperator_setMidRows_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _TridiagonalOperator_setLastRow_f : c_obj list -> c_obj list = "_wrap_TridiagonalOperator_setLastRowQuantLib" ;;
let _TridiagonalOperator_setLastRow arg = match _TridiagonalOperator_setLastRow_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _TridiagonalOperator_identity_f : c_obj list -> c_obj list = "_wrap_TridiagonalOperator_identityQuantLib" ;;
let _TridiagonalOperator_identity arg = match _TridiagonalOperator_identity_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_TridiagonalOperator_f : c_obj list -> c_obj list = "_wrap_delete_TridiagonalOperatorQuantLib" ;;
let _delete_TridiagonalOperator arg = match _delete_TridiagonalOperator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DPlus_f : c_obj list -> c_obj list = "_wrap_new_DPlusQuantLib" ;;
let _new_DPlus arg = match _new_DPlus_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DPlus_f : c_obj list -> c_obj list = "_wrap_delete_DPlusQuantLib" ;;
let _delete_DPlus arg = match _delete_DPlus_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DMinus_f : c_obj list -> c_obj list = "_wrap_new_DMinusQuantLib" ;;
let _new_DMinus arg = match _new_DMinus_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DMinus_f : c_obj list -> c_obj list = "_wrap_delete_DMinusQuantLib" ;;
let _delete_DMinus arg = match _delete_DMinus_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DZero_f : c_obj list -> c_obj list = "_wrap_new_DZeroQuantLib" ;;
let _new_DZero arg = match _new_DZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DZero_f : c_obj list -> c_obj list = "_wrap_delete_DZeroQuantLib" ;;
let _delete_DZero arg = match _delete_DZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_DPlusDMinus_f : c_obj list -> c_obj list = "_wrap_new_DPlusDMinusQuantLib" ;;
let _new_DPlusDMinus arg = match _new_DPlusDMinus_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_DPlusDMinus_f : c_obj list -> c_obj list = "_wrap_delete_DPlusDMinusQuantLib" ;;
let _delete_DPlusDMinus arg = match _delete_DPlusDMinus_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Discount_f : c_obj list -> c_obj list = "_wrap_new_DiscountQuantLib" ;;
let _new_Discount arg = match _new_Discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Discount_f : c_obj list -> c_obj list = "_wrap_delete_DiscountQuantLib" ;;
let _delete_Discount arg = match _delete_Discount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroYield_f : c_obj list -> c_obj list = "_wrap_new_ZeroYieldQuantLib" ;;
let _new_ZeroYield arg = match _new_ZeroYield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZeroYield_f : c_obj list -> c_obj list = "_wrap_delete_ZeroYieldQuantLib" ;;
let _delete_ZeroYield arg = match _delete_ZeroYield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardRate_f : c_obj list -> c_obj list = "_wrap_new_ForwardRateQuantLib" ;;
let _new_ForwardRate arg = match _new_ForwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ForwardRate_f : c_obj list -> c_obj list = "_wrap_delete_ForwardRateQuantLib" ;;
let _delete_ForwardRate arg = match _delete_ForwardRate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatForward__SWIG_0QuantLib" ;;
let _new_PiecewiseFlatForward arg = match _new_PiecewiseFlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatForward__SWIG_1QuantLib" ;;
let _new_PiecewiseFlatForward arg = match _new_PiecewiseFlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatForward__SWIG_2QuantLib" ;;
let _new_PiecewiseFlatForward arg = match _new_PiecewiseFlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatForward__SWIG_3QuantLib" ;;
let _new_PiecewiseFlatForward arg = match _new_PiecewiseFlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatForward__SWIG_4QuantLib" ;;
let _new_PiecewiseFlatForward arg = match _new_PiecewiseFlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatForward__SWIG_5QuantLib" ;;
let _new_PiecewiseFlatForward arg = match _new_PiecewiseFlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatForward__SWIG_6QuantLib" ;;
let _new_PiecewiseFlatForward arg = match _new_PiecewiseFlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatForward__SWIG_7QuantLib" ;;
let _new_PiecewiseFlatForward arg = match _new_PiecewiseFlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatForward__SWIG_8QuantLib" ;;
let _new_PiecewiseFlatForward arg = match _new_PiecewiseFlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseFlatForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseFlatForwardQuantLib" ;;
let _new_PiecewiseFlatForward arg = match _new_PiecewiseFlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseFlatForward_dates_f : c_obj list -> c_obj list = "_wrap_PiecewiseFlatForward_datesQuantLib" ;;
let _PiecewiseFlatForward_dates arg = match _PiecewiseFlatForward_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseFlatForward_times_f : c_obj list -> c_obj list = "_wrap_PiecewiseFlatForward_timesQuantLib" ;;
let _PiecewiseFlatForward_times arg = match _PiecewiseFlatForward_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseFlatForward_nodes_f : c_obj list -> c_obj list = "_wrap_PiecewiseFlatForward_nodesQuantLib" ;;
let _PiecewiseFlatForward_nodes arg = match _PiecewiseFlatForward_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PiecewiseFlatForward_f : c_obj list -> c_obj list = "_wrap_delete_PiecewiseFlatForwardQuantLib" ;;
let _delete_PiecewiseFlatForward arg = match _delete_PiecewiseFlatForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearForward__SWIG_0QuantLib" ;;
let _new_PiecewiseLinearForward arg = match _new_PiecewiseLinearForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearForward__SWIG_1QuantLib" ;;
let _new_PiecewiseLinearForward arg = match _new_PiecewiseLinearForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearForward__SWIG_2QuantLib" ;;
let _new_PiecewiseLinearForward arg = match _new_PiecewiseLinearForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearForward__SWIG_3QuantLib" ;;
let _new_PiecewiseLinearForward arg = match _new_PiecewiseLinearForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearForward__SWIG_4QuantLib" ;;
let _new_PiecewiseLinearForward arg = match _new_PiecewiseLinearForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearForward__SWIG_5QuantLib" ;;
let _new_PiecewiseLinearForward arg = match _new_PiecewiseLinearForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearForward__SWIG_6QuantLib" ;;
let _new_PiecewiseLinearForward arg = match _new_PiecewiseLinearForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearForward__SWIG_7QuantLib" ;;
let _new_PiecewiseLinearForward arg = match _new_PiecewiseLinearForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearForward__SWIG_8QuantLib" ;;
let _new_PiecewiseLinearForward arg = match _new_PiecewiseLinearForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearForward_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearForwardQuantLib" ;;
let _new_PiecewiseLinearForward arg = match _new_PiecewiseLinearForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseLinearForward_dates_f : c_obj list -> c_obj list = "_wrap_PiecewiseLinearForward_datesQuantLib" ;;
let _PiecewiseLinearForward_dates arg = match _PiecewiseLinearForward_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseLinearForward_times_f : c_obj list -> c_obj list = "_wrap_PiecewiseLinearForward_timesQuantLib" ;;
let _PiecewiseLinearForward_times arg = match _PiecewiseLinearForward_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseLinearForward_nodes_f : c_obj list -> c_obj list = "_wrap_PiecewiseLinearForward_nodesQuantLib" ;;
let _PiecewiseLinearForward_nodes arg = match _PiecewiseLinearForward_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PiecewiseLinearForward_f : c_obj list -> c_obj list = "_wrap_delete_PiecewiseLinearForwardQuantLib" ;;
let _delete_PiecewiseLinearForward arg = match _delete_PiecewiseLinearForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearZero__SWIG_0QuantLib" ;;
let _new_PiecewiseLinearZero arg = match _new_PiecewiseLinearZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearZero__SWIG_1QuantLib" ;;
let _new_PiecewiseLinearZero arg = match _new_PiecewiseLinearZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearZero__SWIG_2QuantLib" ;;
let _new_PiecewiseLinearZero arg = match _new_PiecewiseLinearZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearZero__SWIG_3QuantLib" ;;
let _new_PiecewiseLinearZero arg = match _new_PiecewiseLinearZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearZero__SWIG_4QuantLib" ;;
let _new_PiecewiseLinearZero arg = match _new_PiecewiseLinearZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearZero__SWIG_5QuantLib" ;;
let _new_PiecewiseLinearZero arg = match _new_PiecewiseLinearZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearZero__SWIG_6QuantLib" ;;
let _new_PiecewiseLinearZero arg = match _new_PiecewiseLinearZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearZero__SWIG_7QuantLib" ;;
let _new_PiecewiseLinearZero arg = match _new_PiecewiseLinearZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearZero__SWIG_8QuantLib" ;;
let _new_PiecewiseLinearZero arg = match _new_PiecewiseLinearZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLinearZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLinearZeroQuantLib" ;;
let _new_PiecewiseLinearZero arg = match _new_PiecewiseLinearZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseLinearZero_dates_f : c_obj list -> c_obj list = "_wrap_PiecewiseLinearZero_datesQuantLib" ;;
let _PiecewiseLinearZero_dates arg = match _PiecewiseLinearZero_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseLinearZero_times_f : c_obj list -> c_obj list = "_wrap_PiecewiseLinearZero_timesQuantLib" ;;
let _PiecewiseLinearZero_times arg = match _PiecewiseLinearZero_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseLinearZero_nodes_f : c_obj list -> c_obj list = "_wrap_PiecewiseLinearZero_nodesQuantLib" ;;
let _PiecewiseLinearZero_nodes arg = match _PiecewiseLinearZero_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PiecewiseLinearZero_f : c_obj list -> c_obj list = "_wrap_delete_PiecewiseLinearZeroQuantLib" ;;
let _delete_PiecewiseLinearZero arg = match _delete_PiecewiseLinearZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseCubicZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseCubicZero__SWIG_0QuantLib" ;;
let _new_PiecewiseCubicZero arg = match _new_PiecewiseCubicZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseCubicZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseCubicZero__SWIG_1QuantLib" ;;
let _new_PiecewiseCubicZero arg = match _new_PiecewiseCubicZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseCubicZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseCubicZero__SWIG_2QuantLib" ;;
let _new_PiecewiseCubicZero arg = match _new_PiecewiseCubicZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseCubicZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseCubicZero__SWIG_3QuantLib" ;;
let _new_PiecewiseCubicZero arg = match _new_PiecewiseCubicZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseCubicZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseCubicZero__SWIG_4QuantLib" ;;
let _new_PiecewiseCubicZero arg = match _new_PiecewiseCubicZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseCubicZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseCubicZero__SWIG_5QuantLib" ;;
let _new_PiecewiseCubicZero arg = match _new_PiecewiseCubicZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseCubicZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseCubicZero__SWIG_6QuantLib" ;;
let _new_PiecewiseCubicZero arg = match _new_PiecewiseCubicZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseCubicZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseCubicZero__SWIG_7QuantLib" ;;
let _new_PiecewiseCubicZero arg = match _new_PiecewiseCubicZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseCubicZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseCubicZero__SWIG_8QuantLib" ;;
let _new_PiecewiseCubicZero arg = match _new_PiecewiseCubicZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseCubicZero_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseCubicZeroQuantLib" ;;
let _new_PiecewiseCubicZero arg = match _new_PiecewiseCubicZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseCubicZero_dates_f : c_obj list -> c_obj list = "_wrap_PiecewiseCubicZero_datesQuantLib" ;;
let _PiecewiseCubicZero_dates arg = match _PiecewiseCubicZero_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseCubicZero_times_f : c_obj list -> c_obj list = "_wrap_PiecewiseCubicZero_timesQuantLib" ;;
let _PiecewiseCubicZero_times arg = match _PiecewiseCubicZero_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseCubicZero_nodes_f : c_obj list -> c_obj list = "_wrap_PiecewiseCubicZero_nodesQuantLib" ;;
let _PiecewiseCubicZero_nodes arg = match _PiecewiseCubicZero_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PiecewiseCubicZero_f : c_obj list -> c_obj list = "_wrap_delete_PiecewiseCubicZeroQuantLib" ;;
let _delete_PiecewiseCubicZero arg = match _delete_PiecewiseCubicZero_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLogCubicDiscount_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLogCubicDiscount__SWIG_0QuantLib" ;;
let _new_PiecewiseLogCubicDiscount arg = match _new_PiecewiseLogCubicDiscount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLogCubicDiscount_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLogCubicDiscount__SWIG_1QuantLib" ;;
let _new_PiecewiseLogCubicDiscount arg = match _new_PiecewiseLogCubicDiscount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLogCubicDiscount_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLogCubicDiscount__SWIG_2QuantLib" ;;
let _new_PiecewiseLogCubicDiscount arg = match _new_PiecewiseLogCubicDiscount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLogCubicDiscount_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLogCubicDiscount__SWIG_3QuantLib" ;;
let _new_PiecewiseLogCubicDiscount arg = match _new_PiecewiseLogCubicDiscount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLogCubicDiscount_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLogCubicDiscount__SWIG_4QuantLib" ;;
let _new_PiecewiseLogCubicDiscount arg = match _new_PiecewiseLogCubicDiscount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLogCubicDiscount_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLogCubicDiscount__SWIG_5QuantLib" ;;
let _new_PiecewiseLogCubicDiscount arg = match _new_PiecewiseLogCubicDiscount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLogCubicDiscount_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLogCubicDiscount__SWIG_6QuantLib" ;;
let _new_PiecewiseLogCubicDiscount arg = match _new_PiecewiseLogCubicDiscount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLogCubicDiscount_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLogCubicDiscount__SWIG_7QuantLib" ;;
let _new_PiecewiseLogCubicDiscount arg = match _new_PiecewiseLogCubicDiscount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLogCubicDiscount_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLogCubicDiscount__SWIG_8QuantLib" ;;
let _new_PiecewiseLogCubicDiscount arg = match _new_PiecewiseLogCubicDiscount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_PiecewiseLogCubicDiscount_f : c_obj list -> c_obj list = "_wrap_new_PiecewiseLogCubicDiscountQuantLib" ;;
let _new_PiecewiseLogCubicDiscount arg = match _new_PiecewiseLogCubicDiscount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseLogCubicDiscount_dates_f : c_obj list -> c_obj list = "_wrap_PiecewiseLogCubicDiscount_datesQuantLib" ;;
let _PiecewiseLogCubicDiscount_dates arg = match _PiecewiseLogCubicDiscount_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseLogCubicDiscount_times_f : c_obj list -> c_obj list = "_wrap_PiecewiseLogCubicDiscount_timesQuantLib" ;;
let _PiecewiseLogCubicDiscount_times arg = match _PiecewiseLogCubicDiscount_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _PiecewiseLogCubicDiscount_nodes_f : c_obj list -> c_obj list = "_wrap_PiecewiseLogCubicDiscount_nodesQuantLib" ;;
let _PiecewiseLogCubicDiscount_nodes arg = match _PiecewiseLogCubicDiscount_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_PiecewiseLogCubicDiscount_f : c_obj list -> c_obj list = "_wrap_delete_PiecewiseLogCubicDiscountQuantLib" ;;
let _delete_PiecewiseLogCubicDiscount arg = match _delete_PiecewiseLogCubicDiscount_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SampledCurve_f : c_obj list -> c_obj list = "_wrap_new_SampledCurve__SWIG_0QuantLib" ;;
let _new_SampledCurve arg = match _new_SampledCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SampledCurve_f : c_obj list -> c_obj list = "_wrap_new_SampledCurveQuantLib" ;;
let _new_SampledCurve arg = match _new_SampledCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_grid_f : c_obj list -> c_obj list = "_wrap_SampledCurve_gridQuantLib" ;;
let _SampledCurve_grid arg = match _SampledCurve_grid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_values_f : c_obj list -> c_obj list = "_wrap_SampledCurve_valuesQuantLib" ;;
let _SampledCurve_values arg = match _SampledCurve_values_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_gridValue_f : c_obj list -> c_obj list = "_wrap_SampledCurve_gridValueQuantLib" ;;
let _SampledCurve_gridValue arg = match _SampledCurve_gridValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_value_f : c_obj list -> c_obj list = "_wrap_SampledCurve_valueQuantLib" ;;
let _SampledCurve_value arg = match _SampledCurve_value_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_size_f : c_obj list -> c_obj list = "_wrap_SampledCurve_sizeQuantLib" ;;
let _SampledCurve_size arg = match _SampledCurve_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_empty_f : c_obj list -> c_obj list = "_wrap_SampledCurve_emptyQuantLib" ;;
let _SampledCurve_empty arg = match _SampledCurve_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_setGrid_f : c_obj list -> c_obj list = "_wrap_SampledCurve_setGridQuantLib" ;;
let _SampledCurve_setGrid arg = match _SampledCurve_setGrid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_setValues_f : c_obj list -> c_obj list = "_wrap_SampledCurve_setValuesQuantLib" ;;
let _SampledCurve_setValues arg = match _SampledCurve_setValues_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_swap_f : c_obj list -> c_obj list = "_wrap_SampledCurve_swapQuantLib" ;;
let _SampledCurve_swap arg = match _SampledCurve_swap_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_setLogGrid_f : c_obj list -> c_obj list = "_wrap_SampledCurve_setLogGridQuantLib" ;;
let _SampledCurve_setLogGrid arg = match _SampledCurve_setLogGrid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_regridLogGrid_f : c_obj list -> c_obj list = "_wrap_SampledCurve_regridLogGridQuantLib" ;;
let _SampledCurve_regridLogGrid arg = match _SampledCurve_regridLogGrid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_shiftGrid_f : c_obj list -> c_obj list = "_wrap_SampledCurve_shiftGridQuantLib" ;;
let _SampledCurve_shiftGrid arg = match _SampledCurve_shiftGrid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_scaleGrid_f : c_obj list -> c_obj list = "_wrap_SampledCurve_scaleGridQuantLib" ;;
let _SampledCurve_scaleGrid arg = match _SampledCurve_scaleGrid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SampledCurve_regrid_f : c_obj list -> c_obj list = "_wrap_SampledCurve_regridQuantLib" ;;
let _SampledCurve_regrid arg = match _SampledCurve_regrid_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SampledCurve_f : c_obj list -> c_obj list = "_wrap_delete_SampledCurveQuantLib" ;;
let _delete_SampledCurve arg = match _delete_SampledCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Settings_instance_f : c_obj list -> c_obj list = "_wrap_Settings_instanceQuantLib" ;;
let _Settings_instance arg = match _Settings_instance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Settings_getEvaluationDate_f : c_obj list -> c_obj list = "_wrap_Settings_getEvaluationDateQuantLib" ;;
let _Settings_getEvaluationDate arg = match _Settings_getEvaluationDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Settings_setEvaluationDate_f : c_obj list -> c_obj list = "_wrap_Settings_setEvaluationDateQuantLib" ;;
let _Settings_setEvaluationDate arg = match _Settings_setEvaluationDate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Settings_includeReferenceDateEvents_f : c_obj list -> c_obj list = "_wrap_Settings_includeReferenceDateEventsQuantLib" ;;
let _Settings_includeReferenceDateEvents arg = match _Settings_includeReferenceDateEvents_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Settings_includeTodaysCashFlows_f : c_obj list -> c_obj list = "_wrap_Settings_includeTodaysCashFlowsQuantLib" ;;
let _Settings_includeTodaysCashFlows arg = match _Settings_includeTodaysCashFlows_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Settings_f : c_obj list -> c_obj list = "_wrap_delete_SettingsQuantLib" ;;
let _delete_Settings arg = match _delete_Settings_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_samples_f : c_obj list -> c_obj list = "_wrap_Statistics_samplesQuantLib" ;;
let _Statistics_samples arg = match _Statistics_samples_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_weightSum_f : c_obj list -> c_obj list = "_wrap_Statistics_weightSumQuantLib" ;;
let _Statistics_weightSum arg = match _Statistics_weightSum_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_mean_f : c_obj list -> c_obj list = "_wrap_Statistics_meanQuantLib" ;;
let _Statistics_mean arg = match _Statistics_mean_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_variance_f : c_obj list -> c_obj list = "_wrap_Statistics_varianceQuantLib" ;;
let _Statistics_variance arg = match _Statistics_variance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_standardDeviation_f : c_obj list -> c_obj list = "_wrap_Statistics_standardDeviationQuantLib" ;;
let _Statistics_standardDeviation arg = match _Statistics_standardDeviation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_errorEstimate_f : c_obj list -> c_obj list = "_wrap_Statistics_errorEstimateQuantLib" ;;
let _Statistics_errorEstimate arg = match _Statistics_errorEstimate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_skewness_f : c_obj list -> c_obj list = "_wrap_Statistics_skewnessQuantLib" ;;
let _Statistics_skewness arg = match _Statistics_skewness_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_kurtosis_f : c_obj list -> c_obj list = "_wrap_Statistics_kurtosisQuantLib" ;;
let _Statistics_kurtosis arg = match _Statistics_kurtosis_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_min_f : c_obj list -> c_obj list = "_wrap_Statistics_minQuantLib" ;;
let _Statistics_min arg = match _Statistics_min_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_max_f : c_obj list -> c_obj list = "_wrap_Statistics_maxQuantLib" ;;
let _Statistics_max arg = match _Statistics_max_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_reset_f : c_obj list -> c_obj list = "_wrap_Statistics_resetQuantLib" ;;
let _Statistics_reset arg = match _Statistics_reset_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_add_f : c_obj list -> c_obj list = "_wrap_Statistics_add__SWIG_0QuantLib" ;;
let _Statistics_add arg = match _Statistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_add_f : c_obj list -> c_obj list = "_wrap_Statistics_add__SWIG_1QuantLib" ;;
let _Statistics_add arg = match _Statistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_add_f : c_obj list -> c_obj list = "_wrap_Statistics_add__SWIG_2QuantLib" ;;
let _Statistics_add arg = match _Statistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Statistics_add_f : c_obj list -> c_obj list = "_wrap_Statistics_addQuantLib" ;;
let _Statistics_add arg = match _Statistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Statistics_f : c_obj list -> c_obj list = "_wrap_new_StatisticsQuantLib" ;;
let _new_Statistics arg = match _new_Statistics_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Statistics_f : c_obj list -> c_obj list = "_wrap_delete_StatisticsQuantLib" ;;
let _delete_Statistics arg = match _delete_Statistics_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_samples_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_samplesQuantLib" ;;
let _IncrementalStatistics_samples arg = match _IncrementalStatistics_samples_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_weightSum_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_weightSumQuantLib" ;;
let _IncrementalStatistics_weightSum arg = match _IncrementalStatistics_weightSum_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_mean_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_meanQuantLib" ;;
let _IncrementalStatistics_mean arg = match _IncrementalStatistics_mean_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_variance_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_varianceQuantLib" ;;
let _IncrementalStatistics_variance arg = match _IncrementalStatistics_variance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_standardDeviation_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_standardDeviationQuantLib" ;;
let _IncrementalStatistics_standardDeviation arg = match _IncrementalStatistics_standardDeviation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_errorEstimate_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_errorEstimateQuantLib" ;;
let _IncrementalStatistics_errorEstimate arg = match _IncrementalStatistics_errorEstimate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_skewness_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_skewnessQuantLib" ;;
let _IncrementalStatistics_skewness arg = match _IncrementalStatistics_skewness_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_kurtosis_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_kurtosisQuantLib" ;;
let _IncrementalStatistics_kurtosis arg = match _IncrementalStatistics_kurtosis_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_min_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_minQuantLib" ;;
let _IncrementalStatistics_min arg = match _IncrementalStatistics_min_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_max_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_maxQuantLib" ;;
let _IncrementalStatistics_max arg = match _IncrementalStatistics_max_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_reset_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_resetQuantLib" ;;
let _IncrementalStatistics_reset arg = match _IncrementalStatistics_reset_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_add_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_add__SWIG_0QuantLib" ;;
let _IncrementalStatistics_add arg = match _IncrementalStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_add_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_add__SWIG_1QuantLib" ;;
let _IncrementalStatistics_add arg = match _IncrementalStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_add_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_add__SWIG_2QuantLib" ;;
let _IncrementalStatistics_add arg = match _IncrementalStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _IncrementalStatistics_add_f : c_obj list -> c_obj list = "_wrap_IncrementalStatistics_addQuantLib" ;;
let _IncrementalStatistics_add arg = match _IncrementalStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_IncrementalStatistics_f : c_obj list -> c_obj list = "_wrap_new_IncrementalStatisticsQuantLib" ;;
let _new_IncrementalStatistics arg = match _new_IncrementalStatistics_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_IncrementalStatistics_f : c_obj list -> c_obj list = "_wrap_delete_IncrementalStatisticsQuantLib" ;;
let _delete_IncrementalStatistics arg = match _delete_IncrementalStatistics_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RiskStatistics_semiVariance_f : c_obj list -> c_obj list = "_wrap_RiskStatistics_semiVarianceQuantLib" ;;
let _RiskStatistics_semiVariance arg = match _RiskStatistics_semiVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RiskStatistics_semiDeviation_f : c_obj list -> c_obj list = "_wrap_RiskStatistics_semiDeviationQuantLib" ;;
let _RiskStatistics_semiDeviation arg = match _RiskStatistics_semiDeviation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RiskStatistics_downsideVariance_f : c_obj list -> c_obj list = "_wrap_RiskStatistics_downsideVarianceQuantLib" ;;
let _RiskStatistics_downsideVariance arg = match _RiskStatistics_downsideVariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RiskStatistics_downsideDeviation_f : c_obj list -> c_obj list = "_wrap_RiskStatistics_downsideDeviationQuantLib" ;;
let _RiskStatistics_downsideDeviation arg = match _RiskStatistics_downsideDeviation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RiskStatistics_regret_f : c_obj list -> c_obj list = "_wrap_RiskStatistics_regretQuantLib" ;;
let _RiskStatistics_regret arg = match _RiskStatistics_regret_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RiskStatistics_potentialUpside_f : c_obj list -> c_obj list = "_wrap_RiskStatistics_potentialUpsideQuantLib" ;;
let _RiskStatistics_potentialUpside arg = match _RiskStatistics_potentialUpside_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RiskStatistics_valueAtRisk_f : c_obj list -> c_obj list = "_wrap_RiskStatistics_valueAtRiskQuantLib" ;;
let _RiskStatistics_valueAtRisk arg = match _RiskStatistics_valueAtRisk_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RiskStatistics_expectedShortfall_f : c_obj list -> c_obj list = "_wrap_RiskStatistics_expectedShortfallQuantLib" ;;
let _RiskStatistics_expectedShortfall arg = match _RiskStatistics_expectedShortfall_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RiskStatistics_shortfall_f : c_obj list -> c_obj list = "_wrap_RiskStatistics_shortfallQuantLib" ;;
let _RiskStatistics_shortfall arg = match _RiskStatistics_shortfall_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RiskStatistics_averageShortfall_f : c_obj list -> c_obj list = "_wrap_RiskStatistics_averageShortfallQuantLib" ;;
let _RiskStatistics_averageShortfall arg = match _RiskStatistics_averageShortfall_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RiskStatistics_f : c_obj list -> c_obj list = "_wrap_new_RiskStatisticsQuantLib" ;;
let _new_RiskStatistics arg = match _new_RiskStatistics_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RiskStatistics_f : c_obj list -> c_obj list = "_wrap_delete_RiskStatisticsQuantLib" ;;
let _delete_RiskStatistics arg = match _delete_RiskStatistics_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MultipleStatistics_f : c_obj list -> c_obj list = "_wrap_new_MultipleStatisticsQuantLib" ;;
let _new_MultipleStatistics arg = match _new_MultipleStatistics_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_size_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_sizeQuantLib" ;;
let _MultipleStatistics_size arg = match _MultipleStatistics_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_samples_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_samplesQuantLib" ;;
let _MultipleStatistics_samples arg = match _MultipleStatistics_samples_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_weightSum_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_weightSumQuantLib" ;;
let _MultipleStatistics_weightSum arg = match _MultipleStatistics_weightSum_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_mean_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_meanQuantLib" ;;
let _MultipleStatistics_mean arg = match _MultipleStatistics_mean_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_variance_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_varianceQuantLib" ;;
let _MultipleStatistics_variance arg = match _MultipleStatistics_variance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_standardDeviation_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_standardDeviationQuantLib" ;;
let _MultipleStatistics_standardDeviation arg = match _MultipleStatistics_standardDeviation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_errorEstimate_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_errorEstimateQuantLib" ;;
let _MultipleStatistics_errorEstimate arg = match _MultipleStatistics_errorEstimate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_skewness_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_skewnessQuantLib" ;;
let _MultipleStatistics_skewness arg = match _MultipleStatistics_skewness_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_kurtosis_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_kurtosisQuantLib" ;;
let _MultipleStatistics_kurtosis arg = match _MultipleStatistics_kurtosis_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_min_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_minQuantLib" ;;
let _MultipleStatistics_min arg = match _MultipleStatistics_min_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_max_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_maxQuantLib" ;;
let _MultipleStatistics_max arg = match _MultipleStatistics_max_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_covariance_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_covarianceQuantLib" ;;
let _MultipleStatistics_covariance arg = match _MultipleStatistics_covariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_correlation_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_correlationQuantLib" ;;
let _MultipleStatistics_correlation arg = match _MultipleStatistics_correlation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_reset_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_resetQuantLib" ;;
let _MultipleStatistics_reset arg = match _MultipleStatistics_reset_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_add_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_add__SWIG_0QuantLib" ;;
let _MultipleStatistics_add arg = match _MultipleStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_add_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_add__SWIG_1QuantLib" ;;
let _MultipleStatistics_add arg = match _MultipleStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_add_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_add__SWIG_2QuantLib" ;;
let _MultipleStatistics_add arg = match _MultipleStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleStatistics_add_f : c_obj list -> c_obj list = "_wrap_MultipleStatistics_addQuantLib" ;;
let _MultipleStatistics_add arg = match _MultipleStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MultipleStatistics_f : c_obj list -> c_obj list = "_wrap_delete_MultipleStatisticsQuantLib" ;;
let _delete_MultipleStatistics arg = match _delete_MultipleStatistics_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_SequenceStatistics_f : c_obj list -> c_obj list = "_wrap_new_SequenceStatisticsQuantLib" ;;
let _new_SequenceStatistics arg = match _new_SequenceStatistics_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_size_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_sizeQuantLib" ;;
let _SequenceStatistics_size arg = match _SequenceStatistics_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_samples_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_samplesQuantLib" ;;
let _SequenceStatistics_samples arg = match _SequenceStatistics_samples_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_weightSum_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_weightSumQuantLib" ;;
let _SequenceStatistics_weightSum arg = match _SequenceStatistics_weightSum_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_mean_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_meanQuantLib" ;;
let _SequenceStatistics_mean arg = match _SequenceStatistics_mean_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_variance_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_varianceQuantLib" ;;
let _SequenceStatistics_variance arg = match _SequenceStatistics_variance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_standardDeviation_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_standardDeviationQuantLib" ;;
let _SequenceStatistics_standardDeviation arg = match _SequenceStatistics_standardDeviation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_errorEstimate_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_errorEstimateQuantLib" ;;
let _SequenceStatistics_errorEstimate arg = match _SequenceStatistics_errorEstimate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_skewness_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_skewnessQuantLib" ;;
let _SequenceStatistics_skewness arg = match _SequenceStatistics_skewness_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_kurtosis_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_kurtosisQuantLib" ;;
let _SequenceStatistics_kurtosis arg = match _SequenceStatistics_kurtosis_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_min_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_minQuantLib" ;;
let _SequenceStatistics_min arg = match _SequenceStatistics_min_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_max_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_maxQuantLib" ;;
let _SequenceStatistics_max arg = match _SequenceStatistics_max_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_covariance_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_covarianceQuantLib" ;;
let _SequenceStatistics_covariance arg = match _SequenceStatistics_covariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_correlation_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_correlationQuantLib" ;;
let _SequenceStatistics_correlation arg = match _SequenceStatistics_correlation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_reset_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_resetQuantLib" ;;
let _SequenceStatistics_reset arg = match _SequenceStatistics_reset_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_add_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_add__SWIG_0QuantLib" ;;
let _SequenceStatistics_add arg = match _SequenceStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_add_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_add__SWIG_1QuantLib" ;;
let _SequenceStatistics_add arg = match _SequenceStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_add_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_add__SWIG_2QuantLib" ;;
let _SequenceStatistics_add arg = match _SequenceStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _SequenceStatistics_add_f : c_obj list -> c_obj list = "_wrap_SequenceStatistics_addQuantLib" ;;
let _SequenceStatistics_add arg = match _SequenceStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_SequenceStatistics_f : c_obj list -> c_obj list = "_wrap_delete_SequenceStatisticsQuantLib" ;;
let _delete_SequenceStatistics arg = match _delete_SequenceStatistics_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MultipleIncrementalStatistics_f : c_obj list -> c_obj list = "_wrap_new_MultipleIncrementalStatisticsQuantLib" ;;
let _new_MultipleIncrementalStatistics arg = match _new_MultipleIncrementalStatistics_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_size_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_sizeQuantLib" ;;
let _MultipleIncrementalStatistics_size arg = match _MultipleIncrementalStatistics_size_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_samples_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_samplesQuantLib" ;;
let _MultipleIncrementalStatistics_samples arg = match _MultipleIncrementalStatistics_samples_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_weightSum_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_weightSumQuantLib" ;;
let _MultipleIncrementalStatistics_weightSum arg = match _MultipleIncrementalStatistics_weightSum_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_mean_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_meanQuantLib" ;;
let _MultipleIncrementalStatistics_mean arg = match _MultipleIncrementalStatistics_mean_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_variance_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_varianceQuantLib" ;;
let _MultipleIncrementalStatistics_variance arg = match _MultipleIncrementalStatistics_variance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_standardDeviation_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_standardDeviationQuantLib" ;;
let _MultipleIncrementalStatistics_standardDeviation arg = match _MultipleIncrementalStatistics_standardDeviation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_errorEstimate_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_errorEstimateQuantLib" ;;
let _MultipleIncrementalStatistics_errorEstimate arg = match _MultipleIncrementalStatistics_errorEstimate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_skewness_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_skewnessQuantLib" ;;
let _MultipleIncrementalStatistics_skewness arg = match _MultipleIncrementalStatistics_skewness_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_kurtosis_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_kurtosisQuantLib" ;;
let _MultipleIncrementalStatistics_kurtosis arg = match _MultipleIncrementalStatistics_kurtosis_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_min_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_minQuantLib" ;;
let _MultipleIncrementalStatistics_min arg = match _MultipleIncrementalStatistics_min_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_max_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_maxQuantLib" ;;
let _MultipleIncrementalStatistics_max arg = match _MultipleIncrementalStatistics_max_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_covariance_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_covarianceQuantLib" ;;
let _MultipleIncrementalStatistics_covariance arg = match _MultipleIncrementalStatistics_covariance_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_correlation_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_correlationQuantLib" ;;
let _MultipleIncrementalStatistics_correlation arg = match _MultipleIncrementalStatistics_correlation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_reset_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_resetQuantLib" ;;
let _MultipleIncrementalStatistics_reset arg = match _MultipleIncrementalStatistics_reset_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_add_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_add__SWIG_0QuantLib" ;;
let _MultipleIncrementalStatistics_add arg = match _MultipleIncrementalStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_add_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_add__SWIG_1QuantLib" ;;
let _MultipleIncrementalStatistics_add arg = match _MultipleIncrementalStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_add_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_add__SWIG_2QuantLib" ;;
let _MultipleIncrementalStatistics_add arg = match _MultipleIncrementalStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MultipleIncrementalStatistics_add_f : c_obj list -> c_obj list = "_wrap_MultipleIncrementalStatistics_addQuantLib" ;;
let _MultipleIncrementalStatistics_add arg = match _MultipleIncrementalStatistics_add_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MultipleIncrementalStatistics_f : c_obj list -> c_obj list = "_wrap_delete_MultipleIncrementalStatisticsQuantLib" ;;
let _delete_MultipleIncrementalStatistics arg = match _delete_MultipleIncrementalStatistics_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructure___deref___f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructure___deref__QuantLib" ;;
let _CapFloorTermVolatilityStructure___deref__ arg = match _CapFloorTermVolatilityStructure___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructure_isNull_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructure_isNullQuantLib" ;;
let _CapFloorTermVolatilityStructure_isNull arg = match _CapFloorTermVolatilityStructure_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructure_asObservable_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructure_asObservableQuantLib" ;;
let _CapFloorTermVolatilityStructure_asObservable arg = match _CapFloorTermVolatilityStructure_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolatilityStructure_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolatilityStructureQuantLib" ;;
let _new_CapFloorTermVolatilityStructure arg = match _new_CapFloorTermVolatilityStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CapFloorTermVolatilityStructure_f : c_obj list -> c_obj list = "_wrap_delete_CapFloorTermVolatilityStructureQuantLib" ;;
let _delete_CapFloorTermVolatilityStructure arg = match _delete_CapFloorTermVolatilityStructure_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructure_volatility__SWIG_0QuantLib" ;;
let _CapFloorTermVolatilityStructure_volatility arg = match _CapFloorTermVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructure_volatility__SWIG_1QuantLib" ;;
let _CapFloorTermVolatilityStructure_volatility arg = match _CapFloorTermVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructure_volatility__SWIG_2QuantLib" ;;
let _CapFloorTermVolatilityStructure_volatility arg = match _CapFloorTermVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructure_volatility__SWIG_3QuantLib" ;;
let _CapFloorTermVolatilityStructure_volatility arg = match _CapFloorTermVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructure_volatility__SWIG_4QuantLib" ;;
let _CapFloorTermVolatilityStructure_volatility arg = match _CapFloorTermVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructure_volatility_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructure_volatilityQuantLib" ;;
let _CapFloorTermVolatilityStructure_volatility arg = match _CapFloorTermVolatilityStructure_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructure_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructure_enableExtrapolationQuantLib" ;;
let _CapFloorTermVolatilityStructure_enableExtrapolation arg = match _CapFloorTermVolatilityStructure_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructure_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructure_disableExtrapolationQuantLib" ;;
let _CapFloorTermVolatilityStructure_disableExtrapolation arg = match _CapFloorTermVolatilityStructure_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructure_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructure_allowsExtrapolationQuantLib" ;;
let _CapFloorTermVolatilityStructure_allowsExtrapolation arg = match _CapFloorTermVolatilityStructure_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolatilityStructureHandle__SWIG_0QuantLib" ;;
let _new_CapFloorTermVolatilityStructureHandle arg = match _new_CapFloorTermVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolatilityStructureHandleQuantLib" ;;
let _new_CapFloorTermVolatilityStructureHandle arg = match _new_CapFloorTermVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructureHandle___deref___f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructureHandle___deref__QuantLib" ;;
let _CapFloorTermVolatilityStructureHandle___deref__ arg = match _CapFloorTermVolatilityStructureHandle___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructureHandle_empty_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructureHandle_emptyQuantLib" ;;
let _CapFloorTermVolatilityStructureHandle_empty arg = match _CapFloorTermVolatilityStructureHandle_empty_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructureHandle_asObservable_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructureHandle_asObservableQuantLib" ;;
let _CapFloorTermVolatilityStructureHandle_asObservable arg = match _CapFloorTermVolatilityStructureHandle_asObservable_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CapFloorTermVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_CapFloorTermVolatilityStructureHandleQuantLib" ;;
let _delete_CapFloorTermVolatilityStructureHandle arg = match _delete_CapFloorTermVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructureHandle_volatility__SWIG_0QuantLib" ;;
let _CapFloorTermVolatilityStructureHandle_volatility arg = match _CapFloorTermVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructureHandle_volatility__SWIG_1QuantLib" ;;
let _CapFloorTermVolatilityStructureHandle_volatility arg = match _CapFloorTermVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructureHandle_volatility__SWIG_2QuantLib" ;;
let _CapFloorTermVolatilityStructureHandle_volatility arg = match _CapFloorTermVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructureHandle_volatility__SWIG_3QuantLib" ;;
let _CapFloorTermVolatilityStructureHandle_volatility arg = match _CapFloorTermVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructureHandle_volatility__SWIG_4QuantLib" ;;
let _CapFloorTermVolatilityStructureHandle_volatility arg = match _CapFloorTermVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructureHandle_volatility_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructureHandle_volatilityQuantLib" ;;
let _CapFloorTermVolatilityStructureHandle_volatility arg = match _CapFloorTermVolatilityStructureHandle_volatility_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructureHandle_enableExtrapolation_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructureHandle_enableExtrapolationQuantLib" ;;
let _CapFloorTermVolatilityStructureHandle_enableExtrapolation arg = match _CapFloorTermVolatilityStructureHandle_enableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructureHandle_disableExtrapolation_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructureHandle_disableExtrapolationQuantLib" ;;
let _CapFloorTermVolatilityStructureHandle_disableExtrapolation arg = match _CapFloorTermVolatilityStructureHandle_disableExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CapFloorTermVolatilityStructureHandle_allowsExtrapolation_f : c_obj list -> c_obj list = "_wrap_CapFloorTermVolatilityStructureHandle_allowsExtrapolationQuantLib" ;;
let _CapFloorTermVolatilityStructureHandle_allowsExtrapolation arg = match _CapFloorTermVolatilityStructureHandle_allowsExtrapolation_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableCapFloorTermVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableCapFloorTermVolatilityStructureHandle__SWIG_0QuantLib" ;;
let _new_RelinkableCapFloorTermVolatilityStructureHandle arg = match _new_RelinkableCapFloorTermVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_RelinkableCapFloorTermVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_new_RelinkableCapFloorTermVolatilityStructureHandleQuantLib" ;;
let _new_RelinkableCapFloorTermVolatilityStructureHandle arg = match _new_RelinkableCapFloorTermVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _RelinkableCapFloorTermVolatilityStructureHandle_linkTo_f : c_obj list -> c_obj list = "_wrap_RelinkableCapFloorTermVolatilityStructureHandle_linkToQuantLib" ;;
let _RelinkableCapFloorTermVolatilityStructureHandle_linkTo arg = match _RelinkableCapFloorTermVolatilityStructureHandle_linkTo_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_RelinkableCapFloorTermVolatilityStructureHandle_f : c_obj list -> c_obj list = "_wrap_delete_RelinkableCapFloorTermVolatilityStructureHandleQuantLib" ;;
let _delete_RelinkableCapFloorTermVolatilityStructureHandle arg = match _delete_RelinkableCapFloorTermVolatilityStructureHandle_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolCurve_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolCurve__SWIG_0QuantLib" ;;
let _new_CapFloorTermVolCurve arg = match _new_CapFloorTermVolCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolCurve_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolCurve__SWIG_1QuantLib" ;;
let _new_CapFloorTermVolCurve arg = match _new_CapFloorTermVolCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolCurve_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolCurve__SWIG_2QuantLib" ;;
let _new_CapFloorTermVolCurve arg = match _new_CapFloorTermVolCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolCurve_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolCurveQuantLib" ;;
let _new_CapFloorTermVolCurve arg = match _new_CapFloorTermVolCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CapFloorTermVolCurve_f : c_obj list -> c_obj list = "_wrap_delete_CapFloorTermVolCurveQuantLib" ;;
let _delete_CapFloorTermVolCurve arg = match _delete_CapFloorTermVolCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolSurface_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolSurface__SWIG_0QuantLib" ;;
let _new_CapFloorTermVolSurface arg = match _new_CapFloorTermVolSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolSurface_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolSurface__SWIG_1QuantLib" ;;
let _new_CapFloorTermVolSurface arg = match _new_CapFloorTermVolSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolSurface_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolSurface__SWIG_2QuantLib" ;;
let _new_CapFloorTermVolSurface arg = match _new_CapFloorTermVolSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolSurface_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolSurface__SWIG_3QuantLib" ;;
let _new_CapFloorTermVolSurface arg = match _new_CapFloorTermVolSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolSurface_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolSurface__SWIG_4QuantLib" ;;
let _new_CapFloorTermVolSurface arg = match _new_CapFloorTermVolSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolSurface_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolSurface__SWIG_5QuantLib" ;;
let _new_CapFloorTermVolSurface arg = match _new_CapFloorTermVolSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolSurface_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolSurface__SWIG_6QuantLib" ;;
let _new_CapFloorTermVolSurface arg = match _new_CapFloorTermVolSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CapFloorTermVolSurface_f : c_obj list -> c_obj list = "_wrap_new_CapFloorTermVolSurfaceQuantLib" ;;
let _new_CapFloorTermVolSurface arg = match _new_CapFloorTermVolSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CapFloorTermVolSurface_f : c_obj list -> c_obj list = "_wrap_delete_CapFloorTermVolSurfaceQuantLib" ;;
let _delete_CapFloorTermVolSurface arg = match _delete_CapFloorTermVolSurface_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrippedOptionletBase___deref___f : c_obj list -> c_obj list = "_wrap_StrippedOptionletBase___deref__QuantLib" ;;
let _StrippedOptionletBase___deref__ arg = match _StrippedOptionletBase___deref___f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrippedOptionletBase_isNull_f : c_obj list -> c_obj list = "_wrap_StrippedOptionletBase_isNullQuantLib" ;;
let _StrippedOptionletBase_isNull arg = match _StrippedOptionletBase_isNull_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StrippedOptionletBase_f : c_obj list -> c_obj list = "_wrap_new_StrippedOptionletBaseQuantLib" ;;
let _new_StrippedOptionletBase arg = match _new_StrippedOptionletBase_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_StrippedOptionletBase_f : c_obj list -> c_obj list = "_wrap_delete_StrippedOptionletBaseQuantLib" ;;
let _delete_StrippedOptionletBase arg = match _delete_StrippedOptionletBase_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrippedOptionletBase_optionletStrikes_f : c_obj list -> c_obj list = "_wrap_StrippedOptionletBase_optionletStrikesQuantLib" ;;
let _StrippedOptionletBase_optionletStrikes arg = match _StrippedOptionletBase_optionletStrikes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrippedOptionletBase_optionletVolatilities_f : c_obj list -> c_obj list = "_wrap_StrippedOptionletBase_optionletVolatilitiesQuantLib" ;;
let _StrippedOptionletBase_optionletVolatilities arg = match _StrippedOptionletBase_optionletVolatilities_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrippedOptionletBase_optionletFixingDates_f : c_obj list -> c_obj list = "_wrap_StrippedOptionletBase_optionletFixingDatesQuantLib" ;;
let _StrippedOptionletBase_optionletFixingDates arg = match _StrippedOptionletBase_optionletFixingDates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrippedOptionletBase_optionletFixingTimes_f : c_obj list -> c_obj list = "_wrap_StrippedOptionletBase_optionletFixingTimesQuantLib" ;;
let _StrippedOptionletBase_optionletFixingTimes arg = match _StrippedOptionletBase_optionletFixingTimes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrippedOptionletBase_optionletMaturities_f : c_obj list -> c_obj list = "_wrap_StrippedOptionletBase_optionletMaturitiesQuantLib" ;;
let _StrippedOptionletBase_optionletMaturities arg = match _StrippedOptionletBase_optionletMaturities_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrippedOptionletBase_atmOptionletRates_f : c_obj list -> c_obj list = "_wrap_StrippedOptionletBase_atmOptionletRatesQuantLib" ;;
let _StrippedOptionletBase_atmOptionletRates arg = match _StrippedOptionletBase_atmOptionletRates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrippedOptionletBase_dayCounter_f : c_obj list -> c_obj list = "_wrap_StrippedOptionletBase_dayCounterQuantLib" ;;
let _StrippedOptionletBase_dayCounter arg = match _StrippedOptionletBase_dayCounter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrippedOptionletBase_calendar_f : c_obj list -> c_obj list = "_wrap_StrippedOptionletBase_calendarQuantLib" ;;
let _StrippedOptionletBase_calendar arg = match _StrippedOptionletBase_calendar_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrippedOptionletBase_settlementDays_f : c_obj list -> c_obj list = "_wrap_StrippedOptionletBase_settlementDaysQuantLib" ;;
let _StrippedOptionletBase_settlementDays arg = match _StrippedOptionletBase_settlementDays_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _StrippedOptionletBase_businessDayConvention_f : c_obj list -> c_obj list = "_wrap_StrippedOptionletBase_businessDayConventionQuantLib" ;;
let _StrippedOptionletBase_businessDayConvention arg = match _StrippedOptionletBase_businessDayConvention_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OptionletStripper1_f : c_obj list -> c_obj list = "_wrap_new_OptionletStripper1__SWIG_0QuantLib" ;;
let _new_OptionletStripper1 arg = match _new_OptionletStripper1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OptionletStripper1_f : c_obj list -> c_obj list = "_wrap_new_OptionletStripper1__SWIG_1QuantLib" ;;
let _new_OptionletStripper1 arg = match _new_OptionletStripper1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OptionletStripper1_f : c_obj list -> c_obj list = "_wrap_new_OptionletStripper1__SWIG_2QuantLib" ;;
let _new_OptionletStripper1 arg = match _new_OptionletStripper1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OptionletStripper1_f : c_obj list -> c_obj list = "_wrap_new_OptionletStripper1__SWIG_3QuantLib" ;;
let _new_OptionletStripper1 arg = match _new_OptionletStripper1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OptionletStripper1_f : c_obj list -> c_obj list = "_wrap_new_OptionletStripper1__SWIG_4QuantLib" ;;
let _new_OptionletStripper1 arg = match _new_OptionletStripper1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OptionletStripper1_f : c_obj list -> c_obj list = "_wrap_new_OptionletStripper1__SWIG_5QuantLib" ;;
let _new_OptionletStripper1 arg = match _new_OptionletStripper1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OptionletStripper1_f : c_obj list -> c_obj list = "_wrap_new_OptionletStripper1__SWIG_6QuantLib" ;;
let _new_OptionletStripper1 arg = match _new_OptionletStripper1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_OptionletStripper1_f : c_obj list -> c_obj list = "_wrap_new_OptionletStripper1QuantLib" ;;
let _new_OptionletStripper1 arg = match _new_OptionletStripper1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletStripper1_capFloorPrices_f : c_obj list -> c_obj list = "_wrap_OptionletStripper1_capFloorPricesQuantLib" ;;
let _OptionletStripper1_capFloorPrices arg = match _OptionletStripper1_capFloorPrices_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletStripper1_capFloorVolatilities_f : c_obj list -> c_obj list = "_wrap_OptionletStripper1_capFloorVolatilitiesQuantLib" ;;
let _OptionletStripper1_capFloorVolatilities arg = match _OptionletStripper1_capFloorVolatilities_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletStripper1_optionletPrices_f : c_obj list -> c_obj list = "_wrap_OptionletStripper1_optionletPricesQuantLib" ;;
let _OptionletStripper1_optionletPrices arg = match _OptionletStripper1_optionletPrices_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _OptionletStripper1_switchStrike_f : c_obj list -> c_obj list = "_wrap_OptionletStripper1_switchStrikeQuantLib" ;;
let _OptionletStripper1_switchStrike arg = match _OptionletStripper1_switchStrike_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_OptionletStripper1_f : c_obj list -> c_obj list = "_wrap_delete_OptionletStripper1QuantLib" ;;
let _delete_OptionletStripper1 arg = match _delete_OptionletStripper1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_StrippedOptionletAdapter_f : c_obj list -> c_obj list = "_wrap_new_StrippedOptionletAdapterQuantLib" ;;
let _new_StrippedOptionletAdapter arg = match _new_StrippedOptionletAdapter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_StrippedOptionletAdapter_f : c_obj list -> c_obj list = "_wrap_delete_StrippedOptionletAdapterQuantLib" ;;
let _delete_StrippedOptionletAdapter arg = match _delete_StrippedOptionletAdapter_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
let _ = Callback.register "Settlement::Type_marker" (`Type)
external _Physical : c_obj -> Swig.c_obj = "_wrap_Physical" 
external _Cash : c_obj -> Swig.c_obj = "_wrap_Cash" 
external _new_Settlement_f : c_obj list -> c_obj list = "_wrap_new_SettlementQuantLib" ;;
let _new_Settlement arg = match _new_Settlement_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Settlement_f : c_obj list -> c_obj list = "_wrap_delete_SettlementQuantLib" ;;
let _delete_Settlement arg = match _delete_Settlement_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Swaption_f : c_obj list -> c_obj list = "_wrap_new_Swaption__SWIG_0QuantLib" ;;
let _new_Swaption arg = match _new_Swaption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Swaption_f : c_obj list -> c_obj list = "_wrap_new_SwaptionQuantLib" ;;
let _new_Swaption arg = match _new_Swaption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Swaption_f : c_obj list -> c_obj list = "_wrap_delete_SwaptionQuantLib" ;;
let _delete_Swaption arg = match _delete_Swaption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NonstandardSwaption_f : c_obj list -> c_obj list = "_wrap_new_NonstandardSwaption__SWIG_0QuantLib" ;;
let _new_NonstandardSwaption arg = match _new_NonstandardSwaption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_NonstandardSwaption_f : c_obj list -> c_obj list = "_wrap_new_NonstandardSwaptionQuantLib" ;;
let _new_NonstandardSwaption arg = match _new_NonstandardSwaption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _NonstandardSwaption_calibrationBasket_f : c_obj list -> c_obj list = "_wrap_NonstandardSwaption_calibrationBasketQuantLib" ;;
let _NonstandardSwaption_calibrationBasket arg = match _NonstandardSwaption_calibrationBasket_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_NonstandardSwaption_f : c_obj list -> c_obj list = "_wrap_delete_NonstandardSwaptionQuantLib" ;;
let _delete_NonstandardSwaption arg = match _delete_NonstandardSwaption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FloatFloatSwaption_f : c_obj list -> c_obj list = "_wrap_new_FloatFloatSwaptionQuantLib" ;;
let _new_FloatFloatSwaption arg = match _new_FloatFloatSwaption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatFloatSwaption_calibrationBasket_f : c_obj list -> c_obj list = "_wrap_FloatFloatSwaption_calibrationBasketQuantLib" ;;
let _FloatFloatSwaption_calibrationBasket arg = match _FloatFloatSwaption_calibrationBasket_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FloatFloatSwaption_underlyingValue_f : c_obj list -> c_obj list = "_wrap_FloatFloatSwaption_underlyingValueQuantLib" ;;
let _FloatFloatSwaption_underlyingValue arg = match _FloatFloatSwaption_underlyingValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FloatFloatSwaption_f : c_obj list -> c_obj list = "_wrap_delete_FloatFloatSwaptionQuantLib" ;;
let _delete_FloatFloatSwaption arg = match _delete_FloatFloatSwaption_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_BlackSwaptionEngine__SWIG_0QuantLib" ;;
let _new_BlackSwaptionEngine arg = match _new_BlackSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_BlackSwaptionEngine__SWIG_1QuantLib" ;;
let _new_BlackSwaptionEngine arg = match _new_BlackSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_BlackSwaptionEngine__SWIG_2QuantLib" ;;
let _new_BlackSwaptionEngine arg = match _new_BlackSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BlackSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_BlackSwaptionEngineQuantLib" ;;
let _new_BlackSwaptionEngine arg = match _new_BlackSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BlackSwaptionEngine_vega_f : c_obj list -> c_obj list = "_wrap_BlackSwaptionEngine_vegaQuantLib" ;;
let _BlackSwaptionEngine_vega arg = match _BlackSwaptionEngine_vega_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BlackSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_delete_BlackSwaptionEngineQuantLib" ;;
let _delete_BlackSwaptionEngine arg = match _delete_BlackSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BachelierSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_BachelierSwaptionEngine__SWIG_0QuantLib" ;;
let _new_BachelierSwaptionEngine arg = match _new_BachelierSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BachelierSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_BachelierSwaptionEngine__SWIG_1QuantLib" ;;
let _new_BachelierSwaptionEngine arg = match _new_BachelierSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BachelierSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_new_BachelierSwaptionEngineQuantLib" ;;
let _new_BachelierSwaptionEngine arg = match _new_BachelierSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BachelierSwaptionEngine_f : c_obj list -> c_obj list = "_wrap_delete_BachelierSwaptionEngineQuantLib" ;;
let _delete_BachelierSwaptionEngine arg = match _delete_BachelierSwaptionEngine_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _enableTracing_f : c_obj list -> c_obj list = "_wrap_enableTracingQuantLib" ;;
let _enableTracing arg = match _enableTracing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _disableTracing_f : c_obj list -> c_obj list = "_wrap_disableTracingQuantLib" ;;
let _disableTracing arg = match _disableTracing_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ConstantEstimator_f : c_obj list -> c_obj list = "_wrap_new_ConstantEstimatorQuantLib" ;;
let _new_ConstantEstimator arg = match _new_ConstantEstimator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ConstantEstimator_calculate_f : c_obj list -> c_obj list = "_wrap_ConstantEstimator_calculateQuantLib" ;;
let _ConstantEstimator_calculate arg = match _ConstantEstimator_calculate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ConstantEstimator_f : c_obj list -> c_obj list = "_wrap_delete_ConstantEstimatorQuantLib" ;;
let _delete_ConstantEstimator arg = match _delete_ConstantEstimator_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ParkinsonSigma_f : c_obj list -> c_obj list = "_wrap_new_ParkinsonSigmaQuantLib" ;;
let _new_ParkinsonSigma arg = match _new_ParkinsonSigma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ParkinsonSigma_calculate_f : c_obj list -> c_obj list = "_wrap_ParkinsonSigma_calculateQuantLib" ;;
let _ParkinsonSigma_calculate arg = match _ParkinsonSigma_calculate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ParkinsonSigma_f : c_obj list -> c_obj list = "_wrap_delete_ParkinsonSigmaQuantLib" ;;
let _delete_ParkinsonSigma arg = match _delete_ParkinsonSigma_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GarmanKlassSigma1_f : c_obj list -> c_obj list = "_wrap_new_GarmanKlassSigma1QuantLib" ;;
let _new_GarmanKlassSigma1 arg = match _new_GarmanKlassSigma1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GarmanKlassSigma1_calculate_f : c_obj list -> c_obj list = "_wrap_GarmanKlassSigma1_calculateQuantLib" ;;
let _GarmanKlassSigma1_calculate arg = match _GarmanKlassSigma1_calculate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GarmanKlassSigma1_f : c_obj list -> c_obj list = "_wrap_delete_GarmanKlassSigma1QuantLib" ;;
let _delete_GarmanKlassSigma1 arg = match _delete_GarmanKlassSigma1_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GarmanKlassSigma3_f : c_obj list -> c_obj list = "_wrap_new_GarmanKlassSigma3QuantLib" ;;
let _new_GarmanKlassSigma3 arg = match _new_GarmanKlassSigma3_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GarmanKlassSigma3_calculate_f : c_obj list -> c_obj list = "_wrap_GarmanKlassSigma3_calculateQuantLib" ;;
let _GarmanKlassSigma3_calculate arg = match _GarmanKlassSigma3_calculate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GarmanKlassSigma3_f : c_obj list -> c_obj list = "_wrap_delete_GarmanKlassSigma3QuantLib" ;;
let _delete_GarmanKlassSigma3 arg = match _delete_GarmanKlassSigma3_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GarmanKlassSigma4_f : c_obj list -> c_obj list = "_wrap_new_GarmanKlassSigma4QuantLib" ;;
let _new_GarmanKlassSigma4 arg = match _new_GarmanKlassSigma4_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GarmanKlassSigma4_calculate_f : c_obj list -> c_obj list = "_wrap_GarmanKlassSigma4_calculateQuantLib" ;;
let _GarmanKlassSigma4_calculate arg = match _GarmanKlassSigma4_calculate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GarmanKlassSigma4_f : c_obj list -> c_obj list = "_wrap_delete_GarmanKlassSigma4QuantLib" ;;
let _delete_GarmanKlassSigma4 arg = match _delete_GarmanKlassSigma4_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GarmanKlassSigma5_f : c_obj list -> c_obj list = "_wrap_new_GarmanKlassSigma5QuantLib" ;;
let _new_GarmanKlassSigma5 arg = match _new_GarmanKlassSigma5_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GarmanKlassSigma5_calculate_f : c_obj list -> c_obj list = "_wrap_GarmanKlassSigma5_calculateQuantLib" ;;
let _GarmanKlassSigma5_calculate arg = match _GarmanKlassSigma5_calculate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GarmanKlassSigma5_f : c_obj list -> c_obj list = "_wrap_delete_GarmanKlassSigma5QuantLib" ;;
let _delete_GarmanKlassSigma5 arg = match _delete_GarmanKlassSigma5_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_GarmanKlassSigma6_f : c_obj list -> c_obj list = "_wrap_new_GarmanKlassSigma6QuantLib" ;;
let _new_GarmanKlassSigma6 arg = match _new_GarmanKlassSigma6_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _GarmanKlassSigma6_calculate_f : c_obj list -> c_obj list = "_wrap_GarmanKlassSigma6_calculateQuantLib" ;;
let _GarmanKlassSigma6_calculate arg = match _GarmanKlassSigma6_calculate_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_GarmanKlassSigma6_f : c_obj list -> c_obj list = "_wrap_delete_GarmanKlassSigma6QuantLib" ;;
let _delete_GarmanKlassSigma6 arg = match _delete_GarmanKlassSigma6_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_ZeroCurve__SWIG_0QuantLib" ;;
let _new_ZeroCurve arg = match _new_ZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_ZeroCurve__SWIG_1QuantLib" ;;
let _new_ZeroCurve arg = match _new_ZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_ZeroCurve__SWIG_2QuantLib" ;;
let _new_ZeroCurve arg = match _new_ZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_ZeroCurve__SWIG_3QuantLib" ;;
let _new_ZeroCurve arg = match _new_ZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_ZeroCurveQuantLib" ;;
let _new_ZeroCurve arg = match _new_ZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroCurve_times_f : c_obj list -> c_obj list = "_wrap_ZeroCurve_timesQuantLib" ;;
let _ZeroCurve_times arg = match _ZeroCurve_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroCurve_data_f : c_obj list -> c_obj list = "_wrap_ZeroCurve_dataQuantLib" ;;
let _ZeroCurve_data arg = match _ZeroCurve_data_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroCurve_dates_f : c_obj list -> c_obj list = "_wrap_ZeroCurve_datesQuantLib" ;;
let _ZeroCurve_dates arg = match _ZeroCurve_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroCurve_zeroRates_f : c_obj list -> c_obj list = "_wrap_ZeroCurve_zeroRatesQuantLib" ;;
let _ZeroCurve_zeroRates arg = match _ZeroCurve_zeroRates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ZeroCurve_nodes_f : c_obj list -> c_obj list = "_wrap_ZeroCurve_nodesQuantLib" ;;
let _ZeroCurve_nodes arg = match _ZeroCurve_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ZeroCurve_f : c_obj list -> c_obj list = "_wrap_delete_ZeroCurveQuantLib" ;;
let _delete_ZeroCurve arg = match _delete_ZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogLinearZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_LogLinearZeroCurve__SWIG_0QuantLib" ;;
let _new_LogLinearZeroCurve arg = match _new_LogLinearZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogLinearZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_LogLinearZeroCurve__SWIG_1QuantLib" ;;
let _new_LogLinearZeroCurve arg = match _new_LogLinearZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogLinearZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_LogLinearZeroCurve__SWIG_2QuantLib" ;;
let _new_LogLinearZeroCurve arg = match _new_LogLinearZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogLinearZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_LogLinearZeroCurve__SWIG_3QuantLib" ;;
let _new_LogLinearZeroCurve arg = match _new_LogLinearZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogLinearZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_LogLinearZeroCurveQuantLib" ;;
let _new_LogLinearZeroCurve arg = match _new_LogLinearZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogLinearZeroCurve_times_f : c_obj list -> c_obj list = "_wrap_LogLinearZeroCurve_timesQuantLib" ;;
let _LogLinearZeroCurve_times arg = match _LogLinearZeroCurve_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogLinearZeroCurve_data_f : c_obj list -> c_obj list = "_wrap_LogLinearZeroCurve_dataQuantLib" ;;
let _LogLinearZeroCurve_data arg = match _LogLinearZeroCurve_data_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogLinearZeroCurve_dates_f : c_obj list -> c_obj list = "_wrap_LogLinearZeroCurve_datesQuantLib" ;;
let _LogLinearZeroCurve_dates arg = match _LogLinearZeroCurve_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogLinearZeroCurve_zeroRates_f : c_obj list -> c_obj list = "_wrap_LogLinearZeroCurve_zeroRatesQuantLib" ;;
let _LogLinearZeroCurve_zeroRates arg = match _LogLinearZeroCurve_zeroRates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogLinearZeroCurve_nodes_f : c_obj list -> c_obj list = "_wrap_LogLinearZeroCurve_nodesQuantLib" ;;
let _LogLinearZeroCurve_nodes arg = match _LogLinearZeroCurve_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LogLinearZeroCurve_f : c_obj list -> c_obj list = "_wrap_delete_LogLinearZeroCurveQuantLib" ;;
let _delete_LogLinearZeroCurve arg = match _delete_LogLinearZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_CubicZeroCurve__SWIG_0QuantLib" ;;
let _new_CubicZeroCurve arg = match _new_CubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_CubicZeroCurve__SWIG_1QuantLib" ;;
let _new_CubicZeroCurve arg = match _new_CubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_CubicZeroCurve__SWIG_2QuantLib" ;;
let _new_CubicZeroCurve arg = match _new_CubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_CubicZeroCurve__SWIG_3QuantLib" ;;
let _new_CubicZeroCurve arg = match _new_CubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_CubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_CubicZeroCurveQuantLib" ;;
let _new_CubicZeroCurve arg = match _new_CubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicZeroCurve_times_f : c_obj list -> c_obj list = "_wrap_CubicZeroCurve_timesQuantLib" ;;
let _CubicZeroCurve_times arg = match _CubicZeroCurve_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicZeroCurve_data_f : c_obj list -> c_obj list = "_wrap_CubicZeroCurve_dataQuantLib" ;;
let _CubicZeroCurve_data arg = match _CubicZeroCurve_data_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicZeroCurve_dates_f : c_obj list -> c_obj list = "_wrap_CubicZeroCurve_datesQuantLib" ;;
let _CubicZeroCurve_dates arg = match _CubicZeroCurve_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicZeroCurve_zeroRates_f : c_obj list -> c_obj list = "_wrap_CubicZeroCurve_zeroRatesQuantLib" ;;
let _CubicZeroCurve_zeroRates arg = match _CubicZeroCurve_zeroRates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _CubicZeroCurve_nodes_f : c_obj list -> c_obj list = "_wrap_CubicZeroCurve_nodesQuantLib" ;;
let _CubicZeroCurve_nodes arg = match _CubicZeroCurve_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_CubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_delete_CubicZeroCurveQuantLib" ;;
let _delete_CubicZeroCurve arg = match _delete_CubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogCubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_LogCubicZeroCurve__SWIG_0QuantLib" ;;
let _new_LogCubicZeroCurve arg = match _new_LogCubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogCubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_LogCubicZeroCurve__SWIG_1QuantLib" ;;
let _new_LogCubicZeroCurve arg = match _new_LogCubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogCubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_LogCubicZeroCurve__SWIG_2QuantLib" ;;
let _new_LogCubicZeroCurve arg = match _new_LogCubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogCubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_LogCubicZeroCurve__SWIG_3QuantLib" ;;
let _new_LogCubicZeroCurve arg = match _new_LogCubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_LogCubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_LogCubicZeroCurveQuantLib" ;;
let _new_LogCubicZeroCurve arg = match _new_LogCubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicZeroCurve_times_f : c_obj list -> c_obj list = "_wrap_LogCubicZeroCurve_timesQuantLib" ;;
let _LogCubicZeroCurve_times arg = match _LogCubicZeroCurve_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicZeroCurve_data_f : c_obj list -> c_obj list = "_wrap_LogCubicZeroCurve_dataQuantLib" ;;
let _LogCubicZeroCurve_data arg = match _LogCubicZeroCurve_data_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicZeroCurve_dates_f : c_obj list -> c_obj list = "_wrap_LogCubicZeroCurve_datesQuantLib" ;;
let _LogCubicZeroCurve_dates arg = match _LogCubicZeroCurve_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicZeroCurve_zeroRates_f : c_obj list -> c_obj list = "_wrap_LogCubicZeroCurve_zeroRatesQuantLib" ;;
let _LogCubicZeroCurve_zeroRates arg = match _LogCubicZeroCurve_zeroRates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _LogCubicZeroCurve_nodes_f : c_obj list -> c_obj list = "_wrap_LogCubicZeroCurve_nodesQuantLib" ;;
let _LogCubicZeroCurve_nodes arg = match _LogCubicZeroCurve_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_LogCubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_delete_LogCubicZeroCurveQuantLib" ;;
let _delete_LogCubicZeroCurve arg = match _delete_LogCubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardFlatZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_ForwardFlatZeroCurve__SWIG_0QuantLib" ;;
let _new_ForwardFlatZeroCurve arg = match _new_ForwardFlatZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardFlatZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_ForwardFlatZeroCurve__SWIG_1QuantLib" ;;
let _new_ForwardFlatZeroCurve arg = match _new_ForwardFlatZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardFlatZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_ForwardFlatZeroCurve__SWIG_2QuantLib" ;;
let _new_ForwardFlatZeroCurve arg = match _new_ForwardFlatZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardFlatZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_ForwardFlatZeroCurve__SWIG_3QuantLib" ;;
let _new_ForwardFlatZeroCurve arg = match _new_ForwardFlatZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_ForwardFlatZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_ForwardFlatZeroCurveQuantLib" ;;
let _new_ForwardFlatZeroCurve arg = match _new_ForwardFlatZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardFlatZeroCurve_times_f : c_obj list -> c_obj list = "_wrap_ForwardFlatZeroCurve_timesQuantLib" ;;
let _ForwardFlatZeroCurve_times arg = match _ForwardFlatZeroCurve_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardFlatZeroCurve_data_f : c_obj list -> c_obj list = "_wrap_ForwardFlatZeroCurve_dataQuantLib" ;;
let _ForwardFlatZeroCurve_data arg = match _ForwardFlatZeroCurve_data_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardFlatZeroCurve_dates_f : c_obj list -> c_obj list = "_wrap_ForwardFlatZeroCurve_datesQuantLib" ;;
let _ForwardFlatZeroCurve_dates arg = match _ForwardFlatZeroCurve_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardFlatZeroCurve_zeroRates_f : c_obj list -> c_obj list = "_wrap_ForwardFlatZeroCurve_zeroRatesQuantLib" ;;
let _ForwardFlatZeroCurve_zeroRates arg = match _ForwardFlatZeroCurve_zeroRates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _ForwardFlatZeroCurve_nodes_f : c_obj list -> c_obj list = "_wrap_ForwardFlatZeroCurve_nodesQuantLib" ;;
let _ForwardFlatZeroCurve_nodes arg = match _ForwardFlatZeroCurve_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_ForwardFlatZeroCurve_f : c_obj list -> c_obj list = "_wrap_delete_ForwardFlatZeroCurveQuantLib" ;;
let _delete_ForwardFlatZeroCurve arg = match _delete_ForwardFlatZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BackwardFlatZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_BackwardFlatZeroCurve__SWIG_0QuantLib" ;;
let _new_BackwardFlatZeroCurve arg = match _new_BackwardFlatZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BackwardFlatZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_BackwardFlatZeroCurve__SWIG_1QuantLib" ;;
let _new_BackwardFlatZeroCurve arg = match _new_BackwardFlatZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BackwardFlatZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_BackwardFlatZeroCurve__SWIG_2QuantLib" ;;
let _new_BackwardFlatZeroCurve arg = match _new_BackwardFlatZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BackwardFlatZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_BackwardFlatZeroCurve__SWIG_3QuantLib" ;;
let _new_BackwardFlatZeroCurve arg = match _new_BackwardFlatZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_BackwardFlatZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_BackwardFlatZeroCurveQuantLib" ;;
let _new_BackwardFlatZeroCurve arg = match _new_BackwardFlatZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BackwardFlatZeroCurve_times_f : c_obj list -> c_obj list = "_wrap_BackwardFlatZeroCurve_timesQuantLib" ;;
let _BackwardFlatZeroCurve_times arg = match _BackwardFlatZeroCurve_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BackwardFlatZeroCurve_data_f : c_obj list -> c_obj list = "_wrap_BackwardFlatZeroCurve_dataQuantLib" ;;
let _BackwardFlatZeroCurve_data arg = match _BackwardFlatZeroCurve_data_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BackwardFlatZeroCurve_dates_f : c_obj list -> c_obj list = "_wrap_BackwardFlatZeroCurve_datesQuantLib" ;;
let _BackwardFlatZeroCurve_dates arg = match _BackwardFlatZeroCurve_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BackwardFlatZeroCurve_zeroRates_f : c_obj list -> c_obj list = "_wrap_BackwardFlatZeroCurve_zeroRatesQuantLib" ;;
let _BackwardFlatZeroCurve_zeroRates arg = match _BackwardFlatZeroCurve_zeroRates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _BackwardFlatZeroCurve_nodes_f : c_obj list -> c_obj list = "_wrap_BackwardFlatZeroCurve_nodesQuantLib" ;;
let _BackwardFlatZeroCurve_nodes arg = match _BackwardFlatZeroCurve_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_BackwardFlatZeroCurve_f : c_obj list -> c_obj list = "_wrap_delete_BackwardFlatZeroCurveQuantLib" ;;
let _delete_BackwardFlatZeroCurve arg = match _delete_BackwardFlatZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MonotonicCubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_MonotonicCubicZeroCurve__SWIG_0QuantLib" ;;
let _new_MonotonicCubicZeroCurve arg = match _new_MonotonicCubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MonotonicCubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_MonotonicCubicZeroCurve__SWIG_1QuantLib" ;;
let _new_MonotonicCubicZeroCurve arg = match _new_MonotonicCubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MonotonicCubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_MonotonicCubicZeroCurve__SWIG_2QuantLib" ;;
let _new_MonotonicCubicZeroCurve arg = match _new_MonotonicCubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MonotonicCubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_MonotonicCubicZeroCurve__SWIG_3QuantLib" ;;
let _new_MonotonicCubicZeroCurve arg = match _new_MonotonicCubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_MonotonicCubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_new_MonotonicCubicZeroCurveQuantLib" ;;
let _new_MonotonicCubicZeroCurve arg = match _new_MonotonicCubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicZeroCurve_times_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicZeroCurve_timesQuantLib" ;;
let _MonotonicCubicZeroCurve_times arg = match _MonotonicCubicZeroCurve_times_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicZeroCurve_data_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicZeroCurve_dataQuantLib" ;;
let _MonotonicCubicZeroCurve_data arg = match _MonotonicCubicZeroCurve_data_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicZeroCurve_dates_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicZeroCurve_datesQuantLib" ;;
let _MonotonicCubicZeroCurve_dates arg = match _MonotonicCubicZeroCurve_dates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicZeroCurve_zeroRates_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicZeroCurve_zeroRatesQuantLib" ;;
let _MonotonicCubicZeroCurve_zeroRates arg = match _MonotonicCubicZeroCurve_zeroRates_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _MonotonicCubicZeroCurve_nodes_f : c_obj list -> c_obj list = "_wrap_MonotonicCubicZeroCurve_nodesQuantLib" ;;
let _MonotonicCubicZeroCurve_nodes arg = match _MonotonicCubicZeroCurve_nodes_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_MonotonicCubicZeroCurve_f : c_obj list -> c_obj list = "_wrap_delete_MonotonicCubicZeroCurveQuantLib" ;;
let _delete_MonotonicCubicZeroCurve arg = match _delete_MonotonicCubicZeroCurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _as_zerocurve_f : c_obj list -> c_obj list = "_wrap_as_zerocurveQuantLib" ;;
let _as_zerocurve arg = match _as_zerocurve_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Forward_forwardValue_f : c_obj list -> c_obj list = "_wrap_Forward_forwardValueQuantLib" ;;
let _Forward_forwardValue arg = match _Forward_forwardValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _Forward_impliedYield_f : c_obj list -> c_obj list = "_wrap_Forward_impliedYieldQuantLib" ;;
let _Forward_impliedYield arg = match _Forward_impliedYield_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_Forward_f : c_obj list -> c_obj list = "_wrap_new_ForwardQuantLib" ;;
let _new_Forward arg = match _new_Forward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_Forward_f : c_obj list -> c_obj list = "_wrap_delete_ForwardQuantLib" ;;
let _delete_Forward arg = match _delete_Forward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondForward_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondForward__SWIG_0QuantLib" ;;
let _new_FixedRateBondForward arg = match _new_FixedRateBondForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondForward_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondForward__SWIG_1QuantLib" ;;
let _new_FixedRateBondForward arg = match _new_FixedRateBondForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _new_FixedRateBondForward_f : c_obj list -> c_obj list = "_wrap_new_FixedRateBondForwardQuantLib" ;;
let _new_FixedRateBondForward arg = match _new_FixedRateBondForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if true then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FixedRateBondForward_forwardPrice_f : c_obj list -> c_obj list = "_wrap_FixedRateBondForward_forwardPriceQuantLib" ;;
let _FixedRateBondForward_forwardPrice arg = match _FixedRateBondForward_forwardPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FixedRateBondForward_cleanForwardPrice_f : c_obj list -> c_obj list = "_wrap_FixedRateBondForward_cleanForwardPriceQuantLib" ;;
let _FixedRateBondForward_cleanForwardPrice arg = match _FixedRateBondForward_cleanForwardPrice_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FixedRateBondForward_spotIncome_f : c_obj list -> c_obj list = "_wrap_FixedRateBondForward_spotIncomeQuantLib" ;;
let _FixedRateBondForward_spotIncome arg = match _FixedRateBondForward_spotIncome_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _FixedRateBondForward_spotValue_f : c_obj list -> c_obj list = "_wrap_FixedRateBondForward_spotValueQuantLib" ;;
let _FixedRateBondForward_spotValue arg = match _FixedRateBondForward_spotValue_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external _delete_FixedRateBondForward_f : c_obj list -> c_obj list = "_wrap_delete_FixedRateBondForwardQuantLib" ;;
let _delete_FixedRateBondForward arg = match _delete_FixedRateBondForward_f (fnhelper arg) with
  [] -> C_void
| [x] -> (if false then Gc.finalise 
  (fun x -> ignore ((invoke x) "~" C_void)) x) ; x
| lst -> C_list lst ;;
external f_init : unit -> unit = "f_QuantLib_init" ;;
let _ = f_init ()
let enum_to_int x (v : c_obj) =
   match v with
     C_enum _y ->
     (let y = _y in match (x : c_enum_type) with
       `unknown ->          (match y with
           `Int x -> (Swig.C_int x)
           | _ -> raise (LabelNotFromThisEnum v))
| `Weekday -> (match y with
 | `Sunday -> _Sunday C_void
 | `Monday -> _Monday C_void
 | `Tuesday -> _Tuesday C_void
 | `Wednesday -> _Wednesday C_void
 | `Thursday -> _Thursday C_void
 | `Friday -> _Friday C_void
 | `Saturday -> _Saturday C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Month -> (match y with
 | `January -> _January C_void
 | `February -> _February C_void
 | `March -> _March C_void
 | `April -> _April C_void
 | `May -> _May C_void
 | `June -> _June C_void
 | `July -> _July C_void
 | `August -> _August C_void
 | `September -> _September C_void
 | `October -> _October C_void
 | `November -> _November C_void
 | `December -> _December C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `TimeUnit -> (match y with
 | `Days -> _Days C_void
 | `Weeks -> _Weeks C_void
 | `Months -> _Months C_void
 | `Years -> _Years C_void
 | `Hours -> _Hours C_void
 | `Minutes -> _Minutes C_void
 | `Seconds -> _Seconds C_void
 | `Milliseconds -> _Milliseconds C_void
 | `Microseconds -> _Microseconds C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Frequency -> (match y with
 | `NoFrequency -> _NoFrequency C_void
 | `Once -> _Once C_void
 | `Annual -> _Annual C_void
 | `Semiannual -> _Semiannual C_void
 | `EveryFourthMonth -> _EveryFourthMonth C_void
 | `Quarterly -> _Quarterly C_void
 | `Bimonthly -> _Bimonthly C_void
 | `Monthly -> _Monthly C_void
 | `EveryFourthWeek -> _EveryFourthWeek C_void
 | `Biweekly -> _Biweekly C_void
 | `Weekly -> _Weekly C_void
 | `Daily -> _Daily C_void
 | `OtherFrequency -> _OtherFrequency C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Month -> (match y with
 | `F -> _F C_void
 | `G -> _G C_void
 | `H -> _H C_void
 | `J -> _J C_void
 | `K -> _K C_void
 | `M -> _M C_void
 | `N -> _N C_void
 | `Q -> _Q C_void
 | `U -> _U C_void
 | `V -> _V C_void
 | `X -> _X C_void
 | `Z -> _Z C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Month -> (match y with
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `None -> _None C_void
 | `Spectral -> _Spectral C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `BusinessDayConvention -> (match y with
 | `Following -> _Following C_void
 | `ModifiedFollowing -> _ModifiedFollowing C_void
 | `Preceding -> _Preceding C_void
 | `ModifiedPreceding -> _ModifiedPreceding C_void
 | `Unadjusted -> _Unadjusted C_void
 | `HalfMonthModifiedFollowing -> _HalfMonthModifiedFollowing C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `JointCalendarRule -> (match y with
 | `JoinHolidays -> _JoinHolidays C_void
 | `JoinBusinessDays -> _JoinBusinessDays C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `Merval -> _Merval C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `Settlement -> _Settlement C_void
 | `Exchange -> _Exchange C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `TSX -> _TSX C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `SSE -> _SSE C_void
 | `IB -> _IB C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `PSE -> _PSE C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `FrankfurtStockExchange -> _FrankfurtStockExchange C_void
 | `Xetra -> _Xetra C_void
 | `Eurex -> _Eurex C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `HKEx -> _HKEx C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `ICEX -> _ICEX C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `NSE -> _NSE C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `BEJ -> _BEJ C_void
 | `JSX -> _JSX C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `TASE -> _TASE C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `BMV -> _BMV C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `MOEX -> _MOEX C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `Tadawul -> _Tadawul C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `SGX -> _SGX C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `BSSE -> _BSSE C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `KRX -> _KRX C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `TSEC -> _TSEC C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `USE -> _USE C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `Metals -> _Metals C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Market -> (match y with
 | `NYSE -> _NYSE C_void
 | `GovernmentBond -> _GovernmentBond C_void
 | `NERC -> _NERC C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Convention -> (match y with
 | `Standard -> _Standard C_void
 | `Canadian -> _Canadian C_void
 | `NoLeap -> _NoLeap C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Convention -> (match y with
 | `USA -> _USA C_void
 | `BondBasis -> _BondBasis C_void
 | `European -> _European C_void
 | `EurobondBasis -> _EurobondBasis C_void
 | `Italian -> _Italian C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Convention -> (match y with
 | `ISMA -> _ISMA C_void
 | `Bond -> _Bond C_void
 | `ISDA -> _ISDA C_void
 | `Historical -> _Historical C_void
 | `Actual365 -> _Actual365 C_void
 | `AFB -> _AFB C_void
 | `Euro -> _Euro C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Compounding -> (match y with
 | `Simple -> _Simple C_void
 | `Compounded -> _Compounded C_void
 | `Continuous -> _Continuous C_void
 | `SimpleThenCompounded -> _SimpleThenCompounded C_void
 | `CompoundedThenSimple -> _CompoundedThenSimple C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `Open -> _Open C_void
 | `Close -> _Close C_void
 | `High -> _High C_void
 | `Low -> _Low C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `MaxIterations -> _MaxIterations C_void
 | `StationaryPoint -> _StationaryPoint C_void
 | `StationaryFunctionValue -> _StationaryFunctionValue C_void
 | `StationaryFunctionAccuracy -> _StationaryFunctionAccuracy C_void
 | `ZeroGradientNorm -> _ZeroGradientNorm C_void
 | `Unknown -> _Unknown C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `ResetScheme -> (match y with
 | `NoResetScheme -> _NoResetScheme C_void
 | `ResetToBestPoint -> _ResetToBestPoint C_void
 | `ResetToOrigin -> _ResetToOrigin C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `ResetScheme -> (match y with
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `ResetScheme -> (match y with
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `VolatilityType -> (match y with
 | `ShiftedLognormal -> _ShiftedLognormal C_void
 | `Normal -> _Normal C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Rule -> (match y with
 | `Backward -> _Backward C_void
 | `Forward -> _Forward C_void
 | `Zero -> _Zero C_void
 | `ThirdWednesday -> _ThirdWednesday C_void
 | `Twentieth -> _Twentieth C_void
 | `TwentiethIMM -> _TwentiethIMM C_void
 | `OldCDS -> _OldCDS C_void
 | `CDS -> _CDS C_void
 | `CDS2015 -> _CDS2015 C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `YieldCurveModel -> (match y with
 | `ExactYield -> _ExactYield C_void
 | `ParallelShifts -> _ParallelShifts C_void
 | `NonParallelShifts -> _NonParallelShifts C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `Macaulay -> _Macaulay C_void
 | `Modified -> _Modified C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `Put -> _Put C_void
 | `Call -> _Call C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `DownIn -> _DownIn C_void
 | `UpIn -> _UpIn C_void
 | `DownOut -> _DownOut C_void
 | `UpOut -> _UpOut C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `KnockIn -> _KnockIn C_void
 | `KnockOut -> _KnockOut C_void
 | `KIKO -> _KIKO C_void
 | `KOKI -> _KOKI C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `FdmSchemeType -> (match y with
 | `HundsdorferType -> _HundsdorferType C_void
 | `DouglasType -> _DouglasType C_void
 | `CraigSneydType -> _CraigSneydType C_void
 | `ModifiedCraigSneydType -> _ModifiedCraigSneydType C_void
 | `ImplicitEulerType -> _ImplicitEulerType C_void
 | `ExplicitEulerType -> _ExplicitEulerType C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `Arithmetic -> _Arithmetic C_void
 | `Geometric -> _Geometric C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `Dirty -> _Dirty C_void
 | `Clean -> _Clean C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `InterpolationType -> (match y with
 | `AsIndex -> _AsIndex C_void
 | `Flat -> _Flat C_void
 | `Linear -> _Linear C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Side -> (match y with
 | `Buyer -> _Buyer C_void
 | `Seller -> _Seller C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `ConversionType -> (match y with
 | `NoConversion -> _NoConversion C_void
 | `BaseCurrencyConversion -> _BaseCurrencyConversion C_void
 | `AutomatedConversion -> _AutomatedConversion C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `Direct -> _Direct C_void
 | `Derived -> _Derived C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `IMM -> _IMM C_void
 | `ASX -> _ASX C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Choice -> (match y with
 | `MaturityDate -> _MaturityDate C_void
 | `LastRelevantDate -> _LastRelevantDate C_void
 | `CustomDate -> _CustomDate C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `Long -> _Long C_void
 | `Short -> _Short C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Adjustments -> (match y with
 | `AdjustNone -> _AdjustNone C_void
 | `AdjustDigitals -> _AdjustDigitals C_void
 | `AdjustYts -> _AdjustYts C_void
 | `ExtrapolatePayoffFlat -> _ExtrapolatePayoffFlat C_void
 | `NoPayoffExtrapolation -> _NoPayoffExtrapolation C_void
 | `KahaleSmile -> _KahaleSmile C_void
 | `SmileExponentialExtrapolation -> _SmileExponentialExtrapolation C_void
 | `KahaleInterpolation -> _KahaleInterpolation C_void
 | `SmileDeleteArbitragePoints -> _SmileDeleteArbitragePoints C_void
 | `SabrSmile -> _SabrSmile C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `DirectionIntegers -> (match y with
 | `Unit -> _Unit C_void
 | `Jaeckel -> _Jaeckel C_void
 | `SobolLevitan -> _SobolLevitan C_void
 | `SobolLevitanLemieux -> _SobolLevitanLemieux C_void
 | `JoeKuoD5 -> _JoeKuoD5 C_void
 | `JoeKuoD6 -> _JoeKuoD6 C_void
 | `JoeKuoD7 -> _JoeKuoD7 C_void
 | `Kuo -> _Kuo C_void
 | `Kuo2 -> _Kuo2 C_void
 | `Kuo3 -> _Kuo3 C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
| `Type -> (match y with
 | `Physical -> _Physical C_void
 | `Cash -> _Cash C_void
| `Int x -> Swig.C_int x
| _ -> raise (LabelNotFromThisEnum v))
) | _ -> (C_int (get_int v))
let _ = Callback.register "QuantLib_enum_to_int" enum_to_int
let int_to_enum x y =
    match (x : c_enum_type) with
      `unknown -> C_enum (`Int y)
| `Weekday -> C_enum (
 if y = (get_int (_Sunday C_void)) then `Sunday else
 if y = (get_int (_Monday C_void)) then `Monday else
 if y = (get_int (_Tuesday C_void)) then `Tuesday else
 if y = (get_int (_Wednesday C_void)) then `Wednesday else
 if y = (get_int (_Thursday C_void)) then `Thursday else
 if y = (get_int (_Friday C_void)) then `Friday else
 if y = (get_int (_Saturday C_void)) then `Saturday else
`Int y)
| `Month -> C_enum (
 if y = (get_int (_January C_void)) then `January else
 if y = (get_int (_February C_void)) then `February else
 if y = (get_int (_March C_void)) then `March else
 if y = (get_int (_April C_void)) then `April else
 if y = (get_int (_May C_void)) then `May else
 if y = (get_int (_June C_void)) then `June else
 if y = (get_int (_July C_void)) then `July else
 if y = (get_int (_August C_void)) then `August else
 if y = (get_int (_September C_void)) then `September else
 if y = (get_int (_October C_void)) then `October else
 if y = (get_int (_November C_void)) then `November else
 if y = (get_int (_December C_void)) then `December else
`Int y)
| `TimeUnit -> C_enum (
 if y = (get_int (_Days C_void)) then `Days else
 if y = (get_int (_Weeks C_void)) then `Weeks else
 if y = (get_int (_Months C_void)) then `Months else
 if y = (get_int (_Years C_void)) then `Years else
 if y = (get_int (_Hours C_void)) then `Hours else
 if y = (get_int (_Minutes C_void)) then `Minutes else
 if y = (get_int (_Seconds C_void)) then `Seconds else
 if y = (get_int (_Milliseconds C_void)) then `Milliseconds else
 if y = (get_int (_Microseconds C_void)) then `Microseconds else
`Int y)
| `Frequency -> C_enum (
 if y = (get_int (_NoFrequency C_void)) then `NoFrequency else
 if y = (get_int (_Once C_void)) then `Once else
 if y = (get_int (_Annual C_void)) then `Annual else
 if y = (get_int (_Semiannual C_void)) then `Semiannual else
 if y = (get_int (_EveryFourthMonth C_void)) then `EveryFourthMonth else
 if y = (get_int (_Quarterly C_void)) then `Quarterly else
 if y = (get_int (_Bimonthly C_void)) then `Bimonthly else
 if y = (get_int (_Monthly C_void)) then `Monthly else
 if y = (get_int (_EveryFourthWeek C_void)) then `EveryFourthWeek else
 if y = (get_int (_Biweekly C_void)) then `Biweekly else
 if y = (get_int (_Weekly C_void)) then `Weekly else
 if y = (get_int (_Daily C_void)) then `Daily else
 if y = (get_int (_OtherFrequency C_void)) then `OtherFrequency else
`Int y)
| `Month -> C_enum (
 if y = (get_int (_F C_void)) then `F else
 if y = (get_int (_G C_void)) then `G else
 if y = (get_int (_H C_void)) then `H else
 if y = (get_int (_J C_void)) then `J else
 if y = (get_int (_K C_void)) then `K else
 if y = (get_int (_M C_void)) then `M else
 if y = (get_int (_N C_void)) then `N else
 if y = (get_int (_Q C_void)) then `Q else
 if y = (get_int (_U C_void)) then `U else
 if y = (get_int (_V C_void)) then `V else
 if y = (get_int (_X C_void)) then `X else
 if y = (get_int (_Z C_void)) then `Z else
`Int y)
| `Month -> C_enum (
`Int y)
| `Type -> C_enum (
 if y = (get_int (_None C_void)) then `None else
 if y = (get_int (_Spectral C_void)) then `Spectral else
`Int y)
| `BusinessDayConvention -> C_enum (
 if y = (get_int (_Following C_void)) then `Following else
 if y = (get_int (_ModifiedFollowing C_void)) then `ModifiedFollowing else
 if y = (get_int (_Preceding C_void)) then `Preceding else
 if y = (get_int (_ModifiedPreceding C_void)) then `ModifiedPreceding else
 if y = (get_int (_Unadjusted C_void)) then `Unadjusted else
 if y = (get_int (_HalfMonthModifiedFollowing C_void)) then `HalfMonthModifiedFollowing else
`Int y)
| `JointCalendarRule -> C_enum (
 if y = (get_int (_JoinHolidays C_void)) then `JoinHolidays else
 if y = (get_int (_JoinBusinessDays C_void)) then `JoinBusinessDays else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_Merval C_void)) then `Merval else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_Settlement C_void)) then `Settlement else
 if y = (get_int (_Exchange C_void)) then `Exchange else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_TSX C_void)) then `TSX else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_SSE C_void)) then `SSE else
 if y = (get_int (_IB C_void)) then `IB else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_PSE C_void)) then `PSE else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_FrankfurtStockExchange C_void)) then `FrankfurtStockExchange else
 if y = (get_int (_Xetra C_void)) then `Xetra else
 if y = (get_int (_Eurex C_void)) then `Eurex else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_HKEx C_void)) then `HKEx else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_ICEX C_void)) then `ICEX else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_NSE C_void)) then `NSE else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_BEJ C_void)) then `BEJ else
 if y = (get_int (_JSX C_void)) then `JSX else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_TASE C_void)) then `TASE else
`Int y)
| `Market -> C_enum (
`Int y)
| `Market -> C_enum (
 if y = (get_int (_BMV C_void)) then `BMV else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_MOEX C_void)) then `MOEX else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_Tadawul C_void)) then `Tadawul else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_SGX C_void)) then `SGX else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_BSSE C_void)) then `BSSE else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_KRX C_void)) then `KRX else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_TSEC C_void)) then `TSEC else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_USE C_void)) then `USE else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_Metals C_void)) then `Metals else
`Int y)
| `Market -> C_enum (
 if y = (get_int (_NYSE C_void)) then `NYSE else
 if y = (get_int (_GovernmentBond C_void)) then `GovernmentBond else
 if y = (get_int (_NERC C_void)) then `NERC else
`Int y)
| `Convention -> C_enum (
 if y = (get_int (_Standard C_void)) then `Standard else
 if y = (get_int (_Canadian C_void)) then `Canadian else
 if y = (get_int (_NoLeap C_void)) then `NoLeap else
`Int y)
| `Convention -> C_enum (
 if y = (get_int (_USA C_void)) then `USA else
 if y = (get_int (_BondBasis C_void)) then `BondBasis else
 if y = (get_int (_European C_void)) then `European else
 if y = (get_int (_EurobondBasis C_void)) then `EurobondBasis else
 if y = (get_int (_Italian C_void)) then `Italian else
`Int y)
| `Convention -> C_enum (
 if y = (get_int (_ISMA C_void)) then `ISMA else
 if y = (get_int (_Bond C_void)) then `Bond else
 if y = (get_int (_ISDA C_void)) then `ISDA else
 if y = (get_int (_Historical C_void)) then `Historical else
 if y = (get_int (_Actual365 C_void)) then `Actual365 else
 if y = (get_int (_AFB C_void)) then `AFB else
 if y = (get_int (_Euro C_void)) then `Euro else
`Int y)
| `Compounding -> C_enum (
 if y = (get_int (_Simple C_void)) then `Simple else
 if y = (get_int (_Compounded C_void)) then `Compounded else
 if y = (get_int (_Continuous C_void)) then `Continuous else
 if y = (get_int (_SimpleThenCompounded C_void)) then `SimpleThenCompounded else
 if y = (get_int (_CompoundedThenSimple C_void)) then `CompoundedThenSimple else
`Int y)
| `Type -> C_enum (
 if y = (get_int (_Open C_void)) then `Open else
 if y = (get_int (_Close C_void)) then `Close else
 if y = (get_int (_High C_void)) then `High else
 if y = (get_int (_Low C_void)) then `Low else
`Int y)
| `Type -> C_enum (
 if y = (get_int (_MaxIterations C_void)) then `MaxIterations else
 if y = (get_int (_StationaryPoint C_void)) then `StationaryPoint else
 if y = (get_int (_StationaryFunctionValue C_void)) then `StationaryFunctionValue else
 if y = (get_int (_StationaryFunctionAccuracy C_void)) then `StationaryFunctionAccuracy else
 if y = (get_int (_ZeroGradientNorm C_void)) then `ZeroGradientNorm else
 if y = (get_int (_Unknown C_void)) then `Unknown else
`Int y)
| `ResetScheme -> C_enum (
 if y = (get_int (_NoResetScheme C_void)) then `NoResetScheme else
 if y = (get_int (_ResetToBestPoint C_void)) then `ResetToBestPoint else
 if y = (get_int (_ResetToOrigin C_void)) then `ResetToOrigin else
`Int y)
| `ResetScheme -> C_enum (
`Int y)
| `ResetScheme -> C_enum (
`Int y)
| `VolatilityType -> C_enum (
 if y = (get_int (_ShiftedLognormal C_void)) then `ShiftedLognormal else
 if y = (get_int (_Normal C_void)) then `Normal else
`Int y)
| `Rule -> C_enum (
 if y = (get_int (_Backward C_void)) then `Backward else
 if y = (get_int (_Forward C_void)) then `Forward else
 if y = (get_int (_Zero C_void)) then `Zero else
 if y = (get_int (_ThirdWednesday C_void)) then `ThirdWednesday else
 if y = (get_int (_Twentieth C_void)) then `Twentieth else
 if y = (get_int (_TwentiethIMM C_void)) then `TwentiethIMM else
 if y = (get_int (_OldCDS C_void)) then `OldCDS else
 if y = (get_int (_CDS C_void)) then `CDS else
 if y = (get_int (_CDS2015 C_void)) then `CDS2015 else
`Int y)
| `YieldCurveModel -> C_enum (
 if y = (get_int (_ExactYield C_void)) then `ExactYield else
 if y = (get_int (_ParallelShifts C_void)) then `ParallelShifts else
 if y = (get_int (_NonParallelShifts C_void)) then `NonParallelShifts else
`Int y)
| `Type -> C_enum (
 if y = (get_int (_Macaulay C_void)) then `Macaulay else
 if y = (get_int (_Modified C_void)) then `Modified else
`Int y)
| `Type -> C_enum (
 if y = (get_int (_Put C_void)) then `Put else
 if y = (get_int (_Call C_void)) then `Call else
`Int y)
| `Type -> C_enum (
 if y = (get_int (_DownIn C_void)) then `DownIn else
 if y = (get_int (_UpIn C_void)) then `UpIn else
 if y = (get_int (_DownOut C_void)) then `DownOut else
 if y = (get_int (_UpOut C_void)) then `UpOut else
`Int y)
| `Type -> C_enum (
 if y = (get_int (_KnockIn C_void)) then `KnockIn else
 if y = (get_int (_KnockOut C_void)) then `KnockOut else
 if y = (get_int (_KIKO C_void)) then `KIKO else
 if y = (get_int (_KOKI C_void)) then `KOKI else
`Int y)
| `FdmSchemeType -> C_enum (
 if y = (get_int (_HundsdorferType C_void)) then `HundsdorferType else
 if y = (get_int (_DouglasType C_void)) then `DouglasType else
 if y = (get_int (_CraigSneydType C_void)) then `CraigSneydType else
 if y = (get_int (_ModifiedCraigSneydType C_void)) then `ModifiedCraigSneydType else
 if y = (get_int (_ImplicitEulerType C_void)) then `ImplicitEulerType else
 if y = (get_int (_ExplicitEulerType C_void)) then `ExplicitEulerType else
`Int y)
| `Type -> C_enum (
 if y = (get_int (_Arithmetic C_void)) then `Arithmetic else
 if y = (get_int (_Geometric C_void)) then `Geometric else
`Int y)
| `Type -> C_enum (
 if y = (get_int (_Dirty C_void)) then `Dirty else
 if y = (get_int (_Clean C_void)) then `Clean else
`Int y)
| `InterpolationType -> C_enum (
 if y = (get_int (_AsIndex C_void)) then `AsIndex else
 if y = (get_int (_Flat C_void)) then `Flat else
 if y = (get_int (_Linear C_void)) then `Linear else
`Int y)
| `Side -> C_enum (
 if y = (get_int (_Buyer C_void)) then `Buyer else
 if y = (get_int (_Seller C_void)) then `Seller else
`Int y)
| `ConversionType -> C_enum (
 if y = (get_int (_NoConversion C_void)) then `NoConversion else
 if y = (get_int (_BaseCurrencyConversion C_void)) then `BaseCurrencyConversion else
 if y = (get_int (_AutomatedConversion C_void)) then `AutomatedConversion else
`Int y)
| `Type -> C_enum (
 if y = (get_int (_Direct C_void)) then `Direct else
 if y = (get_int (_Derived C_void)) then `Derived else
`Int y)
| `Type -> C_enum (
 if y = (get_int (_IMM C_void)) then `IMM else
 if y = (get_int (_ASX C_void)) then `ASX else
`Int y)
| `Choice -> C_enum (
 if y = (get_int (_MaturityDate C_void)) then `MaturityDate else
 if y = (get_int (_LastRelevantDate C_void)) then `LastRelevantDate else
 if y = (get_int (_CustomDate C_void)) then `CustomDate else
`Int y)
| `Type -> C_enum (
 if y = (get_int (_Long C_void)) then `Long else
 if y = (get_int (_Short C_void)) then `Short else
`Int y)
| `Adjustments -> C_enum (
 if y = (get_int (_AdjustNone C_void)) then `AdjustNone else
 if y = (get_int (_AdjustDigitals C_void)) then `AdjustDigitals else
 if y = (get_int (_AdjustYts C_void)) then `AdjustYts else
 if y = (get_int (_ExtrapolatePayoffFlat C_void)) then `ExtrapolatePayoffFlat else
 if y = (get_int (_NoPayoffExtrapolation C_void)) then `NoPayoffExtrapolation else
 if y = (get_int (_KahaleSmile C_void)) then `KahaleSmile else
 if y = (get_int (_SmileExponentialExtrapolation C_void)) then `SmileExponentialExtrapolation else
 if y = (get_int (_KahaleInterpolation C_void)) then `KahaleInterpolation else
 if y = (get_int (_SmileDeleteArbitragePoints C_void)) then `SmileDeleteArbitragePoints else
 if y = (get_int (_SabrSmile C_void)) then `SabrSmile else
`Int y)
| `DirectionIntegers -> C_enum (
 if y = (get_int (_Unit C_void)) then `Unit else
 if y = (get_int (_Jaeckel C_void)) then `Jaeckel else
 if y = (get_int (_SobolLevitan C_void)) then `SobolLevitan else
 if y = (get_int (_SobolLevitanLemieux C_void)) then `SobolLevitanLemieux else
 if y = (get_int (_JoeKuoD5 C_void)) then `JoeKuoD5 else
 if y = (get_int (_JoeKuoD6 C_void)) then `JoeKuoD6 else
 if y = (get_int (_JoeKuoD7 C_void)) then `JoeKuoD7 else
 if y = (get_int (_Kuo C_void)) then `Kuo else
 if y = (get_int (_Kuo2 C_void)) then `Kuo2 else
 if y = (get_int (_Kuo3 C_void)) then `Kuo3 else
`Int y)
| `Type -> C_enum (
 if y = (get_int (_Physical C_void)) then `Physical else
 if y = (get_int (_Cash C_void)) then `Cash else
`Int y)
let _ = Callback.register "QuantLib_int_to_enum" int_to_enum

let create_Period_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "length", _Period_length ;
    "units", _Period_units ;
    "frequency", _Period_frequency ;
    "__str__", _Period___str__ ;
    "__repr__", _Period___repr__ ;
    "~", _delete_Period ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Period") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Period"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Period_from_ptr"
          create_Period_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenPeriod_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _PeriodVector_size ;
    "empty", _PeriodVector_empty ;
    "clear", _PeriodVector_clear ;
    "push_back", _PeriodVector_push_back ;
    "[]", _PeriodVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _PeriodVector_operator_xx_xx_equals ;
    "set", _PeriodVector_set ;
    "to_array", _PeriodVector_to_array ;
    "~", _delete_PeriodVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(Period)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(Period)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< Period >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenPeriod_xx_rparen_xx_rdbrace_from_ptr



let create_Date_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "weekday", _Date_weekday ;
    "dayOfMonth", _Date_dayOfMonth ;
    "dayOfYear", _Date_dayOfYear ;
    "month", _Date_month ;
    "year", _Date_year ;
    "hours", _Date_hours ;
    "minutes", _Date_minutes ;
    "seconds", _Date_seconds ;
    "milliseconds", _Date_milliseconds ;
    "microseconds", _Date_microseconds ;
    "fractionOfDay", _Date_fractionOfDay ;
    "fractionOfSecond", _Date_fractionOfSecond ;
    "serialNumber", _Date_serialNumber ;
    "weekdayNumber", _Date_weekdayNumber ;
    "__str__", _Date___str__ ;
    "__repr__", _Date___repr__ ;
    "ISO", _Date_ISO ;
    "~", _delete_Date ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Date") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Date"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Date_from_ptr"
          create_Date_from_ptr



let create_DateParser_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DateParser ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DateParser") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DateParser"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DateParser_from_ptr"
          create_DateParser_from_ptr



let create_PeriodParser_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_PeriodParser ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PeriodParser") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PeriodParser"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PeriodParser_from_ptr"
          create_PeriodParser_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenDate_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _DateVector_size ;
    "empty", _DateVector_empty ;
    "clear", _DateVector_clear ;
    "push_back", _DateVector_push_back ;
    "[]", _DateVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _DateVector_operator_xx_xx_equals ;
    "set", _DateVector_set ;
    "to_array", _DateVector_to_array ;
    "~", _delete_DateVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(Date)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(Date)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< Date >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenDate_xx_rparen_xx_rdbrace_from_ptr



let create_IMM_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_IMM ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "IMM") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"IMM"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_IMM_from_ptr"
          create_IMM_from_ptr



let create_ASX_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ASX ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ASX") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ASX"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ASX_from_ptr"
          create_ASX_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenint_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _IntVector_size ;
    "empty", _IntVector_empty ;
    "clear", _IntVector_clear ;
    "push_back", _IntVector_push_back ;
    "[]", _IntVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _IntVector_operator_xx_xx_equals ;
    "set", _IntVector_set ;
    "to_array", _IntVector_to_array ;
    "~", _delete_IntVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(int)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(int)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< int >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenint_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenunsigned_xxint_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _UnsignedIntVector_size ;
    "empty", _UnsignedIntVector_empty ;
    "clear", _UnsignedIntVector_clear ;
    "push_back", _UnsignedIntVector_push_back ;
    "[]", _UnsignedIntVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _UnsignedIntVector_operator_xx_xx_equals ;
    "set", _UnsignedIntVector_set ;
    "to_array", _UnsignedIntVector_to_array ;
    "~", _delete_UnsignedIntVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(unsigned int)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(unsigned int)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< unsigned int >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenunsigned_xxint_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparendouble_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _DoubleVector_size ;
    "empty", _DoubleVector_empty ;
    "clear", _DoubleVector_clear ;
    "push_back", _DoubleVector_push_back ;
    "[]", _DoubleVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _DoubleVector_operator_xx_xx_equals ;
    "set", _DoubleVector_set ;
    "to_array", _DoubleVector_to_array ;
    "~", _delete_DoubleVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(double)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(double)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< double >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparendouble_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenstd_xxstring_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _StrVector_size ;
    "empty", _StrVector_empty ;
    "clear", _StrVector_clear ;
    "push_back", _StrVector_push_back ;
    "[]", _StrVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _StrVector_operator_xx_xx_equals ;
    "set", _StrVector_set ;
    "to_array", _StrVector_to_array ;
    "~", _delete_StrVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(std::string)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(std::string)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< std::string >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenstd_xxstring_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenbool_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _BoolVector_size ;
    "empty", _BoolVector_empty ;
    "clear", _BoolVector_clear ;
    "push_back", _BoolVector_push_back ;
    "[]", _BoolVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _BoolVector_operator_xx_xx_equals ;
    "set", _BoolVector_set ;
    "to_array", _BoolVector_to_array ;
    "~", _delete_BoolVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(bool)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(bool)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< bool >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenbool_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxpair_xx_ldbrace_xx_lparenDate_xdouble_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "", _NodePair_first_set ;
    "", _NodePair_first_get ;
    "", _NodePair_second_set ;
    "", _NodePair_second_get ;
    "~", _delete_NodePair ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::pair<(Date,double)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::pair<(Date,double)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::pair< Date,double >_from_ptr"
          create_std_xxpair_xx_ldbrace_xx_lparenDate_xdouble_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenstd_xxpair_xx_ldbrace_xx_lparenDate_xdouble_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _NodeVector_size ;
    "empty", _NodeVector_empty ;
    "clear", _NodeVector_clear ;
    "push_back", _NodeVector_push_back ;
    "[]", _NodeVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _NodeVector_operator_xx_xx_equals ;
    "set", _NodeVector_set ;
    "to_array", _NodeVector_to_array ;
    "~", _delete_NodeVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(std::pair<(Date,double)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(std::pair<(Date,double)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< std::pair< Date,double > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenstd_xxpair_xx_ldbrace_xx_lparenDate_xdouble_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenExercise_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _Exercise___deref__ ;
    "isNull", _Exercise_isNull ;
    "exerciseType", _Exercise_exerciseType ;
    "~", _delete_Exercise ;
    "type", _Exercise_type ;
    "dates", _Exercise_dates ;
    "lastDate", _Exercise_lastDate ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(Exercise)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(Exercise)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< Exercise >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenExercise_xx_rparen_xx_rdbrace_from_ptr



let create_EuropeanExercisePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EuropeanExercise ;
   "::boost::shared_ptr<(Exercise)>", (fun args -> (create_class "boost::shared_ptr<(Exercise)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EuropeanExercisePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Exercise)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EuropeanExercisePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EuropeanExercisePtr_from_ptr"
          create_EuropeanExercisePtr_from_ptr



let create_AmericanExercisePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AmericanExercise ;
   "::boost::shared_ptr<(Exercise)>", (fun args -> (create_class "boost::shared_ptr<(Exercise)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AmericanExercisePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Exercise)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AmericanExercisePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AmericanExercisePtr_from_ptr"
          create_AmericanExercisePtr_from_ptr



let create_BermudanExercisePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BermudanExercise ;
   "::boost::shared_ptr<(Exercise)>", (fun args -> (create_class "boost::shared_ptr<(Exercise)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BermudanExercisePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Exercise)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BermudanExercisePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BermudanExercisePtr_from_ptr"
          create_BermudanExercisePtr_from_ptr



let create_RebatedExercisePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_RebatedExercise ;
   "::boost::shared_ptr<(Exercise)>", (fun args -> (create_class "boost::shared_ptr<(Exercise)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RebatedExercisePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Exercise)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RebatedExercisePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RebatedExercisePtr_from_ptr"
          create_RebatedExercisePtr_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenObservable_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _Observable___deref__ ;
    "isNull", _Observable_isNull ;
    "~", _delete_Observable ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(Observable)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(Observable)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< Observable >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenObservable_xx_rparen_xx_rdbrace_from_ptr



let create_Array_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _Array_size ;
    "__str__", _Array___str__ ;
    "~", _delete_Array ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Array") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Array"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Array_from_ptr"
          create_Array_from_ptr



let create_DefaultLexicographicalView_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "xSize", _LexicographicalView_xSize ;
    "ySize", _LexicographicalView_ySize ;
    "__str__", _LexicographicalView___str__ ;
    "~", _delete_LexicographicalView ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DefaultLexicographicalView") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DefaultLexicographicalView"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DefaultLexicographicalView_from_ptr"
          create_DefaultLexicographicalView_from_ptr



let create_Matrix_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "rows", _Matrix_rows ;
    "columns", _Matrix_columns ;
    "__str__", _Matrix___str__ ;
    "~", _delete_Matrix ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Matrix") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Matrix"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Matrix_from_ptr"
          create_Matrix_from_ptr



let create_SalvagingAlgorithm_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SalvagingAlgorithm ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SalvagingAlgorithm") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SalvagingAlgorithm"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SalvagingAlgorithm_from_ptr"
          create_SalvagingAlgorithm_from_ptr



let create_SVD_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "U", _SVD_U ;
    "V", _SVD_V ;
    "S", _SVD_S ;
    "singularValues", _SVD_singularValues ;
    "~", _delete_SVD ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SVD") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SVD"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SVD_from_ptr"
          create_SVD_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _Quote___deref__ ;
    "isNull", _Quote_isNull ;
    "asObservable", _Quote_asObservable ;
    "~", _delete_Quote ;
    "value", _Quote_value ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(Quote)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(Quote)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< Quote >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _QuoteHandle___deref__ ;
    "empty", _QuoteHandle_empty ;
    "asObservable", _QuoteHandle_asObservable ;
    "~", _delete_QuoteHandle ;
    "value", _QuoteHandle_value ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(Quote)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(Quote)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< Quote >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableQuoteHandle_linkTo ;
    "~", _delete_RelinkableQuoteHandle ;
   "::Handle<(Quote)>", (fun args -> (create_class "Handle<(Quote)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(Quote)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(Quote)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(Quote)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< Quote >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_from_ptr



let create_SimpleQuotePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "setValue", _SimpleQuote_setValue ;
    "~", _delete_SimpleQuote ;
   "::boost::shared_ptr<(Quote)>", (fun args -> (create_class "boost::shared_ptr<(Quote)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SimpleQuotePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Quote)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SimpleQuotePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SimpleQuotePtr_from_ptr"
          create_SimpleQuotePtr_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _QuoteVector_size ;
    "empty", _QuoteVector_empty ;
    "clear", _QuoteVector_clear ;
    "push_back", _QuoteVector_push_back ;
    "[]", _QuoteVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _QuoteVector_operator_xx_xx_equals ;
    "set", _QuoteVector_set ;
    "to_array", _QuoteVector_to_array ;
    "~", _delete_QuoteVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(boost::shared_ptr<(Quote)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(boost::shared_ptr<(Quote)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< boost::shared_ptr< Quote > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenstd_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _QuoteVectorVector_size ;
    "empty", _QuoteVectorVector_empty ;
    "clear", _QuoteVectorVector_clear ;
    "push_back", _QuoteVectorVector_push_back ;
    "[]", _QuoteVectorVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _QuoteVectorVector_operator_xx_xx_equals ;
    "set", _QuoteVectorVector_set ;
    "to_array", _QuoteVectorVector_to_array ;
    "~", _delete_QuoteVectorVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(std::vector<(boost::shared_ptr<(Quote)>)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(std::vector<(boost::shared_ptr<(Quote)>)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< std::vector< boost::shared_ptr< Quote > > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenstd_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenHandle_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _QuoteHandleVector_size ;
    "empty", _QuoteHandleVector_empty ;
    "clear", _QuoteHandleVector_clear ;
    "push_back", _QuoteHandleVector_push_back ;
    "[]", _QuoteHandleVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _QuoteHandleVector_operator_xx_xx_equals ;
    "set", _QuoteHandleVector_set ;
    "to_array", _QuoteHandleVector_to_array ;
    "~", _delete_QuoteHandleVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(Handle<(Quote)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(Handle<(Quote)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< Handle< Quote > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenHandle_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenstd_xxvector_xx_ldbrace_xx_lparenHandle_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _QuoteHandleVectorVector_size ;
    "empty", _QuoteHandleVectorVector_empty ;
    "clear", _QuoteHandleVectorVector_clear ;
    "push_back", _QuoteHandleVectorVector_push_back ;
    "[]", _QuoteHandleVectorVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _QuoteHandleVectorVector_operator_xx_xx_equals ;
    "set", _QuoteHandleVectorVector_set ;
    "to_array", _QuoteHandleVectorVector_to_array ;
    "~", _delete_QuoteHandleVectorVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(std::vector<(Handle<(Quote)>)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(std::vector<(Handle<(Quote)>)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< std::vector< Handle< Quote > > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenstd_xxvector_xx_ldbrace_xx_lparenHandle_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenRelinkableHandle_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _RelinkableQuoteHandleVector_size ;
    "empty", _RelinkableQuoteHandleVector_empty ;
    "clear", _RelinkableQuoteHandleVector_clear ;
    "push_back", _RelinkableQuoteHandleVector_push_back ;
    "[]", _RelinkableQuoteHandleVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _RelinkableQuoteHandleVector_operator_xx_xx_equals ;
    "set", _RelinkableQuoteHandleVector_set ;
    "to_array", _RelinkableQuoteHandleVector_to_array ;
    "~", _delete_RelinkableQuoteHandleVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(RelinkableHandle<(Quote)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(RelinkableHandle<(Quote)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< RelinkableHandle< Quote > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenRelinkableHandle_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenstd_xxvector_xx_ldbrace_xx_lparenRelinkableHandle_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _RelinkableQuoteHandleVectorVector_size ;
    "empty", _RelinkableQuoteHandleVectorVector_empty ;
    "clear", _RelinkableQuoteHandleVectorVector_clear ;
    "push_back", _RelinkableQuoteHandleVectorVector_push_back ;
    "[]", _RelinkableQuoteHandleVectorVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _RelinkableQuoteHandleVectorVector_operator_xx_xx_equals ;
    "set", _RelinkableQuoteHandleVectorVector_set ;
    "to_array", _RelinkableQuoteHandleVectorVector_to_array ;
    "~", _delete_RelinkableQuoteHandleVectorVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(std::vector<(RelinkableHandle<(Quote)>)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(std::vector<(RelinkableHandle<(Quote)>)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< std::vector< RelinkableHandle< Quote > > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenstd_xxvector_xx_ldbrace_xx_lparenRelinkableHandle_xx_ldbrace_xx_lparenQuote_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_Calendar_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "isWeekend", _Calendar_isWeekend ;
    "endOfMonth", _Calendar_endOfMonth ;
    "isBusinessDay", _Calendar_isBusinessDay ;
    "isHoliday", _Calendar_isHoliday ;
    "isEndOfMonth", _Calendar_isEndOfMonth ;
    "addHoliday", _Calendar_addHoliday ;
    "removeHoliday", _Calendar_removeHoliday ;
    "adjust", _Calendar_adjust ;
    "adjust", _Calendar_adjust ;
    "advance", _Calendar_advance ;
    "advance", _Calendar_advance ;
    "advance", _Calendar_advance ;
    "advance", _Calendar_advance ;
    "advance", _Calendar_advance ;
    "advance", _Calendar_advance ;
    "businessDaysBetween", _Calendar_businessDaysBetween ;
    "businessDaysBetween", _Calendar_businessDaysBetween ;
    "businessDaysBetween", _Calendar_businessDaysBetween ;
    "name", _Calendar_name ;
    "__str__", _Calendar___str__ ;
    "~", _delete_Calendar ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Calendar") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Calendar"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Calendar_from_ptr"
          create_Calendar_from_ptr



let create_QuantLib_xxArgentina_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Argentina ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Argentina") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Argentina"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Argentina_from_ptr"
          create_QuantLib_xxArgentina_from_ptr



let create_QuantLib_xxAustralia_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Australia ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Australia") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Australia"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Australia_from_ptr"
          create_QuantLib_xxAustralia_from_ptr



let create_QuantLib_xxBrazil_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Brazil ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Brazil") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Brazil"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Brazil_from_ptr"
          create_QuantLib_xxBrazil_from_ptr



let create_QuantLib_xxCanada_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Canada ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Canada") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Canada"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Canada_from_ptr"
          create_QuantLib_xxCanada_from_ptr



let create_QuantLib_xxChina_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_China ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::China") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::China"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::China_from_ptr"
          create_QuantLib_xxChina_from_ptr



let create_QuantLib_xxCzechRepublic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CzechRepublic ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::CzechRepublic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::CzechRepublic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::CzechRepublic_from_ptr"
          create_QuantLib_xxCzechRepublic_from_ptr



let create_QuantLib_xxDenmark_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Denmark ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Denmark") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Denmark"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Denmark_from_ptr"
          create_QuantLib_xxDenmark_from_ptr



let create_QuantLib_xxFinland_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Finland ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Finland") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Finland"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Finland_from_ptr"
          create_QuantLib_xxFinland_from_ptr



let create_QuantLib_xxGermany_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Germany ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Germany") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Germany"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Germany_from_ptr"
          create_QuantLib_xxGermany_from_ptr



let create_QuantLib_xxHongKong_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_HongKong ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::HongKong") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::HongKong"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::HongKong_from_ptr"
          create_QuantLib_xxHongKong_from_ptr



let create_QuantLib_xxHungary_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Hungary ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Hungary") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Hungary"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Hungary_from_ptr"
          create_QuantLib_xxHungary_from_ptr



let create_QuantLib_xxIceland_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Iceland ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Iceland") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Iceland"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Iceland_from_ptr"
          create_QuantLib_xxIceland_from_ptr



let create_QuantLib_xxIndia_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_India ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::India") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::India"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::India_from_ptr"
          create_QuantLib_xxIndia_from_ptr



let create_QuantLib_xxIndonesia_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Indonesia ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Indonesia") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Indonesia"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Indonesia_from_ptr"
          create_QuantLib_xxIndonesia_from_ptr



let create_QuantLib_xxIsrael_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Israel ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Israel") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Israel"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Israel_from_ptr"
          create_QuantLib_xxIsrael_from_ptr



let create_QuantLib_xxItaly_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Italy ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Italy") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Italy"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Italy_from_ptr"
          create_QuantLib_xxItaly_from_ptr



let create_QuantLib_xxJapan_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Japan ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Japan") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Japan"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Japan_from_ptr"
          create_QuantLib_xxJapan_from_ptr



let create_QuantLib_xxMexico_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Mexico ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Mexico") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Mexico"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Mexico_from_ptr"
          create_QuantLib_xxMexico_from_ptr



let create_QuantLib_xxNewZealand_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NewZealand ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::NewZealand") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::NewZealand"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::NewZealand_from_ptr"
          create_QuantLib_xxNewZealand_from_ptr



let create_QuantLib_xxNorway_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Norway ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Norway") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Norway"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Norway_from_ptr"
          create_QuantLib_xxNorway_from_ptr



let create_QuantLib_xxPoland_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Poland ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Poland") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Poland"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Poland_from_ptr"
          create_QuantLib_xxPoland_from_ptr



let create_QuantLib_xxRussia_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Russia ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Russia") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Russia"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Russia_from_ptr"
          create_QuantLib_xxRussia_from_ptr



let create_QuantLib_xxRomania_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Romania ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Romania") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Romania"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Romania_from_ptr"
          create_QuantLib_xxRomania_from_ptr



let create_QuantLib_xxSaudiArabia_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SaudiArabia ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::SaudiArabia") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::SaudiArabia"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::SaudiArabia_from_ptr"
          create_QuantLib_xxSaudiArabia_from_ptr



let create_QuantLib_xxSingapore_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Singapore ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Singapore") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Singapore"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Singapore_from_ptr"
          create_QuantLib_xxSingapore_from_ptr



let create_QuantLib_xxSlovakia_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Slovakia ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Slovakia") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Slovakia"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Slovakia_from_ptr"
          create_QuantLib_xxSlovakia_from_ptr



let create_QuantLib_xxSouthAfrica_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SouthAfrica ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::SouthAfrica") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::SouthAfrica"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::SouthAfrica_from_ptr"
          create_QuantLib_xxSouthAfrica_from_ptr



let create_QuantLib_xxSouthKorea_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SouthKorea ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::SouthKorea") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::SouthKorea"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::SouthKorea_from_ptr"
          create_QuantLib_xxSouthKorea_from_ptr



let create_QuantLib_xxSweden_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Sweden ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Sweden") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Sweden"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Sweden_from_ptr"
          create_QuantLib_xxSweden_from_ptr



let create_QuantLib_xxSwitzerland_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Switzerland ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Switzerland") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Switzerland"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Switzerland_from_ptr"
          create_QuantLib_xxSwitzerland_from_ptr



let create_QuantLib_xxTaiwan_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Taiwan ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Taiwan") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Taiwan"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Taiwan_from_ptr"
          create_QuantLib_xxTaiwan_from_ptr



let create_QuantLib_xxTARGET_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_TARGET ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::TARGET") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::TARGET"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::TARGET_from_ptr"
          create_QuantLib_xxTARGET_from_ptr



let create_QuantLib_xxTurkey_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Turkey ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Turkey") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Turkey"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Turkey_from_ptr"
          create_QuantLib_xxTurkey_from_ptr



let create_QuantLib_xxUkraine_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Ukraine ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Ukraine") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Ukraine"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Ukraine_from_ptr"
          create_QuantLib_xxUkraine_from_ptr



let create_QuantLib_xxUnitedKingdom_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_UnitedKingdom ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::UnitedKingdom") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::UnitedKingdom"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::UnitedKingdom_from_ptr"
          create_QuantLib_xxUnitedKingdom_from_ptr



let create_QuantLib_xxUnitedStates_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_UnitedStates ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::UnitedStates") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::UnitedStates"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::UnitedStates_from_ptr"
          create_QuantLib_xxUnitedStates_from_ptr



let create_QuantLib_xxNullCalendar_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NullCalendar ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::NullCalendar") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::NullCalendar"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::NullCalendar_from_ptr"
          create_QuantLib_xxNullCalendar_from_ptr



let create_QuantLib_xxWeekendsOnly_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_WeekendsOnly ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::WeekendsOnly") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::WeekendsOnly"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::WeekendsOnly_from_ptr"
          create_QuantLib_xxWeekendsOnly_from_ptr



let create_QuantLib_xxJointCalendar_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_JointCalendar ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::JointCalendar") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::JointCalendar"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::JointCalendar_from_ptr"
          create_QuantLib_xxJointCalendar_from_ptr



let create_QuantLib_xxBespokeCalendar_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "addWeekend", _BespokeCalendar_addWeekend ;
    "~", _delete_BespokeCalendar ;
   "::Calendar", (fun args -> (create_class "Calendar") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::BespokeCalendar") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Calendar") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::BespokeCalendar"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::BespokeCalendar_from_ptr"
          create_QuantLib_xxBespokeCalendar_from_ptr



let create_DayCounter_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dayCount", _DayCounter_dayCount ;
    "yearFraction", _DayCounter_yearFraction ;
    "yearFraction", _DayCounter_yearFraction ;
    "yearFraction", _DayCounter_yearFraction ;
    "name", _DayCounter_name ;
    "__str__", _DayCounter___str__ ;
    "~", _delete_DayCounter ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DayCounter") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DayCounter"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DayCounter_from_ptr"
          create_DayCounter_from_ptr



let create_QuantLib_xxActual360_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Actual360 ;
   "::DayCounter", (fun args -> (create_class "DayCounter") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Actual360") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "DayCounter") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Actual360"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Actual360_from_ptr"
          create_QuantLib_xxActual360_from_ptr



let create_QuantLib_xxActual365Fixed_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Actual365Fixed ;
   "::DayCounter", (fun args -> (create_class "DayCounter") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Actual365Fixed") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "DayCounter") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Actual365Fixed"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Actual365Fixed_from_ptr"
          create_QuantLib_xxActual365Fixed_from_ptr



let create_QuantLib_xxThirty360_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Thirty360 ;
   "::DayCounter", (fun args -> (create_class "DayCounter") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Thirty360") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "DayCounter") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Thirty360"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Thirty360_from_ptr"
          create_QuantLib_xxThirty360_from_ptr



let create_QuantLib_xxActualActual_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ActualActual ;
   "::DayCounter", (fun args -> (create_class "DayCounter") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::ActualActual") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "DayCounter") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::ActualActual"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::ActualActual_from_ptr"
          create_QuantLib_xxActualActual_from_ptr



let create_QuantLib_xxOneDayCounter_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_OneDayCounter ;
   "::DayCounter", (fun args -> (create_class "DayCounter") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::OneDayCounter") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "DayCounter") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::OneDayCounter"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::OneDayCounter_from_ptr"
          create_QuantLib_xxOneDayCounter_from_ptr



let create_QuantLib_xxSimpleDayCounter_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SimpleDayCounter ;
   "::DayCounter", (fun args -> (create_class "DayCounter") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::SimpleDayCounter") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "DayCounter") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::SimpleDayCounter"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::SimpleDayCounter_from_ptr"
          create_QuantLib_xxSimpleDayCounter_from_ptr



let create_QuantLib_xxBusiness252_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Business252 ;
   "::DayCounter", (fun args -> (create_class "DayCounter") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::Business252") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "DayCounter") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::Business252"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::Business252_from_ptr"
          create_QuantLib_xxBusiness252_from_ptr



let create_InterestRate_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "rate", _InterestRate_rate ;
    "dayCounter", _InterestRate_dayCounter ;
    "compounding", _InterestRate_compounding ;
    "frequency", _InterestRate_frequency ;
    "discountFactor", _InterestRate_discountFactor ;
    "discountFactor", _InterestRate_discountFactor ;
    "discountFactor", _InterestRate_discountFactor ;
    "discountFactor", _InterestRate_discountFactor ;
    "compoundFactor", _InterestRate_compoundFactor ;
    "compoundFactor", _InterestRate_compoundFactor ;
    "compoundFactor", _InterestRate_compoundFactor ;
    "compoundFactor", _InterestRate_compoundFactor ;
    "equivalentRate", _InterestRate_equivalentRate ;
    "equivalentRate", _InterestRate_equivalentRate ;
    "equivalentRate", _InterestRate_equivalentRate ;
    "equivalentRate", _InterestRate_equivalentRate ;
    "__str__", _InterestRate___str__ ;
    "~", _delete_InterestRate ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InterestRate") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InterestRate"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InterestRate_from_ptr"
          create_InterestRate_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenInterestRate_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _InterestRateVector_size ;
    "empty", _InterestRateVector_empty ;
    "clear", _InterestRateVector_clear ;
    "push_back", _InterestRateVector_push_back ;
    "[]", _InterestRateVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _InterestRateVector_operator_xx_xx_equals ;
    "set", _InterestRateVector_set ;
    "to_array", _InterestRateVector_to_array ;
    "~", _delete_InterestRateVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(InterestRate)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(InterestRate)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< InterestRate >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenInterestRate_xx_rparen_xx_rdbrace_from_ptr



let create_Rounding_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _Rounding_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_Rounding ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Rounding") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Rounding"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Rounding_from_ptr"
          create_Rounding_from_ptr



let create_UpRounding_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_UpRounding ;
   "::Rounding", (fun args -> (create_class "Rounding") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "UpRounding") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Rounding") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"UpRounding"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_UpRounding_from_ptr"
          create_UpRounding_from_ptr



let create_DownRounding_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DownRounding ;
   "::Rounding", (fun args -> (create_class "Rounding") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DownRounding") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Rounding") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DownRounding"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DownRounding_from_ptr"
          create_DownRounding_from_ptr



let create_ClosestRounding_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ClosestRounding ;
   "::Rounding", (fun args -> (create_class "Rounding") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ClosestRounding") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Rounding") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ClosestRounding"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ClosestRounding_from_ptr"
          create_ClosestRounding_from_ptr



let create_CeilingTruncation_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CeilingTruncation ;
   "::Rounding", (fun args -> (create_class "Rounding") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CeilingTruncation") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Rounding") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CeilingTruncation"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CeilingTruncation_from_ptr"
          create_CeilingTruncation_from_ptr



let create_FloorTruncation_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FloorTruncation ;
   "::Rounding", (fun args -> (create_class "Rounding") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FloorTruncation") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Rounding") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FloorTruncation"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FloorTruncation_from_ptr"
          create_FloorTruncation_from_ptr



let create_Currency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "name", _Currency_name ;
    "code", _Currency_code ;
    "numericCode", _Currency_numericCode ;
    "symbol", _Currency_symbol ;
    "fractionSymbol", _Currency_fractionSymbol ;
    "fractionsPerUnit", _Currency_fractionsPerUnit ;
    "rounding", _Currency_rounding ;
    "format", _Currency_format ;
    "empty", _Currency_empty ;
    "triangulationCurrency", _Currency_triangulationCurrency ;
    "__str__", _Currency___str__ ;
    "~", _delete_Currency ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Currency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Currency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Currency_from_ptr"
          create_Currency_from_ptr



let create_QuantLib_xxARSCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ARSCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::ARSCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::ARSCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::ARSCurrency_from_ptr"
          create_QuantLib_xxARSCurrency_from_ptr



let create_QuantLib_xxATSCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ATSCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::ATSCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::ATSCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::ATSCurrency_from_ptr"
          create_QuantLib_xxATSCurrency_from_ptr



let create_QuantLib_xxAUDCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AUDCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::AUDCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::AUDCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::AUDCurrency_from_ptr"
          create_QuantLib_xxAUDCurrency_from_ptr



let create_QuantLib_xxBDTCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BDTCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::BDTCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::BDTCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::BDTCurrency_from_ptr"
          create_QuantLib_xxBDTCurrency_from_ptr



let create_QuantLib_xxBEFCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BEFCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::BEFCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::BEFCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::BEFCurrency_from_ptr"
          create_QuantLib_xxBEFCurrency_from_ptr



let create_QuantLib_xxBGLCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BGLCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::BGLCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::BGLCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::BGLCurrency_from_ptr"
          create_QuantLib_xxBGLCurrency_from_ptr



let create_QuantLib_xxBRLCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BRLCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::BRLCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::BRLCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::BRLCurrency_from_ptr"
          create_QuantLib_xxBRLCurrency_from_ptr



let create_QuantLib_xxBYRCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BYRCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::BYRCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::BYRCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::BYRCurrency_from_ptr"
          create_QuantLib_xxBYRCurrency_from_ptr



let create_QuantLib_xxCADCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CADCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::CADCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::CADCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::CADCurrency_from_ptr"
          create_QuantLib_xxCADCurrency_from_ptr



let create_QuantLib_xxCHFCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CHFCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::CHFCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::CHFCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::CHFCurrency_from_ptr"
          create_QuantLib_xxCHFCurrency_from_ptr



let create_QuantLib_xxCLPCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CLPCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::CLPCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::CLPCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::CLPCurrency_from_ptr"
          create_QuantLib_xxCLPCurrency_from_ptr



let create_QuantLib_xxCNYCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CNYCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::CNYCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::CNYCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::CNYCurrency_from_ptr"
          create_QuantLib_xxCNYCurrency_from_ptr



let create_QuantLib_xxCOPCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_COPCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::COPCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::COPCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::COPCurrency_from_ptr"
          create_QuantLib_xxCOPCurrency_from_ptr



let create_QuantLib_xxCYPCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CYPCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::CYPCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::CYPCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::CYPCurrency_from_ptr"
          create_QuantLib_xxCYPCurrency_from_ptr



let create_QuantLib_xxCZKCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CZKCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::CZKCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::CZKCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::CZKCurrency_from_ptr"
          create_QuantLib_xxCZKCurrency_from_ptr



let create_QuantLib_xxDEMCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DEMCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::DEMCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::DEMCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::DEMCurrency_from_ptr"
          create_QuantLib_xxDEMCurrency_from_ptr



let create_QuantLib_xxDKKCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DKKCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::DKKCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::DKKCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::DKKCurrency_from_ptr"
          create_QuantLib_xxDKKCurrency_from_ptr



let create_QuantLib_xxEEKCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EEKCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::EEKCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::EEKCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::EEKCurrency_from_ptr"
          create_QuantLib_xxEEKCurrency_from_ptr



let create_QuantLib_xxESPCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ESPCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::ESPCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::ESPCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::ESPCurrency_from_ptr"
          create_QuantLib_xxESPCurrency_from_ptr



let create_QuantLib_xxEURCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::EURCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::EURCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::EURCurrency_from_ptr"
          create_QuantLib_xxEURCurrency_from_ptr



let create_QuantLib_xxFIMCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FIMCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::FIMCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::FIMCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::FIMCurrency_from_ptr"
          create_QuantLib_xxFIMCurrency_from_ptr



let create_QuantLib_xxFRFCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FRFCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::FRFCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::FRFCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::FRFCurrency_from_ptr"
          create_QuantLib_xxFRFCurrency_from_ptr



let create_QuantLib_xxGBPCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GBPCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::GBPCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::GBPCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::GBPCurrency_from_ptr"
          create_QuantLib_xxGBPCurrency_from_ptr



let create_QuantLib_xxGRDCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GRDCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::GRDCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::GRDCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::GRDCurrency_from_ptr"
          create_QuantLib_xxGRDCurrency_from_ptr



let create_QuantLib_xxHKDCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_HKDCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::HKDCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::HKDCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::HKDCurrency_from_ptr"
          create_QuantLib_xxHKDCurrency_from_ptr



let create_QuantLib_xxHUFCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_HUFCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::HUFCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::HUFCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::HUFCurrency_from_ptr"
          create_QuantLib_xxHUFCurrency_from_ptr



let create_QuantLib_xxIEPCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_IEPCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::IEPCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::IEPCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::IEPCurrency_from_ptr"
          create_QuantLib_xxIEPCurrency_from_ptr



let create_QuantLib_xxIDRCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_IDRCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::IDRCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::IDRCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::IDRCurrency_from_ptr"
          create_QuantLib_xxIDRCurrency_from_ptr



let create_QuantLib_xxILSCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ILSCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::ILSCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::ILSCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::ILSCurrency_from_ptr"
          create_QuantLib_xxILSCurrency_from_ptr



let create_QuantLib_xxINRCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_INRCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::INRCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::INRCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::INRCurrency_from_ptr"
          create_QuantLib_xxINRCurrency_from_ptr



let create_QuantLib_xxIQDCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_IQDCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::IQDCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::IQDCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::IQDCurrency_from_ptr"
          create_QuantLib_xxIQDCurrency_from_ptr



let create_QuantLib_xxIRRCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_IRRCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::IRRCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::IRRCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::IRRCurrency_from_ptr"
          create_QuantLib_xxIRRCurrency_from_ptr



let create_QuantLib_xxISKCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ISKCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::ISKCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::ISKCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::ISKCurrency_from_ptr"
          create_QuantLib_xxISKCurrency_from_ptr



let create_QuantLib_xxITLCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ITLCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::ITLCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::ITLCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::ITLCurrency_from_ptr"
          create_QuantLib_xxITLCurrency_from_ptr



let create_QuantLib_xxJPYCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_JPYCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::JPYCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::JPYCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::JPYCurrency_from_ptr"
          create_QuantLib_xxJPYCurrency_from_ptr



let create_QuantLib_xxKRWCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_KRWCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::KRWCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::KRWCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::KRWCurrency_from_ptr"
          create_QuantLib_xxKRWCurrency_from_ptr



let create_QuantLib_xxKWDCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_KWDCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::KWDCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::KWDCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::KWDCurrency_from_ptr"
          create_QuantLib_xxKWDCurrency_from_ptr



let create_QuantLib_xxLTLCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_LTLCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::LTLCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::LTLCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::LTLCurrency_from_ptr"
          create_QuantLib_xxLTLCurrency_from_ptr



let create_QuantLib_xxLUFCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_LUFCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::LUFCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::LUFCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::LUFCurrency_from_ptr"
          create_QuantLib_xxLUFCurrency_from_ptr



let create_QuantLib_xxLVLCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_LVLCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::LVLCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::LVLCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::LVLCurrency_from_ptr"
          create_QuantLib_xxLVLCurrency_from_ptr



let create_QuantLib_xxMTLCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MTLCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::MTLCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::MTLCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::MTLCurrency_from_ptr"
          create_QuantLib_xxMTLCurrency_from_ptr



let create_QuantLib_xxMXNCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MXNCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::MXNCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::MXNCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::MXNCurrency_from_ptr"
          create_QuantLib_xxMXNCurrency_from_ptr



let create_QuantLib_xxMYRCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MYRCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::MYRCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::MYRCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::MYRCurrency_from_ptr"
          create_QuantLib_xxMYRCurrency_from_ptr



let create_QuantLib_xxNLGCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NLGCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::NLGCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::NLGCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::NLGCurrency_from_ptr"
          create_QuantLib_xxNLGCurrency_from_ptr



let create_QuantLib_xxNOKCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NOKCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::NOKCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::NOKCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::NOKCurrency_from_ptr"
          create_QuantLib_xxNOKCurrency_from_ptr



let create_QuantLib_xxNPRCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NPRCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::NPRCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::NPRCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::NPRCurrency_from_ptr"
          create_QuantLib_xxNPRCurrency_from_ptr



let create_QuantLib_xxNZDCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NZDCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::NZDCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::NZDCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::NZDCurrency_from_ptr"
          create_QuantLib_xxNZDCurrency_from_ptr



let create_QuantLib_xxPEHCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_PEHCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::PEHCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::PEHCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::PEHCurrency_from_ptr"
          create_QuantLib_xxPEHCurrency_from_ptr



let create_QuantLib_xxPEICurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_PEICurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::PEICurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::PEICurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::PEICurrency_from_ptr"
          create_QuantLib_xxPEICurrency_from_ptr



let create_QuantLib_xxPENCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_PENCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::PENCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::PENCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::PENCurrency_from_ptr"
          create_QuantLib_xxPENCurrency_from_ptr



let create_QuantLib_xxPKRCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_PKRCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::PKRCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::PKRCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::PKRCurrency_from_ptr"
          create_QuantLib_xxPKRCurrency_from_ptr



let create_QuantLib_xxPLNCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_PLNCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::PLNCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::PLNCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::PLNCurrency_from_ptr"
          create_QuantLib_xxPLNCurrency_from_ptr



let create_QuantLib_xxPTECurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_PTECurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::PTECurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::PTECurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::PTECurrency_from_ptr"
          create_QuantLib_xxPTECurrency_from_ptr



let create_QuantLib_xxROLCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ROLCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::ROLCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::ROLCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::ROLCurrency_from_ptr"
          create_QuantLib_xxROLCurrency_from_ptr



let create_QuantLib_xxRONCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_RONCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::RONCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::RONCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::RONCurrency_from_ptr"
          create_QuantLib_xxRONCurrency_from_ptr



let create_QuantLib_xxRUBCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_RUBCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::RUBCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::RUBCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::RUBCurrency_from_ptr"
          create_QuantLib_xxRUBCurrency_from_ptr



let create_QuantLib_xxSARCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SARCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::SARCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::SARCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::SARCurrency_from_ptr"
          create_QuantLib_xxSARCurrency_from_ptr



let create_QuantLib_xxSEKCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SEKCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::SEKCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::SEKCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::SEKCurrency_from_ptr"
          create_QuantLib_xxSEKCurrency_from_ptr



let create_QuantLib_xxSGDCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SGDCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::SGDCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::SGDCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::SGDCurrency_from_ptr"
          create_QuantLib_xxSGDCurrency_from_ptr



let create_QuantLib_xxSITCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SITCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::SITCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::SITCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::SITCurrency_from_ptr"
          create_QuantLib_xxSITCurrency_from_ptr



let create_QuantLib_xxSKKCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SKKCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::SKKCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::SKKCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::SKKCurrency_from_ptr"
          create_QuantLib_xxSKKCurrency_from_ptr



let create_QuantLib_xxTHBCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_THBCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::THBCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::THBCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::THBCurrency_from_ptr"
          create_QuantLib_xxTHBCurrency_from_ptr



let create_QuantLib_xxTRLCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_TRLCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::TRLCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::TRLCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::TRLCurrency_from_ptr"
          create_QuantLib_xxTRLCurrency_from_ptr



let create_QuantLib_xxTRYCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_TRYCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::TRYCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::TRYCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::TRYCurrency_from_ptr"
          create_QuantLib_xxTRYCurrency_from_ptr



let create_QuantLib_xxTTDCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_TTDCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::TTDCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::TTDCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::TTDCurrency_from_ptr"
          create_QuantLib_xxTTDCurrency_from_ptr



let create_QuantLib_xxTWDCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_TWDCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::TWDCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::TWDCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::TWDCurrency_from_ptr"
          create_QuantLib_xxTWDCurrency_from_ptr



let create_QuantLib_xxUSDCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_USDCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::USDCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::USDCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::USDCurrency_from_ptr"
          create_QuantLib_xxUSDCurrency_from_ptr



let create_QuantLib_xxVEBCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_VEBCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::VEBCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::VEBCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::VEBCurrency_from_ptr"
          create_QuantLib_xxVEBCurrency_from_ptr



let create_QuantLib_xxVNDCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_VNDCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::VNDCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::VNDCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::VNDCurrency_from_ptr"
          create_QuantLib_xxVNDCurrency_from_ptr



let create_QuantLib_xxZARCurrency_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ZARCurrency ;
   "::Currency", (fun args -> (create_class "Currency") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantLib::ZARCurrency") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Currency") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantLib::ZARCurrency"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantLib::ZARCurrency_from_ptr"
          create_QuantLib_xxZARCurrency_from_ptr



let create_SafeLinearInterpolation_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _LinearInterpolation_operator_xx_xx_lparen_xx_rparen ;
    "()", _LinearInterpolation_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_LinearInterpolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeLinearInterpolation") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeLinearInterpolation"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeLinearInterpolation_from_ptr"
          create_SafeLinearInterpolation_from_ptr



let create_SafeLogLinearInterpolation_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _LogLinearInterpolation_operator_xx_xx_lparen_xx_rparen ;
    "()", _LogLinearInterpolation_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_LogLinearInterpolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeLogLinearInterpolation") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeLogLinearInterpolation"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeLogLinearInterpolation_from_ptr"
          create_SafeLogLinearInterpolation_from_ptr



let create_SafeBackwardFlatInterpolation_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _BackwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen ;
    "()", _BackwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_BackwardFlatInterpolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeBackwardFlatInterpolation") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeBackwardFlatInterpolation"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeBackwardFlatInterpolation_from_ptr"
          create_SafeBackwardFlatInterpolation_from_ptr



let create_SafeForwardFlatInterpolation_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _ForwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen ;
    "()", _ForwardFlatInterpolation_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_ForwardFlatInterpolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeForwardFlatInterpolation") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeForwardFlatInterpolation"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeForwardFlatInterpolation_from_ptr"
          create_SafeForwardFlatInterpolation_from_ptr



let create_SafeCubicNaturalSpline_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _CubicNaturalSpline_operator_xx_xx_lparen_xx_rparen ;
    "()", _CubicNaturalSpline_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _CubicNaturalSpline_derivative ;
    "derivative", _CubicNaturalSpline_derivative ;
    "secondDerivative", _CubicNaturalSpline_secondDerivative ;
    "secondDerivative", _CubicNaturalSpline_secondDerivative ;
    "primitive", _CubicNaturalSpline_primitive ;
    "primitive", _CubicNaturalSpline_primitive ;
    "~", _delete_CubicNaturalSpline ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeCubicNaturalSpline") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeCubicNaturalSpline"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeCubicNaturalSpline_from_ptr"
          create_SafeCubicNaturalSpline_from_ptr



let create_SafeLogCubicNaturalSpline_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _LogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen ;
    "()", _LogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _LogCubicNaturalSpline_derivative ;
    "derivative", _LogCubicNaturalSpline_derivative ;
    "secondDerivative", _LogCubicNaturalSpline_secondDerivative ;
    "secondDerivative", _LogCubicNaturalSpline_secondDerivative ;
    "primitive", _LogCubicNaturalSpline_primitive ;
    "primitive", _LogCubicNaturalSpline_primitive ;
    "~", _delete_LogCubicNaturalSpline ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeLogCubicNaturalSpline") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeLogCubicNaturalSpline"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeLogCubicNaturalSpline_from_ptr"
          create_SafeLogCubicNaturalSpline_from_ptr



let create_SafeMonotonicCubicNaturalSpline_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _MonotonicCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen ;
    "()", _MonotonicCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _MonotonicCubicNaturalSpline_derivative ;
    "derivative", _MonotonicCubicNaturalSpline_derivative ;
    "secondDerivative", _MonotonicCubicNaturalSpline_secondDerivative ;
    "secondDerivative", _MonotonicCubicNaturalSpline_secondDerivative ;
    "primitive", _MonotonicCubicNaturalSpline_primitive ;
    "primitive", _MonotonicCubicNaturalSpline_primitive ;
    "~", _delete_MonotonicCubicNaturalSpline ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeMonotonicCubicNaturalSpline") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeMonotonicCubicNaturalSpline"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeMonotonicCubicNaturalSpline_from_ptr"
          create_SafeMonotonicCubicNaturalSpline_from_ptr



let create_SafeMonotonicLogCubicNaturalSpline_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _MonotonicLogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen ;
    "()", _MonotonicLogCubicNaturalSpline_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _MonotonicLogCubicNaturalSpline_derivative ;
    "derivative", _MonotonicLogCubicNaturalSpline_derivative ;
    "secondDerivative", _MonotonicLogCubicNaturalSpline_secondDerivative ;
    "secondDerivative", _MonotonicLogCubicNaturalSpline_secondDerivative ;
    "primitive", _MonotonicLogCubicNaturalSpline_primitive ;
    "primitive", _MonotonicLogCubicNaturalSpline_primitive ;
    "~", _delete_MonotonicLogCubicNaturalSpline ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeMonotonicLogCubicNaturalSpline") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeMonotonicLogCubicNaturalSpline"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeMonotonicLogCubicNaturalSpline_from_ptr"
          create_SafeMonotonicLogCubicNaturalSpline_from_ptr



let create_SafeKrugerCubic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _KrugerCubic_operator_xx_xx_lparen_xx_rparen ;
    "()", _KrugerCubic_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _KrugerCubic_derivative ;
    "derivative", _KrugerCubic_derivative ;
    "secondDerivative", _KrugerCubic_secondDerivative ;
    "secondDerivative", _KrugerCubic_secondDerivative ;
    "primitive", _KrugerCubic_primitive ;
    "primitive", _KrugerCubic_primitive ;
    "~", _delete_KrugerCubic ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeKrugerCubic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeKrugerCubic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeKrugerCubic_from_ptr"
          create_SafeKrugerCubic_from_ptr



let create_SafeKrugerLogCubic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _KrugerLogCubic_operator_xx_xx_lparen_xx_rparen ;
    "()", _KrugerLogCubic_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _KrugerLogCubic_derivative ;
    "derivative", _KrugerLogCubic_derivative ;
    "secondDerivative", _KrugerLogCubic_secondDerivative ;
    "secondDerivative", _KrugerLogCubic_secondDerivative ;
    "primitive", _KrugerLogCubic_primitive ;
    "primitive", _KrugerLogCubic_primitive ;
    "~", _delete_KrugerLogCubic ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeKrugerLogCubic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeKrugerLogCubic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeKrugerLogCubic_from_ptr"
          create_SafeKrugerLogCubic_from_ptr



let create_SafeFritschButlandCubic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _FritschButlandCubic_operator_xx_xx_lparen_xx_rparen ;
    "()", _FritschButlandCubic_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _FritschButlandCubic_derivative ;
    "derivative", _FritschButlandCubic_derivative ;
    "secondDerivative", _FritschButlandCubic_secondDerivative ;
    "secondDerivative", _FritschButlandCubic_secondDerivative ;
    "primitive", _FritschButlandCubic_primitive ;
    "primitive", _FritschButlandCubic_primitive ;
    "~", _delete_FritschButlandCubic ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeFritschButlandCubic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeFritschButlandCubic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeFritschButlandCubic_from_ptr"
          create_SafeFritschButlandCubic_from_ptr



let create_SafeFritschButlandLogCubic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _FritschButlandLogCubic_operator_xx_xx_lparen_xx_rparen ;
    "()", _FritschButlandLogCubic_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _FritschButlandLogCubic_derivative ;
    "derivative", _FritschButlandLogCubic_derivative ;
    "secondDerivative", _FritschButlandLogCubic_secondDerivative ;
    "secondDerivative", _FritschButlandLogCubic_secondDerivative ;
    "primitive", _FritschButlandLogCubic_primitive ;
    "primitive", _FritschButlandLogCubic_primitive ;
    "~", _delete_FritschButlandLogCubic ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeFritschButlandLogCubic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeFritschButlandLogCubic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeFritschButlandLogCubic_from_ptr"
          create_SafeFritschButlandLogCubic_from_ptr



let create_SafeParabolic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _Parabolic_operator_xx_xx_lparen_xx_rparen ;
    "()", _Parabolic_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _Parabolic_derivative ;
    "derivative", _Parabolic_derivative ;
    "secondDerivative", _Parabolic_secondDerivative ;
    "secondDerivative", _Parabolic_secondDerivative ;
    "primitive", _Parabolic_primitive ;
    "primitive", _Parabolic_primitive ;
    "~", _delete_Parabolic ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeParabolic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeParabolic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeParabolic_from_ptr"
          create_SafeParabolic_from_ptr



let create_SafeLogParabolic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _LogParabolic_operator_xx_xx_lparen_xx_rparen ;
    "()", _LogParabolic_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _LogParabolic_derivative ;
    "derivative", _LogParabolic_derivative ;
    "secondDerivative", _LogParabolic_secondDerivative ;
    "secondDerivative", _LogParabolic_secondDerivative ;
    "primitive", _LogParabolic_primitive ;
    "primitive", _LogParabolic_primitive ;
    "~", _delete_LogParabolic ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeLogParabolic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeLogParabolic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeLogParabolic_from_ptr"
          create_SafeLogParabolic_from_ptr



let create_SafeMonotonicParabolic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _MonotonicParabolic_operator_xx_xx_lparen_xx_rparen ;
    "()", _MonotonicParabolic_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _MonotonicParabolic_derivative ;
    "derivative", _MonotonicParabolic_derivative ;
    "secondDerivative", _MonotonicParabolic_secondDerivative ;
    "secondDerivative", _MonotonicParabolic_secondDerivative ;
    "primitive", _MonotonicParabolic_primitive ;
    "primitive", _MonotonicParabolic_primitive ;
    "~", _delete_MonotonicParabolic ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeMonotonicParabolic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeMonotonicParabolic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeMonotonicParabolic_from_ptr"
          create_SafeMonotonicParabolic_from_ptr



let create_SafeMonotonicLogParabolic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _MonotonicLogParabolic_operator_xx_xx_lparen_xx_rparen ;
    "()", _MonotonicLogParabolic_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _MonotonicLogParabolic_derivative ;
    "derivative", _MonotonicLogParabolic_derivative ;
    "secondDerivative", _MonotonicLogParabolic_secondDerivative ;
    "secondDerivative", _MonotonicLogParabolic_secondDerivative ;
    "primitive", _MonotonicLogParabolic_primitive ;
    "primitive", _MonotonicLogParabolic_primitive ;
    "~", _delete_MonotonicLogParabolic ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeMonotonicLogParabolic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeMonotonicLogParabolic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeMonotonicLogParabolic_from_ptr"
          create_SafeMonotonicLogParabolic_from_ptr



let create_SafeBilinearInterpolation_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _BilinearInterpolation_operator_xx_xx_lparen_xx_rparen ;
    "()", _BilinearInterpolation_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_BilinearInterpolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeBilinearInterpolation") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeBilinearInterpolation"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeBilinearInterpolation_from_ptr"
          create_SafeBilinearInterpolation_from_ptr



let create_SafeBicubicSpline_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _BicubicSpline_operator_xx_xx_lparen_xx_rparen ;
    "()", _BicubicSpline_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_BicubicSpline ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SafeBicubicSpline") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SafeBicubicSpline"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SafeBicubicSpline_from_ptr"
          create_SafeBicubicSpline_from_ptr



let create_BackwardFlat_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BackwardFlat ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BackwardFlat") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BackwardFlat"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BackwardFlat_from_ptr"
          create_BackwardFlat_from_ptr



let create_ForwardFlat_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ForwardFlat ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ForwardFlat") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ForwardFlat"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ForwardFlat_from_ptr"
          create_ForwardFlat_from_ptr



let create_Linear_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Linear ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Linear") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Linear"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Linear_from_ptr"
          create_Linear_from_ptr



let create_LogLinear_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_LogLinear ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "LogLinear") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"LogLinear"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_LogLinear_from_ptr"
          create_LogLinear_from_ptr



let create_Cubic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Cubic ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Cubic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Cubic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Cubic_from_ptr"
          create_Cubic_from_ptr



let create_MonotonicCubic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MonotonicCubic ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MonotonicCubic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MonotonicCubic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MonotonicCubic_from_ptr"
          create_MonotonicCubic_from_ptr



let create_DefaultLogCubic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DefaultLogCubic ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DefaultLogCubic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DefaultLogCubic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DefaultLogCubic_from_ptr"
          create_DefaultLogCubic_from_ptr



let create_MonotonicLogCubic_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MonotonicLogCubic ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MonotonicLogCubic") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MonotonicLogCubic"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MonotonicLogCubic_from_ptr"
          create_MonotonicLogCubic_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenYieldTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _YieldTermStructure___deref__ ;
    "isNull", _YieldTermStructure_isNull ;
    "asObservable", _YieldTermStructure_asObservable ;
    "~", _delete_YieldTermStructure ;
    "dayCounter", _YieldTermStructure_dayCounter ;
    "calendar", _YieldTermStructure_calendar ;
    "referenceDate", _YieldTermStructure_referenceDate ;
    "maxDate", _YieldTermStructure_maxDate ;
    "maxTime", _YieldTermStructure_maxTime ;
    "discount", _YieldTermStructure_discount ;
    "discount", _YieldTermStructure_discount ;
    "discount", _YieldTermStructure_discount ;
    "discount", _YieldTermStructure_discount ;
    "zeroRate", _YieldTermStructure_zeroRate ;
    "zeroRate", _YieldTermStructure_zeroRate ;
    "zeroRate", _YieldTermStructure_zeroRate ;
    "zeroRate", _YieldTermStructure_zeroRate ;
    "zeroRate", _YieldTermStructure_zeroRate ;
    "zeroRate", _YieldTermStructure_zeroRate ;
    "forwardRate", _YieldTermStructure_forwardRate ;
    "forwardRate", _YieldTermStructure_forwardRate ;
    "forwardRate", _YieldTermStructure_forwardRate ;
    "forwardRate", _YieldTermStructure_forwardRate ;
    "forwardRate", _YieldTermStructure_forwardRate ;
    "forwardRate", _YieldTermStructure_forwardRate ;
    "enableExtrapolation", _YieldTermStructure_enableExtrapolation ;
    "disableExtrapolation", _YieldTermStructure_disableExtrapolation ;
    "allowsExtrapolation", _YieldTermStructure_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(YieldTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(YieldTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< YieldTermStructure >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenYieldTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenYieldTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _YieldTermStructureHandle___deref__ ;
    "empty", _YieldTermStructureHandle_empty ;
    "asObservable", _YieldTermStructureHandle_asObservable ;
    "~", _delete_YieldTermStructureHandle ;
    "dayCounter", _YieldTermStructureHandle_dayCounter ;
    "calendar", _YieldTermStructureHandle_calendar ;
    "referenceDate", _YieldTermStructureHandle_referenceDate ;
    "maxDate", _YieldTermStructureHandle_maxDate ;
    "maxTime", _YieldTermStructureHandle_maxTime ;
    "discount", _YieldTermStructureHandle_discount ;
    "discount", _YieldTermStructureHandle_discount ;
    "discount", _YieldTermStructureHandle_discount ;
    "discount", _YieldTermStructureHandle_discount ;
    "zeroRate", _YieldTermStructureHandle_zeroRate ;
    "zeroRate", _YieldTermStructureHandle_zeroRate ;
    "zeroRate", _YieldTermStructureHandle_zeroRate ;
    "zeroRate", _YieldTermStructureHandle_zeroRate ;
    "zeroRate", _YieldTermStructureHandle_zeroRate ;
    "zeroRate", _YieldTermStructureHandle_zeroRate ;
    "forwardRate", _YieldTermStructureHandle_forwardRate ;
    "forwardRate", _YieldTermStructureHandle_forwardRate ;
    "forwardRate", _YieldTermStructureHandle_forwardRate ;
    "forwardRate", _YieldTermStructureHandle_forwardRate ;
    "forwardRate", _YieldTermStructureHandle_forwardRate ;
    "forwardRate", _YieldTermStructureHandle_forwardRate ;
    "enableExtrapolation", _YieldTermStructureHandle_enableExtrapolation ;
    "disableExtrapolation", _YieldTermStructureHandle_disableExtrapolation ;
    "allowsExtrapolation", _YieldTermStructureHandle_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(YieldTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(YieldTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< YieldTermStructure >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenYieldTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenYieldTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableYieldTermStructureHandle_linkTo ;
    "~", _delete_RelinkableYieldTermStructureHandle ;
   "::Handle<(YieldTermStructure)>", (fun args -> (create_class "Handle<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(YieldTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(YieldTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< YieldTermStructure >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenYieldTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_ImpliedTermStructurePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ImpliedTermStructure ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ImpliedTermStructurePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ImpliedTermStructurePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ImpliedTermStructurePtr_from_ptr"
          create_ImpliedTermStructurePtr_from_ptr



let create_ZeroSpreadedTermStructurePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ZeroSpreadedTermStructure ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ZeroSpreadedTermStructurePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ZeroSpreadedTermStructurePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ZeroSpreadedTermStructurePtr_from_ptr"
          create_ZeroSpreadedTermStructurePtr_from_ptr



let create_ForwardSpreadedTermStructurePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ForwardSpreadedTermStructure ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ForwardSpreadedTermStructurePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ForwardSpreadedTermStructurePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ForwardSpreadedTermStructurePtr_from_ptr"
          create_ForwardSpreadedTermStructurePtr_from_ptr



let create_SpreadedLinearZeroInterpolatedTermStructurePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SpreadedLinearZeroInterpolatedTermStructure ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SpreadedLinearZeroInterpolatedTermStructurePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SpreadedLinearZeroInterpolatedTermStructurePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SpreadedLinearZeroInterpolatedTermStructurePtr_from_ptr"
          create_SpreadedLinearZeroInterpolatedTermStructurePtr_from_ptr



let create_FlatForwardPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FlatForward ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FlatForwardPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FlatForwardPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FlatForwardPtr_from_ptr"
          create_FlatForwardPtr_from_ptr



let create_TimeSeries_xx_ldbrace_xx_lparenReal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _RealTimeSeries_dates ;
    "values", _RealTimeSeries_values ;
    "size", _RealTimeSeries_size ;
    "~", _delete_RealTimeSeries ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TimeSeries<(Real)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TimeSeries<(Real)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TimeSeries< double >_from_ptr"
          create_TimeSeries_xx_ldbrace_xx_lparenReal_xx_rparen_xx_rdbrace_from_ptr



let create_TimeSeries_xx_ldbrace_xx_lparenIntervalPrice_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _IntervalPriceTimeSeries_dates ;
    "values", _IntervalPriceTimeSeries_values ;
    "size", _IntervalPriceTimeSeries_size ;
    "~", _delete_IntervalPriceTimeSeries ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TimeSeries<(IntervalPrice)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TimeSeries<(IntervalPrice)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TimeSeries< IntervalPrice >_from_ptr"
          create_TimeSeries_xx_ldbrace_xx_lparenIntervalPrice_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenIntervalPrice_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _IntervalPriceVector_size ;
    "empty", _IntervalPriceVector_empty ;
    "clear", _IntervalPriceVector_clear ;
    "push_back", _IntervalPriceVector_push_back ;
    "[]", _IntervalPriceVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _IntervalPriceVector_operator_xx_xx_equals ;
    "set", _IntervalPriceVector_set ;
    "to_array", _IntervalPriceVector_to_array ;
    "~", _delete_IntervalPriceVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(IntervalPrice)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(IntervalPrice)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< IntervalPrice >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenIntervalPrice_xx_rparen_xx_rdbrace_from_ptr



let create_IntervalPrice_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "setValue", _IntervalPrice_setValue ;
    "setValues", _IntervalPrice_setValues ;
    "value", _IntervalPrice_value ;
    "open", _IntervalPrice_open ;
    "close", _IntervalPrice_close ;
    "high", _IntervalPrice_high ;
    "low", _IntervalPrice_low ;
    "~", _delete_IntervalPrice ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "IntervalPrice") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"IntervalPrice"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_IntervalPrice_from_ptr"
          create_IntervalPrice_from_ptr



let create_IndexManager_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "setHistory", _IndexManager_setHistory ;
    "getHistory", _IndexManager_getHistory ;
    "hasHistory", _IndexManager_hasHistory ;
    "histories", _IndexManager_histories ;
    "clearHistory", _IndexManager_clearHistory ;
    "clearHistories", _IndexManager_clearHistories ;
    "~", _delete_IndexManager ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "IndexManager") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"IndexManager"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_IndexManager_from_ptr"
          create_IndexManager_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenIndex_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _Index___deref__ ;
    "isNull", _Index_isNull ;
    "addFixings", _Index_addFixings ;
    "__str__", _Index___str__ ;
    "asObservable", _Index_asObservable ;
    "~", _delete_Index ;
    "name", _Index_name ;
    "fixingCalendar", _Index_fixingCalendar ;
    "isValidFixingDate", _Index_isValidFixingDate ;
    "fixing", _Index_fixing ;
    "fixing", _Index_fixing ;
    "addFixing", _Index_addFixing ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(Index)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(Index)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< Index >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenIndex_xx_rparen_xx_rdbrace_from_ptr



let create_InterestRateIndexPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "familyName", _InterestRateIndex_familyName ;
    "tenor", _InterestRateIndex_tenor ;
    "fixingDays", _InterestRateIndex_fixingDays ;
    "fixingDate", _InterestRateIndex_fixingDate ;
    "currency", _InterestRateIndex_currency ;
    "dayCounter", _InterestRateIndex_dayCounter ;
    "maturityDate", _InterestRateIndex_maturityDate ;
    "valueDate", _InterestRateIndex_valueDate ;
    "~", _delete_InterestRateIndex ;
   "::boost::shared_ptr<(Index)>", (fun args -> (create_class "boost::shared_ptr<(Index)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InterestRateIndexPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Index)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InterestRateIndexPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InterestRateIndexPtr_from_ptr"
          create_InterestRateIndexPtr_from_ptr



let create_IborIndexPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "businessDayConvention", _IborIndex_businessDayConvention ;
    "endOfMonth", _IborIndex_endOfMonth ;
    "forwardingTermStructure", _IborIndex_forwardingTermStructure ;
    "clone", _IborIndex_clone ;
    "~", _delete_IborIndex ;
   "::InterestRateIndexPtr", (fun args -> (create_class "InterestRateIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "IborIndexPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "InterestRateIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"IborIndexPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_IborIndexPtr_from_ptr"
          create_IborIndexPtr_from_ptr



let create_OvernightIndexPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_OvernightIndex ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "OvernightIndexPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"OvernightIndexPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_OvernightIndexPtr_from_ptr"
          create_OvernightIndexPtr_from_ptr



let create_LiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Libor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "LiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"LiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_LiborPtr_from_ptr"
          create_LiborPtr_from_ptr



let create_SwapIndexPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "fixedLegTenor", _SwapIndex_fixedLegTenor ;
    "fixedLegConvention", _SwapIndex_fixedLegConvention ;
    "iborIndex", _SwapIndex_iborIndex ;
    "forwardingTermStructure", _SwapIndex_forwardingTermStructure ;
    "~", _delete_SwapIndex ;
   "::InterestRateIndexPtr", (fun args -> (create_class "InterestRateIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SwapIndexPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "InterestRateIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SwapIndexPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SwapIndexPtr_from_ptr"
          create_SwapIndexPtr_from_ptr



let create_AUDLiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AUDLibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AUDLiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AUDLiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AUDLiborPtr_from_ptr"
          create_AUDLiborPtr_from_ptr



let create_CADLiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CADLibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CADLiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CADLiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CADLiborPtr_from_ptr"
          create_CADLiborPtr_from_ptr



let create_CdorPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Cdor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CdorPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CdorPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CdorPtr_from_ptr"
          create_CdorPtr_from_ptr



let create_CHFLiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CHFLibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CHFLiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CHFLiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CHFLiborPtr_from_ptr"
          create_CHFLiborPtr_from_ptr



let create_DKKLiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DKKLibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DKKLiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DKKLiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DKKLiborPtr_from_ptr"
          create_DKKLiborPtr_from_ptr



let create_BbswPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bbsw ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BbswPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BbswPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BbswPtr_from_ptr"
          create_BbswPtr_from_ptr



let create_Bbsw1MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bbsw1M ;
   "::BbswPtr", (fun args -> (create_class "BbswPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bbsw1MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BbswPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bbsw1MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bbsw1MPtr_from_ptr"
          create_Bbsw1MPtr_from_ptr



let create_Bbsw2MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bbsw2M ;
   "::BbswPtr", (fun args -> (create_class "BbswPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bbsw2MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BbswPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bbsw2MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bbsw2MPtr_from_ptr"
          create_Bbsw2MPtr_from_ptr



let create_Bbsw3MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bbsw3M ;
   "::BbswPtr", (fun args -> (create_class "BbswPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bbsw3MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BbswPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bbsw3MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bbsw3MPtr_from_ptr"
          create_Bbsw3MPtr_from_ptr



let create_Bbsw4MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bbsw4M ;
   "::BbswPtr", (fun args -> (create_class "BbswPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bbsw4MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BbswPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bbsw4MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bbsw4MPtr_from_ptr"
          create_Bbsw4MPtr_from_ptr



let create_Bbsw5MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bbsw5M ;
   "::BbswPtr", (fun args -> (create_class "BbswPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bbsw5MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BbswPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bbsw5MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bbsw5MPtr_from_ptr"
          create_Bbsw5MPtr_from_ptr



let create_Bbsw6MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bbsw6M ;
   "::BbswPtr", (fun args -> (create_class "BbswPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bbsw6MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BbswPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bbsw6MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bbsw6MPtr_from_ptr"
          create_Bbsw6MPtr_from_ptr



let create_BkbmPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bkbm ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BkbmPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BkbmPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BkbmPtr_from_ptr"
          create_BkbmPtr_from_ptr



let create_Bkbm1MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bkbm1M ;
   "::BkbmPtr", (fun args -> (create_class "BkbmPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bkbm1MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BkbmPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bkbm1MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bkbm1MPtr_from_ptr"
          create_Bkbm1MPtr_from_ptr



let create_Bkbm2MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bkbm2M ;
   "::BkbmPtr", (fun args -> (create_class "BkbmPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bkbm2MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BkbmPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bkbm2MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bkbm2MPtr_from_ptr"
          create_Bkbm2MPtr_from_ptr



let create_Bkbm3MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bkbm3M ;
   "::BkbmPtr", (fun args -> (create_class "BkbmPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bkbm3MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BkbmPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bkbm3MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bkbm3MPtr_from_ptr"
          create_Bkbm3MPtr_from_ptr



let create_Bkbm4MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bkbm4M ;
   "::BkbmPtr", (fun args -> (create_class "BkbmPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bkbm4MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BkbmPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bkbm4MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bkbm4MPtr_from_ptr"
          create_Bkbm4MPtr_from_ptr



let create_Bkbm5MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bkbm5M ;
   "::BkbmPtr", (fun args -> (create_class "BkbmPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bkbm5MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BkbmPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bkbm5MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bkbm5MPtr_from_ptr"
          create_Bkbm5MPtr_from_ptr



let create_Bkbm6MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Bkbm6M ;
   "::BkbmPtr", (fun args -> (create_class "BkbmPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bkbm6MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BkbmPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bkbm6MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bkbm6MPtr_from_ptr"
          create_Bkbm6MPtr_from_ptr



let create_EuriborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EuriborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EuriborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EuriborPtr_from_ptr"
          create_EuriborPtr_from_ptr



let create_EuriborSWPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EuriborSW ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EuriborSWPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EuriborSWPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EuriborSWPtr_from_ptr"
          create_EuriborSWPtr_from_ptr



let create_Euribor2WPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor2W ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor2WPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor2WPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor2WPtr_from_ptr"
          create_Euribor2WPtr_from_ptr



let create_Euribor3WPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor3W ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor3WPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor3WPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor3WPtr_from_ptr"
          create_Euribor3WPtr_from_ptr



let create_Euribor1MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor1M ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor1MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor1MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor1MPtr_from_ptr"
          create_Euribor1MPtr_from_ptr



let create_Euribor2MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor2M ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor2MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor2MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor2MPtr_from_ptr"
          create_Euribor2MPtr_from_ptr



let create_Euribor3MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor3M ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor3MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor3MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor3MPtr_from_ptr"
          create_Euribor3MPtr_from_ptr



let create_Euribor4MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor4M ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor4MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor4MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor4MPtr_from_ptr"
          create_Euribor4MPtr_from_ptr



let create_Euribor5MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor5M ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor5MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor5MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor5MPtr_from_ptr"
          create_Euribor5MPtr_from_ptr



let create_Euribor6MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor6M ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor6MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor6MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor6MPtr_from_ptr"
          create_Euribor6MPtr_from_ptr



let create_Euribor7MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor7M ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor7MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor7MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor7MPtr_from_ptr"
          create_Euribor7MPtr_from_ptr



let create_Euribor8MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor8M ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor8MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor8MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor8MPtr_from_ptr"
          create_Euribor8MPtr_from_ptr



let create_Euribor9MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor9M ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor9MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor9MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor9MPtr_from_ptr"
          create_Euribor9MPtr_from_ptr



let create_Euribor10MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor10M ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor10MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor10MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor10MPtr_from_ptr"
          create_Euribor10MPtr_from_ptr



let create_Euribor11MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor11M ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor11MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor11MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor11MPtr_from_ptr"
          create_Euribor11MPtr_from_ptr



let create_Euribor1YPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor1Y ;
   "::EuriborPtr", (fun args -> (create_class "EuriborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor1YPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EuriborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor1YPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor1YPtr_from_ptr"
          create_Euribor1YPtr_from_ptr



let create_Euribor365Ptr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365 ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365Ptr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365Ptr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365Ptr_from_ptr"
          create_Euribor365Ptr_from_ptr



let create_Euribor365_SWPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_SW ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_SWPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_SWPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_SWPtr_from_ptr"
          create_Euribor365_SWPtr_from_ptr



let create_Euribor365_2WPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_2W ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_2WPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_2WPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_2WPtr_from_ptr"
          create_Euribor365_2WPtr_from_ptr



let create_Euribor365_3WPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_3W ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_3WPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_3WPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_3WPtr_from_ptr"
          create_Euribor365_3WPtr_from_ptr



let create_Euribor365_1MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_1M ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_1MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_1MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_1MPtr_from_ptr"
          create_Euribor365_1MPtr_from_ptr



let create_Euribor365_2MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_2M ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_2MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_2MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_2MPtr_from_ptr"
          create_Euribor365_2MPtr_from_ptr



let create_Euribor365_3MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_3M ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_3MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_3MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_3MPtr_from_ptr"
          create_Euribor365_3MPtr_from_ptr



let create_Euribor365_4MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_4M ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_4MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_4MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_4MPtr_from_ptr"
          create_Euribor365_4MPtr_from_ptr



let create_Euribor365_5MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_5M ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_5MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_5MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_5MPtr_from_ptr"
          create_Euribor365_5MPtr_from_ptr



let create_Euribor365_6MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_6M ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_6MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_6MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_6MPtr_from_ptr"
          create_Euribor365_6MPtr_from_ptr



let create_Euribor365_7MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_7M ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_7MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_7MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_7MPtr_from_ptr"
          create_Euribor365_7MPtr_from_ptr



let create_Euribor365_8MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_8M ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_8MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_8MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_8MPtr_from_ptr"
          create_Euribor365_8MPtr_from_ptr



let create_Euribor365_9MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_9M ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_9MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_9MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_9MPtr_from_ptr"
          create_Euribor365_9MPtr_from_ptr



let create_Euribor365_10MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_10M ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_10MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_10MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_10MPtr_from_ptr"
          create_Euribor365_10MPtr_from_ptr



let create_Euribor365_11MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_11M ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_11MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_11MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_11MPtr_from_ptr"
          create_Euribor365_11MPtr_from_ptr



let create_Euribor365_1YPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Euribor365_1Y ;
   "::Euribor365Ptr", (fun args -> (create_class "Euribor365Ptr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Euribor365_1YPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Euribor365Ptr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Euribor365_1YPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Euribor365_1YPtr_from_ptr"
          create_Euribor365_1YPtr_from_ptr



let create_EURLiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLiborPtr_from_ptr"
          create_EURLiborPtr_from_ptr



let create_EURLiborSWPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLiborSW ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLiborSWPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLiborSWPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLiborSWPtr_from_ptr"
          create_EURLiborSWPtr_from_ptr



let create_EURLibor2WPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor2W ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor2WPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor2WPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor2WPtr_from_ptr"
          create_EURLibor2WPtr_from_ptr



let create_EURLibor1MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor1M ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor1MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor1MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor1MPtr_from_ptr"
          create_EURLibor1MPtr_from_ptr



let create_EURLibor2MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor2M ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor2MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor2MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor2MPtr_from_ptr"
          create_EURLibor2MPtr_from_ptr



let create_EURLibor3MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor3M ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor3MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor3MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor3MPtr_from_ptr"
          create_EURLibor3MPtr_from_ptr



let create_EURLibor4MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor4M ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor4MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor4MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor4MPtr_from_ptr"
          create_EURLibor4MPtr_from_ptr



let create_EURLibor5MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor5M ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor5MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor5MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor5MPtr_from_ptr"
          create_EURLibor5MPtr_from_ptr



let create_EURLibor6MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor6M ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor6MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor6MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor6MPtr_from_ptr"
          create_EURLibor6MPtr_from_ptr



let create_EURLibor7MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor7M ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor7MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor7MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor7MPtr_from_ptr"
          create_EURLibor7MPtr_from_ptr



let create_EURLibor8MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor8M ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor8MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor8MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor8MPtr_from_ptr"
          create_EURLibor8MPtr_from_ptr



let create_EURLibor9MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor9M ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor9MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor9MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor9MPtr_from_ptr"
          create_EURLibor9MPtr_from_ptr



let create_EURLibor10MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor10M ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor10MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor10MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor10MPtr_from_ptr"
          create_EURLibor10MPtr_from_ptr



let create_EURLibor11MPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor11M ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor11MPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor11MPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor11MPtr_from_ptr"
          create_EURLibor11MPtr_from_ptr



let create_EURLibor1YPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EURLibor1Y ;
   "::EURLiborPtr", (fun args -> (create_class "EURLiborPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EURLibor1YPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "EURLiborPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EURLibor1YPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EURLibor1YPtr_from_ptr"
          create_EURLibor1YPtr_from_ptr



let create_GBPLiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GBPLibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GBPLiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GBPLiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GBPLiborPtr_from_ptr"
          create_GBPLiborPtr_from_ptr



let create_JibarPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Jibar ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "JibarPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"JibarPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_JibarPtr_from_ptr"
          create_JibarPtr_from_ptr



let create_JPYLiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_JPYLibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "JPYLiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"JPYLiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_JPYLiborPtr_from_ptr"
          create_JPYLiborPtr_from_ptr



let create_NZDLiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NZDLibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "NZDLiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"NZDLiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_NZDLiborPtr_from_ptr"
          create_NZDLiborPtr_from_ptr



let create_SEKLiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SEKLibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SEKLiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SEKLiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SEKLiborPtr_from_ptr"
          create_SEKLiborPtr_from_ptr



let create_TiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Tibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TiborPtr_from_ptr"
          create_TiborPtr_from_ptr



let create_TRLiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_TRLibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TRLiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TRLiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TRLiborPtr_from_ptr"
          create_TRLiborPtr_from_ptr



let create_USDLiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_USDLibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "USDLiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"USDLiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_USDLiborPtr_from_ptr"
          create_USDLiborPtr_from_ptr



let create_ZiborPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Zibor ;
   "::IborIndexPtr", (fun args -> (create_class "IborIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ZiborPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ZiborPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ZiborPtr_from_ptr"
          create_ZiborPtr_from_ptr



let create_AoniaPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Aonia ;
   "::OvernightIndexPtr", (fun args -> (create_class "OvernightIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AoniaPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OvernightIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AoniaPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AoniaPtr_from_ptr"
          create_AoniaPtr_from_ptr



let create_EoniaPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Eonia ;
   "::OvernightIndexPtr", (fun args -> (create_class "OvernightIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EoniaPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OvernightIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EoniaPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EoniaPtr_from_ptr"
          create_EoniaPtr_from_ptr



let create_SoniaPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Sonia ;
   "::OvernightIndexPtr", (fun args -> (create_class "OvernightIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SoniaPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OvernightIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SoniaPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SoniaPtr_from_ptr"
          create_SoniaPtr_from_ptr



let create_FedFundsPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FedFunds ;
   "::OvernightIndexPtr", (fun args -> (create_class "OvernightIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FedFundsPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OvernightIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FedFundsPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FedFundsPtr_from_ptr"
          create_FedFundsPtr_from_ptr



let create_NzocrPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Nzocr ;
   "::OvernightIndexPtr", (fun args -> (create_class "OvernightIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "NzocrPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OvernightIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"NzocrPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_NzocrPtr_from_ptr"
          create_NzocrPtr_from_ptr



let create_EuriborSwapIsdaFixAPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EuriborSwapIsdaFixA ;
   "::SwapIndexPtr", (fun args -> (create_class "SwapIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EuriborSwapIsdaFixAPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "SwapIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EuriborSwapIsdaFixAPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EuriborSwapIsdaFixAPtr_from_ptr"
          create_EuriborSwapIsdaFixAPtr_from_ptr



let create_EuriborSwapIsdaFixBPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EuriborSwapIsdaFixB ;
   "::SwapIndexPtr", (fun args -> (create_class "SwapIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EuriborSwapIsdaFixBPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "SwapIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EuriborSwapIsdaFixBPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EuriborSwapIsdaFixBPtr_from_ptr"
          create_EuriborSwapIsdaFixBPtr_from_ptr



let create_EuriborSwapIfrFixPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EuriborSwapIfrFix ;
   "::SwapIndexPtr", (fun args -> (create_class "SwapIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EuriborSwapIfrFixPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "SwapIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EuriborSwapIfrFixPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EuriborSwapIfrFixPtr_from_ptr"
          create_EuriborSwapIfrFixPtr_from_ptr



let create_EurLiborSwapIsdaFixAPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EurLiborSwapIsdaFixA ;
   "::SwapIndexPtr", (fun args -> (create_class "SwapIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EurLiborSwapIsdaFixAPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "SwapIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EurLiborSwapIsdaFixAPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EurLiborSwapIsdaFixAPtr_from_ptr"
          create_EurLiborSwapIsdaFixAPtr_from_ptr



let create_EurLiborSwapIsdaFixBPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EurLiborSwapIsdaFixB ;
   "::SwapIndexPtr", (fun args -> (create_class "SwapIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EurLiborSwapIsdaFixBPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "SwapIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EurLiborSwapIsdaFixBPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EurLiborSwapIsdaFixBPtr_from_ptr"
          create_EurLiborSwapIsdaFixBPtr_from_ptr



let create_EurLiborSwapIfrFixPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EurLiborSwapIfrFix ;
   "::SwapIndexPtr", (fun args -> (create_class "SwapIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EurLiborSwapIfrFixPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "SwapIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EurLiborSwapIfrFixPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EurLiborSwapIfrFixPtr_from_ptr"
          create_EurLiborSwapIfrFixPtr_from_ptr



let create_Brent_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "setMaxEvaluations", _Brent_setMaxEvaluations ;
    "setLowerBound", _Brent_setLowerBound ;
    "setUpperBound", _Brent_setUpperBound ;
    "~", _delete_Brent ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Brent") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Brent"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Brent_from_ptr"
          create_Brent_from_ptr



let create_Bisection_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "setMaxEvaluations", _Bisection_setMaxEvaluations ;
    "setLowerBound", _Bisection_setLowerBound ;
    "setUpperBound", _Bisection_setUpperBound ;
    "~", _delete_Bisection ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Bisection") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Bisection"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Bisection_from_ptr"
          create_Bisection_from_ptr



let create_FalsePosition_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "setMaxEvaluations", _FalsePosition_setMaxEvaluations ;
    "setLowerBound", _FalsePosition_setLowerBound ;
    "setUpperBound", _FalsePosition_setUpperBound ;
    "~", _delete_FalsePosition ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FalsePosition") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FalsePosition"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FalsePosition_from_ptr"
          create_FalsePosition_from_ptr



let create_Ridder_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "setMaxEvaluations", _Ridder_setMaxEvaluations ;
    "setLowerBound", _Ridder_setLowerBound ;
    "setUpperBound", _Ridder_setUpperBound ;
    "~", _delete_Ridder ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Ridder") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Ridder"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Ridder_from_ptr"
          create_Ridder_from_ptr



let create_Secant_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "setMaxEvaluations", _Secant_setMaxEvaluations ;
    "setLowerBound", _Secant_setLowerBound ;
    "setUpperBound", _Secant_setUpperBound ;
    "~", _delete_Secant ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Secant") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Secant"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Secant_from_ptr"
          create_Secant_from_ptr



let create_Constraint_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Constraint ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Constraint") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Constraint"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Constraint_from_ptr"
          create_Constraint_from_ptr



let create_BoundaryConstraint_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BoundaryConstraint ;
   "::Constraint", (fun args -> (create_class "Constraint") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BoundaryConstraint") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Constraint") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BoundaryConstraint"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BoundaryConstraint_from_ptr"
          create_BoundaryConstraint_from_ptr



let create_NoConstraint_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NoConstraint ;
   "::Constraint", (fun args -> (create_class "Constraint") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "NoConstraint") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Constraint") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"NoConstraint"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_NoConstraint_from_ptr"
          create_NoConstraint_from_ptr



let create_PositiveConstraint_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_PositiveConstraint ;
   "::Constraint", (fun args -> (create_class "Constraint") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PositiveConstraint") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Constraint") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PositiveConstraint"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PositiveConstraint_from_ptr"
          create_PositiveConstraint_from_ptr



let create_CompositeConstraint_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CompositeConstraint ;
   "::Constraint", (fun args -> (create_class "Constraint") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CompositeConstraint") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Constraint") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CompositeConstraint"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CompositeConstraint_from_ptr"
          create_CompositeConstraint_from_ptr



let create_NonhomogeneousBoundaryConstraint_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NonhomogeneousBoundaryConstraint ;
   "::Constraint", (fun args -> (create_class "Constraint") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "NonhomogeneousBoundaryConstraint") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Constraint") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"NonhomogeneousBoundaryConstraint"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_NonhomogeneousBoundaryConstraint_from_ptr"
          create_NonhomogeneousBoundaryConstraint_from_ptr



let create_EndCriteria_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _EndCriteria_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_EndCriteria ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EndCriteria") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EndCriteria"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EndCriteria_from_ptr"
          create_EndCriteria_from_ptr



let create_OptimizationMethod_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_OptimizationMethod ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "OptimizationMethod") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"OptimizationMethod"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_OptimizationMethod_from_ptr"
          create_OptimizationMethod_from_ptr



let create_ConjugateGradient_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ConjugateGradient ;
   "::OptimizationMethod", (fun args -> (create_class "OptimizationMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ConjugateGradient") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OptimizationMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ConjugateGradient"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ConjugateGradient_from_ptr"
          create_ConjugateGradient_from_ptr



let create_Simplex_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Simplex ;
   "::OptimizationMethod", (fun args -> (create_class "OptimizationMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Simplex") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OptimizationMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Simplex"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Simplex_from_ptr"
          create_Simplex_from_ptr



let create_SteepestDescent_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SteepestDescent ;
   "::OptimizationMethod", (fun args -> (create_class "OptimizationMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SteepestDescent") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OptimizationMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SteepestDescent"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SteepestDescent_from_ptr"
          create_SteepestDescent_from_ptr



let create_BFGS_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BFGS ;
   "::OptimizationMethod", (fun args -> (create_class "OptimizationMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BFGS") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OptimizationMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BFGS"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BFGS_from_ptr"
          create_BFGS_from_ptr



let create_LevenbergMarquardt_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_LevenbergMarquardt ;
   "::OptimizationMethod", (fun args -> (create_class "OptimizationMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "LevenbergMarquardt") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OptimizationMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"LevenbergMarquardt"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_LevenbergMarquardt_from_ptr"
          create_LevenbergMarquardt_from_ptr



let create_DifferentialEvolution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DifferentialEvolution ;
   "::OptimizationMethod", (fun args -> (create_class "OptimizationMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DifferentialEvolution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OptimizationMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DifferentialEvolution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DifferentialEvolution_from_ptr"
          create_DifferentialEvolution_from_ptr



let create_SamplerGaussian_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SamplerGaussian ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SamplerGaussian") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SamplerGaussian"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SamplerGaussian_from_ptr"
          create_SamplerGaussian_from_ptr



let create_SamplerLogNormal_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SamplerLogNormal ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SamplerLogNormal") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SamplerLogNormal"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SamplerLogNormal_from_ptr"
          create_SamplerLogNormal_from_ptr



let create_SamplerMirrorGaussian_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SamplerMirrorGaussian ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SamplerMirrorGaussian") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SamplerMirrorGaussian"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SamplerMirrorGaussian_from_ptr"
          create_SamplerMirrorGaussian_from_ptr



let create_ProbabilityBoltzmannDownhill_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ProbabilityBoltzmannDownhill ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ProbabilityBoltzmannDownhill") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ProbabilityBoltzmannDownhill"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ProbabilityBoltzmannDownhill_from_ptr"
          create_ProbabilityBoltzmannDownhill_from_ptr



let create_TemperatureExponential_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_TemperatureExponential ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TemperatureExponential") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TemperatureExponential"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TemperatureExponential_from_ptr"
          create_TemperatureExponential_from_ptr



let create_ReannealingTrivial_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ReannealingTrivial ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ReannealingTrivial") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ReannealingTrivial"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ReannealingTrivial_from_ptr"
          create_ReannealingTrivial_from_ptr



let create_GaussianSimulatedAnnealing_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GaussianSimulatedAnnealing ;
   "::OptimizationMethod", (fun args -> (create_class "OptimizationMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussianSimulatedAnnealing") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OptimizationMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussianSimulatedAnnealing"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussianSimulatedAnnealing_from_ptr"
          create_GaussianSimulatedAnnealing_from_ptr



let create_MirrorGaussianSimulatedAnnealing_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MirrorGaussianSimulatedAnnealing ;
   "::OptimizationMethod", (fun args -> (create_class "OptimizationMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MirrorGaussianSimulatedAnnealing") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OptimizationMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MirrorGaussianSimulatedAnnealing"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MirrorGaussianSimulatedAnnealing_from_ptr"
          create_MirrorGaussianSimulatedAnnealing_from_ptr



let create_LogNormalSimulatedAnnealing_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_LogNormalSimulatedAnnealing ;
   "::OptimizationMethod", (fun args -> (create_class "OptimizationMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "LogNormalSimulatedAnnealing") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "OptimizationMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"LogNormalSimulatedAnnealing"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_LogNormalSimulatedAnnealing_from_ptr"
          create_LogNormalSimulatedAnnealing_from_ptr



let create_Optimizer_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Optimizer ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Optimizer") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Optimizer"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Optimizer_from_ptr"
          create_Optimizer_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenBlackVolTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _BlackVolTermStructure___deref__ ;
    "isNull", _BlackVolTermStructure_isNull ;
    "asObservable", _BlackVolTermStructure_asObservable ;
    "~", _delete_BlackVolTermStructure ;
    "referenceDate", _BlackVolTermStructure_referenceDate ;
    "dayCounter", _BlackVolTermStructure_dayCounter ;
    "calendar", _BlackVolTermStructure_calendar ;
    "maxDate", _BlackVolTermStructure_maxDate ;
    "maxTime", _BlackVolTermStructure_maxTime ;
    "minStrike", _BlackVolTermStructure_minStrike ;
    "maxStrike", _BlackVolTermStructure_maxStrike ;
    "blackVol", _BlackVolTermStructure_blackVol ;
    "blackVol", _BlackVolTermStructure_blackVol ;
    "blackVol", _BlackVolTermStructure_blackVol ;
    "blackVol", _BlackVolTermStructure_blackVol ;
    "blackVariance", _BlackVolTermStructure_blackVariance ;
    "blackVariance", _BlackVolTermStructure_blackVariance ;
    "blackVariance", _BlackVolTermStructure_blackVariance ;
    "blackVariance", _BlackVolTermStructure_blackVariance ;
    "blackForwardVol", _BlackVolTermStructure_blackForwardVol ;
    "blackForwardVol", _BlackVolTermStructure_blackForwardVol ;
    "blackForwardVol", _BlackVolTermStructure_blackForwardVol ;
    "blackForwardVol", _BlackVolTermStructure_blackForwardVol ;
    "blackForwardVariance", _BlackVolTermStructure_blackForwardVariance ;
    "blackForwardVariance", _BlackVolTermStructure_blackForwardVariance ;
    "blackForwardVariance", _BlackVolTermStructure_blackForwardVariance ;
    "blackForwardVariance", _BlackVolTermStructure_blackForwardVariance ;
    "enableExtrapolation", _BlackVolTermStructure_enableExtrapolation ;
    "disableExtrapolation", _BlackVolTermStructure_disableExtrapolation ;
    "allowsExtrapolation", _BlackVolTermStructure_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(BlackVolTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(BlackVolTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< BlackVolTermStructure >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenBlackVolTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenBlackVolTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _BlackVolTermStructureHandle___deref__ ;
    "empty", _BlackVolTermStructureHandle_empty ;
    "asObservable", _BlackVolTermStructureHandle_asObservable ;
    "~", _delete_BlackVolTermStructureHandle ;
    "referenceDate", _BlackVolTermStructureHandle_referenceDate ;
    "dayCounter", _BlackVolTermStructureHandle_dayCounter ;
    "calendar", _BlackVolTermStructureHandle_calendar ;
    "maxDate", _BlackVolTermStructureHandle_maxDate ;
    "maxTime", _BlackVolTermStructureHandle_maxTime ;
    "minStrike", _BlackVolTermStructureHandle_minStrike ;
    "maxStrike", _BlackVolTermStructureHandle_maxStrike ;
    "blackVol", _BlackVolTermStructureHandle_blackVol ;
    "blackVol", _BlackVolTermStructureHandle_blackVol ;
    "blackVol", _BlackVolTermStructureHandle_blackVol ;
    "blackVol", _BlackVolTermStructureHandle_blackVol ;
    "blackVariance", _BlackVolTermStructureHandle_blackVariance ;
    "blackVariance", _BlackVolTermStructureHandle_blackVariance ;
    "blackVariance", _BlackVolTermStructureHandle_blackVariance ;
    "blackVariance", _BlackVolTermStructureHandle_blackVariance ;
    "blackForwardVol", _BlackVolTermStructureHandle_blackForwardVol ;
    "blackForwardVol", _BlackVolTermStructureHandle_blackForwardVol ;
    "blackForwardVol", _BlackVolTermStructureHandle_blackForwardVol ;
    "blackForwardVol", _BlackVolTermStructureHandle_blackForwardVol ;
    "blackForwardVariance", _BlackVolTermStructureHandle_blackForwardVariance ;
    "blackForwardVariance", _BlackVolTermStructureHandle_blackForwardVariance ;
    "blackForwardVariance", _BlackVolTermStructureHandle_blackForwardVariance ;
    "blackForwardVariance", _BlackVolTermStructureHandle_blackForwardVariance ;
    "enableExtrapolation", _BlackVolTermStructureHandle_enableExtrapolation ;
    "disableExtrapolation", _BlackVolTermStructureHandle_disableExtrapolation ;
    "allowsExtrapolation", _BlackVolTermStructureHandle_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(BlackVolTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(BlackVolTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< BlackVolTermStructure >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenBlackVolTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenBlackVolTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableBlackVolTermStructureHandle_linkTo ;
    "~", _delete_RelinkableBlackVolTermStructureHandle ;
   "::Handle<(BlackVolTermStructure)>", (fun args -> (create_class "Handle<(BlackVolTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(BlackVolTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(BlackVolTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(BlackVolTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< BlackVolTermStructure >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenBlackVolTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenLocalVolTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _LocalVolTermStructure___deref__ ;
    "isNull", _LocalVolTermStructure_isNull ;
    "asObservable", _LocalVolTermStructure_asObservable ;
    "~", _delete_LocalVolTermStructure ;
    "referenceDate", _LocalVolTermStructure_referenceDate ;
    "dayCounter", _LocalVolTermStructure_dayCounter ;
    "calendar", _LocalVolTermStructure_calendar ;
    "maxDate", _LocalVolTermStructure_maxDate ;
    "maxTime", _LocalVolTermStructure_maxTime ;
    "minStrike", _LocalVolTermStructure_minStrike ;
    "maxStrike", _LocalVolTermStructure_maxStrike ;
    "localVol", _LocalVolTermStructure_localVol ;
    "localVol", _LocalVolTermStructure_localVol ;
    "localVol", _LocalVolTermStructure_localVol ;
    "localVol", _LocalVolTermStructure_localVol ;
    "enableExtrapolation", _LocalVolTermStructure_enableExtrapolation ;
    "disableExtrapolation", _LocalVolTermStructure_disableExtrapolation ;
    "allowsExtrapolation", _LocalVolTermStructure_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(LocalVolTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(LocalVolTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< LocalVolTermStructure >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenLocalVolTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenLocalVolTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _LocalVolTermStructureHandle___deref__ ;
    "empty", _LocalVolTermStructureHandle_empty ;
    "asObservable", _LocalVolTermStructureHandle_asObservable ;
    "~", _delete_LocalVolTermStructureHandle ;
    "referenceDate", _LocalVolTermStructureHandle_referenceDate ;
    "dayCounter", _LocalVolTermStructureHandle_dayCounter ;
    "calendar", _LocalVolTermStructureHandle_calendar ;
    "maxDate", _LocalVolTermStructureHandle_maxDate ;
    "maxTime", _LocalVolTermStructureHandle_maxTime ;
    "minStrike", _LocalVolTermStructureHandle_minStrike ;
    "maxStrike", _LocalVolTermStructureHandle_maxStrike ;
    "localVol", _LocalVolTermStructureHandle_localVol ;
    "localVol", _LocalVolTermStructureHandle_localVol ;
    "localVol", _LocalVolTermStructureHandle_localVol ;
    "localVol", _LocalVolTermStructureHandle_localVol ;
    "enableExtrapolation", _LocalVolTermStructureHandle_enableExtrapolation ;
    "disableExtrapolation", _LocalVolTermStructureHandle_disableExtrapolation ;
    "allowsExtrapolation", _LocalVolTermStructureHandle_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(LocalVolTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(LocalVolTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< LocalVolTermStructure >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenLocalVolTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenLocalVolTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableLocalVolTermStructureHandle_linkTo ;
    "~", _delete_RelinkableLocalVolTermStructureHandle ;
   "::Handle<(LocalVolTermStructure)>", (fun args -> (create_class "Handle<(LocalVolTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(LocalVolTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(LocalVolTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(LocalVolTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< LocalVolTermStructure >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenLocalVolTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenOptionletVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _OptionletVolatilityStructure___deref__ ;
    "isNull", _OptionletVolatilityStructure_isNull ;
    "asObservable", _OptionletVolatilityStructure_asObservable ;
    "~", _delete_OptionletVolatilityStructure ;
    "referenceDate", _OptionletVolatilityStructure_referenceDate ;
    "dayCounter", _OptionletVolatilityStructure_dayCounter ;
    "calendar", _OptionletVolatilityStructure_calendar ;
    "maxDate", _OptionletVolatilityStructure_maxDate ;
    "maxTime", _OptionletVolatilityStructure_maxTime ;
    "minStrike", _OptionletVolatilityStructure_minStrike ;
    "maxStrike", _OptionletVolatilityStructure_maxStrike ;
    "volatility", _OptionletVolatilityStructure_volatility ;
    "volatility", _OptionletVolatilityStructure_volatility ;
    "volatility", _OptionletVolatilityStructure_volatility ;
    "volatility", _OptionletVolatilityStructure_volatility ;
    "blackVariance", _OptionletVolatilityStructure_blackVariance ;
    "blackVariance", _OptionletVolatilityStructure_blackVariance ;
    "blackVariance", _OptionletVolatilityStructure_blackVariance ;
    "blackVariance", _OptionletVolatilityStructure_blackVariance ;
    "enableExtrapolation", _OptionletVolatilityStructure_enableExtrapolation ;
    "disableExtrapolation", _OptionletVolatilityStructure_disableExtrapolation ;
    "allowsExtrapolation", _OptionletVolatilityStructure_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(OptionletVolatilityStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(OptionletVolatilityStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< OptionletVolatilityStructure >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenOptionletVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenOptionletVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _OptionletVolatilityStructureHandle___deref__ ;
    "empty", _OptionletVolatilityStructureHandle_empty ;
    "asObservable", _OptionletVolatilityStructureHandle_asObservable ;
    "~", _delete_OptionletVolatilityStructureHandle ;
    "referenceDate", _OptionletVolatilityStructureHandle_referenceDate ;
    "dayCounter", _OptionletVolatilityStructureHandle_dayCounter ;
    "calendar", _OptionletVolatilityStructureHandle_calendar ;
    "maxDate", _OptionletVolatilityStructureHandle_maxDate ;
    "maxTime", _OptionletVolatilityStructureHandle_maxTime ;
    "minStrike", _OptionletVolatilityStructureHandle_minStrike ;
    "maxStrike", _OptionletVolatilityStructureHandle_maxStrike ;
    "volatility", _OptionletVolatilityStructureHandle_volatility ;
    "volatility", _OptionletVolatilityStructureHandle_volatility ;
    "volatility", _OptionletVolatilityStructureHandle_volatility ;
    "volatility", _OptionletVolatilityStructureHandle_volatility ;
    "blackVariance", _OptionletVolatilityStructureHandle_blackVariance ;
    "blackVariance", _OptionletVolatilityStructureHandle_blackVariance ;
    "blackVariance", _OptionletVolatilityStructureHandle_blackVariance ;
    "blackVariance", _OptionletVolatilityStructureHandle_blackVariance ;
    "enableExtrapolation", _OptionletVolatilityStructureHandle_enableExtrapolation ;
    "disableExtrapolation", _OptionletVolatilityStructureHandle_disableExtrapolation ;
    "allowsExtrapolation", _OptionletVolatilityStructureHandle_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(OptionletVolatilityStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(OptionletVolatilityStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< OptionletVolatilityStructure >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenOptionletVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenOptionletVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableOptionletVolatilityStructureHandle_linkTo ;
    "~", _delete_RelinkableOptionletVolatilityStructureHandle ;
   "::Handle<(OptionletVolatilityStructure)>", (fun args -> (create_class "Handle<(OptionletVolatilityStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(OptionletVolatilityStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(OptionletVolatilityStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(OptionletVolatilityStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< OptionletVolatilityStructure >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenOptionletVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenSwaptionVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _SwaptionVolatilityStructure___deref__ ;
    "isNull", _SwaptionVolatilityStructure_isNull ;
    "asObservable", _SwaptionVolatilityStructure_asObservable ;
    "~", _delete_SwaptionVolatilityStructure ;
    "referenceDate", _SwaptionVolatilityStructure_referenceDate ;
    "dayCounter", _SwaptionVolatilityStructure_dayCounter ;
    "calendar", _SwaptionVolatilityStructure_calendar ;
    "maxSwapTenor", _SwaptionVolatilityStructure_maxSwapTenor ;
    "maxSwapLength", _SwaptionVolatilityStructure_maxSwapLength ;
    "minStrike", _SwaptionVolatilityStructure_minStrike ;
    "maxStrike", _SwaptionVolatilityStructure_maxStrike ;
    "volatility", _SwaptionVolatilityStructure_volatility ;
    "volatility", _SwaptionVolatilityStructure_volatility ;
    "volatility", _SwaptionVolatilityStructure_volatility ;
    "volatility", _SwaptionVolatilityStructure_volatility ;
    "blackVariance", _SwaptionVolatilityStructure_blackVariance ;
    "blackVariance", _SwaptionVolatilityStructure_blackVariance ;
    "blackVariance", _SwaptionVolatilityStructure_blackVariance ;
    "blackVariance", _SwaptionVolatilityStructure_blackVariance ;
    "optionDateFromTenor", _SwaptionVolatilityStructure_optionDateFromTenor ;
    "enableExtrapolation", _SwaptionVolatilityStructure_enableExtrapolation ;
    "disableExtrapolation", _SwaptionVolatilityStructure_disableExtrapolation ;
    "allowsExtrapolation", _SwaptionVolatilityStructure_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(SwaptionVolatilityStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(SwaptionVolatilityStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< SwaptionVolatilityStructure >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenSwaptionVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenSwaptionVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _SwaptionVolatilityStructureHandle___deref__ ;
    "empty", _SwaptionVolatilityStructureHandle_empty ;
    "asObservable", _SwaptionVolatilityStructureHandle_asObservable ;
    "~", _delete_SwaptionVolatilityStructureHandle ;
    "referenceDate", _SwaptionVolatilityStructureHandle_referenceDate ;
    "dayCounter", _SwaptionVolatilityStructureHandle_dayCounter ;
    "calendar", _SwaptionVolatilityStructureHandle_calendar ;
    "maxSwapTenor", _SwaptionVolatilityStructureHandle_maxSwapTenor ;
    "maxSwapLength", _SwaptionVolatilityStructureHandle_maxSwapLength ;
    "minStrike", _SwaptionVolatilityStructureHandle_minStrike ;
    "maxStrike", _SwaptionVolatilityStructureHandle_maxStrike ;
    "volatility", _SwaptionVolatilityStructureHandle_volatility ;
    "volatility", _SwaptionVolatilityStructureHandle_volatility ;
    "volatility", _SwaptionVolatilityStructureHandle_volatility ;
    "volatility", _SwaptionVolatilityStructureHandle_volatility ;
    "blackVariance", _SwaptionVolatilityStructureHandle_blackVariance ;
    "blackVariance", _SwaptionVolatilityStructureHandle_blackVariance ;
    "blackVariance", _SwaptionVolatilityStructureHandle_blackVariance ;
    "blackVariance", _SwaptionVolatilityStructureHandle_blackVariance ;
    "optionDateFromTenor", _SwaptionVolatilityStructureHandle_optionDateFromTenor ;
    "enableExtrapolation", _SwaptionVolatilityStructureHandle_enableExtrapolation ;
    "disableExtrapolation", _SwaptionVolatilityStructureHandle_disableExtrapolation ;
    "allowsExtrapolation", _SwaptionVolatilityStructureHandle_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(SwaptionVolatilityStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(SwaptionVolatilityStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< SwaptionVolatilityStructure >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenSwaptionVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenSwaptionVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableSwaptionVolatilityStructureHandle_linkTo ;
    "~", _delete_RelinkableSwaptionVolatilityStructureHandle ;
   "::Handle<(SwaptionVolatilityStructure)>", (fun args -> (create_class "Handle<(SwaptionVolatilityStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(SwaptionVolatilityStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(SwaptionVolatilityStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(SwaptionVolatilityStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< SwaptionVolatilityStructure >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenSwaptionVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr



let create_BlackConstantVolPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BlackConstantVol ;
   "::boost::shared_ptr<(BlackVolTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(BlackVolTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackConstantVolPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(BlackVolTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackConstantVolPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackConstantVolPtr_from_ptr"
          create_BlackConstantVolPtr_from_ptr



let create_BlackVarianceCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BlackVarianceCurve ;
   "::boost::shared_ptr<(BlackVolTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(BlackVolTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackVarianceCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(BlackVolTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackVarianceCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackVarianceCurvePtr_from_ptr"
          create_BlackVarianceCurvePtr_from_ptr



let create_BlackVarianceSurfacePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "setInterpolation", _BlackVarianceSurface_setInterpolation ;
    "setInterpolation", _BlackVarianceSurface_setInterpolation ;
    "~", _delete_BlackVarianceSurface ;
   "::boost::shared_ptr<(BlackVolTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(BlackVolTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackVarianceSurfacePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(BlackVolTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackVarianceSurfacePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackVarianceSurfacePtr_from_ptr"
          create_BlackVarianceSurfacePtr_from_ptr



let create_LocalConstantVolPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_LocalConstantVol ;
   "::boost::shared_ptr<(LocalVolTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(LocalVolTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "LocalConstantVolPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(LocalVolTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"LocalConstantVolPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_LocalConstantVolPtr_from_ptr"
          create_LocalConstantVolPtr_from_ptr



let create_LocalVolSurfacePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_LocalVolSurface ;
   "::boost::shared_ptr<(LocalVolTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(LocalVolTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "LocalVolSurfacePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(LocalVolTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"LocalVolSurfacePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_LocalVolSurfacePtr_from_ptr"
          create_LocalVolSurfacePtr_from_ptr



let create_ConstantOptionletVolatilityPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ConstantOptionletVolatility ;
   "::boost::shared_ptr<(OptionletVolatilityStructure)>", (fun args -> (create_class "boost::shared_ptr<(OptionletVolatilityStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ConstantOptionletVolatilityPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(OptionletVolatilityStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ConstantOptionletVolatilityPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ConstantOptionletVolatilityPtr_from_ptr"
          create_ConstantOptionletVolatilityPtr_from_ptr



let create_ConstantSwaptionVolatilityPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ConstantSwaptionVolatility ;
   "::boost::shared_ptr<(SwaptionVolatilityStructure)>", (fun args -> (create_class "boost::shared_ptr<(SwaptionVolatilityStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ConstantSwaptionVolatilityPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(SwaptionVolatilityStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ConstantSwaptionVolatilityPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ConstantSwaptionVolatilityPtr_from_ptr"
          create_ConstantSwaptionVolatilityPtr_from_ptr



let create_SwaptionVolatilityMatrixPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SwaptionVolatilityMatrix ;
   "::boost::shared_ptr<(SwaptionVolatilityStructure)>", (fun args -> (create_class "boost::shared_ptr<(SwaptionVolatilityStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SwaptionVolatilityMatrixPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(SwaptionVolatilityStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SwaptionVolatilityMatrixPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SwaptionVolatilityMatrixPtr_from_ptr"
          create_SwaptionVolatilityMatrixPtr_from_ptr



let create_SwaptionVolCube1Ptr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "sparseSabrParameters", _SwaptionVolCube1_sparseSabrParameters ;
    "denseSabrParameters", _SwaptionVolCube1_denseSabrParameters ;
    "marketVolCube", _SwaptionVolCube1_marketVolCube ;
    "volCubeAtmCalibrated", _SwaptionVolCube1_volCubeAtmCalibrated ;
    "~", _delete_SwaptionVolCube1 ;
   "::boost::shared_ptr<(SwaptionVolatilityStructure)>", (fun args -> (create_class "boost::shared_ptr<(SwaptionVolatilityStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SwaptionVolCube1Ptr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(SwaptionVolatilityStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SwaptionVolCube1Ptr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SwaptionVolCube1Ptr_from_ptr"
          create_SwaptionVolCube1Ptr_from_ptr



let create_SwaptionVolCube2Ptr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SwaptionVolCube2 ;
   "::boost::shared_ptr<(SwaptionVolatilityStructure)>", (fun args -> (create_class "boost::shared_ptr<(SwaptionVolatilityStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SwaptionVolCube2Ptr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(SwaptionVolatilityStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SwaptionVolCube2Ptr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SwaptionVolCube2Ptr_from_ptr"
          create_SwaptionVolCube2Ptr_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenStochasticProcess_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _StochasticProcess___deref__ ;
    "isNull", _StochasticProcess_isNull ;
    "asObservable", _StochasticProcess_asObservable ;
    "~", _delete_StochasticProcess ;
    "size", _StochasticProcess_size ;
    "factors", _StochasticProcess_factors ;
    "initialValues", _StochasticProcess_initialValues ;
    "drift", _StochasticProcess_drift ;
    "diffusion", _StochasticProcess_diffusion ;
    "expectation", _StochasticProcess_expectation ;
    "stdDeviation", _StochasticProcess_stdDeviation ;
    "covariance", _StochasticProcess_covariance ;
    "evolve", _StochasticProcess_evolve ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(StochasticProcess)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(StochasticProcess)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< StochasticProcess >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenStochasticProcess_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenStochasticProcess_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _StochasticProcessVector_size ;
    "empty", _StochasticProcessVector_empty ;
    "clear", _StochasticProcessVector_clear ;
    "push_back", _StochasticProcessVector_push_back ;
    "[]", _StochasticProcessVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _StochasticProcessVector_operator_xx_xx_equals ;
    "set", _StochasticProcessVector_set ;
    "to_array", _StochasticProcessVector_to_array ;
    "~", _delete_StochasticProcessVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(boost::shared_ptr<(StochasticProcess)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(boost::shared_ptr<(StochasticProcess)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< boost::shared_ptr< StochasticProcess > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenStochasticProcess_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_StochasticProcess1DPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "x0", _StochasticProcess1D_x0 ;
    "drift", _StochasticProcess1D_drift ;
    "diffusion", _StochasticProcess1D_diffusion ;
    "expectation", _StochasticProcess1D_expectation ;
    "stdDeviation", _StochasticProcess1D_stdDeviation ;
    "variance", _StochasticProcess1D_variance ;
    "evolve", _StochasticProcess1D_evolve ;
    "apply", _StochasticProcess1D_apply ;
    "~", _delete_StochasticProcess1D ;
   "::boost::shared_ptr<(StochasticProcess)>", (fun args -> (create_class "boost::shared_ptr<(StochasticProcess)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "StochasticProcess1DPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(StochasticProcess)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"StochasticProcess1DPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_StochasticProcess1DPtr_from_ptr"
          create_StochasticProcess1DPtr_from_ptr



let create_GeneralizedBlackScholesProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "stateVariable", _GeneralizedBlackScholesProcess_stateVariable ;
    "dividendYield", _GeneralizedBlackScholesProcess_dividendYield ;
    "riskFreeRate", _GeneralizedBlackScholesProcess_riskFreeRate ;
    "blackVolatility", _GeneralizedBlackScholesProcess_blackVolatility ;
    "~", _delete_GeneralizedBlackScholesProcess ;
   "::StochasticProcess1DPtr", (fun args -> (create_class "StochasticProcess1DPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GeneralizedBlackScholesProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "StochasticProcess1DPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GeneralizedBlackScholesProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GeneralizedBlackScholesProcessPtr_from_ptr"
          create_GeneralizedBlackScholesProcessPtr_from_ptr



let create_BlackScholesProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BlackScholesProcess ;
   "::GeneralizedBlackScholesProcessPtr", (fun args -> (create_class "GeneralizedBlackScholesProcessPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackScholesProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "GeneralizedBlackScholesProcessPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackScholesProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackScholesProcessPtr_from_ptr"
          create_BlackScholesProcessPtr_from_ptr



let create_BlackScholesMertonProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BlackScholesMertonProcess ;
   "::GeneralizedBlackScholesProcessPtr", (fun args -> (create_class "GeneralizedBlackScholesProcessPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackScholesMertonProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "GeneralizedBlackScholesProcessPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackScholesMertonProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackScholesMertonProcessPtr_from_ptr"
          create_BlackScholesMertonProcessPtr_from_ptr



let create_BlackProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BlackProcess ;
   "::GeneralizedBlackScholesProcessPtr", (fun args -> (create_class "GeneralizedBlackScholesProcessPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "GeneralizedBlackScholesProcessPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackProcessPtr_from_ptr"
          create_BlackProcessPtr_from_ptr



let create_GarmanKohlagenProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GarmanKohlagenProcess ;
   "::GeneralizedBlackScholesProcessPtr", (fun args -> (create_class "GeneralizedBlackScholesProcessPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GarmanKohlagenProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "GeneralizedBlackScholesProcessPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GarmanKohlagenProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GarmanKohlagenProcessPtr_from_ptr"
          create_GarmanKohlagenProcessPtr_from_ptr



let create_Merton76ProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Merton76Process ;
   "::StochasticProcess1DPtr", (fun args -> (create_class "StochasticProcess1DPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Merton76ProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "StochasticProcess1DPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Merton76ProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Merton76ProcessPtr_from_ptr"
          create_Merton76ProcessPtr_from_ptr



let create_StochasticProcessArrayPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_StochasticProcessArray ;
   "::boost::shared_ptr<(StochasticProcess)>", (fun args -> (create_class "boost::shared_ptr<(StochasticProcess)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "StochasticProcessArrayPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(StochasticProcess)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"StochasticProcessArrayPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_StochasticProcessArrayPtr_from_ptr"
          create_StochasticProcessArrayPtr_from_ptr



let create_GeometricBrownianMotionProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GeometricBrownianMotionProcess ;
   "::StochasticProcess1DPtr", (fun args -> (create_class "StochasticProcess1DPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GeometricBrownianMotionProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "StochasticProcess1DPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GeometricBrownianMotionProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GeometricBrownianMotionProcessPtr_from_ptr"
          create_GeometricBrownianMotionProcessPtr_from_ptr



let create_VarianceGammaProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_VarianceGammaProcess ;
   "::StochasticProcess1DPtr", (fun args -> (create_class "StochasticProcess1DPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "VarianceGammaProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "StochasticProcess1DPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"VarianceGammaProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_VarianceGammaProcessPtr_from_ptr"
          create_VarianceGammaProcessPtr_from_ptr



let create_HestonProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "s0", _HestonProcess_s0 ;
    "dividendYield", _HestonProcess_dividendYield ;
    "riskFreeRate", _HestonProcess_riskFreeRate ;
    "~", _delete_HestonProcess ;
   "::boost::shared_ptr<(StochasticProcess)>", (fun args -> (create_class "boost::shared_ptr<(StochasticProcess)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "HestonProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(StochasticProcess)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"HestonProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_HestonProcessPtr_from_ptr"
          create_HestonProcessPtr_from_ptr



let create_BatesProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BatesProcess ;
   "::HestonProcessPtr", (fun args -> (create_class "HestonProcessPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BatesProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "HestonProcessPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BatesProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BatesProcessPtr_from_ptr"
          create_BatesProcessPtr_from_ptr



let create_HullWhiteProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_HullWhiteProcess ;
   "::StochasticProcess1DPtr", (fun args -> (create_class "StochasticProcess1DPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "HullWhiteProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "StochasticProcess1DPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"HullWhiteProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_HullWhiteProcessPtr_from_ptr"
          create_HullWhiteProcessPtr_from_ptr



let create_HullWhiteForwardProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "alpha", _HullWhiteForwardProcess_alpha ;
    "M_T", _HullWhiteForwardProcess_M_T ;
    "B", _HullWhiteForwardProcess_B ;
    "setForwardMeasureTime", _HullWhiteForwardProcess_setForwardMeasureTime ;
    "~", _delete_HullWhiteForwardProcess ;
   "::StochasticProcess1DPtr", (fun args -> (create_class "StochasticProcess1DPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "HullWhiteForwardProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "StochasticProcess1DPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"HullWhiteForwardProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_HullWhiteForwardProcessPtr_from_ptr"
          create_HullWhiteForwardProcessPtr_from_ptr



let create_GsrProcessPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "sigma", _GsrProcess_sigma ;
    "reversion", _GsrProcess_reversion ;
    "y", _GsrProcess_y ;
    "G", _GsrProcess_G ;
    "setForwardMeasureTime", _GsrProcess_setForwardMeasureTime ;
    "~", _delete_GsrProcess ;
   "::StochasticProcess1DPtr", (fun args -> (create_class "StochasticProcess1DPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GsrProcessPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "StochasticProcess1DPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GsrProcessPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GsrProcessPtr_from_ptr"
          create_GsrProcessPtr_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenPricingEngine_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _PricingEngine___deref__ ;
    "isNull", _PricingEngine_isNull ;
    "~", _delete_PricingEngine ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(PricingEngine)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(PricingEngine)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< PricingEngine >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenPricingEngine_xx_rparen_xx_rdbrace_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenInstrument_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _Instrument___deref__ ;
    "isNull", _Instrument_isNull ;
    "asObservable", _Instrument_asObservable ;
    "~", _delete_Instrument ;
    "NPV", _Instrument_NPV ;
    "errorEstimate", _Instrument_errorEstimate ;
    "isExpired", _Instrument_isExpired ;
    "setPricingEngine", _Instrument_setPricingEngine ;
    "recalculate", _Instrument_recalculate ;
    "freeze", _Instrument_freeze ;
    "unfreeze", _Instrument_unfreeze ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(Instrument)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(Instrument)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< Instrument >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenInstrument_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenInstrument_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _InstrumentVector_size ;
    "empty", _InstrumentVector_empty ;
    "clear", _InstrumentVector_clear ;
    "push_back", _InstrumentVector_push_back ;
    "[]", _InstrumentVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _InstrumentVector_operator_xx_xx_equals ;
    "set", _InstrumentVector_set ;
    "to_array", _InstrumentVector_to_array ;
    "~", _delete_InstrumentVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(boost::shared_ptr<(Instrument)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(boost::shared_ptr<(Instrument)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< boost::shared_ptr< Instrument > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenInstrument_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_StockPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Stock ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "StockPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"StockPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_StockPtr_from_ptr"
          create_StockPtr_from_ptr



let create_CompositeInstrumentPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "add", _CompositeInstrument_add ;
    "add", _CompositeInstrument_add ;
    "subtract", _CompositeInstrument_subtract ;
    "subtract", _CompositeInstrument_subtract ;
    "~", _delete_CompositeInstrument ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CompositeInstrumentPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CompositeInstrumentPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CompositeInstrumentPtr_from_ptr"
          create_CompositeInstrumentPtr_from_ptr



let create_DateGeneration_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DateGeneration ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DateGeneration") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DateGeneration"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DateGeneration_from_ptr"
          create_DateGeneration_from_ptr



let create_Schedule_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _Schedule_size ;
    "date", _Schedule_date ;
    "isRegular", _Schedule_isRegular ;
    "until", _Schedule_until ;
    "~", _delete_Schedule ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Schedule") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Schedule"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Schedule_from_ptr"
          create_Schedule_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenCashFlow_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _CashFlow___deref__ ;
    "isNull", _CashFlow_isNull ;
    "asObservable", _CashFlow_asObservable ;
    "~", _delete_CashFlow ;
    "amount", _CashFlow_amount ;
    "date", _CashFlow_date ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(CashFlow)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(CashFlow)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< CashFlow >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenCashFlow_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenCashFlow_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _Leg_size ;
    "empty", _Leg_empty ;
    "clear", _Leg_clear ;
    "push_back", _Leg_push_back ;
    "[]", _Leg_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _Leg_operator_xx_xx_equals ;
    "set", _Leg_set ;
    "to_array", _Leg_to_array ;
    "~", _delete_Leg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(boost::shared_ptr<(CashFlow)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(boost::shared_ptr<(CashFlow)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< boost::shared_ptr< CashFlow > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenCashFlow_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_SimpleCashFlowPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SimpleCashFlow ;
   "::boost::shared_ptr<(CashFlow)>", (fun args -> (create_class "boost::shared_ptr<(CashFlow)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SimpleCashFlowPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(CashFlow)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SimpleCashFlowPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SimpleCashFlowPtr_from_ptr"
          create_SimpleCashFlowPtr_from_ptr



let create_RedemptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Redemption ;
   "::boost::shared_ptr<(CashFlow)>", (fun args -> (create_class "boost::shared_ptr<(CashFlow)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RedemptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(CashFlow)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RedemptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RedemptionPtr_from_ptr"
          create_RedemptionPtr_from_ptr



let create_AmortizingPaymentPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AmortizingPayment ;
   "::boost::shared_ptr<(CashFlow)>", (fun args -> (create_class "boost::shared_ptr<(CashFlow)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AmortizingPaymentPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(CashFlow)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AmortizingPaymentPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AmortizingPaymentPtr_from_ptr"
          create_AmortizingPaymentPtr_from_ptr



let create_CouponPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nominal", _Coupon_nominal ;
    "accrualStartDate", _Coupon_accrualStartDate ;
    "accrualEndDate", _Coupon_accrualEndDate ;
    "referencePeriodStart", _Coupon_referencePeriodStart ;
    "referencePeriodEnd", _Coupon_referencePeriodEnd ;
    "exCouponDate", _Coupon_exCouponDate ;
    "rate", _Coupon_rate ;
    "accrualPeriod", _Coupon_accrualPeriod ;
    "accrualDays", _Coupon_accrualDays ;
    "dayCounter", _Coupon_dayCounter ;
    "accruedAmount", _Coupon_accruedAmount ;
    "~", _delete_Coupon ;
   "::boost::shared_ptr<(CashFlow)>", (fun args -> (create_class "boost::shared_ptr<(CashFlow)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CouponPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(CashFlow)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CouponPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CouponPtr_from_ptr"
          create_CouponPtr_from_ptr



let create_FixedRateCouponPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "interestRate", _FixedRateCoupon_interestRate ;
    "~", _delete_FixedRateCoupon ;
   "::CouponPtr", (fun args -> (create_class "CouponPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FixedRateCouponPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "CouponPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FixedRateCouponPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FixedRateCouponPtr_from_ptr"
          create_FixedRateCouponPtr_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenFloatingRateCouponPricer_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _FloatingRateCouponPricer___deref__ ;
    "isNull", _FloatingRateCouponPricer_isNull ;
    "~", _delete_FloatingRateCouponPricer ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(FloatingRateCouponPricer)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(FloatingRateCouponPricer)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< FloatingRateCouponPricer >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenFloatingRateCouponPricer_xx_rparen_xx_rdbrace_from_ptr



let create_FloatingRateCouponPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "fixingDate", _FloatingRateCoupon_fixingDate ;
    "fixingDays", _FloatingRateCoupon_fixingDays ;
    "isInArrears", _FloatingRateCoupon_isInArrears ;
    "gearing", _FloatingRateCoupon_gearing ;
    "spread", _FloatingRateCoupon_spread ;
    "indexFixing", _FloatingRateCoupon_indexFixing ;
    "adjustedFixing", _FloatingRateCoupon_adjustedFixing ;
    "convexityAdjustment", _FloatingRateCoupon_convexityAdjustment ;
    "price", _FloatingRateCoupon_price ;
    "index", _FloatingRateCoupon_index ;
    "setPricer", _FloatingRateCoupon_setPricer ;
    "~", _delete_FloatingRateCoupon ;
   "::CouponPtr", (fun args -> (create_class "CouponPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FloatingRateCouponPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "CouponPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FloatingRateCouponPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FloatingRateCouponPtr_from_ptr"
          create_FloatingRateCouponPtr_from_ptr



let create_CappedFlooredCouponPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "cap", _CappedFlooredCoupon_cap ;
    "floor", _CappedFlooredCoupon_floor ;
    "effectiveCap", _CappedFlooredCoupon_effectiveCap ;
    "effectiveFloor", _CappedFlooredCoupon_effectiveFloor ;
    "isCapped", _CappedFlooredCoupon_isCapped ;
    "isFloored", _CappedFlooredCoupon_isFloored ;
    "setPricer", _CappedFlooredCoupon_setPricer ;
    "~", _delete_CappedFlooredCoupon ;
   "::FloatingRateCouponPtr", (fun args -> (create_class "FloatingRateCouponPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CappedFlooredCouponPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "FloatingRateCouponPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CappedFlooredCouponPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CappedFlooredCouponPtr_from_ptr"
          create_CappedFlooredCouponPtr_from_ptr



let create_IborCouponPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_IborCoupon ;
   "::FloatingRateCouponPtr", (fun args -> (create_class "FloatingRateCouponPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "IborCouponPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "FloatingRateCouponPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"IborCouponPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_IborCouponPtr_from_ptr"
          create_IborCouponPtr_from_ptr



let create_IborCouponPricerPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "capletVolatility", _IborCouponPricer_capletVolatility ;
    "setCapletVolatility", _IborCouponPricer_setCapletVolatility ;
    "setCapletVolatility", _IborCouponPricer_setCapletVolatility ;
    "~", _delete_IborCouponPricer ;
   "::boost::shared_ptr<(FloatingRateCouponPricer)>", (fun args -> (create_class "boost::shared_ptr<(FloatingRateCouponPricer)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "IborCouponPricerPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(FloatingRateCouponPricer)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"IborCouponPricerPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_IborCouponPricerPtr_from_ptr"
          create_IborCouponPricerPtr_from_ptr



let create_BlackIborCouponPricerPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BlackIborCouponPricer ;
   "::IborCouponPricerPtr", (fun args -> (create_class "IborCouponPricerPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackIborCouponPricerPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "IborCouponPricerPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackIborCouponPricerPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackIborCouponPricerPtr_from_ptr"
          create_BlackIborCouponPricerPtr_from_ptr



let create_CmsCouponPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CmsCoupon ;
   "::FloatingRateCouponPtr", (fun args -> (create_class "FloatingRateCouponPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CmsCouponPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "FloatingRateCouponPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CmsCouponPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CmsCouponPtr_from_ptr"
          create_CmsCouponPtr_from_ptr



let create_CmsCouponPricerPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "swaptionVolatility", _CmsCouponPricer_swaptionVolatility ;
    "setSwaptionVolatility", _CmsCouponPricer_setSwaptionVolatility ;
    "setSwaptionVolatility", _CmsCouponPricer_setSwaptionVolatility ;
    "~", _delete_CmsCouponPricer ;
   "::boost::shared_ptr<(FloatingRateCouponPricer)>", (fun args -> (create_class "boost::shared_ptr<(FloatingRateCouponPricer)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CmsCouponPricerPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(FloatingRateCouponPricer)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CmsCouponPricerPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CmsCouponPricerPtr_from_ptr"
          create_CmsCouponPricerPtr_from_ptr



let create_GFunctionFactory_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GFunctionFactory ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GFunctionFactory") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GFunctionFactory"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GFunctionFactory_from_ptr"
          create_GFunctionFactory_from_ptr



let create_AnalyticHaganPricerPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticHaganPricer ;
   "::CmsCouponPricerPtr", (fun args -> (create_class "CmsCouponPricerPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticHaganPricerPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "CmsCouponPricerPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticHaganPricerPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticHaganPricerPtr_from_ptr"
          create_AnalyticHaganPricerPtr_from_ptr



let create_NumericHaganPricerPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NumericHaganPricer ;
   "::CmsCouponPricerPtr", (fun args -> (create_class "CmsCouponPricerPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "NumericHaganPricerPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "CmsCouponPricerPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"NumericHaganPricerPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_NumericHaganPricerPtr_from_ptr"
          create_NumericHaganPricerPtr_from_ptr



let create_CappedFlooredCmsCouponPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CappedFlooredCmsCoupon ;
   "::CappedFlooredCouponPtr", (fun args -> (create_class "CappedFlooredCouponPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CappedFlooredCmsCouponPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "CappedFlooredCouponPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CappedFlooredCmsCouponPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CappedFlooredCmsCouponPtr_from_ptr"
          create_CappedFlooredCmsCouponPtr_from_ptr



let create_LinearTsrPricerPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_LinearTsrPricer ;
   "::CmsCouponPricerPtr", (fun args -> (create_class "CmsCouponPricerPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "LinearTsrPricerPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "CmsCouponPricerPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"LinearTsrPricerPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_LinearTsrPricerPtr_from_ptr"
          create_LinearTsrPricerPtr_from_ptr



let create_Duration_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Duration ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Duration") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Duration"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Duration_from_ptr"
          create_Duration_from_ptr



let create_CashFlows_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CashFlows ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CashFlows") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CashFlows"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CashFlows_from_ptr"
          create_CashFlows_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenCalibrationHelper_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _CalibrationHelper___deref__ ;
    "isNull", _CalibrationHelper_isNull ;
    "swaptionExpiryDate", _CalibrationHelper_swaptionExpiryDate ;
    "swaptionStrike", _CalibrationHelper_swaptionStrike ;
    "swaptionNominal", _CalibrationHelper_swaptionNominal ;
    "swaptionMaturityDate", _CalibrationHelper_swaptionMaturityDate ;
    "~", _delete_CalibrationHelper ;
    "setPricingEngine", _CalibrationHelper_setPricingEngine ;
    "marketValue", _CalibrationHelper_marketValue ;
    "modelValue", _CalibrationHelper_modelValue ;
    "calibrationError", _CalibrationHelper_calibrationError ;
    "impliedVolatility", _CalibrationHelper_impliedVolatility ;
    "blackPrice", _CalibrationHelper_blackPrice ;
    "volatility", _CalibrationHelper_volatility ;
    "volatilityType", _CalibrationHelper_volatilityType ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(CalibrationHelper)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(CalibrationHelper)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< CalibrationHelper >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenCalibrationHelper_xx_rparen_xx_rdbrace_from_ptr



let create_SwaptionHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "times", _SwaptionHelper_times ;
    "~", _delete_SwaptionHelper ;
   "::boost::shared_ptr<(CalibrationHelper)>", (fun args -> (create_class "boost::shared_ptr<(CalibrationHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SwaptionHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(CalibrationHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SwaptionHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SwaptionHelperPtr_from_ptr"
          create_SwaptionHelperPtr_from_ptr



let create_CapHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "times", _CapHelper_times ;
    "~", _delete_CapHelper ;
   "::boost::shared_ptr<(CalibrationHelper)>", (fun args -> (create_class "boost::shared_ptr<(CalibrationHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CapHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(CalibrationHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CapHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CapHelperPtr_from_ptr"
          create_CapHelperPtr_from_ptr



let create_HestonModelHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_HestonModelHelper ;
   "::boost::shared_ptr<(CalibrationHelper)>", (fun args -> (create_class "boost::shared_ptr<(CalibrationHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "HestonModelHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(CalibrationHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"HestonModelHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_HestonModelHelperPtr_from_ptr"
          create_HestonModelHelperPtr_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenCalibrationHelper_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _CalibrationHelperVector_size ;
    "empty", _CalibrationHelperVector_empty ;
    "clear", _CalibrationHelperVector_clear ;
    "push_back", _CalibrationHelperVector_push_back ;
    "[]", _CalibrationHelperVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _CalibrationHelperVector_operator_xx_xx_equals ;
    "set", _CalibrationHelperVector_set ;
    "to_array", _CalibrationHelperVector_to_array ;
    "~", _delete_CalibrationHelperVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(boost::shared_ptr<(CalibrationHelper)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(boost::shared_ptr<(CalibrationHelper)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< boost::shared_ptr< CalibrationHelper > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenCalibrationHelper_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenCalibratedModel_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _CalibratedModel___deref__ ;
    "isNull", _CalibratedModel_isNull ;
    "asObservable", _CalibratedModel_asObservable ;
    "~", _delete_CalibratedModel ;
    "params", _CalibratedModel_params ;
    "calibrate", _CalibratedModel_calibrate ;
    "calibrate", _CalibratedModel_calibrate ;
    "calibrate", _CalibratedModel_calibrate ;
    "setParams", _CalibratedModel_setParams ;
    "value", _CalibratedModel_value ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(CalibratedModel)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(CalibratedModel)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< CalibratedModel >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenCalibratedModel_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenCalibratedModel_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _CalibratedModelHandle___deref__ ;
    "empty", _CalibratedModelHandle_empty ;
    "asObservable", _CalibratedModelHandle_asObservable ;
    "~", _delete_CalibratedModelHandle ;
    "params", _CalibratedModelHandle_params ;
    "calibrate", _CalibratedModelHandle_calibrate ;
    "calibrate", _CalibratedModelHandle_calibrate ;
    "calibrate", _CalibratedModelHandle_calibrate ;
    "setParams", _CalibratedModelHandle_setParams ;
    "value", _CalibratedModelHandle_value ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(CalibratedModel)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(CalibratedModel)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< CalibratedModel >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenCalibratedModel_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenCalibratedModel_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableCalibratedModelHandle_linkTo ;
    "~", _delete_RelinkableCalibratedModelHandle ;
   "::Handle<(CalibratedModel)>", (fun args -> (create_class "Handle<(CalibratedModel)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(CalibratedModel)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(CalibratedModel)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(CalibratedModel)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< CalibratedModel >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenCalibratedModel_xx_rparen_xx_rdbrace_from_ptr



let create_TimeGrid_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _TimeGrid_size ;
    "~", _delete_TimeGrid ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TimeGrid") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TimeGrid"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TimeGrid_from_ptr"
          create_TimeGrid_from_ptr



let create_Parameter_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "params", _Parameter_params ;
    "setParam", _Parameter_setParam ;
    "testParams", _Parameter_testParams ;
    "size", _Parameter_size ;
    "()", _Parameter_operator_xx_xx_lparen_xx_rparen ;
    "constraint", _Parameter_constraint ;
    "~", _delete_Parameter ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Parameter") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Parameter"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Parameter_from_ptr"
          create_Parameter_from_ptr



let create_ConstantParameter_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ConstantParameter ;
   "::Parameter", (fun args -> (create_class "Parameter") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ConstantParameter") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Parameter") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ConstantParameter"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ConstantParameter_from_ptr"
          create_ConstantParameter_from_ptr



let create_NullParameter_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NullParameter ;
   "::Parameter", (fun args -> (create_class "Parameter") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "NullParameter") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Parameter") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"NullParameter"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_NullParameter_from_ptr"
          create_NullParameter_from_ptr



let create_PiecewiseConstantParameter_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_PiecewiseConstantParameter ;
   "::Parameter", (fun args -> (create_class "Parameter") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PiecewiseConstantParameter") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Parameter") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PiecewiseConstantParameter"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PiecewiseConstantParameter_from_ptr"
          create_PiecewiseConstantParameter_from_ptr



let create_Option_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Option ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Option") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Option"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Option_from_ptr"
          create_Option_from_ptr



let create_Barrier_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Barrier ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Barrier") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Barrier"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Barrier_from_ptr"
          create_Barrier_from_ptr



let create_DoubleBarrier_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DoubleBarrier ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DoubleBarrier") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DoubleBarrier"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DoubleBarrier_from_ptr"
          create_DoubleBarrier_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenPayoff_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _Payoff___deref__ ;
    "isNull", _Payoff_isNull ;
    "~", _delete_Payoff ;
    "()", _Payoff_operator_xx_xx_lparen_xx_rparen ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(Payoff)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(Payoff)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< Payoff >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenPayoff_xx_rparen_xx_rdbrace_from_ptr



let create_VanillaOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "priceCurve", _VanillaOption_priceCurve ;
    "impliedVolatility", _VanillaOption_impliedVolatility ;
    "impliedVolatility", _VanillaOption_impliedVolatility ;
    "impliedVolatility", _VanillaOption_impliedVolatility ;
    "impliedVolatility", _VanillaOption_impliedVolatility ;
    "impliedVolatility", _VanillaOption_impliedVolatility ;
    "delta", _VanillaOption_delta ;
    "gamma", _VanillaOption_gamma ;
    "theta", _VanillaOption_theta ;
    "thetaPerDay", _VanillaOption_thetaPerDay ;
    "vega", _VanillaOption_vega ;
    "rho", _VanillaOption_rho ;
    "dividendRho", _VanillaOption_dividendRho ;
    "strikeSensitivity", _VanillaOption_strikeSensitivity ;
    "~", _delete_VanillaOption ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "VanillaOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"VanillaOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_VanillaOptionPtr_from_ptr"
          create_VanillaOptionPtr_from_ptr



let create_EuropeanOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EuropeanOption ;
   "::VanillaOptionPtr", (fun args -> (create_class "VanillaOptionPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EuropeanOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "VanillaOptionPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EuropeanOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EuropeanOptionPtr_from_ptr"
          create_EuropeanOptionPtr_from_ptr



let create_ForwardVanillaOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ForwardVanillaOption ;
   "::VanillaOptionPtr", (fun args -> (create_class "VanillaOptionPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ForwardVanillaOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "VanillaOptionPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ForwardVanillaOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ForwardVanillaOptionPtr_from_ptr"
          create_ForwardVanillaOptionPtr_from_ptr



let create_QuantoVanillaOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "qvega", _QuantoVanillaOption_qvega ;
    "qrho", _QuantoVanillaOption_qrho ;
    "qlambda", _QuantoVanillaOption_qlambda ;
    "~", _delete_QuantoVanillaOption ;
   "::VanillaOptionPtr", (fun args -> (create_class "VanillaOptionPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantoVanillaOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "VanillaOptionPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantoVanillaOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantoVanillaOptionPtr_from_ptr"
          create_QuantoVanillaOptionPtr_from_ptr



let create_QuantoForwardVanillaOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_QuantoForwardVanillaOption ;
   "::QuantoVanillaOptionPtr", (fun args -> (create_class "QuantoVanillaOptionPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantoForwardVanillaOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "QuantoVanillaOptionPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantoForwardVanillaOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantoForwardVanillaOptionPtr_from_ptr"
          create_QuantoForwardVanillaOptionPtr_from_ptr



let create_MultiAssetOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "delta", _MultiAssetOption_delta ;
    "gamma", _MultiAssetOption_gamma ;
    "theta", _MultiAssetOption_theta ;
    "vega", _MultiAssetOption_vega ;
    "rho", _MultiAssetOption_rho ;
    "dividendRho", _MultiAssetOption_dividendRho ;
    "~", _delete_MultiAssetOption ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MultiAssetOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MultiAssetOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MultiAssetOptionPtr_from_ptr"
          create_MultiAssetOptionPtr_from_ptr



let create_AnalyticEuropeanEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticEuropeanEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticEuropeanEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticEuropeanEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticEuropeanEnginePtr_from_ptr"
          create_AnalyticEuropeanEnginePtr_from_ptr



let create_HestonModelPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "theta", _HestonModel_theta ;
    "kappa", _HestonModel_kappa ;
    "sigma", _HestonModel_sigma ;
    "rho", _HestonModel_rho ;
    "v0", _HestonModel_v0 ;
    "~", _delete_HestonModel ;
   "::boost::shared_ptr<(CalibratedModel)>", (fun args -> (create_class "boost::shared_ptr<(CalibratedModel)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "HestonModelPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(CalibratedModel)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"HestonModelPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_HestonModelPtr_from_ptr"
          create_HestonModelPtr_from_ptr



let create_PiecewiseTimeDependentHestonModelPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "theta", _PiecewiseTimeDependentHestonModel_theta ;
    "kappa", _PiecewiseTimeDependentHestonModel_kappa ;
    "sigma", _PiecewiseTimeDependentHestonModel_sigma ;
    "rho", _PiecewiseTimeDependentHestonModel_rho ;
    "v0", _PiecewiseTimeDependentHestonModel_v0 ;
    "s0", _PiecewiseTimeDependentHestonModel_s0 ;
    "timeGrid", _PiecewiseTimeDependentHestonModel_timeGrid ;
    "dividendYield", _PiecewiseTimeDependentHestonModel_dividendYield ;
    "riskFreeRate", _PiecewiseTimeDependentHestonModel_riskFreeRate ;
    "~", _delete_PiecewiseTimeDependentHestonModel ;
   "::boost::shared_ptr<(CalibratedModel)>", (fun args -> (create_class "boost::shared_ptr<(CalibratedModel)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PiecewiseTimeDependentHestonModelPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(CalibratedModel)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PiecewiseTimeDependentHestonModelPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PiecewiseTimeDependentHestonModelPtr_from_ptr"
          create_PiecewiseTimeDependentHestonModelPtr_from_ptr



let create_AnalyticHestonEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticHestonEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticHestonEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticHestonEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticHestonEnginePtr_from_ptr"
          create_AnalyticHestonEnginePtr_from_ptr



let create_AnalyticPTDHestonEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticPTDHestonEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticPTDHestonEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticPTDHestonEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticPTDHestonEnginePtr_from_ptr"
          create_AnalyticPTDHestonEnginePtr_from_ptr



let create_BatesModelPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nu", _BatesModel_nu ;
    "delta", _BatesModel_delta ;
    "lambda", _BatesModel_lambda ;
    "~", _delete_BatesModel ;
   "::HestonModelPtr", (fun args -> (create_class "HestonModelPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BatesModelPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "HestonModelPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BatesModelPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BatesModelPtr_from_ptr"
          create_BatesModelPtr_from_ptr



let create_BatesEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BatesEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BatesEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BatesEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BatesEnginePtr_from_ptr"
          create_BatesEnginePtr_from_ptr



let create_IntegralEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_IntegralEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "IntegralEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"IntegralEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_IntegralEnginePtr_from_ptr"
          create_IntegralEnginePtr_from_ptr



let create_FDBermudanEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FDBermudanEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FDBermudanEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FDBermudanEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FDBermudanEnginePtr_from_ptr"
          create_FDBermudanEnginePtr_from_ptr



let create_FDEuropeanEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FDEuropeanEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FDEuropeanEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FDEuropeanEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FDEuropeanEnginePtr_from_ptr"
          create_FDEuropeanEnginePtr_from_ptr



let create_BinomialVanillaEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BinomialVanillaEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BinomialVanillaEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BinomialVanillaEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BinomialVanillaEnginePtr_from_ptr"
          create_BinomialVanillaEnginePtr_from_ptr



let create_MCEuropeanEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MCEuropeanEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MCEuropeanEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MCEuropeanEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MCEuropeanEnginePtr_from_ptr"
          create_MCEuropeanEnginePtr_from_ptr



let create_FDAmericanEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FDAmericanEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FDAmericanEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FDAmericanEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FDAmericanEnginePtr_from_ptr"
          create_FDAmericanEnginePtr_from_ptr



let create_FdBlackScholesVanillaEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FdBlackScholesVanillaEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FdBlackScholesVanillaEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FdBlackScholesVanillaEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FdBlackScholesVanillaEnginePtr_from_ptr"
          create_FdBlackScholesVanillaEnginePtr_from_ptr



let create_FdBatesVanillaEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FdBatesVanillaEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FdBatesVanillaEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FdBatesVanillaEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FdBatesVanillaEnginePtr_from_ptr"
          create_FdBatesVanillaEnginePtr_from_ptr



let create_ContinuousArithmeticAsianLevyEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ContinuousArithmeticAsianLevyEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ContinuousArithmeticAsianLevyEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ContinuousArithmeticAsianLevyEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ContinuousArithmeticAsianLevyEnginePtr_from_ptr"
          create_ContinuousArithmeticAsianLevyEnginePtr_from_ptr



let create_FdBlackScholesAsianEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FdBlackScholesAsianEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FdBlackScholesAsianEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FdBlackScholesAsianEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FdBlackScholesAsianEnginePtr_from_ptr"
          create_FdBlackScholesAsianEnginePtr_from_ptr



let create_FDShoutEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FDShoutEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FDShoutEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FDShoutEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FDShoutEnginePtr_from_ptr"
          create_FDShoutEnginePtr_from_ptr



let create_BaroneAdesiWhaleyApproximationEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BaroneAdesiWhaleyEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BaroneAdesiWhaleyApproximationEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BaroneAdesiWhaleyApproximationEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BaroneAdesiWhaleyApproximationEnginePtr_from_ptr"
          create_BaroneAdesiWhaleyApproximationEnginePtr_from_ptr



let create_BjerksundStenslandApproximationEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BjerksundStenslandEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BjerksundStenslandApproximationEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BjerksundStenslandApproximationEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BjerksundStenslandApproximationEnginePtr_from_ptr"
          create_BjerksundStenslandApproximationEnginePtr_from_ptr



let create_AnalyticDigitalAmericanEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticDigitalAmericanEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticDigitalAmericanEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticDigitalAmericanEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticDigitalAmericanEnginePtr_from_ptr"
          create_AnalyticDigitalAmericanEnginePtr_from_ptr



let create_AnalyticDigitalAmericanKOEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticDigitalAmericanKOEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticDigitalAmericanKOEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticDigitalAmericanKOEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticDigitalAmericanKOEnginePtr_from_ptr"
          create_AnalyticDigitalAmericanKOEnginePtr_from_ptr



let create_DividendVanillaOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "priceCurve", _DividendVanillaOption_priceCurve ;
    "impliedVolatility", _DividendVanillaOption_impliedVolatility ;
    "impliedVolatility", _DividendVanillaOption_impliedVolatility ;
    "impliedVolatility", _DividendVanillaOption_impliedVolatility ;
    "impliedVolatility", _DividendVanillaOption_impliedVolatility ;
    "impliedVolatility", _DividendVanillaOption_impliedVolatility ;
    "delta", _DividendVanillaOption_delta ;
    "gamma", _DividendVanillaOption_gamma ;
    "theta", _DividendVanillaOption_theta ;
    "thetaPerDay", _DividendVanillaOption_thetaPerDay ;
    "vega", _DividendVanillaOption_vega ;
    "rho", _DividendVanillaOption_rho ;
    "dividendRho", _DividendVanillaOption_dividendRho ;
    "strikeSensitivity", _DividendVanillaOption_strikeSensitivity ;
    "~", _delete_DividendVanillaOption ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DividendVanillaOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DividendVanillaOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DividendVanillaOptionPtr_from_ptr"
          create_DividendVanillaOptionPtr_from_ptr



let create_AnalyticDividendEuropeanEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticDividendEuropeanEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticDividendEuropeanEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticDividendEuropeanEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticDividendEuropeanEnginePtr_from_ptr"
          create_AnalyticDividendEuropeanEnginePtr_from_ptr



let create_FDDividendEuropeanEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FDDividendEuropeanEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FDDividendEuropeanEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FDDividendEuropeanEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FDDividendEuropeanEnginePtr_from_ptr"
          create_FDDividendEuropeanEnginePtr_from_ptr



let create_FDDividendAmericanEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FDDividendAmericanEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FDDividendAmericanEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FDDividendAmericanEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FDDividendAmericanEnginePtr_from_ptr"
          create_FDDividendAmericanEnginePtr_from_ptr



let create_BarrierOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "priceCurve", _BarrierOption_priceCurve ;
    "impliedVolatility", _BarrierOption_impliedVolatility ;
    "impliedVolatility", _BarrierOption_impliedVolatility ;
    "impliedVolatility", _BarrierOption_impliedVolatility ;
    "impliedVolatility", _BarrierOption_impliedVolatility ;
    "impliedVolatility", _BarrierOption_impliedVolatility ;
    "delta", _BarrierOption_delta ;
    "gamma", _BarrierOption_gamma ;
    "theta", _BarrierOption_theta ;
    "thetaPerDay", _BarrierOption_thetaPerDay ;
    "vega", _BarrierOption_vega ;
    "rho", _BarrierOption_rho ;
    "dividendRho", _BarrierOption_dividendRho ;
    "strikeSensitivity", _BarrierOption_strikeSensitivity ;
    "~", _delete_BarrierOption ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BarrierOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BarrierOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BarrierOptionPtr_from_ptr"
          create_BarrierOptionPtr_from_ptr



let create_AnalyticBarrierEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticBarrierEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticBarrierEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticBarrierEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticBarrierEnginePtr_from_ptr"
          create_AnalyticBarrierEnginePtr_from_ptr



let create_MCBarrierEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MCBarrierEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MCBarrierEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MCBarrierEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MCBarrierEnginePtr_from_ptr"
          create_MCBarrierEnginePtr_from_ptr



let create_FdmSchemeDesc_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "", _FdmSchemeDesc_type_get ;
    "", _FdmSchemeDesc_theta_get ;
    "", _FdmSchemeDesc_mu_get ;
    "~", _delete_FdmSchemeDesc ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FdmSchemeDesc") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FdmSchemeDesc"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FdmSchemeDesc_from_ptr"
          create_FdmSchemeDesc_from_ptr



let create_FdBlackScholesBarrierEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FdBlackScholesBarrierEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FdBlackScholesBarrierEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FdBlackScholesBarrierEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FdBlackScholesBarrierEnginePtr_from_ptr"
          create_FdBlackScholesBarrierEnginePtr_from_ptr



let create_AnalyticBinaryBarrierEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticBinaryBarrierEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticBinaryBarrierEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticBinaryBarrierEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticBinaryBarrierEnginePtr_from_ptr"
          create_AnalyticBinaryBarrierEnginePtr_from_ptr



let create_BinomialBarrierEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BinomialBarrierEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BinomialBarrierEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BinomialBarrierEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BinomialBarrierEnginePtr_from_ptr"
          create_BinomialBarrierEnginePtr_from_ptr



let create_ForwardEuropeanEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ForwardEuropeanEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ForwardEuropeanEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ForwardEuropeanEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ForwardEuropeanEnginePtr_from_ptr"
          create_ForwardEuropeanEnginePtr_from_ptr



let create_QuantoEuropeanEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_QuantoEuropeanEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantoEuropeanEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantoEuropeanEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantoEuropeanEnginePtr_from_ptr"
          create_QuantoEuropeanEnginePtr_from_ptr



let create_QuantoForwardEuropeanEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_QuantoForwardEuropeanEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantoForwardEuropeanEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantoForwardEuropeanEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantoForwardEuropeanEnginePtr_from_ptr"
          create_QuantoForwardEuropeanEnginePtr_from_ptr



let create_BlackCalculator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "value", _BlackCalculator_value ;
    "deltaForward", _BlackCalculator_deltaForward ;
    "delta", _BlackCalculator_delta ;
    "elasticityForward", _BlackCalculator_elasticityForward ;
    "elasticity", _BlackCalculator_elasticity ;
    "gammaForward", _BlackCalculator_gammaForward ;
    "gamma", _BlackCalculator_gamma ;
    "theta", _BlackCalculator_theta ;
    "thetaPerDay", _BlackCalculator_thetaPerDay ;
    "vega", _BlackCalculator_vega ;
    "rho", _BlackCalculator_rho ;
    "dividendRho", _BlackCalculator_dividendRho ;
    "itmCashProbability", _BlackCalculator_itmCashProbability ;
    "itmAssetProbability", _BlackCalculator_itmAssetProbability ;
    "strikeSensitivity", _BlackCalculator_strikeSensitivity ;
    "alpha", _BlackCalculator_alpha ;
    "beta", _BlackCalculator_beta ;
    "~", _delete_BlackCalculator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackCalculator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackCalculator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackCalculator_from_ptr"
          create_BlackCalculator_from_ptr



let create_Average_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Average ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Average") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Average"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Average_from_ptr"
          create_Average_from_ptr



let create_ContinuousAveragingAsianOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "delta", _ContinuousAveragingAsianOption_delta ;
    "gamma", _ContinuousAveragingAsianOption_gamma ;
    "theta", _ContinuousAveragingAsianOption_theta ;
    "thetaPerDay", _ContinuousAveragingAsianOption_thetaPerDay ;
    "vega", _ContinuousAveragingAsianOption_vega ;
    "rho", _ContinuousAveragingAsianOption_rho ;
    "dividendRho", _ContinuousAveragingAsianOption_dividendRho ;
    "strikeSensitivity", _ContinuousAveragingAsianOption_strikeSensitivity ;
    "~", _delete_ContinuousAveragingAsianOption ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ContinuousAveragingAsianOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ContinuousAveragingAsianOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ContinuousAveragingAsianOptionPtr_from_ptr"
          create_ContinuousAveragingAsianOptionPtr_from_ptr



let create_DiscreteAveragingAsianOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "delta", _DiscreteAveragingAsianOption_delta ;
    "gamma", _DiscreteAveragingAsianOption_gamma ;
    "theta", _DiscreteAveragingAsianOption_theta ;
    "thetaPerDay", _DiscreteAveragingAsianOption_thetaPerDay ;
    "vega", _DiscreteAveragingAsianOption_vega ;
    "rho", _DiscreteAveragingAsianOption_rho ;
    "dividendRho", _DiscreteAveragingAsianOption_dividendRho ;
    "strikeSensitivity", _DiscreteAveragingAsianOption_strikeSensitivity ;
    "~", _delete_DiscreteAveragingAsianOption ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DiscreteAveragingAsianOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DiscreteAveragingAsianOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DiscreteAveragingAsianOptionPtr_from_ptr"
          create_DiscreteAveragingAsianOptionPtr_from_ptr



let create_AnalyticContinuousGeometricAveragePriceAsianEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticContinuousGeometricAveragePriceAsianEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticContinuousGeometricAveragePriceAsianEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticContinuousGeometricAveragePriceAsianEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticContinuousGeometricAveragePriceAsianEnginePtr_from_ptr"
          create_AnalyticContinuousGeometricAveragePriceAsianEnginePtr_from_ptr



let create_AnalyticDiscreteGeometricAveragePriceAsianEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticDiscreteGeometricAveragePriceAsianEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticDiscreteGeometricAveragePriceAsianEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticDiscreteGeometricAveragePriceAsianEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticDiscreteGeometricAveragePriceAsianEnginePtr_from_ptr"
          create_AnalyticDiscreteGeometricAveragePriceAsianEnginePtr_from_ptr



let create_AnalyticDiscreteGeometricAverageStrikeAsianEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticDiscreteGeometricAverageStrikeAsianEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticDiscreteGeometricAverageStrikeAsianEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticDiscreteGeometricAverageStrikeAsianEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticDiscreteGeometricAverageStrikeAsianEnginePtr_from_ptr"
          create_AnalyticDiscreteGeometricAverageStrikeAsianEnginePtr_from_ptr



let create_MCDiscreteArithmeticAPEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MCDiscreteArithmeticAPEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MCDiscreteArithmeticAPEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MCDiscreteArithmeticAPEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MCDiscreteArithmeticAPEnginePtr_from_ptr"
          create_MCDiscreteArithmeticAPEnginePtr_from_ptr



let create_MCDiscreteArithmeticASEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MCDiscreteArithmeticASEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MCDiscreteArithmeticASEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MCDiscreteArithmeticASEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MCDiscreteArithmeticASEnginePtr_from_ptr"
          create_MCDiscreteArithmeticASEnginePtr_from_ptr



let create_MCDiscreteGeometricAPEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MCDiscreteGeometricAPEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MCDiscreteGeometricAPEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MCDiscreteGeometricAPEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MCDiscreteGeometricAPEnginePtr_from_ptr"
          create_MCDiscreteGeometricAPEnginePtr_from_ptr



let create_VarianceGammaEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_VarianceGammaEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "VarianceGammaEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"VarianceGammaEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_VarianceGammaEnginePtr_from_ptr"
          create_VarianceGammaEnginePtr_from_ptr



let create_FFTVarianceGammaEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "precalculate", _FFTVarianceGammaEngine_precalculate ;
    "~", _delete_FFTVarianceGammaEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FFTVarianceGammaEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FFTVarianceGammaEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FFTVarianceGammaEnginePtr_from_ptr"
          create_FFTVarianceGammaEnginePtr_from_ptr



let create_DoubleBarrierOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "delta", _DoubleBarrierOption_delta ;
    "gamma", _DoubleBarrierOption_gamma ;
    "theta", _DoubleBarrierOption_theta ;
    "thetaPerDay", _DoubleBarrierOption_thetaPerDay ;
    "vega", _DoubleBarrierOption_vega ;
    "rho", _DoubleBarrierOption_rho ;
    "dividendRho", _DoubleBarrierOption_dividendRho ;
    "strikeSensitivity", _DoubleBarrierOption_strikeSensitivity ;
    "~", _delete_DoubleBarrierOption ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DoubleBarrierOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DoubleBarrierOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DoubleBarrierOptionPtr_from_ptr"
          create_DoubleBarrierOptionPtr_from_ptr



let create_QuantoDoubleBarrierOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "qvega", _QuantoDoubleBarrierOption_qvega ;
    "qrho", _QuantoDoubleBarrierOption_qrho ;
    "qlambda", _QuantoDoubleBarrierOption_qlambda ;
    "~", _delete_QuantoDoubleBarrierOption ;
   "::DoubleBarrierOptionPtr", (fun args -> (create_class "DoubleBarrierOptionPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "QuantoDoubleBarrierOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "DoubleBarrierOptionPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"QuantoDoubleBarrierOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_QuantoDoubleBarrierOptionPtr_from_ptr"
          create_QuantoDoubleBarrierOptionPtr_from_ptr



let create_AnalyticDoubleBarrierEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticDoubleBarrierEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticDoubleBarrierEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticDoubleBarrierEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticDoubleBarrierEnginePtr_from_ptr"
          create_AnalyticDoubleBarrierEnginePtr_from_ptr



let create_WulinYongDoubleBarrierEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_WulinYongDoubleBarrierEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "WulinYongDoubleBarrierEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"WulinYongDoubleBarrierEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_WulinYongDoubleBarrierEnginePtr_from_ptr"
          create_WulinYongDoubleBarrierEnginePtr_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenDeltaVolQuote_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _DeltaVolQuote___deref__ ;
    "isNull", _DeltaVolQuote_isNull ;
    "asObservable", _DeltaVolQuote_asObservable ;
    "~", _delete_DeltaVolQuote ;
    "value", _DeltaVolQuote_value ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(DeltaVolQuote)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(DeltaVolQuote)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< DeltaVolQuote >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenDeltaVolQuote_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenDeltaVolQuote_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _DeltaVolQuoteHandle___deref__ ;
    "empty", _DeltaVolQuoteHandle_empty ;
    "asObservable", _DeltaVolQuoteHandle_asObservable ;
    "~", _delete_DeltaVolQuoteHandle ;
    "value", _DeltaVolQuoteHandle_value ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(DeltaVolQuote)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(DeltaVolQuote)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< DeltaVolQuote >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenDeltaVolQuote_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenDeltaVolQuote_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableDeltaVolQuoteHandle_linkTo ;
    "~", _delete_RelinkableDeltaVolQuoteHandle ;
   "::Handle<(DeltaVolQuote)>", (fun args -> (create_class "Handle<(DeltaVolQuote)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(DeltaVolQuote)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(DeltaVolQuote)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(DeltaVolQuote)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< DeltaVolQuote >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenDeltaVolQuote_xx_rparen_xx_rdbrace_from_ptr



let create_VannaVolgaDoubleBarrierEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_VannaVolgaDoubleBarrierEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "VannaVolgaDoubleBarrierEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"VannaVolgaDoubleBarrierEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_VannaVolgaDoubleBarrierEnginePtr_from_ptr"
          create_VannaVolgaDoubleBarrierEnginePtr_from_ptr



let create_AnalyticDoubleBarrierBinaryEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticDoubleBarrierBinaryEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticDoubleBarrierBinaryEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticDoubleBarrierBinaryEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticDoubleBarrierBinaryEnginePtr_from_ptr"
          create_AnalyticDoubleBarrierBinaryEnginePtr_from_ptr



let create_BinomialDoubleBarrierEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BinomialDoubleBarrierEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BinomialDoubleBarrierEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BinomialDoubleBarrierEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BinomialDoubleBarrierEnginePtr_from_ptr"
          create_BinomialDoubleBarrierEnginePtr_from_ptr



let create_PlainVanillaPayoffPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "optionType", _PlainVanillaPayoff_optionType ;
    "strike", _PlainVanillaPayoff_strike ;
    "~", _delete_PlainVanillaPayoff ;
   "::boost::shared_ptr<(Payoff)>", (fun args -> (create_class "boost::shared_ptr<(Payoff)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PlainVanillaPayoffPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Payoff)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PlainVanillaPayoffPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PlainVanillaPayoffPtr_from_ptr"
          create_PlainVanillaPayoffPtr_from_ptr



let create_PercentageStrikePayoffPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_PercentageStrikePayoff ;
   "::boost::shared_ptr<(Payoff)>", (fun args -> (create_class "boost::shared_ptr<(Payoff)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PercentageStrikePayoffPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Payoff)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PercentageStrikePayoffPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PercentageStrikePayoffPtr_from_ptr"
          create_PercentageStrikePayoffPtr_from_ptr



let create_CashOrNothingPayoffPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CashOrNothingPayoff ;
   "::boost::shared_ptr<(Payoff)>", (fun args -> (create_class "boost::shared_ptr<(Payoff)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CashOrNothingPayoffPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Payoff)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CashOrNothingPayoffPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CashOrNothingPayoffPtr_from_ptr"
          create_CashOrNothingPayoffPtr_from_ptr



let create_AssetOrNothingPayoffPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AssetOrNothingPayoff ;
   "::boost::shared_ptr<(Payoff)>", (fun args -> (create_class "boost::shared_ptr<(Payoff)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AssetOrNothingPayoffPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Payoff)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AssetOrNothingPayoffPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AssetOrNothingPayoffPtr_from_ptr"
          create_AssetOrNothingPayoffPtr_from_ptr



let create_SuperSharePayoffPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SuperSharePayoff ;
   "::boost::shared_ptr<(Payoff)>", (fun args -> (create_class "boost::shared_ptr<(Payoff)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SuperSharePayoffPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Payoff)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SuperSharePayoffPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SuperSharePayoffPtr_from_ptr"
          create_SuperSharePayoffPtr_from_ptr



let create_GapPayoffPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GapPayoff ;
   "::boost::shared_ptr<(Payoff)>", (fun args -> (create_class "boost::shared_ptr<(Payoff)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GapPayoffPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Payoff)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GapPayoffPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GapPayoffPtr_from_ptr"
          create_GapPayoffPtr_from_ptr



let create_BasketPayoffPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BasketPayoff ;
   "::boost::shared_ptr<(Payoff)>", (fun args -> (create_class "boost::shared_ptr<(Payoff)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BasketPayoffPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Payoff)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BasketPayoffPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BasketPayoffPtr_from_ptr"
          create_BasketPayoffPtr_from_ptr



let create_MinBasketPayoffPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MinBasketPayoff ;
   "::BasketPayoffPtr", (fun args -> (create_class "BasketPayoffPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MinBasketPayoffPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BasketPayoffPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MinBasketPayoffPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MinBasketPayoffPtr_from_ptr"
          create_MinBasketPayoffPtr_from_ptr



let create_MaxBasketPayoffPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MaxBasketPayoff ;
   "::BasketPayoffPtr", (fun args -> (create_class "BasketPayoffPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MaxBasketPayoffPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BasketPayoffPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MaxBasketPayoffPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MaxBasketPayoffPtr_from_ptr"
          create_MaxBasketPayoffPtr_from_ptr



let create_AverageBasketPayoffPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AverageBasketPayoff ;
   "::BasketPayoffPtr", (fun args -> (create_class "BasketPayoffPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AverageBasketPayoffPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BasketPayoffPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AverageBasketPayoffPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AverageBasketPayoffPtr_from_ptr"
          create_AverageBasketPayoffPtr_from_ptr



let create_BasketOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BasketOption ;
   "::MultiAssetOptionPtr", (fun args -> (create_class "MultiAssetOptionPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BasketOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "MultiAssetOptionPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BasketOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BasketOptionPtr_from_ptr"
          create_BasketOptionPtr_from_ptr



let create_MCEuropeanBasketEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MCEuropeanBasketEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MCEuropeanBasketEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MCEuropeanBasketEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MCEuropeanBasketEnginePtr_from_ptr"
          create_MCEuropeanBasketEnginePtr_from_ptr



let create_MCAmericanBasketEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MCAmericanBasketEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MCAmericanBasketEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MCAmericanBasketEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MCAmericanBasketEnginePtr_from_ptr"
          create_MCAmericanBasketEnginePtr_from_ptr



let create_StulzEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_StulzEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "StulzEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"StulzEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_StulzEnginePtr_from_ptr"
          create_StulzEnginePtr_from_ptr



let create_EverestOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EverestOption ;
   "::MultiAssetOptionPtr", (fun args -> (create_class "MultiAssetOptionPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EverestOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "MultiAssetOptionPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EverestOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EverestOptionPtr_from_ptr"
          create_EverestOptionPtr_from_ptr



let create_MCEverestEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MCEverestEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MCEverestEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MCEverestEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MCEverestEnginePtr_from_ptr"
          create_MCEverestEnginePtr_from_ptr



let create_HimalayaOptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_HimalayaOption ;
   "::MultiAssetOptionPtr", (fun args -> (create_class "MultiAssetOptionPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "HimalayaOptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "MultiAssetOptionPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"HimalayaOptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_HimalayaOptionPtr_from_ptr"
          create_HimalayaOptionPtr_from_ptr



let create_MCHimalayaEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MCHimalayaEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MCHimalayaEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MCHimalayaEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MCHimalayaEnginePtr_from_ptr"
          create_MCHimalayaEnginePtr_from_ptr



let create_BlackDeltaCalculator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "deltaFromStrike", _BlackDeltaCalculator_deltaFromStrike ;
    "strikeFromDelta", _BlackDeltaCalculator_strikeFromDelta ;
    "atmStrike", _BlackDeltaCalculator_atmStrike ;
    "~", _delete_BlackDeltaCalculator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackDeltaCalculator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackDeltaCalculator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackDeltaCalculator_from_ptr"
          create_BlackDeltaCalculator_from_ptr



let create_CallabilityPrice_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "amount", _CallabilityPrice_amount ;
    "type", _CallabilityPrice_type ;
    "~", _delete_CallabilityPrice ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CallabilityPrice") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CallabilityPrice"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CallabilityPrice_from_ptr"
          create_CallabilityPrice_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenCallability_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _Callability___deref__ ;
    "isNull", _Callability_isNull ;
    "~", _delete_Callability ;
    "price", _Callability_price ;
    "type", _Callability_type ;
    "date", _Callability_date ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(Callability)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(Callability)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< Callability >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenCallability_xx_rparen_xx_rdbrace_from_ptr



let create_SoftCallabilityPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SoftCallability ;
   "::boost::shared_ptr<(Callability)>", (fun args -> (create_class "boost::shared_ptr<(Callability)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SoftCallabilityPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Callability)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SoftCallabilityPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SoftCallabilityPtr_from_ptr"
          create_SoftCallabilityPtr_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenCallability_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _CallabilitySchedule_size ;
    "empty", _CallabilitySchedule_empty ;
    "clear", _CallabilitySchedule_clear ;
    "push_back", _CallabilitySchedule_push_back ;
    "[]", _CallabilitySchedule_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _CallabilitySchedule_operator_xx_xx_equals ;
    "set", _CallabilitySchedule_set ;
    "to_array", _CallabilitySchedule_to_array ;
    "~", _delete_CallabilitySchedule ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(boost::shared_ptr<(Callability)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(boost::shared_ptr<(Callability)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< boost::shared_ptr< Callability > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenCallability_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenSeasonality_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _Seasonality___deref__ ;
    "isNull", _Seasonality_isNull ;
    "~", _delete_Seasonality ;
    "correctZeroRate", _Seasonality_correctZeroRate ;
    "correctYoYRate", _Seasonality_correctYoYRate ;
    "isConsistent", _Seasonality_isConsistent ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(Seasonality)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(Seasonality)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< Seasonality >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenSeasonality_xx_rparen_xx_rdbrace_from_ptr



let create_MultiplicativePriceSeasonalityPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MultiplicativePriceSeasonalityPtr ;
   "::boost::shared_ptr<(Seasonality)>", (fun args -> (create_class "boost::shared_ptr<(Seasonality)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MultiplicativePriceSeasonalityPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Seasonality)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MultiplicativePriceSeasonalityPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MultiplicativePriceSeasonalityPtr_from_ptr"
          create_MultiplicativePriceSeasonalityPtr_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenYoYInflationTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _YoYInflationTermStructure___deref__ ;
    "isNull", _YoYInflationTermStructure_isNull ;
    "asObservable", _YoYInflationTermStructure_asObservable ;
    "~", _delete_YoYInflationTermStructure ;
    "yoyRate", _YoYInflationTermStructure_yoyRate ;
    "yoyRate", _YoYInflationTermStructure_yoyRate ;
    "yoyRate", _YoYInflationTermStructure_yoyRate ;
    "yoyRate", _YoYInflationTermStructure_yoyRate ;
    "dayCounter", _YoYInflationTermStructure_dayCounter ;
    "calendar", _YoYInflationTermStructure_calendar ;
    "referenceDate", _YoYInflationTermStructure_referenceDate ;
    "maxDate", _YoYInflationTermStructure_maxDate ;
    "maxTime", _YoYInflationTermStructure_maxTime ;
    "observationLag", _YoYInflationTermStructure_observationLag ;
    "frequency", _YoYInflationTermStructure_frequency ;
    "indexIsInterpolated", _YoYInflationTermStructure_indexIsInterpolated ;
    "baseRate", _YoYInflationTermStructure_baseRate ;
    "nominalTermStructure", _YoYInflationTermStructure_nominalTermStructure ;
    "baseDate", _YoYInflationTermStructure_baseDate ;
    "setSeasonality", _YoYInflationTermStructure_setSeasonality ;
    "setSeasonality", _YoYInflationTermStructure_setSeasonality ;
    "seasonality", _YoYInflationTermStructure_seasonality ;
    "hasSeasonality", _YoYInflationTermStructure_hasSeasonality ;
    "enableExtrapolation", _YoYInflationTermStructure_enableExtrapolation ;
    "disableExtrapolation", _YoYInflationTermStructure_disableExtrapolation ;
    "allowsExtrapolation", _YoYInflationTermStructure_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(YoYInflationTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(YoYInflationTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< YoYInflationTermStructure >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenYoYInflationTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenYoYInflationTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _YoYInflationTermStructureHandle___deref__ ;
    "empty", _YoYInflationTermStructureHandle_empty ;
    "asObservable", _YoYInflationTermStructureHandle_asObservable ;
    "~", _delete_YoYInflationTermStructureHandle ;
    "yoyRate", _YoYInflationTermStructureHandle_yoyRate ;
    "yoyRate", _YoYInflationTermStructureHandle_yoyRate ;
    "yoyRate", _YoYInflationTermStructureHandle_yoyRate ;
    "yoyRate", _YoYInflationTermStructureHandle_yoyRate ;
    "dayCounter", _YoYInflationTermStructureHandle_dayCounter ;
    "calendar", _YoYInflationTermStructureHandle_calendar ;
    "referenceDate", _YoYInflationTermStructureHandle_referenceDate ;
    "maxDate", _YoYInflationTermStructureHandle_maxDate ;
    "maxTime", _YoYInflationTermStructureHandle_maxTime ;
    "observationLag", _YoYInflationTermStructureHandle_observationLag ;
    "frequency", _YoYInflationTermStructureHandle_frequency ;
    "indexIsInterpolated", _YoYInflationTermStructureHandle_indexIsInterpolated ;
    "baseRate", _YoYInflationTermStructureHandle_baseRate ;
    "nominalTermStructure", _YoYInflationTermStructureHandle_nominalTermStructure ;
    "baseDate", _YoYInflationTermStructureHandle_baseDate ;
    "setSeasonality", _YoYInflationTermStructureHandle_setSeasonality ;
    "setSeasonality", _YoYInflationTermStructureHandle_setSeasonality ;
    "seasonality", _YoYInflationTermStructureHandle_seasonality ;
    "hasSeasonality", _YoYInflationTermStructureHandle_hasSeasonality ;
    "enableExtrapolation", _YoYInflationTermStructureHandle_enableExtrapolation ;
    "disableExtrapolation", _YoYInflationTermStructureHandle_disableExtrapolation ;
    "allowsExtrapolation", _YoYInflationTermStructureHandle_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(YoYInflationTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(YoYInflationTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< YoYInflationTermStructure >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenYoYInflationTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenYoYInflationTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableYoYInflationTermStructureHandle_linkTo ;
    "~", _delete_RelinkableYoYInflationTermStructureHandle ;
   "::Handle<(YoYInflationTermStructure)>", (fun args -> (create_class "Handle<(YoYInflationTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(YoYInflationTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(YoYInflationTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(YoYInflationTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< YoYInflationTermStructure >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenYoYInflationTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenZeroInflationTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _ZeroInflationTermStructure___deref__ ;
    "isNull", _ZeroInflationTermStructure_isNull ;
    "asObservable", _ZeroInflationTermStructure_asObservable ;
    "~", _delete_ZeroInflationTermStructure ;
    "zeroRate", _ZeroInflationTermStructure_zeroRate ;
    "zeroRate", _ZeroInflationTermStructure_zeroRate ;
    "zeroRate", _ZeroInflationTermStructure_zeroRate ;
    "zeroRate", _ZeroInflationTermStructure_zeroRate ;
    "dayCounter", _ZeroInflationTermStructure_dayCounter ;
    "calendar", _ZeroInflationTermStructure_calendar ;
    "referenceDate", _ZeroInflationTermStructure_referenceDate ;
    "maxDate", _ZeroInflationTermStructure_maxDate ;
    "maxTime", _ZeroInflationTermStructure_maxTime ;
    "observationLag", _ZeroInflationTermStructure_observationLag ;
    "frequency", _ZeroInflationTermStructure_frequency ;
    "indexIsInterpolated", _ZeroInflationTermStructure_indexIsInterpolated ;
    "baseRate", _ZeroInflationTermStructure_baseRate ;
    "nominalTermStructure", _ZeroInflationTermStructure_nominalTermStructure ;
    "baseDate", _ZeroInflationTermStructure_baseDate ;
    "setSeasonality", _ZeroInflationTermStructure_setSeasonality ;
    "setSeasonality", _ZeroInflationTermStructure_setSeasonality ;
    "seasonality", _ZeroInflationTermStructure_seasonality ;
    "hasSeasonality", _ZeroInflationTermStructure_hasSeasonality ;
    "enableExtrapolation", _ZeroInflationTermStructure_enableExtrapolation ;
    "disableExtrapolation", _ZeroInflationTermStructure_disableExtrapolation ;
    "allowsExtrapolation", _ZeroInflationTermStructure_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(ZeroInflationTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(ZeroInflationTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< ZeroInflationTermStructure >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenZeroInflationTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenZeroInflationTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _ZeroInflationTermStructureHandle___deref__ ;
    "empty", _ZeroInflationTermStructureHandle_empty ;
    "asObservable", _ZeroInflationTermStructureHandle_asObservable ;
    "~", _delete_ZeroInflationTermStructureHandle ;
    "zeroRate", _ZeroInflationTermStructureHandle_zeroRate ;
    "zeroRate", _ZeroInflationTermStructureHandle_zeroRate ;
    "zeroRate", _ZeroInflationTermStructureHandle_zeroRate ;
    "zeroRate", _ZeroInflationTermStructureHandle_zeroRate ;
    "dayCounter", _ZeroInflationTermStructureHandle_dayCounter ;
    "calendar", _ZeroInflationTermStructureHandle_calendar ;
    "referenceDate", _ZeroInflationTermStructureHandle_referenceDate ;
    "maxDate", _ZeroInflationTermStructureHandle_maxDate ;
    "maxTime", _ZeroInflationTermStructureHandle_maxTime ;
    "observationLag", _ZeroInflationTermStructureHandle_observationLag ;
    "frequency", _ZeroInflationTermStructureHandle_frequency ;
    "indexIsInterpolated", _ZeroInflationTermStructureHandle_indexIsInterpolated ;
    "baseRate", _ZeroInflationTermStructureHandle_baseRate ;
    "nominalTermStructure", _ZeroInflationTermStructureHandle_nominalTermStructure ;
    "baseDate", _ZeroInflationTermStructureHandle_baseDate ;
    "setSeasonality", _ZeroInflationTermStructureHandle_setSeasonality ;
    "setSeasonality", _ZeroInflationTermStructureHandle_setSeasonality ;
    "seasonality", _ZeroInflationTermStructureHandle_seasonality ;
    "hasSeasonality", _ZeroInflationTermStructureHandle_hasSeasonality ;
    "enableExtrapolation", _ZeroInflationTermStructureHandle_enableExtrapolation ;
    "disableExtrapolation", _ZeroInflationTermStructureHandle_disableExtrapolation ;
    "allowsExtrapolation", _ZeroInflationTermStructureHandle_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(ZeroInflationTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(ZeroInflationTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< ZeroInflationTermStructure >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenZeroInflationTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenZeroInflationTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableZeroInflationTermStructureHandle_linkTo ;
    "~", _delete_RelinkableZeroInflationTermStructureHandle ;
   "::Handle<(ZeroInflationTermStructure)>", (fun args -> (create_class "Handle<(ZeroInflationTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(ZeroInflationTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(ZeroInflationTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(ZeroInflationTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< ZeroInflationTermStructure >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenZeroInflationTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_Region_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "name", _Region_name ;
    "code", _Region_code ;
    "~", _delete_Region ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Region") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Region"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Region_from_ptr"
          create_Region_from_ptr



let create_CustomRegion_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CustomRegion ;
   "::Region", (fun args -> (create_class "Region") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CustomRegion") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Region") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CustomRegion"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CustomRegion_from_ptr"
          create_CustomRegion_from_ptr



let create_InflationIndexPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "interpolated", _InflationIndex_interpolated ;
    "frequency", _InflationIndex_frequency ;
    "availabilityLag", _InflationIndex_availabilityLag ;
    "currency", _InflationIndex_currency ;
    "~", _delete_InflationIndex ;
   "::boost::shared_ptr<(Index)>", (fun args -> (create_class "boost::shared_ptr<(Index)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InflationIndexPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Index)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InflationIndexPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InflationIndexPtr_from_ptr"
          create_InflationIndexPtr_from_ptr



let create_ZeroInflationIndexPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ZeroInflationIndex ;
   "::InflationIndexPtr", (fun args -> (create_class "InflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ZeroInflationIndexPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "InflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ZeroInflationIndexPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ZeroInflationIndexPtr_from_ptr"
          create_ZeroInflationIndexPtr_from_ptr



let create_YoYInflationIndexPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_YoYInflationIndex ;
   "::InflationIndexPtr", (fun args -> (create_class "InflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YoYInflationIndexPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "InflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YoYInflationIndexPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YoYInflationIndexPtr_from_ptr"
          create_YoYInflationIndexPtr_from_ptr



let create_EUHICPPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EUHICP ;
   "::ZeroInflationIndexPtr", (fun args -> (create_class "ZeroInflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EUHICPPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "ZeroInflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EUHICPPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EUHICPPtr_from_ptr"
          create_EUHICPPtr_from_ptr



let create_EUHICPXTPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_EUHICPXT ;
   "::ZeroInflationIndexPtr", (fun args -> (create_class "ZeroInflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "EUHICPXTPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "ZeroInflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"EUHICPXTPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_EUHICPXTPtr_from_ptr"
          create_EUHICPXTPtr_from_ptr



let create_FRHICPPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FRHICP ;
   "::ZeroInflationIndexPtr", (fun args -> (create_class "ZeroInflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FRHICPPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "ZeroInflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FRHICPPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FRHICPPtr_from_ptr"
          create_FRHICPPtr_from_ptr



let create_UKRPIPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_UKRPI ;
   "::ZeroInflationIndexPtr", (fun args -> (create_class "ZeroInflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "UKRPIPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "ZeroInflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"UKRPIPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_UKRPIPtr_from_ptr"
          create_UKRPIPtr_from_ptr



let create_USCPIPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_USCPI ;
   "::ZeroInflationIndexPtr", (fun args -> (create_class "ZeroInflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "USCPIPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "ZeroInflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"USCPIPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_USCPIPtr_from_ptr"
          create_USCPIPtr_from_ptr



let create_ZACPIPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ZACPI ;
   "::ZeroInflationIndexPtr", (fun args -> (create_class "ZeroInflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ZACPIPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "ZeroInflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ZACPIPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ZACPIPtr_from_ptr"
          create_ZACPIPtr_from_ptr



let create_YYEUHICPPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_YYEUHICP ;
   "::YoYInflationIndexPtr", (fun args -> (create_class "YoYInflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YYEUHICPPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "YoYInflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YYEUHICPPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YYEUHICPPtr_from_ptr"
          create_YYEUHICPPtr_from_ptr



let create_YYEUHICPXTPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_YYEUHICPXT ;
   "::YoYInflationIndexPtr", (fun args -> (create_class "YoYInflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YYEUHICPXTPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "YoYInflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YYEUHICPXTPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YYEUHICPXTPtr_from_ptr"
          create_YYEUHICPXTPtr_from_ptr



let create_YYFRHICPPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_YYFRHICP ;
   "::YoYInflationIndexPtr", (fun args -> (create_class "YoYInflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YYFRHICPPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "YoYInflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YYFRHICPPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YYFRHICPPtr_from_ptr"
          create_YYFRHICPPtr_from_ptr



let create_YYUKRPIPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_YYUKRPI ;
   "::YoYInflationIndexPtr", (fun args -> (create_class "YoYInflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YYUKRPIPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "YoYInflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YYUKRPIPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YYUKRPIPtr_from_ptr"
          create_YYUKRPIPtr_from_ptr



let create_YYUSCPIPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_YYUSCPI ;
   "::YoYInflationIndexPtr", (fun args -> (create_class "YoYInflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YYUSCPIPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "YoYInflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YYUSCPIPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YYUSCPIPtr_from_ptr"
          create_YYUSCPIPtr_from_ptr



let create_YYZACPIPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_YYZACPI ;
   "::YoYInflationIndexPtr", (fun args -> (create_class "YoYInflationIndexPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YYZACPIPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "YoYInflationIndexPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YYZACPIPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YYZACPIPtr_from_ptr"
          create_YYZACPIPtr_from_ptr



let create_CPI_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CPI ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CPI") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CPI"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CPI_from_ptr"
          create_CPI_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenZeroHelper_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _ZeroHelper___deref__ ;
    "isNull", _ZeroHelper_isNull ;
    "~", _delete_ZeroHelper ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(ZeroHelper)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(ZeroHelper)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< ZeroHelper >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenZeroHelper_xx_rparen_xx_rdbrace_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenYoYHelper_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _YoYHelper___deref__ ;
    "isNull", _YoYHelper_isNull ;
    "~", _delete_YoYHelper ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(YoYHelper)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(YoYHelper)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< YoYHelper >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenYoYHelper_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenZeroHelper_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _ZeroHelperVector_size ;
    "empty", _ZeroHelperVector_empty ;
    "clear", _ZeroHelperVector_clear ;
    "push_back", _ZeroHelperVector_push_back ;
    "[]", _ZeroHelperVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _ZeroHelperVector_operator_xx_xx_equals ;
    "set", _ZeroHelperVector_set ;
    "to_array", _ZeroHelperVector_to_array ;
    "~", _delete_ZeroHelperVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(boost::shared_ptr<(ZeroHelper)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(boost::shared_ptr<(ZeroHelper)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< boost::shared_ptr< ZeroHelper > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenZeroHelper_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenYoYHelper_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _YoYHelperVector_size ;
    "empty", _YoYHelperVector_empty ;
    "clear", _YoYHelperVector_clear ;
    "push_back", _YoYHelperVector_push_back ;
    "[]", _YoYHelperVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _YoYHelperVector_operator_xx_xx_equals ;
    "set", _YoYHelperVector_set ;
    "to_array", _YoYHelperVector_to_array ;
    "~", _delete_YoYHelperVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(boost::shared_ptr<(YoYHelper)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(boost::shared_ptr<(YoYHelper)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< boost::shared_ptr< YoYHelper > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenYoYHelper_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_ZeroCouponInflationSwapHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ZeroCouponInflationSwapHelper ;
   "::boost::shared_ptr<(ZeroHelper)>", (fun args -> (create_class "boost::shared_ptr<(ZeroHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ZeroCouponInflationSwapHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(ZeroHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ZeroCouponInflationSwapHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ZeroCouponInflationSwapHelperPtr_from_ptr"
          create_ZeroCouponInflationSwapHelperPtr_from_ptr



let create_YearOnYearInflationSwapHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_YearOnYearInflationSwapHelper ;
   "::boost::shared_ptr<(YoYHelper)>", (fun args -> (create_class "boost::shared_ptr<(YoYHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YearOnYearInflationSwapHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YoYHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YearOnYearInflationSwapHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YearOnYearInflationSwapHelperPtr_from_ptr"
          create_YearOnYearInflationSwapHelperPtr_from_ptr



let create_PiecewiseZeroInflationPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _PiecewiseZeroInflation_dates ;
    "times", _PiecewiseZeroInflation_times ;
    "nodes", _PiecewiseZeroInflation_nodes ;
    "~", _delete_PiecewiseZeroInflation ;
   "::boost::shared_ptr<(ZeroInflationTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(ZeroInflationTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PiecewiseZeroInflationPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(ZeroInflationTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PiecewiseZeroInflationPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PiecewiseZeroInflationPtr_from_ptr"
          create_PiecewiseZeroInflationPtr_from_ptr



let create_PiecewiseYoYInflationPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _PiecewiseYoYInflation_dates ;
    "times", _PiecewiseYoYInflation_times ;
    "nodes", _PiecewiseYoYInflation_nodes ;
    "~", _delete_PiecewiseYoYInflation ;
   "::boost::shared_ptr<(YoYInflationTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YoYInflationTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PiecewiseYoYInflationPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YoYInflationTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PiecewiseYoYInflationPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PiecewiseYoYInflationPtr_from_ptr"
          create_PiecewiseYoYInflationPtr_from_ptr



let create_ZeroCouponInflationSwapPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "fairRate", _ZeroCouponInflationSwap_fairRate ;
    "fixedLeg", _ZeroCouponInflationSwap_fixedLeg ;
    "inflationLeg", _ZeroCouponInflationSwap_inflationLeg ;
    "type", _ZeroCouponInflationSwap_type ;
    "~", _delete_ZeroCouponInflationSwap ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ZeroCouponInflationSwapPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ZeroCouponInflationSwapPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ZeroCouponInflationSwapPtr_from_ptr"
          create_ZeroCouponInflationSwapPtr_from_ptr



let create_YearOnYearInflationSwapPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "fairRate", _YearOnYearInflationSwap_fairRate ;
    "~", _delete_YearOnYearInflationSwap ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YearOnYearInflationSwapPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YearOnYearInflationSwapPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YearOnYearInflationSwapPtr_from_ptr"
          create_YearOnYearInflationSwapPtr_from_ptr



let create_YoYInflationCapFloorPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "impliedVolatility", _YoYInflationCapFloor_impliedVolatility ;
    "impliedVolatility", _YoYInflationCapFloor_impliedVolatility ;
    "impliedVolatility", _YoYInflationCapFloor_impliedVolatility ;
    "impliedVolatility", _YoYInflationCapFloor_impliedVolatility ;
    "impliedVolatility", _YoYInflationCapFloor_impliedVolatility ;
    "~", _delete_YoYInflationCapFloor ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YoYInflationCapFloorPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YoYInflationCapFloorPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YoYInflationCapFloorPtr_from_ptr"
          create_YoYInflationCapFloorPtr_from_ptr



let create_YoYInflationCapPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_YoYInflationCap ;
   "::YoYInflationCapFloorPtr", (fun args -> (create_class "YoYInflationCapFloorPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YoYInflationCapPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "YoYInflationCapFloorPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YoYInflationCapPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YoYInflationCapPtr_from_ptr"
          create_YoYInflationCapPtr_from_ptr



let create_YoYInflationFloorPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_YoYInflationFloor ;
   "::YoYInflationCapFloorPtr", (fun args -> (create_class "YoYInflationCapFloorPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YoYInflationFloorPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "YoYInflationCapFloorPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YoYInflationFloorPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YoYInflationFloorPtr_from_ptr"
          create_YoYInflationFloorPtr_from_ptr



let create_YoYInflationCollarPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_YoYInflationCollar ;
   "::YoYInflationCapFloorPtr", (fun args -> (create_class "YoYInflationCapFloorPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "YoYInflationCollarPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "YoYInflationCapFloorPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"YoYInflationCollarPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_YoYInflationCollarPtr_from_ptr"
          create_YoYInflationCollarPtr_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenShortRateModel_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _ShortRateModel___deref__ ;
    "isNull", _ShortRateModel_isNull ;
    "asObservable", _ShortRateModel_asObservable ;
    "~", _delete_ShortRateModel ;
    "params", _ShortRateModel_params ;
    "calibrate", _ShortRateModel_calibrate ;
    "calibrate", _ShortRateModel_calibrate ;
    "calibrate", _ShortRateModel_calibrate ;
    "calibrate", _ShortRateModel_calibrate ;
    "value", _ShortRateModel_value ;
    "endCriteria", _ShortRateModel_endCriteria ;
    "setParams", _ShortRateModel_setParams ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(ShortRateModel)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(ShortRateModel)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< ShortRateModel >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenShortRateModel_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenShortRateModel_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _ShortRateModelHandle___deref__ ;
    "empty", _ShortRateModelHandle_empty ;
    "asObservable", _ShortRateModelHandle_asObservable ;
    "~", _delete_ShortRateModelHandle ;
    "params", _ShortRateModelHandle_params ;
    "calibrate", _ShortRateModelHandle_calibrate ;
    "calibrate", _ShortRateModelHandle_calibrate ;
    "calibrate", _ShortRateModelHandle_calibrate ;
    "calibrate", _ShortRateModelHandle_calibrate ;
    "value", _ShortRateModelHandle_value ;
    "endCriteria", _ShortRateModelHandle_endCriteria ;
    "setParams", _ShortRateModelHandle_setParams ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(ShortRateModel)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(ShortRateModel)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< ShortRateModel >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenShortRateModel_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenShortRateModel_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableShortRateModelHandle_linkTo ;
    "~", _delete_RelinkableShortRateModelHandle ;
   "::Handle<(ShortRateModel)>", (fun args -> (create_class "Handle<(ShortRateModel)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(ShortRateModel)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(ShortRateModel)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(ShortRateModel)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< ShortRateModel >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenShortRateModel_xx_rparen_xx_rdbrace_from_ptr



let create_VasicekPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "discount", _Vasicek_discount ;
    "discountBond", _Vasicek_discountBond ;
    "~", _delete_Vasicek ;
   "::boost::shared_ptr<(ShortRateModel)>", (fun args -> (create_class "boost::shared_ptr<(ShortRateModel)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "VasicekPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(ShortRateModel)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"VasicekPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_VasicekPtr_from_ptr"
          create_VasicekPtr_from_ptr



let create_HullWhitePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "discount", _HullWhite_discount ;
    "discountBond", _HullWhite_discountBond ;
    "~", _delete_HullWhite ;
   "::boost::shared_ptr<(ShortRateModel)>", (fun args -> (create_class "boost::shared_ptr<(ShortRateModel)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "HullWhitePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(ShortRateModel)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"HullWhitePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_HullWhitePtr_from_ptr"
          create_HullWhitePtr_from_ptr



let create_BlackKarasinskiPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BlackKarasinski ;
   "::boost::shared_ptr<(ShortRateModel)>", (fun args -> (create_class "boost::shared_ptr<(ShortRateModel)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackKarasinskiPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(ShortRateModel)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackKarasinskiPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackKarasinskiPtr_from_ptr"
          create_BlackKarasinskiPtr_from_ptr



let create_G2Ptr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "discount", _G2_discount ;
    "discountBond", _G2_discountBond ;
    "~", _delete_G2 ;
   "::boost::shared_ptr<(ShortRateModel)>", (fun args -> (create_class "boost::shared_ptr<(ShortRateModel)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "G2Ptr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(ShortRateModel)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"G2Ptr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_G2Ptr_from_ptr"
          create_G2Ptr_from_ptr



let create_JamshidianSwaptionEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_JamshidianSwaptionEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "JamshidianSwaptionEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"JamshidianSwaptionEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_JamshidianSwaptionEnginePtr_from_ptr"
          create_JamshidianSwaptionEnginePtr_from_ptr



let create_TreeSwaptionEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_TreeSwaptionEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TreeSwaptionEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TreeSwaptionEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TreeSwaptionEnginePtr_from_ptr"
          create_TreeSwaptionEnginePtr_from_ptr



let create_AnalyticCapFloorEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_AnalyticCapFloorEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AnalyticCapFloorEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AnalyticCapFloorEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AnalyticCapFloorEnginePtr_from_ptr"
          create_AnalyticCapFloorEnginePtr_from_ptr



let create_TreeCapFloorEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_TreeCapFloorEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TreeCapFloorEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TreeCapFloorEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TreeCapFloorEnginePtr_from_ptr"
          create_TreeCapFloorEnginePtr_from_ptr



let create_G2SwaptionEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_G2SwaptionEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "G2SwaptionEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"G2SwaptionEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_G2SwaptionEnginePtr_from_ptr"
          create_G2SwaptionEnginePtr_from_ptr



let create_FdG2SwaptionEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FdG2SwaptionEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FdG2SwaptionEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FdG2SwaptionEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FdG2SwaptionEnginePtr_from_ptr"
          create_FdG2SwaptionEnginePtr_from_ptr



let create_FdHullWhiteSwaptionEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FdHullWhiteSwaptionEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FdHullWhiteSwaptionEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FdHullWhiteSwaptionEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FdHullWhiteSwaptionEnginePtr_from_ptr"
          create_FdHullWhiteSwaptionEnginePtr_from_ptr



let create_BondPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextCouponRate", _Bond_nextCouponRate ;
    "nextCouponRate", _Bond_nextCouponRate ;
    "previousCouponRate", _Bond_previousCouponRate ;
    "previousCouponRate", _Bond_previousCouponRate ;
    "settlementDays", _Bond_settlementDays ;
    "settlementDate", _Bond_settlementDate ;
    "settlementDate", _Bond_settlementDate ;
    "startDate", _Bond_startDate ;
    "maturityDate", _Bond_maturityDate ;
    "issueDate", _Bond_issueDate ;
    "cashflows", _Bond_cashflows ;
    "redemptions", _Bond_redemptions ;
    "redemption", _Bond_redemption ;
    "calendar", _Bond_calendar ;
    "notionals", _Bond_notionals ;
    "notional", _Bond_notional ;
    "notional", _Bond_notional ;
    "cleanPrice", _Bond_cleanPrice ;
    "cleanPrice", _Bond_cleanPrice ;
    "cleanPrice", _Bond_cleanPrice ;
    "dirtyPrice", _Bond_dirtyPrice ;
    "dirtyPrice", _Bond_dirtyPrice ;
    "dirtyPrice", _Bond_dirtyPrice ;
    "yield", _Bond_yield ;
    "yield", _Bond_yield ;
    "yield", _Bond_yield ;
    "yield", _Bond_yield ;
    "yield", _Bond_yield ;
    "yield", _Bond_yield ;
    "yield", _Bond_yield ;
    "accruedAmount", _Bond_accruedAmount ;
    "accruedAmount", _Bond_accruedAmount ;
    "settlementValue", _Bond_settlementValue ;
    "settlementValue", _Bond_settlementValue ;
    "~", _delete_Bond ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BondPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BondPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BondPtr_from_ptr"
          create_BondPtr_from_ptr



let create_ZeroCouponBondPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ZeroCouponBond ;
   "::BondPtr", (fun args -> (create_class "BondPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ZeroCouponBondPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BondPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ZeroCouponBondPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ZeroCouponBondPtr_from_ptr"
          create_ZeroCouponBondPtr_from_ptr



let create_FixedRateBondPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "frequency", _FixedRateBond_frequency ;
    "dayCounter", _FixedRateBond_dayCounter ;
    "~", _delete_FixedRateBond ;
   "::BondPtr", (fun args -> (create_class "BondPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FixedRateBondPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BondPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FixedRateBondPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FixedRateBondPtr_from_ptr"
          create_FixedRateBondPtr_from_ptr



let create_FloatingRateBondPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FloatingRateBond ;
   "::BondPtr", (fun args -> (create_class "BondPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FloatingRateBondPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BondPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FloatingRateBondPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FloatingRateBondPtr_from_ptr"
          create_FloatingRateBondPtr_from_ptr



let create_CmsRateBondPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CmsRateBond ;
   "::BondPtr", (fun args -> (create_class "BondPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CmsRateBondPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BondPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CmsRateBondPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CmsRateBondPtr_from_ptr"
          create_CmsRateBondPtr_from_ptr



let create_DiscountingBondEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DiscountingBondEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DiscountingBondEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DiscountingBondEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DiscountingBondEnginePtr_from_ptr"
          create_DiscountingBondEnginePtr_from_ptr



let create_CallableFixedRateBondPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CallableFixedRateBond ;
   "::BondPtr", (fun args -> (create_class "BondPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CallableFixedRateBondPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BondPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CallableFixedRateBondPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CallableFixedRateBondPtr_from_ptr"
          create_CallableFixedRateBondPtr_from_ptr



let create_TreeCallableFixedRateBondEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_TreeCallableFixedRateBondEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TreeCallableFixedRateBondEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TreeCallableFixedRateBondEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TreeCallableFixedRateBondEnginePtr_from_ptr"
          create_TreeCallableFixedRateBondEnginePtr_from_ptr



let create_BlackCallableFixedRateBondEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BlackCallableFixedRateBondEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackCallableFixedRateBondEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackCallableFixedRateBondEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackCallableFixedRateBondEnginePtr_from_ptr"
          create_BlackCallableFixedRateBondEnginePtr_from_ptr



let create_CPIBondPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CPIBond ;
   "::BondPtr", (fun args -> (create_class "BondPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CPIBondPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BondPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CPIBondPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CPIBondPtr_from_ptr"
          create_CPIBondPtr_from_ptr



let create_BondFunctions_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BondFunctions ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BondFunctions") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BondFunctions"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BondFunctions_from_ptr"
          create_BondFunctions_from_ptr



let create_CapFloorPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "impliedVolatility", _CapFloor_impliedVolatility ;
    "impliedVolatility", _CapFloor_impliedVolatility ;
    "impliedVolatility", _CapFloor_impliedVolatility ;
    "impliedVolatility", _CapFloor_impliedVolatility ;
    "impliedVolatility", _CapFloor_impliedVolatility ;
    "impliedVolatility", _CapFloor_impliedVolatility ;
    "impliedVolatility", _CapFloor_impliedVolatility ;
    "floatingLeg", _CapFloor_floatingLeg ;
    "capRates", _CapFloor_capRates ;
    "floorRates", _CapFloor_floorRates ;
    "startDate", _CapFloor_startDate ;
    "maturityDate", _CapFloor_maturityDate ;
    "atmRate", _CapFloor_atmRate ;
    "~", _delete_CapFloor ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CapFloorPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CapFloorPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CapFloorPtr_from_ptr"
          create_CapFloorPtr_from_ptr



let create_CapPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Cap ;
   "::CapFloorPtr", (fun args -> (create_class "CapFloorPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CapPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "CapFloorPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CapPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CapPtr_from_ptr"
          create_CapPtr_from_ptr



let create_FloorPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Floor ;
   "::CapFloorPtr", (fun args -> (create_class "CapFloorPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FloorPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "CapFloorPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FloorPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FloorPtr_from_ptr"
          create_FloorPtr_from_ptr



let create_CollarPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Collar ;
   "::CapFloorPtr", (fun args -> (create_class "CapFloorPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CollarPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "CapFloorPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CollarPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CollarPtr_from_ptr"
          create_CollarPtr_from_ptr



let create_BlackCapFloorEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BlackCapFloorEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackCapFloorEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackCapFloorEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackCapFloorEnginePtr_from_ptr"
          create_BlackCapFloorEnginePtr_from_ptr



let create_BachelierCapFloorEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BachelierCapFloorEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BachelierCapFloorEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BachelierCapFloorEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BachelierCapFloorEnginePtr_from_ptr"
          create_BachelierCapFloorEnginePtr_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenDividend_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _Dividend___deref__ ;
    "isNull", _Dividend_isNull ;
    "~", _delete_Dividend ;
    "amount", _Dividend_amount ;
    "date", _Dividend_date ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(Dividend)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(Dividend)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< Dividend >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenDividend_xx_rparen_xx_rdbrace_from_ptr



let create_FixedDividendPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FixedDividend ;
   "::boost::shared_ptr<(Dividend)>", (fun args -> (create_class "boost::shared_ptr<(Dividend)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FixedDividendPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Dividend)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FixedDividendPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FixedDividendPtr_from_ptr"
          create_FixedDividendPtr_from_ptr



let create_FractionalDividendPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FractionalDividend ;
   "::boost::shared_ptr<(Dividend)>", (fun args -> (create_class "boost::shared_ptr<(Dividend)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FractionalDividendPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Dividend)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FractionalDividendPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FractionalDividendPtr_from_ptr"
          create_FractionalDividendPtr_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenDividend_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _DividendSchedule_size ;
    "empty", _DividendSchedule_empty ;
    "clear", _DividendSchedule_clear ;
    "push_back", _DividendSchedule_push_back ;
    "[]", _DividendSchedule_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _DividendSchedule_operator_xx_xx_equals ;
    "set", _DividendSchedule_set ;
    "to_array", _DividendSchedule_to_array ;
    "~", _delete_DividendSchedule ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(boost::shared_ptr<(Dividend)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(boost::shared_ptr<(Dividend)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< boost::shared_ptr< Dividend > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenDividend_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_ConvertibleZeroCouponBondPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ConvertibleZeroCouponBond ;
   "::BondPtr", (fun args -> (create_class "BondPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ConvertibleZeroCouponBondPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BondPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ConvertibleZeroCouponBondPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ConvertibleZeroCouponBondPtr_from_ptr"
          create_ConvertibleZeroCouponBondPtr_from_ptr



let create_ConvertibleFixedCouponBondPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ConvertibleFixedCouponBond ;
   "::BondPtr", (fun args -> (create_class "BondPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ConvertibleFixedCouponBondPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BondPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ConvertibleFixedCouponBondPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ConvertibleFixedCouponBondPtr_from_ptr"
          create_ConvertibleFixedCouponBondPtr_from_ptr



let create_ConvertibleFloatingRateBondPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ConvertibleFloatingRateBond ;
   "::BondPtr", (fun args -> (create_class "BondPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ConvertibleFloatingRateBondPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BondPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ConvertibleFloatingRateBondPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ConvertibleFloatingRateBondPtr_from_ptr"
          create_ConvertibleFloatingRateBondPtr_from_ptr



let create_BinomialConvertibleEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BinomialConvertibleEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BinomialConvertibleEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BinomialConvertibleEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BinomialConvertibleEnginePtr_from_ptr"
          create_BinomialConvertibleEnginePtr_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenDefaultProbabilityTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _DefaultProbabilityTermStructure___deref__ ;
    "isNull", _DefaultProbabilityTermStructure_isNull ;
    "asObservable", _DefaultProbabilityTermStructure_asObservable ;
    "~", _delete_DefaultProbabilityTermStructure ;
    "dayCounter", _DefaultProbabilityTermStructure_dayCounter ;
    "calendar", _DefaultProbabilityTermStructure_calendar ;
    "referenceDate", _DefaultProbabilityTermStructure_referenceDate ;
    "maxDate", _DefaultProbabilityTermStructure_maxDate ;
    "maxTime", _DefaultProbabilityTermStructure_maxTime ;
    "defaultProbability", _DefaultProbabilityTermStructure_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructure_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructure_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructure_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructure_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructure_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructure_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructure_defaultProbability ;
    "survivalProbability", _DefaultProbabilityTermStructure_survivalProbability ;
    "survivalProbability", _DefaultProbabilityTermStructure_survivalProbability ;
    "survivalProbability", _DefaultProbabilityTermStructure_survivalProbability ;
    "survivalProbability", _DefaultProbabilityTermStructure_survivalProbability ;
    "defaultDensity", _DefaultProbabilityTermStructure_defaultDensity ;
    "defaultDensity", _DefaultProbabilityTermStructure_defaultDensity ;
    "defaultDensity", _DefaultProbabilityTermStructure_defaultDensity ;
    "defaultDensity", _DefaultProbabilityTermStructure_defaultDensity ;
    "hazardRate", _DefaultProbabilityTermStructure_hazardRate ;
    "hazardRate", _DefaultProbabilityTermStructure_hazardRate ;
    "hazardRate", _DefaultProbabilityTermStructure_hazardRate ;
    "hazardRate", _DefaultProbabilityTermStructure_hazardRate ;
    "enableExtrapolation", _DefaultProbabilityTermStructure_enableExtrapolation ;
    "disableExtrapolation", _DefaultProbabilityTermStructure_disableExtrapolation ;
    "allowsExtrapolation", _DefaultProbabilityTermStructure_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(DefaultProbabilityTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(DefaultProbabilityTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< DefaultProbabilityTermStructure >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenDefaultProbabilityTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenDefaultProbabilityTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _DefaultProbabilityTermStructureHandle___deref__ ;
    "empty", _DefaultProbabilityTermStructureHandle_empty ;
    "asObservable", _DefaultProbabilityTermStructureHandle_asObservable ;
    "~", _delete_DefaultProbabilityTermStructureHandle ;
    "dayCounter", _DefaultProbabilityTermStructureHandle_dayCounter ;
    "calendar", _DefaultProbabilityTermStructureHandle_calendar ;
    "referenceDate", _DefaultProbabilityTermStructureHandle_referenceDate ;
    "maxDate", _DefaultProbabilityTermStructureHandle_maxDate ;
    "maxTime", _DefaultProbabilityTermStructureHandle_maxTime ;
    "defaultProbability", _DefaultProbabilityTermStructureHandle_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructureHandle_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructureHandle_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructureHandle_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructureHandle_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructureHandle_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructureHandle_defaultProbability ;
    "defaultProbability", _DefaultProbabilityTermStructureHandle_defaultProbability ;
    "survivalProbability", _DefaultProbabilityTermStructureHandle_survivalProbability ;
    "survivalProbability", _DefaultProbabilityTermStructureHandle_survivalProbability ;
    "survivalProbability", _DefaultProbabilityTermStructureHandle_survivalProbability ;
    "survivalProbability", _DefaultProbabilityTermStructureHandle_survivalProbability ;
    "defaultDensity", _DefaultProbabilityTermStructureHandle_defaultDensity ;
    "defaultDensity", _DefaultProbabilityTermStructureHandle_defaultDensity ;
    "defaultDensity", _DefaultProbabilityTermStructureHandle_defaultDensity ;
    "defaultDensity", _DefaultProbabilityTermStructureHandle_defaultDensity ;
    "hazardRate", _DefaultProbabilityTermStructureHandle_hazardRate ;
    "hazardRate", _DefaultProbabilityTermStructureHandle_hazardRate ;
    "hazardRate", _DefaultProbabilityTermStructureHandle_hazardRate ;
    "hazardRate", _DefaultProbabilityTermStructureHandle_hazardRate ;
    "enableExtrapolation", _DefaultProbabilityTermStructureHandle_enableExtrapolation ;
    "disableExtrapolation", _DefaultProbabilityTermStructureHandle_disableExtrapolation ;
    "allowsExtrapolation", _DefaultProbabilityTermStructureHandle_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(DefaultProbabilityTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(DefaultProbabilityTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< DefaultProbabilityTermStructure >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenDefaultProbabilityTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenDefaultProbabilityTermStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableDefaultProbabilityTermStructureHandle_linkTo ;
    "~", _delete_RelinkableDefaultProbabilityTermStructureHandle ;
   "::Handle<(DefaultProbabilityTermStructure)>", (fun args -> (create_class "Handle<(DefaultProbabilityTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(DefaultProbabilityTermStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(DefaultProbabilityTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(DefaultProbabilityTermStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< DefaultProbabilityTermStructure >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenDefaultProbabilityTermStructure_xx_rparen_xx_rdbrace_from_ptr



let create_FlatHazardRatePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FlatHazardRate ;
   "::boost::shared_ptr<(DefaultProbabilityTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(DefaultProbabilityTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FlatHazardRatePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(DefaultProbabilityTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FlatHazardRatePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FlatHazardRatePtr_from_ptr"
          create_FlatHazardRatePtr_from_ptr



let create_HazardRateCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _HazardRateCurve_dates ;
    "hazardRates", _HazardRateCurve_hazardRates ;
    "nodes", _HazardRateCurve_nodes ;
    "~", _delete_HazardRateCurve ;
   "::boost::shared_ptr<(DefaultProbabilityTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(DefaultProbabilityTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "HazardRateCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(DefaultProbabilityTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"HazardRateCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_HazardRateCurvePtr_from_ptr"
          create_HazardRateCurvePtr_from_ptr



let create_DefaultDensityCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _DefaultDensityCurve_dates ;
    "defaultDensities", _DefaultDensityCurve_defaultDensities ;
    "nodes", _DefaultDensityCurve_nodes ;
    "~", _delete_DefaultDensityCurve ;
   "::boost::shared_ptr<(DefaultProbabilityTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(DefaultProbabilityTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DefaultDensityCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(DefaultProbabilityTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DefaultDensityCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DefaultDensityCurvePtr_from_ptr"
          create_DefaultDensityCurvePtr_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenDefaultProbabilityHelper_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _DefaultProbabilityHelper___deref__ ;
    "isNull", _DefaultProbabilityHelper_isNull ;
    "~", _delete_DefaultProbabilityHelper ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(DefaultProbabilityHelper)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(DefaultProbabilityHelper)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< DefaultProbabilityHelper >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenDefaultProbabilityHelper_xx_rparen_xx_rdbrace_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenDefaultProbabilityHelper_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _DefaultProbabilityHelperVector_size ;
    "empty", _DefaultProbabilityHelperVector_empty ;
    "clear", _DefaultProbabilityHelperVector_clear ;
    "push_back", _DefaultProbabilityHelperVector_push_back ;
    "[]", _DefaultProbabilityHelperVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _DefaultProbabilityHelperVector_operator_xx_xx_equals ;
    "set", _DefaultProbabilityHelperVector_set ;
    "to_array", _DefaultProbabilityHelperVector_to_array ;
    "~", _delete_DefaultProbabilityHelperVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(boost::shared_ptr<(DefaultProbabilityHelper)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(boost::shared_ptr<(DefaultProbabilityHelper)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< boost::shared_ptr< DefaultProbabilityHelper > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenDefaultProbabilityHelper_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_SpreadCdsHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SpreadCdsHelper ;
   "::boost::shared_ptr<(DefaultProbabilityHelper)>", (fun args -> (create_class "boost::shared_ptr<(DefaultProbabilityHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SpreadCdsHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(DefaultProbabilityHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SpreadCdsHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SpreadCdsHelperPtr_from_ptr"
          create_SpreadCdsHelperPtr_from_ptr



let create_UpfrontCdsHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_UpfrontCdsHelper ;
   "::boost::shared_ptr<(DefaultProbabilityHelper)>", (fun args -> (create_class "boost::shared_ptr<(DefaultProbabilityHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "UpfrontCdsHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(DefaultProbabilityHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"UpfrontCdsHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_UpfrontCdsHelperPtr_from_ptr"
          create_UpfrontCdsHelperPtr_from_ptr



let create_HazardRate_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_HazardRate ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "HazardRate") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"HazardRate"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_HazardRate_from_ptr"
          create_HazardRate_from_ptr



let create_DefaultDensity_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DefaultDensity ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DefaultDensity") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DefaultDensity"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DefaultDensity_from_ptr"
          create_DefaultDensity_from_ptr



let create_PiecewiseFlatHazardRatePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _PiecewiseFlatHazardRate_dates ;
    "times", _PiecewiseFlatHazardRate_times ;
    "nodes", _PiecewiseFlatHazardRate_nodes ;
    "~", _delete_PiecewiseFlatHazardRate ;
   "::boost::shared_ptr<(DefaultProbabilityTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(DefaultProbabilityTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PiecewiseFlatHazardRatePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(DefaultProbabilityTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PiecewiseFlatHazardRatePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PiecewiseFlatHazardRatePtr_from_ptr"
          create_PiecewiseFlatHazardRatePtr_from_ptr



let create_Protection_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Protection ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Protection") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Protection"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Protection_from_ptr"
          create_Protection_from_ptr



let create_CreditDefaultSwapPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "side", _CreditDefaultSwap_side ;
    "notional", _CreditDefaultSwap_notional ;
    "runningSpread", _CreditDefaultSwap_runningSpread ;
    "upfront", _CreditDefaultSwap_upfront ;
    "settlesAccrual", _CreditDefaultSwap_settlesAccrual ;
    "paysAtDefaultTime", _CreditDefaultSwap_paysAtDefaultTime ;
    "fairSpread", _CreditDefaultSwap_fairSpread ;
    "fairUpfront", _CreditDefaultSwap_fairUpfront ;
    "couponLegBPS", _CreditDefaultSwap_couponLegBPS ;
    "couponLegNPV", _CreditDefaultSwap_couponLegNPV ;
    "defaultLegNPV", _CreditDefaultSwap_defaultLegNPV ;
    "upfrontBPS", _CreditDefaultSwap_upfrontBPS ;
    "upfrontNPV", _CreditDefaultSwap_upfrontNPV ;
    "impliedHazardRate", _CreditDefaultSwap_impliedHazardRate ;
    "impliedHazardRate", _CreditDefaultSwap_impliedHazardRate ;
    "impliedHazardRate", _CreditDefaultSwap_impliedHazardRate ;
    "coupons", _CreditDefaultSwap_coupons ;
    "~", _delete_CreditDefaultSwap ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CreditDefaultSwapPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CreditDefaultSwapPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CreditDefaultSwapPtr_from_ptr"
          create_CreditDefaultSwapPtr_from_ptr



let create_MidPointCdsEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MidPointCdsEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MidPointCdsEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MidPointCdsEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MidPointCdsEnginePtr_from_ptr"
          create_MidPointCdsEnginePtr_from_ptr



let create_IntegralCdsEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_IntegralCdsEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "IntegralCdsEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"IntegralCdsEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_IntegralCdsEnginePtr_from_ptr"
          create_IntegralCdsEnginePtr_from_ptr



let create_DiscountCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "times", _DiscountCurve_times ;
    "data", _DiscountCurve_data ;
    "dates", _DiscountCurve_dates ;
    "discounts", _DiscountCurve_discounts ;
    "nodes", _DiscountCurve_nodes ;
    "~", _delete_DiscountCurve ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DiscountCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DiscountCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DiscountCurvePtr_from_ptr"
          create_DiscountCurvePtr_from_ptr



let create_NormalDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _NormalDistribution_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _NormalDistribution_derivative ;
    "~", _delete_NormalDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "NormalDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"NormalDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_NormalDistribution_from_ptr"
          create_NormalDistribution_from_ptr



let create_CumulativeNormalDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _CumulativeNormalDistribution_operator_xx_xx_lparen_xx_rparen ;
    "derivative", _CumulativeNormalDistribution_derivative ;
    "~", _delete_CumulativeNormalDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CumulativeNormalDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CumulativeNormalDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CumulativeNormalDistribution_from_ptr"
          create_CumulativeNormalDistribution_from_ptr



let create_InverseCumulativeNormal_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _InverseCumulativeNormal_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_InverseCumulativeNormal ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeNormal") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeNormal"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeNormal_from_ptr"
          create_InverseCumulativeNormal_from_ptr



let create_MoroInverseCumulativeNormal_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _MoroInverseCumulativeNormal_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_MoroInverseCumulativeNormal ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MoroInverseCumulativeNormal") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MoroInverseCumulativeNormal"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MoroInverseCumulativeNormal_from_ptr"
          create_MoroInverseCumulativeNormal_from_ptr



let create_BivariateCumulativeNormalDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _BivariateCumulativeNormalDistribution_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_BivariateCumulativeNormalDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BivariateCumulativeNormalDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BivariateCumulativeNormalDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BivariateCumulativeNormalDistribution_from_ptr"
          create_BivariateCumulativeNormalDistribution_from_ptr



let create_BinomialDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _BinomialDistribution_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_BinomialDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BinomialDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BinomialDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BinomialDistribution_from_ptr"
          create_BinomialDistribution_from_ptr



let create_CumulativeBinomialDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _CumulativeBinomialDistribution_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_CumulativeBinomialDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CumulativeBinomialDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CumulativeBinomialDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CumulativeBinomialDistribution_from_ptr"
          create_CumulativeBinomialDistribution_from_ptr



let create_BivariateCumulativeNormalDistributionDr78_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _BivariateCumulativeNormalDistributionDr78_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_BivariateCumulativeNormalDistributionDr78 ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BivariateCumulativeNormalDistributionDr78") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BivariateCumulativeNormalDistributionDr78"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BivariateCumulativeNormalDistributionDr78_from_ptr"
          create_BivariateCumulativeNormalDistributionDr78_from_ptr



let create_BivariateCumulativeNormalDistributionWe04DP_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _BivariateCumulativeNormalDistributionWe04DP_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_BivariateCumulativeNormalDistributionWe04DP ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BivariateCumulativeNormalDistributionWe04DP") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BivariateCumulativeNormalDistributionWe04DP"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BivariateCumulativeNormalDistributionWe04DP_from_ptr"
          create_BivariateCumulativeNormalDistributionWe04DP_from_ptr



let create_ChiSquareDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _ChiSquareDistribution_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_ChiSquareDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ChiSquareDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ChiSquareDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ChiSquareDistribution_from_ptr"
          create_ChiSquareDistribution_from_ptr



let create_NonCentralChiSquareDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _NonCentralChiSquareDistribution_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_NonCentralChiSquareDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "NonCentralChiSquareDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"NonCentralChiSquareDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_NonCentralChiSquareDistribution_from_ptr"
          create_NonCentralChiSquareDistribution_from_ptr



let create_InverseNonCentralChiSquareDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _InverseNonCentralChiSquareDistribution_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_InverseNonCentralChiSquareDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseNonCentralChiSquareDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseNonCentralChiSquareDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseNonCentralChiSquareDistribution_from_ptr"
          create_InverseNonCentralChiSquareDistribution_from_ptr



let create_GammaDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _GammaDistribution_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_GammaDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GammaDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GammaDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GammaDistribution_from_ptr"
          create_GammaDistribution_from_ptr



let create_GammaFunction_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "logValue", _GammaFunction_logValue ;
    "~", _delete_GammaFunction ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GammaFunction") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GammaFunction"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GammaFunction_from_ptr"
          create_GammaFunction_from_ptr



let create_PoissonDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _PoissonDistribution_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_PoissonDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PoissonDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PoissonDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PoissonDistribution_from_ptr"
          create_PoissonDistribution_from_ptr



let create_CumulativePoissonDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _CumulativePoissonDistribution_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_CumulativePoissonDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CumulativePoissonDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CumulativePoissonDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CumulativePoissonDistribution_from_ptr"
          create_CumulativePoissonDistribution_from_ptr



let create_InverseCumulativePoisson_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _InverseCumulativePoisson_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_InverseCumulativePoisson ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativePoisson") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativePoisson"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativePoisson_from_ptr"
          create_InverseCumulativePoisson_from_ptr



let create_StudentDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _StudentDistribution_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_StudentDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "StudentDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"StudentDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_StudentDistribution_from_ptr"
          create_StudentDistribution_from_ptr



let create_CumulativeStudentDistribution_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _CumulativeStudentDistribution_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_CumulativeStudentDistribution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CumulativeStudentDistribution") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CumulativeStudentDistribution"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CumulativeStudentDistribution_from_ptr"
          create_CumulativeStudentDistribution_from_ptr



let create_InverseCumulativeStudent_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "()", _InverseCumulativeStudent_operator_xx_xx_lparen_xx_rparen ;
    "~", _delete_InverseCumulativeStudent ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeStudent") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeStudent"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeStudent_from_ptr"
          create_InverseCumulativeStudent_from_ptr



let create_Money_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "currency", _Money_currency ;
    "value", _Money_value ;
    "rounded", _Money_rounded ;
    "~", _delete_Money ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Money") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Money"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Money_from_ptr"
          create_Money_from_ptr



let create_ExchangeRate_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "source", _ExchangeRate_source ;
    "target", _ExchangeRate_target ;
    "type", _ExchangeRate_type ;
    "rate", _ExchangeRate_rate ;
    "exchange", _ExchangeRate_exchange ;
    "~", _delete_ExchangeRate ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ExchangeRate") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ExchangeRate"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ExchangeRate_from_ptr"
          create_ExchangeRate_from_ptr



let create_ExchangeRateManager_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "add", _ExchangeRateManager_add ;
    "add", _ExchangeRateManager_add ;
    "add", _ExchangeRateManager_add ;
    "lookup", _ExchangeRateManager_lookup ;
    "lookup", _ExchangeRateManager_lookup ;
    "clear", _ExchangeRateManager_clear ;
    "~", _delete_ExchangeRateManager ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ExchangeRateManager") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ExchangeRateManager"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ExchangeRateManager_from_ptr"
          create_ExchangeRateManager_from_ptr



let create_Futures_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Futures ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Futures") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Futures"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Futures_from_ptr"
          create_Futures_from_ptr



let create_TimeBasket_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _TimeBasket_size ;
    "rebin", _TimeBasket_rebin ;
    "~", _delete_TimeBasket ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TimeBasket") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TimeBasket"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TimeBasket_from_ptr"
          create_TimeBasket_from_ptr



let create_SwapPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "startDate", _Swap_startDate ;
    "maturityDate", _Swap_maturityDate ;
    "leg", _Swap_leg ;
    "legNPV", _Swap_legNPV ;
    "~", _delete_Swap ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SwapPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SwapPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SwapPtr_from_ptr"
          create_SwapPtr_from_ptr



let create_VanillaSwapPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "fairRate", _VanillaSwap_fairRate ;
    "fairSpread", _VanillaSwap_fairSpread ;
    "fixedLegBPS", _VanillaSwap_fixedLegBPS ;
    "floatingLegBPS", _VanillaSwap_floatingLegBPS ;
    "fixedLegNPV", _VanillaSwap_fixedLegNPV ;
    "floatingLegNPV", _VanillaSwap_floatingLegNPV ;
    "fixedLeg", _VanillaSwap_fixedLeg ;
    "floatingLeg", _VanillaSwap_floatingLeg ;
    "nominal", _VanillaSwap_nominal ;
    "fixedSchedule", _VanillaSwap_fixedSchedule ;
    "floatingSchedule", _VanillaSwap_floatingSchedule ;
    "fixedRate", _VanillaSwap_fixedRate ;
    "spread", _VanillaSwap_spread ;
    "floatingDayCount", _VanillaSwap_floatingDayCount ;
    "fixedDayCount", _VanillaSwap_fixedDayCount ;
    "~", _delete_VanillaSwap ;
   "::SwapPtr", (fun args -> (create_class "SwapPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "VanillaSwapPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "SwapPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"VanillaSwapPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_VanillaSwapPtr_from_ptr"
          create_VanillaSwapPtr_from_ptr



let create_NonstandardSwapPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "fixedLeg", _NonstandardSwap_fixedLeg ;
    "floatingLeg", _NonstandardSwap_floatingLeg ;
    "fixedNominals", _NonstandardSwap_fixedNominals ;
    "floatingNominals", _NonstandardSwap_floatingNominals ;
    "fixedSchedule", _NonstandardSwap_fixedSchedule ;
    "floatingSchedule", _NonstandardSwap_floatingSchedule ;
    "fixedRate", _NonstandardSwap_fixedRate ;
    "spreads", _NonstandardSwap_spreads ;
    "gearings", _NonstandardSwap_gearings ;
    "floatingDayCount", _NonstandardSwap_floatingDayCount ;
    "fixedDayCount", _NonstandardSwap_fixedDayCount ;
    "~", _delete_NonstandardSwap ;
   "::SwapPtr", (fun args -> (create_class "SwapPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "NonstandardSwapPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "SwapPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"NonstandardSwapPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_NonstandardSwapPtr_from_ptr"
          create_NonstandardSwapPtr_from_ptr



let create_DiscountingSwapEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DiscountingSwapEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DiscountingSwapEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DiscountingSwapEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DiscountingSwapEnginePtr_from_ptr"
          create_DiscountingSwapEnginePtr_from_ptr



let create_AssetSwapPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "fairCleanPrice", _AssetSwap_fairCleanPrice ;
    "fairSpread", _AssetSwap_fairSpread ;
    "~", _delete_AssetSwap ;
   "::SwapPtr", (fun args -> (create_class "SwapPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "AssetSwapPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "SwapPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"AssetSwapPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_AssetSwapPtr_from_ptr"
          create_AssetSwapPtr_from_ptr



let create_FloatFloatSwapPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FloatFloatSwap ;
   "::SwapPtr", (fun args -> (create_class "SwapPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FloatFloatSwapPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "SwapPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FloatFloatSwapPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FloatFloatSwapPtr_from_ptr"
          create_FloatFloatSwapPtr_from_ptr



let create_Pillar_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Pillar ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Pillar") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Pillar"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Pillar_from_ptr"
          create_Pillar_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenRateHelper_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _RateHelper___deref__ ;
    "isNull", _RateHelper_isNull ;
    "~", _delete_RateHelper ;
    "quote", _RateHelper_quote ;
    "latestDate", _RateHelper_latestDate ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(RateHelper)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(RateHelper)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< RateHelper >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenRateHelper_xx_rparen_xx_rdbrace_from_ptr



let create_DepositRateHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DepositRateHelper ;
   "::boost::shared_ptr<(RateHelper)>", (fun args -> (create_class "boost::shared_ptr<(RateHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DepositRateHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(RateHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DepositRateHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DepositRateHelperPtr_from_ptr"
          create_DepositRateHelperPtr_from_ptr



let create_FraRateHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FraRateHelper ;
   "::boost::shared_ptr<(RateHelper)>", (fun args -> (create_class "boost::shared_ptr<(RateHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FraRateHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(RateHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FraRateHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FraRateHelperPtr_from_ptr"
          create_FraRateHelperPtr_from_ptr



let create_FuturesRateHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FuturesRateHelper ;
   "::boost::shared_ptr<(RateHelper)>", (fun args -> (create_class "boost::shared_ptr<(RateHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FuturesRateHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(RateHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FuturesRateHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FuturesRateHelperPtr_from_ptr"
          create_FuturesRateHelperPtr_from_ptr



let create_SwapRateHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "swap", _SwapRateHelper_swap ;
    "~", _delete_SwapRateHelper ;
   "::boost::shared_ptr<(RateHelper)>", (fun args -> (create_class "boost::shared_ptr<(RateHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SwapRateHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(RateHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SwapRateHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SwapRateHelperPtr_from_ptr"
          create_SwapRateHelperPtr_from_ptr



let create_BondHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "bond", _BondHelper_bond ;
    "~", _delete_BondHelper ;
   "::boost::shared_ptr<(RateHelper)>", (fun args -> (create_class "boost::shared_ptr<(RateHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BondHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(RateHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BondHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BondHelperPtr_from_ptr"
          create_BondHelperPtr_from_ptr



let create_FixedRateBondHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "bond", _FixedRateBondHelper_bond ;
    "~", _delete_FixedRateBondHelper ;
   "::BondHelperPtr", (fun args -> (create_class "BondHelperPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FixedRateBondHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "BondHelperPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FixedRateBondHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FixedRateBondHelperPtr_from_ptr"
          create_FixedRateBondHelperPtr_from_ptr



let create_OISRateHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_OISRateHelper ;
   "::boost::shared_ptr<(RateHelper)>", (fun args -> (create_class "boost::shared_ptr<(RateHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "OISRateHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(RateHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"OISRateHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_OISRateHelperPtr_from_ptr"
          create_OISRateHelperPtr_from_ptr



let create_DatedOISRateHelperPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DatedOISRateHelper ;
   "::boost::shared_ptr<(RateHelper)>", (fun args -> (create_class "boost::shared_ptr<(RateHelper)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DatedOISRateHelperPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(RateHelper)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DatedOISRateHelperPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DatedOISRateHelperPtr_from_ptr"
          create_DatedOISRateHelperPtr_from_ptr



let create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenRateHelper_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _RateHelperVector_size ;
    "empty", _RateHelperVector_empty ;
    "clear", _RateHelperVector_clear ;
    "push_back", _RateHelperVector_push_back ;
    "[]", _RateHelperVector_operator_xx_xx_lbrace_xx_rbrace ;
    "=", _RateHelperVector_operator_xx_xx_equals ;
    "set", _RateHelperVector_set ;
    "to_array", _RateHelperVector_to_array ;
    "~", _delete_RateHelperVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "std::vector<(boost::shared_ptr<(RateHelper)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"std::vector<(boost::shared_ptr<(RateHelper)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_std::vector< boost::shared_ptr< RateHelper > >_from_ptr"
          create_std_xxvector_xx_ldbrace_xx_lparenboost_xxshared_ptr_xx_ldbrace_xx_lparenRateHelper_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_FittingMethod_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_FittingMethod ;
    "solution", _FittingMethod_solution ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FittingMethod") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FittingMethod"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FittingMethod_from_ptr"
          create_FittingMethod_from_ptr



let create_FittedBondDiscountCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "fitResults", _FittedBondDiscountCurve_fitResults ;
    "~", _delete_FittedBondDiscountCurve ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FittedBondDiscountCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FittedBondDiscountCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FittedBondDiscountCurvePtr_from_ptr"
          create_FittedBondDiscountCurvePtr_from_ptr



let create_ExponentialSplinesFitting_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ExponentialSplinesFitting ;
   "::FittingMethod", (fun args -> (create_class "FittingMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ExponentialSplinesFitting") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "FittingMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ExponentialSplinesFitting"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ExponentialSplinesFitting_from_ptr"
          create_ExponentialSplinesFitting_from_ptr



let create_NelsonSiegelFitting_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NelsonSiegelFitting ;
   "::FittingMethod", (fun args -> (create_class "FittingMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "NelsonSiegelFitting") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "FittingMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"NelsonSiegelFitting"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_NelsonSiegelFitting_from_ptr"
          create_NelsonSiegelFitting_from_ptr



let create_SvenssonFitting_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SvenssonFitting ;
   "::FittingMethod", (fun args -> (create_class "FittingMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SvenssonFitting") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "FittingMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SvenssonFitting"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SvenssonFitting_from_ptr"
          create_SvenssonFitting_from_ptr



let create_CubicBSplinesFitting_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CubicBSplinesFitting ;
   "::FittingMethod", (fun args -> (create_class "FittingMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CubicBSplinesFitting") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "FittingMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CubicBSplinesFitting"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CubicBSplinesFitting_from_ptr"
          create_CubicBSplinesFitting_from_ptr



let create_SimplePolynomialFitting_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SimplePolynomialFitting ;
   "::FittingMethod", (fun args -> (create_class "FittingMethod") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SimplePolynomialFitting") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "FittingMethod") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SimplePolynomialFitting"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SimplePolynomialFitting_from_ptr"
          create_SimplePolynomialFitting_from_ptr



let create_ForwardCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _ForwardCurve_dates ;
    "forwards", _ForwardCurve_forwards ;
    "nodes", _ForwardCurve_nodes ;
    "~", _delete_ForwardCurve ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ForwardCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ForwardCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ForwardCurvePtr_from_ptr"
          create_ForwardCurvePtr_from_ptr



let create_Position_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Position ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Position") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Position"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Position_from_ptr"
          create_Position_from_ptr



let create_ForwardRateAgreementPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "spotIncome", _ForwardRateAgreement_spotIncome ;
    "spotValue", _ForwardRateAgreement_spotValue ;
    "forwardRate", _ForwardRateAgreement_forwardRate ;
    "~", _delete_ForwardRateAgreement ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ForwardRateAgreementPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ForwardRateAgreementPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ForwardRateAgreementPtr_from_ptr"
          create_ForwardRateAgreementPtr_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenGaussian1dModel_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _Gaussian1dModel___deref__ ;
    "isNull", _Gaussian1dModel_isNull ;
    "~", _delete_Gaussian1dModel ;
    "stateProcess", _Gaussian1dModel_stateProcess ;
    "numeraire", _Gaussian1dModel_numeraire ;
    "numeraire", _Gaussian1dModel_numeraire ;
    "numeraire", _Gaussian1dModel_numeraire ;
    "numeraire", _Gaussian1dModel_numeraire ;
    "numeraire", _Gaussian1dModel_numeraire ;
    "numeraire", _Gaussian1dModel_numeraire ;
    "zerobond", _Gaussian1dModel_zerobond ;
    "zerobond", _Gaussian1dModel_zerobond ;
    "zerobond", _Gaussian1dModel_zerobond ;
    "zerobond", _Gaussian1dModel_zerobond ;
    "zerobond", _Gaussian1dModel_zerobond ;
    "zerobond", _Gaussian1dModel_zerobond ;
    "zerobond", _Gaussian1dModel_zerobond ;
    "zerobond", _Gaussian1dModel_zerobond ;
    "zerobondOption", _Gaussian1dModel_zerobondOption ;
    "zerobondOption", _Gaussian1dModel_zerobondOption ;
    "zerobondOption", _Gaussian1dModel_zerobondOption ;
    "zerobondOption", _Gaussian1dModel_zerobondOption ;
    "zerobondOption", _Gaussian1dModel_zerobondOption ;
    "zerobondOption", _Gaussian1dModel_zerobondOption ;
    "zerobondOption", _Gaussian1dModel_zerobondOption ;
    "zerobondOption", _Gaussian1dModel_zerobondOption ;
    "forwardRate", _Gaussian1dModel_forwardRate ;
    "forwardRate", _Gaussian1dModel_forwardRate ;
    "forwardRate", _Gaussian1dModel_forwardRate ;
    "forwardRate", _Gaussian1dModel_forwardRate ;
    "swapRate", _Gaussian1dModel_swapRate ;
    "swapRate", _Gaussian1dModel_swapRate ;
    "swapRate", _Gaussian1dModel_swapRate ;
    "swapRate", _Gaussian1dModel_swapRate ;
    "swapAnnuity", _Gaussian1dModel_swapAnnuity ;
    "swapAnnuity", _Gaussian1dModel_swapAnnuity ;
    "swapAnnuity", _Gaussian1dModel_swapAnnuity ;
    "swapAnnuity", _Gaussian1dModel_swapAnnuity ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(Gaussian1dModel)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(Gaussian1dModel)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< Gaussian1dModel >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenGaussian1dModel_xx_rparen_xx_rdbrace_from_ptr



let create_GsrPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "calibrateVolatilitiesIterative", _Gsr_calibrateVolatilitiesIterative ;
    "calibrateVolatilitiesIterative", _Gsr_calibrateVolatilitiesIterative ;
    "calibrateVolatilitiesIterative", _Gsr_calibrateVolatilitiesIterative ;
    "calibrate", _Gsr_calibrate ;
    "calibrate", _Gsr_calibrate ;
    "calibrate", _Gsr_calibrate ;
    "calibrate", _Gsr_calibrate ;
    "params", _Gsr_params ;
    "value", _Gsr_value ;
    "endCriteria", _Gsr_endCriteria ;
    "setParams", _Gsr_setParams ;
    "functionEvaluation", _Gsr_functionEvaluation ;
    "reversion", _Gsr_reversion ;
    "volatility", _Gsr_volatility ;
    "~", _delete_Gsr ;
   "::boost::shared_ptr<(Gaussian1dModel)>", (fun args -> (create_class "boost::shared_ptr<(Gaussian1dModel)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GsrPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Gaussian1dModel)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GsrPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GsrPtr_from_ptr"
          create_GsrPtr_from_ptr



let create_MarkovFunctional_xxModelSettings_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_MarkovFunctionalSettings ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MarkovFunctional::ModelSettings") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MarkovFunctional::ModelSettings"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MarkovFunctional::ModelSettings_from_ptr"
          create_MarkovFunctional_xxModelSettings_from_ptr



let create_MarkovFunctionalPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "calibrate", _MarkovFunctional_calibrate ;
    "calibrate", _MarkovFunctional_calibrate ;
    "calibrate", _MarkovFunctional_calibrate ;
    "calibrate", _MarkovFunctional_calibrate ;
    "volatility", _MarkovFunctional_volatility ;
    "~", _delete_MarkovFunctional ;
   "::boost::shared_ptr<(Gaussian1dModel)>", (fun args -> (create_class "boost::shared_ptr<(Gaussian1dModel)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MarkovFunctionalPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Gaussian1dModel)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MarkovFunctionalPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MarkovFunctionalPtr_from_ptr"
          create_MarkovFunctionalPtr_from_ptr



let create_Gaussian1dSwaptionEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Gaussian1dSwaptionEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Gaussian1dSwaptionEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Gaussian1dSwaptionEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Gaussian1dSwaptionEnginePtr_from_ptr"
          create_Gaussian1dSwaptionEnginePtr_from_ptr



let create_Gaussian1dJamshidianSwaptionEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Gaussian1dJamshidianSwaptionEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Gaussian1dJamshidianSwaptionEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Gaussian1dJamshidianSwaptionEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Gaussian1dJamshidianSwaptionEnginePtr_from_ptr"
          create_Gaussian1dJamshidianSwaptionEnginePtr_from_ptr



let create_Gaussian1dNonstandardSwaptionEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Gaussian1dNonstandardSwaptionEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Gaussian1dNonstandardSwaptionEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Gaussian1dNonstandardSwaptionEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Gaussian1dNonstandardSwaptionEnginePtr_from_ptr"
          create_Gaussian1dNonstandardSwaptionEnginePtr_from_ptr



let create_Gaussian1dFloatFloatSwaptionEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Gaussian1dFloatFloatSwaptionEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Gaussian1dFloatFloatSwaptionEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Gaussian1dFloatFloatSwaptionEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Gaussian1dFloatFloatSwaptionEnginePtr_from_ptr"
          create_Gaussian1dFloatFloatSwaptionEnginePtr_from_ptr



let create_SegmentIntegral_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SegmentIntegral ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SegmentIntegral") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SegmentIntegral"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SegmentIntegral_from_ptr"
          create_SegmentIntegral_from_ptr



let create_TrapezoidIntegral_xx_ldbrace_xx_lparenDefault_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_TrapezoidIntegralDefault ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TrapezoidIntegral<(Default)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TrapezoidIntegral<(Default)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TrapezoidIntegral< Default >_from_ptr"
          create_TrapezoidIntegral_xx_ldbrace_xx_lparenDefault_xx_rparen_xx_rdbrace_from_ptr



let create_TrapezoidIntegral_xx_ldbrace_xx_lparenMidPoint_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_TrapezoidIntegralMidPoint ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TrapezoidIntegral<(MidPoint)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TrapezoidIntegral<(MidPoint)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TrapezoidIntegral< MidPoint >_from_ptr"
          create_TrapezoidIntegral_xx_ldbrace_xx_lparenMidPoint_xx_rparen_xx_rdbrace_from_ptr



let create_SimpsonIntegral_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_SimpsonIntegral ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SimpsonIntegral") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SimpsonIntegral"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SimpsonIntegral_from_ptr"
          create_SimpsonIntegral_from_ptr



let create_GaussKronrodAdaptive_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GaussKronrodAdaptive ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussKronrodAdaptive") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussKronrodAdaptive"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussKronrodAdaptive_from_ptr"
          create_GaussKronrodAdaptive_from_ptr



let create_GaussKronrodNonAdaptive_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GaussKronrodNonAdaptive ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussKronrodNonAdaptive") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussKronrodNonAdaptive"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussKronrodNonAdaptive_from_ptr"
          create_GaussKronrodNonAdaptive_from_ptr



let create_GaussLobattoIntegral_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GaussLobattoIntegral ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussLobattoIntegral") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussLobattoIntegral"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussLobattoIntegral_from_ptr"
          create_GaussLobattoIntegral_from_ptr



let create_GaussLaguerreIntegration_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GaussLaguerreIntegration ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussLaguerreIntegration") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussLaguerreIntegration"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussLaguerreIntegration_from_ptr"
          create_GaussLaguerreIntegration_from_ptr



let create_GaussHermiteIntegration_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GaussHermiteIntegration ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussHermiteIntegration") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussHermiteIntegration"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussHermiteIntegration_from_ptr"
          create_GaussHermiteIntegration_from_ptr



let create_GaussJacobiIntegration_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GaussJacobiIntegration ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussJacobiIntegration") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussJacobiIntegration"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussJacobiIntegration_from_ptr"
          create_GaussJacobiIntegration_from_ptr



let create_GaussHyperbolicIntegration_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GaussHyperbolicIntegration ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussHyperbolicIntegration") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussHyperbolicIntegration"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussHyperbolicIntegration_from_ptr"
          create_GaussHyperbolicIntegration_from_ptr



let create_GaussLegendreIntegration_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GaussLegendreIntegration ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussLegendreIntegration") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussLegendreIntegration"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussLegendreIntegration_from_ptr"
          create_GaussLegendreIntegration_from_ptr



let create_GaussChebyshevIntegration_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GaussChebyshevIntegration ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussChebyshevIntegration") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussChebyshevIntegration"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussChebyshevIntegration_from_ptr"
          create_GaussChebyshevIntegration_from_ptr



let create_GaussChebyshev2ndIntegration_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GaussChebyshev2ndIntegration ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussChebyshev2ndIntegration") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussChebyshev2ndIntegration"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussChebyshev2ndIntegration_from_ptr"
          create_GaussChebyshev2ndIntegration_from_ptr



let create_GaussGegenbauerIntegration_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_GaussGegenbauerIntegration ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussGegenbauerIntegration") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussGegenbauerIntegration"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussGegenbauerIntegration_from_ptr"
          create_GaussGegenbauerIntegration_from_ptr



let create_Sample_xx_ldbrace_xx_lparenReal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "value", _SampleNumber_value ;
    "weight", _SampleNumber_weight ;
    "~", _delete_SampleNumber ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Sample<(Real)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Sample<(Real)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Sample< double >_from_ptr"
          create_Sample_xx_ldbrace_xx_lparenReal_xx_rparen_xx_rdbrace_from_ptr



let create_Sample_xx_ldbrace_xx_lparenArray_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "value", _SampleArray_value ;
    "weight", _SampleArray_weight ;
    "~", _delete_SampleArray ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Sample<(Array)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Sample<(Array)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Sample< Array >_from_ptr"
          create_Sample_xx_ldbrace_xx_lparenArray_xx_rparen_xx_rdbrace_from_ptr



let create_Sample_xx_ldbrace_xx_lparenstd_xxvector_xx_ldbrace_xx_lparenReal_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "value", _SampleRealVector_value ;
    "weight", _SampleRealVector_weight ;
    "~", _delete_SampleRealVector ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Sample<(std::vector<(Real)>)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Sample<(std::vector<(Real)>)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Sample< std::vector< double > >_from_ptr"
          create_Sample_xx_ldbrace_xx_lparenstd_xxvector_xx_ldbrace_xx_lparenReal_xx_rparen_xx_rdbrace_xx_rparen_xx_rdbrace_from_ptr



let create_LecuyerUniformRng_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _LecuyerUniformRng_next ;
    "~", _delete_LecuyerUniformRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "LecuyerUniformRng") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"LecuyerUniformRng"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_LecuyerUniformRng_from_ptr"
          create_LecuyerUniformRng_from_ptr



let create_KnuthUniformRng_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _KnuthUniformRng_next ;
    "~", _delete_KnuthUniformRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "KnuthUniformRng") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"KnuthUniformRng"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_KnuthUniformRng_from_ptr"
          create_KnuthUniformRng_from_ptr



let create_MersenneTwisterUniformRng_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _MersenneTwisterUniformRng_next ;
    "~", _delete_MersenneTwisterUniformRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MersenneTwisterUniformRng") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MersenneTwisterUniformRng"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MersenneTwisterUniformRng_from_ptr"
          create_MersenneTwisterUniformRng_from_ptr



let create_UniformRandomGenerator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _UniformRandomGenerator_next ;
    "nextValue", _UniformRandomGenerator_nextValue ;
    "~", _delete_UniformRandomGenerator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "UniformRandomGenerator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"UniformRandomGenerator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_UniformRandomGenerator_from_ptr"
          create_UniformRandomGenerator_from_ptr



let create_CLGaussianRng_xx_ldbrace_xx_lparenLecuyerUniformRng_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _CentralLimitLecuyerGaussianRng_next ;
    "~", _delete_CentralLimitLecuyerGaussianRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CLGaussianRng<(LecuyerUniformRng)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CLGaussianRng<(LecuyerUniformRng)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CLGaussianRng< LecuyerUniformRng >_from_ptr"
          create_CLGaussianRng_xx_ldbrace_xx_lparenLecuyerUniformRng_xx_rparen_xx_rdbrace_from_ptr



let create_CLGaussianRng_xx_ldbrace_xx_lparenKnuthUniformRng_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _CentralLimitKnuthGaussianRng_next ;
    "~", _delete_CentralLimitKnuthGaussianRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CLGaussianRng<(KnuthUniformRng)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CLGaussianRng<(KnuthUniformRng)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CLGaussianRng< KnuthUniformRng >_from_ptr"
          create_CLGaussianRng_xx_ldbrace_xx_lparenKnuthUniformRng_xx_rparen_xx_rdbrace_from_ptr



let create_CLGaussianRng_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _CentralLimitMersenneTwisterGaussianRng_next ;
    "~", _delete_CentralLimitMersenneTwisterGaussianRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CLGaussianRng<(MersenneTwisterUniformRng)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CLGaussianRng<(MersenneTwisterUniformRng)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CLGaussianRng< MersenneTwisterUniformRng >_from_ptr"
          create_CLGaussianRng_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xx_rparen_xx_rdbrace_from_ptr



let create_BoxMullerGaussianRng_xx_ldbrace_xx_lparenLecuyerUniformRng_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _BoxMullerLecuyerGaussianRng_next ;
    "~", _delete_BoxMullerLecuyerGaussianRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BoxMullerGaussianRng<(LecuyerUniformRng)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BoxMullerGaussianRng<(LecuyerUniformRng)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BoxMullerGaussianRng< LecuyerUniformRng >_from_ptr"
          create_BoxMullerGaussianRng_xx_ldbrace_xx_lparenLecuyerUniformRng_xx_rparen_xx_rdbrace_from_ptr



let create_BoxMullerGaussianRng_xx_ldbrace_xx_lparenKnuthUniformRng_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _BoxMullerKnuthGaussianRng_next ;
    "~", _delete_BoxMullerKnuthGaussianRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BoxMullerGaussianRng<(KnuthUniformRng)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BoxMullerGaussianRng<(KnuthUniformRng)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BoxMullerGaussianRng< KnuthUniformRng >_from_ptr"
          create_BoxMullerGaussianRng_xx_ldbrace_xx_lparenKnuthUniformRng_xx_rparen_xx_rdbrace_from_ptr



let create_BoxMullerGaussianRng_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _BoxMullerMersenneTwisterGaussianRng_next ;
    "~", _delete_BoxMullerMersenneTwisterGaussianRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BoxMullerGaussianRng<(MersenneTwisterUniformRng)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BoxMullerGaussianRng<(MersenneTwisterUniformRng)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BoxMullerGaussianRng< MersenneTwisterUniformRng >_from_ptr"
          create_BoxMullerGaussianRng_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRng_xx_ldbrace_xx_lparenLecuyerUniformRng_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _MoroInvCumulativeLecuyerGaussianRng_next ;
    "~", _delete_MoroInvCumulativeLecuyerGaussianRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRng<(LecuyerUniformRng,MoroInverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRng<(LecuyerUniformRng,MoroInverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRng< LecuyerUniformRng,MoroInverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRng_xx_ldbrace_xx_lparenLecuyerUniformRng_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRng_xx_ldbrace_xx_lparenKnuthUniformRng_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _MoroInvCumulativeKnuthGaussianRng_next ;
    "~", _delete_MoroInvCumulativeKnuthGaussianRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRng<(KnuthUniformRng,MoroInverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRng<(KnuthUniformRng,MoroInverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRng< KnuthUniformRng,MoroInverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRng_xx_ldbrace_xx_lparenKnuthUniformRng_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRng_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _MoroInvCumulativeMersenneTwisterGaussianRng_next ;
    "~", _delete_MoroInvCumulativeMersenneTwisterGaussianRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRng<(MersenneTwisterUniformRng,MoroInverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRng<(MersenneTwisterUniformRng,MoroInverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRng< MersenneTwisterUniformRng,MoroInverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRng_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRng_xx_ldbrace_xx_lparenLecuyerUniformRng_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _InvCumulativeLecuyerGaussianRng_next ;
    "~", _delete_InvCumulativeLecuyerGaussianRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRng<(LecuyerUniformRng,InverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRng<(LecuyerUniformRng,InverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRng< LecuyerUniformRng,InverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRng_xx_ldbrace_xx_lparenLecuyerUniformRng_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRng_xx_ldbrace_xx_lparenKnuthUniformRng_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _InvCumulativeKnuthGaussianRng_next ;
    "~", _delete_InvCumulativeKnuthGaussianRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRng<(KnuthUniformRng,InverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRng<(KnuthUniformRng,InverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRng< KnuthUniformRng,InverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRng_xx_ldbrace_xx_lparenKnuthUniformRng_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRng_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _InvCumulativeMersenneTwisterGaussianRng_next ;
    "~", _delete_InvCumulativeMersenneTwisterGaussianRng ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRng<(MersenneTwisterUniformRng,InverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRng<(MersenneTwisterUniformRng,InverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRng< MersenneTwisterUniformRng,InverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRng_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_GaussianRandomGenerator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _GaussianRandomGenerator_next ;
    "nextValue", _GaussianRandomGenerator_nextValue ;
    "~", _delete_GaussianRandomGenerator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussianRandomGenerator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussianRandomGenerator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussianRandomGenerator_from_ptr"
          create_GaussianRandomGenerator_from_ptr



let create_HaltonRsg_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _HaltonRsg_nextSequence ;
    "lastSequence", _HaltonRsg_lastSequence ;
    "dimension", _HaltonRsg_dimension ;
    "~", _delete_HaltonRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "HaltonRsg") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"HaltonRsg"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_HaltonRsg_from_ptr"
          create_HaltonRsg_from_ptr



let create_SobolRsg_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _SobolRsg_nextSequence ;
    "lastSequence", _SobolRsg_lastSequence ;
    "dimension", _SobolRsg_dimension ;
    "~", _delete_SobolRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SobolRsg") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SobolRsg"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SobolRsg_from_ptr"
          create_SobolRsg_from_ptr



let create_SobolBrownianBridgeRsg_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _SobolBrownianBridgeRsg_nextSequence ;
    "lastSequence", _SobolBrownianBridgeRsg_lastSequence ;
    "dimension", _SobolBrownianBridgeRsg_dimension ;
    "~", _delete_SobolBrownianBridgeRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SobolBrownianBridgeRsg") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SobolBrownianBridgeRsg"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SobolBrownianBridgeRsg_from_ptr"
          create_SobolBrownianBridgeRsg_from_ptr



let create_RandomSequenceGenerator_xx_ldbrace_xx_lparenLecuyerUniformRng_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _LecuyerUniformRsg_nextSequence ;
    "dimension", _LecuyerUniformRsg_dimension ;
    "~", _delete_LecuyerUniformRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RandomSequenceGenerator<(LecuyerUniformRng)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RandomSequenceGenerator<(LecuyerUniformRng)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RandomSequenceGenerator< LecuyerUniformRng >_from_ptr"
          create_RandomSequenceGenerator_xx_ldbrace_xx_lparenLecuyerUniformRng_xx_rparen_xx_rdbrace_from_ptr



let create_RandomSequenceGenerator_xx_ldbrace_xx_lparenKnuthUniformRng_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _KnuthUniformRsg_nextSequence ;
    "dimension", _KnuthUniformRsg_dimension ;
    "~", _delete_KnuthUniformRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RandomSequenceGenerator<(KnuthUniformRng)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RandomSequenceGenerator<(KnuthUniformRng)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RandomSequenceGenerator< KnuthUniformRng >_from_ptr"
          create_RandomSequenceGenerator_xx_ldbrace_xx_lparenKnuthUniformRng_xx_rparen_xx_rdbrace_from_ptr



let create_RandomSequenceGenerator_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _MersenneTwisterUniformRsg_nextSequence ;
    "dimension", _MersenneTwisterUniformRsg_dimension ;
    "~", _delete_MersenneTwisterUniformRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RandomSequenceGenerator<(MersenneTwisterUniformRng)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RandomSequenceGenerator<(MersenneTwisterUniformRng)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RandomSequenceGenerator< MersenneTwisterUniformRng >_from_ptr"
          create_RandomSequenceGenerator_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xx_rparen_xx_rdbrace_from_ptr



let create_UniformRandomSequenceGenerator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _UniformRandomSequenceGenerator_nextSequence ;
    "dimension", _UniformRandomSequenceGenerator_dimension ;
    "~", _delete_UniformRandomSequenceGenerator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "UniformRandomSequenceGenerator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"UniformRandomSequenceGenerator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_UniformRandomSequenceGenerator_from_ptr"
          create_UniformRandomSequenceGenerator_from_ptr



let create_UniformLowDiscrepancySequenceGenerator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _UniformLowDiscrepancySequenceGenerator_nextSequence ;
    "dimension", _UniformLowDiscrepancySequenceGenerator_dimension ;
    "~", _delete_UniformLowDiscrepancySequenceGenerator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "UniformLowDiscrepancySequenceGenerator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"UniformLowDiscrepancySequenceGenerator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_UniformLowDiscrepancySequenceGenerator_from_ptr"
          create_UniformLowDiscrepancySequenceGenerator_from_ptr



let create_InverseCumulativeRsg_xx_ldbrace_xx_lparenRandomSequenceGenerator_xx_ldbrace_xx_lparenLecuyerUniformRng_xx_rparen_xx_rdbrace_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _MoroInvCumulativeLecuyerGaussianRsg_nextSequence ;
    "dimension", _MoroInvCumulativeLecuyerGaussianRsg_dimension ;
    "~", _delete_MoroInvCumulativeLecuyerGaussianRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRsg<(RandomSequenceGenerator<(LecuyerUniformRng)>,MoroInverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRsg<(RandomSequenceGenerator<(LecuyerUniformRng)>,MoroInverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRsg< RandomSequenceGenerator< LecuyerUniformRng >,MoroInverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRsg_xx_ldbrace_xx_lparenRandomSequenceGenerator_xx_ldbrace_xx_lparenLecuyerUniformRng_xx_rparen_xx_rdbrace_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRsg_xx_ldbrace_xx_lparenRandomSequenceGenerator_xx_ldbrace_xx_lparenKnuthUniformRng_xx_rparen_xx_rdbrace_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _MoroInvCumulativeKnuthGaussianRsg_nextSequence ;
    "dimension", _MoroInvCumulativeKnuthGaussianRsg_dimension ;
    "~", _delete_MoroInvCumulativeKnuthGaussianRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRsg<(RandomSequenceGenerator<(KnuthUniformRng)>,MoroInverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRsg<(RandomSequenceGenerator<(KnuthUniformRng)>,MoroInverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRsg< RandomSequenceGenerator< KnuthUniformRng >,MoroInverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRsg_xx_ldbrace_xx_lparenRandomSequenceGenerator_xx_ldbrace_xx_lparenKnuthUniformRng_xx_rparen_xx_rdbrace_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRsg_xx_ldbrace_xx_lparenRandomSequenceGenerator_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xx_rparen_xx_rdbrace_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _MoroInvCumulativeMersenneTwisterGaussianRsg_nextSequence ;
    "dimension", _MoroInvCumulativeMersenneTwisterGaussianRsg_dimension ;
    "~", _delete_MoroInvCumulativeMersenneTwisterGaussianRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRsg<(RandomSequenceGenerator<(MersenneTwisterUniformRng)>,MoroInverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRsg<(RandomSequenceGenerator<(MersenneTwisterUniformRng)>,MoroInverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRsg< RandomSequenceGenerator< MersenneTwisterUniformRng >,MoroInverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRsg_xx_ldbrace_xx_lparenRandomSequenceGenerator_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xx_rparen_xx_rdbrace_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRsg_xx_ldbrace_xx_lparenHaltonRsg_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _MoroInvCumulativeHaltonGaussianRsg_nextSequence ;
    "dimension", _MoroInvCumulativeHaltonGaussianRsg_dimension ;
    "~", _delete_MoroInvCumulativeHaltonGaussianRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRsg<(HaltonRsg,MoroInverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRsg<(HaltonRsg,MoroInverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRsg< HaltonRsg,MoroInverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRsg_xx_ldbrace_xx_lparenHaltonRsg_xMoroInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRsg_xx_ldbrace_xx_lparenRandomSequenceGenerator_xx_ldbrace_xx_lparenLecuyerUniformRng_xx_rparen_xx_rdbrace_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _InvCumulativeLecuyerGaussianRsg_nextSequence ;
    "dimension", _InvCumulativeLecuyerGaussianRsg_dimension ;
    "~", _delete_InvCumulativeLecuyerGaussianRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRsg<(RandomSequenceGenerator<(LecuyerUniformRng)>,InverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRsg<(RandomSequenceGenerator<(LecuyerUniformRng)>,InverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRsg< RandomSequenceGenerator< LecuyerUniformRng >,InverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRsg_xx_ldbrace_xx_lparenRandomSequenceGenerator_xx_ldbrace_xx_lparenLecuyerUniformRng_xx_rparen_xx_rdbrace_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRsg_xx_ldbrace_xx_lparenRandomSequenceGenerator_xx_ldbrace_xx_lparenKnuthUniformRng_xx_rparen_xx_rdbrace_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _InvCumulativeKnuthGaussianRsg_nextSequence ;
    "dimension", _InvCumulativeKnuthGaussianRsg_dimension ;
    "~", _delete_InvCumulativeKnuthGaussianRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRsg<(RandomSequenceGenerator<(KnuthUniformRng)>,InverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRsg<(RandomSequenceGenerator<(KnuthUniformRng)>,InverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRsg< RandomSequenceGenerator< KnuthUniformRng >,InverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRsg_xx_ldbrace_xx_lparenRandomSequenceGenerator_xx_ldbrace_xx_lparenKnuthUniformRng_xx_rparen_xx_rdbrace_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRsg_xx_ldbrace_xx_lparenRandomSequenceGenerator_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xx_rparen_xx_rdbrace_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _InvCumulativeMersenneTwisterGaussianRsg_nextSequence ;
    "dimension", _InvCumulativeMersenneTwisterGaussianRsg_dimension ;
    "~", _delete_InvCumulativeMersenneTwisterGaussianRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRsg<(RandomSequenceGenerator<(MersenneTwisterUniformRng)>,InverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRsg<(RandomSequenceGenerator<(MersenneTwisterUniformRng)>,InverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRsg< RandomSequenceGenerator< MersenneTwisterUniformRng >,InverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRsg_xx_ldbrace_xx_lparenRandomSequenceGenerator_xx_ldbrace_xx_lparenMersenneTwisterUniformRng_xx_rparen_xx_rdbrace_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_InverseCumulativeRsg_xx_ldbrace_xx_lparenHaltonRsg_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _InvCumulativeHaltonGaussianRsg_nextSequence ;
    "dimension", _InvCumulativeHaltonGaussianRsg_dimension ;
    "~", _delete_InvCumulativeHaltonGaussianRsg ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "InverseCumulativeRsg<(HaltonRsg,InverseCumulativeNormal)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"InverseCumulativeRsg<(HaltonRsg,InverseCumulativeNormal)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_InverseCumulativeRsg< HaltonRsg,InverseCumulativeNormal >_from_ptr"
          create_InverseCumulativeRsg_xx_ldbrace_xx_lparenHaltonRsg_xInverseCumulativeNormal_xx_rparen_xx_rdbrace_from_ptr



let create_GaussianRandomSequenceGenerator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _GaussianRandomSequenceGenerator_nextSequence ;
    "dimension", _GaussianRandomSequenceGenerator_dimension ;
    "~", _delete_GaussianRandomSequenceGenerator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussianRandomSequenceGenerator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussianRandomSequenceGenerator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussianRandomSequenceGenerator_from_ptr"
          create_GaussianRandomSequenceGenerator_from_ptr



let create_GaussianLowDiscrepancySequenceGenerator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "nextSequence", _GaussianLowDiscrepancySequenceGenerator_nextSequence ;
    "dimension", _GaussianLowDiscrepancySequenceGenerator_dimension ;
    "~", _delete_GaussianLowDiscrepancySequenceGenerator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussianLowDiscrepancySequenceGenerator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussianLowDiscrepancySequenceGenerator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussianLowDiscrepancySequenceGenerator_from_ptr"
          create_GaussianLowDiscrepancySequenceGenerator_from_ptr



let create_Path_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "length", _Path_length ;
    "value", _Path_value ;
    "front", _Path_front ;
    "back", _Path_back ;
    "time", _Path_time ;
    "~", _delete_Path ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Path") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Path"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Path_from_ptr"
          create_Path_from_ptr



let create_Sample_xx_ldbrace_xx_lparenPath_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "value", _SamplePath_value ;
    "weight", _SamplePath_weight ;
    "~", _delete_SamplePath ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Sample<(Path)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Sample<(Path)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Sample< Path >_from_ptr"
          create_Sample_xx_ldbrace_xx_lparenPath_xx_rparen_xx_rdbrace_from_ptr



let create_GaussianPathGenerator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _GaussianPathGenerator_next ;
    "antithetic", _GaussianPathGenerator_antithetic ;
    "~", _delete_GaussianPathGenerator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussianPathGenerator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussianPathGenerator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussianPathGenerator_from_ptr"
          create_GaussianPathGenerator_from_ptr



let create_GaussianSobolPathGenerator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _GaussianSobolPathGenerator_next ;
    "antithetic", _GaussianSobolPathGenerator_antithetic ;
    "~", _delete_GaussianSobolPathGenerator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussianSobolPathGenerator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussianSobolPathGenerator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussianSobolPathGenerator_from_ptr"
          create_GaussianSobolPathGenerator_from_ptr



let create_MultiPath_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "pathSize", _MultiPath_pathSize ;
    "assetNumber", _MultiPath_assetNumber ;
    "at", _MultiPath_at ;
    "~", _delete_MultiPath ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MultiPath") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MultiPath"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MultiPath_from_ptr"
          create_MultiPath_from_ptr



let create_Sample_xx_ldbrace_xx_lparenMultiPath_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "value", _SampleMultiPath_value ;
    "weight", _SampleMultiPath_weight ;
    "~", _delete_SampleMultiPath ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Sample<(MultiPath)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Sample<(MultiPath)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Sample< MultiPath >_from_ptr"
          create_Sample_xx_ldbrace_xx_lparenMultiPath_xx_rparen_xx_rdbrace_from_ptr



let create_GaussianMultiPathGenerator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "next", _GaussianMultiPathGenerator_next ;
    "antithetic", _GaussianMultiPathGenerator_antithetic ;
    "~", _delete_GaussianMultiPathGenerator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GaussianMultiPathGenerator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GaussianMultiPathGenerator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GaussianMultiPathGenerator_from_ptr"
          create_GaussianMultiPathGenerator_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenDefaultBoundaryCondition_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _BoundaryCondition___deref__ ;
    "isNull", _BoundaryCondition_isNull ;
    "~", _delete_BoundaryCondition ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(DefaultBoundaryCondition)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(DefaultBoundaryCondition)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< DefaultBoundaryCondition >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenDefaultBoundaryCondition_xx_rparen_xx_rdbrace_from_ptr



let create_NeumannBCPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_NeumannBC ;
   "::boost::shared_ptr<(DefaultBoundaryCondition)>", (fun args -> (create_class "boost::shared_ptr<(DefaultBoundaryCondition)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "NeumannBCPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(DefaultBoundaryCondition)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"NeumannBCPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_NeumannBCPtr_from_ptr"
          create_NeumannBCPtr_from_ptr



let create_DirichletBCPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DirichletBC ;
   "::boost::shared_ptr<(DefaultBoundaryCondition)>", (fun args -> (create_class "boost::shared_ptr<(DefaultBoundaryCondition)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DirichletBCPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(DefaultBoundaryCondition)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DirichletBCPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DirichletBCPtr_from_ptr"
          create_DirichletBCPtr_from_ptr



let create_TridiagonalOperator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "solveFor", _TridiagonalOperator_solveFor ;
    "applyTo", _TridiagonalOperator_applyTo ;
    "size", _TridiagonalOperator_size ;
    "setFirstRow", _TridiagonalOperator_setFirstRow ;
    "setMidRow", _TridiagonalOperator_setMidRow ;
    "setMidRows", _TridiagonalOperator_setMidRows ;
    "setLastRow", _TridiagonalOperator_setLastRow ;
    "~", _delete_TridiagonalOperator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "TridiagonalOperator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"TridiagonalOperator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_TridiagonalOperator_from_ptr"
          create_TridiagonalOperator_from_ptr



let create_DPlus_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DPlus ;
   "::TridiagonalOperator", (fun args -> (create_class "TridiagonalOperator") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DPlus") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "TridiagonalOperator") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DPlus"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DPlus_from_ptr"
          create_DPlus_from_ptr



let create_DMinus_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DMinus ;
   "::TridiagonalOperator", (fun args -> (create_class "TridiagonalOperator") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DMinus") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "TridiagonalOperator") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DMinus"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DMinus_from_ptr"
          create_DMinus_from_ptr



let create_DZero_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DZero ;
   "::TridiagonalOperator", (fun args -> (create_class "TridiagonalOperator") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DZero") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "TridiagonalOperator") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DZero"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DZero_from_ptr"
          create_DZero_from_ptr



let create_DPlusDMinus_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_DPlusDMinus ;
   "::TridiagonalOperator", (fun args -> (create_class "TridiagonalOperator") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "DPlusDMinus") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "TridiagonalOperator") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"DPlusDMinus"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_DPlusDMinus_from_ptr"
          create_DPlusDMinus_from_ptr



let create_Discount_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Discount ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Discount") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Discount"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Discount_from_ptr"
          create_Discount_from_ptr



let create_ZeroYield_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ZeroYield ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ZeroYield") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ZeroYield"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ZeroYield_from_ptr"
          create_ZeroYield_from_ptr



let create_ForwardRate_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_ForwardRate ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ForwardRate") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ForwardRate"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ForwardRate_from_ptr"
          create_ForwardRate_from_ptr



let create_PiecewiseFlatForwardPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _PiecewiseFlatForward_dates ;
    "times", _PiecewiseFlatForward_times ;
    "nodes", _PiecewiseFlatForward_nodes ;
    "~", _delete_PiecewiseFlatForward ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PiecewiseFlatForwardPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PiecewiseFlatForwardPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PiecewiseFlatForwardPtr_from_ptr"
          create_PiecewiseFlatForwardPtr_from_ptr



let create_PiecewiseLinearForwardPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _PiecewiseLinearForward_dates ;
    "times", _PiecewiseLinearForward_times ;
    "nodes", _PiecewiseLinearForward_nodes ;
    "~", _delete_PiecewiseLinearForward ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PiecewiseLinearForwardPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PiecewiseLinearForwardPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PiecewiseLinearForwardPtr_from_ptr"
          create_PiecewiseLinearForwardPtr_from_ptr



let create_PiecewiseLinearZeroPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _PiecewiseLinearZero_dates ;
    "times", _PiecewiseLinearZero_times ;
    "nodes", _PiecewiseLinearZero_nodes ;
    "~", _delete_PiecewiseLinearZero ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PiecewiseLinearZeroPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PiecewiseLinearZeroPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PiecewiseLinearZeroPtr_from_ptr"
          create_PiecewiseLinearZeroPtr_from_ptr



let create_PiecewiseCubicZeroPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _PiecewiseCubicZero_dates ;
    "times", _PiecewiseCubicZero_times ;
    "nodes", _PiecewiseCubicZero_nodes ;
    "~", _delete_PiecewiseCubicZero ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PiecewiseCubicZeroPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PiecewiseCubicZeroPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PiecewiseCubicZeroPtr_from_ptr"
          create_PiecewiseCubicZeroPtr_from_ptr



let create_PiecewiseLogCubicDiscountPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "dates", _PiecewiseLogCubicDiscount_dates ;
    "times", _PiecewiseLogCubicDiscount_times ;
    "nodes", _PiecewiseLogCubicDiscount_nodes ;
    "~", _delete_PiecewiseLogCubicDiscount ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "PiecewiseLogCubicDiscountPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"PiecewiseLogCubicDiscountPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_PiecewiseLogCubicDiscountPtr_from_ptr"
          create_PiecewiseLogCubicDiscountPtr_from_ptr



let create_SampledCurve_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "grid", _SampledCurve_grid ;
    "values", _SampledCurve_values ;
    "gridValue", _SampledCurve_gridValue ;
    "value", _SampledCurve_value ;
    "size", _SampledCurve_size ;
    "empty", _SampledCurve_empty ;
    "setGrid", _SampledCurve_setGrid ;
    "setValues", _SampledCurve_setValues ;
    "swap", _SampledCurve_swap ;
    "setLogGrid", _SampledCurve_setLogGrid ;
    "regridLogGrid", _SampledCurve_regridLogGrid ;
    "shiftGrid", _SampledCurve_shiftGrid ;
    "scaleGrid", _SampledCurve_scaleGrid ;
    "regrid", _SampledCurve_regrid ;
    "~", _delete_SampledCurve ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SampledCurve") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SampledCurve"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SampledCurve_from_ptr"
          create_SampledCurve_from_ptr



let create_Settings_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "getEvaluationDate", _Settings_getEvaluationDate ;
    "setEvaluationDate", _Settings_setEvaluationDate ;
    "includeReferenceDateEvents", _Settings_includeReferenceDateEvents ;
    "includeTodaysCashFlows", _Settings_includeTodaysCashFlows ;
    "~", _delete_Settings ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Settings") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Settings"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Settings_from_ptr"
          create_Settings_from_ptr



let create_Statistics_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "samples", _Statistics_samples ;
    "weightSum", _Statistics_weightSum ;
    "mean", _Statistics_mean ;
    "variance", _Statistics_variance ;
    "standardDeviation", _Statistics_standardDeviation ;
    "errorEstimate", _Statistics_errorEstimate ;
    "skewness", _Statistics_skewness ;
    "kurtosis", _Statistics_kurtosis ;
    "min", _Statistics_min ;
    "max", _Statistics_max ;
    "reset", _Statistics_reset ;
    "add", _Statistics_add ;
    "add", _Statistics_add ;
    "add", _Statistics_add ;
    "add", _Statistics_add ;
    "~", _delete_Statistics ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Statistics") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Statistics"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Statistics_from_ptr"
          create_Statistics_from_ptr



let create_IncrementalStatistics_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "samples", _IncrementalStatistics_samples ;
    "weightSum", _IncrementalStatistics_weightSum ;
    "mean", _IncrementalStatistics_mean ;
    "variance", _IncrementalStatistics_variance ;
    "standardDeviation", _IncrementalStatistics_standardDeviation ;
    "errorEstimate", _IncrementalStatistics_errorEstimate ;
    "skewness", _IncrementalStatistics_skewness ;
    "kurtosis", _IncrementalStatistics_kurtosis ;
    "min", _IncrementalStatistics_min ;
    "max", _IncrementalStatistics_max ;
    "reset", _IncrementalStatistics_reset ;
    "add", _IncrementalStatistics_add ;
    "add", _IncrementalStatistics_add ;
    "add", _IncrementalStatistics_add ;
    "add", _IncrementalStatistics_add ;
    "~", _delete_IncrementalStatistics ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "IncrementalStatistics") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"IncrementalStatistics"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_IncrementalStatistics_from_ptr"
          create_IncrementalStatistics_from_ptr



let create_RiskStatistics_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "semiVariance", _RiskStatistics_semiVariance ;
    "semiDeviation", _RiskStatistics_semiDeviation ;
    "downsideVariance", _RiskStatistics_downsideVariance ;
    "downsideDeviation", _RiskStatistics_downsideDeviation ;
    "regret", _RiskStatistics_regret ;
    "potentialUpside", _RiskStatistics_potentialUpside ;
    "valueAtRisk", _RiskStatistics_valueAtRisk ;
    "expectedShortfall", _RiskStatistics_expectedShortfall ;
    "shortfall", _RiskStatistics_shortfall ;
    "averageShortfall", _RiskStatistics_averageShortfall ;
    "~", _delete_RiskStatistics ;
   "::Statistics", (fun args -> (create_class "Statistics") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RiskStatistics") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Statistics") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RiskStatistics"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RiskStatistics_from_ptr"
          create_RiskStatistics_from_ptr



let create_GenericSequenceStatistics_xx_ldbrace_xx_lparenStatistics_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _MultipleStatistics_size ;
    "samples", _MultipleStatistics_samples ;
    "weightSum", _MultipleStatistics_weightSum ;
    "mean", _MultipleStatistics_mean ;
    "variance", _MultipleStatistics_variance ;
    "standardDeviation", _MultipleStatistics_standardDeviation ;
    "errorEstimate", _MultipleStatistics_errorEstimate ;
    "skewness", _MultipleStatistics_skewness ;
    "kurtosis", _MultipleStatistics_kurtosis ;
    "min", _MultipleStatistics_min ;
    "max", _MultipleStatistics_max ;
    "covariance", _MultipleStatistics_covariance ;
    "correlation", _MultipleStatistics_correlation ;
    "reset", _MultipleStatistics_reset ;
    "add", _MultipleStatistics_add ;
    "add", _MultipleStatistics_add ;
    "add", _MultipleStatistics_add ;
    "add", _MultipleStatistics_add ;
    "~", _delete_MultipleStatistics ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GenericSequenceStatistics<(Statistics)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GenericSequenceStatistics<(Statistics)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GenericSequenceStatistics< Statistics >_from_ptr"
          create_GenericSequenceStatistics_xx_ldbrace_xx_lparenStatistics_xx_rparen_xx_rdbrace_from_ptr



let create_GenericSequenceStatistics_xx_ldbrace_xx_lparenRiskStatistics_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _SequenceStatistics_size ;
    "samples", _SequenceStatistics_samples ;
    "weightSum", _SequenceStatistics_weightSum ;
    "mean", _SequenceStatistics_mean ;
    "variance", _SequenceStatistics_variance ;
    "standardDeviation", _SequenceStatistics_standardDeviation ;
    "errorEstimate", _SequenceStatistics_errorEstimate ;
    "skewness", _SequenceStatistics_skewness ;
    "kurtosis", _SequenceStatistics_kurtosis ;
    "min", _SequenceStatistics_min ;
    "max", _SequenceStatistics_max ;
    "covariance", _SequenceStatistics_covariance ;
    "correlation", _SequenceStatistics_correlation ;
    "reset", _SequenceStatistics_reset ;
    "add", _SequenceStatistics_add ;
    "add", _SequenceStatistics_add ;
    "add", _SequenceStatistics_add ;
    "add", _SequenceStatistics_add ;
    "~", _delete_SequenceStatistics ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GenericSequenceStatistics<(RiskStatistics)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GenericSequenceStatistics<(RiskStatistics)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GenericSequenceStatistics< RiskStatistics >_from_ptr"
          create_GenericSequenceStatistics_xx_ldbrace_xx_lparenRiskStatistics_xx_rparen_xx_rdbrace_from_ptr



let create_GenericSequenceStatistics_xx_ldbrace_xx_lparenIncrementalStatistics_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "size", _MultipleIncrementalStatistics_size ;
    "samples", _MultipleIncrementalStatistics_samples ;
    "weightSum", _MultipleIncrementalStatistics_weightSum ;
    "mean", _MultipleIncrementalStatistics_mean ;
    "variance", _MultipleIncrementalStatistics_variance ;
    "standardDeviation", _MultipleIncrementalStatistics_standardDeviation ;
    "errorEstimate", _MultipleIncrementalStatistics_errorEstimate ;
    "skewness", _MultipleIncrementalStatistics_skewness ;
    "kurtosis", _MultipleIncrementalStatistics_kurtosis ;
    "min", _MultipleIncrementalStatistics_min ;
    "max", _MultipleIncrementalStatistics_max ;
    "covariance", _MultipleIncrementalStatistics_covariance ;
    "correlation", _MultipleIncrementalStatistics_correlation ;
    "reset", _MultipleIncrementalStatistics_reset ;
    "add", _MultipleIncrementalStatistics_add ;
    "add", _MultipleIncrementalStatistics_add ;
    "add", _MultipleIncrementalStatistics_add ;
    "add", _MultipleIncrementalStatistics_add ;
    "~", _delete_MultipleIncrementalStatistics ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GenericSequenceStatistics<(IncrementalStatistics)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GenericSequenceStatistics<(IncrementalStatistics)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GenericSequenceStatistics< IncrementalStatistics >_from_ptr"
          create_GenericSequenceStatistics_xx_ldbrace_xx_lparenIncrementalStatistics_xx_rparen_xx_rdbrace_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenCapFloorTermVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _CapFloorTermVolatilityStructure___deref__ ;
    "isNull", _CapFloorTermVolatilityStructure_isNull ;
    "asObservable", _CapFloorTermVolatilityStructure_asObservable ;
    "~", _delete_CapFloorTermVolatilityStructure ;
    "volatility", _CapFloorTermVolatilityStructure_volatility ;
    "volatility", _CapFloorTermVolatilityStructure_volatility ;
    "volatility", _CapFloorTermVolatilityStructure_volatility ;
    "volatility", _CapFloorTermVolatilityStructure_volatility ;
    "volatility", _CapFloorTermVolatilityStructure_volatility ;
    "volatility", _CapFloorTermVolatilityStructure_volatility ;
    "enableExtrapolation", _CapFloorTermVolatilityStructure_enableExtrapolation ;
    "disableExtrapolation", _CapFloorTermVolatilityStructure_disableExtrapolation ;
    "allowsExtrapolation", _CapFloorTermVolatilityStructure_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(CapFloorTermVolatilityStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(CapFloorTermVolatilityStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< CapFloorTermVolatilityStructure >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenCapFloorTermVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr



let create_Handle_xx_ldbrace_xx_lparenCapFloorTermVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _CapFloorTermVolatilityStructureHandle___deref__ ;
    "empty", _CapFloorTermVolatilityStructureHandle_empty ;
    "asObservable", _CapFloorTermVolatilityStructureHandle_asObservable ;
    "~", _delete_CapFloorTermVolatilityStructureHandle ;
    "volatility", _CapFloorTermVolatilityStructureHandle_volatility ;
    "volatility", _CapFloorTermVolatilityStructureHandle_volatility ;
    "volatility", _CapFloorTermVolatilityStructureHandle_volatility ;
    "volatility", _CapFloorTermVolatilityStructureHandle_volatility ;
    "volatility", _CapFloorTermVolatilityStructureHandle_volatility ;
    "volatility", _CapFloorTermVolatilityStructureHandle_volatility ;
    "enableExtrapolation", _CapFloorTermVolatilityStructureHandle_enableExtrapolation ;
    "disableExtrapolation", _CapFloorTermVolatilityStructureHandle_disableExtrapolation ;
    "allowsExtrapolation", _CapFloorTermVolatilityStructureHandle_allowsExtrapolation ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Handle<(CapFloorTermVolatilityStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Handle<(CapFloorTermVolatilityStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Handle< CapFloorTermVolatilityStructure >_from_ptr"
          create_Handle_xx_ldbrace_xx_lparenCapFloorTermVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr



let create_RelinkableHandle_xx_ldbrace_xx_lparenCapFloorTermVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "linkTo", _RelinkableCapFloorTermVolatilityStructureHandle_linkTo ;
    "~", _delete_RelinkableCapFloorTermVolatilityStructureHandle ;
   "::Handle<(CapFloorTermVolatilityStructure)>", (fun args -> (create_class "Handle<(CapFloorTermVolatilityStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "RelinkableHandle<(CapFloorTermVolatilityStructure)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "Handle<(CapFloorTermVolatilityStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"RelinkableHandle<(CapFloorTermVolatilityStructure)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_RelinkableHandle< CapFloorTermVolatilityStructure >_from_ptr"
          create_RelinkableHandle_xx_ldbrace_xx_lparenCapFloorTermVolatilityStructure_xx_rparen_xx_rdbrace_from_ptr



let create_CapFloorTermVolCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CapFloorTermVolCurve ;
   "::boost::shared_ptr<(CapFloorTermVolatilityStructure)>", (fun args -> (create_class "boost::shared_ptr<(CapFloorTermVolatilityStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CapFloorTermVolCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(CapFloorTermVolatilityStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CapFloorTermVolCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CapFloorTermVolCurvePtr_from_ptr"
          create_CapFloorTermVolCurvePtr_from_ptr



let create_CapFloorTermVolSurfacePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_CapFloorTermVolSurface ;
   "::boost::shared_ptr<(CapFloorTermVolatilityStructure)>", (fun args -> (create_class "boost::shared_ptr<(CapFloorTermVolatilityStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CapFloorTermVolSurfacePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(CapFloorTermVolatilityStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CapFloorTermVolSurfacePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CapFloorTermVolSurfacePtr_from_ptr"
          create_CapFloorTermVolSurfacePtr_from_ptr



let create_boost_xxshared_ptr_xx_ldbrace_xx_lparenStrippedOptionletBase_xx_rparen_xx_rdbrace_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "__deref__", _StrippedOptionletBase___deref__ ;
    "isNull", _StrippedOptionletBase_isNull ;
    "~", _delete_StrippedOptionletBase ;
    "optionletStrikes", _StrippedOptionletBase_optionletStrikes ;
    "optionletVolatilities", _StrippedOptionletBase_optionletVolatilities ;
    "optionletFixingDates", _StrippedOptionletBase_optionletFixingDates ;
    "optionletFixingTimes", _StrippedOptionletBase_optionletFixingTimes ;
    "optionletMaturities", _StrippedOptionletBase_optionletMaturities ;
    "atmOptionletRates", _StrippedOptionletBase_atmOptionletRates ;
    "dayCounter", _StrippedOptionletBase_dayCounter ;
    "calendar", _StrippedOptionletBase_calendar ;
    "settlementDays", _StrippedOptionletBase_settlementDays ;
    "businessDayConvention", _StrippedOptionletBase_businessDayConvention ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "boost::shared_ptr<(StrippedOptionletBase)>") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"boost::shared_ptr<(StrippedOptionletBase)>"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_boost::shared_ptr< StrippedOptionletBase >_from_ptr"
          create_boost_xxshared_ptr_xx_ldbrace_xx_lparenStrippedOptionletBase_xx_rparen_xx_rdbrace_from_ptr



let create_OptionletStripper1Ptr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "capFloorPrices", _OptionletStripper1_capFloorPrices ;
    "capFloorVolatilities", _OptionletStripper1_capFloorVolatilities ;
    "optionletPrices", _OptionletStripper1_optionletPrices ;
    "switchStrike", _OptionletStripper1_switchStrike ;
    "~", _delete_OptionletStripper1 ;
   "::boost::shared_ptr<(StrippedOptionletBase)>", (fun args -> (create_class "boost::shared_ptr<(StrippedOptionletBase)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "OptionletStripper1Ptr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(StrippedOptionletBase)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"OptionletStripper1Ptr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_OptionletStripper1Ptr_from_ptr"
          create_OptionletStripper1Ptr_from_ptr



let create_StrippedOptionletAdapterPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_StrippedOptionletAdapter ;
   "::boost::shared_ptr<(OptionletVolatilityStructure)>", (fun args -> (create_class "boost::shared_ptr<(OptionletVolatilityStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "StrippedOptionletAdapterPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(OptionletVolatilityStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"StrippedOptionletAdapterPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_StrippedOptionletAdapterPtr_from_ptr"
          create_StrippedOptionletAdapterPtr_from_ptr



let create_Settlement_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Settlement ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "Settlement") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"Settlement"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_Settlement_from_ptr"
          create_Settlement_from_ptr



let create_SwaptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_Swaption ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "SwaptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"SwaptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_SwaptionPtr_from_ptr"
          create_SwaptionPtr_from_ptr



let create_NonstandardSwaptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "calibrationBasket", _NonstandardSwaption_calibrationBasket ;
    "~", _delete_NonstandardSwaption ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "NonstandardSwaptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"NonstandardSwaptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_NonstandardSwaptionPtr_from_ptr"
          create_NonstandardSwaptionPtr_from_ptr



let create_FloatFloatSwaptionPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "calibrationBasket", _FloatFloatSwaption_calibrationBasket ;
    "underlyingValue", _FloatFloatSwaption_underlyingValue ;
    "~", _delete_FloatFloatSwaption ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FloatFloatSwaptionPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FloatFloatSwaptionPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FloatFloatSwaptionPtr_from_ptr"
          create_FloatFloatSwaptionPtr_from_ptr



let create_BlackSwaptionEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "vega", _BlackSwaptionEngine_vega ;
    "~", _delete_BlackSwaptionEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BlackSwaptionEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BlackSwaptionEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BlackSwaptionEnginePtr_from_ptr"
          create_BlackSwaptionEnginePtr_from_ptr



let create_BachelierSwaptionEnginePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "~", _delete_BachelierSwaptionEngine ;
   "::boost::shared_ptr<(PricingEngine)>", (fun args -> (create_class "boost::shared_ptr<(PricingEngine)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BachelierSwaptionEnginePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(PricingEngine)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BachelierSwaptionEnginePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BachelierSwaptionEnginePtr_from_ptr"
          create_BachelierSwaptionEnginePtr_from_ptr



let create_ConstantEstimator_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "calculate", _ConstantEstimator_calculate ;
    "~", _delete_ConstantEstimator ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ConstantEstimator") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ConstantEstimator"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ConstantEstimator_from_ptr"
          create_ConstantEstimator_from_ptr



let create_ParkinsonSigma_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "calculate", _ParkinsonSigma_calculate ;
    "~", _delete_ParkinsonSigma ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ParkinsonSigma") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ParkinsonSigma"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ParkinsonSigma_from_ptr"
          create_ParkinsonSigma_from_ptr



let create_GarmanKlassSigma1_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "calculate", _GarmanKlassSigma1_calculate ;
    "~", _delete_GarmanKlassSigma1 ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GarmanKlassSigma1") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GarmanKlassSigma1"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GarmanKlassSigma1_from_ptr"
          create_GarmanKlassSigma1_from_ptr



let create_GarmanKlassSigma3_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "calculate", _GarmanKlassSigma3_calculate ;
    "~", _delete_GarmanKlassSigma3 ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GarmanKlassSigma3") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GarmanKlassSigma3"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GarmanKlassSigma3_from_ptr"
          create_GarmanKlassSigma3_from_ptr



let create_GarmanKlassSigma4_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "calculate", _GarmanKlassSigma4_calculate ;
    "~", _delete_GarmanKlassSigma4 ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GarmanKlassSigma4") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GarmanKlassSigma4"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GarmanKlassSigma4_from_ptr"
          create_GarmanKlassSigma4_from_ptr



let create_GarmanKlassSigma5_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "calculate", _GarmanKlassSigma5_calculate ;
    "~", _delete_GarmanKlassSigma5 ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GarmanKlassSigma5") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GarmanKlassSigma5"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GarmanKlassSigma5_from_ptr"
          create_GarmanKlassSigma5_from_ptr



let create_GarmanKlassSigma6_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "calculate", _GarmanKlassSigma6_calculate ;
    "~", _delete_GarmanKlassSigma6 ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "GarmanKlassSigma6") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    
		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"GarmanKlassSigma6"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_GarmanKlassSigma6_from_ptr"
          create_GarmanKlassSigma6_from_ptr



let create_ZeroCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "times", _ZeroCurve_times ;
    "data", _ZeroCurve_data ;
    "dates", _ZeroCurve_dates ;
    "zeroRates", _ZeroCurve_zeroRates ;
    "nodes", _ZeroCurve_nodes ;
    "~", _delete_ZeroCurve ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ZeroCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ZeroCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ZeroCurvePtr_from_ptr"
          create_ZeroCurvePtr_from_ptr



let create_LogLinearZeroCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "times", _LogLinearZeroCurve_times ;
    "data", _LogLinearZeroCurve_data ;
    "dates", _LogLinearZeroCurve_dates ;
    "zeroRates", _LogLinearZeroCurve_zeroRates ;
    "nodes", _LogLinearZeroCurve_nodes ;
    "~", _delete_LogLinearZeroCurve ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "LogLinearZeroCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"LogLinearZeroCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_LogLinearZeroCurvePtr_from_ptr"
          create_LogLinearZeroCurvePtr_from_ptr



let create_CubicZeroCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "times", _CubicZeroCurve_times ;
    "data", _CubicZeroCurve_data ;
    "dates", _CubicZeroCurve_dates ;
    "zeroRates", _CubicZeroCurve_zeroRates ;
    "nodes", _CubicZeroCurve_nodes ;
    "~", _delete_CubicZeroCurve ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "CubicZeroCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"CubicZeroCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_CubicZeroCurvePtr_from_ptr"
          create_CubicZeroCurvePtr_from_ptr



let create_LogCubicZeroCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "times", _LogCubicZeroCurve_times ;
    "data", _LogCubicZeroCurve_data ;
    "dates", _LogCubicZeroCurve_dates ;
    "zeroRates", _LogCubicZeroCurve_zeroRates ;
    "nodes", _LogCubicZeroCurve_nodes ;
    "~", _delete_LogCubicZeroCurve ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "LogCubicZeroCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"LogCubicZeroCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_LogCubicZeroCurvePtr_from_ptr"
          create_LogCubicZeroCurvePtr_from_ptr



let create_ForwardFlatZeroCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "times", _ForwardFlatZeroCurve_times ;
    "data", _ForwardFlatZeroCurve_data ;
    "dates", _ForwardFlatZeroCurve_dates ;
    "zeroRates", _ForwardFlatZeroCurve_zeroRates ;
    "nodes", _ForwardFlatZeroCurve_nodes ;
    "~", _delete_ForwardFlatZeroCurve ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ForwardFlatZeroCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ForwardFlatZeroCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ForwardFlatZeroCurvePtr_from_ptr"
          create_ForwardFlatZeroCurvePtr_from_ptr



let create_BackwardFlatZeroCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "times", _BackwardFlatZeroCurve_times ;
    "data", _BackwardFlatZeroCurve_data ;
    "dates", _BackwardFlatZeroCurve_dates ;
    "zeroRates", _BackwardFlatZeroCurve_zeroRates ;
    "nodes", _BackwardFlatZeroCurve_nodes ;
    "~", _delete_BackwardFlatZeroCurve ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "BackwardFlatZeroCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"BackwardFlatZeroCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_BackwardFlatZeroCurvePtr_from_ptr"
          create_BackwardFlatZeroCurvePtr_from_ptr



let create_MonotonicCubicZeroCurvePtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "times", _MonotonicCubicZeroCurve_times ;
    "data", _MonotonicCubicZeroCurve_data ;
    "dates", _MonotonicCubicZeroCurve_dates ;
    "zeroRates", _MonotonicCubicZeroCurve_zeroRates ;
    "nodes", _MonotonicCubicZeroCurve_nodes ;
    "~", _delete_MonotonicCubicZeroCurve ;
   "::boost::shared_ptr<(YieldTermStructure)>", (fun args -> (create_class "boost::shared_ptr<(YieldTermStructure)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "MonotonicCubicZeroCurvePtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(YieldTermStructure)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"MonotonicCubicZeroCurvePtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_MonotonicCubicZeroCurvePtr_from_ptr"
          create_MonotonicCubicZeroCurvePtr_from_ptr



let create_ForwardPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "forwardValue", _Forward_forwardValue ;
    "impliedYield", _Forward_impliedYield ;
    "~", _delete_Forward ;
   "::boost::shared_ptr<(Instrument)>", (fun args -> (create_class "boost::shared_ptr<(Instrument)>") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "ForwardPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "boost::shared_ptr<(Instrument)>") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"ForwardPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_ForwardPtr_from_ptr"
          create_ForwardPtr_from_ptr



let create_FixedRateBondForwardPtr_from_ptr raw_ptr =
  C_obj 
begin
  let h = Hashtbl.create 20 in
    List.iter (fun (nm,fn) -> Hashtbl.replace h nm fn) 
	[ "nop", (fun args -> C_void) ;
	      "forwardPrice", _FixedRateBondForward_forwardPrice ;
    "cleanForwardPrice", _FixedRateBondForward_cleanForwardPrice ;
    "spotIncome", _FixedRateBondForward_spotIncome ;
    "spotValue", _FixedRateBondForward_spotValue ;
    "~", _delete_FixedRateBondForward ;
   "::ForwardPtr", (fun args -> (create_class "ForwardPtr") args) ;
 
	 "&", (fun args -> raw_ptr) ;
       ":parents",
       (fun args ->
          C_list
	  (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (x,y) :: !out) h ;
          (List.map	
	     (fun (x,y) ->
		C_string (String.sub x 2 ((String.length x) - 2)))
	     (List.filter
		(fun (x,y) ->
		   ((String.length x) > 2)
		   && x.[0] == ':' && x.[1] == ':') !out)))) ;
       ":classof", (fun args -> C_string "FixedRateBondForwardPtr") ;
       ":methods", (fun args -> 
	  C_list (let out = ref [] in 
	    Hashtbl.iter (fun x y -> out := (C_string x) :: !out) h ; !out))
	] ; 
	let rec invoke_inner raw_ptr mth arg = 
	begin
	  try
	    let application = Hashtbl.find h mth in
	      application
		(match arg with 
		     C_list l -> (C_list (raw_ptr :: l)) 
		   | C_void -> (C_list [ raw_ptr ])
		   | v -> (C_list [ raw_ptr ; v ]))
	  with Not_found -> 
		(* Try parent classes *)
		begin
		  let parent_classes = [
		    (create_class "ForwardPtr") ;

		  ] in
		  let rec try_parent plist raw_ptr =
		    match plist with
			p :: tl -> 
			  begin
			    try
			      (invoke (p raw_ptr)) mth arg
			    with (BadMethodName (p,m,s)) -> 
			      try_parent tl raw_ptr
			  end
		      | [] ->
			  raise (BadMethodName (raw_ptr,mth,"FixedRateBondForwardPtr"))
		  in try_parent parent_classes raw_ptr
		end
	end in
	  (fun mth arg -> invoke_inner raw_ptr mth arg)
end

let _ = Callback.register 
          "create_FixedRateBondForwardPtr_from_ptr"
          create_FixedRateBondForwardPtr_from_ptr


let new_Period clst = _new_Period clst
let new_Period clst = _new_Period clst
let new_Period clst = _new_Period clst
let new_Period clst = _new_Period clst
let new_PeriodVector clst = _new_PeriodVector clst
let new_PeriodVector clst = _new_PeriodVector clst
let new_PeriodVector clst = _new_PeriodVector clst
let new_PeriodVector clst = _new_PeriodVector clst
let new_Date clst = _new_Date clst
let new_Date clst = _new_Date clst
let new_Date clst = _new_Date clst
let new_Date clst = _new_Date clst
let new_Date clst = _new_Date clst
let new_Date clst = _new_Date clst
let new_Date clst = _new_Date clst
let new_DateParser clst = _new_DateParser clst
let new_PeriodParser clst = _new_PeriodParser clst
let new_DateVector clst = _new_DateVector clst
let new_DateVector clst = _new_DateVector clst
let new_DateVector clst = _new_DateVector clst
let new_DateVector clst = _new_DateVector clst
let new_IMM clst = _new_IMM clst
let new_ASX clst = _new_ASX clst
let new_IntVector clst = _new_IntVector clst
let new_IntVector clst = _new_IntVector clst
let new_IntVector clst = _new_IntVector clst
let new_IntVector clst = _new_IntVector clst
let new_UnsignedIntVector clst = _new_UnsignedIntVector clst
let new_UnsignedIntVector clst = _new_UnsignedIntVector clst
let new_UnsignedIntVector clst = _new_UnsignedIntVector clst
let new_UnsignedIntVector clst = _new_UnsignedIntVector clst
let new_DoubleVector clst = _new_DoubleVector clst
let new_DoubleVector clst = _new_DoubleVector clst
let new_DoubleVector clst = _new_DoubleVector clst
let new_DoubleVector clst = _new_DoubleVector clst
let new_StrVector clst = _new_StrVector clst
let new_StrVector clst = _new_StrVector clst
let new_StrVector clst = _new_StrVector clst
let new_StrVector clst = _new_StrVector clst
let new_BoolVector clst = _new_BoolVector clst
let new_BoolVector clst = _new_BoolVector clst
let new_BoolVector clst = _new_BoolVector clst
let new_BoolVector clst = _new_BoolVector clst
let new_NodePair clst = _new_NodePair clst
let new_NodePair clst = _new_NodePair clst
let new_NodePair clst = _new_NodePair clst
let new_NodeVector clst = _new_NodeVector clst
let new_NodeVector clst = _new_NodeVector clst
let new_NodeVector clst = _new_NodeVector clst
let new_NodeVector clst = _new_NodeVector clst
let new_Exercise clst = _new_Exercise clst
let new_EuropeanExercise clst = _new_EuropeanExercise clst
let new_AmericanExercise clst = _new_AmericanExercise clst
let new_AmericanExercise clst = _new_AmericanExercise clst
let new_BermudanExercise clst = _new_BermudanExercise clst
let new_BermudanExercise clst = _new_BermudanExercise clst
let new_RebatedExercise clst = _new_RebatedExercise clst
let new_RebatedExercise clst = _new_RebatedExercise clst
let new_RebatedExercise clst = _new_RebatedExercise clst
let new_RebatedExercise clst = _new_RebatedExercise clst
let new_Observable clst = _new_Observable clst
let new_Array clst = _new_Array clst
let new_Array clst = _new_Array clst
let new_Array clst = _new_Array clst
let new_Array clst = _new_Array clst
let new_LexicographicalView clst = _new_LexicographicalView clst
let new_Matrix clst = _new_Matrix clst
let new_Matrix clst = _new_Matrix clst
let new_Matrix clst = _new_Matrix clst
let new_Matrix clst = _new_Matrix clst
let new_SalvagingAlgorithm clst = _new_SalvagingAlgorithm clst
let new_SVD clst = _new_SVD clst
let new_Quote clst = _new_Quote clst
let new_QuoteHandle clst = _new_QuoteHandle clst
let new_QuoteHandle clst = _new_QuoteHandle clst
let new_RelinkableQuoteHandle clst = _new_RelinkableQuoteHandle clst
let new_RelinkableQuoteHandle clst = _new_RelinkableQuoteHandle clst
let new_SimpleQuote clst = _new_SimpleQuote clst
let new_QuoteVector clst = _new_QuoteVector clst
let new_QuoteVector clst = _new_QuoteVector clst
let new_QuoteVector clst = _new_QuoteVector clst
let new_QuoteVector clst = _new_QuoteVector clst
let new_QuoteVectorVector clst = _new_QuoteVectorVector clst
let new_QuoteVectorVector clst = _new_QuoteVectorVector clst
let new_QuoteVectorVector clst = _new_QuoteVectorVector clst
let new_QuoteVectorVector clst = _new_QuoteVectorVector clst
let new_QuoteHandleVector clst = _new_QuoteHandleVector clst
let new_QuoteHandleVector clst = _new_QuoteHandleVector clst
let new_QuoteHandleVector clst = _new_QuoteHandleVector clst
let new_QuoteHandleVector clst = _new_QuoteHandleVector clst
let new_QuoteHandleVectorVector clst = _new_QuoteHandleVectorVector clst
let new_QuoteHandleVectorVector clst = _new_QuoteHandleVectorVector clst
let new_QuoteHandleVectorVector clst = _new_QuoteHandleVectorVector clst
let new_QuoteHandleVectorVector clst = _new_QuoteHandleVectorVector clst
let new_RelinkableQuoteHandleVector clst = _new_RelinkableQuoteHandleVector clst
let new_RelinkableQuoteHandleVector clst = _new_RelinkableQuoteHandleVector clst
let new_RelinkableQuoteHandleVector clst = _new_RelinkableQuoteHandleVector clst
let new_RelinkableQuoteHandleVector clst = _new_RelinkableQuoteHandleVector clst
let new_RelinkableQuoteHandleVectorVector clst = _new_RelinkableQuoteHandleVectorVector clst
let new_RelinkableQuoteHandleVectorVector clst = _new_RelinkableQuoteHandleVectorVector clst
let new_RelinkableQuoteHandleVectorVector clst = _new_RelinkableQuoteHandleVectorVector clst
let new_RelinkableQuoteHandleVectorVector clst = _new_RelinkableQuoteHandleVectorVector clst
let new_Argentina clst = _new_Argentina clst
let new_Argentina clst = _new_Argentina clst
let new_Australia clst = _new_Australia clst
let new_Brazil clst = _new_Brazil clst
let new_Brazil clst = _new_Brazil clst
let new_Canada clst = _new_Canada clst
let new_Canada clst = _new_Canada clst
let new_China clst = _new_China clst
let new_China clst = _new_China clst
let new_CzechRepublic clst = _new_CzechRepublic clst
let new_CzechRepublic clst = _new_CzechRepublic clst
let new_Denmark clst = _new_Denmark clst
let new_Finland clst = _new_Finland clst
let new_Germany clst = _new_Germany clst
let new_Germany clst = _new_Germany clst
let new_HongKong clst = _new_HongKong clst
let new_HongKong clst = _new_HongKong clst
let new_Hungary clst = _new_Hungary clst
let new_Iceland clst = _new_Iceland clst
let new_Iceland clst = _new_Iceland clst
let new_India clst = _new_India clst
let new_India clst = _new_India clst
let new_Indonesia clst = _new_Indonesia clst
let new_Indonesia clst = _new_Indonesia clst
let new_Israel clst = _new_Israel clst
let new_Israel clst = _new_Israel clst
let new_Italy clst = _new_Italy clst
let new_Italy clst = _new_Italy clst
let new_Japan clst = _new_Japan clst
let new_Mexico clst = _new_Mexico clst
let new_Mexico clst = _new_Mexico clst
let new_NewZealand clst = _new_NewZealand clst
let new_Norway clst = _new_Norway clst
let new_Poland clst = _new_Poland clst
let new_Russia clst = _new_Russia clst
let new_Russia clst = _new_Russia clst
let new_Romania clst = _new_Romania clst
let new_SaudiArabia clst = _new_SaudiArabia clst
let new_SaudiArabia clst = _new_SaudiArabia clst
let new_Singapore clst = _new_Singapore clst
let new_Singapore clst = _new_Singapore clst
let new_Slovakia clst = _new_Slovakia clst
let new_Slovakia clst = _new_Slovakia clst
let new_SouthAfrica clst = _new_SouthAfrica clst
let new_SouthKorea clst = _new_SouthKorea clst
let new_SouthKorea clst = _new_SouthKorea clst
let new_Sweden clst = _new_Sweden clst
let new_Switzerland clst = _new_Switzerland clst
let new_Taiwan clst = _new_Taiwan clst
let new_Taiwan clst = _new_Taiwan clst
let new_TARGET clst = _new_TARGET clst
let new_Turkey clst = _new_Turkey clst
let new_Ukraine clst = _new_Ukraine clst
let new_Ukraine clst = _new_Ukraine clst
let new_UnitedKingdom clst = _new_UnitedKingdom clst
let new_UnitedKingdom clst = _new_UnitedKingdom clst
let new_UnitedStates clst = _new_UnitedStates clst
let new_UnitedStates clst = _new_UnitedStates clst
let new_NullCalendar clst = _new_NullCalendar clst
let new_WeekendsOnly clst = _new_WeekendsOnly clst
let new_JointCalendar clst = _new_JointCalendar clst
let new_JointCalendar clst = _new_JointCalendar clst
let new_JointCalendar clst = _new_JointCalendar clst
let new_JointCalendar clst = _new_JointCalendar clst
let new_JointCalendar clst = _new_JointCalendar clst
let new_JointCalendar clst = _new_JointCalendar clst
let new_BespokeCalendar clst = _new_BespokeCalendar clst
let new_Actual360 clst = _new_Actual360 clst
let new_Actual365Fixed clst = _new_Actual365Fixed clst
let new_Actual365Fixed clst = _new_Actual365Fixed clst
let new_Thirty360 clst = _new_Thirty360 clst
let new_Thirty360 clst = _new_Thirty360 clst
let new_ActualActual clst = _new_ActualActual clst
let new_ActualActual clst = _new_ActualActual clst
let new_ActualActual clst = _new_ActualActual clst
let new_OneDayCounter clst = _new_OneDayCounter clst
let new_SimpleDayCounter clst = _new_SimpleDayCounter clst
let new_Business252 clst = _new_Business252 clst
let new_Business252 clst = _new_Business252 clst
let new_InterestRate clst = _new_InterestRate clst
let new_InterestRate clst = _new_InterestRate clst
let new_InterestRateVector clst = _new_InterestRateVector clst
let new_InterestRateVector clst = _new_InterestRateVector clst
let new_InterestRateVector clst = _new_InterestRateVector clst
let new_InterestRateVector clst = _new_InterestRateVector clst
let new_Rounding clst = _new_Rounding clst
let new_UpRounding clst = _new_UpRounding clst
let new_UpRounding clst = _new_UpRounding clst
let new_DownRounding clst = _new_DownRounding clst
let new_DownRounding clst = _new_DownRounding clst
let new_ClosestRounding clst = _new_ClosestRounding clst
let new_ClosestRounding clst = _new_ClosestRounding clst
let new_CeilingTruncation clst = _new_CeilingTruncation clst
let new_CeilingTruncation clst = _new_CeilingTruncation clst
let new_FloorTruncation clst = _new_FloorTruncation clst
let new_FloorTruncation clst = _new_FloorTruncation clst
let new_Currency clst = _new_Currency clst
let new_ARSCurrency clst = _new_ARSCurrency clst
let new_ATSCurrency clst = _new_ATSCurrency clst
let new_AUDCurrency clst = _new_AUDCurrency clst
let new_BDTCurrency clst = _new_BDTCurrency clst
let new_BEFCurrency clst = _new_BEFCurrency clst
let new_BGLCurrency clst = _new_BGLCurrency clst
let new_BRLCurrency clst = _new_BRLCurrency clst
let new_BYRCurrency clst = _new_BYRCurrency clst
let new_CADCurrency clst = _new_CADCurrency clst
let new_CHFCurrency clst = _new_CHFCurrency clst
let new_CLPCurrency clst = _new_CLPCurrency clst
let new_CNYCurrency clst = _new_CNYCurrency clst
let new_COPCurrency clst = _new_COPCurrency clst
let new_CYPCurrency clst = _new_CYPCurrency clst
let new_CZKCurrency clst = _new_CZKCurrency clst
let new_DEMCurrency clst = _new_DEMCurrency clst
let new_DKKCurrency clst = _new_DKKCurrency clst
let new_EEKCurrency clst = _new_EEKCurrency clst
let new_ESPCurrency clst = _new_ESPCurrency clst
let new_EURCurrency clst = _new_EURCurrency clst
let new_FIMCurrency clst = _new_FIMCurrency clst
let new_FRFCurrency clst = _new_FRFCurrency clst
let new_GBPCurrency clst = _new_GBPCurrency clst
let new_GRDCurrency clst = _new_GRDCurrency clst
let new_HKDCurrency clst = _new_HKDCurrency clst
let new_HUFCurrency clst = _new_HUFCurrency clst
let new_IEPCurrency clst = _new_IEPCurrency clst
let new_IDRCurrency clst = _new_IDRCurrency clst
let new_ILSCurrency clst = _new_ILSCurrency clst
let new_INRCurrency clst = _new_INRCurrency clst
let new_IQDCurrency clst = _new_IQDCurrency clst
let new_IRRCurrency clst = _new_IRRCurrency clst
let new_ISKCurrency clst = _new_ISKCurrency clst
let new_ITLCurrency clst = _new_ITLCurrency clst
let new_JPYCurrency clst = _new_JPYCurrency clst
let new_KRWCurrency clst = _new_KRWCurrency clst
let new_KWDCurrency clst = _new_KWDCurrency clst
let new_LTLCurrency clst = _new_LTLCurrency clst
let new_LUFCurrency clst = _new_LUFCurrency clst
let new_LVLCurrency clst = _new_LVLCurrency clst
let new_MTLCurrency clst = _new_MTLCurrency clst
let new_MXNCurrency clst = _new_MXNCurrency clst
let new_MYRCurrency clst = _new_MYRCurrency clst
let new_NLGCurrency clst = _new_NLGCurrency clst
let new_NOKCurrency clst = _new_NOKCurrency clst
let new_NPRCurrency clst = _new_NPRCurrency clst
let new_NZDCurrency clst = _new_NZDCurrency clst
let new_PEHCurrency clst = _new_PEHCurrency clst
let new_PEICurrency clst = _new_PEICurrency clst
let new_PENCurrency clst = _new_PENCurrency clst
let new_PKRCurrency clst = _new_PKRCurrency clst
let new_PLNCurrency clst = _new_PLNCurrency clst
let new_PTECurrency clst = _new_PTECurrency clst
let new_ROLCurrency clst = _new_ROLCurrency clst
let new_RONCurrency clst = _new_RONCurrency clst
let new_RUBCurrency clst = _new_RUBCurrency clst
let new_SARCurrency clst = _new_SARCurrency clst
let new_SEKCurrency clst = _new_SEKCurrency clst
let new_SGDCurrency clst = _new_SGDCurrency clst
let new_SITCurrency clst = _new_SITCurrency clst
let new_SKKCurrency clst = _new_SKKCurrency clst
let new_THBCurrency clst = _new_THBCurrency clst
let new_TRLCurrency clst = _new_TRLCurrency clst
let new_TRYCurrency clst = _new_TRYCurrency clst
let new_TTDCurrency clst = _new_TTDCurrency clst
let new_TWDCurrency clst = _new_TWDCurrency clst
let new_USDCurrency clst = _new_USDCurrency clst
let new_VEBCurrency clst = _new_VEBCurrency clst
let new_VNDCurrency clst = _new_VNDCurrency clst
let new_ZARCurrency clst = _new_ZARCurrency clst
let new_LinearInterpolation clst = _new_LinearInterpolation clst
let new_LogLinearInterpolation clst = _new_LogLinearInterpolation clst
let new_BackwardFlatInterpolation clst = _new_BackwardFlatInterpolation clst
let new_ForwardFlatInterpolation clst = _new_ForwardFlatInterpolation clst
let new_CubicNaturalSpline clst = _new_CubicNaturalSpline clst
let new_LogCubicNaturalSpline clst = _new_LogCubicNaturalSpline clst
let new_MonotonicCubicNaturalSpline clst = _new_MonotonicCubicNaturalSpline clst
let new_MonotonicLogCubicNaturalSpline clst = _new_MonotonicLogCubicNaturalSpline clst
let new_KrugerCubic clst = _new_KrugerCubic clst
let new_KrugerLogCubic clst = _new_KrugerLogCubic clst
let new_FritschButlandCubic clst = _new_FritschButlandCubic clst
let new_FritschButlandLogCubic clst = _new_FritschButlandLogCubic clst
let new_Parabolic clst = _new_Parabolic clst
let new_LogParabolic clst = _new_LogParabolic clst
let new_MonotonicParabolic clst = _new_MonotonicParabolic clst
let new_MonotonicLogParabolic clst = _new_MonotonicLogParabolic clst
let new_BilinearInterpolation clst = _new_BilinearInterpolation clst
let new_BicubicSpline clst = _new_BicubicSpline clst
let new_BackwardFlat clst = _new_BackwardFlat clst
let new_ForwardFlat clst = _new_ForwardFlat clst
let new_Linear clst = _new_Linear clst
let new_LogLinear clst = _new_LogLinear clst
let new_Cubic clst = _new_Cubic clst
let new_MonotonicCubic clst = _new_MonotonicCubic clst
let new_DefaultLogCubic clst = _new_DefaultLogCubic clst
let new_MonotonicLogCubic clst = _new_MonotonicLogCubic clst
let new_YieldTermStructure clst = _new_YieldTermStructure clst
let new_YieldTermStructureHandle clst = _new_YieldTermStructureHandle clst
let new_YieldTermStructureHandle clst = _new_YieldTermStructureHandle clst
let new_RelinkableYieldTermStructureHandle clst = _new_RelinkableYieldTermStructureHandle clst
let new_RelinkableYieldTermStructureHandle clst = _new_RelinkableYieldTermStructureHandle clst
let new_ImpliedTermStructure clst = _new_ImpliedTermStructure clst
let new_ZeroSpreadedTermStructure clst = _new_ZeroSpreadedTermStructure clst
let new_ZeroSpreadedTermStructure clst = _new_ZeroSpreadedTermStructure clst
let new_ZeroSpreadedTermStructure clst = _new_ZeroSpreadedTermStructure clst
let new_ZeroSpreadedTermStructure clst = _new_ZeroSpreadedTermStructure clst
let new_ForwardSpreadedTermStructure clst = _new_ForwardSpreadedTermStructure clst
let new_SpreadedLinearZeroInterpolatedTermStructure clst = _new_SpreadedLinearZeroInterpolatedTermStructure clst
let new_SpreadedLinearZeroInterpolatedTermStructure clst = _new_SpreadedLinearZeroInterpolatedTermStructure clst
let new_SpreadedLinearZeroInterpolatedTermStructure clst = _new_SpreadedLinearZeroInterpolatedTermStructure clst
let new_SpreadedLinearZeroInterpolatedTermStructure clst = _new_SpreadedLinearZeroInterpolatedTermStructure clst
let new_SpreadedLinearZeroInterpolatedTermStructure clst = _new_SpreadedLinearZeroInterpolatedTermStructure clst
let new_FlatForward clst = _new_FlatForward clst
let new_FlatForward clst = _new_FlatForward clst
let new_FlatForward clst = _new_FlatForward clst
let new_FlatForward clst = _new_FlatForward clst
let new_FlatForward clst = _new_FlatForward clst
let new_FlatForward clst = _new_FlatForward clst
let new_FlatForward clst = _new_FlatForward clst
let new_FlatForward clst = _new_FlatForward clst
let new_FlatForward clst = _new_FlatForward clst
let new_FlatForward clst = _new_FlatForward clst
let new_FlatForward clst = _new_FlatForward clst
let new_FlatForward clst = _new_FlatForward clst
let new_RealTimeSeries clst = _new_RealTimeSeries clst
let new_RealTimeSeries clst = _new_RealTimeSeries clst
let new_IntervalPriceTimeSeries clst = _new_IntervalPriceTimeSeries clst
let new_IntervalPriceTimeSeries clst = _new_IntervalPriceTimeSeries clst
let new_IntervalPriceVector clst = _new_IntervalPriceVector clst
let new_IntervalPriceVector clst = _new_IntervalPriceVector clst
let new_IntervalPriceVector clst = _new_IntervalPriceVector clst
let new_IntervalPriceVector clst = _new_IntervalPriceVector clst
let new_IntervalPrice clst = _new_IntervalPrice clst
let new_Index clst = _new_Index clst
let new_IborIndex clst = _new_IborIndex clst
let new_IborIndex clst = _new_IborIndex clst
let new_OvernightIndex clst = _new_OvernightIndex clst
let new_OvernightIndex clst = _new_OvernightIndex clst
let new_Libor clst = _new_Libor clst
let new_Libor clst = _new_Libor clst
let new_SwapIndex clst = _new_SwapIndex clst
let new_SwapIndex clst = _new_SwapIndex clst
let new_AUDLibor clst = _new_AUDLibor clst
let new_AUDLibor clst = _new_AUDLibor clst
let new_CADLibor clst = _new_CADLibor clst
let new_CADLibor clst = _new_CADLibor clst
let new_Cdor clst = _new_Cdor clst
let new_Cdor clst = _new_Cdor clst
let new_CHFLibor clst = _new_CHFLibor clst
let new_CHFLibor clst = _new_CHFLibor clst
let new_DKKLibor clst = _new_DKKLibor clst
let new_DKKLibor clst = _new_DKKLibor clst
let new_Bbsw clst = _new_Bbsw clst
let new_Bbsw clst = _new_Bbsw clst
let new_Bbsw1M clst = _new_Bbsw1M clst
let new_Bbsw1M clst = _new_Bbsw1M clst
let new_Bbsw2M clst = _new_Bbsw2M clst
let new_Bbsw2M clst = _new_Bbsw2M clst
let new_Bbsw3M clst = _new_Bbsw3M clst
let new_Bbsw3M clst = _new_Bbsw3M clst
let new_Bbsw4M clst = _new_Bbsw4M clst
let new_Bbsw4M clst = _new_Bbsw4M clst
let new_Bbsw5M clst = _new_Bbsw5M clst
let new_Bbsw5M clst = _new_Bbsw5M clst
let new_Bbsw6M clst = _new_Bbsw6M clst
let new_Bbsw6M clst = _new_Bbsw6M clst
let new_Bkbm clst = _new_Bkbm clst
let new_Bkbm clst = _new_Bkbm clst
let new_Bkbm1M clst = _new_Bkbm1M clst
let new_Bkbm1M clst = _new_Bkbm1M clst
let new_Bkbm2M clst = _new_Bkbm2M clst
let new_Bkbm2M clst = _new_Bkbm2M clst
let new_Bkbm3M clst = _new_Bkbm3M clst
let new_Bkbm3M clst = _new_Bkbm3M clst
let new_Bkbm4M clst = _new_Bkbm4M clst
let new_Bkbm4M clst = _new_Bkbm4M clst
let new_Bkbm5M clst = _new_Bkbm5M clst
let new_Bkbm5M clst = _new_Bkbm5M clst
let new_Bkbm6M clst = _new_Bkbm6M clst
let new_Bkbm6M clst = _new_Bkbm6M clst
let new_Euribor clst = _new_Euribor clst
let new_Euribor clst = _new_Euribor clst
let new_EuriborSW clst = _new_EuriborSW clst
let new_EuriborSW clst = _new_EuriborSW clst
let new_Euribor2W clst = _new_Euribor2W clst
let new_Euribor2W clst = _new_Euribor2W clst
let new_Euribor3W clst = _new_Euribor3W clst
let new_Euribor3W clst = _new_Euribor3W clst
let new_Euribor1M clst = _new_Euribor1M clst
let new_Euribor1M clst = _new_Euribor1M clst
let new_Euribor2M clst = _new_Euribor2M clst
let new_Euribor2M clst = _new_Euribor2M clst
let new_Euribor3M clst = _new_Euribor3M clst
let new_Euribor3M clst = _new_Euribor3M clst
let new_Euribor4M clst = _new_Euribor4M clst
let new_Euribor4M clst = _new_Euribor4M clst
let new_Euribor5M clst = _new_Euribor5M clst
let new_Euribor5M clst = _new_Euribor5M clst
let new_Euribor6M clst = _new_Euribor6M clst
let new_Euribor6M clst = _new_Euribor6M clst
let new_Euribor7M clst = _new_Euribor7M clst
let new_Euribor7M clst = _new_Euribor7M clst
let new_Euribor8M clst = _new_Euribor8M clst
let new_Euribor8M clst = _new_Euribor8M clst
let new_Euribor9M clst = _new_Euribor9M clst
let new_Euribor9M clst = _new_Euribor9M clst
let new_Euribor10M clst = _new_Euribor10M clst
let new_Euribor10M clst = _new_Euribor10M clst
let new_Euribor11M clst = _new_Euribor11M clst
let new_Euribor11M clst = _new_Euribor11M clst
let new_Euribor1Y clst = _new_Euribor1Y clst
let new_Euribor1Y clst = _new_Euribor1Y clst
let new_Euribor365 clst = _new_Euribor365 clst
let new_Euribor365 clst = _new_Euribor365 clst
let new_Euribor365_SW clst = _new_Euribor365_SW clst
let new_Euribor365_SW clst = _new_Euribor365_SW clst
let new_Euribor365_2W clst = _new_Euribor365_2W clst
let new_Euribor365_2W clst = _new_Euribor365_2W clst
let new_Euribor365_3W clst = _new_Euribor365_3W clst
let new_Euribor365_3W clst = _new_Euribor365_3W clst
let new_Euribor365_1M clst = _new_Euribor365_1M clst
let new_Euribor365_1M clst = _new_Euribor365_1M clst
let new_Euribor365_2M clst = _new_Euribor365_2M clst
let new_Euribor365_2M clst = _new_Euribor365_2M clst
let new_Euribor365_3M clst = _new_Euribor365_3M clst
let new_Euribor365_3M clst = _new_Euribor365_3M clst
let new_Euribor365_4M clst = _new_Euribor365_4M clst
let new_Euribor365_4M clst = _new_Euribor365_4M clst
let new_Euribor365_5M clst = _new_Euribor365_5M clst
let new_Euribor365_5M clst = _new_Euribor365_5M clst
let new_Euribor365_6M clst = _new_Euribor365_6M clst
let new_Euribor365_6M clst = _new_Euribor365_6M clst
let new_Euribor365_7M clst = _new_Euribor365_7M clst
let new_Euribor365_7M clst = _new_Euribor365_7M clst
let new_Euribor365_8M clst = _new_Euribor365_8M clst
let new_Euribor365_8M clst = _new_Euribor365_8M clst
let new_Euribor365_9M clst = _new_Euribor365_9M clst
let new_Euribor365_9M clst = _new_Euribor365_9M clst
let new_Euribor365_10M clst = _new_Euribor365_10M clst
let new_Euribor365_10M clst = _new_Euribor365_10M clst
let new_Euribor365_11M clst = _new_Euribor365_11M clst
let new_Euribor365_11M clst = _new_Euribor365_11M clst
let new_Euribor365_1Y clst = _new_Euribor365_1Y clst
let new_Euribor365_1Y clst = _new_Euribor365_1Y clst
let new_EURLibor clst = _new_EURLibor clst
let new_EURLibor clst = _new_EURLibor clst
let new_EURLiborSW clst = _new_EURLiborSW clst
let new_EURLiborSW clst = _new_EURLiborSW clst
let new_EURLibor2W clst = _new_EURLibor2W clst
let new_EURLibor2W clst = _new_EURLibor2W clst
let new_EURLibor1M clst = _new_EURLibor1M clst
let new_EURLibor1M clst = _new_EURLibor1M clst
let new_EURLibor2M clst = _new_EURLibor2M clst
let new_EURLibor2M clst = _new_EURLibor2M clst
let new_EURLibor3M clst = _new_EURLibor3M clst
let new_EURLibor3M clst = _new_EURLibor3M clst
let new_EURLibor4M clst = _new_EURLibor4M clst
let new_EURLibor4M clst = _new_EURLibor4M clst
let new_EURLibor5M clst = _new_EURLibor5M clst
let new_EURLibor5M clst = _new_EURLibor5M clst
let new_EURLibor6M clst = _new_EURLibor6M clst
let new_EURLibor6M clst = _new_EURLibor6M clst
let new_EURLibor7M clst = _new_EURLibor7M clst
let new_EURLibor7M clst = _new_EURLibor7M clst
let new_EURLibor8M clst = _new_EURLibor8M clst
let new_EURLibor8M clst = _new_EURLibor8M clst
let new_EURLibor9M clst = _new_EURLibor9M clst
let new_EURLibor9M clst = _new_EURLibor9M clst
let new_EURLibor10M clst = _new_EURLibor10M clst
let new_EURLibor10M clst = _new_EURLibor10M clst
let new_EURLibor11M clst = _new_EURLibor11M clst
let new_EURLibor11M clst = _new_EURLibor11M clst
let new_EURLibor1Y clst = _new_EURLibor1Y clst
let new_EURLibor1Y clst = _new_EURLibor1Y clst
let new_GBPLibor clst = _new_GBPLibor clst
let new_GBPLibor clst = _new_GBPLibor clst
let new_Jibar clst = _new_Jibar clst
let new_Jibar clst = _new_Jibar clst
let new_JPYLibor clst = _new_JPYLibor clst
let new_JPYLibor clst = _new_JPYLibor clst
let new_NZDLibor clst = _new_NZDLibor clst
let new_NZDLibor clst = _new_NZDLibor clst
let new_SEKLibor clst = _new_SEKLibor clst
let new_SEKLibor clst = _new_SEKLibor clst
let new_Tibor clst = _new_Tibor clst
let new_Tibor clst = _new_Tibor clst
let new_TRLibor clst = _new_TRLibor clst
let new_TRLibor clst = _new_TRLibor clst
let new_USDLibor clst = _new_USDLibor clst
let new_USDLibor clst = _new_USDLibor clst
let new_Zibor clst = _new_Zibor clst
let new_Zibor clst = _new_Zibor clst
let new_Aonia clst = _new_Aonia clst
let new_Aonia clst = _new_Aonia clst
let new_Eonia clst = _new_Eonia clst
let new_Eonia clst = _new_Eonia clst
let new_Sonia clst = _new_Sonia clst
let new_Sonia clst = _new_Sonia clst
let new_FedFunds clst = _new_FedFunds clst
let new_FedFunds clst = _new_FedFunds clst
let new_Nzocr clst = _new_Nzocr clst
let new_Nzocr clst = _new_Nzocr clst
let new_EuriborSwapIsdaFixA clst = _new_EuriborSwapIsdaFixA clst
let new_EuriborSwapIsdaFixA clst = _new_EuriborSwapIsdaFixA clst
let new_EuriborSwapIsdaFixA clst = _new_EuriborSwapIsdaFixA clst
let new_EuriborSwapIsdaFixB clst = _new_EuriborSwapIsdaFixB clst
let new_EuriborSwapIsdaFixB clst = _new_EuriborSwapIsdaFixB clst
let new_EuriborSwapIsdaFixB clst = _new_EuriborSwapIsdaFixB clst
let new_EuriborSwapIfrFix clst = _new_EuriborSwapIfrFix clst
let new_EuriborSwapIfrFix clst = _new_EuriborSwapIfrFix clst
let new_EuriborSwapIfrFix clst = _new_EuriborSwapIfrFix clst
let new_EurLiborSwapIsdaFixA clst = _new_EurLiborSwapIsdaFixA clst
let new_EurLiborSwapIsdaFixA clst = _new_EurLiborSwapIsdaFixA clst
let new_EurLiborSwapIsdaFixA clst = _new_EurLiborSwapIsdaFixA clst
let new_EurLiborSwapIsdaFixB clst = _new_EurLiborSwapIsdaFixB clst
let new_EurLiborSwapIsdaFixB clst = _new_EurLiborSwapIsdaFixB clst
let new_EurLiborSwapIsdaFixB clst = _new_EurLiborSwapIsdaFixB clst
let new_EurLiborSwapIfrFix clst = _new_EurLiborSwapIfrFix clst
let new_EurLiborSwapIfrFix clst = _new_EurLiborSwapIfrFix clst
let new_EurLiborSwapIfrFix clst = _new_EurLiborSwapIfrFix clst
let new_Brent clst = _new_Brent clst
let new_Bisection clst = _new_Bisection clst
let new_FalsePosition clst = _new_FalsePosition clst
let new_Ridder clst = _new_Ridder clst
let new_Secant clst = _new_Secant clst
let new_BoundaryConstraint clst = _new_BoundaryConstraint clst
let new_NoConstraint clst = _new_NoConstraint clst
let new_PositiveConstraint clst = _new_PositiveConstraint clst
let new_CompositeConstraint clst = _new_CompositeConstraint clst
let new_NonhomogeneousBoundaryConstraint clst = _new_NonhomogeneousBoundaryConstraint clst
let new_EndCriteria clst = _new_EndCriteria clst
let new_ConjugateGradient clst = _new_ConjugateGradient clst
let new_Simplex clst = _new_Simplex clst
let new_SteepestDescent clst = _new_SteepestDescent clst
let new_BFGS clst = _new_BFGS clst
let new_LevenbergMarquardt clst = _new_LevenbergMarquardt clst
let new_LevenbergMarquardt clst = _new_LevenbergMarquardt clst
let new_LevenbergMarquardt clst = _new_LevenbergMarquardt clst
let new_LevenbergMarquardt clst = _new_LevenbergMarquardt clst
let new_DifferentialEvolution clst = _new_DifferentialEvolution clst
let new_SamplerGaussian clst = _new_SamplerGaussian clst
let new_SamplerGaussian clst = _new_SamplerGaussian clst
let new_SamplerLogNormal clst = _new_SamplerLogNormal clst
let new_SamplerLogNormal clst = _new_SamplerLogNormal clst
let new_SamplerMirrorGaussian clst = _new_SamplerMirrorGaussian clst
let new_SamplerMirrorGaussian clst = _new_SamplerMirrorGaussian clst
let new_ProbabilityBoltzmannDownhill clst = _new_ProbabilityBoltzmannDownhill clst
let new_ProbabilityBoltzmannDownhill clst = _new_ProbabilityBoltzmannDownhill clst
let new_TemperatureExponential clst = _new_TemperatureExponential clst
let new_TemperatureExponential clst = _new_TemperatureExponential clst
let new_ReannealingTrivial clst = _new_ReannealingTrivial clst
let new_GaussianSimulatedAnnealing clst = _new_GaussianSimulatedAnnealing clst
let new_GaussianSimulatedAnnealing clst = _new_GaussianSimulatedAnnealing clst
let new_GaussianSimulatedAnnealing clst = _new_GaussianSimulatedAnnealing clst
let new_GaussianSimulatedAnnealing clst = _new_GaussianSimulatedAnnealing clst
let new_GaussianSimulatedAnnealing clst = _new_GaussianSimulatedAnnealing clst
let new_GaussianSimulatedAnnealing clst = _new_GaussianSimulatedAnnealing clst
let new_GaussianSimulatedAnnealing clst = _new_GaussianSimulatedAnnealing clst
let new_MirrorGaussianSimulatedAnnealing clst = _new_MirrorGaussianSimulatedAnnealing clst
let new_MirrorGaussianSimulatedAnnealing clst = _new_MirrorGaussianSimulatedAnnealing clst
let new_MirrorGaussianSimulatedAnnealing clst = _new_MirrorGaussianSimulatedAnnealing clst
let new_MirrorGaussianSimulatedAnnealing clst = _new_MirrorGaussianSimulatedAnnealing clst
let new_MirrorGaussianSimulatedAnnealing clst = _new_MirrorGaussianSimulatedAnnealing clst
let new_MirrorGaussianSimulatedAnnealing clst = _new_MirrorGaussianSimulatedAnnealing clst
let new_MirrorGaussianSimulatedAnnealing clst = _new_MirrorGaussianSimulatedAnnealing clst
let new_LogNormalSimulatedAnnealing clst = _new_LogNormalSimulatedAnnealing clst
let new_LogNormalSimulatedAnnealing clst = _new_LogNormalSimulatedAnnealing clst
let new_LogNormalSimulatedAnnealing clst = _new_LogNormalSimulatedAnnealing clst
let new_LogNormalSimulatedAnnealing clst = _new_LogNormalSimulatedAnnealing clst
let new_LogNormalSimulatedAnnealing clst = _new_LogNormalSimulatedAnnealing clst
let new_LogNormalSimulatedAnnealing clst = _new_LogNormalSimulatedAnnealing clst
let new_LogNormalSimulatedAnnealing clst = _new_LogNormalSimulatedAnnealing clst
let new_Optimizer clst = _new_Optimizer clst
let new_BlackVolTermStructure clst = _new_BlackVolTermStructure clst
let new_BlackVolTermStructureHandle clst = _new_BlackVolTermStructureHandle clst
let new_BlackVolTermStructureHandle clst = _new_BlackVolTermStructureHandle clst
let new_RelinkableBlackVolTermStructureHandle clst = _new_RelinkableBlackVolTermStructureHandle clst
let new_RelinkableBlackVolTermStructureHandle clst = _new_RelinkableBlackVolTermStructureHandle clst
let new_LocalVolTermStructure clst = _new_LocalVolTermStructure clst
let new_LocalVolTermStructureHandle clst = _new_LocalVolTermStructureHandle clst
let new_LocalVolTermStructureHandle clst = _new_LocalVolTermStructureHandle clst
let new_RelinkableLocalVolTermStructureHandle clst = _new_RelinkableLocalVolTermStructureHandle clst
let new_RelinkableLocalVolTermStructureHandle clst = _new_RelinkableLocalVolTermStructureHandle clst
let new_OptionletVolatilityStructure clst = _new_OptionletVolatilityStructure clst
let new_OptionletVolatilityStructureHandle clst = _new_OptionletVolatilityStructureHandle clst
let new_OptionletVolatilityStructureHandle clst = _new_OptionletVolatilityStructureHandle clst
let new_RelinkableOptionletVolatilityStructureHandle clst = _new_RelinkableOptionletVolatilityStructureHandle clst
let new_RelinkableOptionletVolatilityStructureHandle clst = _new_RelinkableOptionletVolatilityStructureHandle clst
let new_SwaptionVolatilityStructure clst = _new_SwaptionVolatilityStructure clst
let new_SwaptionVolatilityStructureHandle clst = _new_SwaptionVolatilityStructureHandle clst
let new_SwaptionVolatilityStructureHandle clst = _new_SwaptionVolatilityStructureHandle clst
let new_RelinkableSwaptionVolatilityStructureHandle clst = _new_RelinkableSwaptionVolatilityStructureHandle clst
let new_RelinkableSwaptionVolatilityStructureHandle clst = _new_RelinkableSwaptionVolatilityStructureHandle clst
let new_BlackConstantVol clst = _new_BlackConstantVol clst
let new_BlackConstantVol clst = _new_BlackConstantVol clst
let new_BlackConstantVol clst = _new_BlackConstantVol clst
let new_BlackConstantVol clst = _new_BlackConstantVol clst
let new_BlackVarianceCurve clst = _new_BlackVarianceCurve clst
let new_BlackVarianceCurve clst = _new_BlackVarianceCurve clst
let new_BlackVarianceSurface clst = _new_BlackVarianceSurface clst
let new_BlackVarianceSurface clst = _new_BlackVarianceSurface clst
let new_BlackVarianceSurface clst = _new_BlackVarianceSurface clst
let new_BlackVarianceSurface clst = _new_BlackVarianceSurface clst
let new_LocalConstantVol clst = _new_LocalConstantVol clst
let new_LocalConstantVol clst = _new_LocalConstantVol clst
let new_LocalConstantVol clst = _new_LocalConstantVol clst
let new_LocalConstantVol clst = _new_LocalConstantVol clst
let new_LocalVolSurface clst = _new_LocalVolSurface clst
let new_LocalVolSurface clst = _new_LocalVolSurface clst
let new_ConstantOptionletVolatility clst = _new_ConstantOptionletVolatility clst
let new_ConstantOptionletVolatility clst = _new_ConstantOptionletVolatility clst
let new_ConstantOptionletVolatility clst = _new_ConstantOptionletVolatility clst
let new_ConstantOptionletVolatility clst = _new_ConstantOptionletVolatility clst
let new_ConstantOptionletVolatility clst = _new_ConstantOptionletVolatility clst
let new_ConstantOptionletVolatility clst = _new_ConstantOptionletVolatility clst
let new_ConstantOptionletVolatility clst = _new_ConstantOptionletVolatility clst
let new_ConstantOptionletVolatility clst = _new_ConstantOptionletVolatility clst
let new_ConstantOptionletVolatility clst = _new_ConstantOptionletVolatility clst
let new_ConstantOptionletVolatility clst = _new_ConstantOptionletVolatility clst
let new_ConstantOptionletVolatility clst = _new_ConstantOptionletVolatility clst
let new_ConstantOptionletVolatility clst = _new_ConstantOptionletVolatility clst
let new_ConstantSwaptionVolatility clst = _new_ConstantSwaptionVolatility clst
let new_ConstantSwaptionVolatility clst = _new_ConstantSwaptionVolatility clst
let new_ConstantSwaptionVolatility clst = _new_ConstantSwaptionVolatility clst
let new_ConstantSwaptionVolatility clst = _new_ConstantSwaptionVolatility clst
let new_ConstantSwaptionVolatility clst = _new_ConstantSwaptionVolatility clst
let new_ConstantSwaptionVolatility clst = _new_ConstantSwaptionVolatility clst
let new_ConstantSwaptionVolatility clst = _new_ConstantSwaptionVolatility clst
let new_ConstantSwaptionVolatility clst = _new_ConstantSwaptionVolatility clst
let new_ConstantSwaptionVolatility clst = _new_ConstantSwaptionVolatility clst
let new_ConstantSwaptionVolatility clst = _new_ConstantSwaptionVolatility clst
let new_ConstantSwaptionVolatility clst = _new_ConstantSwaptionVolatility clst
let new_ConstantSwaptionVolatility clst = _new_ConstantSwaptionVolatility clst
let new_SwaptionVolatilityMatrix clst = _new_SwaptionVolatilityMatrix clst
let new_SwaptionVolatilityMatrix clst = _new_SwaptionVolatilityMatrix clst
let new_SwaptionVolatilityMatrix clst = _new_SwaptionVolatilityMatrix clst
let new_SwaptionVolatilityMatrix clst = _new_SwaptionVolatilityMatrix clst
let new_SwaptionVolatilityMatrix clst = _new_SwaptionVolatilityMatrix clst
let new_SwaptionVolatilityMatrix clst = _new_SwaptionVolatilityMatrix clst
let new_SwaptionVolatilityMatrix clst = _new_SwaptionVolatilityMatrix clst
let new_SwaptionVolatilityMatrix clst = _new_SwaptionVolatilityMatrix clst
let new_SwaptionVolatilityMatrix clst = _new_SwaptionVolatilityMatrix clst
let new_SwaptionVolatilityMatrix clst = _new_SwaptionVolatilityMatrix clst
let new_SwaptionVolatilityMatrix clst = _new_SwaptionVolatilityMatrix clst
let new_SwaptionVolatilityMatrix clst = _new_SwaptionVolatilityMatrix clst
let new_SwaptionVolCube1 clst = _new_SwaptionVolCube1 clst
let new_SwaptionVolCube1 clst = _new_SwaptionVolCube1 clst
let new_SwaptionVolCube1 clst = _new_SwaptionVolCube1 clst
let new_SwaptionVolCube1 clst = _new_SwaptionVolCube1 clst
let new_SwaptionVolCube2 clst = _new_SwaptionVolCube2 clst
let new_StochasticProcess clst = _new_StochasticProcess clst
let new_StochasticProcessVector clst = _new_StochasticProcessVector clst
let new_StochasticProcessVector clst = _new_StochasticProcessVector clst
let new_StochasticProcessVector clst = _new_StochasticProcessVector clst
let new_StochasticProcessVector clst = _new_StochasticProcessVector clst
let new_GeneralizedBlackScholesProcess clst = _new_GeneralizedBlackScholesProcess clst
let new_BlackScholesProcess clst = _new_BlackScholesProcess clst
let new_BlackScholesMertonProcess clst = _new_BlackScholesMertonProcess clst
let new_BlackProcess clst = _new_BlackProcess clst
let new_GarmanKohlagenProcess clst = _new_GarmanKohlagenProcess clst
let new_Merton76Process clst = _new_Merton76Process clst
let new_StochasticProcessArray clst = _new_StochasticProcessArray clst
let new_GeometricBrownianMotionProcess clst = _new_GeometricBrownianMotionProcess clst
let new_VarianceGammaProcess clst = _new_VarianceGammaProcess clst
let new_HestonProcess clst = _new_HestonProcess clst
let new_BatesProcess clst = _new_BatesProcess clst
let new_HullWhiteProcess clst = _new_HullWhiteProcess clst
let new_HullWhiteForwardProcess clst = _new_HullWhiteForwardProcess clst
let new_GsrProcess clst = _new_GsrProcess clst
let new_GsrProcess clst = _new_GsrProcess clst
let new_PricingEngine clst = _new_PricingEngine clst
let new_Instrument clst = _new_Instrument clst
let new_InstrumentVector clst = _new_InstrumentVector clst
let new_InstrumentVector clst = _new_InstrumentVector clst
let new_InstrumentVector clst = _new_InstrumentVector clst
let new_InstrumentVector clst = _new_InstrumentVector clst
let new_Stock clst = _new_Stock clst
let new_CompositeInstrument clst = _new_CompositeInstrument clst
let new_DateGeneration clst = _new_DateGeneration clst
let new_Schedule clst = _new_Schedule clst
let new_Schedule clst = _new_Schedule clst
let new_Schedule clst = _new_Schedule clst
let new_Schedule clst = _new_Schedule clst
let new_Schedule clst = _new_Schedule clst
let new_Schedule clst = _new_Schedule clst
let new_Schedule clst = _new_Schedule clst
let new_CashFlow clst = _new_CashFlow clst
let new_Leg clst = _new_Leg clst
let new_Leg clst = _new_Leg clst
let new_Leg clst = _new_Leg clst
let new_Leg clst = _new_Leg clst
let new_SimpleCashFlow clst = _new_SimpleCashFlow clst
let new_Redemption clst = _new_Redemption clst
let new_AmortizingPayment clst = _new_AmortizingPayment clst
let new_FixedRateCoupon clst = _new_FixedRateCoupon clst
let new_FixedRateCoupon clst = _new_FixedRateCoupon clst
let new_FixedRateCoupon clst = _new_FixedRateCoupon clst
let new_FixedRateCoupon clst = _new_FixedRateCoupon clst
let new_FloatingRateCouponPricer clst = _new_FloatingRateCouponPricer clst
let new_CappedFlooredCoupon clst = _new_CappedFlooredCoupon clst
let new_CappedFlooredCoupon clst = _new_CappedFlooredCoupon clst
let new_CappedFlooredCoupon clst = _new_CappedFlooredCoupon clst
let new_IborCoupon clst = _new_IborCoupon clst
let new_IborCoupon clst = _new_IborCoupon clst
let new_IborCoupon clst = _new_IborCoupon clst
let new_IborCoupon clst = _new_IborCoupon clst
let new_IborCoupon clst = _new_IborCoupon clst
let new_IborCoupon clst = _new_IborCoupon clst
let new_BlackIborCouponPricer clst = _new_BlackIborCouponPricer clst
let new_BlackIborCouponPricer clst = _new_BlackIborCouponPricer clst
let new_CmsCoupon clst = _new_CmsCoupon clst
let new_CmsCoupon clst = _new_CmsCoupon clst
let new_CmsCoupon clst = _new_CmsCoupon clst
let new_CmsCoupon clst = _new_CmsCoupon clst
let new_CmsCoupon clst = _new_CmsCoupon clst
let new_CmsCoupon clst = _new_CmsCoupon clst
let new_CmsCoupon clst = _new_CmsCoupon clst
let new_AnalyticHaganPricer clst = _new_AnalyticHaganPricer clst
let new_NumericHaganPricer clst = _new_NumericHaganPricer clst
let new_NumericHaganPricer clst = _new_NumericHaganPricer clst
let new_NumericHaganPricer clst = _new_NumericHaganPricer clst
let new_NumericHaganPricer clst = _new_NumericHaganPricer clst
let new_CappedFlooredCmsCoupon clst = _new_CappedFlooredCmsCoupon clst
let new_CappedFlooredCmsCoupon clst = _new_CappedFlooredCmsCoupon clst
let new_CappedFlooredCmsCoupon clst = _new_CappedFlooredCmsCoupon clst
let new_CappedFlooredCmsCoupon clst = _new_CappedFlooredCmsCoupon clst
let new_CappedFlooredCmsCoupon clst = _new_CappedFlooredCmsCoupon clst
let new_CappedFlooredCmsCoupon clst = _new_CappedFlooredCmsCoupon clst
let new_CappedFlooredCmsCoupon clst = _new_CappedFlooredCmsCoupon clst
let new_CappedFlooredCmsCoupon clst = _new_CappedFlooredCmsCoupon clst
let new_CappedFlooredCmsCoupon clst = _new_CappedFlooredCmsCoupon clst
let new_LinearTsrPricer clst = _new_LinearTsrPricer clst
let new_LinearTsrPricer clst = _new_LinearTsrPricer clst
let new_LinearTsrPricer clst = _new_LinearTsrPricer clst
let new_Duration clst = _new_Duration clst
let new_CalibrationHelper clst = _new_CalibrationHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_SwaptionHelper clst = _new_SwaptionHelper clst
let new_CapHelper clst = _new_CapHelper clst
let new_CapHelper clst = _new_CapHelper clst
let new_HestonModelHelper clst = _new_HestonModelHelper clst
let new_HestonModelHelper clst = _new_HestonModelHelper clst
let new_CalibrationHelperVector clst = _new_CalibrationHelperVector clst
let new_CalibrationHelperVector clst = _new_CalibrationHelperVector clst
let new_CalibrationHelperVector clst = _new_CalibrationHelperVector clst
let new_CalibrationHelperVector clst = _new_CalibrationHelperVector clst
let new_CalibratedModel clst = _new_CalibratedModel clst
let new_CalibratedModelHandle clst = _new_CalibratedModelHandle clst
let new_CalibratedModelHandle clst = _new_CalibratedModelHandle clst
let new_RelinkableCalibratedModelHandle clst = _new_RelinkableCalibratedModelHandle clst
let new_RelinkableCalibratedModelHandle clst = _new_RelinkableCalibratedModelHandle clst
let new_TimeGrid clst = _new_TimeGrid clst
let new_TimeGrid clst = _new_TimeGrid clst
let new_TimeGrid clst = _new_TimeGrid clst
let new_TimeGrid clst = _new_TimeGrid clst
let new_Parameter clst = _new_Parameter clst
let new_ConstantParameter clst = _new_ConstantParameter clst
let new_ConstantParameter clst = _new_ConstantParameter clst
let new_NullParameter clst = _new_NullParameter clst
let new_PiecewiseConstantParameter clst = _new_PiecewiseConstantParameter clst
let new_PiecewiseConstantParameter clst = _new_PiecewiseConstantParameter clst
let new_Barrier clst = _new_Barrier clst
let new_DoubleBarrier clst = _new_DoubleBarrier clst
let new_Payoff clst = _new_Payoff clst
let new_VanillaOption clst = _new_VanillaOption clst
let new_EuropeanOption clst = _new_EuropeanOption clst
let new_ForwardVanillaOption clst = _new_ForwardVanillaOption clst
let new_QuantoVanillaOption clst = _new_QuantoVanillaOption clst
let new_QuantoForwardVanillaOption clst = _new_QuantoForwardVanillaOption clst
let new_MultiAssetOption clst = _new_MultiAssetOption clst
let new_AnalyticEuropeanEngine clst = _new_AnalyticEuropeanEngine clst
let new_HestonModel clst = _new_HestonModel clst
let new_PiecewiseTimeDependentHestonModel clst = _new_PiecewiseTimeDependentHestonModel clst
let new_AnalyticHestonEngine clst = _new_AnalyticHestonEngine clst
let new_AnalyticHestonEngine clst = _new_AnalyticHestonEngine clst
let new_AnalyticHestonEngine clst = _new_AnalyticHestonEngine clst
let new_AnalyticPTDHestonEngine clst = _new_AnalyticPTDHestonEngine clst
let new_AnalyticPTDHestonEngine clst = _new_AnalyticPTDHestonEngine clst
let new_AnalyticPTDHestonEngine clst = _new_AnalyticPTDHestonEngine clst
let new_BatesModel clst = _new_BatesModel clst
let new_BatesEngine clst = _new_BatesEngine clst
let new_BatesEngine clst = _new_BatesEngine clst
let new_BatesEngine clst = _new_BatesEngine clst
let new_IntegralEngine clst = _new_IntegralEngine clst
let new_FDBermudanEngine clst = _new_FDBermudanEngine clst
let new_FDBermudanEngine clst = _new_FDBermudanEngine clst
let new_FDBermudanEngine clst = _new_FDBermudanEngine clst
let new_FDBermudanEngine clst = _new_FDBermudanEngine clst
let new_FDEuropeanEngine clst = _new_FDEuropeanEngine clst
let new_FDEuropeanEngine clst = _new_FDEuropeanEngine clst
let new_FDEuropeanEngine clst = _new_FDEuropeanEngine clst
let new_FDEuropeanEngine clst = _new_FDEuropeanEngine clst
let new_BinomialVanillaEngine clst = _new_BinomialVanillaEngine clst
let new_MCEuropeanEngine clst = _new_MCEuropeanEngine clst
let new_MCEuropeanEngine clst = _new_MCEuropeanEngine clst
let new_MCEuropeanEngine clst = _new_MCEuropeanEngine clst
let new_MCEuropeanEngine clst = _new_MCEuropeanEngine clst
let new_MCEuropeanEngine clst = _new_MCEuropeanEngine clst
let new_MCEuropeanEngine clst = _new_MCEuropeanEngine clst
let new_MCEuropeanEngine clst = _new_MCEuropeanEngine clst
let new_MCEuropeanEngine clst = _new_MCEuropeanEngine clst
let new_MCEuropeanEngine clst = _new_MCEuropeanEngine clst
let new_FDAmericanEngine clst = _new_FDAmericanEngine clst
let new_FDAmericanEngine clst = _new_FDAmericanEngine clst
let new_FDAmericanEngine clst = _new_FDAmericanEngine clst
let new_FDAmericanEngine clst = _new_FDAmericanEngine clst
let new_FdBlackScholesVanillaEngine clst = _new_FdBlackScholesVanillaEngine clst
let new_FdBlackScholesVanillaEngine clst = _new_FdBlackScholesVanillaEngine clst
let new_FdBlackScholesVanillaEngine clst = _new_FdBlackScholesVanillaEngine clst
let new_FdBlackScholesVanillaEngine clst = _new_FdBlackScholesVanillaEngine clst
let new_FdBatesVanillaEngine clst = _new_FdBatesVanillaEngine clst
let new_FdBatesVanillaEngine clst = _new_FdBatesVanillaEngine clst
let new_FdBatesVanillaEngine clst = _new_FdBatesVanillaEngine clst
let new_FdBatesVanillaEngine clst = _new_FdBatesVanillaEngine clst
let new_FdBatesVanillaEngine clst = _new_FdBatesVanillaEngine clst
let new_ContinuousArithmeticAsianLevyEngine clst = _new_ContinuousArithmeticAsianLevyEngine clst
let new_FdBlackScholesAsianEngine clst = _new_FdBlackScholesAsianEngine clst
let new_FDShoutEngine clst = _new_FDShoutEngine clst
let new_FDShoutEngine clst = _new_FDShoutEngine clst
let new_FDShoutEngine clst = _new_FDShoutEngine clst
let new_FDShoutEngine clst = _new_FDShoutEngine clst
let new_BaroneAdesiWhaleyEngine clst = _new_BaroneAdesiWhaleyEngine clst
let new_BjerksundStenslandEngine clst = _new_BjerksundStenslandEngine clst
let new_AnalyticDigitalAmericanEngine clst = _new_AnalyticDigitalAmericanEngine clst
let new_AnalyticDigitalAmericanKOEngine clst = _new_AnalyticDigitalAmericanKOEngine clst
let new_DividendVanillaOption clst = _new_DividendVanillaOption clst
let new_AnalyticDividendEuropeanEngine clst = _new_AnalyticDividendEuropeanEngine clst
let new_FDDividendEuropeanEngine clst = _new_FDDividendEuropeanEngine clst
let new_FDDividendEuropeanEngine clst = _new_FDDividendEuropeanEngine clst
let new_FDDividendEuropeanEngine clst = _new_FDDividendEuropeanEngine clst
let new_FDDividendEuropeanEngine clst = _new_FDDividendEuropeanEngine clst
let new_FDDividendAmericanEngine clst = _new_FDDividendAmericanEngine clst
let new_FDDividendAmericanEngine clst = _new_FDDividendAmericanEngine clst
let new_FDDividendAmericanEngine clst = _new_FDDividendAmericanEngine clst
let new_FDDividendAmericanEngine clst = _new_FDDividendAmericanEngine clst
let new_BarrierOption clst = _new_BarrierOption clst
let new_AnalyticBarrierEngine clst = _new_AnalyticBarrierEngine clst
let new_MCBarrierEngine clst = _new_MCBarrierEngine clst
let new_MCBarrierEngine clst = _new_MCBarrierEngine clst
let new_MCBarrierEngine clst = _new_MCBarrierEngine clst
let new_MCBarrierEngine clst = _new_MCBarrierEngine clst
let new_MCBarrierEngine clst = _new_MCBarrierEngine clst
let new_MCBarrierEngine clst = _new_MCBarrierEngine clst
let new_MCBarrierEngine clst = _new_MCBarrierEngine clst
let new_MCBarrierEngine clst = _new_MCBarrierEngine clst
let new_MCBarrierEngine clst = _new_MCBarrierEngine clst
let new_MCBarrierEngine clst = _new_MCBarrierEngine clst
let new_FdmSchemeDesc clst = _new_FdmSchemeDesc clst
let new_FdBlackScholesBarrierEngine clst = _new_FdBlackScholesBarrierEngine clst
let new_FdBlackScholesBarrierEngine clst = _new_FdBlackScholesBarrierEngine clst
let new_FdBlackScholesBarrierEngine clst = _new_FdBlackScholesBarrierEngine clst
let new_FdBlackScholesBarrierEngine clst = _new_FdBlackScholesBarrierEngine clst
let new_FdBlackScholesBarrierEngine clst = _new_FdBlackScholesBarrierEngine clst
let new_FdBlackScholesBarrierEngine clst = _new_FdBlackScholesBarrierEngine clst
let new_FdBlackScholesBarrierEngine clst = _new_FdBlackScholesBarrierEngine clst
let new_AnalyticBinaryBarrierEngine clst = _new_AnalyticBinaryBarrierEngine clst
let new_BinomialBarrierEngine clst = _new_BinomialBarrierEngine clst
let new_BinomialBarrierEngine clst = _new_BinomialBarrierEngine clst
let new_ForwardEuropeanEngine clst = _new_ForwardEuropeanEngine clst
let new_QuantoEuropeanEngine clst = _new_QuantoEuropeanEngine clst
let new_QuantoForwardEuropeanEngine clst = _new_QuantoForwardEuropeanEngine clst
let new_BlackCalculator clst = _new_BlackCalculator clst
let new_BlackCalculator clst = _new_BlackCalculator clst
let new_Average clst = _new_Average clst
let new_ContinuousAveragingAsianOption clst = _new_ContinuousAveragingAsianOption clst
let new_DiscreteAveragingAsianOption clst = _new_DiscreteAveragingAsianOption clst
let new_AnalyticContinuousGeometricAveragePriceAsianEngine clst = _new_AnalyticContinuousGeometricAveragePriceAsianEngine clst
let new_AnalyticDiscreteGeometricAveragePriceAsianEngine clst = _new_AnalyticDiscreteGeometricAveragePriceAsianEngine clst
let new_AnalyticDiscreteGeometricAverageStrikeAsianEngine clst = _new_AnalyticDiscreteGeometricAverageStrikeAsianEngine clst
let new_MCDiscreteArithmeticAPEngine clst = _new_MCDiscreteArithmeticAPEngine clst
let new_MCDiscreteArithmeticAPEngine clst = _new_MCDiscreteArithmeticAPEngine clst
let new_MCDiscreteArithmeticAPEngine clst = _new_MCDiscreteArithmeticAPEngine clst
let new_MCDiscreteArithmeticAPEngine clst = _new_MCDiscreteArithmeticAPEngine clst
let new_MCDiscreteArithmeticAPEngine clst = _new_MCDiscreteArithmeticAPEngine clst
let new_MCDiscreteArithmeticAPEngine clst = _new_MCDiscreteArithmeticAPEngine clst
let new_MCDiscreteArithmeticAPEngine clst = _new_MCDiscreteArithmeticAPEngine clst
let new_MCDiscreteArithmeticAPEngine clst = _new_MCDiscreteArithmeticAPEngine clst
let new_MCDiscreteArithmeticASEngine clst = _new_MCDiscreteArithmeticASEngine clst
let new_MCDiscreteArithmeticASEngine clst = _new_MCDiscreteArithmeticASEngine clst
let new_MCDiscreteArithmeticASEngine clst = _new_MCDiscreteArithmeticASEngine clst
let new_MCDiscreteArithmeticASEngine clst = _new_MCDiscreteArithmeticASEngine clst
let new_MCDiscreteArithmeticASEngine clst = _new_MCDiscreteArithmeticASEngine clst
let new_MCDiscreteArithmeticASEngine clst = _new_MCDiscreteArithmeticASEngine clst
let new_MCDiscreteArithmeticASEngine clst = _new_MCDiscreteArithmeticASEngine clst
let new_MCDiscreteGeometricAPEngine clst = _new_MCDiscreteGeometricAPEngine clst
let new_MCDiscreteGeometricAPEngine clst = _new_MCDiscreteGeometricAPEngine clst
let new_MCDiscreteGeometricAPEngine clst = _new_MCDiscreteGeometricAPEngine clst
let new_MCDiscreteGeometricAPEngine clst = _new_MCDiscreteGeometricAPEngine clst
let new_MCDiscreteGeometricAPEngine clst = _new_MCDiscreteGeometricAPEngine clst
let new_MCDiscreteGeometricAPEngine clst = _new_MCDiscreteGeometricAPEngine clst
let new_MCDiscreteGeometricAPEngine clst = _new_MCDiscreteGeometricAPEngine clst
let new_VarianceGammaEngine clst = _new_VarianceGammaEngine clst
let new_FFTVarianceGammaEngine clst = _new_FFTVarianceGammaEngine clst
let new_FFTVarianceGammaEngine clst = _new_FFTVarianceGammaEngine clst
let new_DoubleBarrierOption clst = _new_DoubleBarrierOption clst
let new_QuantoDoubleBarrierOption clst = _new_QuantoDoubleBarrierOption clst
let new_AnalyticDoubleBarrierEngine clst = _new_AnalyticDoubleBarrierEngine clst
let new_AnalyticDoubleBarrierEngine clst = _new_AnalyticDoubleBarrierEngine clst
let new_WulinYongDoubleBarrierEngine clst = _new_WulinYongDoubleBarrierEngine clst
let new_WulinYongDoubleBarrierEngine clst = _new_WulinYongDoubleBarrierEngine clst
let new_DeltaVolQuote clst = _new_DeltaVolQuote clst
let new_DeltaVolQuote clst = _new_DeltaVolQuote clst
let new_DeltaVolQuoteHandle clst = _new_DeltaVolQuoteHandle clst
let new_DeltaVolQuoteHandle clst = _new_DeltaVolQuoteHandle clst
let new_RelinkableDeltaVolQuoteHandle clst = _new_RelinkableDeltaVolQuoteHandle clst
let new_RelinkableDeltaVolQuoteHandle clst = _new_RelinkableDeltaVolQuoteHandle clst
let new_VannaVolgaDoubleBarrierEngine clst = _new_VannaVolgaDoubleBarrierEngine clst
let new_VannaVolgaDoubleBarrierEngine clst = _new_VannaVolgaDoubleBarrierEngine clst
let new_VannaVolgaDoubleBarrierEngine clst = _new_VannaVolgaDoubleBarrierEngine clst
let new_VannaVolgaDoubleBarrierEngine clst = _new_VannaVolgaDoubleBarrierEngine clst
let new_VannaVolgaDoubleBarrierEngine clst = _new_VannaVolgaDoubleBarrierEngine clst
let new_AnalyticDoubleBarrierBinaryEngine clst = _new_AnalyticDoubleBarrierBinaryEngine clst
let new_BinomialDoubleBarrierEngine clst = _new_BinomialDoubleBarrierEngine clst
let new_PlainVanillaPayoff clst = _new_PlainVanillaPayoff clst
let new_PercentageStrikePayoff clst = _new_PercentageStrikePayoff clst
let new_CashOrNothingPayoff clst = _new_CashOrNothingPayoff clst
let new_AssetOrNothingPayoff clst = _new_AssetOrNothingPayoff clst
let new_SuperSharePayoff clst = _new_SuperSharePayoff clst
let new_GapPayoff clst = _new_GapPayoff clst
let new_BasketPayoff clst = _new_BasketPayoff clst
let new_MinBasketPayoff clst = _new_MinBasketPayoff clst
let new_MaxBasketPayoff clst = _new_MaxBasketPayoff clst
let new_AverageBasketPayoff clst = _new_AverageBasketPayoff clst
let new_AverageBasketPayoff clst = _new_AverageBasketPayoff clst
let new_BasketOption clst = _new_BasketOption clst
let new_MCEuropeanBasketEngine clst = _new_MCEuropeanBasketEngine clst
let new_MCEuropeanBasketEngine clst = _new_MCEuropeanBasketEngine clst
let new_MCEuropeanBasketEngine clst = _new_MCEuropeanBasketEngine clst
let new_MCEuropeanBasketEngine clst = _new_MCEuropeanBasketEngine clst
let new_MCEuropeanBasketEngine clst = _new_MCEuropeanBasketEngine clst
let new_MCEuropeanBasketEngine clst = _new_MCEuropeanBasketEngine clst
let new_MCEuropeanBasketEngine clst = _new_MCEuropeanBasketEngine clst
let new_MCEuropeanBasketEngine clst = _new_MCEuropeanBasketEngine clst
let new_MCEuropeanBasketEngine clst = _new_MCEuropeanBasketEngine clst
let new_MCAmericanBasketEngine clst = _new_MCAmericanBasketEngine clst
let new_MCAmericanBasketEngine clst = _new_MCAmericanBasketEngine clst
let new_MCAmericanBasketEngine clst = _new_MCAmericanBasketEngine clst
let new_MCAmericanBasketEngine clst = _new_MCAmericanBasketEngine clst
let new_MCAmericanBasketEngine clst = _new_MCAmericanBasketEngine clst
let new_MCAmericanBasketEngine clst = _new_MCAmericanBasketEngine clst
let new_MCAmericanBasketEngine clst = _new_MCAmericanBasketEngine clst
let new_MCAmericanBasketEngine clst = _new_MCAmericanBasketEngine clst
let new_MCAmericanBasketEngine clst = _new_MCAmericanBasketEngine clst
let new_StulzEngine clst = _new_StulzEngine clst
let new_EverestOption clst = _new_EverestOption clst
let new_MCEverestEngine clst = _new_MCEverestEngine clst
let new_MCEverestEngine clst = _new_MCEverestEngine clst
let new_MCEverestEngine clst = _new_MCEverestEngine clst
let new_MCEverestEngine clst = _new_MCEverestEngine clst
let new_MCEverestEngine clst = _new_MCEverestEngine clst
let new_MCEverestEngine clst = _new_MCEverestEngine clst
let new_MCEverestEngine clst = _new_MCEverestEngine clst
let new_MCEverestEngine clst = _new_MCEverestEngine clst
let new_MCEverestEngine clst = _new_MCEverestEngine clst
let new_HimalayaOption clst = _new_HimalayaOption clst
let new_MCHimalayaEngine clst = _new_MCHimalayaEngine clst
let new_MCHimalayaEngine clst = _new_MCHimalayaEngine clst
let new_MCHimalayaEngine clst = _new_MCHimalayaEngine clst
let new_MCHimalayaEngine clst = _new_MCHimalayaEngine clst
let new_MCHimalayaEngine clst = _new_MCHimalayaEngine clst
let new_MCHimalayaEngine clst = _new_MCHimalayaEngine clst
let new_MCHimalayaEngine clst = _new_MCHimalayaEngine clst
let new_BlackDeltaCalculator clst = _new_BlackDeltaCalculator clst
let new_CallabilityPrice clst = _new_CallabilityPrice clst
let new_Callability clst = _new_Callability clst
let new_SoftCallability clst = _new_SoftCallability clst
let new_CallabilitySchedule clst = _new_CallabilitySchedule clst
let new_CallabilitySchedule clst = _new_CallabilitySchedule clst
let new_CallabilitySchedule clst = _new_CallabilitySchedule clst
let new_CallabilitySchedule clst = _new_CallabilitySchedule clst
let new_Seasonality clst = _new_Seasonality clst
let new_MultiplicativePriceSeasonalityPtr clst = _new_MultiplicativePriceSeasonalityPtr clst
let new_YoYInflationTermStructure clst = _new_YoYInflationTermStructure clst
let new_YoYInflationTermStructureHandle clst = _new_YoYInflationTermStructureHandle clst
let new_YoYInflationTermStructureHandle clst = _new_YoYInflationTermStructureHandle clst
let new_RelinkableYoYInflationTermStructureHandle clst = _new_RelinkableYoYInflationTermStructureHandle clst
let new_RelinkableYoYInflationTermStructureHandle clst = _new_RelinkableYoYInflationTermStructureHandle clst
let new_ZeroInflationTermStructure clst = _new_ZeroInflationTermStructure clst
let new_ZeroInflationTermStructureHandle clst = _new_ZeroInflationTermStructureHandle clst
let new_ZeroInflationTermStructureHandle clst = _new_ZeroInflationTermStructureHandle clst
let new_RelinkableZeroInflationTermStructureHandle clst = _new_RelinkableZeroInflationTermStructureHandle clst
let new_RelinkableZeroInflationTermStructureHandle clst = _new_RelinkableZeroInflationTermStructureHandle clst
let new_CustomRegion clst = _new_CustomRegion clst
let new_ZeroInflationIndex clst = _new_ZeroInflationIndex clst
let new_ZeroInflationIndex clst = _new_ZeroInflationIndex clst
let new_EUHICP clst = _new_EUHICP clst
let new_EUHICP clst = _new_EUHICP clst
let new_EUHICPXT clst = _new_EUHICPXT clst
let new_EUHICPXT clst = _new_EUHICPXT clst
let new_FRHICP clst = _new_FRHICP clst
let new_FRHICP clst = _new_FRHICP clst
let new_UKRPI clst = _new_UKRPI clst
let new_UKRPI clst = _new_UKRPI clst
let new_USCPI clst = _new_USCPI clst
let new_USCPI clst = _new_USCPI clst
let new_ZACPI clst = _new_ZACPI clst
let new_ZACPI clst = _new_ZACPI clst
let new_YYEUHICP clst = _new_YYEUHICP clst
let new_YYEUHICP clst = _new_YYEUHICP clst
let new_YYEUHICPXT clst = _new_YYEUHICPXT clst
let new_YYEUHICPXT clst = _new_YYEUHICPXT clst
let new_YYFRHICP clst = _new_YYFRHICP clst
let new_YYFRHICP clst = _new_YYFRHICP clst
let new_YYUKRPI clst = _new_YYUKRPI clst
let new_YYUKRPI clst = _new_YYUKRPI clst
let new_YYUSCPI clst = _new_YYUSCPI clst
let new_YYUSCPI clst = _new_YYUSCPI clst
let new_YYZACPI clst = _new_YYZACPI clst
let new_YYZACPI clst = _new_YYZACPI clst
let new_CPI clst = _new_CPI clst
let new_ZeroHelper clst = _new_ZeroHelper clst
let new_YoYHelper clst = _new_YoYHelper clst
let new_ZeroHelperVector clst = _new_ZeroHelperVector clst
let new_ZeroHelperVector clst = _new_ZeroHelperVector clst
let new_ZeroHelperVector clst = _new_ZeroHelperVector clst
let new_ZeroHelperVector clst = _new_ZeroHelperVector clst
let new_YoYHelperVector clst = _new_YoYHelperVector clst
let new_YoYHelperVector clst = _new_YoYHelperVector clst
let new_YoYHelperVector clst = _new_YoYHelperVector clst
let new_YoYHelperVector clst = _new_YoYHelperVector clst
let new_ZeroCouponInflationSwapHelper clst = _new_ZeroCouponInflationSwapHelper clst
let new_YearOnYearInflationSwapHelper clst = _new_YearOnYearInflationSwapHelper clst
let new_PiecewiseZeroInflation clst = _new_PiecewiseZeroInflation clst
let new_PiecewiseZeroInflation clst = _new_PiecewiseZeroInflation clst
let new_PiecewiseZeroInflation clst = _new_PiecewiseZeroInflation clst
let new_PiecewiseYoYInflation clst = _new_PiecewiseYoYInflation clst
let new_PiecewiseYoYInflation clst = _new_PiecewiseYoYInflation clst
let new_PiecewiseYoYInflation clst = _new_PiecewiseYoYInflation clst
let new_ZeroCouponInflationSwap clst = _new_ZeroCouponInflationSwap clst
let new_ZeroCouponInflationSwap clst = _new_ZeroCouponInflationSwap clst
let new_ZeroCouponInflationSwap clst = _new_ZeroCouponInflationSwap clst
let new_ZeroCouponInflationSwap clst = _new_ZeroCouponInflationSwap clst
let new_YearOnYearInflationSwap clst = _new_YearOnYearInflationSwap clst
let new_YearOnYearInflationSwap clst = _new_YearOnYearInflationSwap clst
let new_YoYInflationCapFloor clst = _new_YoYInflationCapFloor clst
let new_YoYInflationCap clst = _new_YoYInflationCap clst
let new_YoYInflationFloor clst = _new_YoYInflationFloor clst
let new_YoYInflationCollar clst = _new_YoYInflationCollar clst
let new_ShortRateModel clst = _new_ShortRateModel clst
let new_ShortRateModelHandle clst = _new_ShortRateModelHandle clst
let new_ShortRateModelHandle clst = _new_ShortRateModelHandle clst
let new_RelinkableShortRateModelHandle clst = _new_RelinkableShortRateModelHandle clst
let new_RelinkableShortRateModelHandle clst = _new_RelinkableShortRateModelHandle clst
let new_Vasicek clst = _new_Vasicek clst
let new_Vasicek clst = _new_Vasicek clst
let new_Vasicek clst = _new_Vasicek clst
let new_Vasicek clst = _new_Vasicek clst
let new_Vasicek clst = _new_Vasicek clst
let new_Vasicek clst = _new_Vasicek clst
let new_HullWhite clst = _new_HullWhite clst
let new_HullWhite clst = _new_HullWhite clst
let new_HullWhite clst = _new_HullWhite clst
let new_BlackKarasinski clst = _new_BlackKarasinski clst
let new_BlackKarasinski clst = _new_BlackKarasinski clst
let new_BlackKarasinski clst = _new_BlackKarasinski clst
let new_G2 clst = _new_G2 clst
let new_G2 clst = _new_G2 clst
let new_G2 clst = _new_G2 clst
let new_G2 clst = _new_G2 clst
let new_G2 clst = _new_G2 clst
let new_G2 clst = _new_G2 clst
let new_JamshidianSwaptionEngine clst = _new_JamshidianSwaptionEngine clst
let new_JamshidianSwaptionEngine clst = _new_JamshidianSwaptionEngine clst
let new_TreeSwaptionEngine clst = _new_TreeSwaptionEngine clst
let new_TreeSwaptionEngine clst = _new_TreeSwaptionEngine clst
let new_TreeSwaptionEngine clst = _new_TreeSwaptionEngine clst
let new_TreeSwaptionEngine clst = _new_TreeSwaptionEngine clst
let new_TreeSwaptionEngine clst = _new_TreeSwaptionEngine clst
let new_TreeSwaptionEngine clst = _new_TreeSwaptionEngine clst
let new_AnalyticCapFloorEngine clst = _new_AnalyticCapFloorEngine clst
let new_AnalyticCapFloorEngine clst = _new_AnalyticCapFloorEngine clst
let new_TreeCapFloorEngine clst = _new_TreeCapFloorEngine clst
let new_TreeCapFloorEngine clst = _new_TreeCapFloorEngine clst
let new_TreeCapFloorEngine clst = _new_TreeCapFloorEngine clst
let new_TreeCapFloorEngine clst = _new_TreeCapFloorEngine clst
let new_G2SwaptionEngine clst = _new_G2SwaptionEngine clst
let new_FdG2SwaptionEngine clst = _new_FdG2SwaptionEngine clst
let new_FdG2SwaptionEngine clst = _new_FdG2SwaptionEngine clst
let new_FdG2SwaptionEngine clst = _new_FdG2SwaptionEngine clst
let new_FdG2SwaptionEngine clst = _new_FdG2SwaptionEngine clst
let new_FdG2SwaptionEngine clst = _new_FdG2SwaptionEngine clst
let new_FdG2SwaptionEngine clst = _new_FdG2SwaptionEngine clst
let new_FdG2SwaptionEngine clst = _new_FdG2SwaptionEngine clst
let new_FdHullWhiteSwaptionEngine clst = _new_FdHullWhiteSwaptionEngine clst
let new_FdHullWhiteSwaptionEngine clst = _new_FdHullWhiteSwaptionEngine clst
let new_FdHullWhiteSwaptionEngine clst = _new_FdHullWhiteSwaptionEngine clst
let new_FdHullWhiteSwaptionEngine clst = _new_FdHullWhiteSwaptionEngine clst
let new_FdHullWhiteSwaptionEngine clst = _new_FdHullWhiteSwaptionEngine clst
let new_FdHullWhiteSwaptionEngine clst = _new_FdHullWhiteSwaptionEngine clst
let new_Bond clst = _new_Bond clst
let new_Bond clst = _new_Bond clst
let new_Bond clst = _new_Bond clst
let new_ZeroCouponBond clst = _new_ZeroCouponBond clst
let new_ZeroCouponBond clst = _new_ZeroCouponBond clst
let new_ZeroCouponBond clst = _new_ZeroCouponBond clst
let new_ZeroCouponBond clst = _new_ZeroCouponBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FixedRateBond clst = _new_FixedRateBond clst
let new_FloatingRateBond clst = _new_FloatingRateBond clst
let new_FloatingRateBond clst = _new_FloatingRateBond clst
let new_FloatingRateBond clst = _new_FloatingRateBond clst
let new_FloatingRateBond clst = _new_FloatingRateBond clst
let new_FloatingRateBond clst = _new_FloatingRateBond clst
let new_FloatingRateBond clst = _new_FloatingRateBond clst
let new_FloatingRateBond clst = _new_FloatingRateBond clst
let new_FloatingRateBond clst = _new_FloatingRateBond clst
let new_FloatingRateBond clst = _new_FloatingRateBond clst
let new_FloatingRateBond clst = _new_FloatingRateBond clst
let new_CmsRateBond clst = _new_CmsRateBond clst
let new_CmsRateBond clst = _new_CmsRateBond clst
let new_CmsRateBond clst = _new_CmsRateBond clst
let new_CmsRateBond clst = _new_CmsRateBond clst
let new_DiscountingBondEngine clst = _new_DiscountingBondEngine clst
let new_CallableFixedRateBond clst = _new_CallableFixedRateBond clst
let new_TreeCallableFixedRateBondEngine clst = _new_TreeCallableFixedRateBondEngine clst
let new_TreeCallableFixedRateBondEngine clst = _new_TreeCallableFixedRateBondEngine clst
let new_TreeCallableFixedRateBondEngine clst = _new_TreeCallableFixedRateBondEngine clst
let new_TreeCallableFixedRateBondEngine clst = _new_TreeCallableFixedRateBondEngine clst
let new_BlackCallableFixedRateBondEngine clst = _new_BlackCallableFixedRateBondEngine clst
let new_CPIBond clst = _new_CPIBond clst
let new_CPIBond clst = _new_CPIBond clst
let new_CPIBond clst = _new_CPIBond clst
let new_CPIBond clst = _new_CPIBond clst
let new_CPIBond clst = _new_CPIBond clst
let new_CPIBond clst = _new_CPIBond clst
let new_CPIBond clst = _new_CPIBond clst
let new_CPIBond clst = _new_CPIBond clst
let new_BondFunctions clst = _new_BondFunctions clst
let new_CapFloor clst = _new_CapFloor clst
let new_Cap clst = _new_Cap clst
let new_Floor clst = _new_Floor clst
let new_Collar clst = _new_Collar clst
let new_BlackCapFloorEngine clst = _new_BlackCapFloorEngine clst
let new_BlackCapFloorEngine clst = _new_BlackCapFloorEngine clst
let new_BachelierCapFloorEngine clst = _new_BachelierCapFloorEngine clst
let new_BachelierCapFloorEngine clst = _new_BachelierCapFloorEngine clst
let new_Dividend clst = _new_Dividend clst
let new_FixedDividend clst = _new_FixedDividend clst
let new_FractionalDividend clst = _new_FractionalDividend clst
let new_DividendSchedule clst = _new_DividendSchedule clst
let new_DividendSchedule clst = _new_DividendSchedule clst
let new_DividendSchedule clst = _new_DividendSchedule clst
let new_DividendSchedule clst = _new_DividendSchedule clst
let new_ConvertibleZeroCouponBond clst = _new_ConvertibleZeroCouponBond clst
let new_ConvertibleZeroCouponBond clst = _new_ConvertibleZeroCouponBond clst
let new_ConvertibleFixedCouponBond clst = _new_ConvertibleFixedCouponBond clst
let new_ConvertibleFixedCouponBond clst = _new_ConvertibleFixedCouponBond clst
let new_ConvertibleFloatingRateBond clst = _new_ConvertibleFloatingRateBond clst
let new_ConvertibleFloatingRateBond clst = _new_ConvertibleFloatingRateBond clst
let new_BinomialConvertibleEngine clst = _new_BinomialConvertibleEngine clst
let new_DefaultProbabilityTermStructure clst = _new_DefaultProbabilityTermStructure clst
let new_DefaultProbabilityTermStructureHandle clst = _new_DefaultProbabilityTermStructureHandle clst
let new_DefaultProbabilityTermStructureHandle clst = _new_DefaultProbabilityTermStructureHandle clst
let new_RelinkableDefaultProbabilityTermStructureHandle clst = _new_RelinkableDefaultProbabilityTermStructureHandle clst
let new_RelinkableDefaultProbabilityTermStructureHandle clst = _new_RelinkableDefaultProbabilityTermStructureHandle clst
let new_FlatHazardRate clst = _new_FlatHazardRate clst
let new_FlatHazardRate clst = _new_FlatHazardRate clst
let new_HazardRateCurve clst = _new_HazardRateCurve clst
let new_HazardRateCurve clst = _new_HazardRateCurve clst
let new_HazardRateCurve clst = _new_HazardRateCurve clst
let new_DefaultDensityCurve clst = _new_DefaultDensityCurve clst
let new_DefaultDensityCurve clst = _new_DefaultDensityCurve clst
let new_DefaultDensityCurve clst = _new_DefaultDensityCurve clst
let new_DefaultProbabilityHelper clst = _new_DefaultProbabilityHelper clst
let new_DefaultProbabilityHelperVector clst = _new_DefaultProbabilityHelperVector clst
let new_DefaultProbabilityHelperVector clst = _new_DefaultProbabilityHelperVector clst
let new_DefaultProbabilityHelperVector clst = _new_DefaultProbabilityHelperVector clst
let new_DefaultProbabilityHelperVector clst = _new_DefaultProbabilityHelperVector clst
let new_SpreadCdsHelper clst = _new_SpreadCdsHelper clst
let new_SpreadCdsHelper clst = _new_SpreadCdsHelper clst
let new_SpreadCdsHelper clst = _new_SpreadCdsHelper clst
let new_SpreadCdsHelper clst = _new_SpreadCdsHelper clst
let new_SpreadCdsHelper clst = _new_SpreadCdsHelper clst
let new_SpreadCdsHelper clst = _new_SpreadCdsHelper clst
let new_UpfrontCdsHelper clst = _new_UpfrontCdsHelper clst
let new_UpfrontCdsHelper clst = _new_UpfrontCdsHelper clst
let new_UpfrontCdsHelper clst = _new_UpfrontCdsHelper clst
let new_UpfrontCdsHelper clst = _new_UpfrontCdsHelper clst
let new_UpfrontCdsHelper clst = _new_UpfrontCdsHelper clst
let new_UpfrontCdsHelper clst = _new_UpfrontCdsHelper clst
let new_UpfrontCdsHelper clst = _new_UpfrontCdsHelper clst
let new_UpfrontCdsHelper clst = _new_UpfrontCdsHelper clst
let new_HazardRate clst = _new_HazardRate clst
let new_DefaultDensity clst = _new_DefaultDensity clst
let new_PiecewiseFlatHazardRate clst = _new_PiecewiseFlatHazardRate clst
let new_PiecewiseFlatHazardRate clst = _new_PiecewiseFlatHazardRate clst
let new_PiecewiseFlatHazardRate clst = _new_PiecewiseFlatHazardRate clst
let new_PiecewiseFlatHazardRate clst = _new_PiecewiseFlatHazardRate clst
let new_PiecewiseFlatHazardRate clst = _new_PiecewiseFlatHazardRate clst
let new_PiecewiseFlatHazardRate clst = _new_PiecewiseFlatHazardRate clst
let new_Protection clst = _new_Protection clst
let new_CreditDefaultSwap clst = _new_CreditDefaultSwap clst
let new_CreditDefaultSwap clst = _new_CreditDefaultSwap clst
let new_CreditDefaultSwap clst = _new_CreditDefaultSwap clst
let new_CreditDefaultSwap clst = _new_CreditDefaultSwap clst
let new_CreditDefaultSwap clst = _new_CreditDefaultSwap clst
let new_CreditDefaultSwap clst = _new_CreditDefaultSwap clst
let new_MidPointCdsEngine clst = _new_MidPointCdsEngine clst
let new_IntegralCdsEngine clst = _new_IntegralCdsEngine clst
let new_IntegralCdsEngine clst = _new_IntegralCdsEngine clst
let new_DiscountCurve clst = _new_DiscountCurve clst
let new_DiscountCurve clst = _new_DiscountCurve clst
let new_DiscountCurve clst = _new_DiscountCurve clst
let new_NormalDistribution clst = _new_NormalDistribution clst
let new_NormalDistribution clst = _new_NormalDistribution clst
let new_NormalDistribution clst = _new_NormalDistribution clst
let new_CumulativeNormalDistribution clst = _new_CumulativeNormalDistribution clst
let new_CumulativeNormalDistribution clst = _new_CumulativeNormalDistribution clst
let new_CumulativeNormalDistribution clst = _new_CumulativeNormalDistribution clst
let new_InverseCumulativeNormal clst = _new_InverseCumulativeNormal clst
let new_InverseCumulativeNormal clst = _new_InverseCumulativeNormal clst
let new_InverseCumulativeNormal clst = _new_InverseCumulativeNormal clst
let new_MoroInverseCumulativeNormal clst = _new_MoroInverseCumulativeNormal clst
let new_MoroInverseCumulativeNormal clst = _new_MoroInverseCumulativeNormal clst
let new_MoroInverseCumulativeNormal clst = _new_MoroInverseCumulativeNormal clst
let new_BivariateCumulativeNormalDistribution clst = _new_BivariateCumulativeNormalDistribution clst
let new_BinomialDistribution clst = _new_BinomialDistribution clst
let new_CumulativeBinomialDistribution clst = _new_CumulativeBinomialDistribution clst
let new_BivariateCumulativeNormalDistributionDr78 clst = _new_BivariateCumulativeNormalDistributionDr78 clst
let new_BivariateCumulativeNormalDistributionWe04DP clst = _new_BivariateCumulativeNormalDistributionWe04DP clst
let new_ChiSquareDistribution clst = _new_ChiSquareDistribution clst
let new_NonCentralChiSquareDistribution clst = _new_NonCentralChiSquareDistribution clst
let new_InverseNonCentralChiSquareDistribution clst = _new_InverseNonCentralChiSquareDistribution clst
let new_InverseNonCentralChiSquareDistribution clst = _new_InverseNonCentralChiSquareDistribution clst
let new_InverseNonCentralChiSquareDistribution clst = _new_InverseNonCentralChiSquareDistribution clst
let new_GammaDistribution clst = _new_GammaDistribution clst
let new_GammaFunction clst = _new_GammaFunction clst
let new_PoissonDistribution clst = _new_PoissonDistribution clst
let new_CumulativePoissonDistribution clst = _new_CumulativePoissonDistribution clst
let new_InverseCumulativePoisson clst = _new_InverseCumulativePoisson clst
let new_StudentDistribution clst = _new_StudentDistribution clst
let new_CumulativeStudentDistribution clst = _new_CumulativeStudentDistribution clst
let new_InverseCumulativeStudent clst = _new_InverseCumulativeStudent clst
let new_InverseCumulativeStudent clst = _new_InverseCumulativeStudent clst
let new_InverseCumulativeStudent clst = _new_InverseCumulativeStudent clst
let new_Money clst = _new_Money clst
let new_Money clst = _new_Money clst
let new_ExchangeRate clst = _new_ExchangeRate clst
let new_Futures clst = _new_Futures clst
let new_TimeBasket clst = _new_TimeBasket clst
let new_TimeBasket clst = _new_TimeBasket clst
let new_Swap clst = _new_Swap clst
let new_VanillaSwap clst = _new_VanillaSwap clst
let new_NonstandardSwap clst = _new_NonstandardSwap clst
let new_NonstandardSwap clst = _new_NonstandardSwap clst
let new_NonstandardSwap clst = _new_NonstandardSwap clst
let new_NonstandardSwap clst = _new_NonstandardSwap clst
let new_DiscountingSwapEngine clst = _new_DiscountingSwapEngine clst
let new_DiscountingSwapEngine clst = _new_DiscountingSwapEngine clst
let new_DiscountingSwapEngine clst = _new_DiscountingSwapEngine clst
let new_DiscountingSwapEngine clst = _new_DiscountingSwapEngine clst
let new_DiscountingSwapEngine clst = _new_DiscountingSwapEngine clst
let new_DiscountingSwapEngine clst = _new_DiscountingSwapEngine clst
let new_AssetSwap clst = _new_AssetSwap clst
let new_AssetSwap clst = _new_AssetSwap clst
let new_AssetSwap clst = _new_AssetSwap clst
let new_AssetSwap clst = _new_AssetSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_FloatFloatSwap clst = _new_FloatFloatSwap clst
let new_Pillar clst = _new_Pillar clst
let new_RateHelper clst = _new_RateHelper clst
let new_DepositRateHelper clst = _new_DepositRateHelper clst
let new_DepositRateHelper clst = _new_DepositRateHelper clst
let new_DepositRateHelper clst = _new_DepositRateHelper clst
let new_DepositRateHelper clst = _new_DepositRateHelper clst
let new_FraRateHelper clst = _new_FraRateHelper clst
let new_FraRateHelper clst = _new_FraRateHelper clst
let new_FraRateHelper clst = _new_FraRateHelper clst
let new_FraRateHelper clst = _new_FraRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_FuturesRateHelper clst = _new_FuturesRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_SwapRateHelper clst = _new_SwapRateHelper clst
let new_BondHelper clst = _new_BondHelper clst
let new_BondHelper clst = _new_BondHelper clst
let new_FixedRateBondHelper clst = _new_FixedRateBondHelper clst
let new_FixedRateBondHelper clst = _new_FixedRateBondHelper clst
let new_FixedRateBondHelper clst = _new_FixedRateBondHelper clst
let new_FixedRateBondHelper clst = _new_FixedRateBondHelper clst
let new_FixedRateBondHelper clst = _new_FixedRateBondHelper clst
let new_FixedRateBondHelper clst = _new_FixedRateBondHelper clst
let new_FixedRateBondHelper clst = _new_FixedRateBondHelper clst
let new_FixedRateBondHelper clst = _new_FixedRateBondHelper clst
let new_FixedRateBondHelper clst = _new_FixedRateBondHelper clst
let new_FixedRateBondHelper clst = _new_FixedRateBondHelper clst
let new_OISRateHelper clst = _new_OISRateHelper clst
let new_OISRateHelper clst = _new_OISRateHelper clst
let new_DatedOISRateHelper clst = _new_DatedOISRateHelper clst
let new_DatedOISRateHelper clst = _new_DatedOISRateHelper clst
let new_RateHelperVector clst = _new_RateHelperVector clst
let new_RateHelperVector clst = _new_RateHelperVector clst
let new_RateHelperVector clst = _new_RateHelperVector clst
let new_RateHelperVector clst = _new_RateHelperVector clst
let new_FittedBondDiscountCurve clst = _new_FittedBondDiscountCurve clst
let new_FittedBondDiscountCurve clst = _new_FittedBondDiscountCurve clst
let new_FittedBondDiscountCurve clst = _new_FittedBondDiscountCurve clst
let new_FittedBondDiscountCurve clst = _new_FittedBondDiscountCurve clst
let new_FittedBondDiscountCurve clst = _new_FittedBondDiscountCurve clst
let new_FittedBondDiscountCurve clst = _new_FittedBondDiscountCurve clst
let new_FittedBondDiscountCurve clst = _new_FittedBondDiscountCurve clst
let new_FittedBondDiscountCurve clst = _new_FittedBondDiscountCurve clst
let new_FittedBondDiscountCurve clst = _new_FittedBondDiscountCurve clst
let new_FittedBondDiscountCurve clst = _new_FittedBondDiscountCurve clst
let new_ExponentialSplinesFitting clst = _new_ExponentialSplinesFitting clst
let new_ExponentialSplinesFitting clst = _new_ExponentialSplinesFitting clst
let new_NelsonSiegelFitting clst = _new_NelsonSiegelFitting clst
let new_SvenssonFitting clst = _new_SvenssonFitting clst
let new_CubicBSplinesFitting clst = _new_CubicBSplinesFitting clst
let new_CubicBSplinesFitting clst = _new_CubicBSplinesFitting clst
let new_SimplePolynomialFitting clst = _new_SimplePolynomialFitting clst
let new_SimplePolynomialFitting clst = _new_SimplePolynomialFitting clst
let new_ForwardCurve clst = _new_ForwardCurve clst
let new_ForwardCurve clst = _new_ForwardCurve clst
let new_ForwardCurve clst = _new_ForwardCurve clst
let new_Position clst = _new_Position clst
let new_ForwardRateAgreement clst = _new_ForwardRateAgreement clst
let new_ForwardRateAgreement clst = _new_ForwardRateAgreement clst
let new_Gaussian1dModel clst = _new_Gaussian1dModel clst
let new_Gsr clst = _new_Gsr clst
let new_Gsr clst = _new_Gsr clst
let new_MarkovFunctionalSettings clst = _new_MarkovFunctionalSettings clst
let new_MarkovFunctional clst = _new_MarkovFunctional clst
let new_MarkovFunctional clst = _new_MarkovFunctional clst
let new_MarkovFunctional clst = _new_MarkovFunctional clst
let new_MarkovFunctional clst = _new_MarkovFunctional clst
let new_MarkovFunctional clst = _new_MarkovFunctional clst
let new_MarkovFunctional clst = _new_MarkovFunctional clst
let new_MarkovFunctional clst = _new_MarkovFunctional clst
let new_MarkovFunctional clst = _new_MarkovFunctional clst
let new_MarkovFunctional clst = _new_MarkovFunctional clst
let new_MarkovFunctional clst = _new_MarkovFunctional clst
let new_Gaussian1dSwaptionEngine clst = _new_Gaussian1dSwaptionEngine clst
let new_Gaussian1dSwaptionEngine clst = _new_Gaussian1dSwaptionEngine clst
let new_Gaussian1dSwaptionEngine clst = _new_Gaussian1dSwaptionEngine clst
let new_Gaussian1dSwaptionEngine clst = _new_Gaussian1dSwaptionEngine clst
let new_Gaussian1dSwaptionEngine clst = _new_Gaussian1dSwaptionEngine clst
let new_Gaussian1dSwaptionEngine clst = _new_Gaussian1dSwaptionEngine clst
let new_Gaussian1dJamshidianSwaptionEngine clst = _new_Gaussian1dJamshidianSwaptionEngine clst
let new_Gaussian1dNonstandardSwaptionEngine clst = _new_Gaussian1dNonstandardSwaptionEngine clst
let new_Gaussian1dNonstandardSwaptionEngine clst = _new_Gaussian1dNonstandardSwaptionEngine clst
let new_Gaussian1dNonstandardSwaptionEngine clst = _new_Gaussian1dNonstandardSwaptionEngine clst
let new_Gaussian1dNonstandardSwaptionEngine clst = _new_Gaussian1dNonstandardSwaptionEngine clst
let new_Gaussian1dNonstandardSwaptionEngine clst = _new_Gaussian1dNonstandardSwaptionEngine clst
let new_Gaussian1dNonstandardSwaptionEngine clst = _new_Gaussian1dNonstandardSwaptionEngine clst
let new_Gaussian1dNonstandardSwaptionEngine clst = _new_Gaussian1dNonstandardSwaptionEngine clst
let new_Gaussian1dFloatFloatSwaptionEngine clst = _new_Gaussian1dFloatFloatSwaptionEngine clst
let new_Gaussian1dFloatFloatSwaptionEngine clst = _new_Gaussian1dFloatFloatSwaptionEngine clst
let new_Gaussian1dFloatFloatSwaptionEngine clst = _new_Gaussian1dFloatFloatSwaptionEngine clst
let new_Gaussian1dFloatFloatSwaptionEngine clst = _new_Gaussian1dFloatFloatSwaptionEngine clst
let new_Gaussian1dFloatFloatSwaptionEngine clst = _new_Gaussian1dFloatFloatSwaptionEngine clst
let new_Gaussian1dFloatFloatSwaptionEngine clst = _new_Gaussian1dFloatFloatSwaptionEngine clst
let new_Gaussian1dFloatFloatSwaptionEngine clst = _new_Gaussian1dFloatFloatSwaptionEngine clst
let new_Gaussian1dFloatFloatSwaptionEngine clst = _new_Gaussian1dFloatFloatSwaptionEngine clst
let new_Gaussian1dFloatFloatSwaptionEngine clst = _new_Gaussian1dFloatFloatSwaptionEngine clst
let new_SegmentIntegral clst = _new_SegmentIntegral clst
let new_TrapezoidIntegralDefault clst = _new_TrapezoidIntegralDefault clst
let new_TrapezoidIntegralMidPoint clst = _new_TrapezoidIntegralMidPoint clst
let new_SimpsonIntegral clst = _new_SimpsonIntegral clst
let new_GaussKronrodAdaptive clst = _new_GaussKronrodAdaptive clst
let new_GaussKronrodAdaptive clst = _new_GaussKronrodAdaptive clst
let new_GaussKronrodNonAdaptive clst = _new_GaussKronrodNonAdaptive clst
let new_GaussLobattoIntegral clst = _new_GaussLobattoIntegral clst
let new_GaussLobattoIntegral clst = _new_GaussLobattoIntegral clst
let new_GaussLobattoIntegral clst = _new_GaussLobattoIntegral clst
let new_GaussLaguerreIntegration clst = _new_GaussLaguerreIntegration clst
let new_GaussLaguerreIntegration clst = _new_GaussLaguerreIntegration clst
let new_GaussHermiteIntegration clst = _new_GaussHermiteIntegration clst
let new_GaussHermiteIntegration clst = _new_GaussHermiteIntegration clst
let new_GaussJacobiIntegration clst = _new_GaussJacobiIntegration clst
let new_GaussHyperbolicIntegration clst = _new_GaussHyperbolicIntegration clst
let new_GaussLegendreIntegration clst = _new_GaussLegendreIntegration clst
let new_GaussChebyshevIntegration clst = _new_GaussChebyshevIntegration clst
let new_GaussChebyshev2ndIntegration clst = _new_GaussChebyshev2ndIntegration clst
let new_GaussGegenbauerIntegration clst = _new_GaussGegenbauerIntegration clst
let new_LecuyerUniformRng clst = _new_LecuyerUniformRng clst
let new_LecuyerUniformRng clst = _new_LecuyerUniformRng clst
let new_KnuthUniformRng clst = _new_KnuthUniformRng clst
let new_KnuthUniformRng clst = _new_KnuthUniformRng clst
let new_MersenneTwisterUniformRng clst = _new_MersenneTwisterUniformRng clst
let new_MersenneTwisterUniformRng clst = _new_MersenneTwisterUniformRng clst
let new_UniformRandomGenerator clst = _new_UniformRandomGenerator clst
let new_UniformRandomGenerator clst = _new_UniformRandomGenerator clst
let new_CentralLimitLecuyerGaussianRng clst = _new_CentralLimitLecuyerGaussianRng clst
let new_CentralLimitKnuthGaussianRng clst = _new_CentralLimitKnuthGaussianRng clst
let new_CentralLimitMersenneTwisterGaussianRng clst = _new_CentralLimitMersenneTwisterGaussianRng clst
let new_BoxMullerLecuyerGaussianRng clst = _new_BoxMullerLecuyerGaussianRng clst
let new_BoxMullerKnuthGaussianRng clst = _new_BoxMullerKnuthGaussianRng clst
let new_BoxMullerMersenneTwisterGaussianRng clst = _new_BoxMullerMersenneTwisterGaussianRng clst
let new_MoroInvCumulativeLecuyerGaussianRng clst = _new_MoroInvCumulativeLecuyerGaussianRng clst
let new_MoroInvCumulativeKnuthGaussianRng clst = _new_MoroInvCumulativeKnuthGaussianRng clst
let new_MoroInvCumulativeMersenneTwisterGaussianRng clst = _new_MoroInvCumulativeMersenneTwisterGaussianRng clst
let new_InvCumulativeLecuyerGaussianRng clst = _new_InvCumulativeLecuyerGaussianRng clst
let new_InvCumulativeKnuthGaussianRng clst = _new_InvCumulativeKnuthGaussianRng clst
let new_InvCumulativeMersenneTwisterGaussianRng clst = _new_InvCumulativeMersenneTwisterGaussianRng clst
let new_GaussianRandomGenerator clst = _new_GaussianRandomGenerator clst
let new_HaltonRsg clst = _new_HaltonRsg clst
let new_HaltonRsg clst = _new_HaltonRsg clst
let new_HaltonRsg clst = _new_HaltonRsg clst
let new_HaltonRsg clst = _new_HaltonRsg clst
let new_SobolRsg clst = _new_SobolRsg clst
let new_SobolRsg clst = _new_SobolRsg clst
let new_SobolRsg clst = _new_SobolRsg clst
let new_SobolBrownianBridgeRsg clst = _new_SobolBrownianBridgeRsg clst
let new_LecuyerUniformRsg clst = _new_LecuyerUniformRsg clst
let new_KnuthUniformRsg clst = _new_KnuthUniformRsg clst
let new_MersenneTwisterUniformRsg clst = _new_MersenneTwisterUniformRsg clst
let new_UniformRandomSequenceGenerator clst = _new_UniformRandomSequenceGenerator clst
let new_UniformLowDiscrepancySequenceGenerator clst = _new_UniformLowDiscrepancySequenceGenerator clst
let new_MoroInvCumulativeLecuyerGaussianRsg clst = _new_MoroInvCumulativeLecuyerGaussianRsg clst
let new_MoroInvCumulativeKnuthGaussianRsg clst = _new_MoroInvCumulativeKnuthGaussianRsg clst
let new_MoroInvCumulativeMersenneTwisterGaussianRsg clst = _new_MoroInvCumulativeMersenneTwisterGaussianRsg clst
let new_MoroInvCumulativeHaltonGaussianRsg clst = _new_MoroInvCumulativeHaltonGaussianRsg clst
let new_InvCumulativeLecuyerGaussianRsg clst = _new_InvCumulativeLecuyerGaussianRsg clst
let new_InvCumulativeKnuthGaussianRsg clst = _new_InvCumulativeKnuthGaussianRsg clst
let new_InvCumulativeMersenneTwisterGaussianRsg clst = _new_InvCumulativeMersenneTwisterGaussianRsg clst
let new_InvCumulativeHaltonGaussianRsg clst = _new_InvCumulativeHaltonGaussianRsg clst
let new_GaussianRandomSequenceGenerator clst = _new_GaussianRandomSequenceGenerator clst
let new_GaussianLowDiscrepancySequenceGenerator clst = _new_GaussianLowDiscrepancySequenceGenerator clst
let new_GaussianPathGenerator clst = _new_GaussianPathGenerator clst
let new_GaussianSobolPathGenerator clst = _new_GaussianSobolPathGenerator clst
let new_GaussianMultiPathGenerator clst = _new_GaussianMultiPathGenerator clst
let new_GaussianMultiPathGenerator clst = _new_GaussianMultiPathGenerator clst
let new_BoundaryCondition clst = _new_BoundaryCondition clst
let new_NeumannBC clst = _new_NeumannBC clst
let new_DirichletBC clst = _new_DirichletBC clst
let new_TridiagonalOperator clst = _new_TridiagonalOperator clst
let new_DPlus clst = _new_DPlus clst
let new_DMinus clst = _new_DMinus clst
let new_DZero clst = _new_DZero clst
let new_DPlusDMinus clst = _new_DPlusDMinus clst
let new_Discount clst = _new_Discount clst
let new_ZeroYield clst = _new_ZeroYield clst
let new_ForwardRate clst = _new_ForwardRate clst
let new_PiecewiseFlatForward clst = _new_PiecewiseFlatForward clst
let new_PiecewiseFlatForward clst = _new_PiecewiseFlatForward clst
let new_PiecewiseFlatForward clst = _new_PiecewiseFlatForward clst
let new_PiecewiseFlatForward clst = _new_PiecewiseFlatForward clst
let new_PiecewiseFlatForward clst = _new_PiecewiseFlatForward clst
let new_PiecewiseFlatForward clst = _new_PiecewiseFlatForward clst
let new_PiecewiseFlatForward clst = _new_PiecewiseFlatForward clst
let new_PiecewiseFlatForward clst = _new_PiecewiseFlatForward clst
let new_PiecewiseFlatForward clst = _new_PiecewiseFlatForward clst
let new_PiecewiseFlatForward clst = _new_PiecewiseFlatForward clst
let new_PiecewiseLinearForward clst = _new_PiecewiseLinearForward clst
let new_PiecewiseLinearForward clst = _new_PiecewiseLinearForward clst
let new_PiecewiseLinearForward clst = _new_PiecewiseLinearForward clst
let new_PiecewiseLinearForward clst = _new_PiecewiseLinearForward clst
let new_PiecewiseLinearForward clst = _new_PiecewiseLinearForward clst
let new_PiecewiseLinearForward clst = _new_PiecewiseLinearForward clst
let new_PiecewiseLinearForward clst = _new_PiecewiseLinearForward clst
let new_PiecewiseLinearForward clst = _new_PiecewiseLinearForward clst
let new_PiecewiseLinearForward clst = _new_PiecewiseLinearForward clst
let new_PiecewiseLinearForward clst = _new_PiecewiseLinearForward clst
let new_PiecewiseLinearZero clst = _new_PiecewiseLinearZero clst
let new_PiecewiseLinearZero clst = _new_PiecewiseLinearZero clst
let new_PiecewiseLinearZero clst = _new_PiecewiseLinearZero clst
let new_PiecewiseLinearZero clst = _new_PiecewiseLinearZero clst
let new_PiecewiseLinearZero clst = _new_PiecewiseLinearZero clst
let new_PiecewiseLinearZero clst = _new_PiecewiseLinearZero clst
let new_PiecewiseLinearZero clst = _new_PiecewiseLinearZero clst
let new_PiecewiseLinearZero clst = _new_PiecewiseLinearZero clst
let new_PiecewiseLinearZero clst = _new_PiecewiseLinearZero clst
let new_PiecewiseLinearZero clst = _new_PiecewiseLinearZero clst
let new_PiecewiseCubicZero clst = _new_PiecewiseCubicZero clst
let new_PiecewiseCubicZero clst = _new_PiecewiseCubicZero clst
let new_PiecewiseCubicZero clst = _new_PiecewiseCubicZero clst
let new_PiecewiseCubicZero clst = _new_PiecewiseCubicZero clst
let new_PiecewiseCubicZero clst = _new_PiecewiseCubicZero clst
let new_PiecewiseCubicZero clst = _new_PiecewiseCubicZero clst
let new_PiecewiseCubicZero clst = _new_PiecewiseCubicZero clst
let new_PiecewiseCubicZero clst = _new_PiecewiseCubicZero clst
let new_PiecewiseCubicZero clst = _new_PiecewiseCubicZero clst
let new_PiecewiseCubicZero clst = _new_PiecewiseCubicZero clst
let new_PiecewiseLogCubicDiscount clst = _new_PiecewiseLogCubicDiscount clst
let new_PiecewiseLogCubicDiscount clst = _new_PiecewiseLogCubicDiscount clst
let new_PiecewiseLogCubicDiscount clst = _new_PiecewiseLogCubicDiscount clst
let new_PiecewiseLogCubicDiscount clst = _new_PiecewiseLogCubicDiscount clst
let new_PiecewiseLogCubicDiscount clst = _new_PiecewiseLogCubicDiscount clst
let new_PiecewiseLogCubicDiscount clst = _new_PiecewiseLogCubicDiscount clst
let new_PiecewiseLogCubicDiscount clst = _new_PiecewiseLogCubicDiscount clst
let new_PiecewiseLogCubicDiscount clst = _new_PiecewiseLogCubicDiscount clst
let new_PiecewiseLogCubicDiscount clst = _new_PiecewiseLogCubicDiscount clst
let new_PiecewiseLogCubicDiscount clst = _new_PiecewiseLogCubicDiscount clst
let new_SampledCurve clst = _new_SampledCurve clst
let new_SampledCurve clst = _new_SampledCurve clst
let new_Statistics clst = _new_Statistics clst
let new_IncrementalStatistics clst = _new_IncrementalStatistics clst
let new_RiskStatistics clst = _new_RiskStatistics clst
let new_MultipleStatistics clst = _new_MultipleStatistics clst
let new_SequenceStatistics clst = _new_SequenceStatistics clst
let new_MultipleIncrementalStatistics clst = _new_MultipleIncrementalStatistics clst
let new_CapFloorTermVolatilityStructure clst = _new_CapFloorTermVolatilityStructure clst
let new_CapFloorTermVolatilityStructureHandle clst = _new_CapFloorTermVolatilityStructureHandle clst
let new_CapFloorTermVolatilityStructureHandle clst = _new_CapFloorTermVolatilityStructureHandle clst
let new_RelinkableCapFloorTermVolatilityStructureHandle clst = _new_RelinkableCapFloorTermVolatilityStructureHandle clst
let new_RelinkableCapFloorTermVolatilityStructureHandle clst = _new_RelinkableCapFloorTermVolatilityStructureHandle clst
let new_CapFloorTermVolCurve clst = _new_CapFloorTermVolCurve clst
let new_CapFloorTermVolCurve clst = _new_CapFloorTermVolCurve clst
let new_CapFloorTermVolCurve clst = _new_CapFloorTermVolCurve clst
let new_CapFloorTermVolCurve clst = _new_CapFloorTermVolCurve clst
let new_CapFloorTermVolSurface clst = _new_CapFloorTermVolSurface clst
let new_CapFloorTermVolSurface clst = _new_CapFloorTermVolSurface clst
let new_CapFloorTermVolSurface clst = _new_CapFloorTermVolSurface clst
let new_CapFloorTermVolSurface clst = _new_CapFloorTermVolSurface clst
let new_CapFloorTermVolSurface clst = _new_CapFloorTermVolSurface clst
let new_CapFloorTermVolSurface clst = _new_CapFloorTermVolSurface clst
let new_CapFloorTermVolSurface clst = _new_CapFloorTermVolSurface clst
let new_CapFloorTermVolSurface clst = _new_CapFloorTermVolSurface clst
let new_StrippedOptionletBase clst = _new_StrippedOptionletBase clst
let new_OptionletStripper1 clst = _new_OptionletStripper1 clst
let new_OptionletStripper1 clst = _new_OptionletStripper1 clst
let new_OptionletStripper1 clst = _new_OptionletStripper1 clst
let new_OptionletStripper1 clst = _new_OptionletStripper1 clst
let new_OptionletStripper1 clst = _new_OptionletStripper1 clst
let new_OptionletStripper1 clst = _new_OptionletStripper1 clst
let new_OptionletStripper1 clst = _new_OptionletStripper1 clst
let new_OptionletStripper1 clst = _new_OptionletStripper1 clst
let new_StrippedOptionletAdapter clst = _new_StrippedOptionletAdapter clst
let new_Settlement clst = _new_Settlement clst
let new_Swaption clst = _new_Swaption clst
let new_Swaption clst = _new_Swaption clst
let new_NonstandardSwaption clst = _new_NonstandardSwaption clst
let new_NonstandardSwaption clst = _new_NonstandardSwaption clst
let new_FloatFloatSwaption clst = _new_FloatFloatSwaption clst
let new_BlackSwaptionEngine clst = _new_BlackSwaptionEngine clst
let new_BlackSwaptionEngine clst = _new_BlackSwaptionEngine clst
let new_BlackSwaptionEngine clst = _new_BlackSwaptionEngine clst
let new_BlackSwaptionEngine clst = _new_BlackSwaptionEngine clst
let new_BachelierSwaptionEngine clst = _new_BachelierSwaptionEngine clst
let new_BachelierSwaptionEngine clst = _new_BachelierSwaptionEngine clst
let new_BachelierSwaptionEngine clst = _new_BachelierSwaptionEngine clst
let new_ConstantEstimator clst = _new_ConstantEstimator clst
let new_ParkinsonSigma clst = _new_ParkinsonSigma clst
let new_GarmanKlassSigma1 clst = _new_GarmanKlassSigma1 clst
let new_GarmanKlassSigma3 clst = _new_GarmanKlassSigma3 clst
let new_GarmanKlassSigma4 clst = _new_GarmanKlassSigma4 clst
let new_GarmanKlassSigma5 clst = _new_GarmanKlassSigma5 clst
let new_GarmanKlassSigma6 clst = _new_GarmanKlassSigma6 clst
let new_ZeroCurve clst = _new_ZeroCurve clst
let new_ZeroCurve clst = _new_ZeroCurve clst
let new_ZeroCurve clst = _new_ZeroCurve clst
let new_ZeroCurve clst = _new_ZeroCurve clst
let new_ZeroCurve clst = _new_ZeroCurve clst
let new_LogLinearZeroCurve clst = _new_LogLinearZeroCurve clst
let new_LogLinearZeroCurve clst = _new_LogLinearZeroCurve clst
let new_LogLinearZeroCurve clst = _new_LogLinearZeroCurve clst
let new_LogLinearZeroCurve clst = _new_LogLinearZeroCurve clst
let new_LogLinearZeroCurve clst = _new_LogLinearZeroCurve clst
let new_CubicZeroCurve clst = _new_CubicZeroCurve clst
let new_CubicZeroCurve clst = _new_CubicZeroCurve clst
let new_CubicZeroCurve clst = _new_CubicZeroCurve clst
let new_CubicZeroCurve clst = _new_CubicZeroCurve clst
let new_CubicZeroCurve clst = _new_CubicZeroCurve clst
let new_LogCubicZeroCurve clst = _new_LogCubicZeroCurve clst
let new_LogCubicZeroCurve clst = _new_LogCubicZeroCurve clst
let new_LogCubicZeroCurve clst = _new_LogCubicZeroCurve clst
let new_LogCubicZeroCurve clst = _new_LogCubicZeroCurve clst
let new_LogCubicZeroCurve clst = _new_LogCubicZeroCurve clst
let new_ForwardFlatZeroCurve clst = _new_ForwardFlatZeroCurve clst
let new_ForwardFlatZeroCurve clst = _new_ForwardFlatZeroCurve clst
let new_ForwardFlatZeroCurve clst = _new_ForwardFlatZeroCurve clst
let new_ForwardFlatZeroCurve clst = _new_ForwardFlatZeroCurve clst
let new_ForwardFlatZeroCurve clst = _new_ForwardFlatZeroCurve clst
let new_BackwardFlatZeroCurve clst = _new_BackwardFlatZeroCurve clst
let new_BackwardFlatZeroCurve clst = _new_BackwardFlatZeroCurve clst
let new_BackwardFlatZeroCurve clst = _new_BackwardFlatZeroCurve clst
let new_BackwardFlatZeroCurve clst = _new_BackwardFlatZeroCurve clst
let new_BackwardFlatZeroCurve clst = _new_BackwardFlatZeroCurve clst
let new_MonotonicCubicZeroCurve clst = _new_MonotonicCubicZeroCurve clst
let new_MonotonicCubicZeroCurve clst = _new_MonotonicCubicZeroCurve clst
let new_MonotonicCubicZeroCurve clst = _new_MonotonicCubicZeroCurve clst
let new_MonotonicCubicZeroCurve clst = _new_MonotonicCubicZeroCurve clst
let new_MonotonicCubicZeroCurve clst = _new_MonotonicCubicZeroCurve clst
let new_Forward clst = _new_Forward clst
let new_FixedRateBondForward clst = _new_FixedRateBondForward clst
let new_FixedRateBondForward clst = _new_FixedRateBondForward clst
let new_FixedRateBondForward clst = _new_FixedRateBondForward clst

  let rec swig_val t v = 
    match v with
        C_enum e -> enum_to_int t v
      | C_list l -> Swig.C_list (List.map (swig_val t) l)
      | C_array a -> Swig.C_array (Array.map (swig_val t) a)
      | _ -> Obj.magic v

